/*
 * This file is part of the OdinMS Maple Story Server
 * Copyright (C) 2008 Patrick Huy <patrick.huy@frz.cc>
 * Matthias Butz <matze@odinms.de>
 * Jan Christian Meyer <vimes@odinms.de>
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation version 3 as published by
 * the Free Software Foundation. You may not use, modify or distribute
 * this program under any other version of the GNU Affero General Public
 * License.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package net.server.channel.handlers;

import client.MapleClient;
import client.inventory.MapleInventoryType;
import net.AbstractMaplePacketHandler;
import server.MapleInventoryManipulator;
import tools.data.input.SeekableLittleEndianAccessor;
import tools.packets.CWvsContext;

/**
 * @author Matze
 */
public final class ItemMoveHandler extends AbstractMaplePacketHandler{

	@Override
	public final void handlePacket(SeekableLittleEndianAccessor slea, MapleClient c){
		slea.skip(4);
		if(c.getPlayer().getAutobanManager().getLastSpam(6) + 300 > System.currentTimeMillis()){
			c.announce(CWvsContext.enableActions());
			return;
		}
		if(!c.getPlayer().isAlive()){
			c.announce(CWvsContext.enableActions());
			return;
		}
		MapleInventoryType type = MapleInventoryType.getByType(slea.readByte());
		byte src = (byte) slea.readShort();
		short action = slea.readShort();
		short quantity = slea.readShort();
		if(src < 0 && action > 0){
			MapleInventoryManipulator.unequip(c, src, action);
		}else if(action < 0){
			MapleInventoryManipulator.equip(c, src, action);
		}else if(action == 0){
			MapleInventoryManipulator.drop(c, type, src, quantity);
		}else{
			MapleInventoryManipulator.move(c, type, src, action);
		}
		c.getPlayer().getAutobanManager().spam(6);
	}
}