package server.life;

/**
 * @Author Arnah
 * @Website http://Vertisy.ca/
 * @since Dec 9, 2017
 */
public enum MobStat{
	PAD(0),
	PDR(1),
	MAD(2),
	MDR(3),
	ACC(4),
	EVA(5),
	Speed(6),
	Stun(7),
	Freeze(8),
	Poison(9),
	Seal(10),
	Darkness(11),
	PowerUp(12),
	MagicUp(13),
	PGuardUp(14),
	MGuardUp(15),
	PImmune(18),
	MImmune(19),
	Doom(16),
	Web(17),
	HardSkin(21),
	Ambush(22),
	Venom(24),
	Blind(25),
	SealSkill(26),
	Dazzle(28),
	PCounter(29),
	MCounter(30),
	RiseByToss(32),
	BodyPressure(33),
	Weakness(34),
	TimeBomb(35),
	Showdown(20),
	MagicCrash(36),
	Burned(27),
	Disable(31),
	Slow(32),
	Morph(33),
	Ghost(49),
	Regen(34),
	BasicStatUp(35),
	Stance(36),
	SharpEyes(37),
	ManaReflection(38),
	Attract(39),
	SpiritJavelin(40),
	Infinity(41),
	Holyshield(42),
	HamString(43),
	Concentration(45),
	BanMap(46),
	MaxLevelBuff(47),
	Barrier(50),
	DojangShield(62),
	ReverseInput(51),
	MesoUpByItem(48),
	ItemUpByItem(52),
	RespectPImmune(53),
	RespectMImmune(54),
	DefenseAtt(55),
	DefenseState(56),
	DojangBerserk(59),
	DojangInvincible(60),
	Spark(61),
	SoulMasterFinal(63),
	WindBreakerFinal(64),
	ElementalReset(65),
	WindWalk(66),
	EventRate(67),
	ComboAbilityBuff(68),
	ComboDrain(69),
	ComboBarrier(70),
	SmartKnockback(72),
	RepeatEffect(73),
	ExpBuffRate(74),
	IncEffectHPPotion(57),
	IncEffectMPPotion(58),
	StopPortion(75),
	StopMotion(76),
	Fear(77),
	EvanSlow(78),
	MagicShield(79),
	MagicResistance(80),
	SoulStone(81),
	Flying(82),
	Frozen(83),
	AssistCharge(84),
	SuddenDeath(86),
	NotDamaged(87),
	FinalCut(88),
	ThornsEffect(89),
	SwallowAttackDamage(90),
	MorewildDamageUp(91),
	Mine(92),
	Cyclone(101),
	SwallowCritical(102),
	SwallowMaxMP(103),
	SwallowDefence(104),
	SwallowEvasion(105),
	Conversion(106),
	Revive(107),
	Sneak(108),
	Mechanic(109),
	Aura(110),
	DarkAura(111),
	BlueAura(112),
	YellowAura(113),
	SuperBody(114),

	EnergyCharged(115),
	DashSpeed(116),
	DashJump(117),
	RideVehicle(118),
	PartyBooster(119),
	GuidedBullet(120),
	Undead(121),
	RideVehicleExpire(122),
	SummonBomb(127),// UINT128 - 1;
	None(0xFFFFFFFF);

	private final int shift;
	private final int mask;
	private final byte set;

	MobStat(int shift){
		this.shift = shift;
		this.mask = 1 << (shift >> 32);
		this.set = (byte) (shift >> 5);
	}

	public int getShift(){
		return shift;
	}

	public int getMask(){
		return mask;
	}

	public byte getSet(){
		return set;
	}

	public boolean isMovementAffectingStat(){
		switch (this){
			case Stun:
			case Freeze:
			case Doom:
			case RiseByToss:
			case Speed:
			case Weakness:
			case Slow:
			case Morph:
			case Ghost:
			case BasicStatUp:
			case Attract:
			case RideVehicle:
			case DashSpeed:
			case DashJump:
			case Flying:
			case Frozen:
				return true;
			default:
				return false;
		}
	}

	public static MobStat getByValue(int value){
		for(MobStat ms : values()){
			if(ms.getShift() == value) return ms;
		}
		return null;
	}
}
