package tools;

import com.zaxxer.hikari.HikariConfig;
import com.zaxxer.hikari.HikariDataSource;
import constants.ServerConstants;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * @author xXxXweebXxXx
 */
public class DatabaseConnection {
	public static final int RETURN_GENERATED_KEYS = 1;

	static {
		final var cfg = new HikariConfig();
		cfg.setDriverClassName(ServerConstants.DB_DRIVER);
		cfg.setJdbcUrl(ServerConstants.DB_URL);
		cfg.setUsername(ServerConstants.DB_USER);
		cfg.setPassword(ServerConstants.DB_PASS);
		cfg.setMaximumPoolSize(20);
		cfg.setLeakDetectionThreshold(15 * 1000L);

		cfg.addDataSourceProperty("cachePrepStmts", true);
		cfg.addDataSourceProperty("prepStmtCacheSize", 400);
		cfg.addDataSourceProperty("prepStmtCacheSqlLimit", 2048);
		cfg.addDataSourceProperty("autoReconnect", "true");

		dataSource = new HikariDataSource(cfg);
	}

	private static HikariDataSource dataSource;

	public static Connection getConnection() throws SQLException {
		return dataSource.getConnection();
	}
}