CREATE DATABASE  IF NOT EXISTS `Vertisy90` /*!40100 DEFAULT CHARACTER SET latin1 */;
USE `Vertisy90`;

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `SlayerTasks`
--

DROP TABLE IF EXISTS `SlayerTasks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `SlayerTasks` (
  `chrid` int(11) NOT NULL,
  `targetid` int(11) NOT NULL,
  `kills` int(11) NOT NULL,
  `requiredKills` int(11) NOT NULL,
  `map` longtext NOT NULL,
  PRIMARY KEY (`chrid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `SlayerTasks`
--

LOCK TABLES `SlayerTasks` WRITE;
/*!40000 ALTER TABLE `SlayerTasks` DISABLE KEYS */;
/*!40000 ALTER TABLE `SlayerTasks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `accounts`
--

DROP TABLE IF EXISTS `accounts`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `accounts` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(13) NOT NULL DEFAULT '',
  `password` varchar(128) NOT NULL DEFAULT '',
  `pin` varchar(10) DEFAULT NULL,
  `pic` varchar(128) DEFAULT NULL,
  `loggedin` tinyint(4) NOT NULL DEFAULT '0',
  `createdat` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `birthday` date NOT NULL DEFAULT '1970-01-01',
  `banned` tinyint(1) NOT NULL DEFAULT '0',
  `banreason` text,
  `gm` tinyint(1) NOT NULL DEFAULT '0',
  `macs` text,
  `nxCredit` int(11) DEFAULT NULL,
  `maplePoint` int(11) DEFAULT NULL,
  `nxPrepaid` int(11) DEFAULT NULL,
  `characterslots` tinyint(2) NOT NULL DEFAULT '5',
  `gender` tinyint(2) NOT NULL DEFAULT '10',
  `tempban` timestamp NOT NULL DEFAULT '2015-01-01 05:00:00',
  `greason` tinyint(4) NOT NULL DEFAULT '0',
  `tos` tinyint(1) NOT NULL DEFAULT '0',
  `webadmin` int(1) DEFAULT '0',
  `nick` varchar(20) DEFAULT NULL,
  `mute` int(1) DEFAULT '0',
  `email` varchar(45) DEFAULT NULL,
  `ip` text,
  `rewardpoints` int(11) NOT NULL DEFAULT '0',
  `hwid` text,
  `sessionID` bigint(18) DEFAULT NULL,
  `votePoints` int(11) NOT NULL DEFAULT '0',
  `chatBan` int(11) NOT NULL DEFAULT '0',
  `chatBanDate` timestamp NOT NULL DEFAULT '2015-01-01 05:00:00',
  `chatBanDuration` int(11) NOT NULL DEFAULT '0',
  `chatBanReason` varchar(255) DEFAULT '',
  `eliteStart` bigint(20) NOT NULL DEFAULT '0',
  `eliteLength` bigint(20) NOT NULL DEFAULT '0',
  `autoSell` varchar(45) NOT NULL DEFAULT 'false',
  `autoSellItems` longtext,
  `autoSellInventories` longtext,
  `progressValues` longtext,
  `petvac` tinyint(1) NOT NULL DEFAULT '1',
  `alpha` tinyint(1) NOT NULL DEFAULT '0',
  `lastNameChange` bigint(20) NOT NULL DEFAULT '0',
  `machineid` text,
  `remember_token` varchar(100) DEFAULT NULL,
  `created_at` timestamp NULL DEFAULT NULL,
  `updated_at` bigint(20) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`),
  KEY `ranking1` (`id`,`banned`,`gm`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `accounts`
--

LOCK TABLES `accounts` WRITE;
/*!40000 ALTER TABLE `accounts` DISABLE KEYS */;
/*!40000 ALTER TABLE `accounts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `alliance`
--

DROP TABLE IF EXISTS `alliance`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `alliance` (
  `id` int(10) unsigned NOT NULL,
  `name` varchar(13) NOT NULL,
  `notice` varchar(128) NOT NULL DEFAULT '',
  `capacity` int(10) unsigned NOT NULL DEFAULT '2',
  `rank_title1` varchar(45) NOT NULL DEFAULT 'Master',
  `rank_title2` varchar(45) NOT NULL DEFAULT 'Jr.Master',
  `rank_title3` varchar(45) NOT NULL DEFAULT 'Member',
  `rank_title4` varchar(45) NOT NULL DEFAULT 'Member',
  `rank_title5` varchar(45) NOT NULL DEFAULT 'Member',
  `guild1` int(10) NOT NULL DEFAULT '-1',
  `guild2` int(10) NOT NULL DEFAULT '-1',
  `guild3` int(10) NOT NULL DEFAULT '-1',
  `guild4` int(10) NOT NULL DEFAULT '-1',
  `guild5` int(10) NOT NULL DEFAULT '-1',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `alliance`
--

LOCK TABLES `alliance` WRITE;
/*!40000 ALTER TABLE `alliance` DISABLE KEYS */;
/*!40000 ALTER TABLE `alliance` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `area_info`
--

DROP TABLE IF EXISTS `area_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `area_info` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `charid` int(11) NOT NULL,
  `area` int(11) NOT NULL,
  `info` varchar(200) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `area_info`
--

LOCK TABLES `area_info` WRITE;
/*!40000 ALTER TABLE `area_info` DISABLE KEYS */;
/*!40000 ALTER TABLE `area_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `bbs_replies`
--

DROP TABLE IF EXISTS `bbs_replies`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `bbs_replies` (
  `replyid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `threadid` int(10) unsigned NOT NULL,
  `postercid` int(10) unsigned NOT NULL,
  `timestamp` bigint(20) unsigned NOT NULL,
  `content` varchar(26) NOT NULL DEFAULT '',
  PRIMARY KEY (`replyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `bbs_replies`
--

LOCK TABLES `bbs_replies` WRITE;
/*!40000 ALTER TABLE `bbs_replies` DISABLE KEYS */;
/*!40000 ALTER TABLE `bbs_replies` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `bbs_threads`
--

DROP TABLE IF EXISTS `bbs_threads`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `bbs_threads` (
  `threadid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `postercid` int(10) unsigned NOT NULL,
  `name` varchar(26) NOT NULL DEFAULT '',
  `timestamp` bigint(20) unsigned NOT NULL,
  `icon` smallint(5) unsigned NOT NULL,
  `replycount` smallint(5) unsigned NOT NULL DEFAULT '0',
  `startpost` text NOT NULL,
  `guildid` int(10) unsigned NOT NULL,
  `localthreadid` int(10) unsigned NOT NULL,
  PRIMARY KEY (`threadid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `bbs_threads`
--

LOCK TABLES `bbs_threads` WRITE;
/*!40000 ALTER TABLE `bbs_threads` DISABLE KEYS */;
/*!40000 ALTER TABLE `bbs_threads` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `bestitems`
--

DROP TABLE IF EXISTS `bestitems`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `bestitems` (
  `sn` int(11) NOT NULL,
  `gender` int(11) NOT NULL,
  `category` int(11) NOT NULL,
  `purchases` int(11) NOT NULL,
  PRIMARY KEY (`sn`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `bestitems`
--

LOCK TABLES `bestitems` WRITE;
/*!40000 ALTER TABLE `bestitems` DISABLE KEYS */;
/*!40000 ALTER TABLE `bestitems` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `buddies`
--

DROP TABLE IF EXISTS `buddies`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `buddies` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `characterid` int(11) NOT NULL,
  `buddyid` int(11) NOT NULL,
  `pending` tinyint(4) NOT NULL DEFAULT '0',
  `group` varchar(17) DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `buddies`
--

LOCK TABLES `buddies` WRITE;
/*!40000 ALTER TABLE `buddies` DISABLE KEYS */;
/*!40000 ALTER TABLE `buddies` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `characters`
--

DROP TABLE IF EXISTS `characters`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `characters` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `accountid` int(11) NOT NULL DEFAULT '0',
  `world` int(11) NOT NULL DEFAULT '0',
  `name` varchar(13) NOT NULL DEFAULT '',
  `level` int(11) NOT NULL DEFAULT '1',
  `exp` int(11) NOT NULL DEFAULT '0',
  `gachaexp` int(11) NOT NULL DEFAULT '0',
  `str` int(11) NOT NULL DEFAULT '12',
  `dex` int(11) NOT NULL DEFAULT '5',
  `luk` int(11) NOT NULL DEFAULT '4',
  `int` int(11) NOT NULL DEFAULT '4',
  `hp` int(11) NOT NULL DEFAULT '50',
  `mp` int(11) NOT NULL DEFAULT '5',
  `maxhp` int(11) NOT NULL DEFAULT '50',
  `maxmp` int(11) NOT NULL DEFAULT '5',
  `meso` int(11) NOT NULL DEFAULT '0',
  `hpMpUsed` int(11) unsigned NOT NULL DEFAULT '0',
  `job` int(11) NOT NULL DEFAULT '0',
  `subjob` int(4) NOT NULL DEFAULT '0',
  `skincolor` int(11) NOT NULL DEFAULT '0',
  `gender` int(11) NOT NULL DEFAULT '0',
  `fame` int(11) NOT NULL DEFAULT '0',
  `hair` int(11) NOT NULL DEFAULT '0',
  `face` int(11) NOT NULL DEFAULT '0',
  `ap` int(11) NOT NULL DEFAULT '0',
  `sp` varchar(128) NOT NULL DEFAULT '0,0,0,0,0,0,0,0,0,0',
  `map` int(11) NOT NULL DEFAULT '0',
  `spawnpoint` int(11) NOT NULL DEFAULT '0',
  `gm` tinyint(1) NOT NULL DEFAULT '0',
  `party` int(11) NOT NULL DEFAULT '0',
  `buddyCapacity` int(11) NOT NULL DEFAULT '25',
  `createdate` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `rank` int(10) unsigned NOT NULL DEFAULT '1',
  `rankMove` int(11) NOT NULL DEFAULT '0',
  `jobRank` int(10) unsigned NOT NULL DEFAULT '1',
  `jobRankMove` int(11) NOT NULL DEFAULT '0',
  `guildid` int(10) unsigned NOT NULL DEFAULT '0',
  `guildrank` int(10) unsigned NOT NULL DEFAULT '5',
  `gp` int(11) NOT NULL DEFAULT '0',
  `messengerid` int(10) unsigned NOT NULL DEFAULT '0',
  `messengerposition` int(10) unsigned NOT NULL DEFAULT '4',
  `mountlevel` int(9) NOT NULL DEFAULT '1',
  `mountexp` int(9) NOT NULL DEFAULT '0',
  `mounttiredness` int(9) NOT NULL DEFAULT '0',
  `omokwins` int(11) NOT NULL DEFAULT '0',
  `omoklosses` int(11) NOT NULL DEFAULT '0',
  `omokties` int(11) NOT NULL DEFAULT '0',
  `matchcardwins` int(11) NOT NULL DEFAULT '0',
  `matchcardlosses` int(11) NOT NULL DEFAULT '0',
  `matchcardties` int(11) NOT NULL DEFAULT '0',
  `MerchantMesos` int(11) DEFAULT '0',
  `HasMerchant` tinyint(1) DEFAULT '0',
  `equipslots` int(11) NOT NULL DEFAULT '24',
  `useslots` int(11) NOT NULL DEFAULT '24',
  `setupslots` int(11) NOT NULL DEFAULT '24',
  `etcslots` int(11) NOT NULL DEFAULT '24',
  `familyId` int(11) NOT NULL DEFAULT '-1',
  `monsterbookcover` int(11) NOT NULL DEFAULT '0',
  `allianceRank` int(10) NOT NULL DEFAULT '5',
  `vanquisherStage` int(11) unsigned NOT NULL DEFAULT '0',
  `dojoPoints` int(11) unsigned NOT NULL DEFAULT '0',
  `lastDojoStage` int(10) unsigned NOT NULL DEFAULT '0',
  `finishedDojoTutorial` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `vanquisherKills` int(11) unsigned NOT NULL DEFAULT '0',
  `summonValue` int(11) unsigned NOT NULL DEFAULT '0',
  `partnerId` int(11) NOT NULL DEFAULT '0',
  `reborns` int(5) NOT NULL DEFAULT '0',
  `PQPoints` int(11) NOT NULL DEFAULT '0',
  `dataString` varchar(64) NOT NULL DEFAULT '',
  `lastLogoutTime` timestamp NOT NULL DEFAULT '2015-01-01 05:00:00',
  `pendantExp` tinyint(1) NOT NULL DEFAULT '0',
  `deleted` int(11) NOT NULL DEFAULT '0',
  `ironMan` int(11) NOT NULL DEFAULT '0',
  `ironManNX` int(11) NOT NULL DEFAULT '0',
  `hardmode` int(11) NOT NULL DEFAULT '0',
  `rsSkillLevel` longtext,
  `rsSkillExp` longtext,
  `marriedto` int(11) NOT NULL DEFAULT '0',
  `marriageringid` int(11) NOT NULL DEFAULT '0',
  `engagementringid` int(11) NOT NULL DEFAULT '0',
  `marriageid` int(11) NOT NULL DEFAULT '0',
  `progressValues` longtext,
  `reincarnations` int(11) NOT NULL DEFAULT '0',
  `tasksCompleted` int(11) NOT NULL DEFAULT '0',
  `playtime` bigint(20) NOT NULL DEFAULT '0',
  `hash` varchar(40) NOT NULL DEFAULT '',
  `highestLevel` int(11) NOT NULL DEFAULT '1',
  `bossEntries` varchar(500) DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `id_3` (`id`),
  KEY `id` (`id`),
  KEY `id_2` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 PACK_KEYS=0;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `characters`
--

LOCK TABLES `characters` WRITE;
/*!40000 ALTER TABLE `characters` DISABLE KEYS */;
/*!40000 ALTER TABLE `characters` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cooldowns`
--

DROP TABLE IF EXISTS `cooldowns`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cooldowns` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `charid` int(11) NOT NULL,
  `SkillID` int(11) NOT NULL,
  `length` bigint(20) unsigned NOT NULL,
  `StartTime` bigint(20) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cooldowns`
--

LOCK TABLES `cooldowns` WRITE;
/*!40000 ALTER TABLE `cooldowns` DISABLE KEYS */;
/*!40000 ALTER TABLE `cooldowns` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cs_categorydiscount`
--

DROP TABLE IF EXISTS `cs_categorydiscount`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cs_categorydiscount` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `category` int(11) DEFAULT NULL,
  `categorySub` int(11) DEFAULT NULL,
  `discountRate` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cs_categorydiscount`
--

LOCK TABLES `cs_categorydiscount` WRITE;
/*!40000 ALTER TABLE `cs_categorydiscount` DISABLE KEYS */;
/*!40000 ALTER TABLE `cs_categorydiscount` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `donate_log`
--

DROP TABLE IF EXISTS `donate_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `donate_log` (
  `donateid` int(11) NOT NULL AUTO_INCREMENT,
  `id` varchar(64) NOT NULL,
  `email` varchar(255) NOT NULL,
  `username` varchar(16) NOT NULL,
  `amount` double NOT NULL,
  `original_request` text NOT NULL,
  `DT` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`donateid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `donate_log`
--

LOCK TABLES `donate_log` WRITE;
/*!40000 ALTER TABLE `donate_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `donate_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `donate_log_full`
--

DROP TABLE IF EXISTS `donate_log_full`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `donate_log_full` (
  `donateid` int(11) NOT NULL AUTO_INCREMENT,
  `id` varchar(64) NOT NULL,
  `email` varchar(255) NOT NULL,
  `username` varchar(16) NOT NULL,
  `amount` double NOT NULL,
  `original_request` text NOT NULL,
  `DT` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`donateid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `donate_log_full`
--

LOCK TABLES `donate_log_full` WRITE;
/*!40000 ALTER TABLE `donate_log_full` DISABLE KEYS */;
/*!40000 ALTER TABLE `donate_log_full` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `drop_data`
--

DROP TABLE IF EXISTS `drop_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `drop_data` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `dropperid` int(11) NOT NULL,
  `itemid` int(11) NOT NULL DEFAULT '0',
  `dropType` tinyint(1) NOT NULL DEFAULT '0',
  `minimum_quantity` int(11) NOT NULL DEFAULT '1',
  `maximum_quantity` int(11) NOT NULL DEFAULT '1',
  `questid` int(11) NOT NULL DEFAULT '0',
  `chance` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=14304 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `drop_data`
--

LOCK TABLES `drop_data` WRITE;
/*!40000 ALTER TABLE `drop_data` DISABLE KEYS */;
INSERT INTO `drop_data` VALUES (1,9400121,4000138,0,1,1,0,600000),(3,9400121,2000006,0,1,1,0,999999),(4,9400121,2000011,0,1,1,0,100000),(5,9400121,2020016,0,1,1,0,100000),(6,9400121,2022024,0,1,1,0,100000),(7,9400121,2022026,0,1,1,0,100000),(8,9400121,2043705,0,1,1,0,1500),(9,9400121,2040716,0,1,1,0,1500),(10,9400121,2040908,0,1,1,0,1500),(11,9400121,2040510,0,1,1,0,1500),(12,9400121,1072239,0,1,1,0,4000),(13,9400121,1422013,0,1,1,0,3500),(14,9400121,1402016,0,1,1,0,3500),(15,9400121,1442020,0,1,1,0,3500),(16,9400121,1432011,0,1,1,0,2500),(17,9400121,1332022,0,1,1,0,2500),(18,9400121,1312015,0,1,1,0,3500),(19,9400121,1382010,0,1,1,0,3500),(20,9400121,1372009,0,1,1,0,3500),(21,9400121,1082085,0,1,1,0,5000),(22,9400121,1332022,0,1,1,0,2500),(23,9400121,1472033,0,1,1,0,2500),(24,8810018,4001094,0,1,1,0,999999),(25,8810018,2290125,0,1,1,0,100000),(27,9400013,4000225,0,1,1,0,600000),(28,9400013,2000006,0,1,1,0,20000),(29,9400013,2000004,0,1,1,0,20000),(30,9400013,2070013,0,1,1,0,500),(31,9400013,2002005,0,1,1,0,20000),(32,9400013,2022018,0,1,1,0,20000),(33,9400013,2040306,0,1,1,0,100),(34,9400013,2043704,0,1,1,0,100),(35,9400013,2044605,0,1,1,0,100),(36,9400013,2041034,0,1,1,0,100),(37,9400013,1032019,0,1,1,0,800),(38,9400013,1102013,0,1,1,0,800),(39,9400013,1322026,0,1,1,0,800),(40,9400013,1092015,0,1,1,0,800),(41,9400013,1382016,0,1,1,0,800),(42,9400013,1002276,0,1,1,0,800),(43,9400013,1002403,0,1,1,0,800),(44,9400013,1472027,0,1,1,0,800),(45,9400113,4000140,0,1,1,0,600000),(46,9400113,2022027,0,1,1,0,200000),(47,9400113,2022027,0,1,1,0,200000),(48,9400113,2000004,0,1,1,0,999999),(49,9400113,2000004,0,1,1,0,999999),(50,9400113,2002008,0,1,1,0,200000),(51,9400113,2002008,0,1,1,0,200000),(52,9400300,4000141,0,1,1,0,600000),(53,9400300,2000004,0,1,1,0,999999),(54,9400300,2040813,0,1,1,0,1500),(55,9400300,2041030,0,1,1,0,1500),(56,9400300,2041040,0,1,1,0,1500),(57,9400300,1072238,0,1,1,0,8000),(58,9400300,1032026,0,1,1,0,10000),(59,9400300,1372011,0,1,1,0,7000),(60,9400112,4000139,0,1,1,0,600000),(61,9400112,2002011,0,1,1,0,200000),(62,9400112,2002011,0,1,1,0,200000),(63,9400112,2002011,0,1,1,0,200000),(64,9400112,2000004,0,1,1,0,999999),(65,9400112,2000004,0,1,1,0,999999),(66,9400545,4032024,0,1,1,0,50000),(67,9400545,4032025,0,1,1,0,600000),(72,9400545,2070006,0,1,1,0,100),(73,9400545,2044404,0,1,1,0,100),(74,9400545,2044702,0,1,1,0,100),(75,9400545,2044305,0,1,1,0,100),(76,9400545,1102029,0,1,1,0,800),(77,9400545,1032023,0,1,1,0,800),(78,9400545,1402004,0,1,1,0,800),(79,9400545,1072210,0,1,1,0,800),(80,9400545,1040104,0,1,1,0,800),(81,9400545,1060092,0,1,1,0,800),(82,9400545,1082129,0,1,1,0,800),(83,9400545,1442008,0,1,1,0,800),(84,9400545,1072178,0,1,1,0,800),(85,9400545,1050092,0,1,1,0,800),(86,9400545,1002271,0,1,1,0,800),(87,9400545,1051053,0,1,1,0,800),(88,9400545,1382008,0,1,1,0,800),(89,9400545,1002275,0,1,1,0,800),(90,9400545,1051082,0,1,1,0,800),(91,9400545,1050064,0,1,1,0,800),(92,9400545,1472028,0,1,1,0,800),(93,9400545,1072193,0,1,1,0,800),(94,9400545,1072172,0,1,1,0,800),(95,9400545,1002285,0,1,1,0,800),(96,100100,4000019,0,1,1,0,600000),(97,100100,2000000,0,1,1,0,20000),(98,100100,2040002,0,1,1,0,100),(99,100100,2041001,0,1,1,0,100),(100,100100,2060000,0,1,1,0,30000),(103,100100,2061000,0,1,1,0,30000),(104,100100,1002067,0,1,1,0,800),(105,100100,2010009,0,1,1,0,20000),(106,100101,4000000,0,1,1,0,600000),(107,100101,2041006,0,1,1,0,100),(108,100101,2000000,0,1,1,0,20000),(110,100101,2060000,0,1,1,0,30000),(112,100101,2061000,0,1,1,0,30000),(113,100101,1040013,0,1,1,0,800),(114,100101,1041012,0,1,1,0,800),(115,100101,1060004,0,1,1,0,800),(116,100101,1040017,0,1,1,0,800),(117,100101,1060013,0,1,1,0,800),(118,100101,2010009,0,1,1,0,20000),(119,1110100,4000012,0,1,1,0,600000),(120,1110100,2000000,0,1,1,0,20000),(121,1110100,2043102,0,1,1,0,100),(122,1110100,2000003,0,1,1,0,20000),(124,1110100,1322000,0,1,1,0,800),(125,1110100,2060000,0,1,1,0,30000),(126,1110100,1041044,0,1,1,0,800),(127,1110100,1061037,0,1,1,0,800),(129,1110100,1092008,0,1,1,0,800),(130,1110100,1041017,0,1,1,0,800),(131,1110100,1061012,0,1,1,0,800),(132,1110100,1462002,0,1,1,0,800),(133,1110100,2061000,0,1,1,0,30000),(134,1110100,1041063,0,1,1,0,800),(135,1110100,1061059,0,1,1,0,800),(136,1110100,1452003,0,1,1,0,800),(137,1110100,2048000,0,1,1,0,100),(138,1110100,1002033,0,1,1,0,800),(139,1110100,1302007,0,1,1,0,800),(141,1110100,1032001,0,1,1,0,800),(142,1110100,1002010,0,1,1,0,800),(143,1110100,2000001,0,1,1,0,20000),(144,1110100,1002143,0,1,1,0,800),(145,1110100,1432005,0,1,1,0,800),(146,1110100,1412012,0,1,1,0,800),(147,1110100,1072285,0,1,1,0,800),(148,1110100,1482001,0,1,1,0,800),(149,1110101,4000005,0,1,1,0,600000),(150,1110101,2000000,0,1,1,0,20000),(151,1110101,2040802,0,1,1,0,100),(152,1110101,1092003,0,1,1,0,800),(153,1110101,1002039,0,1,1,0,800),(154,1110101,1442000,0,1,1,0,800),(155,1110101,1041061,0,1,1,0,800),(156,1110101,1061057,0,1,1,0,800),(157,1110101,1041018,0,1,1,0,800),(158,1110101,1061013,0,1,1,0,800),(159,1110101,2060000,0,1,1,0,30000),(162,1110101,2061000,0,1,1,0,30000),(163,1110101,1032001,0,1,1,0,800),(164,1110101,1382000,0,1,1,0,800),(165,1110101,1302006,0,1,1,0,800),(166,1110101,2000001,0,1,1,0,20000),(167,1110101,2000003,0,1,1,0,20000),(168,1110101,1482000,0,1,1,0,800),(169,1110101,1002613,0,1,1,0,800),(170,1120100,4000006,0,1,1,0,600000),(171,1120100,2000000,0,1,1,0,20000),(172,1120100,2043002,0,1,1,0,100),(173,1120100,1032001,0,1,1,0,800),(174,1120100,1422000,0,1,1,0,800),(175,1120100,1092000,0,1,1,0,800),(176,1120100,2060000,0,1,1,0,30000),(179,1120100,2000003,0,1,1,0,20000),(180,1120100,1041026,0,1,1,0,800),(181,1120100,1061022,0,1,1,0,800),(182,1120100,2061000,0,1,1,0,30000),(183,1120100,1040037,0,1,1,0,800),(184,1120100,1060027,0,1,1,0,800),(185,1120100,1482001,0,1,1,0,800),(186,1130100,4000018,0,1,1,0,600000),(187,1130100,2000000,0,1,1,0,20000),(188,1130100,2043202,0,1,1,0,100),(189,1130100,1372001,0,1,1,0,800),(190,1130100,2000003,0,1,1,0,20000),(191,1130100,1072008,0,1,1,0,800),(192,1130100,2060000,0,1,1,0,30000),(195,1130100,1312016,0,1,1,0,800),(196,1130100,1402001,0,1,1,0,800),(197,1130100,1032003,0,1,1,0,800),(198,1130100,1092007,0,1,1,0,800),(199,1130100,1040019,0,1,1,0,800),(200,1130100,1060015,0,1,1,0,800),(201,1130100,1041045,0,1,1,0,800),(202,1130100,1061038,0,1,1,0,800),(203,1130100,2061000,0,1,1,0,30000),(204,1130100,1002118,0,1,1,0,800),(205,1130100,1382004,0,1,1,0,800),(206,1130100,1402009,0,1,1,0,800),(207,1130100,1492001,0,1,1,0,800),(208,1140100,2000000,0,1,1,0,20000),(209,1140100,2000003,0,1,1,0,20000),(210,1140100,4000195,0,1,1,0,600000),(211,1140100,2060000,0,1,1,0,30000),(212,1140100,2061000,0,1,1,0,30000),(216,1140100,2040501,0,1,1,0,100),(217,1140100,2040801,0,1,1,0,100),(218,1140100,1041062,0,1,1,0,800),(219,1140100,1061058,0,1,1,0,800),(220,1140100,1050010,0,1,1,0,800),(221,1140100,2048001,0,1,1,0,100),(222,1140100,1041029,0,1,1,0,800),(223,1140100,1061027,0,1,1,0,800),(224,1140100,1072046,0,1,1,0,800),(225,1140100,1072066,0,1,1,0,800),(226,1140100,1082018,0,1,1,0,800),(227,1140100,1002107,0,1,1,0,800),(228,1140100,1002113,0,1,1,0,800),(229,1140100,1050003,0,1,1,0,800),(230,1140100,1412012,0,1,1,0,800),(231,1140100,1082180,0,1,1,0,800),(232,1140100,2044802,0,1,1,0,100),(233,120100,4000011,0,1,1,0,600000),(234,120100,2041007,0,1,1,0,100),(235,120100,2000000,0,1,1,0,20000),(238,120100,2060000,0,1,1,0,30000),(239,120100,1332006,0,1,1,0,800),(240,120100,2061000,0,1,1,0,30000),(241,120100,1062000,0,1,1,0,800),(242,120100,1060007,0,1,1,0,800),(243,120100,1061009,0,1,1,0,800),(244,120100,2010009,0,1,1,0,20000),(245,120100,1002610,0,1,1,0,800),(246,1210100,4000017,0,1,1,0,40000),(247,1210100,2041021,0,1,1,0,100),(248,1210100,2000000,0,1,1,0,20000),(249,1210100,2040702,0,1,1,0,100),(250,1210100,1002008,0,1,1,0,800),(251,1210100,1062002,0,1,1,0,800),(252,1210100,1422000,0,1,1,0,800),(253,1210100,2060000,0,1,1,0,30000),(256,1210100,1472000,0,1,1,0,800),(257,1210100,4000021,0,1,1,0,50000),(258,1210100,2061000,0,1,1,0,30000),(259,1210100,1061028,0,1,1,0,800),(260,1210100,1041014,0,1,1,0,800),(261,1210100,1040034,0,1,1,0,800),(262,1210100,2010009,0,1,1,0,20000),(263,1210100,1002610,0,1,1,0,800),(264,1210101,4000002,0,1,1,0,600000),(265,1210101,2000000,0,1,1,0,20000),(266,1210101,4003004,0,1,1,0,200000),(267,1210101,2040902,0,1,1,0,100),(268,1210101,1040011,0,1,1,0,800),(269,1210101,1040034,0,1,1,0,800),(270,1210101,1060024,0,1,1,0,800),(271,1210101,2060000,0,1,1,0,30000),(274,1210101,4000021,0,1,1,0,50000),(275,1210101,2061000,0,1,1,0,30000),(276,1210101,1402018,0,1,1,0,800),(277,1210101,1032003,0,1,1,0,800),(278,1210101,1041012,0,1,1,0,800),(279,1210101,1040014,0,1,1,0,800),(280,1210101,1492000,0,1,1,0,800),(281,1210101,1052098,0,1,1,0,800),(282,1210101,1072285,0,1,1,0,800),(283,1210102,4000001,0,1,1,0,600000),(284,1210102,2000000,0,1,1,0,20000),(285,1210102,2040705,0,1,1,0,100),(286,1210102,1072004,0,1,1,0,800),(287,1210102,1002043,0,1,1,0,800),(288,1210102,1432000,0,1,1,0,800),(289,1210102,1312000,0,1,1,0,800),(290,1210102,2060000,0,1,1,0,30000),(293,1210102,2061000,0,1,1,0,30000),(294,1210102,1082012,0,1,1,0,800),(295,1210102,1072015,0,1,1,0,800),(296,1210102,1072031,0,1,1,0,800),(297,1210102,1052095,0,1,1,0,800),(298,1210102,2330000,0,1,1,0,100),(299,1210103,2000000,0,1,1,0,20000),(300,1210103,2041015,0,1,1,0,100),(301,1210103,2043302,0,1,1,0,100),(302,1210103,2041004,0,1,1,0,100),(303,1210103,2000003,0,1,1,0,20000),(306,1210103,2060000,0,1,1,0,30000),(307,1210103,2061000,0,1,1,0,30000),(308,1210103,4000037,0,1,1,0,600000),(309,1210103,1002075,0,1,1,0,800),(310,1210103,1432000,0,1,1,0,800),(311,1210103,1040035,0,1,1,0,800),(312,1210103,1060025,0,1,1,0,800),(313,1210103,1041062,0,1,1,0,800),(314,1210103,1061058,0,1,1,0,800),(315,1210103,1402018,0,1,1,0,800),(316,1210103,1072019,0,1,1,0,800),(317,1210103,1432008,0,1,1,0,800),(318,1210103,4006000,0,1,1,0,10000),(319,1210103,2048001,0,1,1,0,100),(320,1210103,1412012,0,1,1,0,800),(321,1210103,1082180,0,1,1,0,800),(322,1210103,1492001,0,1,1,0,800),(323,1210103,2330000,0,1,1,0,100),(324,130100,4000003,0,1,1,0,600000),(325,130100,2041008,0,1,1,0,100),(326,130100,2000000,0,1,1,0,20000),(327,130100,2040402,0,1,1,0,100),(329,130100,2060000,0,1,1,0,30000),(331,130100,1332000,0,1,1,0,800),(332,130100,2061000,0,1,1,0,30000),(333,130100,1072007,0,1,1,0,800),(334,130100,1082003,0,1,1,0,800),(335,130100,1452003,0,1,1,0,800),(336,130100,2010009,0,1,1,0,20000),(337,130100,1061014,0,1,1,0,800),(338,130100,1492000,0,1,1,0,800),(339,130101,4000016,0,1,1,0,600000),(340,130101,2041009,0,1,1,0,100),(341,130101,2000000,0,1,1,0,20000),(342,130101,2040502,0,1,1,0,100),(343,130101,1402001,0,1,1,0,800),(344,130101,1322007,0,1,1,0,800),(345,130101,2060000,0,1,1,0,30000),(348,130101,2061000,0,1,1,0,30000),(349,130101,1372002,0,1,1,0,800),(350,130101,1082029,0,1,1,0,800),(351,130101,1072060,0,1,1,0,800),(352,130101,1032003,0,1,1,0,800),(353,130101,1061029,0,1,1,0,800),(354,130101,2010009,0,1,1,0,20000),(355,130101,1052095,0,1,1,0,800),(356,2100100,2000001,0,1,1,0,20000),(357,2100100,2000003,0,1,1,0,20000),(358,2100100,2060000,0,1,1,0,30000),(359,2100100,2061000,0,1,1,0,30000),(360,2100100,4000324,0,1,1,0,600000),(363,2100100,2040601,0,1,1,0,100),(364,2100100,1382002,0,1,1,0,800),(365,2100100,1002119,0,1,1,0,800),(366,2100100,1332010,0,1,1,0,800),(367,2100100,1050025,0,1,1,0,800),(368,2100100,1082002,0,1,1,0,800),(369,2100100,1072007,0,1,1,0,800),(370,2100100,1032009,0,1,1,0,800),(371,2100100,1050005,0,1,1,0,800),(372,2100100,4003004,0,1,1,0,200000),(374,2100100,1072288,0,1,1,0,800),(375,2100100,2040420,0,1,1,0,100),(376,2100100,2049000,0,1,1,0,150),(377,2100101,2000001,0,1,1,0,20000),(378,2100101,2000003,0,1,1,0,20000),(379,2100101,2060000,0,1,1,0,30000),(380,2100101,2061000,0,1,1,0,30000),(381,2100101,4000325,0,1,1,0,600000),(382,2100101,2002002,0,1,1,0,20000),(385,2100101,2044602,0,1,1,0,100),(386,2100101,1092021,0,1,1,0,800),(387,2100101,1472006,0,1,1,0,800),(388,2100101,1060017,0,1,1,0,800),(389,2100101,1061028,0,1,1,0,800),(390,2100101,1002129,0,1,1,0,800),(391,2100101,1041027,0,1,1,0,800),(392,2100101,1061025,0,1,1,0,800),(393,2100101,4003004,0,1,1,0,200000),(395,2100101,1082183,0,1,1,0,800),(396,2100101,2044210,0,1,1,0,100),(397,2100102,2000001,0,1,1,0,20000),(398,2100102,2000003,0,1,1,0,20000),(399,2100102,2060000,0,1,1,0,30000),(400,2100102,2061000,0,1,1,0,30000),(401,2100102,4000329,0,1,1,0,600000),(404,2100102,2040705,0,1,1,0,100),(405,2100102,2044102,0,1,1,0,100),(406,2100102,1051004,0,1,1,0,800),(407,2100102,1050024,0,1,1,0,800),(408,2100102,1032006,0,1,1,0,800),(409,2100102,1002048,0,1,1,0,800),(410,2100102,1072027,0,1,1,0,800),(411,2100102,1040044,0,1,1,0,800),(412,2100102,1060033,0,1,1,0,800),(413,2100102,1462003,0,1,1,0,800),(414,2100102,2022155,0,1,1,0,20000),(416,2100102,1082183,0,1,1,0,800),(417,2100102,1082186,0,1,1,0,800),(418,2100102,2044901,0,1,1,0,100),(419,2100102,2043212,0,1,1,0,100),(420,2100103,2000001,0,1,1,0,20000),(421,2100103,2000003,0,1,1,0,20000),(422,2100103,2060000,0,1,1,0,30000),(423,2100103,2061000,0,1,1,0,30000),(424,2100103,4000330,0,1,1,0,600000),(427,2100103,2040501,0,1,1,0,100),(428,2100103,1322009,0,1,1,0,800),(429,2100103,1092002,0,1,1,0,800),(430,2100103,1432002,0,1,1,0,800),(431,2100103,1072054,0,1,1,0,800),(432,2100103,1082016,0,1,1,0,800),(433,2100103,1072078,0,1,1,0,800),(434,2100103,1061054,0,1,1,0,800),(435,2100103,1041058,0,1,1,0,800),(436,2100103,1002096,0,1,1,0,800),(437,2100103,1050011,0,1,1,0,800),(438,2100103,2022155,0,1,1,0,20000),(440,2100103,1072291,0,1,1,0,800),(441,2100103,2044314,0,1,1,0,100),(442,2100104,2000001,0,1,1,0,20000),(443,2100104,2000003,0,1,1,0,20000),(444,2100104,2060000,0,1,1,0,30000),(445,2100104,2061000,0,1,1,0,30000),(446,2100104,4000331,0,1,1,0,600000),(447,2100104,2002003,0,1,1,0,20000),(451,2100104,2041002,0,1,1,0,100),(452,2100104,1442001,0,1,1,0,800),(453,2100104,1322003,0,1,1,0,800),(454,2100104,1092019,0,1,1,0,800),(455,2100104,1072087,0,1,1,0,800),(456,2100104,1040068,0,1,1,0,800),(457,2100104,1060057,0,1,1,0,800),(458,2100104,1082052,0,1,1,0,800),(459,2100104,1002004,0,1,1,0,800),(460,2100104,2022155,0,1,1,0,20000),(462,2100104,1082186,0,1,1,0,800),(463,2100104,2043214,0,1,1,0,100),(464,2100105,2000001,0,1,1,0,20000),(465,2100105,2000003,0,1,1,0,20000),(466,2100105,2060000,0,1,1,0,30000),(467,2100105,2061000,0,1,1,0,30000),(468,2100105,4000328,0,1,1,0,600000),(470,2100105,4006001,0,1,1,0,10000),(471,2100105,2040902,0,1,1,0,100),(472,2100105,2044002,0,1,1,0,100),(473,2100105,1452003,0,1,1,0,800),(474,2100105,1302006,0,1,1,0,800),(475,2100105,1372004,0,1,1,0,800),(476,2100105,1002013,0,1,1,0,800),(477,2100105,1072086,0,1,1,0,800),(478,2100105,1002119,0,1,1,0,800),(479,2100105,1072007,0,1,1,0,800),(480,2100105,1082020,0,1,1,0,800),(482,2100105,1052101,0,1,1,0,800),(483,2100105,1482003,0,1,1,0,800),(484,2100105,2330000,0,1,1,0,100),(485,2100105,2040316,0,1,1,0,100),(486,2100105,2040319,0,1,1,0,100),(487,2100105,2044412,0,1,1,0,100),(488,2100106,2000001,0,1,1,0,20000),(489,2100106,2000003,0,1,1,0,20000),(490,2100106,2060000,0,1,1,0,30000),(491,2100106,2061000,0,1,1,0,30000),(492,2100106,4000326,0,1,1,0,600000),(493,2100106,2002004,0,1,1,0,20000),(496,2100106,2044501,0,1,1,0,100),(497,2100106,1402002,0,1,1,0,800),(498,2100106,1032004,0,1,1,0,800),(499,2100106,1050001,0,1,1,0,800),(500,2100106,1002055,0,1,1,0,800),(501,2100106,1040049,0,1,1,0,800),(502,2100106,1060037,0,1,1,0,800),(503,2100106,1082068,0,1,1,0,800),(504,2100106,1432001,0,1,1,0,800),(506,2100106,1492002,0,1,1,0,800),(507,2100106,2330000,0,1,1,0,100),(508,2100106,2040926,0,1,1,0,100),(509,2100107,2000001,0,1,1,0,20000),(510,2100107,2000003,0,1,1,0,20000),(511,2100107,2060000,0,1,1,0,30000),(512,2100107,2061000,0,1,1,0,30000),(513,2100107,4000327,0,1,1,0,600000),(516,2100107,2048001,0,1,1,0,100),(517,2100107,2070002,0,1,1,0,500),(518,2100107,1332004,0,1,1,0,800),(519,2100107,1382017,0,1,1,0,800),(520,2100107,1041054,0,1,1,0,800),(521,2100107,1061050,0,1,1,0,800),(522,2100107,1002141,0,1,1,0,800),(523,2100107,1051011,0,1,1,0,800),(524,2100107,1040059,0,1,1,0,800),(525,2100107,1060045,0,1,1,0,800),(527,2100107,1492003,0,1,1,0,800),(528,2100108,2000001,0,1,1,0,20000),(529,2100108,2000003,0,1,1,0,20000),(530,2100108,2060000,0,1,1,0,30000),(531,2100108,2061000,0,1,1,0,30000),(532,2100108,4000333,0,1,1,0,600000),(533,2100108,2002005,0,1,1,0,20000),(537,2100108,2043002,0,1,1,0,100),(538,2100108,2043701,0,1,1,0,100),(539,2100108,1332009,0,1,1,0,800),(540,2100108,1412004,0,1,1,0,800),(541,2100108,1040062,0,1,1,0,800),(542,2100108,1060051,0,1,1,0,800),(543,2100108,1050029,0,1,1,0,800),(544,2100108,1002164,0,1,1,0,800),(545,2100108,1082005,0,1,1,0,800),(546,2100108,4003004,0,1,1,0,200000),(548,2100108,1482003,0,1,1,0,800),(549,2100108,2044801,0,1,1,0,100),(550,2100108,2044014,0,1,1,0,100),(551,2100108,2044214,0,1,1,0,100),(552,210100,4000004,0,1,1,0,600000),(553,210100,2041018,0,1,1,0,100),(554,210100,4000010,0,1,1,0,600000),(555,210100,2000000,0,1,1,0,20000),(556,210100,2040602,0,1,1,0,100),(557,210100,1002019,0,1,1,0,800),(558,210100,1412001,0,1,1,0,800),(559,210100,2060000,0,1,1,0,30000),(562,210100,2061000,0,1,1,0,30000),(563,210100,1432001,0,1,1,0,800),(564,210100,1082019,0,1,1,0,800),(565,210100,1072023,0,1,1,0,800),(566,210100,1322007,0,1,1,0,800),(567,210100,1412012,0,1,1,0,800),(568,210100,2010009,0,1,1,0,20000),(569,210100,1482000,0,1,1,0,800),(570,2110200,4000015,0,1,1,0,600000),(571,2110200,2000001,0,1,1,0,20000),(572,2110200,2002003,0,1,1,0,20000),(573,2110200,2044102,0,1,1,0,100),(574,2110200,1002005,0,1,1,0,800),(575,2110200,1041008,0,1,1,0,800),(576,2110200,1061006,0,1,1,0,800),(577,2110200,1072073,0,1,1,0,800),(578,2110200,1050006,0,1,1,0,800),(579,2110200,2060000,0,1,1,0,30000),(582,2110200,2000003,0,1,1,0,20000),(583,2110200,1462004,0,1,1,0,800),(584,2110200,1040044,0,1,1,0,800),(585,2110200,1060033,0,1,1,0,800),(586,2110200,2061000,0,1,1,0,30000),(587,2110200,1060002,0,1,1,0,800),(588,2110200,1082000,0,1,1,0,800),(589,2110200,1002038,0,1,1,0,800),(590,2110200,1092000,0,1,1,0,800),(591,2110200,1302004,0,1,1,0,800),(592,2110200,1442001,0,1,1,0,800),(593,2110200,1492002,0,1,1,0,800),(594,2110200,1052104,0,1,1,0,800),(595,2110200,2330000,0,1,1,0,100),(596,2110200,2043214,0,1,1,0,100),(597,2110300,2000001,0,1,1,0,20000),(598,2110300,2000003,0,1,1,0,20000),(599,2110300,2060000,0,1,1,0,30000),(600,2110300,2061000,0,1,1,0,30000),(601,2110300,2002004,0,1,1,0,20000),(604,2110300,2044501,0,1,1,0,100),(605,2110300,1402002,0,1,1,0,800),(606,2110300,1032004,0,1,1,0,800),(607,2110300,1050001,0,1,1,0,800),(608,2110300,1002055,0,1,1,0,800),(609,2110300,1040049,0,1,1,0,800),(610,2110300,1060037,0,1,1,0,800),(611,2110300,1082068,0,1,1,0,800),(612,2110300,1432001,0,1,1,0,800),(614,2110300,4000350,0,1,1,0,600000),(615,2110300,1002619,0,1,1,0,800),(616,2110300,2043214,0,1,1,0,100),(617,2110301,2000001,0,1,1,0,20000),(618,2110301,2000003,0,1,1,0,20000),(619,2110301,2060000,0,1,1,0,30000),(620,2110301,2061000,0,1,1,0,30000),(621,2110301,2002005,0,1,1,0,20000),(625,2110301,2043002,0,1,1,0,100),(626,2110301,2043701,0,1,1,0,100),(627,2110301,1332009,0,1,1,0,800),(628,2110301,1412004,0,1,1,0,800),(629,2110301,1040062,0,1,1,0,800),(630,2110301,1060051,0,1,1,0,800),(631,2110301,1050029,0,1,1,0,800),(632,2110301,1002164,0,1,1,0,800),(633,2110301,1082005,0,1,1,0,800),(635,2110301,4000351,0,1,1,0,600000),(636,2110301,1492003,0,1,1,0,800),(637,2110301,2330001,0,1,1,0,100),(638,2110301,2043114,0,1,1,0,100),(639,2130100,4000018,0,1,1,0,600000),(640,2130100,2000001,0,1,1,0,20000),(641,2130100,2012002,0,1,1,0,6000),(642,2130100,2044202,0,1,1,0,100),(643,2130100,1051003,0,1,1,0,800),(644,2130100,1061006,0,1,1,0,800),(645,2130100,1041028,0,1,1,0,800),(646,2130100,1061026,0,1,1,0,800),(647,2130100,2060000,0,1,1,0,30000),(650,2130100,2000003,0,1,1,0,20000),(651,2130100,1472006,0,1,1,0,800),(652,2130100,1072085,0,1,1,0,800),(653,2130100,1002097,0,1,1,0,800),(654,2130100,1472009,0,1,1,0,800),(655,2130100,1472012,0,1,1,0,800),(656,2130100,2061000,0,1,1,0,30000),(657,2130100,1051004,0,1,1,0,800),(658,2130100,1072087,0,1,1,0,800),(659,2130100,4006001,0,1,1,0,10000),(660,2130100,2070009,0,1,1,0,500),(661,2130100,4000215,0,1,1,0,600000),(662,2130100,1002616,0,1,1,0,800),(663,2130100,2044012,0,1,1,0,100),(664,2130100,2044210,0,1,1,0,100),(665,2130103,4000034,0,1,1,0,600000),(666,2130103,2000001,0,1,1,0,20000),(667,2130103,2040902,0,1,1,0,100),(670,2130103,2010003,0,1,1,0,20000),(671,2130103,1332008,0,1,1,0,800),(672,2130103,1072069,0,1,1,0,800),(673,2130103,1002027,0,1,1,0,800),(674,2130103,1050005,0,1,1,0,800),(675,2130103,1061028,0,1,1,0,800),(676,2130103,1041031,0,1,1,0,800),(677,2130103,1041021,0,1,1,0,800),(678,2130103,1061018,0,1,1,0,800),(679,2130103,2048003,0,1,1,0,100),(680,2130103,1482002,0,1,1,0,800),(681,2130103,2040617,0,1,1,0,100),(682,2130103,2049100,0,1,1,0,150),(683,2220000,4000000,0,1,1,0,600000),(684,2220000,4000000,0,1,1,0,600000),(685,2220000,4000000,0,1,1,0,600000),(686,2220000,4000016,0,1,1,0,600000),(687,2220000,4000016,0,1,1,0,600000),(688,2220000,4000016,0,1,1,0,600000),(689,2220000,4000019,0,1,1,0,600000),(690,2220000,4000019,0,1,1,0,600000),(691,2220000,4000019,0,1,1,0,600000),(694,2220000,2000000,0,1,1,0,200000),(695,2220000,2010009,0,1,1,0,200000),(696,2220000,2020014,0,1,1,0,200000),(697,2220000,2040001,0,1,1,0,1500),(698,2220000,2040301,0,1,1,0,1500),(699,2220000,2040401,0,1,1,0,1500),(700,2220000,2043201,0,1,1,0,1500),(701,2220000,2043701,0,1,1,0,1500),(702,2220000,2041016,0,1,1,0,1500),(703,2220000,2043801,0,1,1,0,1500),(704,2220000,2044001,0,1,1,0,1500),(705,2220000,2040501,0,1,1,0,1500),(706,2220000,2040601,0,1,1,0,1500),(707,2220000,2060000,0,1,1,0,300000),(708,2220000,2061000,0,1,1,0,300000),(709,2220000,2070000,0,1,1,0,5000),(710,2220000,1002049,0,1,1,0,15000),(711,2220000,1002073,0,1,1,0,15000),(712,2220000,1002159,0,1,1,0,15000),(713,2220000,1002150,0,1,1,0,15000),(714,2220000,1040041,0,1,1,0,8000),(715,2220000,1041024,0,1,1,0,8000),(716,2220000,1050025,0,1,1,0,7000),(717,2220000,1051005,0,1,1,0,7000),(718,2220000,1040023,0,1,1,0,8000),(719,2220000,1041033,0,1,1,0,8000),(720,2220000,1040050,0,1,1,0,8000),(721,2220000,1041060,0,1,1,0,8000),(722,2220000,1082001,0,1,1,0,10000),(723,2220000,1082028,0,1,1,0,10000),(724,2220000,1082018,0,1,1,0,10000),(725,2220000,1082039,0,1,1,0,10000),(726,2220000,1072052,0,1,1,0,8000),(727,2220000,1072074,0,1,1,0,8000),(728,2220000,1072069,0,1,1,0,8000),(729,2220000,1072087,0,1,1,0,8000),(730,2220000,2040002,0,1,1,0,1500),(731,2220000,2040302,0,1,1,0,1500),(732,2220000,2040402,0,1,1,0,1500),(733,2220000,2043302,0,1,1,0,1500),(734,2220000,2043702,0,1,1,0,1500),(735,2220000,2210006,0,1,1,0,999999),(736,2220000,1002619,0,1,1,0,15000),(737,2220000,1052104,0,1,1,0,7000),(738,2220000,1082186,0,1,1,0,10000),(739,2220000,1072291,0,1,1,0,8000),(740,2220000,2330000,0,1,1,0,1000),(741,2220000,2044801,0,1,1,0,1500),(742,2220000,2044902,0,1,1,0,1500),(743,2220000,2040418,0,1,1,0,1500),(744,2220000,2040928,0,1,1,0,1500),(745,2220000,2043114,0,1,1,0,1500),(746,2220000,2044414,0,1,1,0,1500),(747,2220100,4000009,0,1,1,0,600000),(748,2220100,2000001,0,1,1,0,20000),(749,2220100,2002002,0,1,1,0,20000),(750,2220100,2044002,0,1,1,0,100),(751,2220100,1332006,0,1,1,0,800),(752,2220100,1051000,0,1,1,0,800),(753,2220100,1002127,0,1,1,0,800),(754,2220100,2060000,0,1,1,0,30000),(757,2220100,2000003,0,1,1,0,20000),(758,2220100,1442001,0,1,1,0,800),(759,2220100,1041027,0,1,1,0,800),(760,2220100,1061025,0,1,1,0,800),(761,2220100,1040012,0,1,1,0,800),(762,2220100,1060010,0,1,1,0,800),(763,2220100,2061000,0,1,1,0,30000),(764,2220100,1072020,0,1,1,0,800),(765,2220100,1432001,0,1,1,0,800),(767,2220100,2000002,0,1,1,0,20000),(768,2220100,1072011,0,1,1,0,800),(769,2220100,1332001,0,1,1,0,800),(770,2220100,1382002,0,1,1,0,800),(771,2220100,1002178,0,1,1,0,800),(772,2220100,1412012,0,1,1,0,800),(773,2220100,1002613,0,1,1,0,800),(774,2220100,1002616,0,1,1,0,800),(775,2220100,1002619,0,1,1,0,800),(776,2230100,4000007,0,1,1,0,600000),(777,2230100,2000001,0,1,1,0,20000),(778,2230100,2002001,0,1,1,0,20000),(779,2230100,2044402,0,1,1,0,100),(780,2230100,1032009,0,1,1,0,800),(781,2230100,1041060,0,1,1,0,800),(782,2230100,1061056,0,1,1,0,800),(783,2230100,1002047,0,1,1,0,800),(784,2230100,1032008,0,1,1,0,800),(785,2230100,2060000,0,1,1,0,30000),(788,2230100,1302004,0,1,1,0,800),(789,2230100,1050026,0,1,1,0,800),(790,2230100,2000003,0,1,1,0,20000),(791,2230100,1051012,0,1,1,0,800),(792,2230100,2061000,0,1,1,0,30000),(793,2230100,1041032,0,1,1,0,800),(794,2230100,1062006,0,1,1,0,800),(795,2230100,1432002,0,1,1,0,800),(796,2230100,1040021,0,1,1,0,800),(798,2230100,2000002,0,1,1,0,20000),(799,2230100,1041007,0,1,1,0,800),(800,2230100,1422001,0,1,1,0,800),(801,2230100,1060071,0,1,1,0,800),(802,2230100,1482003,0,1,1,0,800),(803,2230100,2040823,0,1,1,0,100),(804,2230100,2044010,0,1,1,0,100),(805,2230101,4000008,0,1,1,0,600000),(806,2230101,2000001,0,1,1,0,20000),(807,2230101,2002000,0,1,1,0,20000),(808,2230101,2044302,0,1,1,0,100),(809,2230101,1032000,0,1,1,0,800),(810,2230101,1032004,0,1,1,0,800),(811,2230101,1452001,0,1,1,0,800),(812,2230101,1412002,0,1,1,0,800),(813,2230101,2060000,0,1,1,0,30000),(816,2230101,1002158,0,1,1,0,800),(817,2230101,2000003,0,1,1,0,20000),(818,2230101,1040048,0,1,1,0,800),(819,2230101,2061000,0,1,1,0,30000),(820,2230101,1060038,0,1,1,0,800),(821,2230101,1372003,0,1,1,0,800),(822,2230101,1060018,0,1,1,0,800),(823,2230101,1040026,0,1,1,0,800),(824,2230101,1040009,0,1,1,0,800),(826,2230101,2000002,0,1,1,0,20000),(827,2230101,1050030,0,1,1,0,800),(828,2230101,1050031,0,1,1,0,800),(829,2230101,1432003,0,1,1,0,800),(830,2230101,1002035,0,1,1,0,800),(831,2230101,1312007,0,1,1,0,800),(832,2230101,1040021,0,1,1,0,800),(833,2230101,1082183,0,1,1,0,800),(834,2230101,1492003,0,1,1,0,800),(835,2230101,2049100,0,1,1,0,150),(836,2230102,4000020,0,1,1,0,600000),(837,2230102,2000001,0,1,1,0,20000),(838,2230102,2002004,0,1,1,0,20000),(839,2230102,2060000,0,1,1,0,30000),(840,2230102,4003004,0,1,1,0,200000),(841,2230102,1032000,0,1,1,0,800),(842,2230102,1041013,0,1,1,0,800),(843,2230102,1061024,0,1,1,0,800),(844,2230102,1051005,0,1,1,0,800),(845,2230102,1032002,0,1,1,0,800),(848,2230102,1002064,0,1,1,0,800),(849,2230102,2000003,0,1,1,0,20000),(850,2230102,1072039,0,1,1,0,800),(851,2230102,1072033,0,1,1,0,800),(852,2230102,4000021,0,1,1,0,50000),(853,2230102,1432003,0,1,1,0,800),(854,2230102,1402006,0,1,1,0,800),(855,2230102,2061000,0,1,1,0,30000),(856,2230102,1382017,0,1,1,0,800),(857,2230102,1040079,0,1,1,0,800),(858,2230102,1060069,0,1,1,0,800),(859,2230102,1002151,0,1,1,0,800),(860,2230102,1060050,0,1,1,0,800),(861,2230102,1452005,0,1,1,0,800),(862,2230102,1462004,0,1,1,0,800),(863,2230102,1002166,0,1,1,0,800),(864,2230102,1412005,0,1,1,0,800),(865,2230102,1082186,0,1,1,0,800),(866,2230102,2330001,0,1,1,0,100),(867,2230103,4000097,0,1,1,0,600000),(868,2230103,4131000,0,1,1,0,6000),(869,2230103,2060000,0,1,1,0,30000),(870,2230103,2061000,0,1,1,0,30000),(871,2230103,2002006,0,1,1,0,20000),(874,2230103,2000001,0,1,1,0,20000),(875,2230103,2000003,0,1,1,0,20000),(876,2230103,2040900,0,1,1,0,100),(877,2230103,1332020,0,1,1,0,800),(878,2230103,1402010,0,1,1,0,800),(879,2230103,1302003,0,1,1,0,800),(880,2230103,1312003,0,1,1,0,800),(881,2230103,1082017,0,1,1,0,800),(882,2230103,1002020,0,1,1,0,800),(883,2230103,1050023,0,1,1,0,800),(884,2230103,2070000,0,1,1,0,500),(885,2230103,1462003,0,1,1,0,800),(886,2230103,1072288,0,1,1,0,800),(887,2230103,1072291,0,1,1,0,800),(888,2230103,2044802,0,1,1,0,100),(889,2230103,2040319,0,1,1,0,100),(890,2230103,2044114,0,1,1,0,100),(891,2230104,4000098,0,1,1,0,600000),(892,2230104,4131010,0,1,1,0,6000),(893,2230104,2060000,0,1,1,0,30000),(894,2230104,2061000,0,1,1,0,30000),(895,2230104,2002007,0,1,1,0,20000),(899,2230104,2000002,0,1,1,0,20000),(900,2230104,2000003,0,1,1,0,20000),(901,2230104,2040601,0,1,1,0,100),(902,2230104,1332010,0,1,1,0,800),(903,2230104,1061034,0,1,1,0,800),(904,2230104,1041041,0,1,1,0,800),(905,2230104,1382002,0,1,1,0,800),(906,2230104,1082043,0,1,1,0,800),(907,2230104,1002162,0,1,1,0,800),(908,2230104,1050028,0,1,1,0,800),(909,2230104,2070002,0,1,1,0,500),(910,2230104,1082042,0,1,1,0,800),(911,2230104,1052104,0,1,1,0,800),(912,2230104,2040929,0,1,1,0,100),(913,2230104,2043112,0,1,1,0,100),(914,2230105,4000161,0,1,1,0,600000),(915,2230105,4131000,0,1,1,0,6000),(916,2230105,2060000,0,1,1,0,30000),(917,2230105,2061000,0,1,1,0,30000),(918,2230105,2002004,0,1,1,0,20000),(921,2230105,2000001,0,1,1,0,20000),(922,2230105,2000003,0,1,1,0,20000),(923,2230105,2040900,0,1,1,0,100),(924,2230105,1312003,0,1,1,0,800),(925,2230105,1322004,0,1,1,0,800),(926,2230105,1041042,0,1,1,0,800),(927,2230105,1061035,0,1,1,0,800),(928,2230105,1072007,0,1,1,0,800),(929,2230105,1072046,0,1,1,0,800),(930,2230105,1050011,0,1,1,0,800),(931,2230105,1082016,0,1,1,0,800),(932,2230105,2070000,0,1,1,0,500),(933,2230105,1032005,0,1,1,0,800),(934,2230105,1492002,0,1,1,0,800),(935,2230105,2040617,0,1,1,0,100),(936,2230105,2043015,0,1,1,0,100),(937,2230106,4000163,0,1,1,0,600000),(938,2230106,2000001,0,1,1,0,20000),(939,2230106,2002001,0,1,1,0,20000),(940,2230106,2060000,0,1,1,0,30000),(941,2230106,2002005,0,1,1,0,20000),(942,2230106,2040001,0,1,1,0,100),(945,2230106,1332013,0,1,1,0,800),(946,2230106,1041040,0,1,1,0,800),(947,2230106,1061033,0,1,1,0,800),(948,2230106,2000003,0,1,1,0,20000),(949,2230106,1002146,0,1,1,0,800),(950,2230106,1002158,0,1,1,0,800),(951,2230106,2040401,0,1,1,0,100),(952,2230106,1041050,0,1,1,0,800),(953,2230106,1061046,0,1,1,0,800),(954,2230106,2061000,0,1,1,0,30000),(955,2230106,1332009,0,1,1,0,800),(956,2230106,1040040,0,1,1,0,800),(957,2230106,1060060,0,1,1,0,800),(958,2230106,1052104,0,1,1,0,800),(959,2230106,2040417,0,1,1,0,100),(960,2230107,4000162,0,1,1,0,600000),(961,2230107,2000001,0,1,1,0,20000),(962,2230107,2002000,0,1,1,0,20000),(963,2230107,2044302,0,1,1,0,100),(964,2230107,1402000,0,1,1,0,800),(965,2230107,1082026,0,1,1,0,800),(966,2230107,2041004,0,1,1,0,100),(967,2230107,1041034,0,1,1,0,800),(968,2230107,1062006,0,1,1,0,800),(969,2230107,2060000,0,1,1,0,30000),(972,2230107,1072051,0,1,1,0,800),(973,2230107,2000003,0,1,1,0,20000),(974,2230107,1332004,0,1,1,0,800),(975,2230107,2061000,0,1,1,0,30000),(976,2230107,1041051,0,1,1,0,800),(977,2230107,1061047,0,1,1,0,800),(978,2230107,1061054,0,1,1,0,800),(979,2230107,1041058,0,1,1,0,800),(980,2230107,1072288,0,1,1,0,800),(981,2230107,2043110,0,1,1,0,100),(982,2230108,4000160,0,1,1,0,600000),(983,2230108,2000001,0,1,1,0,20000),(984,2230108,2002003,0,1,1,0,20000),(985,2230108,2044202,0,1,1,0,100),(986,2230108,1072065,0,1,1,0,800),(987,2230108,1041027,0,1,1,0,800),(988,2230108,1061025,0,1,1,0,800),(989,2230108,1002131,0,1,1,0,800),(990,2230108,2060000,0,1,1,0,30000),(993,2230108,2000003,0,1,1,0,20000),(994,2230108,1072054,0,1,1,0,800),(995,2230108,1002119,0,1,1,0,800),(996,2230108,2061000,0,1,1,0,30000),(997,2230108,1051005,0,1,1,0,800),(998,2230108,1050024,0,1,1,0,800),(999,2230108,4006001,0,1,1,0,10000),(1000,2230108,1032004,0,1,1,0,800),(1001,2230108,1052101,0,1,1,0,800),(1002,2230108,2040623,0,1,1,0,100),(1003,2230109,4000164,0,1,1,0,600000),(1004,2230109,4131010,0,1,1,0,6000),(1005,2230109,2060000,0,1,1,0,30000),(1006,2230109,2061000,0,1,1,0,30000),(1007,2230109,2002002,0,1,1,0,20000),(1010,2230109,1032007,0,1,1,0,800),(1012,2230109,2000002,0,1,1,0,20000),(1013,2230109,2000003,0,1,1,0,20000),(1014,2230109,2040701,0,1,1,0,100),(1015,2230109,1002034,0,1,1,0,800),(1016,2230109,1372003,0,1,1,0,800),(1017,2230109,1040041,0,1,1,0,800),(1018,2230109,1060030,0,1,1,0,800),(1019,2230109,1072054,0,1,1,0,800),(1020,2230109,1072027,0,1,1,0,800),(1021,2230109,1050021,0,1,1,0,800),(1022,2230109,2070002,0,1,1,0,500),(1023,2230109,1051007,0,1,1,0,800),(1024,2230109,1002065,0,1,1,0,800),(1025,2230109,1002619,0,1,1,0,800),(1026,2230110,2060000,0,1,1,0,30000),(1027,2230110,2061000,0,1,1,0,30000),(1028,2230110,4000196,0,1,1,0,600000),(1029,2230110,2000001,0,1,1,0,20000),(1030,2230110,2000003,0,1,1,0,20000),(1034,2230110,2002003,0,1,1,0,20000),(1035,2230110,2041016,0,1,1,0,100),(1036,2230110,1002121,0,1,1,0,800),(1037,2230110,1002058,0,1,1,0,800),(1038,2230110,2040901,0,1,1,0,100),(1039,2230110,1002131,0,1,1,0,800),(1040,2230110,1040020,0,1,1,0,800),(1041,2230110,1060014,0,1,1,0,800),(1042,2230110,1072087,0,1,1,0,800),(1043,2230110,1072053,0,1,1,0,800),(1044,2230110,1082043,0,1,1,0,800),(1045,2230110,1332010,0,1,1,0,800),(1046,2230110,1082006,0,1,1,0,800),(1047,2230110,1082026,0,1,1,0,800),(1048,2230110,1002616,0,1,1,0,800),(1049,2230110,2330000,0,1,1,0,100),(1050,2230110,2044312,0,1,1,0,100),(1051,2230110,2044805,0,1,1,0,100),(1052,2230111,2000001,0,1,1,0,20000),(1053,2230111,2000003,0,1,1,0,20000),(1054,2230111,4000197,0,1,1,0,600000),(1055,2230111,2002000,0,1,1,0,20000),(1059,2230111,2060000,0,1,1,0,30000),(1060,2230111,2061000,0,1,1,0,30000),(1061,2230111,2040301,0,1,1,0,100),(1062,2230111,2044301,0,1,1,0,100),(1063,2230111,1302002,0,1,1,0,800),(1064,2230111,1372004,0,1,1,0,800),(1065,2230111,1040042,0,1,1,0,800),(1066,2230111,1060031,0,1,1,0,800),(1067,2230111,1041023,0,1,1,0,800),(1068,2230111,1061019,0,1,1,0,800),(1069,2230111,2043801,0,1,1,0,100),(1070,2230111,1452005,0,1,1,0,800),(1071,2230111,1082049,0,1,1,0,800),(1072,2230111,1082051,0,1,1,0,800),(1073,2230111,2049000,0,1,1,0,150),(1074,2230200,4000165,0,1,1,0,600000),(1075,2230200,2044601,0,1,1,0,100),(1076,2230200,2000001,0,1,1,0,20000),(1077,2230200,2000003,0,1,1,0,20000),(1081,2230200,1040072,0,1,1,0,800),(1082,2230200,1060061,0,1,1,0,800),(1083,2230200,1422001,0,1,1,0,800),(1084,2230200,1412000,0,1,1,0,800),(1085,2230200,1072086,0,1,1,0,800),(1086,2230200,1002160,0,1,1,0,800),(1087,2230200,1040062,0,1,1,0,800),(1088,2230200,1060051,0,1,1,0,800),(1089,2230200,2061000,0,1,1,0,30000),(1090,2230200,2060000,0,1,1,0,30000),(1091,2230200,2040501,0,1,1,0,100),(1092,2230200,4006000,0,1,1,0,10000),(1093,2230200,1412006,0,1,1,0,800),(1094,2230200,1072291,0,1,1,0,800),(1095,2300100,4000042,0,1,1,0,600000),(1096,2300100,2060000,0,1,1,0,30000),(1097,2300100,2061000,0,1,1,0,30000),(1098,2300100,2000001,0,1,1,0,20000),(1099,2300100,2000003,0,1,1,0,20000),(1102,2300100,2010004,0,1,1,0,20000),(1103,2300100,4003004,0,1,1,0,200000),(1104,2300100,1040009,0,1,1,0,800),(1105,2300100,1060009,0,1,1,0,800),(1106,2300100,1040043,0,1,1,0,800),(1107,2300100,1060032,0,1,1,0,800),(1108,2300100,1041039,0,1,1,0,800),(1109,2300100,1061041,0,1,1,0,800),(1110,2300100,1082002,0,1,1,0,800),(1111,2300100,2048004,0,1,1,0,100),(1112,2300100,2041002,0,1,1,0,100),(1113,2300100,1002119,0,1,1,0,800),(1114,2300100,1452005,0,1,1,0,800),(1115,2300100,1052098,0,1,1,0,800),(1116,2300100,1052101,0,1,1,0,800),(1117,2300100,2044801,0,1,1,0,100),(1118,2300100,2040024,0,1,1,0,100),(1119,2300100,2043112,0,1,1,0,100),(1120,3000000,4000063,0,1,1,0,600000),(1121,3000000,2041016,0,1,1,0,100),(1122,3000000,2000001,0,1,1,0,20000),(1123,3000000,2000003,0,1,1,0,20000),(1127,3000000,1382018,0,1,1,0,800),(1128,3000000,1312016,0,1,1,0,800),(1129,3000000,1312005,0,1,1,0,800),(1130,3000000,1040021,0,1,1,0,800),(1131,3000000,1060017,0,1,1,0,800),(1132,3000000,1002137,0,1,1,0,800),(1133,3000000,1032006,0,1,1,0,800),(1134,3000000,1060050,0,1,1,0,800),(1135,3000000,1040061,0,1,1,0,800),(1136,3000000,2061000,0,1,1,0,30000),(1137,3000000,2060000,0,1,1,0,30000),(1138,3000000,2041005,0,1,1,0,100),(1139,3000000,4006000,0,1,1,0,10000),(1140,3000000,1082037,0,1,1,0,800),(1141,3000000,1002622,0,1,1,0,800),(1142,3000000,2040316,0,1,1,0,100),(1143,3000000,2040620,0,1,1,0,100),(1144,3000001,4000068,0,1,1,0,600000),(1145,3000001,2000001,0,1,1,0,20000),(1146,3000001,2000003,0,1,1,0,20000),(1149,3000001,2050000,0,1,1,0,50000),(1150,3000001,2050001,0,1,1,0,50000),(1151,3000001,2050002,0,1,1,0,50000),(1152,3000001,2050003,0,1,1,0,50000),(1153,3000001,2050004,0,1,1,0,50000),(1154,3000005,4000106,0,1,1,0,600000),(1155,3000005,4131003,0,1,1,0,6000),(1156,3000005,2060000,0,1,1,0,30000),(1157,3000005,2061000,0,1,1,0,30000),(1161,3000005,2000002,0,1,1,0,20000),(1162,3000005,2000003,0,1,1,0,20000),(1163,3000005,2040701,0,1,1,0,100),(1164,3000005,1462000,0,1,1,0,800),(1165,3000005,1322014,0,1,1,0,800),(1166,3000005,1050030,0,1,1,0,800),(1167,3000005,1040058,0,1,1,0,800),(1168,3000005,1060044,0,1,1,0,800),(1169,3000005,1041058,0,1,1,0,800),(1170,3000005,1061054,0,1,1,0,800),(1171,3000005,1072101,0,1,1,0,800),(1172,3000005,1002013,0,1,1,0,800),(1173,3000005,1052107,0,1,1,0,800),(1174,3000006,4000166,0,1,1,0,600000),(1175,3000006,4131003,0,1,1,0,6000),(1176,3000006,2060000,0,1,1,0,30000),(1177,3000006,2061000,0,1,1,0,30000),(1181,3000006,2000002,0,1,1,0,20000),(1182,3000006,2000003,0,1,1,0,20000),(1183,3000006,2040601,0,1,1,0,100),(1184,3000006,1082046,0,1,1,0,800),(1185,3000006,1382017,0,1,1,0,800),(1186,3000006,1082005,0,1,1,0,800),(1187,3000006,1050002,0,1,1,0,800),(1188,3000006,1072086,0,1,1,0,800),(1189,3000006,1072103,0,1,1,0,800),(1190,3000006,1462000,0,1,1,0,800),(1191,3000006,1040040,0,1,1,0,800),(1192,3000006,1060060,0,1,1,0,800),(1193,3000006,1041052,0,1,1,0,800),(1194,3000006,1061048,0,1,1,0,800),(1195,3000006,1082189,0,1,1,0,800),(1196,3000006,2040422,0,1,1,0,100),(1197,3000006,2040530,0,1,1,0,100),(1198,3100101,2000003,0,1,1,0,20000),(1199,3100101,2060000,0,1,1,0,30000),(1200,3100101,2061000,0,1,1,0,30000),(1201,3100101,2000002,0,1,1,0,20000),(1202,3100101,4000334,0,1,1,0,600000),(1205,3100101,4006000,0,1,1,0,10000),(1206,3100101,2044701,0,1,1,0,100),(1207,3100101,1332020,0,1,1,0,800),(1208,3100101,1040000,0,1,1,0,800),(1209,3100101,1060075,0,1,1,0,800),(1210,3100101,1402010,0,1,1,0,800),(1211,3100101,1032007,0,1,1,0,800),(1212,3100101,1072078,0,1,1,0,800),(1213,3100101,1082046,0,1,1,0,800),(1214,3100101,1002156,0,1,1,0,800),(1216,3100101,1002622,0,1,1,0,800),(1217,3100101,4130005,0,1,1,0,6000),(1218,3100101,4130009,0,1,1,0,6000),(1219,3100102,2000003,0,1,1,0,20000),(1220,3100102,2060000,0,1,1,0,30000),(1221,3100102,2061000,0,1,1,0,30000),(1222,3100102,2000002,0,1,1,0,20000),(1223,3100102,4000335,0,1,1,0,600000),(1225,3100102,4006000,0,1,1,0,10000),(1226,3100102,2040401,0,1,1,0,100),(1227,3100102,2041018,0,1,1,0,100),(1228,3100102,1462004,0,1,1,0,800),(1229,3100102,1472011,0,1,1,0,800),(1230,3100102,1002181,0,1,1,0,800),(1231,3100102,1050022,0,1,1,0,800),(1232,3100102,1061048,0,1,1,0,800),(1233,3100102,1041052,0,1,1,0,800),(1234,3100102,1082069,0,1,1,0,800),(1235,3100102,4003004,0,1,1,0,200000),(1237,3100102,1072294,0,1,1,0,800),(1238,3110100,2000002,0,1,1,0,20000),(1239,3110100,2000003,0,1,1,0,20000),(1242,3110100,1322009,0,1,1,0,800),(1243,3110100,1332014,0,1,1,0,800),(1244,3110100,4000032,0,1,1,0,600000),(1245,3110100,2041002,0,1,1,0,100),(1246,3110100,4006000,0,1,1,0,10000),(1247,3110100,1051013,0,1,1,0,800),(1248,3110100,1082049,0,1,1,0,800),(1249,3110100,1422001,0,1,1,0,800),(1250,3110100,1041051,0,1,1,0,800),(1251,3110100,1061047,0,1,1,0,800),(1252,3110100,1082046,0,1,1,0,800),(1253,3110100,1072112,0,1,1,0,800),(1254,3110100,1092012,0,1,1,0,800),(1255,3110100,1432005,0,1,1,0,800),(1256,3110100,1002622,0,1,1,0,800),(1257,3110100,2044802,0,1,1,0,100),(1258,3110100,4130002,0,1,1,0,6000),(1259,3110100,4130008,0,1,1,0,6000),(1260,3110100,4130010,0,1,1,0,6000),(1261,3110101,4000107,0,1,1,0,600000),(1262,3110101,4131001,0,1,1,0,6000),(1263,3110101,2002009,0,1,1,0,20000),(1264,3110101,2060000,0,1,1,0,30000),(1265,3110101,2061000,0,1,1,0,30000),(1268,3110101,2000002,0,1,1,0,20000),(1269,3110101,2000003,0,1,1,0,20000),(1270,3110101,2041017,0,1,1,0,100),(1271,3110101,1092007,0,1,1,0,800),(1272,3110101,1041055,0,1,1,0,800),(1273,3110101,1061051,0,1,1,0,800),(1274,3110101,1082007,0,1,1,0,800),(1275,3110101,1072077,0,1,1,0,800),(1276,3110101,1462004,0,1,1,0,800),(1277,3110101,1050002,0,1,1,0,800),(1278,3110101,1040062,0,1,1,0,800),(1279,3110101,1060051,0,1,1,0,800),(1280,3110101,1082035,0,1,1,0,800),(1281,3110101,1072090,0,1,1,0,800),(1282,3110101,1472014,0,1,1,0,800),(1283,3110101,1082189,0,1,1,0,800),(1284,3110101,2330001,0,1,1,0,100),(1285,3110101,2044012,0,1,1,0,100),(1286,3110101,4130002,0,1,1,0,6000),(1287,3110102,4000095,0,1,1,0,600000),(1288,3110102,4000021,0,1,1,0,50000),(1289,3110102,4131002,0,1,1,0,6000),(1290,3110102,2060000,0,1,1,0,30000),(1291,3110102,2061000,0,1,1,0,30000),(1296,3110102,2000002,0,1,1,0,20000),(1297,3110102,2000003,0,1,1,0,20000),(1298,3110102,2044401,0,1,1,0,100),(1299,3110102,1002173,0,1,1,0,800),(1300,3110102,1002164,0,1,1,0,800),(1301,3110102,1082051,0,1,1,0,800),(1302,3110102,1072035,0,1,1,0,800),(1303,3110102,1332009,0,1,1,0,800),(1304,3110102,1040029,0,1,1,0,800),(1305,3110102,1060020,0,1,1,0,800),(1306,3110102,1082068,0,1,1,0,800),(1307,3110102,1312006,0,1,1,0,800),(1308,3110102,1322016,0,1,1,0,800),(1309,3110102,1072294,0,1,1,0,800),(1310,3110102,2044210,0,1,1,0,100),(1311,3110102,4130003,0,1,1,0,6000),(1312,3110102,4130004,0,1,1,0,6000),(1313,3110102,4130011,0,1,1,0,6000),(1314,3110300,2000003,0,1,1,0,20000),(1315,3110300,2060000,0,1,1,0,30000),(1316,3110300,2061000,0,1,1,0,30000),(1317,3110300,2000002,0,1,1,0,20000),(1320,3110300,4006000,0,1,1,0,10000),(1321,3110300,2044701,0,1,1,0,100),(1322,3110300,1332020,0,1,1,0,800),(1323,3110300,1040000,0,1,1,0,800),(1324,3110300,1060075,0,1,1,0,800),(1325,3110300,1402010,0,1,1,0,800),(1326,3110300,1032007,0,1,1,0,800),(1327,3110300,1072078,0,1,1,0,800),(1328,3110300,1082046,0,1,1,0,800),(1329,3110300,1002156,0,1,1,0,800),(1331,3110300,4000353,0,1,1,0,600000),(1332,3110300,1072294,0,1,1,0,800),(1333,3110300,2040530,0,1,1,0,100),(1334,3110300,2044410,0,1,1,0,100),(1335,3110300,2049100,0,1,1,0,150),(1336,3110300,4130002,0,1,1,0,6000),(1337,3110300,4130009,0,1,1,0,6000),(1338,3110300,4130013,0,1,1,0,6000),(1339,3110301,2000003,0,1,1,0,20000),(1340,3110301,2060000,0,1,1,0,30000),(1341,3110301,2061000,0,1,1,0,30000),(1342,3110301,2000002,0,1,1,0,20000),(1345,3110301,4006000,0,1,1,0,10000),(1346,3110301,2044701,0,1,1,0,100),(1347,3110301,1332020,0,1,1,0,800),(1348,3110301,1040000,0,1,1,0,800),(1349,3110301,1060075,0,1,1,0,800),(1350,3110301,1402010,0,1,1,0,800),(1351,3110301,1032007,0,1,1,0,800),(1352,3110301,1072078,0,1,1,0,800),(1353,3110301,1082046,0,1,1,0,800),(1354,3110301,1002156,0,1,1,0,800),(1356,3110301,4000352,0,1,1,0,600000),(1357,3110301,1082189,0,1,1,0,800),(1358,3110301,2040420,0,1,1,0,100),(1359,3110301,4130001,0,1,1,0,6000),(1360,3110301,4130006,0,1,1,0,6000),(1361,3110302,2000002,0,1,1,0,20000),(1362,3110302,2002005,0,1,1,0,20000),(1363,3110302,2044502,0,1,1,0,100),(1364,3110302,2000003,0,1,1,0,20000),(1365,3110302,1322003,0,1,1,0,800),(1366,3110302,2060000,0,1,1,0,30000),(1369,3110302,2061000,0,1,1,0,30000),(1370,3110302,1040021,0,1,1,0,800),(1371,3110302,1060016,0,1,1,0,800),(1372,3110302,1002180,0,1,1,0,800),(1373,3110302,1002143,0,1,1,0,800),(1374,3110302,1060052,0,1,1,0,800),(1375,3110302,1040063,0,1,1,0,800),(1376,3110302,1432003,0,1,1,0,800),(1377,3110302,1051025,0,1,1,0,800),(1378,3110302,1002025,0,1,1,0,800),(1379,3110302,1040079,0,1,1,0,800),(1380,3110302,1060069,0,1,1,0,800),(1381,3110302,4000356,0,1,1,0,600000),(1382,3110302,1072297,0,1,1,0,800),(1383,3110302,2040324,0,1,1,0,100),(1384,3110302,2044210,0,1,1,0,100),(1385,3110302,4130010,0,1,1,0,6000),(1386,3110302,4130015,0,1,1,0,6000),(1387,3110303,2060000,0,1,1,0,30000),(1388,3110303,2061000,0,1,1,0,30000),(1392,3110303,2000002,0,1,1,0,20000),(1393,3110303,2000003,0,1,1,0,20000),(1394,3110303,2040302,0,1,1,0,100),(1395,3110303,1382018,0,1,1,0,800),(1396,3110303,1472012,0,1,1,0,800),(1397,3110303,1432003,0,1,1,0,800),(1398,3110303,1462005,0,1,1,0,800),(1399,3110303,1002183,0,1,1,0,800),(1400,3110303,1002167,0,1,1,0,800),(1401,3110303,1040086,0,1,1,0,800),(1402,3110303,1060075,0,1,1,0,800),(1403,3110303,1041076,0,1,1,0,800),(1404,3110303,1061071,0,1,1,0,800),(1405,3110303,1072000,0,1,1,0,800),(1406,3110303,1032018,0,1,1,0,800),(1407,3110303,1082082,0,1,1,0,800),(1408,3110303,1082085,0,1,1,0,800),(1409,3110303,1072129,0,1,1,0,800),(1410,3110303,1082010,0,1,1,0,800),(1411,3110303,4000356,0,1,1,0,600000),(1412,3110303,1072297,0,1,1,0,800),(1413,3110303,2330001,0,1,1,0,100),(1414,3110303,2040417,0,1,1,0,100),(1415,3110303,2044112,0,1,1,0,100),(1416,3110303,2044310,0,1,1,0,100),(1417,3110303,2044809,0,1,1,0,100),(1418,3110303,4130001,0,1,1,0,6000),(1419,3110303,4130002,0,1,1,0,6000),(1420,3110303,4130016,0,1,1,0,6000),(1421,3210100,4000021,0,1,1,0,50000),(1422,3210100,2070001,0,1,1,0,180),(1423,3210100,2000002,0,1,1,0,20000),(1424,3210100,2000003,0,1,1,0,20000),(1425,3210100,4000024,0,1,1,0,600000),(1428,3210100,1332020,0,1,1,0,800),(1430,3210100,1452005,0,1,1,0,800),(1431,3210100,1040026,0,1,1,0,800),(1432,3210100,1060019,0,1,1,0,800),(1433,3210100,1082044,0,1,1,0,800),(1434,3210100,1072079,0,1,1,0,800),(1435,3210100,1082052,0,1,1,0,800),(1436,3210100,1472012,0,1,1,0,800),(1437,3210100,1072091,0,1,1,0,800),(1438,3210100,1002178,0,1,1,0,800),(1439,3210100,1072103,0,1,1,0,800),(1440,3210100,1462005,0,1,1,0,800),(1441,3210100,1372012,0,1,1,0,800),(1442,3210100,1002141,0,1,1,0,800),(1444,3210100,1372003,0,1,1,0,800),(1445,3210100,2000001,0,1,1,0,20000),(1446,3210100,1052107,0,1,1,0,800),(1447,3210100,4130011,0,1,1,0,6000),(1448,3210100,4130016,0,1,1,0,6000),(1449,3210100,4130017,0,1,1,0,6000),(1450,3210200,4000073,0,1,1,0,600000),(1451,3210200,4000021,0,1,1,0,50000),(1452,3210200,2000002,0,1,1,0,20000),(1453,3210200,2000003,0,1,1,0,20000),(1454,3210200,4003004,0,1,1,0,200000),(1458,3210200,2070001,0,1,1,0,160),(1459,3210200,2044701,0,1,1,0,100),(1460,3210200,1322009,0,1,1,0,800),(1461,3210200,2050003,0,1,1,0,50000),(1462,3210200,1002174,0,1,1,0,800),(1463,3210200,1002038,0,1,1,0,800),(1464,3210200,1082042,0,1,1,0,800),(1465,3210200,1072041,0,1,1,0,800),(1466,3210200,1412006,0,1,1,0,800),(1467,3210200,1032008,0,1,1,0,800),(1468,3210200,1072002,0,1,1,0,800),(1469,3210200,1332014,0,1,1,0,800),(1470,3210200,1040073,0,1,1,0,800),(1471,3210200,1060062,0,1,1,0,800),(1472,3210200,1050035,0,1,1,0,800),(1473,3210200,1462005,0,1,1,0,800),(1474,3210200,1002145,0,1,1,0,800),(1475,3210200,1052107,0,1,1,0,800),(1476,3210200,4130007,0,1,1,0,6000),(1477,3210200,4130016,0,1,1,0,6000),(1478,3210201,4000073,0,1,1,0,600000),(1479,3210201,4000021,0,1,1,0,50000),(1480,3210201,2000002,0,1,1,0,20000),(1481,3210201,2000003,0,1,1,0,20000),(1482,3210201,4003004,0,1,1,0,200000),(1486,3210201,2044501,0,1,1,0,100),(1487,3210201,4006001,0,1,1,0,10000),(1489,3210201,1442001,0,1,1,0,800),(1490,3210201,1332012,0,1,1,0,800),(1491,3210201,1072083,0,1,1,0,800),(1492,3210201,1002172,0,1,1,0,800),(1493,3210201,1472013,0,1,1,0,800),(1494,3210201,1072089,0,1,1,0,800),(1495,3210201,1082070,0,1,1,0,800),(1496,3210201,1051016,0,1,1,0,800),(1497,3210201,1050036,0,1,1,0,800),(1498,3210201,1051024,0,1,1,0,800),(1499,3210201,1492004,0,1,1,0,800),(1500,3210201,2043114,0,1,1,0,100),(1501,3210201,4130003,0,1,1,0,6000),(1502,3210201,4130004,0,1,1,0,6000),(1503,3210201,4130012,0,1,1,0,6000),(1504,3210202,4000073,0,1,1,0,600000),(1505,3210202,4000021,0,1,1,0,50000),(1506,3210202,2000002,0,1,1,0,20000),(1507,3210202,2000003,0,1,1,0,20000),(1508,3210202,4003004,0,1,1,0,200000),(1512,3210202,4006000,0,1,1,0,10000),(1513,3210202,2043701,0,1,1,0,100),(1514,3210202,2070003,0,1,1,0,400),(1515,3210202,1302017,0,1,1,0,800),(1516,3210202,1002037,0,1,1,0,800),(1517,3210202,1002163,0,1,1,0,800),(1518,3210202,1040028,0,1,1,0,800),(1519,3210202,1332001,0,1,1,0,800),(1520,3210202,1041053,0,1,1,0,800),(1521,3210202,1061049,0,1,1,0,800),(1522,3210202,1060020,0,1,1,0,800),(1523,3210202,1041066,0,1,1,0,800),(1524,3210202,1061061,0,1,1,0,800),(1525,3210202,1082045,0,1,1,0,800),(1526,3210202,1322015,0,1,1,0,800),(1527,3210202,1032011,0,1,1,0,800),(1528,3210202,1492004,0,1,1,0,800),(1529,3210202,1002628,0,1,1,0,800),(1530,3210202,2043110,0,1,1,0,100),(1531,3210202,2044807,0,1,1,0,100),(1532,3210202,4130006,0,1,1,0,6000),(1533,3210202,4130012,0,1,1,0,6000),(1534,3210203,4000108,0,1,1,0,600000),(1535,3210203,4131009,0,1,1,0,6000),(1536,3210203,2002008,0,1,1,0,20000),(1537,3210203,2060000,0,1,1,0,30000),(1538,3210203,2061000,0,1,1,0,30000),(1541,3210203,2000002,0,1,1,0,20000),(1542,3210203,2000003,0,1,1,0,20000),(1543,3210203,2044501,0,1,1,0,100),(1544,3210203,1060018,0,1,1,0,800),(1545,3210203,1040021,0,1,1,0,800),(1546,3210203,1072080,0,1,1,0,800),(1547,3210203,1051006,0,1,1,0,800),(1548,3210203,1050039,0,1,1,0,800),(1549,3210203,1002153,0,1,1,0,800),(1550,3210203,1002166,0,1,1,0,800),(1551,3210203,1082025,0,1,1,0,800),(1552,3210203,1072126,0,1,1,0,800),(1553,3210203,1072115,0,1,1,0,800),(1554,3210203,1312007,0,1,1,0,800),(1555,3210203,1332031,0,1,1,0,800),(1556,3210203,1482005,0,1,1,0,800),(1557,3210203,2040923,0,1,1,0,100),(1558,3210203,2043212,0,1,1,0,100),(1559,3210203,2049100,0,1,1,0,150),(1560,3210203,4130003,0,1,1,0,6000),(1561,3210204,4000109,0,1,1,0,600000),(1562,3210204,4003004,0,1,1,0,200000),(1563,3210204,4003005,0,1,1,0,200000),(1564,3210204,2060000,0,1,1,0,30000),(1565,3210204,2061000,0,1,1,0,30000),(1569,3210204,2000002,0,1,1,0,20000),(1570,3210204,2000003,0,1,1,0,20000),(1571,3210204,2043202,0,1,1,0,100),(1572,3210204,1040070,0,1,1,0,800),(1573,3210204,1060059,0,1,1,0,800),(1574,3210204,1040060,0,1,1,0,800),(1575,3210204,1060046,0,1,1,0,800),(1576,3210204,1082053,0,1,1,0,800),(1577,3210204,1050031,0,1,1,0,800),(1578,3210204,1002004,0,1,1,0,800),(1579,3210204,1050021,0,1,1,0,800),(1580,3210204,1072002,0,1,1,0,800),(1581,3210204,1082071,0,1,1,0,800),(1582,3210204,1332011,0,1,1,0,800),(1583,3210204,1052110,0,1,1,0,800),(1584,3210204,2040617,0,1,1,0,100),(1585,3210204,4130000,0,1,1,0,6000),(1586,3210204,4130015,0,1,1,0,6000),(1587,3210204,4130017,0,1,1,0,6000),(1588,3210205,4000096,0,1,1,0,600000),(1589,3210205,4000021,0,1,1,0,50000),(1590,3210205,2002010,0,1,1,0,20000),(1591,3210205,2060000,0,1,1,0,30000),(1592,3210205,2061000,0,1,1,0,30000),(1595,3210205,2000002,0,1,1,0,20000),(1596,3210205,2000003,0,1,1,0,20000),(1597,3210205,2040703,0,1,1,0,100),(1598,3210205,2050001,0,1,1,0,50000),(1599,3210205,1041043,0,1,1,0,800),(1600,3210205,1061036,0,1,1,0,800),(1601,3210205,1040057,0,1,1,0,800),(1602,3210205,1060043,0,1,1,0,800),(1603,3210205,1002048,0,1,1,0,800),(1604,3210205,1002136,0,1,1,0,800),(1605,3210205,1040076,0,1,1,0,800),(1606,3210205,1060065,0,1,1,0,800),(1607,3210205,1051015,0,1,1,0,800),(1608,3210205,1050037,0,1,1,0,800),(1609,3210205,1082075,0,1,1,0,800),(1610,3210205,1382019,0,1,1,0,800),(1611,3210205,1082192,0,1,1,0,800),(1612,3210205,1052113,0,1,1,0,800),(1613,3210205,4130001,0,1,1,0,6000),(1614,3210205,4130004,0,1,1,0,6000),(1615,3210205,4130014,0,1,1,0,6000),(1616,3210206,4000103,0,1,1,0,600000),(1617,3210206,4131006,0,1,1,0,6000),(1618,3210206,2060000,0,1,1,0,30000),(1619,3210206,2061000,0,1,1,0,30000),(1623,3210206,2000002,0,1,1,0,20000),(1624,3210206,2000003,0,1,1,0,20000),(1625,3210206,2043001,0,1,1,0,100),(1626,3210206,1332020,0,1,1,0,800),(1627,3210206,2070003,0,1,1,0,400),(1628,3210206,1072036,0,1,1,0,800),(1629,3210206,1072082,0,1,1,0,800),(1630,3210206,1072003,0,1,1,0,800),(1631,3210206,1002179,0,1,1,0,800),(1632,3210206,1072103,0,1,1,0,800),(1633,3210206,1051026,0,1,1,0,800),(1634,3210206,1002168,0,1,1,0,800),(1635,3210206,1040000,0,1,1,0,800),(1636,3210206,1060000,0,1,1,0,800),(1637,3210206,1040081,0,1,1,0,800),(1638,3210206,1060070,0,1,1,0,800),(1639,3210206,1051032,0,1,1,0,800),(1640,3210206,1002207,0,1,1,0,800),(1641,3210206,1072132,0,1,1,0,800),(1642,3210206,1002212,0,1,1,0,800),(1643,3210206,1492005,0,1,1,0,800),(1644,3210206,4130015,0,1,1,0,6000),(1645,3210206,4130016,0,1,1,0,6000),(1646,3210207,4000113,0,1,1,0,600000),(1647,3210207,4131011,0,1,1,0,6000),(1648,3210207,2060000,0,1,1,0,30000),(1649,3210207,2061000,0,1,1,0,30000),(1653,3210207,2000002,0,1,1,0,20000),(1654,3210207,2000003,0,1,1,0,20000),(1655,3210207,2041018,0,1,1,0,100),(1656,3210207,2043102,0,1,1,0,100),(1657,3210207,2070008,0,1,1,0,200),(1659,3210207,1082048,0,1,1,0,800),(1660,3210207,1072076,0,1,1,0,800),(1661,3210207,1372001,0,1,1,0,800),(1662,3210207,1002139,0,1,1,0,800),(1663,3210207,1002178,0,1,1,0,800),(1664,3210207,1041069,0,1,1,0,800),(1665,3210207,1061064,0,1,1,0,800),(1666,3210207,1082055,0,1,1,0,800),(1667,3210207,1050038,0,1,1,0,800),(1668,3210207,1082024,0,1,1,0,800),(1669,3210207,1072107,0,1,1,0,800),(1670,3210207,1412005,0,1,1,0,800),(1671,3210207,1072297,0,1,1,0,800),(1672,3210207,2043214,0,1,1,0,100),(1673,3210207,2049000,0,1,1,0,150),(1674,3210207,4130007,0,1,1,0,6000),(1675,3210207,4130008,0,1,1,0,6000),(1676,3210208,4000168,0,1,1,0,600000),(1677,3210208,4131009,0,1,1,0,6000),(1678,3210208,2002005,0,1,1,0,20000),(1679,3210208,2060000,0,1,1,0,30000),(1680,3210208,2061000,0,1,1,0,30000),(1683,3210208,2000002,0,1,1,0,20000),(1684,3210208,2000003,0,1,1,0,20000),(1685,3210208,2044501,0,1,1,0,100),(1686,3210208,1382018,0,1,1,0,800),(1687,3210208,1002173,0,1,1,0,800),(1688,3210208,1041052,0,1,1,0,800),(1689,3210208,1061048,0,1,1,0,800),(1690,3210208,1002048,0,1,1,0,800),(1691,3210208,1032008,0,1,1,0,800),(1692,3210208,1041065,0,1,1,0,800),(1693,3210208,1061060,0,1,1,0,800),(1694,3210208,1051008,0,1,1,0,800),(1695,3210208,1082072,0,1,1,0,800),(1696,3210208,1082076,0,1,1,0,800),(1697,3210208,1072117,0,1,1,0,800),(1698,3210208,1072127,0,1,1,0,800),(1699,3210208,1052110,0,1,1,0,800),(1700,3210208,1082195,0,1,1,0,800),(1701,3210208,4130006,0,1,1,0,6000),(1702,3210208,4130008,0,1,1,0,6000),(1703,3210450,4000153,0,1,1,0,600000),(1704,3210450,4131008,0,1,1,0,6000),(1705,3210450,2060000,0,1,1,0,30000),(1706,3210450,2061000,0,1,1,0,30000),(1709,3210450,2000002,0,1,1,0,20000),(1710,3210450,2000003,0,1,1,0,20000),(1711,3210450,2022040,0,1,1,0,20000),(1712,3210450,1041042,0,1,1,0,800),(1713,3210450,1061035,0,1,1,0,800),(1714,3210450,1002023,0,1,1,0,800),(1715,3210450,1002163,0,1,1,0,800),(1716,3210450,1032010,0,1,1,0,800),(1717,3210450,1040062,0,1,1,0,800),(1718,3210450,1060051,0,1,1,0,800),(1719,3210450,1051015,0,1,1,0,800),(1720,3210450,1302004,0,1,1,0,800),(1721,3210450,1332014,0,1,1,0,800),(1722,3210450,1072119,0,1,1,0,800),(1723,3210450,1072110,0,1,1,0,800),(1724,3210450,1082063,0,1,1,0,800),(1725,3210450,1002625,0,1,1,0,800),(1726,3210450,2330001,0,1,1,0,100),(1727,3210450,4130000,0,1,1,0,6000),(1728,3210450,4130014,0,1,1,0,6000),(1729,3210450,4130017,0,1,1,0,6000),(1730,3210800,4000026,0,1,1,0,600000),(1731,3210800,4003004,0,1,1,0,200000),(1732,3210800,2041010,0,1,1,0,100),(1733,3210800,2000003,0,1,1,0,20000),(1734,3210800,4000021,0,1,1,0,50000),(1735,3210800,2070003,0,1,1,0,400),(1738,3210800,4000029,0,1,1,0,600000),(1739,3210800,1402010,0,1,1,0,800),(1740,3210800,2070008,0,1,1,0,200),(1741,3210800,1002038,0,1,1,0,800),(1742,3210800,1002172,0,1,1,0,800),(1743,3210800,1041050,0,1,1,0,800),(1744,3210800,1061046,0,1,1,0,800),(1745,3210800,1002136,0,1,1,0,800),(1746,3210800,1040075,0,1,1,0,800),(1747,3210800,1060064,0,1,1,0,800),(1748,3210800,1051014,0,1,1,0,800),(1749,3210800,1072109,0,1,1,0,800),(1750,3210800,1072116,0,1,1,0,800),(1751,3210800,1092013,0,1,1,0,800),(1752,3210800,1472017,0,1,1,0,800),(1754,3210800,1302003,0,1,1,0,800),(1755,3210800,1041094,0,1,1,0,800),(1756,3210800,2000002,0,1,1,0,20000),(1757,3210800,1082192,0,1,1,0,800),(1758,3210800,1072300,0,1,1,0,800),(1759,3210800,2044414,0,1,1,0,100),(1760,3210800,4130001,0,1,1,0,6000),(1761,3210800,4130008,0,1,1,0,6000),(1762,3210800,4130010,0,1,1,0,6000),(1763,3220000,4000003,0,1,1,0,600000),(1764,3220000,4000003,0,1,1,0,600000),(1765,3220000,4000003,0,1,1,0,600000),(1766,3220000,4000005,0,1,1,0,600000),(1767,3220000,4000005,0,1,1,0,600000),(1768,3220000,4000005,0,1,1,0,600000),(1769,3220000,4000018,0,1,1,0,600000),(1770,3220000,4000018,0,1,1,0,600000),(1771,3220000,4000018,0,1,1,0,600000),(1772,3220000,4000195,0,1,1,0,600000),(1773,3220000,4000195,0,1,1,0,600000),(1774,3220000,4000195,0,1,1,0,600000),(1777,3220000,2000001,0,1,1,0,200000),(1778,3220000,2000003,0,1,1,0,200000),(1779,3220000,2012002,0,1,1,0,60000),(1780,3220000,2040701,0,1,1,0,1500),(1781,3220000,2040801,0,1,1,0,1500),(1782,3220000,2040901,0,1,1,0,1500),(1783,3220000,2041001,0,1,1,0,1500),(1784,3220000,2043001,0,1,1,0,1500),(1785,3220000,2043101,0,1,1,0,1500),(1786,3220000,2041010,0,1,1,0,1500),(1787,3220000,2043201,0,1,1,0,1500),(1788,3220000,2041004,0,1,1,0,1500),(1789,3220000,2060000,0,1,1,0,300000),(1790,3220000,2061000,0,1,1,0,300000),(1791,3220000,2041017,0,1,1,0,1500),(1792,3220000,2040402,0,1,1,0,1500),(1793,3220000,2044002,0,1,1,0,1500),(1794,3220000,2040502,0,1,1,0,1500),(1795,3220000,2040602,0,1,1,0,1500),(1796,3220000,2041016,0,1,1,0,1500),(1797,3220000,2070009,0,1,1,0,5000),(1798,3220000,1002098,0,1,1,0,15000),(1799,3220000,1002154,0,1,1,0,15000),(1800,3220000,1002170,0,1,1,0,15000),(1801,3220000,1002185,0,1,1,0,15000),(1802,3220000,1040085,0,1,1,0,8000),(1803,3220000,1041086,0,1,1,0,8000),(1804,3220000,1050039,0,1,1,0,7000),(1805,3220000,1051026,0,1,1,0,7000),(1806,3220000,1040080,0,1,1,0,8000),(1807,3220000,1041083,0,1,1,0,8000),(1808,3220000,1040084,0,1,1,0,8000),(1809,3220000,1041076,0,1,1,0,8000),(1810,3220000,1082025,0,1,1,0,10000),(1811,3220000,1082064,0,1,1,0,10000),(1812,3220000,1082073,0,1,1,0,10000),(1813,3220000,1082074,0,1,1,0,10000),(1814,3220000,1072126,0,1,1,0,8000),(1815,3220000,1072117,0,1,1,0,8000),(1816,3220000,1072118,0,1,1,0,8000),(1817,3220000,1072107,0,1,1,0,8000),(1818,3220000,1002628,0,1,1,0,15000),(1819,3220000,1052113,0,1,1,0,7000),(1820,3220000,1082195,0,1,1,0,10000),(1821,3220000,1072300,0,1,1,0,8000),(1822,3220000,1322027,0,1,1,0,7000),(1823,3220000,2044112,0,1,1,0,1500),(1824,3220000,2044412,0,1,1,0,1500),(1825,3220001,4000329,0,1,1,0,600000),(1826,3220001,4000329,0,1,1,0,600000),(1827,3220001,4000329,0,1,1,0,600000),(1828,3220001,4000331,0,1,1,0,600000),(1829,3220001,4000331,0,1,1,0,600000),(1830,3220001,4000331,0,1,1,0,600000),(1831,3220001,4000330,0,1,1,0,600000),(1832,3220001,4000330,0,1,1,0,600000),(1833,3220001,4000330,0,1,1,0,600000),(1837,3220001,2022155,0,1,1,0,200000),(1838,3220001,2000001,0,1,1,0,200000),(1839,3220001,2000003,0,1,1,0,200000),(1840,3220001,2040004,0,1,1,0,1500),(1841,3220001,2040501,0,1,1,0,1500),(1842,3220001,2040504,0,1,1,0,1500),(1843,3220001,2040801,0,1,1,0,1500),(1844,3220001,2041007,0,1,1,0,1500),(1845,3220001,2041004,0,1,1,0,1500),(1846,3220001,2043801,0,1,1,0,1500),(1847,3220001,2044001,0,1,1,0,1500),(1848,3220001,2044201,0,1,1,0,1500),(1849,3220001,2044601,0,1,1,0,1500),(1850,3220001,2044801,0,1,1,0,1500),(1851,3220001,1082073,0,1,1,0,10000),(1852,3220001,1082025,0,1,1,0,10000),(1853,3220001,1082064,0,1,1,0,10000),(1854,3220001,1082074,0,1,1,0,10000),(1855,3220001,1082195,0,1,1,0,10000),(1856,3220001,1032013,0,1,1,0,10000),(1857,3220001,1302063,0,1,1,0,7000),(1858,3230100,4000013,0,1,1,0,600000),(1859,3230100,2000002,0,1,1,0,20000),(1860,3230100,2002005,0,1,1,0,20000),(1861,3230100,2044502,0,1,1,0,100),(1862,3230100,2000003,0,1,1,0,20000),(1863,3230100,1322003,0,1,1,0,800),(1864,3230100,2060000,0,1,1,0,30000),(1867,3230100,2061000,0,1,1,0,30000),(1868,3230100,1040021,0,1,1,0,800),(1869,3230100,1060016,0,1,1,0,800),(1870,3230100,1002180,0,1,1,0,800),(1871,3230100,1002143,0,1,1,0,800),(1872,3230100,1060052,0,1,1,0,800),(1873,3230100,1040063,0,1,1,0,800),(1874,3230100,1432003,0,1,1,0,800),(1875,3230100,1051025,0,1,1,0,800),(1876,3230100,1002025,0,1,1,0,800),(1877,3230100,1040079,0,1,1,0,800),(1878,3230100,1060069,0,1,1,0,800),(1879,3230100,1482005,0,1,1,0,800),(1880,3230100,1492006,0,1,1,0,800),(1881,3230100,2330001,0,1,1,0,100),(1882,3230100,2044902,0,1,1,0,100),(1883,3230100,4130006,0,1,1,0,6000),(1884,3230100,4130012,0,1,1,0,6000),(1885,3230100,4130017,0,1,1,0,6000),(1886,3230101,2000002,0,1,1,0,20000),(1887,3230101,2040005,0,1,1,0,100),(1888,3230101,2070002,0,1,1,0,500),(1891,3230101,4000035,0,1,1,0,600000),(1892,3230101,2048002,0,1,1,0,100),(1893,3230101,1452000,0,1,1,0,800),(1894,3230101,1051010,0,1,1,0,800),(1895,3230101,1050022,0,1,1,0,800),(1896,3230101,1051008,0,1,1,0,800),(1897,3230101,1082069,0,1,1,0,800),(1898,3230101,1082056,0,1,1,0,800),(1899,3230101,1082047,0,1,1,0,800),(1900,3230101,1412004,0,1,1,0,800),(1901,3230101,1072114,0,1,1,0,800),(1902,3230101,1072118,0,1,1,0,800),(1903,3230101,1472016,0,1,1,0,800),(1904,3230101,1492005,0,1,1,0,800),(1905,3230101,2040027,0,1,1,0,100),(1906,3230101,4130007,0,1,1,0,6000),(1907,3230101,4130014,0,1,1,0,6000),(1908,3230102,4000043,0,1,1,0,600000),(1909,3230102,2000003,0,1,1,0,20000),(1910,3230102,2000002,0,1,1,0,20000),(1913,3230102,2043301,0,1,1,0,100),(1914,3230102,1302017,0,1,1,0,800),(1915,3230102,2048005,0,1,1,0,100),(1916,3230102,1332020,0,1,1,0,800),(1917,3230102,4006001,0,1,1,0,10000),(1918,3230102,1452005,0,1,1,0,800),(1919,3230102,1442001,0,1,1,0,800),(1920,3230102,1382017,0,1,1,0,800),(1921,3230102,1072113,0,1,1,0,800),(1922,3230102,1082056,0,1,1,0,800),(1923,3230102,1050000,0,1,1,0,800),(1924,3230102,1050038,0,1,1,0,800),(1925,3230102,1092014,0,1,1,0,800),(1926,3230102,1072121,0,1,1,0,800),(1927,3230102,1082074,0,1,1,0,800),(1928,3230102,1040080,0,1,1,0,800),(1929,3230102,1060068,0,1,1,0,800),(1930,3230102,1041074,0,1,1,0,800),(1931,3230102,1061069,0,1,1,0,800),(1932,3230102,1072297,0,1,1,0,800),(1933,3230102,1482006,0,1,1,0,800),(1934,3230102,2044802,0,1,1,0,100),(1935,3230102,2040024,0,1,1,0,100),(1936,3230102,2040423,0,1,1,0,100),(1937,3230102,4130011,0,1,1,0,6000),(1938,3230102,4130015,0,1,1,0,6000),(1939,3230103,4000100,0,1,1,0,600000),(1940,3230103,4131013,0,1,1,0,6000),(1941,3230103,2002007,0,1,1,0,20000),(1942,3230103,2060000,0,1,1,0,30000),(1943,3230103,2061000,0,1,1,0,30000),(1947,3230103,2000002,0,1,1,0,20000),(1948,3230103,2000003,0,1,1,0,20000),(1949,3230103,2040302,0,1,1,0,100),(1950,3230103,2048002,0,1,1,0,100),(1951,3230103,1082035,0,1,1,0,800),(1952,3230103,1072105,0,1,1,0,800),(1953,3230103,1472011,0,1,1,0,800),(1954,3230103,1452006,0,1,1,0,800),(1955,3230103,1442003,0,1,1,0,800),(1956,3230103,1002093,0,1,1,0,800),(1957,3230103,1002154,0,1,1,0,800),(1958,3230103,1040083,0,1,1,0,800),(1959,3230103,1060072,0,1,1,0,800),(1960,3230103,1032011,0,1,1,0,800),(1961,3230103,1041082,0,1,1,0,800),(1962,3230103,1061081,0,1,1,0,800),(1963,3230103,1050045,0,1,1,0,800),(1964,3230103,1002625,0,1,1,0,800),(1965,3230103,2044112,0,1,1,0,100),(1966,3230103,4130001,0,1,1,0,6000),(1967,3230103,4130011,0,1,1,0,6000),(1968,3230104,2000002,0,1,1,0,20000),(1969,3230104,2040801,0,1,1,0,100),(1970,3230104,2070002,0,1,1,0,500),(1973,3230104,1382018,0,1,1,0,800),(1974,3230104,4000167,0,1,1,0,600000),(1975,3230104,2040701,0,1,1,0,100),(1976,3230104,1332020,0,1,1,0,800),(1977,3230104,1002023,0,1,1,0,800),(1978,3230104,1041050,0,1,1,0,800),(1979,3230104,1061046,0,1,1,0,800),(1980,3230104,1041056,0,1,1,0,800),(1981,3230104,1061052,0,1,1,0,800),(1982,3230104,1061048,0,1,1,0,800),(1983,3230104,1041052,0,1,1,0,800),(1984,3230104,1002135,0,1,1,0,800),(1985,3230104,1051014,0,1,1,0,800),(1986,3230104,1402006,0,1,1,0,800),(1987,3230104,1082023,0,1,1,0,800),(1988,3230104,1072114,0,1,1,0,800),(1989,3230104,1002184,0,1,1,0,800),(1990,3230104,1082073,0,1,1,0,800),(1991,3230104,1482004,0,1,1,0,800),(1992,3230104,2044212,0,1,1,0,100),(1993,3230104,4130000,0,1,1,0,6000),(1994,3230104,4130003,0,1,1,0,6000),(1995,3230104,4130005,0,1,1,0,6000),(1996,3230200,4000059,0,1,1,0,600000),(1997,3230200,4003004,0,1,1,0,200000),(1998,3230200,2041012,0,1,1,0,100),(1999,3230200,2000002,0,1,1,0,20000),(2000,3230200,2000003,0,1,1,0,20000),(2001,3230200,1092008,0,1,1,0,800),(2002,3230200,2040902,0,1,1,0,100),(2003,3230200,2041005,0,1,1,0,100),(2004,3230200,1302017,0,1,1,0,800),(2005,3230200,2060000,0,1,1,0,30000),(2006,3230200,2061000,0,1,1,0,30000),(2009,3230200,1432008,0,1,1,0,800),(2010,3230200,4006000,0,1,1,0,10000),(2012,3230200,1082050,0,1,1,0,800),(2013,3230200,1082005,0,1,1,0,800),(2014,3230200,1072106,0,1,1,0,800),(2015,3230200,1092007,0,1,1,0,800),(2016,3230200,1072102,0,1,1,0,800),(2017,3230200,1002176,0,1,1,0,800),(2018,3230200,1041065,0,1,1,0,800),(2019,3230200,1061060,0,1,1,0,800),(2020,3230200,1051027,0,1,1,0,800),(2021,3230200,1302009,0,1,1,0,800),(2022,3230200,1452007,0,1,1,0,800),(2023,3230200,1002152,0,1,1,0,800),(2024,3230200,1002625,0,1,1,0,800),(2025,3230200,2044807,0,1,1,0,100),(2026,3230200,4130009,0,1,1,0,6000),(2027,3230200,4130014,0,1,1,0,6000),(2028,3230300,4000067,0,1,1,0,400000),(2029,3230300,2000002,0,1,1,0,20000),(2030,3230300,2000003,0,1,1,0,20000),(2037,3230302,4000099,0,1,1,0,600000),(2038,3230302,4131008,0,1,1,0,6000),(2039,3230302,2060000,0,1,1,0,30000),(2040,3230302,2061000,0,1,1,0,30000),(2044,3230302,2000002,0,1,1,0,20000),(2045,3230302,2000003,0,1,1,0,20000),(2046,3230302,2041023,0,1,1,0,100),(2047,3230302,1072040,0,1,1,0,800),(2048,3230302,1072078,0,1,1,0,800),(2049,3230302,1472010,0,1,1,0,800),(2050,3230302,1002141,0,1,1,0,800),(2051,3230302,1040075,0,1,1,0,800),(2052,3230302,1060064,0,1,1,0,800),(2053,3230302,1051009,0,1,1,0,800),(2054,3230302,1442009,0,1,1,0,800),(2055,3230302,1040082,0,1,1,0,800),(2056,3230302,1060071,0,1,1,0,800),(2057,3230302,1462006,0,1,1,0,800),(2058,3230302,1052110,0,1,1,0,800),(2059,3230302,4130005,0,1,1,0,6000),(2060,3230302,4130012,0,1,1,0,6000),(2061,3230302,4130013,0,1,1,0,6000),(2062,3230303,4000104,0,1,1,0,600000),(2063,3230303,1092021,0,1,1,0,800),(2064,3230303,4131007,0,1,1,0,6000),(2065,3230303,2060000,0,1,1,0,30000),(2066,3230303,2061000,0,1,1,0,30000),(2070,3230303,2000002,0,1,1,0,20000),(2071,3230303,2000003,0,1,1,0,20000),(2072,3230303,2043301,0,1,1,0,100),(2073,3230303,1372003,0,1,1,0,800),(2074,3230303,1312005,0,1,1,0,800),(2075,3230303,1322003,0,1,1,0,800),(2076,3230303,1402010,0,1,1,0,800),(2077,3230303,1072104,0,1,1,0,800),(2078,3230303,1072091,0,1,1,0,800),(2079,3230303,1082046,0,1,1,0,800),(2080,3230303,1041084,0,1,1,0,800),(2081,3230303,1061083,0,1,1,0,800),(2082,3230303,1041081,0,1,1,0,800),(2083,3230303,1061080,0,1,1,0,800),(2084,3230303,1002181,0,1,1,0,800),(2085,3230303,1002092,0,1,1,0,800),(2086,3230303,1082080,0,1,1,0,800),(2087,3230303,1472018,0,1,1,0,800),(2088,3230303,1462007,0,1,1,0,800),(2089,3230303,1402003,0,1,1,0,800),(2090,3230303,1002145,0,1,1,0,800),(2091,3230303,1482005,0,1,1,0,800),(2092,3230303,2044312,0,1,1,0,100),(2093,3230303,4130009,0,1,1,0,6000),(2094,3230303,4130010,0,1,1,0,6000),(2095,3230303,4130012,0,1,1,0,6000),(2096,3230304,4000105,0,1,1,0,600000),(2097,3230304,4131005,0,1,1,0,6000),(2098,3230304,2060000,0,1,1,0,30000),(2099,3230304,2061000,0,1,1,0,30000),(2103,3230304,2000002,0,1,1,0,20000),(2104,3230304,2000003,0,1,1,0,20000),(2105,3230304,2040302,0,1,1,0,100),(2106,3230304,1382018,0,1,1,0,800),(2107,3230304,1472012,0,1,1,0,800),(2108,3230304,1432003,0,1,1,0,800),(2109,3230304,1462005,0,1,1,0,800),(2110,3230304,1002183,0,1,1,0,800),(2111,3230304,1002167,0,1,1,0,800),(2112,3230304,1040086,0,1,1,0,800),(2113,3230304,1060075,0,1,1,0,800),(2114,3230304,1041076,0,1,1,0,800),(2115,3230304,1061071,0,1,1,0,800),(2116,3230304,1072000,0,1,1,0,800),(2117,3230304,1032018,0,1,1,0,800),(2118,3230304,1082082,0,1,1,0,800),(2119,3230304,1082085,0,1,1,0,800),(2120,3230304,1072129,0,1,1,0,800),(2121,3230304,1082010,0,1,1,0,800),(2122,3230304,1052110,0,1,1,0,800),(2123,3230304,2040316,0,1,1,0,100),(2124,3230304,2049000,0,1,1,0,150),(2125,3230304,4130002,0,1,1,0,6000),(2126,3230304,4130017,0,1,1,0,6000),(2127,3230305,4000110,0,1,1,0,600000),(2128,3230305,4000003,0,1,1,0,600000),(2129,3230305,4000018,0,1,1,0,600000),(2130,3230305,2060000,0,1,1,0,30000),(2131,3230305,2061000,0,1,1,0,30000),(2134,3230305,2000002,0,1,1,0,20000),(2135,3230305,2000003,0,1,1,0,20000),(2136,3230305,2041001,0,1,1,0,100),(2137,3230305,1032002,0,1,1,0,800),(2138,3230305,1041066,0,1,1,0,800),(2139,3230305,1061061,0,1,1,0,800),(2140,3230305,1040029,0,1,1,0,800),(2141,3230305,1060020,0,1,1,0,800),(2142,3230305,1002184,0,1,1,0,800),(2143,3230305,1002099,0,1,1,0,800),(2144,3230305,1082064,0,1,1,0,800),(2145,3230305,1082075,0,1,1,0,800),(2146,3230305,1072119,0,1,1,0,800),(2147,3230305,1442009,0,1,1,0,800),(2148,3230305,1051033,0,1,1,0,800),(2149,3230305,1492005,0,1,1,0,800),(2150,3230305,2330001,0,1,1,0,100),(2151,3230305,2040926,0,1,1,0,100),(2152,3230305,4130003,0,1,1,0,6000),(2153,3230305,4130004,0,1,1,0,6000),(2154,3230305,4130014,0,1,1,0,6000),(2155,3230306,4000115,0,1,1,0,600000),(2156,3230306,1092021,0,1,1,0,800),(2157,3230306,2002006,0,1,1,0,20000),(2158,3230306,2060000,0,1,1,0,30000),(2159,3230306,2061000,0,1,1,0,30000),(2163,3230306,2000002,0,1,1,0,20000),(2164,3230306,2000003,0,1,1,0,20000),(2165,3230306,2043702,0,1,1,0,100),(2166,3230306,2044201,0,1,1,0,100),(2167,3230306,4006000,0,1,1,0,10000),(2168,3230306,1072032,0,1,1,0,800),(2169,3230306,1072041,0,1,1,0,800),(2170,3230306,1051006,0,1,1,0,800),(2171,3230306,1082069,0,1,1,0,800),(2172,3230306,1072089,0,1,1,0,800),(2173,3230306,1041069,0,1,1,0,800),(2174,3230306,1061064,0,1,1,0,800),(2175,3230306,1002182,0,1,1,0,800),(2176,3230306,1002155,0,1,1,0,800),(2177,3230306,1040085,0,1,1,0,800),(2178,3230306,1060074,0,1,1,0,800),(2179,3230306,1492005,0,1,1,0,800),(2180,3230306,2044901,0,1,1,0,100),(2181,3230306,4130000,0,1,1,0,6000),(2182,3230306,4130010,0,1,1,0,6000),(2183,3230307,4000123,0,1,1,0,600000),(2184,3230307,2060000,0,1,1,0,30000),(2185,3230307,2061000,0,1,1,0,30000),(2189,3230307,2000002,0,1,1,0,20000),(2190,3230307,2000003,0,1,1,0,20000),(2191,3230307,4003004,0,1,1,0,200000),(2192,3230307,4000003,0,1,1,0,600000),(2193,3230307,1051004,0,1,1,0,800),(2194,3230307,1332004,0,1,1,0,800),(2195,3230307,1040069,0,1,1,0,800),(2196,3230307,1060058,0,1,1,0,800),(2197,3230307,1002036,0,1,1,0,800),(2198,3230307,1312005,0,1,1,0,800),(2199,3230307,1082008,0,1,1,0,800),(2200,3230307,1072104,0,1,1,0,800),(2201,3230307,1302004,0,1,1,0,800),(2202,3230307,1002183,0,1,1,0,800),(2203,3230307,1002152,0,1,1,0,800),(2204,3230307,1072120,0,1,1,0,800),(2205,3230307,1082023,0,1,1,0,800),(2206,3230307,1482004,0,1,1,0,800),(2207,3230307,2040929,0,1,1,0,100),(2208,3230307,2044110,0,1,1,0,100),(2209,3230307,4130010,0,1,1,0,6000),(2210,3230307,4130013,0,1,1,0,6000),(2211,3230308,4000116,0,1,1,0,600000),(2212,3230308,2002008,0,1,1,0,20000),(2213,3230308,2060000,0,1,1,0,30000),(2214,3230308,2061000,0,1,1,0,30000),(2217,3230308,2000002,0,1,1,0,20000),(2218,3230308,2000003,0,1,1,0,20000),(2220,3230308,2040902,0,1,1,0,100),(2221,3230308,1322003,0,1,1,0,800),(2222,3230308,4003005,0,1,1,0,200000),(2223,3230308,4000003,0,1,1,0,600000),(2224,3230308,1402006,0,1,1,0,800),(2225,3230308,1422008,0,1,1,0,800),(2226,3230308,1372000,0,1,1,0,800),(2227,3230308,1072107,0,1,1,0,800),(2228,3230308,1072120,0,1,1,0,800),(2229,3230308,1072115,0,1,1,0,800),(2230,3230308,1092012,0,1,1,0,800),(2231,3230308,1082073,0,1,1,0,800),(2232,3230308,1041085,0,1,1,0,800),(2233,3230308,1061084,0,1,1,0,800),(2234,3230308,1051033,0,1,1,0,800),(2235,3230308,1082065,0,1,1,0,800),(2236,3230308,1082010,0,1,1,0,800),(2237,3230308,1082083,0,1,1,0,800),(2238,3230308,1482005,0,1,1,0,800),(2239,3230308,2043210,0,1,1,0,100),(2240,3230308,4130004,0,1,1,0,6000),(2241,3230308,4130006,0,1,1,0,6000),(2242,3230308,4130015,0,1,1,0,6000),(2243,3230400,4000127,0,1,1,0,600000),(2244,3230400,2000002,0,1,1,0,20000),(2245,3230400,2000003,0,1,1,0,20000),(2246,3230400,2060000,0,1,1,0,30000),(2247,3230400,2061000,0,1,1,0,30000),(2250,3230400,4006001,0,1,1,0,10000),(2252,3230400,1092008,0,1,1,0,800),(2253,3230400,2070002,0,1,1,0,500),(2254,3230400,1302013,0,1,1,0,800),(2255,3230400,1402008,0,1,1,0,800),(2256,3230400,1041033,0,1,1,0,800),(2257,3230400,1062006,0,1,1,0,800),(2258,3230400,1041049,0,1,1,0,800),(2259,3230400,1061045,0,1,1,0,800),(2260,3230400,1050011,0,1,1,0,800),(2261,3230400,1082053,0,1,1,0,800),(2262,3230400,1040074,0,1,1,0,800),(2263,3230400,1060063,0,1,1,0,800),(2264,3230400,1002144,0,1,1,0,800),(2265,3230400,1372000,0,1,1,0,800),(2266,3230400,1492004,0,1,1,0,800),(2267,3230400,2044901,0,1,1,0,100),(2268,3230400,2044414,0,1,1,0,100),(2269,3230400,2049100,0,1,1,0,150),(2270,3230400,4130001,0,1,1,0,6000),(2271,3230400,4130008,0,1,1,0,6000),(2272,3230400,4130015,0,1,1,0,6000),(2273,3230405,4000154,0,1,1,0,600000),(2274,3230405,2002005,0,1,1,0,20000),(2275,3230405,4131005,0,1,1,0,6000),(2276,3230405,2060000,0,1,1,0,30000),(2277,3230405,2061000,0,1,1,0,30000),(2279,3230405,1372012,0,1,1,0,800),(2282,3230405,2000002,0,1,1,0,20000),(2283,3230405,2000003,0,1,1,0,20000),(2284,3230405,2040302,0,1,1,0,100),(2285,3230405,1082054,0,1,1,0,800),(2286,3230405,1060062,0,1,1,0,800),(2287,3230405,1040073,0,1,1,0,800),(2288,3230405,1002177,0,1,1,0,800),(2289,3230405,1051023,0,1,1,0,800),(2290,3230405,1302009,0,1,1,0,800),(2291,3230405,1312007,0,1,1,0,800),(2292,3230405,1332011,0,1,1,0,800),(2293,3230405,1332031,0,1,1,0,800),(2294,3230405,1072122,0,1,1,0,800),(2295,3230405,1072128,0,1,1,0,800),(2296,3230405,1082009,0,1,1,0,800),(2297,3230405,1082192,0,1,1,0,800),(2298,3230405,2044410,0,1,1,0,100),(2299,3230405,4130009,0,1,1,0,6000),(2300,3230405,4130013,0,1,1,0,6000),(2301,4110300,2000002,0,1,1,0,20000),(2302,4110300,2000003,0,1,1,0,20000),(2305,4110300,2000004,0,1,1,0,20000),(2306,4110300,2060000,0,1,1,0,30000),(2307,4110300,2061000,0,1,1,0,30000),(2309,4110300,2041019,0,1,1,0,100),(2310,4110300,1002045,0,1,1,0,800),(2311,4110300,1061062,0,1,1,0,800),(2312,4110300,1041067,0,1,1,0,800),(2313,4110300,1050037,0,1,1,0,800),(2314,4110300,1041076,0,1,1,0,800),(2315,4110300,1060073,0,1,1,0,800),(2316,4110300,1412005,0,1,1,0,800),(2317,4110300,1452007,0,1,1,0,800),(2318,4110300,1002213,0,1,1,0,800),(2319,4110300,1002085,0,1,1,0,800),(2320,4110300,1032012,0,1,1,0,800),(2321,4110300,1040096,0,1,1,0,800),(2322,4110300,1060085,0,1,1,0,800),(2323,4110300,4000357,0,1,1,0,600000),(2324,4110300,1052116,0,1,1,0,800),(2325,4110300,2330002,0,1,1,0,100),(2326,4110300,4130002,0,1,1,0,6000),(2327,4110300,4130012,0,1,1,0,6000),(2328,4110300,4130013,0,1,1,0,6000),(2329,4110301,2000002,0,1,1,0,20000),(2330,4110301,2000003,0,1,1,0,20000),(2334,4110301,2060000,0,1,1,0,30000),(2335,4110301,2061000,0,1,1,0,30000),(2336,4110301,2040504,0,1,1,0,100),(2337,4110301,2044002,0,1,1,0,100),(2338,4110301,1002085,0,1,1,0,800),(2339,4110301,1382001,0,1,1,0,800),(2340,4110301,1082010,0,1,1,0,800),(2341,4110301,1041077,0,1,1,0,800),(2342,4110301,4000358,0,1,1,0,600000),(2343,4110301,4130007,0,1,1,0,6000),(2344,4110301,4130012,0,1,1,0,6000),(2345,4110302,2000002,0,1,1,0,20000),(2346,4110302,2000003,0,1,1,0,20000),(2349,4110302,4130012,0,1,1,0,6000),(2350,4110302,2044102,0,1,1,0,100),(2351,4110302,1372007,0,1,1,0,800),(2352,4110302,1002215,0,1,1,0,800),(2353,4110302,4006001,0,1,1,0,10000),(2354,4110302,1040089,0,1,1,0,800),(2355,4110302,1050045,0,1,1,0,800),(2357,4110302,2040001,0,1,1,0,100),(2358,4110302,4000359,0,1,1,0,600000),(2359,4110302,1082198,0,1,1,0,800),(2360,4130100,4000014,0,1,1,0,600000),(2362,4130100,2000002,0,1,1,0,20000),(2363,4130100,2000004,0,1,1,0,20000),(2365,4130100,4000030,0,1,1,0,60000),(2366,4130100,2000003,0,1,1,0,20000),(2367,4130100,4006001,0,1,1,0,10000),(2368,4130100,1050022,0,1,1,0,800),(2369,4130100,1002138,0,1,1,0,800),(2370,4130100,1322016,0,1,1,0,800),(2371,4130100,1082064,0,1,1,0,800),(2372,4130100,1060069,0,1,1,0,800),(2373,4130100,1040079,0,1,1,0,800),(2374,4130100,1002045,0,1,1,0,800),(2375,4130100,1382001,0,1,1,0,800),(2376,4130100,1050046,0,1,1,0,800),(2377,4130100,1302010,0,1,1,0,800),(2378,4130100,1332016,0,1,1,0,800),(2379,4130100,1072133,0,1,1,0,800),(2380,4130100,1072125,0,1,1,0,800),(2381,4130100,1052113,0,1,1,0,800),(2382,4130100,2040025,0,1,1,0,100),(2383,4130100,2040621,0,1,1,0,100),(2384,4130100,2044014,0,1,1,0,100),(2385,4130100,2049100,0,1,1,0,150),(2386,4130100,4130006,0,1,1,0,6000),(2387,4130100,4130016,0,1,1,0,6000),(2388,4130101,4000045,0,1,1,0,600000),(2389,4130101,2041013,0,1,1,0,100),(2390,4130101,2000002,0,1,1,0,20000),(2391,4130101,2000004,0,1,1,0,20000),(2392,4130101,2000003,0,1,1,0,20000),(2395,4130101,2040805,0,1,1,0,100),(2396,4130101,1472016,0,1,1,0,800),(2397,4130101,1002152,0,1,1,0,800),(2398,4130101,1002183,0,1,1,0,800),(2399,4130101,1041081,0,1,1,0,800),(2400,4130101,1061080,0,1,1,0,800),(2401,4130101,1402003,0,1,1,0,800),(2402,4130101,1092004,0,1,1,0,800),(2403,4130101,1072124,0,1,1,0,800),(2404,4130101,1072142,0,1,1,0,800),(2405,4130101,1061088,0,1,1,0,800),(2406,4130101,1041089,0,1,1,0,800),(2407,4130101,1061078,0,1,1,0,800),(2408,4130101,1041079,0,1,1,0,800),(2409,4130101,1072303,0,1,1,0,800),(2410,4130101,2040923,0,1,1,0,100),(2411,4130101,4130003,0,1,1,0,6000),(2412,4130101,4130005,0,1,1,0,6000),(2413,4130101,4130009,0,1,1,0,6000),(2414,4130102,4000062,0,1,1,0,600000),(2415,4130102,2041014,0,1,1,0,100),(2417,4130102,2000002,0,1,1,0,20000),(2418,4130102,2000004,0,1,1,0,20000),(2419,4130102,2000003,0,1,1,0,20000),(2423,4130102,1302013,0,1,1,0,800),(2424,4130102,2044201,0,1,1,0,100),(2425,4130102,4006001,0,1,1,0,10000),(2426,4130102,1051027,0,1,1,0,800),(2427,4130102,1002092,0,1,1,0,800),(2428,4130102,1040080,0,1,1,0,800),(2429,4130102,1060068,0,1,1,0,800),(2430,4130102,1072110,0,1,1,0,800),(2431,4130102,1082063,0,1,1,0,800),(2432,4130102,1041087,0,1,1,0,800),(2433,4130102,1061086,0,1,1,0,800),(2434,4130102,1040095,0,1,1,0,800),(2435,4130102,1060084,0,1,1,0,800),(2436,4130102,1082084,0,1,1,0,800),(2437,4130102,1072132,0,1,1,0,800),(2438,4130102,4130000,0,1,1,0,6000),(2439,4130102,4130003,0,1,1,0,6000),(2440,4130102,4130013,0,1,1,0,6000),(2441,4130103,4000124,0,1,1,0,600000),(2442,4130103,2060000,0,1,1,0,300000),(2443,4130103,2061000,0,1,1,0,300000),(2444,4130103,2000002,0,1,1,0,200000),(2445,4130103,2000004,0,1,1,0,999999),(2446,4130103,4131009,0,1,1,0,60000),(2448,4130103,4005002,0,1,1,0,10000),(2449,4130103,2040902,0,1,1,0,1500),(2452,4130103,4006000,0,1,1,0,100000),(2453,4130103,1060052,0,1,1,0,8000),(2454,4130103,1040063,0,1,1,0,8000),(2455,4130103,1442009,0,1,1,0,7000),(2456,4130103,1082071,0,1,1,0,10000),(2457,4130103,1462006,0,1,1,0,5000),(2458,4130103,1051032,0,1,1,0,7000),(2459,4130103,1372007,0,1,1,0,7000),(2460,4130103,1472019,0,1,1,0,5000),(2461,4130103,1072129,0,1,1,0,8000),(2462,4130103,1432004,0,1,1,0,5000),(2463,4130103,1072140,0,1,1,0,8000),(2464,4130103,1082085,0,1,1,0,10000),(2465,4130103,1312008,0,1,1,0,7000),(2466,4130103,1492007,0,1,1,0,5000),(2467,4130103,2043210,0,1,1,0,1500),(2468,4130103,4130002,0,1,1,0,60000),(2469,4130103,4130004,0,1,1,0,60000),(2470,4130103,4130012,0,1,1,0,60000),(2471,4220000,4000166,0,1,1,0,600000),(2472,4220000,4000166,0,1,1,0,600000),(2473,4220000,4000166,0,1,1,0,600000),(2474,4220000,4000167,0,1,1,0,600000),(2475,4220000,4000167,0,1,1,0,600000),(2476,4220000,4000167,0,1,1,0,600000),(2479,4220000,2000002,0,1,1,0,200000),(2480,4220000,2000003,0,1,1,0,200000),(2481,4220000,2040301,0,1,1,0,1500),(2482,4220000,2040302,0,1,1,0,1500),(2483,4220000,2040516,0,1,1,0,1500),(2484,4220000,2040517,0,1,1,0,1500),(2485,4220000,2040704,0,1,1,0,1500),(2486,4220000,2040705,0,1,1,0,1500),(2487,4220000,2040804,0,1,1,0,1000),(2488,4220000,2040805,0,1,1,0,1000),(2489,4220000,2041007,0,1,1,0,1500),(2490,4220000,2041008,0,1,1,0,1500),(2491,4220000,1302010,0,1,1,0,7000),(2492,4220000,1312008,0,1,1,0,7000),(2493,4220000,1322017,0,1,1,0,7000),(2494,4220000,1402003,0,1,1,0,7000),(2495,4220000,1412003,0,1,1,0,7000),(2496,4220000,1422005,0,1,1,0,7000),(2497,4220000,1432004,0,1,1,0,5000),(2498,4220000,1442005,0,1,1,0,7000),(2499,4220000,1452008,0,1,1,0,5000),(2500,4220000,1462007,0,1,1,0,5000),(2501,4220000,1332003,0,1,1,0,5000),(2502,4220000,1472020,0,1,1,0,5000),(2503,4220000,1332016,0,1,1,0,5000),(2504,4220000,1482007,0,1,1,0,5000),(2505,4220000,1492007,0,1,1,0,5000),(2506,4220000,1382006,0,1,1,0,7000),(2507,4220000,1372007,0,1,1,0,7000),(2508,4220000,1442039,0,1,1,0,7000),(2509,4220000,2040029,0,1,1,0,1500),(2510,4220000,2040326,0,1,1,0,1500),(2511,4220000,2044809,0,1,1,0,1500),(2512,4220000,2049100,0,1,1,0,1500),(2513,4230100,4000023,0,1,1,0,600000),(2514,4230100,2040001,0,1,1,0,100),(2515,4230100,2000002,0,1,1,0,20000),(2517,4230100,2000003,0,1,1,0,20000),(2519,4230100,1002103,0,1,1,0,800),(2520,4230100,2070010,0,1,1,0,500),(2521,4230100,1462004,0,1,1,0,800),(2522,4230100,1472013,0,1,1,0,800),(2523,4230100,1412004,0,1,1,0,800),(2524,4230100,1072090,0,1,1,0,800),(2525,4230100,1472017,0,1,1,0,800),(2526,4230100,1002166,0,1,1,0,800),(2527,4230100,1002098,0,1,1,0,800),(2528,4230100,1002169,0,1,1,0,800),(2529,4230100,1041075,0,1,1,0,800),(2530,4230100,1061070,0,1,1,0,800),(2531,4230100,1072132,0,1,1,0,800),(2532,4230100,1072140,0,1,1,0,800),(2533,4230100,1082066,0,1,1,0,800),(2534,4230100,1032008,0,1,1,0,800),(2536,4230100,1060057,0,1,1,0,800),(2537,4230100,2000006,0,1,1,0,20000),(2538,4230100,2044412,0,1,1,0,100),(2539,4230100,2049100,0,1,1,0,150),(2540,4230100,4130004,0,1,1,0,6000),(2541,4230100,4130005,0,1,1,0,6000),(2542,4230100,4130009,0,1,1,0,6000),(2543,4230101,2000002,0,1,1,0,20000),(2544,4230101,4003004,0,1,1,0,200000),(2545,4230101,2000003,0,1,1,0,20000),(2548,4230101,1462006,0,1,1,0,800),(2549,4230101,4000031,0,1,1,0,600000),(2550,4230101,1051009,0,1,1,0,800),(2551,4230101,1051001,0,1,1,0,800),(2552,4230101,1040074,0,1,1,0,800),(2553,4230101,1060063,0,1,1,0,800),(2554,4230101,1050039,0,1,1,0,800),(2555,4230101,1002185,0,1,1,0,800),(2556,4230101,1002151,0,1,1,0,800),(2557,4230101,1041086,0,1,1,0,800),(2558,4230101,1061085,0,1,1,0,800),(2559,4230101,1472015,0,1,1,0,800),(2560,4230101,1382001,0,1,1,0,800),(2561,4230101,1462007,0,1,1,0,800),(2562,4230101,1442005,0,1,1,0,800),(2563,4230101,1332003,0,1,1,0,800),(2564,4230101,1040000,0,1,1,0,800),(2565,4230101,1082037,0,1,1,0,800),(2566,4230101,1041068,0,1,1,0,800),(2567,4230101,1002628,0,1,1,0,800),(2568,4230101,2044314,0,1,1,0,100),(2569,4230101,4130000,0,1,1,0,6000),(2570,4230101,4130005,0,1,1,0,6000),(2571,4230101,4130012,0,1,1,0,6000),(2572,4230102,4000036,0,1,1,0,600000),(2574,4230102,2000002,0,1,1,0,20000),(2575,4230102,2000004,0,1,1,0,20000),(2576,4230102,2000003,0,1,1,0,20000),(2579,4230102,1302013,0,1,1,0,800),(2580,4230102,4006001,0,1,1,0,10000),(2581,4230102,1032008,0,1,1,0,800),(2582,4230102,1060050,0,1,1,0,800),(2583,4230102,1040061,0,1,1,0,800),(2584,4230102,1040085,0,1,1,0,800),(2585,4230102,1060074,0,1,1,0,800),(2586,4230102,1002099,0,1,1,0,800),(2587,4230102,1002207,0,1,1,0,800),(2588,4230102,1002211,0,1,1,0,800),(2589,4230102,1002215,0,1,1,0,800),(2590,4230102,1002212,0,1,1,0,800),(2591,4230102,1082066,0,1,1,0,800),(2592,4230102,1072141,0,1,1,0,800),(2593,4230102,1072303,0,1,1,0,800),(2594,4230102,2330002,0,1,1,0,100),(2595,4230102,2040026,0,1,1,0,100),(2596,4230102,4130007,0,1,1,0,6000),(2597,4230102,4130008,0,1,1,0,6000),(2598,4230103,4000039,0,1,1,0,600000),(2599,4230103,2000002,0,1,1,0,20000),(2600,4230103,2000003,0,1,1,0,20000),(2603,4230103,2000004,0,1,1,0,20000),(2604,4230103,2060000,0,1,1,0,30000),(2605,4230103,2061000,0,1,1,0,30000),(2606,4230103,1332001,0,1,1,0,800),(2607,4230103,1312006,0,1,1,0,800),(2608,4230103,1002179,0,1,1,0,800),(2609,4230103,1092014,0,1,1,0,800),(2610,4230103,1072121,0,1,1,0,800),(2611,4230103,1072114,0,1,1,0,800),(2612,4230103,1082076,0,1,1,0,800),(2613,4230103,1002151,0,1,1,0,800),(2614,4230103,1051034,0,1,1,0,800),(2615,4230103,1472019,0,1,1,0,800),(2616,4230103,1322017,0,1,1,0,800),(2617,4230103,1050051,0,1,1,0,800),(2618,4230103,2040027,0,1,1,0,100),(2619,4230103,4130007,0,1,1,0,6000),(2620,4230103,4130008,0,1,1,0,6000),(2621,4230104,4000044,0,1,1,0,600000),(2622,4230104,2000004,0,1,1,0,20000),(2623,4230104,2000003,0,1,1,0,20000),(2626,4230104,1302016,0,1,1,0,800),(2627,4230104,2043201,0,1,1,0,100),(2628,4230104,1040083,0,1,1,0,800),(2629,4230104,1060072,0,1,1,0,800),(2630,4230104,1061081,0,1,1,0,800),(2631,4230104,1041082,0,1,1,0,800),(2632,4230104,1002025,0,1,1,0,800),(2633,4230104,1382001,0,1,1,0,800),(2634,4230104,1002217,0,1,1,0,800),(2635,4230104,1002085,0,1,1,0,800),(2636,4230104,1041087,0,1,1,0,800),(2637,4230104,1061086,0,1,1,0,800),(2638,4230104,1060084,0,1,1,0,800),(2639,4230104,1040095,0,1,1,0,800),(2640,4230104,1412003,0,1,1,0,800),(2641,4230104,1482007,0,1,1,0,800),(2642,4230104,2040412,0,1,1,0,100),(2643,4230104,4130005,0,1,1,0,6000),(2644,4230104,4130015,0,1,1,0,6000),(2645,4230104,4130017,0,1,1,0,6000),(2646,4230105,4000058,0,1,1,0,600000),(2647,4230105,2041011,0,1,1,0,100),(2648,4230105,2000002,0,1,1,0,20000),(2649,4230105,2000003,0,1,1,0,20000),(2653,4230105,2041001,0,1,1,0,100),(2654,4230105,1332020,0,1,1,0,800),(2655,4230105,1072103,0,1,1,0,800),(2656,4230105,1002182,0,1,1,0,800),(2657,4230105,1002098,0,1,1,0,800),(2658,4230105,1041083,0,1,1,0,800),(2659,4230105,1061082,0,1,1,0,800),(2660,4230105,1040083,0,1,1,0,800),(2661,4230105,1060072,0,1,1,0,800),(2662,4230105,1382019,0,1,1,0,800),(2663,4230105,1472015,0,1,1,0,800),(2664,4230105,1050048,0,1,1,0,800),(2665,4230105,1051038,0,1,1,0,800),(2666,4230105,1082011,0,1,1,0,800),(2667,4230105,1072130,0,1,1,0,800),(2668,4230105,2022039,0,1,1,0,20000),(2669,4230105,4130004,0,1,1,0,6000),(2670,4230105,4130013,0,1,1,0,6000),(2671,4230106,4000060,0,1,1,0,600000),(2672,4230106,4003004,0,1,1,0,200000),(2673,4230106,2000002,0,1,1,0,20000),(2674,4230106,2000003,0,1,1,0,20000),(2678,4230106,2060000,0,1,1,0,30000),(2679,4230106,2061000,0,1,1,0,30000),(2680,4230106,1302016,0,1,1,0,800),(2681,4230106,2070002,0,1,1,0,500),(2682,4230106,4006000,0,1,1,0,10000),(2683,4230106,2040705,0,1,1,0,100),(2684,4230106,1082036,0,1,1,0,800),(2685,4230106,1082045,0,1,1,0,800),(2686,4230106,1040081,0,1,1,0,800),(2687,4230106,1060070,0,1,1,0,800),(2688,4230106,1060075,0,1,1,0,800),(2689,4230106,1040086,0,1,1,0,800),(2690,4230106,1072118,0,1,1,0,800),(2691,4230106,1051032,0,1,1,0,800),(2692,4230106,1002216,0,1,1,0,800),(2693,4230106,1002210,0,1,1,0,800),(2694,4230106,1041080,0,1,1,0,800),(2695,4230106,1061079,0,1,1,0,800),(2696,4230106,1050052,0,1,1,0,800),(2697,4230106,1002628,0,1,1,0,800),(2698,4230106,2040319,0,1,1,0,100),(2699,4230106,2044114,0,1,1,0,100),(2700,4230106,2044214,0,1,1,0,100),(2701,4230106,4130003,0,1,1,0,6000),(2702,4230106,4130007,0,1,1,0,6000),(2703,4230106,4130009,0,1,1,0,6000),(2704,4230107,4000076,0,1,1,0,600000),(2705,4230107,2000002,0,1,1,0,20000),(2706,4230107,2000003,0,1,1,0,20000),(2707,4230107,4003004,0,1,1,0,200000),(2710,4230107,1332020,0,1,1,0,800),(2711,4230107,2043202,0,1,1,0,100),(2712,4230107,2041014,0,1,1,0,100),(2714,4230107,4006000,0,1,1,0,10000),(2716,4230107,1040030,0,1,1,0,800),(2717,4230107,1060020,0,1,1,0,800),(2718,4230107,1060061,0,1,1,0,800),(2719,4230107,1040072,0,1,1,0,800),(2720,4230107,1050035,0,1,1,0,800),(2721,4230107,1060071,0,1,1,0,800),(2722,4230107,1040082,0,1,1,0,800),(2723,4230107,1082072,0,1,1,0,800),(2724,4230107,1082063,0,1,1,0,800),(2725,4230107,1051030,0,1,1,0,800),(2726,4230107,1072134,0,1,1,0,800),(2727,4230107,1072129,0,1,1,0,800),(2728,4230107,1452008,0,1,1,0,800),(2729,4230107,4130005,0,1,1,0,6000),(2730,4230107,4130015,0,1,1,0,6000),(2731,4230108,4000078,0,1,1,0,600000),(2732,4230108,2000002,0,1,1,0,20000),(2733,4230108,2000003,0,1,1,0,20000),(2737,4230108,4000021,0,1,1,0,50000),(2738,4230108,4003004,0,1,1,0,200000),(2739,4230108,2041017,0,1,1,0,100),(2740,4230108,2070002,0,1,1,0,500),(2741,4230108,1432008,0,1,1,0,800),(2742,4230108,2060000,0,1,1,0,30000),(2743,4230108,2061000,0,1,1,0,30000),(2744,4230108,1050031,0,1,1,0,800),(2745,4230108,1072113,0,1,1,0,800),(2746,4230108,1072108,0,1,1,0,800),(2747,4230108,1082073,0,1,1,0,800),(2748,4230108,1422007,0,1,1,0,800),(2749,4230108,1041082,0,1,1,0,800),(2750,4230108,1061081,0,1,1,0,800),(2751,4230108,1472018,0,1,1,0,800),(2752,4230108,1442005,0,1,1,0,800),(2753,4230108,1002209,0,1,1,0,800),(2754,4230108,1002218,0,1,1,0,800),(2755,4230108,1002086,0,1,1,0,800),(2756,4230108,2040623,0,1,1,0,100),(2757,4230108,4130010,0,1,1,0,6000),(2758,4230108,4130011,0,1,1,0,6000),(2759,4230109,4000101,0,1,1,0,600000),(2760,4230109,2060000,0,1,1,0,30000),(2761,4230109,2061000,0,1,1,0,30000),(2764,4230109,2000002,0,1,1,0,20000),(2765,4230109,2000003,0,1,1,0,20000),(2766,4230109,2040901,0,1,1,0,100),(2767,4230109,1032018,0,1,1,0,800),(2768,4230109,1402002,0,1,1,0,800),(2769,4230109,1002180,0,1,1,0,800),(2770,4230109,1082070,0,1,1,0,800),(2771,4230109,1051024,0,1,1,0,800),(2772,4230109,1002154,0,1,1,0,800),(2773,4230109,1002167,0,1,1,0,800),(2774,4230109,1472017,0,1,1,0,800),(2775,4230109,1072117,0,1,1,0,800),(2776,4230109,1040087,0,1,1,0,800),(2777,4230109,1060076,0,1,1,0,800),(2778,4230109,1462007,0,1,1,0,800),(2779,4230109,1092004,0,1,1,0,800),(2780,4230109,1482006,0,1,1,0,800),(2781,4230109,2043212,0,1,1,0,100),(2782,4230109,2044414,0,1,1,0,100),(2783,4230109,4130000,0,1,1,0,6000),(2784,4230109,4130005,0,1,1,0,6000),(2785,4230109,4130014,0,1,1,0,6000),(2786,4230110,4000102,0,1,1,0,600000),(2787,4230110,2060000,0,1,1,0,30000),(2788,4230110,2061000,0,1,1,0,30000),(2791,4230110,2000002,0,1,1,0,20000),(2792,4230110,2000004,0,1,1,0,20000),(2793,4230110,2040504,0,1,1,0,100),(2794,4230110,2044002,0,1,1,0,100),(2795,4230110,2044301,0,1,1,0,100),(2796,4230110,1302013,0,1,1,0,800),(2797,4230110,1002004,0,1,1,0,800),(2798,4230110,1041067,0,1,1,0,800),(2799,4230110,1061062,0,1,1,0,800),(2800,4230110,1002144,0,1,1,0,800),(2801,4230110,1002170,0,1,1,0,800),(2802,4230110,1002181,0,1,1,0,800),(2803,4230110,1040082,0,1,1,0,800),(2804,4230110,1060071,0,1,1,0,800),(2805,4230110,1061083,0,1,1,0,800),(2806,4230110,1041084,0,1,1,0,800),(2807,4230110,1040088,0,1,1,0,800),(2808,4230110,1060077,0,1,1,0,800),(2809,4230110,1082081,0,1,1,0,800),(2810,4230110,1082083,0,1,1,0,800),(2811,4230110,1072135,0,1,1,0,800),(2812,4230110,1082195,0,1,1,0,800),(2813,4230110,2044902,0,1,1,0,100),(2814,4230110,2040618,0,1,1,0,100),(2815,4230110,2040627,0,1,1,0,100),(2816,4230110,2040931,0,1,1,0,100),(2817,4230110,2044014,0,1,1,0,100),(2818,4230110,4130002,0,1,1,0,6000),(2819,4230110,4130010,0,1,1,0,6000),(2820,4230110,4130011,0,1,1,0,6000),(2821,4230111,4000111,0,1,1,0,600000),(2822,4230111,2060000,0,1,1,0,30000),(2823,4230111,2061000,0,1,1,0,30000),(2827,4230111,2000002,0,1,1,0,20000),(2828,4230111,2000003,0,1,1,0,20000),(2829,4230111,2040602,0,1,1,0,100),(2830,4230111,2043302,0,1,1,0,100),(2831,4230111,1041051,0,1,1,0,800),(2832,4230111,1061047,0,1,1,0,800),(2833,4230111,1051007,0,1,1,0,800),(2834,4230111,1050021,0,1,1,0,800),(2835,4230111,1002021,0,1,1,0,800),(2836,4230111,1002153,0,1,1,0,800),(2837,4230111,1002168,0,1,1,0,800),(2838,4230111,1072116,0,1,1,0,800),(2839,4230111,1072127,0,1,1,0,800),(2840,4230111,1072123,0,1,1,0,800),(2841,4230111,1302010,0,1,1,0,800),(2842,4230111,1472018,0,1,1,0,800),(2843,4230111,1002628,0,1,1,0,800),(2844,4230111,2040926,0,1,1,0,100),(2845,4230111,2044010,0,1,1,0,100),(2846,4230111,4130003,0,1,1,0,6000),(2847,4230111,4130006,0,1,1,0,6000),(2848,4230111,4130015,0,1,1,0,6000),(2849,4230112,4000112,0,1,1,0,600000),(2850,4230112,2060000,0,1,1,0,30000),(2851,4230112,2061000,0,1,1,0,30000),(2853,4230112,2002008,0,1,1,0,20000),(2854,4230112,2000002,0,1,1,0,20000),(2855,4230112,2000004,0,1,1,0,20000),(2856,4230112,2040004,0,1,1,0,100),(2857,4230112,2040502,0,1,1,0,100),(2858,4230112,1302016,0,1,1,0,800),(2859,4230112,1302010,0,1,1,0,800),(2860,4230112,1072101,0,1,1,0,800),(2861,4230112,1051026,0,1,1,0,800),(2862,4230112,1072000,0,1,1,0,800),(2863,4230112,1072110,0,1,1,0,800),(2864,4230112,1082025,0,1,1,0,800),(2865,4230112,1002169,0,1,1,0,800),(2866,4230112,1472020,0,1,1,0,800),(2867,4230112,1412003,0,1,1,0,800),(2868,4230112,1402003,0,1,1,0,800),(2869,4230112,1040097,0,1,1,0,800),(2870,4230112,1060086,0,1,1,0,800),(2871,4230112,1002214,0,1,1,0,800),(2872,4230112,1492007,0,1,1,0,800),(2873,4230112,2049000,0,1,1,0,150),(2874,4230112,4130003,0,1,1,0,6000),(2875,4230112,4130010,0,1,1,0,6000),(2876,4230113,4000114,0,1,1,0,600000),(2877,4230113,2060000,0,1,1,0,30000),(2878,4230113,2061000,0,1,1,0,30000),(2881,4230113,2000002,0,1,1,0,20000),(2882,4230113,2000003,0,1,1,0,20000),(2883,4230113,1382019,0,1,1,0,800),(2884,4230113,2040401,0,1,1,0,100),(2885,4230113,2044701,0,1,1,0,100),(2886,4230113,1002047,0,1,1,0,800),(2887,4230113,1002139,0,1,1,0,800),(2888,4230113,1002142,0,1,1,0,800),(2889,4230113,1040061,0,1,1,0,800),(2890,4230113,1060050,0,1,1,0,800),(2891,4230113,1051025,0,1,1,0,800),(2892,4230113,1082071,0,1,1,0,800),(2893,4230113,1082023,0,1,1,0,800),(2894,4230113,1072108,0,1,1,0,800),(2895,4230113,1032018,0,1,1,0,800),(2896,4230113,1372007,0,1,1,0,800),(2897,4230113,1332016,0,1,1,0,800),(2898,4230113,1322017,0,1,1,0,800),(2899,4230113,1052113,0,1,1,0,800),(2900,4230113,4130008,0,1,1,0,6000),(2901,4230113,4130013,0,1,1,0,6000),(2902,4230113,4130017,0,1,1,0,6000),(2903,4230114,4000115,0,1,1,0,600000),(2904,4230114,2060000,0,1,1,0,30000),(2905,4230114,2061000,0,1,1,0,30000),(2907,4230114,2002010,0,1,1,0,20000),(2909,4230114,2000002,0,1,1,0,20000),(2910,4230114,2000003,0,1,1,0,20000),(2911,4230114,2040804,0,1,1,0,100),(2912,4230114,1402007,0,1,1,0,800),(2913,4230114,1092029,0,1,1,0,800),(2914,4230114,1002176,0,1,1,0,800),(2915,4230114,1002143,0,1,1,0,800),(2916,4230114,1040076,0,1,1,0,800),(2917,4230114,1060065,0,1,1,0,800),(2918,4230114,1050036,0,1,1,0,800),(2919,4230114,1040085,0,1,1,0,800),(2920,4230114,1060074,0,1,1,0,800),(2921,4230114,1082074,0,1,1,0,800),(2922,4230114,1072116,0,1,1,0,800),(2923,4230114,1092013,0,1,1,0,800),(2924,4230114,1432004,0,1,1,0,800),(2925,4230114,1312008,0,1,1,0,800),(2926,4230114,1052113,0,1,1,0,800),(2927,4230114,4130006,0,1,1,0,6000),(2928,4230114,4130016,0,1,1,0,6000),(2929,4230114,4130017,0,1,1,0,6000),(2930,4230115,4000115,0,1,1,0,600000),(2931,4230115,2060000,0,1,1,0,30000),(2932,4230115,2061000,0,1,1,0,30000),(2933,4230115,2002010,0,1,1,0,20000),(2937,4230115,2000002,0,1,1,0,20000),(2938,4230115,2000004,0,1,1,0,20000),(2939,4230115,2043802,0,1,1,0,100),(2940,4230115,2044102,0,1,1,0,100),(2941,4230115,4006001,0,1,1,0,10000),(2942,4230115,2070004,0,1,1,0,300),(2943,4230115,1082069,0,1,1,0,800),(2944,4230115,1072000,0,1,1,0,800),(2945,4230115,1072118,0,1,1,0,800),(2946,4230115,1060069,0,1,1,0,800),(2947,4230115,1040079,0,1,1,0,800),(2948,4230115,1050049,0,1,1,0,800),(2949,4230115,1041088,0,1,1,0,800),(2950,4230115,1061087,0,1,1,0,800),(2951,4230115,1082065,0,1,1,0,800),(2952,4230115,1072141,0,1,1,0,800),(2953,4230115,1422005,0,1,1,0,800),(2954,4230115,1472021,0,1,1,0,800),(2955,4230115,1482007,0,1,1,0,800),(2956,4230115,2040029,0,1,1,0,100),(2957,4230115,2040617,0,1,1,0,100),(2958,4230115,2040931,0,1,1,0,100),(2959,4230115,2044214,0,1,1,0,100),(2960,4230115,4130011,0,1,1,0,6000),(2961,4230115,4130015,0,1,1,0,6000),(2962,4230115,4130016,0,1,1,0,6000),(2963,4230116,4000117,0,1,1,0,600000),(2964,4230116,2002009,0,1,1,0,20000),(2965,4230116,2000002,0,1,1,0,20000),(2966,4230116,2000003,0,1,1,0,20000),(2970,4230116,2041005,0,1,1,0,100),(2971,4230116,1302016,0,1,1,0,800),(2972,4230116,2060000,0,1,1,0,30000),(2973,4230116,2061000,0,1,1,0,30000),(2975,4230116,1372001,0,1,1,0,800),(2976,4230116,1322015,0,1,1,0,800),(2977,4230116,1402006,0,1,1,0,800),(2978,4230116,1092007,0,1,1,0,800),(2979,4230116,1072109,0,1,1,0,800),(2980,4230116,1072120,0,1,1,0,800),(2981,4230116,1082062,0,1,1,0,800),(2982,4230116,1040084,0,1,1,0,800),(2983,4230116,1060073,0,1,1,0,800),(2984,4230116,1050047,0,1,1,0,800),(2985,4230116,1002211,0,1,1,0,800),(2986,4230116,1002028,0,1,1,0,800),(2987,4230116,1082195,0,1,1,0,800),(2988,4230116,4130007,0,1,1,0,6000),(2989,4230116,4130017,0,1,1,0,6000),(2990,4230117,4000118,0,1,1,0,600000),(2993,4230117,2002007,0,1,1,0,20000),(2995,4230117,2000002,0,1,1,0,20000),(2996,4230117,2000003,0,1,1,0,20000),(2997,4230117,2040707,0,1,1,0,100),(2998,4230117,2060000,0,1,1,0,30000),(2999,4230117,2061000,0,1,1,0,30000),(3000,4230117,1092020,0,1,1,0,800),(3001,4230117,2070002,0,1,1,0,500),(3002,4230117,1082047,0,1,1,0,800),(3003,4230117,1082008,0,1,1,0,800),(3004,4230117,1041085,0,1,1,0,800),(3005,4230117,1061084,0,1,1,0,800),(3006,4230117,1060068,0,1,1,0,800),(3007,4230117,1040080,0,1,1,0,800),(3008,4230117,1050049,0,1,1,0,800),(3009,4230117,1002208,0,1,1,0,800),(3010,4230117,1002212,0,1,1,0,800),(3011,4230117,1002217,0,1,1,0,800),(3012,4230117,1312008,0,1,1,0,800),(3013,4230117,1332003,0,1,1,0,800),(3014,4230117,1492006,0,1,1,0,800),(3015,4230117,4130009,0,1,1,0,6000),(3016,4230117,4130010,0,1,1,0,6000),(3017,4230118,4000119,0,1,1,0,600000),(3018,4230118,2002009,0,1,1,0,20000),(3022,4230118,2040802,0,1,1,0,100),(3023,4230118,2000002,0,1,1,0,20000),(3024,4230118,2000004,0,1,1,0,20000),(3025,4230118,2060000,0,1,1,0,30000),(3026,4230118,2061000,0,1,1,0,30000),(3027,4230118,2070004,0,1,1,0,300),(3028,4230118,1041068,0,1,1,0,800),(3029,4230118,1061063,0,1,1,0,800),(3030,4230118,1050038,0,1,1,0,800),(3031,4230118,1002155,0,1,1,0,800),(3032,4230118,1061070,0,1,1,0,800),(3033,4230118,1041075,0,1,1,0,800),(3034,4230118,1082024,0,1,1,0,800),(3035,4230118,1040000,0,1,1,0,800),(3036,4230118,1060075,0,1,1,0,800),(3037,4230118,1002024,0,1,1,0,800),(3038,4230118,1032012,0,1,1,0,800),(3039,4230118,1072143,0,1,1,0,800),(3040,4230118,1422005,0,1,1,0,800),(3041,4230118,1472021,0,1,1,0,800),(3042,4230118,1072300,0,1,1,0,800),(3043,4230118,2040031,0,1,1,0,100),(3044,4230118,2040931,0,1,1,0,100),(3045,4230118,4130004,0,1,1,0,6000),(3046,4230119,4000120,0,1,1,0,600000),(3047,4230119,2000002,0,1,1,0,20000),(3048,4230119,2002006,0,1,1,0,20000),(3049,4230119,2000003,0,1,1,0,20000),(3053,4230119,2040804,0,1,1,0,100),(3054,4230119,2060000,0,1,1,0,30000),(3055,4230119,2061000,0,1,1,0,30000),(3056,4230119,4131004,0,1,1,0,6000),(3057,4230119,1092019,0,1,1,0,800),(3058,4230119,1002178,0,1,1,0,800),(3059,4230119,1051016,0,1,1,0,800),(3060,4230119,1082068,0,1,1,0,800),(3061,4230119,1072002,0,1,1,0,800),(3062,4230119,1050035,0,1,1,0,800),(3063,4230119,1041075,0,1,1,0,800),(3064,4230119,1061070,0,1,1,0,800),(3065,4230119,1061083,0,1,1,0,800),(3066,4230119,1041084,0,1,1,0,800),(3067,4230119,1082080,0,1,1,0,800),(3068,4230119,1072124,0,1,1,0,800),(3069,4230119,1082067,0,1,1,0,800),(3070,4230119,1082195,0,1,1,0,800),(3071,4230119,2330001,0,1,1,0,100),(3072,4230119,2044110,0,1,1,0,100),(3073,4230119,4130001,0,1,1,0,6000),(3074,4230119,4130006,0,1,1,0,6000),(3075,4230120,4000121,0,1,1,0,600000),(3076,4230120,4131004,0,1,1,0,6000),(3079,4230120,2040804,0,1,1,0,100),(3080,4230120,2000002,0,1,1,0,20000),(3081,4230120,2000004,0,1,1,0,20000),(3082,4230120,2060000,0,1,1,0,30000),(3083,4230120,2061000,0,1,1,0,30000),(3084,4230120,4006001,0,1,1,0,10000),(3085,4230120,1002141,0,1,1,0,800),(3086,4230120,1002135,0,1,1,0,800),(3087,4230120,1041086,0,1,1,0,800),(3088,4230120,1061085,0,1,1,0,800),(3089,4230120,1061080,0,1,1,0,800),(3090,4230120,1041081,0,1,1,0,800),(3091,4230120,1040084,0,1,1,0,800),(3092,4230120,1061071,0,1,1,0,800),(3093,4230120,1051030,0,1,1,0,800),(3094,4230120,1051039,0,1,1,0,800),(3095,4230120,1082084,0,1,1,0,800),(3096,4230120,1072131,0,1,1,0,800),(3097,4230120,1432004,0,1,1,0,800),(3098,4230120,1452008,0,1,1,0,800),(3099,4230120,1482007,0,1,1,0,800),(3100,4230120,2040324,0,1,1,0,100),(3101,4230120,2040530,0,1,1,0,100),(3102,4230120,4130001,0,1,1,0,6000),(3103,4230120,4130002,0,1,1,0,6000),(3104,4230121,4000122,0,1,1,0,600000),(3105,4230121,4131012,0,1,1,0,6000),(3109,4230121,2043802,0,1,1,0,100),(3110,4230121,2000002,0,1,1,0,20000),(3111,4230121,2000004,0,1,1,0,20000),(3112,4230121,2060000,0,1,1,0,30000),(3113,4230121,2061000,0,1,1,0,30000),(3114,4230121,1041053,0,1,1,0,800),(3115,4230121,1061049,0,1,1,0,800),(3116,4230121,1051015,0,1,1,0,800),(3117,4230121,1082047,0,1,1,0,800),(3118,4230121,1051024,0,1,1,0,800),(3119,4230121,1002155,0,1,1,0,800),(3120,4230121,1002184,0,1,1,0,800),(3121,4230121,1082072,0,1,1,0,800),(3122,4230121,1372007,0,1,1,0,800),(3123,4230121,1040089,0,1,1,0,800),(3124,4230121,1060078,0,1,1,0,800),(3125,4230121,1061076,0,1,1,0,800),(3126,4230121,1041077,0,1,1,0,800),(3127,4230121,1412003,0,1,1,0,800),(3128,4230121,1082198,0,1,1,0,800),(3129,4230121,2044901,0,1,1,0,100),(3130,4230121,4130000,0,1,1,0,6000),(3131,4230121,4130006,0,1,1,0,6000),(3132,4230121,4130013,0,1,1,0,6000),(3133,4230123,4000156,0,1,1,0,600000),(3134,4230123,2000002,0,1,1,0,20000),(3135,4230123,2000003,0,1,1,0,20000),(3136,4230123,4000157,0,1,1,0,100000),(3140,4230123,4003004,0,1,1,0,200000),(3141,4230123,2048004,0,1,1,0,100),(3142,4230123,2070002,0,1,1,0,500),(3143,4230123,2044501,0,1,1,0,100),(3144,4230123,1442009,0,1,1,0,800),(3145,4230123,2060000,0,1,1,0,30000),(3146,4230123,2061000,0,1,1,0,30000),(3147,4230123,1452008,0,1,1,0,800),(3148,4230123,1002024,0,1,1,0,800),(3149,4230123,1472017,0,1,1,0,800),(3150,4230123,1041083,0,1,1,0,800),(3151,4230123,1061082,0,1,1,0,800),(3152,4230123,1082198,0,1,1,0,800),(3153,4230123,2044801,0,1,1,0,100),(3154,4230123,2044805,0,1,1,0,100),(3155,4230123,4130008,0,1,1,0,6000),(3156,4230124,4000155,0,1,1,0,600000),(3157,4230124,2000002,0,1,1,0,20000),(3158,4230124,2000003,0,1,1,0,20000),(3159,4230124,4000157,0,1,1,0,100000),(3162,4230124,2000004,0,1,1,0,20000),(3163,4230124,2060000,0,1,1,0,30000),(3164,4230124,2061000,0,1,1,0,30000),(3166,4230124,2041019,0,1,1,0,100),(3167,4230124,1002045,0,1,1,0,800),(3168,4230124,1061062,0,1,1,0,800),(3169,4230124,1041067,0,1,1,0,800),(3170,4230124,1050037,0,1,1,0,800),(3171,4230124,1041076,0,1,1,0,800),(3172,4230124,1060073,0,1,1,0,800),(3173,4230124,1412005,0,1,1,0,800),(3174,4230124,1452007,0,1,1,0,800),(3175,4230124,1002213,0,1,1,0,800),(3176,4230124,1002085,0,1,1,0,800),(3177,4230124,1032012,0,1,1,0,800),(3178,4230124,1040096,0,1,1,0,800),(3179,4230124,1060085,0,1,1,0,800),(3180,4230124,1002631,0,1,1,0,800),(3181,4230124,4130008,0,1,1,0,6000),(3182,4230124,4130012,0,1,1,0,6000),(3183,4230124,4130014,0,1,1,0,6000),(3184,4230125,4000204,0,1,1,0,600000),(3185,4230125,2000002,0,1,1,0,20000),(3186,4230125,2000003,0,1,1,0,20000),(3190,4230125,2060000,0,1,1,0,30000),(3191,4230125,2061000,0,1,1,0,30000),(3192,4230125,1002047,0,1,1,0,800),(3193,4230125,1002081,0,1,1,0,800),(3194,4230125,1002144,0,1,1,0,800),(3195,4230125,1002178,0,1,1,0,800),(3196,4230125,1422007,0,1,1,0,800),(3197,4230125,1382019,0,1,1,0,800),(3198,4230125,1332016,0,1,1,0,800),(3199,4230125,1050052,0,1,1,0,800),(3200,4230125,1072118,0,1,1,0,800),(3201,4230125,1072108,0,1,1,0,800),(3202,4230125,1072126,0,1,1,0,800),(3203,4230125,2070002,0,1,1,0,500),(3204,4230125,4006000,0,1,1,0,10000),(3205,4230125,2044301,0,1,1,0,100),(3206,4230125,2040705,0,1,1,0,100),(3207,4230125,2040824,0,1,1,0,100),(3208,4230125,2040929,0,1,1,0,100),(3209,4230125,4130002,0,1,1,0,6000),(3210,4230125,4130011,0,1,1,0,6000),(3211,4230126,4000205,0,1,1,0,600000),(3212,4230126,2041014,0,1,1,0,100),(3214,4230126,2000002,0,1,1,0,20000),(3215,4230126,2000004,0,1,1,0,20000),(3216,4230126,2000003,0,1,1,0,20000),(3219,4230126,2060000,0,1,1,0,30000),(3220,4230126,2061000,0,1,1,0,30000),(3221,4230126,1041084,0,1,1,0,800),(3222,4230126,1060075,0,1,1,0,800),(3223,4230126,1041082,0,1,1,0,800),(3224,4230126,1060069,0,1,1,0,800),(3225,4230126,1050048,0,1,1,0,800),(3226,4230126,1051032,0,1,1,0,800),(3227,4230126,1082010,0,1,1,0,800),(3228,4230126,2044201,0,1,1,0,100),(3229,4230126,1082066,0,1,1,0,800),(3230,4230126,1082092,0,1,1,0,800),(3231,4230126,1082089,0,1,1,0,800),(3232,4230126,1082059,0,1,1,0,800),(3233,4230126,4006001,0,1,1,0,10000),(3234,4230126,1002631,0,1,1,0,800),(3235,4230126,2040419,0,1,1,0,100),(3236,4230126,2040413,0,1,1,0,100),(3237,4230126,2049000,0,1,1,0,150),(3238,4230126,4130004,0,1,1,0,6000),(3239,4230126,4130008,0,1,1,0,6000),(3240,4230126,4130012,0,1,1,0,6000),(3241,4230200,2000002,0,1,1,0,20000),(3242,4230200,2022040,0,1,1,0,20000),(3243,4230200,2000003,0,1,1,0,20000),(3247,4230200,2040001,0,1,1,0,100),(3248,4230200,2040704,0,1,1,0,100),(3249,4230200,4000158,0,1,1,0,600000),(3250,4230200,1072112,0,1,1,0,800),(3251,4230200,1051027,0,1,1,0,800),(3252,4230200,1002170,0,1,1,0,800),(3253,4230200,1040000,0,1,1,0,800),(3254,4230200,1060000,0,1,1,0,800),(3255,4230200,1432005,0,1,1,0,800),(3256,4230200,1472014,0,1,1,0,800),(3257,4230200,1462006,0,1,1,0,800),(3258,4230200,1002207,0,1,1,0,800),(3259,4230200,1002215,0,1,1,0,800),(3260,4230200,1040094,0,1,1,0,800),(3261,4230200,1060083,0,1,1,0,800),(3262,4230200,1051038,0,1,1,0,800),(3263,4230200,1041088,0,1,1,0,800),(3264,4230200,1061087,0,1,1,0,800),(3265,4230200,1072300,0,1,1,0,800),(3266,4230200,2040620,0,1,1,0,100),(3267,4230200,2044310,0,1,1,0,100),(3268,4230200,4130003,0,1,1,0,6000),(3269,4230200,4130007,0,1,1,0,6000),(3270,4230201,4000159,0,1,1,0,600000),(3271,4230201,2002004,0,1,1,0,20000),(3272,4230201,2000002,0,1,1,0,20000),(3273,4230201,2000003,0,1,1,0,20000),(3274,4230201,2022040,0,1,1,0,20000),(3278,4230201,2040801,0,1,1,0,100),(3279,4230201,2040901,0,1,1,0,100),(3280,4230201,2060000,0,1,1,0,30000),(3281,4230201,2061000,0,1,1,0,30000),(3282,4230201,1072106,0,1,1,0,800),(3283,4230201,1072102,0,1,1,0,800),(3284,4230201,1082055,0,1,1,0,800),(3285,4230201,1002137,0,1,1,0,800),(3286,4230201,1072126,0,1,1,0,800),(3287,4230201,1082024,0,1,1,0,800),(3288,4230201,1041074,0,1,1,0,800),(3289,4230201,1061069,0,1,1,0,800),(3290,4230201,1051031,0,1,1,0,800),(3291,4230201,1041078,0,1,1,0,800),(3292,4230201,1061077,0,1,1,0,800),(3293,4230201,1051037,0,1,1,0,800),(3294,4230201,1072140,0,1,1,0,800),(3295,4230201,1082011,0,1,1,0,800),(3296,4230201,2040417,0,1,1,0,100),(3297,4230201,4130006,0,1,1,0,6000),(3298,4230201,4130016,0,1,1,0,6000),(3299,4230300,4000169,0,1,1,0,600000),(3300,4230300,4000021,0,1,1,0,50000),(3301,4230300,2000002,0,1,1,0,20000),(3302,4230300,2000003,0,1,1,0,20000),(3306,4230300,2060000,0,1,1,0,30000),(3307,4230300,2061000,0,1,1,0,30000),(3308,4230300,1302016,0,1,1,0,800),(3309,4230300,1082072,0,1,1,0,800),(3310,4230300,1072109,0,1,1,0,800),(3311,4230300,1072112,0,1,1,0,800),(3312,4230300,1092014,0,1,1,0,800),(3313,4230300,1032011,0,1,1,0,800),(3314,4230300,1312007,0,1,1,0,800),(3315,4230300,2070002,0,1,1,0,500),(3316,4230300,1102001,0,1,1,0,800),(3317,4230300,4006000,0,1,1,0,10000),(3318,4230300,2040705,0,1,1,0,100),(3319,4230300,1482006,0,1,1,0,800),(3320,4230300,2040029,0,1,1,0,100),(3321,4230300,2040417,0,1,1,0,100),(3322,4230300,4130009,0,1,1,0,6000),(3323,4230300,4130015,0,1,1,0,6000),(3324,4230300,4130017,0,1,1,0,6000),(3325,4230400,4000178,0,1,1,0,600000),(3326,4230400,2044001,0,1,1,0,100),(3327,4230400,2060000,0,1,1,0,30000),(3328,4230400,2061000,0,1,1,0,30000),(3331,4230400,2000002,0,1,1,0,20000),(3332,4230400,2000003,0,1,1,0,20000),(3333,4230400,2000004,0,1,1,0,20000),(3334,4230400,1002184,0,1,1,0,800),(3335,4230400,1032018,0,1,1,0,800),(3336,4230400,1041082,0,1,1,0,800),(3337,4230400,1061081,0,1,1,0,800),(3338,4230400,1050047,0,1,1,0,800),(3339,4230400,1082071,0,1,1,0,800),(3340,4230400,1072116,0,1,1,0,800),(3341,4230400,1072126,0,1,1,0,800),(3343,4230400,2040923,0,1,1,0,100),(3344,4230400,4130001,0,1,1,0,6000),(3345,4230400,4130010,0,1,1,0,6000),(3346,4230400,4130011,0,1,1,0,6000),(3347,4230500,4000276,0,1,1,0,600000),(3348,4230500,4000021,0,1,1,0,50000),(3349,4230500,2060000,0,1,1,0,30000),(3350,4230500,2061000,0,1,1,0,30000),(3351,4230500,2040001,0,1,1,0,100),(3352,4230500,2000002,0,1,1,0,20000),(3354,4230500,2000003,0,1,1,0,20000),(3355,4230500,1002023,0,1,1,0,800),(3357,4230500,1002103,0,1,1,0,800),(3358,4230500,1002092,0,1,1,0,800),(3359,4230500,1002155,0,1,1,0,800),(3360,4230500,1051016,0,1,1,0,800),(3361,4230500,1061061,0,1,1,0,800),(3362,4230500,1041066,0,1,1,0,800),(3363,4230500,1050038,0,1,1,0,800),(3364,4230500,1041095,0,1,1,0,800),(3365,4230500,1061094,0,1,1,0,800),(3366,4230500,1482006,0,1,1,0,800),(3367,4230500,2330001,0,1,1,0,100),(3368,4230500,4130004,0,1,1,0,6000),(3369,4230500,4130014,0,1,1,0,6000),(3370,4230500,4130016,0,1,1,0,6000),(3371,4230501,4000277,0,1,1,0,600000),(3372,4230501,2060000,0,1,1,0,30000),(3373,4230501,2061000,0,1,1,0,30000),(3375,4230501,2000002,0,1,1,0,20000),(3376,4230501,2000003,0,1,1,0,20000),(3377,4230501,2040901,0,1,1,0,100),(3378,4230501,1472018,0,1,1,0,800),(3379,4230501,1032018,0,1,1,0,800),(3380,4230501,1072110,0,1,1,0,800),(3381,4230501,1051026,0,1,1,0,800),(3382,4230501,1061076,0,1,1,0,800),(3383,4230501,1002217,0,1,1,0,800),(3385,4230501,1072300,0,1,1,0,800),(3386,4230501,2040420,0,1,1,0,100),(3387,4230501,2049000,0,1,1,0,150),(3388,4230501,4130000,0,1,1,0,6000),(3389,4230501,4130009,0,1,1,0,6000),(3390,4230501,4130011,0,1,1,0,6000),(3391,4230502,4000278,0,1,1,0,600000),(3392,4230502,2000002,0,1,1,0,20000),(3393,4230502,2000003,0,1,1,0,20000),(3397,4230502,2048004,0,1,1,0,100),(3398,4230502,2070002,0,1,1,0,500),(3399,4230502,2044501,0,1,1,0,100),(3400,4230502,1442009,0,1,1,0,800),(3401,4230502,2060000,0,1,1,0,30000),(3402,4230502,2061000,0,1,1,0,30000),(3403,4230502,1452008,0,1,1,0,800),(3404,4230502,1002024,0,1,1,0,800),(3405,4230502,1041083,0,1,1,0,800),(3406,4230502,1061082,0,1,1,0,800),(3407,4230502,1072303,0,1,1,0,800),(3408,4230502,2040823,0,1,1,0,100),(3409,4230502,2043114,0,1,1,0,100),(3410,4230502,4130003,0,1,1,0,6000),(3411,4230502,4130009,0,1,1,0,6000),(3412,4230502,4130017,0,1,1,0,6000),(3413,4230503,4000281,0,1,1,0,600000),(3414,4230503,2000002,0,1,1,0,20000),(3415,4230503,2000003,0,1,1,0,20000),(3419,4230503,2060000,0,1,1,0,30000),(3420,4230503,2061000,0,1,1,0,30000),(3421,4230503,1032008,0,1,1,0,800),(3422,4230503,1002081,0,1,1,0,800),(3423,4230503,1040089,0,1,1,0,800),(3424,4230503,1060078,0,1,1,0,800),(3425,4230503,1050052,0,1,1,0,800),(3426,4230503,1102001,0,1,1,0,800),(3427,4230503,2040705,0,1,1,0,100),(3428,4230503,4000280,0,1,1,0,600000),(3429,4230503,1492006,0,1,1,0,800),(3430,4230503,2044410,0,1,1,0,100),(3431,4230503,4130001,0,1,1,0,6000),(3432,4230503,4130007,0,1,1,0,6000),(3433,4230504,4000281,0,1,1,0,600000),(3434,4230504,2000002,0,1,1,0,20000),(3435,4230504,2000003,0,1,1,0,20000),(3439,4230504,2060000,0,1,1,0,30000),(3440,4230504,2061000,0,1,1,0,30000),(3441,4230504,2040504,0,1,1,0,100),(3442,4230504,2044002,0,1,1,0,100),(3443,4230504,1002085,0,1,1,0,800),(3444,4230504,1382001,0,1,1,0,800),(3445,4230504,1082010,0,1,1,0,800),(3446,4230504,1041077,0,1,1,0,800),(3447,4230504,4000279,0,1,1,0,600000),(3448,4230504,1002631,0,1,1,0,800),(3449,4230504,2330002,0,1,1,0,100),(3450,4230504,2044310,0,1,1,0,100),(3451,4230504,4130002,0,1,1,0,6000),(3452,4230504,4130013,0,1,1,0,6000),(3453,4230505,4000291,0,1,1,0,600000),(3454,4230505,2000002,0,1,1,0,20000),(3455,4230505,2000003,0,1,1,0,20000),(3458,4230505,2044102,0,1,1,0,100),(3459,4230505,1372007,0,1,1,0,800),(3460,4230505,1002215,0,1,1,0,800),(3461,4230505,4006001,0,1,1,0,10000),(3462,4230505,1040089,0,1,1,0,800),(3463,4230505,1050045,0,1,1,0,800),(3465,4230505,2040001,0,1,1,0,100),(3466,4230505,1052116,0,1,1,0,800),(3467,4230505,2330002,0,1,1,0,100),(3468,4230505,4130001,0,1,1,0,6000),(3469,4230505,4130014,0,1,1,0,6000),(3470,4230505,4130016,0,1,1,0,6000),(3471,4230506,4000292,0,1,1,0,600000),(3472,4230506,2000002,0,1,1,0,20000),(3473,4230506,2000003,0,1,1,0,20000),(3476,4230506,1041086,0,1,1,0,800),(3477,4230506,1061085,0,1,1,0,800),(3478,4230506,1302013,0,1,1,0,800),(3479,4230506,1002083,0,1,1,0,800),(3480,4230506,1032007,0,1,1,0,800),(3481,4230506,1041080,0,1,1,0,800),(3482,4230506,1061079,0,1,1,0,800),(3483,4230506,1002212,0,1,1,0,800),(3484,4230506,1041092,0,1,1,0,800),(3485,4230506,1061091,0,1,1,0,800),(3486,4230506,1102003,0,1,1,0,800),(3487,4230506,4006001,0,1,1,0,10000),(3488,4230506,1492007,0,1,1,0,800),(3489,4230506,2040622,0,1,1,0,100),(3490,4230506,2044110,0,1,1,0,100),(3491,4230506,2044312,0,1,1,0,100),(3492,4230506,2049100,0,1,1,0,150),(3493,4230506,4130000,0,1,1,0,6000),(3494,4230506,4130017,0,1,1,0,6000),(3495,4230600,2000003,0,1,1,0,20000),(3496,4230600,2060000,0,1,1,0,30000),(3497,4230600,2061000,0,1,1,0,30000),(3498,4230600,2000002,0,1,1,0,20000),(3499,4230600,4000332,0,1,1,0,600000),(3502,4230600,4006001,0,1,1,0,10000),(3503,4230600,2044401,0,1,1,0,100),(3504,4230600,2070003,0,1,1,0,400),(3505,4230600,1372012,0,1,1,0,800),(3506,4230600,1432003,0,1,1,0,800),(3507,4230600,1452007,0,1,1,0,800),(3508,4230600,1102000,0,1,1,0,800),(3509,4230600,1002210,0,1,1,0,800),(3510,4230600,1072002,0,1,1,0,800),(3511,4230600,1082055,0,1,1,0,800),(3512,4230600,1041082,0,1,1,0,800),(3513,4230600,1061081,0,1,1,0,800),(3515,4230600,1492006,0,1,1,0,800),(3516,4230600,2044802,0,1,1,0,100),(3517,4230600,2040823,0,1,1,0,100),(3518,4230600,2044412,0,1,1,0,100),(3519,4230600,4130000,0,1,1,0,6000),(3520,4230600,4130016,0,1,1,0,6000),(3521,4240000,4000125,0,1,1,0,600000),(3522,4240000,2060000,0,1,1,0,30000),(3523,4240000,2061000,0,1,1,0,30000),(3524,4240000,2000002,0,1,1,0,20000),(3525,4240000,2000004,0,1,1,0,20000),(3526,4240000,2002008,0,1,1,0,20000),(3527,4240000,1102016,0,1,1,0,800),(3531,4240000,2043801,0,1,1,0,100),(3532,4240000,4006001,0,1,1,0,10000),(3533,4240000,4021009,0,1,1,0,9000),(3534,4240000,1322016,0,1,1,0,800),(3535,4240000,1041074,0,1,1,0,800),(3536,4240000,1061069,0,1,1,0,800),(3537,4240000,1041083,0,1,1,0,800),(3538,4240000,1061082,0,1,1,0,800),(3539,4240000,1332003,0,1,1,0,800),(3540,4240000,1072122,0,1,1,0,800),(3541,4240000,1072130,0,1,1,0,800),(3542,4240000,1072133,0,1,1,0,800),(3543,4240000,1082080,0,1,1,0,800),(3544,4240000,1072125,0,1,1,0,800),(3545,4240000,1002216,0,1,1,0,800),(3546,4240000,1002101,0,1,1,0,800),(3547,4240000,2040029,0,1,1,0,100),(3548,4240000,2040619,0,1,1,0,100),(3549,4240000,2044114,0,1,1,0,100),(3550,4240000,4130006,0,1,1,0,6000),(3551,4240000,4130011,0,1,1,0,6000),(3552,4250000,4000436,0,1,1,0,600000),(3553,4250000,2000002,0,1,1,0,20000),(3554,4250000,2000003,0,1,1,0,20000),(3557,4250000,2040004,0,1,1,0,100),(3558,4250000,1002025,0,1,1,0,800),(3559,4250000,1051025,0,1,1,0,800),(3560,4250000,1082083,0,1,1,0,800),(3561,4250000,1072109,0,1,1,0,800),(3562,4250000,1492006,0,1,1,0,800),(3563,4250000,4130005,0,1,1,0,6000),(3564,4250000,4130015,0,1,1,0,6000),(3565,4250000,4130017,0,1,1,0,6000),(3566,4250001,2000002,0,1,1,0,20000),(3567,4250001,2000003,0,1,1,0,20000),(3570,4250001,2040627,0,1,1,0,100),(3571,4250001,1002215,0,1,1,0,800),(3572,4250001,1051038,0,1,1,0,800),(3573,4250001,1082066,0,1,1,0,800),(3574,4250001,1072303,0,1,1,0,800),(3575,4250001,1442005,0,1,1,0,800),(3576,4250001,4000438,0,1,1,0,600000),(3577,4250001,4130014,0,1,1,0,6000),(3578,5090000,4000413,0,1,1,0,600000),(3579,5090001,4000412,0,1,1,0,600000),(3580,5100000,4000048,0,1,1,0,600000),(3581,5100000,4003005,0,1,1,0,200000),(3582,5100000,4000021,0,1,1,0,50000),(3583,5100000,2000002,0,1,1,0,20000),(3584,5100000,2000003,0,1,1,0,20000),(3585,5100000,2000004,0,1,1,0,20000),(3588,5100000,1072089,0,1,1,0,800),(3589,5100000,1082038,0,1,1,0,800),(3590,5100000,1452006,0,1,1,0,800),(3591,5100000,1442009,0,1,1,0,800),(3592,5100000,1051044,0,1,1,0,800),(3593,5100000,1051045,0,1,1,0,800),(3594,5100000,2044602,0,1,1,0,100),(3595,5100000,1041096,0,1,1,0,800),(3596,5100000,1061095,0,1,1,0,800),(3597,5100000,2040804,0,1,1,0,100),(3599,5100000,1051037,0,1,1,0,800),(3600,5100000,1052116,0,1,1,0,800),(3601,5100000,2040321,0,1,1,0,100),(3602,5100000,2040933,0,1,1,0,100),(3603,5100000,2040925,0,1,1,0,100),(3604,5100000,2043019,0,1,1,0,100),(3605,5100000,2043110,0,1,1,0,100),(3606,5100000,4130010,0,1,1,0,6000),(3607,5100000,4130011,0,1,1,0,6000),(3608,5100002,4000081,0,1,1,0,600000),(3609,5100002,2000002,0,1,1,0,20000),(3610,5100002,2000003,0,1,1,0,20000),(3614,5100002,2041010,0,1,1,0,100),(3615,5100002,2070003,0,1,1,0,400),(3616,5100002,4006000,0,1,1,0,10000),(3617,5100002,1051025,0,1,1,0,800),(3618,5100002,1302009,0,1,1,0,800),(3619,5100002,1041076,0,1,1,0,800),(3620,5100002,1061071,0,1,1,0,800),(3621,5100002,1332016,0,1,1,0,800),(3622,5100002,1322017,0,1,1,0,800),(3623,5100002,1002209,0,1,1,0,800),(3624,5100002,1002214,0,1,1,0,800),(3625,5100002,1040087,0,1,1,0,800),(3626,5100002,1060076,0,1,1,0,800),(3627,5100002,1072150,0,1,1,0,800),(3628,5100002,1002242,0,1,1,0,800),(3629,5100002,1492007,0,1,1,0,800),(3630,5100002,2040326,0,1,1,0,100),(3631,5100002,2049000,0,1,1,0,150),(3632,5100002,4130001,0,1,1,0,6000),(3633,5100002,4130007,0,1,1,0,6000),(3634,5100003,4000170,0,1,1,0,600000),(3635,5100003,4000021,0,1,1,0,50000),(3636,5100003,2000002,0,1,1,0,20000),(3637,5100003,2000003,0,1,1,0,20000),(3638,5100003,2000004,0,1,1,0,20000),(3641,5100003,1332011,0,1,1,0,800),(3642,5100003,1072118,0,1,1,0,800),(3643,5100003,1051038,0,1,1,0,800),(3644,5100003,2040901,0,1,1,0,100),(3645,5100003,2002003,0,1,1,0,20000),(3646,5100003,1322017,0,1,1,0,800),(3647,5100003,2044602,0,1,1,0,100),(3648,5100003,1041088,0,1,1,0,800),(3649,5100003,1060077,0,1,1,0,800),(3650,5100003,2040804,0,1,1,0,100),(3652,5100003,1312008,0,1,1,0,800),(3653,5100003,1082198,0,1,1,0,800),(3654,5100003,2044805,0,1,1,0,100),(3655,5100003,4130003,0,1,1,0,6000),(3656,5100003,4130008,0,1,1,0,6000),(3657,5100003,4130016,0,1,1,0,6000),(3658,5100004,4000172,0,1,1,0,600000),(3659,5100004,4000021,0,1,1,0,50000),(3661,5100004,2000003,0,1,1,0,20000),(3662,5100004,2000004,0,1,1,0,20000),(3665,5100004,1032021,0,1,1,0,800),(3666,5100004,1072134,0,1,1,0,800),(3667,5100004,1082066,0,1,1,0,800),(3668,5100004,1050058,0,1,1,0,800),(3669,5100004,1051046,0,1,1,0,800),(3670,5100004,2043801,0,1,1,0,100),(3671,5100004,1082081,0,1,1,0,800),(3672,5100004,1432006,0,1,1,0,800),(3673,5100004,1040099,0,1,1,0,800),(3674,5100004,1060088,0,1,1,0,800),(3676,5100004,1040087,0,1,1,0,800),(3677,5100004,1060076,0,1,1,0,800),(3678,5100004,2043701,0,1,1,0,100),(3679,5100004,1052119,0,1,1,0,800),(3680,5100004,2040420,0,1,1,0,100),(3681,5100004,4130003,0,1,1,0,6000),(3682,5100004,4130005,0,1,1,0,6000),(3683,5100004,4130011,0,1,1,0,6000),(3684,5100005,4000171,0,1,1,0,600000),(3685,5100005,2000002,0,1,1,0,20000),(3686,5100005,4000021,0,1,1,0,50000),(3687,5100005,2000004,0,1,1,0,20000),(3688,5100005,2000003,0,1,1,0,20000),(3692,5100005,4006000,0,1,1,0,10000),(3693,5100005,2041023,0,1,1,0,100),(3694,5100005,1402006,0,1,1,0,800),(3695,5100005,2044201,0,1,1,0,100),(3696,5100005,1051045,0,1,1,0,800),(3697,5100005,2070004,0,1,1,0,300),(3698,5100005,1422007,0,1,1,0,800),(3699,5100005,1040095,0,1,1,0,800),(3700,5100005,1060084,0,1,1,0,800),(3701,5100005,1041079,0,1,1,0,800),(3702,5100005,1061078,0,1,1,0,800),(3703,5100005,2044901,0,1,1,0,100),(3704,5100005,2040316,0,1,1,0,100),(3705,5100005,2040621,0,1,1,0,100),(3706,5100005,4130008,0,1,1,0,6000),(3707,5100005,4130009,0,1,1,0,6000),(3708,5110300,2000002,0,1,1,0,20000),(3709,5110300,2000003,0,1,1,0,20000),(3712,5110300,1332011,0,1,1,0,800),(3713,5110300,1072118,0,1,1,0,800),(3714,5110300,1051038,0,1,1,0,800),(3715,5110300,2040901,0,1,1,0,100),(3716,5110300,2002003,0,1,1,0,20000),(3717,5110300,2044602,0,1,1,0,100),(3718,5110300,1041088,0,1,1,0,800),(3719,5110300,1060077,0,1,1,0,800),(3720,5110300,1312008,0,1,1,0,800),(3721,5110300,4000360,0,1,1,0,600000),(3722,5110300,1482007,0,1,1,0,800),(3723,5110300,2044902,0,1,1,0,100),(3724,5110300,1052116,0,1,1,0,800),(3725,5110300,2040027,0,1,1,0,100),(3726,5110300,2040317,0,1,1,0,100),(3727,5110300,4130000,0,1,1,0,6000),(3728,5110300,4130004,0,1,1,0,6000),(3729,5110300,4130006,0,1,1,0,6000),(3731,5110301,2000002,0,1,1,0,20000),(3732,5110301,2000003,0,1,1,0,20000),(3734,5110301,1002159,0,1,1,0,800),(3735,5110301,1040057,0,1,1,0,800),(3736,5110301,1082004,0,1,1,0,800),(3737,5110301,1040096,0,1,1,0,800),(3738,5110301,1060085,0,1,1,0,800),(3739,5110301,1050052,0,1,1,0,800),(3740,5110301,1040087,0,1,1,0,800),(3741,5110301,1060076,0,1,1,0,800),(3742,5110301,1040091,0,1,1,0,800),(3743,5110301,1060080,0,1,1,0,800),(3744,5110301,4000364,0,1,1,0,600000),(3745,5110301,1492008,0,1,1,0,800),(3746,5110301,2040323,0,1,1,0,100),(3747,5110301,2040422,0,1,1,0,100),(3748,5110301,2043017,0,1,1,0,100),(3749,5110301,4130001,0,1,1,0,6000),(3750,5110301,4130005,0,1,1,0,6000),(3751,5110301,4130006,0,1,1,0,6000),(3752,5110302,2000003,0,1,1,0,20000),(3753,5110302,2000002,0,1,1,0,20000),(3754,5110302,2000004,0,1,1,0,20000),(3756,5110302,1082066,0,1,1,0,800),(3757,5110302,1072146,0,1,1,0,800),(3758,5110302,1041077,0,1,1,0,800),(3759,5110302,1061076,0,1,1,0,800),(3760,5110302,1051037,0,1,1,0,800),(3761,5110302,1002029,0,1,1,0,800),(3762,5110302,1002248,0,1,1,0,800),(3763,5110302,1002269,0,1,1,0,800),(3764,5110302,2040804,0,1,1,0,100),(3765,5110302,2040901,0,1,1,0,100),(3766,5110302,4000365,0,1,1,0,600000),(3767,5110302,1082201,0,1,1,0,800),(3768,5110302,2040413,0,1,1,0,100),(3769,5110302,2040923,0,1,1,0,100),(3770,5110302,2044114,0,1,1,0,100),(3771,5110302,4130008,0,1,1,0,6000),(3772,5110302,4130009,0,1,1,0,6000),(3773,5120000,4000061,0,1,1,0,600000),(3774,5120000,4003005,0,1,1,0,200000),(3775,5120000,2041017,0,1,1,0,100),(3777,5120000,2000002,0,1,1,0,20000),(3778,5120000,2000004,0,1,1,0,20000),(3779,5120000,2000003,0,1,1,0,20000),(3783,5120000,1092007,0,1,1,0,800),(3784,5120000,2070002,0,1,1,0,500),(3785,5120000,4006001,0,1,1,0,10000),(3786,5120000,2040504,0,1,1,0,100),(3787,5120000,1002185,0,1,1,0,800),(3788,5120000,1060070,0,1,1,0,800),(3789,5120000,1040081,0,1,1,0,800),(3790,5120000,1422007,0,1,1,0,800),(3791,5120000,1051033,0,1,1,0,800),(3792,5120000,1002086,0,1,1,0,800),(3793,5120000,1040088,0,1,1,0,800),(3794,5120000,1060077,0,1,1,0,800),(3795,5120000,1072134,0,1,1,0,800),(3796,5120000,1072128,0,1,1,0,800),(3797,5120000,1072144,0,1,1,0,800),(3798,5120000,1082086,0,1,1,0,800),(3799,5120000,1082201,0,1,1,0,800),(3800,5120000,2330002,0,1,1,0,100),(3801,5120000,2040324,0,1,1,0,100),(3802,5120000,2040423,0,1,1,0,100),(3803,5120000,2043017,0,1,1,0,100),(3804,5120000,4130010,0,1,1,0,6000),(3805,5120001,4000070,0,1,1,0,600000),(3806,5120001,4003005,0,1,1,0,200000),(3807,5120001,2000002,0,1,1,0,20000),(3808,5120001,2000004,0,1,1,0,20000),(3809,5120001,2000003,0,1,1,0,20000),(3813,5120001,4006000,0,1,1,0,10000),(3814,5120001,2041012,0,1,1,0,100),(3815,5120001,2043002,0,1,1,0,100),(3816,5120001,1072115,0,1,1,0,800),(3817,5120001,1072126,0,1,1,0,800),(3818,5120001,1082074,0,1,1,0,800),(3819,5120001,1402007,0,1,1,0,800),(3820,5120001,1002028,0,1,1,0,800),(3821,5120001,1032013,0,1,1,0,800),(3822,5120001,1040094,0,1,1,0,800),(3823,5120001,1060083,0,1,1,0,800),(3824,5120001,1041089,0,1,1,0,800),(3825,5120001,1061088,0,1,1,0,800),(3826,5120001,1050054,0,1,1,0,800),(3827,5120001,1050058,0,1,1,0,800),(3828,5120001,1072306,0,1,1,0,800),(3829,5120001,2331000,0,1,1,0,500),(3830,5120001,2040933,0,1,1,0,100),(3831,5120001,2044212,0,1,1,0,100),(3832,5120001,4130000,0,1,1,0,6000),(3833,5120001,4130008,0,1,1,0,6000),(3834,5120001,4130009,0,1,1,0,6000),(3835,5120002,4000071,0,1,1,0,600000),(3836,5120002,4003005,0,1,1,0,200000),(3837,5120002,2000002,0,1,1,0,20000),(3838,5120002,2000004,0,1,1,0,20000),(3839,5120002,2000003,0,1,1,0,20000),(3843,5120002,4006001,0,1,1,0,10000),(3844,5120002,2041017,0,1,1,0,100),(3845,5120002,2044001,0,1,1,0,100),(3846,5120002,1312007,0,1,1,0,800),(3847,5120002,1040084,0,1,1,0,800),(3848,5120002,1060073,0,1,1,0,800),(3849,5120002,1002045,0,1,1,0,800),(3850,5120002,1002024,0,1,1,0,800),(3851,5120002,1302010,0,1,1,0,800),(3852,5120002,1082009,0,1,1,0,800),(3853,5120002,1082081,0,1,1,0,800),(3854,5120002,1072123,0,1,1,0,800),(3855,5120002,1072131,0,1,1,0,800),(3856,5120002,1051041,0,1,1,0,800),(3857,5120002,1002267,0,1,1,0,800),(3858,5120002,1002631,0,1,1,0,800),(3859,5120002,2330002,0,1,1,0,100),(3860,5120002,2044212,0,1,1,0,100),(3861,5120002,2049100,0,1,1,0,150),(3862,5120002,4130002,0,1,1,0,6000),(3863,5120002,4130014,0,1,1,0,6000),(3864,5120003,4000072,0,1,1,0,600000),(3865,5120003,4003005,0,1,1,0,200000),(3866,5120003,2000002,0,1,1,0,20000),(3867,5120003,2000004,0,1,1,0,20000),(3868,5120003,2000003,0,1,1,0,20000),(3872,5120003,4006000,0,1,1,0,10000),(3873,5120003,2041023,0,1,1,0,100),(3874,5120003,1032019,0,1,1,0,800),(3875,5120003,2070004,0,1,1,0,300),(3876,5120003,2070010,0,1,1,0,500),(3877,5120003,1002153,0,1,1,0,800),(3878,5120003,1002181,0,1,1,0,800),(3879,5120003,1032011,0,1,1,0,800),(3880,5120003,1041085,0,1,1,0,800),(3881,5120003,1061084,0,1,1,0,800),(3882,5120003,1051034,0,1,1,0,800),(3883,5120003,1061077,0,1,1,0,800),(3884,5120003,1041078,0,1,1,0,800),(3885,5120003,1050052,0,1,1,0,800),(3886,5120003,1072135,0,1,1,0,800),(3887,5120003,1082082,0,1,1,0,800),(3888,5120003,1332015,0,1,1,0,800),(3889,5120003,1322018,0,1,1,0,800),(3890,5120003,1002634,0,1,1,0,800),(3891,5120003,2332000,0,1,1,0,500),(3892,5120003,2040323,0,1,1,0,100),(3893,5120003,2040924,0,1,1,0,100),(3894,5120003,4130005,0,1,1,0,6000),(3895,5120003,4130012,0,1,1,0,6000),(3896,5120100,4000126,0,1,1,0,600000),(3897,5120100,2060000,0,1,1,0,300000),(3898,5120100,2061000,0,1,1,0,300000),(3899,5120100,2000002,0,1,1,0,200000),(3900,5120100,2000004,0,1,1,0,999999),(3901,5120100,2002010,0,1,1,0,200000),(3902,5120100,1032014,0,1,1,0,10000),(3907,5120100,4011007,0,1,1,0,90000),(3908,5120100,2044602,0,1,1,0,1500),(3909,5120100,1041082,0,1,1,0,8000),(3910,5120100,1061081,0,1,1,0,8000),(3911,5120100,1002154,0,1,1,0,15000),(3912,5120100,1082010,0,1,1,0,10000),(3913,5120100,1082067,0,1,1,0,10000),(3914,5120100,1072142,0,1,1,0,8000),(3915,5120100,1040096,0,1,1,0,8000),(3916,5120100,1060085,0,1,1,0,8000),(3917,5120100,1002211,0,1,1,0,15000),(3918,5120100,1402011,0,1,1,0,7000),(3919,5120100,1092010,0,1,1,0,7000),(3920,5120100,1412007,0,1,1,0,7000),(3921,5120100,2043017,0,1,1,0,1500),(3922,5120100,4130004,0,1,1,0,60000),(3923,5120100,4130013,0,1,1,0,60000),(3924,5120500,4000283,0,1,1,0,600000),(3925,5120500,4000284,0,1,1,0,600000),(3926,5120500,4000021,0,1,1,0,50000),(3927,5120500,4003005,0,1,1,0,200000),(3929,5120500,2000003,0,1,1,0,20000),(3930,5120500,2000002,0,1,1,0,20000),(3933,5120500,1032021,0,1,1,0,800),(3934,5120500,1072134,0,1,1,0,800),(3935,5120500,1082066,0,1,1,0,800),(3936,5120500,1050058,0,1,1,0,800),(3937,5120500,1082081,0,1,1,0,800),(3938,5120500,1040099,0,1,1,0,800),(3939,5120500,1060088,0,1,1,0,800),(3941,5120500,2043801,0,1,1,0,100),(3942,5120500,1432006,0,1,1,0,800),(3943,5120500,2043701,0,1,1,0,100),(3944,5120500,1082201,0,1,1,0,800),(3945,5120500,2330002,0,1,1,0,100),(3946,5120500,2040031,0,1,1,0,100),(3947,5120500,2040515,0,1,1,0,100),(3948,5120500,2049100,0,1,1,0,150),(3949,5120500,4130000,0,1,1,0,6000),(3950,5120500,4130009,0,1,1,0,6000),(3951,5120501,4000293,0,1,1,0,600000),(3952,5120501,2000002,0,1,1,0,20000),(3953,5120501,2000003,0,1,1,0,20000),(3957,5120501,4006000,0,1,1,0,10000),(3958,5120501,2041023,0,1,1,0,100),(3959,5120501,1050052,0,1,1,0,800),(3960,5120501,1051037,0,1,1,0,800),(3961,5120501,1032019,0,1,1,0,800),(3962,5120501,1040102,0,1,1,0,800),(3963,5120501,1060090,0,1,1,0,800),(3964,5120501,1051041,0,1,1,0,800),(3965,5120501,1482008,0,1,1,0,800),(3966,5120501,2040423,0,1,1,0,100),(3967,5120501,2044310,0,1,1,0,100),(3968,5120501,4130016,0,1,1,0,6000),(3969,5120501,4130017,0,1,1,0,6000),(3970,5120502,4000294,0,1,1,0,600000),(3972,5120502,2000002,0,1,1,0,20000),(3973,5120502,2000003,0,1,1,0,20000),(3975,5120502,1002159,0,1,1,0,800),(3976,5120502,1040057,0,1,1,0,800),(3977,5120502,1082004,0,1,1,0,800),(3978,5120502,1040096,0,1,1,0,800),(3979,5120502,1060085,0,1,1,0,800),(3980,5120502,1050052,0,1,1,0,800),(3981,5120502,1040087,0,1,1,0,800),(3982,5120502,1060076,0,1,1,0,800),(3983,5120502,4006000,0,1,1,0,10000),(3984,5120502,1040091,0,1,1,0,800),(3985,5120502,1060080,0,1,1,0,800),(3986,5120502,1052116,0,1,1,0,800),(3987,5120502,2040413,0,1,1,0,100),(3988,5120502,2040927,0,1,1,0,100),(3989,5120502,4130000,0,1,1,0,6000),(3990,5120502,4130003,0,1,1,0,6000),(3991,5120502,4130005,0,1,1,0,6000),(3992,5120503,4000286,0,1,1,0,600000),(3993,5120503,2000002,0,1,1,0,20000),(3994,5120503,2000003,0,1,1,0,20000),(3997,5120503,1332011,0,1,1,0,800),(3998,5120503,1072118,0,1,1,0,800),(3999,5120503,1051038,0,1,1,0,800),(4000,5120503,2040901,0,1,1,0,100),(4001,5120503,2002003,0,1,1,0,20000),(4002,5120503,2044602,0,1,1,0,100),(4003,5120503,1041088,0,1,1,0,800),(4004,5120503,1060077,0,1,1,0,800),(4005,5120503,1312008,0,1,1,0,800),(4006,5120503,1072303,0,1,1,0,800),(4007,5120503,2040026,0,1,1,0,100),(4008,5120503,2040422,0,1,1,0,100),(4009,5120503,2040925,0,1,1,0,100),(4010,5120503,2040927,0,1,1,0,100),(4011,5120503,4130002,0,1,1,0,6000),(4012,5120503,4130010,0,1,1,0,6000),(4013,5120503,4130013,0,1,1,0,6000),(4014,5120504,4000287,0,1,1,0,600000),(4015,5120504,2000002,0,1,1,0,20000),(4016,5120504,2000003,0,1,1,0,20000),(4020,5120504,1002215,0,1,1,0,800),(4021,5120504,1040097,0,1,1,0,800),(4022,5120504,1060086,0,1,1,0,800),(4023,5120504,1092007,0,1,1,0,800),(4024,5120504,1072072,0,1,1,0,800),(4025,5120504,1040105,0,1,1,0,800),(4026,5120504,1060093,0,1,1,0,800),(4027,5120504,4006001,0,1,1,0,10000),(4028,5120504,2040504,0,1,1,0,100),(4029,5120504,1002634,0,1,1,0,800),(4030,5120504,2330002,0,1,1,0,100),(4031,5120504,2040619,0,1,1,0,100),(4032,5120504,2040825,0,1,1,0,100),(4033,5120504,2040931,0,1,1,0,100),(4034,5120504,4130007,0,1,1,0,6000),(4035,5120504,4130012,0,1,1,0,6000),(4036,5120505,4000021,0,1,1,0,50000),(4037,5120505,4003005,0,1,1,0,200000),(4038,5120505,2000003,0,1,1,0,20000),(4039,5120505,2000002,0,1,1,0,20000),(4040,5120505,2000004,0,1,1,0,20000),(4042,5120505,1082066,0,1,1,0,800),(4043,5120505,1072146,0,1,1,0,800),(4044,5120505,1041077,0,1,1,0,800),(4045,5120505,1061076,0,1,1,0,800),(4046,5120505,1051037,0,1,1,0,800),(4047,5120505,1002029,0,1,1,0,800),(4048,5120505,1002248,0,1,1,0,800),(4049,5120505,1002269,0,1,1,0,800),(4050,5120505,4000288,0,1,1,0,600000),(4051,5120505,2040804,0,1,1,0,100),(4052,5120505,2040901,0,1,1,0,100),(4053,5120505,1052119,0,1,1,0,800),(4054,5120505,2040421,0,1,1,0,100),(4055,5120505,2040534,0,1,1,0,100),(4056,5120505,2040928,0,1,1,0,100),(4057,5120505,2049000,0,1,1,0,150),(4058,5120505,4130004,0,1,1,0,6000),(4059,5120505,4130008,0,1,1,0,6000),(4060,5120505,4130009,0,1,1,0,6000),(4061,5120506,4000298,0,1,1,0,600000),(4062,5120506,2000002,0,1,1,0,20000),(4063,5120506,2000003,0,1,1,0,20000),(4066,5120506,1002168,0,1,1,0,800),(4067,5120506,1002092,0,1,1,0,800),(4068,5120506,1040086,0,1,1,0,800),(4069,5120506,1072127,0,1,1,0,800),(4070,5120506,1402006,0,1,1,0,800),(4071,5120506,2044201,0,1,1,0,100),(4072,5120506,1040095,0,1,1,0,800),(4073,5120506,1060084,0,1,1,0,800),(4074,5120506,1452004,0,1,1,0,800),(4075,5120506,1412007,0,1,1,0,800),(4076,5120506,1050059,0,1,1,0,800),(4077,5120506,1442010,0,1,1,0,800),(4078,5120506,4000299,0,1,1,0,600000),(4079,5120506,1492007,0,1,1,0,800),(4080,5120506,2330002,0,1,1,0,100),(4081,5120506,2040317,0,1,1,0,100),(4082,5120506,2040617,0,1,1,0,100),(4083,5120506,2040825,0,1,1,0,100),(4084,5120506,2040927,0,1,1,0,100),(4085,5120506,4130006,0,1,1,0,6000),(4086,5120506,4130014,0,1,1,0,6000),(4087,5130100,4000014,0,1,1,0,600000),(4088,5130100,2000002,0,1,1,0,20000),(4089,5130100,2002004,0,1,1,0,20000),(4090,5130100,2012000,0,1,1,0,20000),(4091,5130100,2012003,0,1,1,0,20000),(4094,5130100,4000030,0,1,1,0,60000),(4095,5130100,2000004,0,1,1,0,20000),(4096,5130100,2070003,0,1,1,0,400),(4097,5130100,1452007,0,1,1,0,800),(4098,5130100,1432005,0,1,1,0,800),(4099,5130100,1072108,0,1,1,0,800),(4100,5130100,1072116,0,1,1,0,800),(4101,5130100,1412005,0,1,1,0,800),(4102,5130100,1051030,0,1,1,0,800),(4103,5130100,1051037,0,1,1,0,800),(4104,5130100,1040089,0,1,1,0,800),(4105,5130100,1060078,0,1,1,0,800),(4106,5130100,1041077,0,1,1,0,800),(4107,5130100,1061076,0,1,1,0,800),(4108,5130100,1082083,0,1,1,0,800),(4109,5130100,1382006,0,1,1,0,800),(4110,5130100,1092008,0,1,1,0,800),(4111,5130100,1462004,0,1,1,0,800),(4112,5130100,2002001,0,1,1,0,20000),(4114,5130100,1002631,0,1,1,0,800),(4115,5130100,2040422,0,1,1,0,100),(4116,5130100,4130004,0,1,1,0,6000),(4117,5130100,4130009,0,1,1,0,6000),(4118,5130100,4130015,0,1,1,0,6000),(4119,5130101,4000022,0,1,1,0,600000),(4121,5130101,2000004,0,1,1,0,20000),(4122,5130101,1092002,0,1,1,0,800),(4123,5130101,2000003,0,1,1,0,20000),(4124,5130101,2044501,0,1,1,0,100),(4125,5130101,2044601,0,1,1,0,100),(4126,5130101,1372012,0,1,1,0,800),(4127,5130101,1082025,0,1,1,0,800),(4128,5130101,1082076,0,1,1,0,800),(4129,5130101,1072121,0,1,1,0,800),(4130,5130101,1072143,0,1,1,0,800),(4131,5130101,1041080,0,1,1,0,800),(4132,5130101,1061079,0,1,1,0,800),(4133,5130101,1002086,0,1,1,0,800),(4134,5130101,1050048,0,1,1,0,800),(4135,5130101,1002247,0,1,1,0,800),(4136,5130101,1041091,0,1,1,0,800),(4137,5130101,1061090,0,1,1,0,800),(4138,5130101,1312009,0,1,1,0,800),(4139,5130101,1452005,0,1,1,0,800),(4140,5130101,1032002,0,1,1,0,800),(4141,5130101,2070003,0,1,1,0,400),(4142,5130101,2000006,0,1,1,0,20000),(4143,5130101,1040084,0,1,1,0,800),(4144,5130101,1072303,0,1,1,0,800),(4145,5130101,4130010,0,1,1,0,6000),(4146,5130101,4130013,0,1,1,0,6000),(4147,5130102,1050039,0,1,1,0,800),(4148,5130102,4000025,0,1,1,0,600000),(4150,5130102,2000003,0,1,1,0,20000),(4151,5130102,2000004,0,1,1,0,20000),(4153,5130102,2070004,0,1,1,0,300),(4154,5130102,2044201,0,1,1,0,100),(4155,5130102,1040085,0,1,1,0,800),(4156,5130102,1060074,0,1,1,0,800),(4157,5130102,1061069,0,1,1,0,800),(4158,5130102,1041074,0,1,1,0,800),(4159,5130102,1072120,0,1,1,0,800),(4160,5130102,1002209,0,1,1,0,800),(4161,5130102,1002214,0,1,1,0,800),(4162,5130102,1082009,0,1,1,0,800),(4163,5130102,1002022,0,1,1,0,800),(4164,5130102,1032021,0,1,1,0,800),(4165,5130102,1082088,0,1,1,0,800),(4166,5130102,1072139,0,1,1,0,800),(4167,5130102,1102018,0,1,1,0,800),(4168,5130102,1002249,0,1,1,0,800),(4169,5130102,1040091,0,1,1,0,800),(4170,5130102,1060080,0,1,1,0,800),(4171,5130102,1050059,0,1,1,0,800),(4172,5130102,1382007,0,1,1,0,800),(4173,5130102,1492008,0,1,1,0,800),(4174,5130102,2044802,0,1,1,0,100),(4175,5130102,2040413,0,1,1,0,100),(4176,5130102,2040618,0,1,1,0,100),(4177,5130102,4130000,0,1,1,0,6000),(4178,5130102,4130016,0,1,1,0,6000),(4179,5130102,4130017,0,1,1,0,6000),(4180,5130103,4000033,0,1,1,0,600000),(4181,5130103,2000002,0,1,1,0,20000),(4182,5130103,2000004,0,1,1,0,20000),(4183,5130103,2000003,0,1,1,0,20000),(4187,5130103,1332031,0,1,1,0,800),(4188,5130103,1382019,0,1,1,0,800),(4189,5130103,1050046,0,1,1,0,800),(4190,5130103,1002218,0,1,1,0,800),(4191,5130103,1002210,0,1,1,0,800),(4192,5130103,1051038,0,1,1,0,800),(4193,5130103,1041079,0,1,1,0,800),(4194,5130103,1061078,0,1,1,0,800),(4195,5130103,1040098,0,1,1,0,800),(4196,5130103,1060087,0,1,1,0,800),(4197,5130103,1092009,0,1,1,0,800),(4198,5130103,1082092,0,1,1,0,800),(4199,5130103,1052119,0,1,1,0,800),(4200,5130103,2044801,0,1,1,0,100),(4201,5130103,2040027,0,1,1,0,100),(4202,5130103,2043212,0,1,1,0,100),(4203,5130103,2044212,0,1,1,0,100),(4204,5130103,4130007,0,1,1,0,6000),(4205,5130103,4130011,0,1,1,0,6000),(4206,5130104,4000051,0,1,1,0,600000),(4207,5130104,4003004,0,1,1,0,200000),(4208,5130104,2041019,0,1,1,0,100),(4209,5130104,4000021,0,1,1,0,50000),(4210,5130104,2000003,0,1,1,0,20000),(4211,5130104,2000004,0,1,1,0,20000),(4214,5130104,2070003,0,1,1,0,400),(4215,5130104,2060000,0,1,1,0,30000),(4216,5130104,2061000,0,1,1,0,30000),(4218,5130104,1102000,0,1,1,0,800),(4219,5130104,1082064,0,1,1,0,800),(4220,5130104,1082075,0,1,1,0,800),(4221,5130104,1072119,0,1,1,0,800),(4222,5130104,1072127,0,1,1,0,800),(4223,5130104,1002213,0,1,1,0,800),(4224,5130104,1002215,0,1,1,0,800),(4225,5130104,1040097,0,1,1,0,800),(4226,5130104,1060086,0,1,1,0,800),(4227,5130104,1050052,0,1,1,0,800),(4228,5130104,1332017,0,1,1,0,800),(4229,5130104,1422009,0,1,1,0,800),(4230,5130104,1462008,0,1,1,0,800),(4231,5130104,1482007,0,1,1,0,800),(4232,5130104,2040326,0,1,1,0,100),(4233,5130104,2044110,0,1,1,0,100),(4234,5130104,2044809,0,1,1,0,100),(4235,5130104,4130002,0,1,1,0,6000),(4236,5130104,4130015,0,1,1,0,6000),(4237,5130104,4130017,0,1,1,0,6000),(4238,5130105,4000055,0,1,1,0,600000),(4239,5130105,4003004,0,1,1,0,200000),(4241,5130105,4000021,0,1,1,0,50000),(4242,5130105,2000003,0,1,1,0,20000),(4243,5130105,2000004,0,1,1,0,20000),(4247,5130105,2043701,0,1,1,0,100),(4248,5130105,1041086,0,1,1,0,800),(4249,5130105,1061085,0,1,1,0,800),(4250,5130105,1041082,0,1,1,0,800),(4251,5130105,1061081,0,1,1,0,800),(4252,5130105,1002208,0,1,1,0,800),(4253,5130105,1002216,0,1,1,0,800),(4254,5130105,1032021,0,1,1,0,800),(4255,5130105,1382006,0,1,1,0,800),(4256,5130105,1102015,0,1,1,0,800),(4257,5130105,1072151,0,1,1,0,800),(4258,5130105,1072138,0,1,1,0,800),(4259,5130105,1082059,0,1,1,0,800),(4260,5130105,1082090,0,1,1,0,800),(4261,5130105,1092010,0,1,1,0,800),(4262,5130105,1040102,0,1,1,0,800),(4263,5130105,1060090,0,1,1,0,800),(4264,5130105,2040027,0,1,1,0,100),(4265,5130105,2040317,0,1,1,0,100),(4266,5130105,2044112,0,1,1,0,100),(4267,5130105,4130007,0,1,1,0,6000),(4268,5130105,4130017,0,1,1,0,6000),(4269,5130107,4000069,0,1,1,0,600000),(4270,5130107,2000003,0,1,1,0,20000),(4271,5130107,2000004,0,1,1,0,20000),(4272,5130107,2000002,0,1,1,0,20000),(4276,5130107,1082062,0,1,1,0,800),(4277,5130107,1082071,0,1,1,0,800),(4278,5130107,1072109,0,1,1,0,800),(4279,5130107,1072117,0,1,1,0,800),(4280,5130107,1322016,0,1,1,0,800),(4281,5130107,1312008,0,1,1,0,800),(4282,5130107,1051039,0,1,1,0,800),(4283,5130107,1040094,0,1,1,0,800),(4284,5130107,1060083,0,1,1,0,800),(4285,5130107,1032019,0,1,1,0,800),(4286,5130107,1002244,0,1,1,0,800),(4287,5130107,1102016,0,1,1,0,800),(4288,5130107,1040092,0,1,1,0,800),(4289,5130107,1060081,0,1,1,0,800),(4290,5130107,1002269,0,1,1,0,800),(4291,5130107,1002247,0,1,1,0,800),(4292,5130107,1040105,0,1,1,0,800),(4293,5130107,1060093,0,1,1,0,800),(4294,5130107,1482008,0,1,1,0,800),(4295,5130107,2040026,0,1,1,0,100),(4296,5130107,2040515,0,1,1,0,100),(4297,5130107,4130001,0,1,1,0,6000),(4298,5130107,4130006,0,1,1,0,6000),(4299,5130107,4130011,0,1,1,0,6000),(4300,5130108,4000069,0,1,1,0,600000),(4301,5130108,4000082,0,1,1,0,40000),(4302,5130108,2000003,0,1,1,0,20000),(4303,5130108,2000004,0,1,1,0,20000),(4304,5130108,2000002,0,1,1,0,20000),(4308,5130108,2040402,0,1,1,0,100),(4309,5130108,1002169,0,1,1,0,800),(4310,5130108,1002155,0,1,1,0,800),(4311,5130108,1041084,0,1,1,0,800),(4312,5130108,1061083,0,1,1,0,800),(4313,5130108,1332011,0,1,1,0,800),(4314,5130108,1032018,0,1,1,0,800),(4315,5130108,1072130,0,1,1,0,800),(4316,5130108,1072133,0,1,1,0,800),(4317,5130108,1072141,0,1,1,0,800),(4318,5130108,1051046,0,1,1,0,800),(4319,5130108,1102017,0,1,1,0,800),(4320,5130108,1051043,0,1,1,0,800),(4321,5130108,1092011,0,1,1,0,800),(4322,5130108,1082094,0,1,1,0,800),(4323,5130108,1002084,0,1,1,0,800),(4324,5130108,1002243,0,1,1,0,800),(4325,5130108,1041100,0,1,1,0,800),(4326,5130108,1061099,0,1,1,0,800),(4327,5130108,2040029,0,1,1,0,100),(4328,5130108,2040419,0,1,1,0,100),(4329,5130108,4130002,0,1,1,0,6000),(4330,5130108,4130014,0,1,1,0,6000),(4331,5130108,4130015,0,1,1,0,6000),(4332,5140000,4000052,0,1,1,0,600000),(4333,5140000,4003005,0,1,1,0,200000),(4334,5140000,4000021,0,1,1,0,50000),(4335,5140000,2000003,0,1,1,0,20000),(4336,5140000,2000004,0,1,1,0,20000),(4337,5140000,2070004,0,1,1,0,300),(4340,5140000,2060000,0,1,1,0,30000),(4341,5140000,2040901,0,1,1,0,100),(4343,5140000,4006001,0,1,1,0,10000),(4344,5140000,2061000,0,1,1,0,30000),(4345,5140000,1422008,0,1,1,0,800),(4346,5140000,1472014,0,1,1,0,800),(4347,5140000,1082072,0,1,1,0,800),(4348,5140000,1072114,0,1,1,0,800),(4349,5140000,1072127,0,1,1,0,800),(4350,5140000,1082066,0,1,1,0,800),(4351,5140000,1072134,0,1,1,0,800),(4352,5140000,1050051,0,1,1,0,800),(4353,5140000,1041077,0,1,1,0,800),(4354,5140000,1061076,0,1,1,0,800),(4355,5140000,1050053,0,1,1,0,800),(4356,5140000,1032014,0,1,1,0,800),(4357,5140000,1412007,0,1,1,0,800),(4358,5140000,1050059,0,1,1,0,800),(4359,5140000,1002029,0,1,1,0,800),(4360,5140000,1072151,0,1,1,0,800),(4361,5140000,1102021,0,1,1,0,800),(4362,5140000,1041097,0,1,1,0,800),(4363,5140000,1061096,0,1,1,0,800),(4364,5140000,1002634,0,1,1,0,800),(4365,5140000,2040024,0,1,1,0,100),(4366,5140000,2044214,0,1,1,0,100),(4367,5140000,4130001,0,1,1,0,6000),(4368,5140000,4130003,0,1,1,0,6000),(4369,5140000,4130013,0,1,1,0,6000),(4370,5150000,4000177,0,1,1,0,600000),(4371,5150000,2060000,0,1,1,0,30000),(4372,5150000,2061000,0,1,1,0,30000),(4373,5150000,1082066,0,1,1,0,800),(4374,5150000,1072146,0,1,1,0,800),(4375,5150000,1082087,0,1,1,0,800),(4377,5150000,2000004,0,1,1,0,20000),(4378,5150000,1041077,0,1,1,0,800),(4379,5150000,1061076,0,1,1,0,800),(4380,5150000,2000003,0,1,1,0,20000),(4381,5150000,2000002,0,1,1,0,20000),(4382,5150000,1051037,0,1,1,0,800),(4383,5150000,1041094,0,1,1,0,800),(4384,5150000,1061093,0,1,1,0,800),(4385,5150000,1040092,0,1,1,0,800),(4386,5150000,1060081,0,1,1,0,800),(4387,5150000,2040804,0,1,1,0,100),(4388,5150000,2040901,0,1,1,0,100),(4389,5150000,1002029,0,1,1,0,800),(4390,5150000,1002248,0,1,1,0,800),(4391,5150000,1002269,0,1,1,0,800),(4392,5150000,1372014,0,1,1,0,800),(4393,5150000,1072306,0,1,1,0,800),(4394,5150000,2040824,0,1,1,0,100),(4395,5150000,2040928,0,1,1,0,100),(4396,5150000,4130005,0,1,1,0,6000),(4397,5150000,4130007,0,1,1,0,6000),(4398,5150001,4000206,0,1,1,0,600000),(4399,5150001,2000003,0,1,1,0,20000),(4400,5150001,2000004,0,1,1,0,20000),(4403,5150001,1072122,0,1,1,0,800),(4404,5150001,1072132,0,1,1,0,800),(4405,5150001,1072140,0,1,1,0,800),(4406,5150001,1072128,0,1,1,0,800),(4407,5150001,2043801,0,1,1,0,100),(4408,5150001,1040092,0,1,1,0,800),(4409,5150001,1060081,0,1,1,0,800),(4410,5150001,1040098,0,1,1,0,800),(4411,5150001,1060087,0,1,1,0,800),(4412,5150001,1050059,0,1,1,0,800),(4413,5150001,1051045,0,1,1,0,800),(4414,5150001,1002030,0,1,1,0,800),(4415,5150001,1002252,0,1,1,0,800),(4416,5150001,1002281,0,1,1,0,800),(4417,5150001,1002287,0,1,1,0,800),(4418,5150001,2044701,0,1,1,0,100),(4419,5150001,2043701,0,1,1,0,100),(4420,5150001,1072306,0,1,1,0,800),(4421,5150001,2043210,0,1,1,0,100),(4422,5150001,2044312,0,1,1,0,100),(4423,5150001,4130003,0,1,1,0,6000),(4424,5150001,4130010,0,1,1,0,6000),(4425,5200000,4000083,0,1,1,0,600000),(4429,5200000,2044102,0,1,1,0,100),(4430,5200000,2000001,0,1,1,0,20000),(4431,5200000,2000003,0,1,1,0,20000),(4432,5200000,1002129,0,1,1,0,800),(4433,5200000,1322002,0,1,1,0,800),(4434,5200000,1322004,0,1,1,0,800),(4435,5200000,1040016,0,1,1,0,800),(4436,5200000,1060011,0,1,1,0,800),(4437,5200000,1041048,0,1,1,0,800),(4438,5200000,1061044,0,1,1,0,800),(4439,5200000,2070000,0,1,1,0,500),(4440,5200000,2060001,0,1,1,0,30000),(4441,5200000,2061001,0,1,1,0,30000),(4442,5200000,1482002,0,1,1,0,800),(4443,5200000,2044212,0,1,1,0,100),(4444,5200001,4000084,0,1,1,0,600000),(4448,5200001,4006000,0,1,1,0,10000),(4449,5200001,2041016,0,1,1,0,100),(4450,5200001,2000001,0,1,1,0,20000),(4451,5200001,2000003,0,1,1,0,20000),(4452,5200001,1002142,0,1,1,0,800),(4453,5200001,1040024,0,1,1,0,800),(4454,5200001,1062006,0,1,1,0,800),(4455,5200001,1322009,0,1,1,0,800),(4456,5200001,1061043,0,1,1,0,800),(4457,5200001,1041047,0,1,1,0,800),(4458,5200001,1442003,0,1,1,0,800),(4459,5200001,1050026,0,1,1,0,800),(4460,5200001,2060001,0,1,1,0,30000),(4461,5200001,2061001,0,1,1,0,30000),(4462,5200001,2049000,0,1,1,0,150),(4463,5200002,4000085,0,1,1,0,600000),(4467,5200002,4006000,0,1,1,0,10000),(4468,5200002,2040805,0,1,1,0,100),(4469,5200002,2000001,0,1,1,0,20000),(4470,5200002,2000003,0,1,1,0,20000),(4471,5200002,1082052,0,1,1,0,800),(4472,5200002,1041059,0,1,1,0,800),(4473,5200002,1061055,0,1,1,0,800),(4474,5200002,1041054,0,1,1,0,800),(4475,5200002,1061050,0,1,1,0,800),(4476,5200002,1032009,0,1,1,0,800),(4477,5200002,1041064,0,1,1,0,800),(4478,5200002,1072089,0,1,1,0,800),(4479,5200002,1452006,0,1,1,0,800),(4480,5200002,1050000,0,1,1,0,800),(4481,5200002,2060001,0,1,1,0,30000),(4482,5200002,2061001,0,1,1,0,30000),(4483,5200002,2040926,0,1,1,0,100),(4484,5220000,4000043,0,1,1,0,600000),(4485,5220000,4000043,0,1,1,0,600000),(4486,5220000,4000043,0,1,1,0,600000),(4487,5220000,4000044,0,1,1,0,600000),(4488,5220000,4000044,0,1,1,0,600000),(4489,5220000,4000044,0,1,1,0,600000),(4492,5220000,2000002,0,1,1,0,200000),(4493,5220000,2000003,0,1,1,0,200000),(4494,5220000,2001001,0,1,1,0,200000),(4495,5220000,2002000,0,1,1,0,200000),(4496,5220000,2041022,0,1,1,0,1500),(4497,5220000,2044601,0,1,1,0,1500),(4498,5220000,2041013,0,1,1,0,1500),(4499,5220000,2044701,0,1,1,0,1500),(4500,5220000,2048001,0,1,1,0,1500),(4501,5220000,2040707,0,1,1,0,1500),(4502,5220000,2040004,0,1,1,0,1500),(4503,5220000,2040513,0,1,1,0,1500),(4504,5220000,2040704,0,1,1,0,1500),(4505,5220000,2040804,0,1,1,0,1000),(4506,5220000,2040702,0,1,1,0,1500),(4507,5220000,2040802,0,1,1,0,1500),(4508,5220000,2040902,0,1,1,0,1500),(4509,5220000,2041002,0,1,1,0,1500),(4510,5220000,2043002,0,1,1,0,1500),(4511,5220000,2060000,0,1,1,0,300000),(4512,5220000,2061000,0,1,1,0,300000),(4513,5220000,1002029,0,1,1,0,15000),(4514,5220000,1002246,0,1,1,0,15000),(4515,5220000,1002270,0,1,1,0,15000),(4516,5220000,1002249,0,1,1,0,15000),(4517,5220000,1040093,0,1,1,0,8000),(4518,5220000,1041092,0,1,1,0,8000),(4519,5220000,1050056,0,1,1,0,7000),(4520,5220000,1051047,0,1,1,0,7000),(4521,5220000,1050060,0,1,1,0,7000),(4522,5220000,1051041,0,1,1,0,7000),(4523,5220000,1040100,0,1,1,0,8000),(4524,5220000,1041095,0,1,1,0,8000),(4525,5220000,1082061,0,1,1,0,10000),(4526,5220000,1082088,0,1,1,0,10000),(4527,5220000,1082091,0,1,1,0,10000),(4528,5220000,1082094,0,1,1,0,10000),(4529,5220000,1072149,0,1,1,0,8000),(4530,5220000,1072136,0,1,1,0,8000),(4531,5220000,1072144,0,1,1,0,8000),(4532,5220000,1072152,0,1,1,0,8000),(4533,5220000,1002634,0,1,1,0,15000),(4534,5220000,1052119,0,1,1,0,7000),(4535,5220000,1082201,0,1,1,0,10000),(4536,5220000,1072306,0,1,1,0,8000),(4537,5220000,3010008,0,1,1,0,5000),(4538,5220002,4000029,0,1,1,0,600000),(4539,5220002,4000029,0,1,1,0,600000),(4540,5220002,4000029,0,1,1,0,600000),(4541,5220002,4000031,0,1,1,0,600000),(4542,5220002,4000031,0,1,1,0,600000),(4543,5220002,4000031,0,1,1,0,600000),(4544,5220002,4000021,0,1,1,0,500000),(4545,5220002,4000021,0,1,1,0,500000),(4546,5220002,4000021,0,1,1,0,500000),(4547,5220002,4000026,0,1,1,0,600000),(4548,5220002,4000026,0,1,1,0,600000),(4549,5220002,4000026,0,1,1,0,600000),(4552,5220002,2000002,0,1,1,0,200000),(4553,5220002,2000003,0,1,1,0,200000),(4554,5220002,2002002,0,1,1,0,200000),(4555,5220002,2002003,0,1,1,0,200000),(4556,5220002,2040301,0,1,1,0,1500),(4557,5220002,2040504,0,1,1,0,1500),(4558,5220002,2040707,0,1,1,0,1500),(4559,5220002,2040801,0,1,1,0,1500),(4560,5220002,2040901,0,1,1,0,1500),(4561,5220002,2041016,0,1,1,0,1500),(4562,5220002,2043801,0,1,1,0,1500),(4563,5220002,2044101,0,1,1,0,1500),(4564,5220002,2044601,0,1,1,0,1500),(4565,5220002,2044701,0,1,1,0,1500),(4566,5220002,2040514,0,1,1,0,1500),(4567,5220002,2041002,0,1,1,0,1500),(4568,5220002,2041017,0,1,1,0,1500),(4569,5220002,2043702,0,1,1,0,1500),(4570,5220002,2044302,0,1,1,0,1500),(4571,5220002,2060000,0,1,1,0,300000),(4572,5220002,2061000,0,1,1,0,300000),(4573,5220002,1302010,0,1,1,0,7000),(4574,5220002,1312008,0,1,1,0,7000),(4575,5220002,1322017,0,1,1,0,7000),(4576,5220002,1332003,0,1,1,0,5000),(4577,5220002,1372007,0,1,1,0,7000),(4578,5220002,1382006,0,1,1,0,7000),(4579,5220002,1402003,0,1,1,0,7000),(4580,5220002,1412003,0,1,1,0,7000),(4581,5220002,1422005,0,1,1,0,7000),(4582,5220002,1432004,0,1,1,0,5000),(4583,5220002,1442005,0,1,1,0,7000),(4584,5220002,1452008,0,1,1,0,5000),(4585,5220002,1462007,0,1,1,0,5000),(4586,5220002,1472021,0,1,1,0,5000),(4587,5220002,1482007,0,1,1,0,5000),(4588,5220002,1492007,0,1,1,0,5000),(4589,5220002,2044802,0,1,1,0,1500),(4590,5220002,2044901,0,1,1,0,1500),(4591,5220002,1432039,0,1,1,0,5000),(4592,5220002,2040931,0,1,1,0,1500),(4593,5220002,2040928,0,1,1,0,1500),(4594,5220003,4000113,0,1,1,0,600000),(4595,5220003,4000113,0,1,1,0,600000),(4596,5220003,4000113,0,1,1,0,600000),(4597,5220003,4000114,0,1,1,0,600000),(4598,5220003,4000114,0,1,1,0,600000),(4599,5220003,4000114,0,1,1,0,600000),(4600,5220003,4000115,0,1,1,0,600000),(4601,5220003,4000115,0,1,1,0,600000),(4602,5220003,4000115,0,1,1,0,600000),(4606,5220003,2000002,0,1,1,0,200000),(4607,5220003,2000003,0,1,1,0,200000),(4608,5220003,2002002,0,1,1,0,200000),(4609,5220003,2002003,0,1,1,0,200000),(4610,5220003,2040401,0,1,1,0,1500),(4611,5220003,2040516,0,1,1,0,1500),(4612,5220003,2040704,0,1,1,0,1500),(4613,5220003,2040804,0,1,1,0,1000),(4614,5220003,2041013,0,1,1,0,1500),(4615,5220003,2041016,0,1,1,0,1500),(4616,5220003,2043201,0,1,1,0,1500),(4617,5220003,2043701,0,1,1,0,1500),(4618,5220003,2044201,0,1,1,0,1500),(4619,5220003,2044301,0,1,1,0,1500),(4620,5220003,2040302,0,1,1,0,1500),(4621,5220003,2040502,0,1,1,0,1500),(4622,5220003,2041002,0,1,1,0,1500),(4623,5220003,2043802,0,1,1,0,1500),(4624,5220003,2044502,0,1,1,0,1500),(4625,5220003,2060000,0,1,1,0,300000),(4626,5220003,2061000,0,1,1,0,300000),(4627,5220003,1302011,0,1,1,0,7000),(4628,5220003,1312009,0,1,1,0,7000),(4629,5220003,1322018,0,1,1,0,7000),(4630,5220003,1332015,0,1,1,0,5000),(4631,5220003,1332017,0,1,1,0,5000),(4632,5220003,1372014,0,1,1,0,7000),(4633,5220003,1382007,0,1,1,0,7000),(4634,5220003,1402011,0,1,1,0,7000),(4635,5220003,1412007,0,1,1,0,7000),(4636,5220003,1422009,0,1,1,0,7000),(4637,5220003,1432006,0,1,1,0,5000),(4638,5220003,1442010,0,1,1,0,7000),(4639,5220003,1452004,0,1,1,0,5000),(4640,5220003,1462008,0,1,1,0,5000),(4641,5220003,1472025,0,1,1,0,5000),(4642,5220003,1482008,0,1,1,0,5000),(4643,5220003,1492008,0,1,1,0,5000),(4644,5220003,2044801,0,1,1,0,1500),(4645,5220003,2044902,0,1,1,0,1500),(4646,5220003,1372033,0,1,1,0,7000),(4647,5220003,2040627,0,1,1,0,1500),(4648,5220003,2040825,0,1,1,0,1500),(4649,5220003,2040933,0,1,1,0,1500),(4650,5220003,2044114,0,1,1,0,1500),(4651,5220003,2044807,0,1,1,0,1500),(4652,5220004,2040001,0,1,1,0,1500),(4653,5220004,2040004,0,1,1,0,1500),(4654,5220004,2040301,0,1,1,0,1500),(4655,5220004,2040401,0,1,1,0,1500),(4656,5220004,2040501,0,1,1,0,1500),(4657,5220004,2040504,0,1,1,0,1500),(4658,5220004,2040601,0,1,1,0,1500),(4659,5220004,2040701,0,1,1,0,1500),(4660,5220004,2040704,0,1,1,0,1500),(4661,5220004,2040707,0,1,1,0,1500),(4662,5220004,2040801,0,1,1,0,1500),(4663,5220004,2041001,0,1,1,0,1500),(4664,5220004,2041004,0,1,1,0,1500),(4665,5220004,2040804,0,1,1,0,1000),(4666,5220004,2040901,0,1,1,0,1500),(4667,5220004,2070005,0,1,1,0,3000),(4668,5220004,1102002,0,1,1,0,10000),(4669,5220004,1032013,0,1,1,0,10000),(4670,5220004,2000005,0,1,1,0,999999),(4671,5220004,1452009,0,1,1,0,5000),(4672,5220004,1382007,0,1,1,0,7000),(4673,5220004,1462009,0,1,1,0,5000),(4674,5220004,1322019,0,1,1,0,7000),(4675,5220004,1312010,0,1,1,0,7000),(4676,5220004,1412008,0,1,1,0,7000),(4677,5220004,1422010,0,1,1,0,7000),(4678,5220004,1472026,0,1,1,0,5000),(4679,5220004,1432007,0,1,1,0,5000),(4680,5220004,1442008,0,1,1,0,7000),(4681,5220004,1302012,0,1,1,0,7000),(4682,5220004,1402012,0,1,1,0,7000),(4683,5220004,1332018,0,1,1,0,5000),(4684,5220004,1332019,0,1,1,0,5000),(4685,5220004,2043001,0,1,1,0,1500),(4686,5220004,2043101,0,1,1,0,1500),(4687,5220004,2043201,0,1,1,0,1500),(4688,5220004,2043301,0,1,1,0,1500),(4689,5220004,2043701,0,1,1,0,1500),(4690,5220004,2043801,0,1,1,0,1500),(4691,5220004,2044001,0,1,1,0,1500),(4692,5220004,2044101,0,1,1,0,1500),(4693,5220004,2044201,0,1,1,0,1500),(4694,5220004,2044301,0,1,1,0,1500),(4695,5220004,2044401,0,1,1,0,1500),(4696,5220004,2044501,0,1,1,0,1500),(4697,5220004,2044601,0,1,1,0,1500),(4698,5220004,2044701,0,1,1,0,1500),(4699,5220004,2000004,0,1,1,0,999999),(4700,5220004,1092017,0,1,1,0,7000),(4701,5250000,2000002,0,1,1,0,20000),(4702,5250000,2000003,0,1,1,0,20000),(4705,5250000,2044312,0,1,1,0,100),(4706,5250000,1002208,0,1,1,0,800),(4707,5250000,1052116,0,1,1,0,800),(4708,5250000,1082010,0,1,1,0,800),(4709,5250000,1072143,0,1,1,0,800),(4710,5250000,1452004,0,1,1,0,800),(4711,5250000,4000437,0,1,1,0,600000),(4712,5250000,4130003,0,1,1,0,6000),(4713,5250000,4130014,0,1,1,0,6000),(4714,5250000,4130017,0,1,1,0,6000),(4715,5250001,2000002,0,1,1,0,20000),(4716,5250001,2000003,0,1,1,0,20000),(4719,5250001,2041014,0,1,1,0,100),(4720,5250001,1002214,0,1,1,0,800),(4721,5250001,1040096,0,1,1,0,800),(4722,5250001,1041079,0,1,1,0,800),(4723,5250001,1082198,0,1,1,0,800),(4724,5250001,1072133,0,1,1,0,800),(4725,5250001,1372007,0,1,1,0,800),(4726,5250001,4000439,0,1,1,0,600000),(4727,5250001,4130015,0,1,1,0,6000),(4728,5250001,4130016,0,1,1,0,6000),(4729,5250002,4000440,0,1,1,0,600000),(4730,5250002,2000002,0,1,1,0,20000),(4731,5250002,2000003,0,1,1,0,20000),(4734,5250002,2044802,0,1,1,0,100),(4735,5250002,1002634,0,1,1,0,800),(4736,5250002,1040092,0,1,1,0,800),(4737,5250002,1041093,0,1,1,0,800),(4738,5250002,1082087,0,1,1,0,800),(4739,5250002,1072145,0,1,1,0,800),(4740,5250002,1332015,0,1,1,0,800),(4741,5250002,4130001,0,1,1,0,6000),(4742,5250002,4130014,0,1,1,0,6000),(4743,5300000,4000086,0,1,1,0,600000),(4747,5300000,4006001,0,1,1,0,10000),(4748,5300000,2000002,0,1,1,0,20000),(4749,5300000,2000003,0,1,1,0,20000),(4750,5300000,2050001,0,1,1,0,50000),(4751,5300000,2070001,0,1,1,0,200),(4753,5300000,1082016,0,1,1,0,800),(4754,5300000,1002035,0,1,1,0,800),(4755,5300000,1002165,0,1,1,0,800),(4756,5300000,1041048,0,1,1,0,800),(4757,5300000,1061044,0,1,1,0,800),(4758,5300000,1072081,0,1,1,0,800),(4759,5300000,1072075,0,1,1,0,800),(4760,5300000,1382017,0,1,1,0,800),(4761,5300000,1032002,0,1,1,0,800),(4762,5300000,1040030,0,1,1,0,800),(4763,5300000,1060020,0,1,1,0,800),(4764,5300000,1082054,0,1,1,0,800),(4765,5300000,2040705,0,1,1,0,100),(4766,5300000,1482004,0,1,1,0,800),(4767,5300000,4130000,0,1,1,0,6000),(4768,5300000,4130005,0,1,1,0,6000),(4769,5300000,4130011,0,1,1,0,6000),(4770,5300001,4000087,0,1,1,0,600000),(4774,5300001,4006001,0,1,1,0,10000),(4775,5300001,2040402,0,1,1,0,100),(4776,5300001,2000002,0,1,1,0,20000),(4777,5300001,2000003,0,1,1,0,20000),(4778,5300001,2050000,0,1,1,0,50000),(4779,5300001,1002175,0,1,1,0,800),(4780,5300001,1402002,0,1,1,0,800),(4781,5300001,1050029,0,1,1,0,800),(4782,5300001,1002138,0,1,1,0,800),(4783,5300001,1041068,0,1,1,0,800),(4784,5300001,1061063,0,1,1,0,800),(4785,5300001,1082036,0,1,1,0,800),(4786,5300001,1072105,0,1,1,0,800),(4787,5300001,1332014,0,1,1,0,800),(4788,5300001,1051023,0,1,1,0,800),(4789,5300001,1002625,0,1,1,0,800),(4790,5300001,2040623,0,1,1,0,100),(4791,5300001,4130013,0,1,1,0,6000),(4792,5300001,4130016,0,1,1,0,6000),(4793,5300100,4000041,0,1,1,0,600000),(4795,5300100,2000002,0,1,1,0,20000),(4796,5300100,2000003,0,1,1,0,20000),(4799,5300100,2000004,0,1,1,0,20000),(4800,5300100,4006000,0,1,1,0,10000),(4801,5300100,1002168,0,1,1,0,800),(4802,5300100,1002092,0,1,1,0,800),(4803,5300100,1040086,0,1,1,0,800),(4804,5300100,1060000,0,1,1,0,800),(4805,5300100,1051031,0,1,1,0,800),(4806,5300100,1051039,0,1,1,0,800),(4807,5300100,1082011,0,1,1,0,800),(4808,5300100,1452008,0,1,1,0,800),(4809,5300100,1072143,0,1,1,0,800),(4810,5300100,1472020,0,1,1,0,800),(4811,5300100,1032019,0,1,1,0,800),(4812,5300100,1040090,0,1,1,0,800),(4813,5300100,1060079,0,1,1,0,800),(4814,5300100,1452004,0,1,1,0,800),(4815,5300100,1072137,0,1,1,0,800),(4816,5300100,1082093,0,1,1,0,800),(4817,5300100,1082198,0,1,1,0,800),(4818,5300100,4130006,0,1,1,0,6000),(4819,5300100,4130010,0,1,1,0,6000),(4820,5300100,4130016,0,1,1,0,6000),(4821,5400000,4000088,0,1,1,0,600000),(4825,5400000,4006000,0,1,1,0,10000),(4826,5400000,2043801,0,1,1,0,100),(4827,5400000,2000002,0,1,1,0,20000),(4828,5400000,2000003,0,1,1,0,20000),(4829,5400000,2050002,0,1,1,0,50000),(4830,5400000,1432008,0,1,1,0,800),(4831,5400000,2070002,0,1,1,0,500),(4832,5400000,2060001,0,1,1,0,30000),(4833,5400000,2061001,0,1,1,0,30000),(4834,5400000,1060045,0,1,1,0,800),(4835,5400000,1040059,0,1,1,0,800),(4836,5400000,1002177,0,1,1,0,800),(4837,5400000,1041067,0,1,1,0,800),(4838,5400000,1061062,0,1,1,0,800),(4839,5400000,1051001,0,1,1,0,800),(4840,5400000,1422008,0,1,1,0,800),(4841,5400000,1002021,0,1,1,0,800),(4842,5400000,1082062,0,1,1,0,800),(4843,5400000,1072108,0,1,1,0,800),(4844,5400000,1422007,0,1,1,0,800),(4845,5400000,1082192,0,1,1,0,800),(4846,5400000,2044801,0,1,1,0,100),(4847,5400000,2044809,0,1,1,0,100),(4848,5400000,4130002,0,1,1,0,6000),(4849,5400000,4130011,0,1,1,0,6000),(4850,5400000,4130014,0,1,1,0,6000),(4851,6090000,4000336,0,1,1,0,600000),(4852,6090001,4000415,0,1,1,0,600000),(4853,6090003,4000416,0,1,1,0,600000),(4854,6090004,4000419,0,1,1,0,600000),(4855,6110300,2000006,0,1,1,0,20000),(4859,6110300,1041078,0,1,1,0,800),(4860,6110300,1041089,0,1,1,0,800),(4861,6110300,1002022,0,1,1,0,800),(4862,6110300,1032019,0,1,1,0,800),(4863,6110300,1051047,0,1,1,0,800),(4864,6110300,1040099,0,1,1,0,800),(4865,6110300,1060088,0,1,1,0,800),(4866,6110300,1432006,0,1,1,0,800),(4867,6110300,1462008,0,1,1,0,800),(4868,6110300,1472024,0,1,1,0,800),(4869,6110300,1102022,0,1,1,0,800),(4870,6110300,1382007,0,1,1,0,800),(4871,6110300,1472026,0,1,1,0,800),(4872,6110300,1082107,0,1,1,0,800),(4873,6110300,1040104,0,1,1,0,800),(4874,6110300,1060092,0,1,1,0,800),(4875,6110300,1072157,0,1,1,0,800),(4876,6110300,1032020,0,1,1,0,800),(4877,6110300,1051062,0,1,1,0,800),(4878,6110300,4000354,0,1,1,0,600000),(4879,6110300,1072306,0,1,1,0,800),(4880,6110300,2040933,0,1,1,0,100),(4881,6110300,2049100,0,1,1,0,150),(4882,6110300,4130004,0,1,1,0,6000),(4883,6110300,4130009,0,1,1,0,6000),(4884,6110300,4130011,0,1,1,0,6000),(4885,6110301,2000002,0,1,1,0,20000),(4886,6110301,2000006,0,1,1,0,20000),(4887,6110301,2000004,0,1,1,0,20000),(4891,6110301,1092015,0,1,1,0,800),(4892,6110301,1472027,0,1,1,0,800),(4893,6110301,1050088,0,1,1,0,800),(4894,6110301,1072080,0,1,1,0,800),(4895,6110301,1072085,0,1,1,0,800),(4896,6110301,1032015,0,1,1,0,800),(4897,6110301,1050081,0,1,1,0,800),(4898,6110301,1051078,0,1,1,0,800),(4899,6110301,1002289,0,1,1,0,800),(4900,6110301,1462008,0,1,1,0,800),(4901,6110301,1322018,0,1,1,0,800),(4902,6110301,2043302,0,1,1,0,100),(4903,6110301,4000363,0,1,1,0,600000),(4904,6110301,1072309,0,1,1,0,800),(4905,6110301,2330003,0,1,1,0,100),(4906,6110301,2040621,0,1,1,0,100),(4907,6110301,2049000,0,1,1,0,150),(4908,6110301,4130001,0,1,1,0,6000),(4909,6110301,4130007,0,1,1,0,6000),(4910,6130100,4000014,0,1,1,0,600000),(4911,6130100,2000006,0,1,1,0,20000),(4912,6130100,2000004,0,1,1,0,20000),(4915,6130100,2070005,0,1,1,0,200),(4916,6130100,4000030,0,1,1,0,60000),(4917,6130100,1060068,0,1,1,0,800),(4918,6130100,1040080,0,1,1,0,800),(4919,6130100,1040083,0,1,1,0,800),(4920,6130100,1060072,0,1,1,0,800),(4921,6130100,1041080,0,1,1,0,800),(4922,6130100,1061079,0,1,1,0,800),(4923,6130100,1082067,0,1,1,0,800),(4924,6130100,1092004,0,1,1,0,800),(4925,6130100,1050056,0,1,1,0,800),(4926,6130100,1372014,0,1,1,0,800),(4927,6130100,1002246,0,1,1,0,800),(4928,6130100,1002248,0,1,1,0,800),(4929,6130100,1072136,0,1,1,0,800),(4930,6130100,1072146,0,1,1,0,800),(4931,6130100,1072148,0,1,1,0,800),(4932,6130100,1040100,0,1,1,0,800),(4933,6130100,1060089,0,1,1,0,800),(4934,6130100,1102022,0,1,1,0,800),(4935,6130100,1060091,0,1,1,0,800),(4936,6130100,1040103,0,1,1,0,800),(4937,6130100,1072160,0,1,1,0,800),(4938,6130100,1072162,0,1,1,0,800),(4939,6130100,1082106,0,1,1,0,800),(4940,6130100,1482008,0,1,1,0,800),(4941,6130100,2331000,0,1,1,0,500),(4942,6130100,2040319,0,1,1,0,100),(4943,6130100,4130004,0,1,1,0,6000),(4944,6130100,4130014,0,1,1,0,6000),(4945,6130101,4000040,0,1,1,0,600000),(4946,6130101,1092012,0,1,1,0,7000),(4947,6130101,2070006,0,1,1,0,1000),(4948,6130101,2040001,0,1,1,0,1500),(4949,6130101,2040004,0,1,1,0,1500),(4950,6130101,2040301,0,1,1,0,1500),(4951,6130101,2040401,0,1,1,0,1500),(4952,6130101,2040501,0,1,1,0,1500),(4953,6130101,2040504,0,1,1,0,1500),(4954,6130101,2040601,0,1,1,0,1500),(4955,6130101,2040701,0,1,1,0,1500),(4956,6130101,2040704,0,1,1,0,1500),(4957,6130101,2040707,0,1,1,0,1500),(4958,6130101,2040801,0,1,1,0,1500),(4959,6130101,2041001,0,1,1,0,1500),(4960,6130101,2041004,0,1,1,0,1500),(4961,6130101,2040804,0,1,1,0,1000),(4962,6130101,2040901,0,1,1,0,1500),(4963,6130101,1032019,0,1,1,0,10000),(4964,6130101,1382006,0,1,1,0,7000),(4965,6130101,2331000,0,1,1,0,5000),(4966,6130101,2040412,0,1,1,0,1500),(4967,6130101,2040618,0,1,1,0,1500),(4968,6130101,2040619,0,1,1,0,1500),(4969,6130101,2040024,0,1,1,0,1500),(4970,6130101,2043212,0,1,1,0,1500),(4971,6130103,4000050,0,1,1,0,600000),(4972,6130103,2000006,0,1,1,0,20000),(4973,6130103,2000004,0,1,1,0,20000),(4976,6130103,2040401,0,1,1,0,100),(4978,6130103,1050045,0,1,1,0,800),(4979,6130103,1040087,0,1,1,0,800),(4980,6130103,1060076,0,1,1,0,800),(4981,6130103,1040097,0,1,1,0,800),(4982,6130103,1060086,0,1,1,0,800),(4983,6130103,1002170,0,1,1,0,800),(4984,6130103,1002025,0,1,1,0,800),(4985,6130103,1040093,0,1,1,0,800),(4986,6130103,1060082,0,1,1,0,800),(4987,6130103,1072150,0,1,1,0,800),(4988,6130103,1072138,0,1,1,0,800),(4989,6130103,1082060,0,1,1,0,800),(4990,6130103,1072145,0,1,1,0,800),(4991,6130103,1102024,0,1,1,0,800),(4992,6130103,1072157,0,1,1,0,800),(4993,6130103,1002286,0,1,1,0,800),(4994,6130103,1302012,0,1,1,0,800),(4995,6130103,1082095,0,1,1,0,800),(4996,6130103,2040418,0,1,1,0,100),(4997,6130103,4130008,0,1,1,0,6000),(4998,6130103,4130015,0,1,1,0,6000),(4999,6130200,4000128,0,1,1,0,600000),(5001,6130200,2000006,0,1,1,0,20000),(5002,6130200,2000004,0,1,1,0,20000),(5005,6130200,2043701,0,1,1,0,100),(5006,6130200,2043801,0,1,1,0,100),(5007,6130200,2041001,0,1,1,0,100),(5009,6130200,1002182,0,1,1,0,800),(5010,6130200,1002093,0,1,1,0,800),(5011,6130200,1050046,0,1,1,0,800),(5012,6130200,1032012,0,1,1,0,800),(5013,6130200,1040088,0,1,1,0,800),(5014,6130200,1060077,0,1,1,0,800),(5015,6130200,1072122,0,1,1,0,800),(5016,6130200,1082094,0,1,1,0,800),(5017,6130200,1082061,0,1,1,0,800),(5018,6130200,1082087,0,1,1,0,800),(5019,6130200,1072152,0,1,1,0,800),(5020,6130200,1051042,0,1,1,0,800),(5021,6130200,1302011,0,1,1,0,800),(5022,6130200,1102015,0,1,1,0,800),(5023,6130200,1452009,0,1,1,0,800),(5024,6130200,1082098,0,1,1,0,800),(5025,6130200,1312010,0,1,1,0,800),(5026,6130200,1072163,0,1,1,0,800),(5027,6130200,1052122,0,1,1,0,800),(5028,6130200,2043112,0,1,1,0,100),(5029,6130200,2044312,0,1,1,0,100),(5030,6130200,4130004,0,1,1,0,6000),(5031,6130200,4130012,0,1,1,0,6000),(5032,6130200,4130015,0,1,1,0,6000),(5033,6130202,4000173,0,1,1,0,600000),(5034,6130202,2000006,0,1,1,0,20000),(5035,6130202,2000004,0,1,1,0,20000),(5038,6130202,1432004,0,1,1,0,800),(5039,6130202,1442009,0,1,1,0,800),(5040,6130202,1452008,0,1,1,0,800),(5041,6130202,1462006,0,1,1,0,800),(5042,6130202,1082086,0,1,1,0,800),(5043,6130202,1082093,0,1,1,0,800),(5044,6130202,1072144,0,1,1,0,800),(5045,6130202,2040401,0,1,1,0,100),(5046,6130202,1060088,0,1,1,0,800),(5047,6130202,1040099,0,1,1,0,800),(5048,6130202,1102018,0,1,1,0,800),(5049,6130202,1041091,0,1,1,0,800),(5050,6130202,1061090,0,1,1,0,800),(5051,6130202,2040004,0,1,1,0,100),(5053,6130202,2040501,0,1,1,0,100),(5054,6130202,1040089,0,1,1,0,800),(5055,6130202,1060078,0,1,1,0,800),(5056,6130202,4130002,0,1,1,0,6000),(5057,6130203,4000283,0,1,1,0,600000),(5058,6130203,4000285,0,1,1,0,600000),(5059,6130203,4000021,0,1,1,0,50000),(5060,6130203,4003005,0,1,1,0,200000),(5061,6130203,2000006,0,1,1,0,20000),(5062,6130203,2000004,0,1,1,0,20000),(5065,6130203,2070005,0,1,1,0,200),(5066,6130203,1041083,0,1,1,0,800),(5067,6130203,1061082,0,1,1,0,800),(5068,6130203,1072090,0,1,1,0,800),(5069,6130203,1041079,0,1,1,0,800),(5070,6130203,1061078,0,1,1,0,800),(5071,6130203,1002215,0,1,1,0,800),(5072,6130203,1102015,0,1,1,0,800),(5073,6130203,1050056,0,1,1,0,800),(5074,6130203,1002637,0,1,1,0,800),(5075,6130203,2040622,0,1,1,0,100),(5076,6130203,2043112,0,1,1,0,100),(5077,6130203,2044014,0,1,1,0,100),(5078,6130203,4130002,0,1,1,0,6000),(5079,6130203,4130005,0,1,1,0,6000),(5080,6130203,4130013,0,1,1,0,6000),(5081,6130204,4000295,0,1,1,0,600000),(5082,6130204,4003005,0,1,1,0,200000),(5083,6130204,4000021,0,1,1,0,50000),(5084,6130204,2000002,0,1,1,0,20000),(5085,6130204,2000006,0,1,1,0,20000),(5086,6130204,2000004,0,1,1,0,20000),(5089,6130204,1040093,0,1,1,0,800),(5090,6130204,1060082,0,1,1,0,800),(5091,6130204,1051064,0,1,1,0,800),(5092,6130204,1051065,0,1,1,0,800),(5093,6130204,1082062,0,1,1,0,800),(5094,6130204,1040104,0,1,1,0,800),(5095,6130204,1060092,0,1,1,0,800),(5097,6130204,1040107,0,1,1,0,800),(5098,6130204,1060095,0,1,1,0,800),(5099,6130204,2040301,0,1,1,0,100),(5100,6130204,2043001,0,1,1,0,100),(5101,6130204,1402011,0,1,1,0,800),(5102,6130204,1402003,0,1,1,0,800),(5103,6130204,1052119,0,1,1,0,800),(5104,6130204,2330003,0,1,1,0,500),(5105,6130204,2044802,0,1,1,0,100),(5106,6130204,2040421,0,1,1,0,100),(5107,6130204,2049000,0,1,1,0,150),(5108,6130204,4130000,0,1,1,0,6000),(5109,6130204,4130012,0,1,1,0,6000),(5110,6130207,4000282,0,1,1,0,600000),(5111,6130207,4000021,0,1,1,0,50000),(5112,6130207,4003005,0,1,1,0,200000),(5113,6130207,2000002,0,1,1,0,20000),(5114,6130207,2000006,0,1,1,0,20000),(5116,6130207,1040109,0,1,1,0,800),(5117,6130207,1060098,0,1,1,0,800),(5118,6130207,1032011,0,1,1,0,800),(5119,6130207,1102017,0,1,1,0,800),(5120,6130207,1051030,0,1,1,0,800),(5121,6130207,1002210,0,1,1,0,800),(5122,6130207,1051046,0,1,1,0,800),(5123,6130207,1452008,0,1,1,0,800),(5124,6130207,2043701,0,1,1,0,100),(5125,6130207,1072309,0,1,1,0,800),(5126,6130207,2330003,0,1,1,0,100),(5127,6130207,2040328,0,1,1,0,100),(5128,6130207,2044112,0,1,1,0,100),(5129,6130207,4130006,0,1,1,0,6000),(5130,6130207,4130007,0,1,1,0,6000),(5131,6130208,4000296,0,1,1,0,600000),(5132,6130208,2000002,0,1,1,0,20000),(5133,6130208,2000006,0,1,1,0,20000),(5134,6130208,2000004,0,1,1,0,20000),(5138,6130208,1092015,0,1,1,0,800),(5139,6130208,1472027,0,1,1,0,800),(5140,6130208,1050088,0,1,1,0,800),(5141,6130208,1072080,0,1,1,0,800),(5142,6130208,1072085,0,1,1,0,800),(5143,6130208,1032015,0,1,1,0,800),(5144,6130208,1050081,0,1,1,0,800),(5145,6130208,1051078,0,1,1,0,800),(5146,6130208,1002289,0,1,1,0,800),(5147,6130208,1462008,0,1,1,0,800),(5148,6130208,1322018,0,1,1,0,800),(5149,6130208,2043302,0,1,1,0,100),(5150,6130208,1082204,0,1,1,0,800),(5151,6130208,2044902,0,1,1,0,100),(5152,6130208,4130006,0,1,1,0,6000),(5153,6130208,4130008,0,1,1,0,6000),(5154,6130208,4130012,0,1,1,0,6000),(5155,6130209,4000289,0,1,1,0,600000),(5156,6130209,4000021,0,1,1,0,50000),(5157,6130209,4003005,0,1,1,0,200000),(5160,6130209,2000002,0,1,1,0,20000),(5161,6130209,2000004,0,1,1,0,20000),(5163,6130209,1032014,0,1,1,0,800),(5164,6130209,1040096,0,1,1,0,800),(5165,6130209,1060085,0,1,1,0,800),(5166,6130209,1092015,0,1,1,0,800),(5167,6130209,1332019,0,1,1,0,800),(5168,6130209,4006000,0,1,1,0,10000),(5169,6130209,2040301,0,1,1,0,100),(5170,6130209,1492008,0,1,1,0,800),(5171,6130209,2040925,0,1,1,0,100),(5172,6130209,2043017,0,1,1,0,100),(5173,6130209,2043110,0,1,1,0,100),(5174,6130209,4130014,0,1,1,0,6000),(5175,6130209,4130017,0,1,1,0,6000),(5176,6220000,4000032,0,1,1,0,600000),(5177,6220000,4000032,0,1,1,0,600000),(5178,6220000,4000032,0,1,1,0,600000),(5179,6220000,4000033,0,1,1,0,600000),(5180,6220000,4000033,0,1,1,0,600000),(5181,6220000,4000033,0,1,1,0,600000),(5182,6220000,4000021,0,1,1,0,500000),(5183,6220000,4000021,0,1,1,0,500000),(5184,6220000,4000021,0,1,1,0,500000),(5187,6220000,2000002,0,1,1,0,200000),(5188,6220000,2000003,0,1,1,0,200000),(5189,6220000,2002000,0,1,1,0,200000),(5190,6220000,2002001,0,1,1,0,200000),(5191,6220000,2040004,0,1,1,0,1500),(5192,6220000,2040501,0,1,1,0,1500),(5193,6220000,2040516,0,1,1,0,1500),(5194,6220000,2040804,0,1,1,0,1000),(5195,6220000,2041001,0,1,1,0,1500),(5196,6220000,2043301,0,1,1,0,1500),(5197,6220000,2044001,0,1,1,0,1500),(5198,6220000,2044401,0,1,1,0,1500),(5199,6220000,2044601,0,1,1,0,1500),(5200,6220000,2044701,0,1,1,0,1500),(5201,6220000,2040702,0,1,1,0,1500),(5202,6220000,2041008,0,1,1,0,1500),(5203,6220000,2044502,0,1,1,0,1500),(5204,6220000,2044702,0,1,1,0,1500),(5205,6220000,2048002,0,1,1,0,1500),(5206,6220000,2060000,0,1,1,0,300000),(5207,6220000,2061000,0,1,1,0,300000),(5208,6220000,1302012,0,1,1,0,7000),(5209,6220000,1312010,0,1,1,0,7000),(5210,6220000,1322019,0,1,1,0,7000),(5211,6220000,1332018,0,1,1,0,5000),(5212,6220000,1372015,0,1,1,0,7000),(5213,6220000,1382010,0,1,1,0,7000),(5214,6220000,1402012,0,1,1,0,7000),(5215,6220000,1412008,0,1,1,0,7000),(5216,6220000,1422010,0,1,1,0,7000),(5217,6220000,1432007,0,1,1,0,5000),(5218,6220000,1442008,0,1,1,0,7000),(5219,6220000,1452011,0,1,1,0,5000),(5220,6220000,1462009,0,1,1,0,5000),(5221,6220000,1472029,0,1,1,0,5000),(5222,6220000,1482009,0,1,1,0,5000),(5223,6220000,1492009,0,1,1,0,5000),(5224,6220000,2040031,0,1,1,0,1500),(5225,6220000,2040627,0,1,1,0,1500),(5226,6220000,2044312,0,1,1,0,1500),(5227,6220000,2044807,0,1,1,0,1500),(5228,6220001,4000117,0,1,1,0,600000),(5229,6220001,4000118,0,1,1,0,600000),(5230,6220001,4000119,0,1,1,0,600000),(5233,6220001,2000002,0,1,1,0,200000),(5234,6220001,2000003,0,1,1,0,200000),(5235,6220001,2040516,0,1,1,0,1500),(5236,6220001,2040707,0,1,1,0,1500),(5237,6220001,2040804,0,1,1,0,1000),(5238,6220001,2041016,0,1,1,0,1500),(5239,6220001,2043101,0,1,1,0,1500),(5240,6220001,2043301,0,1,1,0,1500),(5241,6220001,2044401,0,1,1,0,1500),(5242,6220001,2044301,0,1,1,0,1500),(5243,6220001,2044901,0,1,1,0,1500),(5244,6220001,2330003,0,1,1,0,1000),(5245,6220001,2070004,0,1,1,0,3000),(5246,6220001,1002024,0,1,1,0,15000),(5247,6220001,1002095,0,1,1,0,15000),(5248,6220001,1002254,0,1,1,0,15000),(5249,6220001,1002289,0,1,1,0,15000),(5250,6220001,1002285,0,1,1,0,15000),(5251,6220001,1002637,0,1,1,0,15000),(5252,6220001,1302049,0,1,1,0,7000),(5253,6220001,2040413,0,1,1,0,1500),(5254,6220001,2040925,0,1,1,0,1500),(5255,6220001,2043214,0,1,1,0,1500),(5256,6220001,2049000,0,1,1,0,1500),(5257,6230100,4000027,0,1,1,0,600000),(5258,6230100,2000006,0,1,1,0,20000),(5261,6230100,2043701,0,1,1,0,100),(5262,6230100,2070004,0,1,1,0,300),(5263,6230100,1422005,0,1,1,0,800),(5264,6230100,1002218,0,1,1,0,800),(5265,6230100,2000005,0,1,1,0,20000),(5266,6230100,1002021,0,1,1,0,800),(5267,6230100,1002166,0,1,1,0,800),(5268,6230100,1050047,0,1,1,0,800),(5269,6230100,1040095,0,1,1,0,800),(5270,6230100,1060084,0,1,1,0,800),(5271,6230100,1041087,0,1,1,0,800),(5272,6230100,1061086,0,1,1,0,800),(5273,6230100,1051045,0,1,1,0,800),(5274,6230100,1082061,0,1,1,0,800),(5275,6230100,1050060,0,1,1,0,800),(5276,6230100,1082090,0,1,1,0,800),(5277,6230100,1072148,0,1,1,0,800),(5278,6230100,1472023,0,1,1,0,800),(5279,6230100,1442010,0,1,1,0,800),(5280,6230100,1102016,0,1,1,0,800),(5281,6230100,1051054,0,1,1,0,800),(5282,6230100,1082106,0,1,1,0,800),(5283,6230100,1072154,0,1,1,0,800),(5284,6230100,1041103,0,1,1,0,800),(5285,6230100,1061102,0,1,1,0,800),(5286,6230100,1082204,0,1,1,0,800),(5287,6230100,2040323,0,1,1,0,100),(5288,6230100,2040823,0,1,1,0,100),(5289,6230100,2043212,0,1,1,0,100),(5290,6230100,2044809,0,1,1,0,100),(5291,6230100,2049100,0,1,1,0,150),(5292,6230100,4130011,0,1,1,0,6000),(5293,6230100,4130012,0,1,1,0,6000),(5294,6230100,4130016,0,1,1,0,6000),(5295,6230200,4000057,0,1,1,0,600000),(5297,6230200,2000006,0,1,1,0,20000),(5298,6230200,2000004,0,1,1,0,20000),(5302,6230200,4006000,0,1,1,0,10000),(5303,6230200,1002218,0,1,1,0,800),(5304,6230200,1472020,0,1,1,0,800),(5305,6230200,1002100,0,1,1,0,800),(5306,6230200,1050055,0,1,1,0,800),(5307,6230200,1002268,0,1,1,0,800),(5308,6230200,1082087,0,1,1,0,800),(5309,6230200,1041094,0,1,1,0,800),(5310,6230200,1061093,0,1,1,0,800),(5311,6230200,1102018,0,1,1,0,800),(5312,6230200,1092011,0,1,1,0,800),(5313,6230200,1472025,0,1,1,0,800),(5314,6230200,1082088,0,1,1,0,800),(5315,6230200,1332017,0,1,1,0,800),(5316,6230200,1472023,0,1,1,0,800),(5317,6230200,1051052,0,1,1,0,800),(5318,6230200,1072164,0,1,1,0,800),(5319,6230200,1072155,0,1,1,0,800),(5320,6230200,1072161,0,1,1,0,800),(5321,6230200,2040419,0,1,1,0,100),(5322,6230200,2040620,0,1,1,0,100),(5323,6230200,4130005,0,1,1,0,6000),(5324,6230200,4130013,0,1,1,0,6000),(5325,6230300,4000129,0,1,1,0,600000),(5328,6230300,2000002,0,1,1,0,20000),(5329,6230300,2000004,0,1,1,0,20000),(5331,6230300,2040301,0,1,1,0,100),(5332,6230300,4006000,0,1,1,0,10000),(5334,6230300,1051031,0,1,1,0,800),(5335,6230300,1082065,0,1,1,0,800),(5336,6230300,1072125,0,1,1,0,800),(5337,6230300,1040089,0,1,1,0,800),(5338,6230300,1060078,0,1,1,0,800),(5339,6230300,1002101,0,1,1,0,800),(5340,6230300,1002242,0,1,1,0,800),(5341,6230300,1040099,0,1,1,0,800),(5342,6230300,1060088,0,1,1,0,800),(5343,6230300,1051042,0,1,1,0,800),(5344,6230300,1082060,0,1,1,0,800),(5345,6230300,1102024,0,1,1,0,800),(5346,6230300,1050061,0,1,1,0,800),(5347,6230300,1432007,0,1,1,0,800),(5348,6230300,1082096,0,1,1,0,800),(5349,6230300,1072158,0,1,1,0,800),(5350,6230300,1032015,0,1,1,0,800),(5351,6230300,1482008,0,1,1,0,800),(5352,6230300,2044801,0,1,1,0,100),(5353,6230300,2040318,0,1,1,0,100),(5354,6230300,2040622,0,1,1,0,100),(5355,6230300,4130001,0,1,1,0,6000),(5356,6230400,4000143,0,1,1,0,600000),(5357,6230400,2000002,0,1,1,0,20000),(5358,6230400,2000004,0,1,1,0,20000),(5359,6230400,2043802,0,1,1,0,100),(5360,6230400,2040804,0,1,1,0,100),(5361,6230400,2002000,0,1,1,0,20000),(5365,6230400,1051034,0,1,1,0,800),(5366,6230400,1002085,0,1,1,0,800),(5367,6230400,1002210,0,1,1,0,800),(5368,6230400,1051037,0,1,1,0,800),(5369,6230400,1040096,0,1,1,0,800),(5370,6230400,1060085,0,1,1,0,800),(5371,6230400,1372014,0,1,1,0,800),(5372,6230400,1082091,0,1,1,0,800),(5373,6230400,1082093,0,1,1,0,800),(5374,6230400,1082086,0,1,1,0,800),(5375,6230400,1072149,0,1,1,0,800),(5376,6230400,1472024,0,1,1,0,800),(5377,6230400,1102017,0,1,1,0,800),(5378,6230400,1322018,0,1,1,0,800),(5379,6230400,1032020,0,1,1,0,800),(5380,6230400,1002281,0,1,1,0,800),(5381,6230400,1002286,0,1,1,0,800),(5382,6230400,1082099,0,1,1,0,800),(5383,6230400,1041098,0,1,1,0,800),(5384,6230400,1061097,0,1,1,0,800),(5385,6230400,1032014,0,1,1,0,800),(5386,6230400,1492009,0,1,1,0,800),(5387,6230400,2044902,0,1,1,0,100),(5388,6230400,2040422,0,1,1,0,100),(5389,6230400,2040530,0,1,1,0,100),(5390,6230400,2040924,0,1,1,0,100),(5391,6230400,2044414,0,1,1,0,100),(5392,6230400,4130012,0,1,1,0,6000),(5393,6230400,4130013,0,1,1,0,6000),(5394,6230401,2040515,0,1,1,0,100),(5395,6230401,2044410,0,1,1,0,100),(5396,6230401,4130009,0,1,1,0,6000),(5397,6230401,4130010,0,1,1,0,6000),(5398,6230401,4130014,0,1,1,0,6000),(5399,6230500,4000144,0,1,1,0,600000),(5400,6230500,4000021,0,1,1,0,50000),(5401,6230500,2000002,0,1,1,0,20000),(5402,6230500,2000004,0,1,1,0,20000),(5405,6230500,4006000,0,1,1,0,10000),(5407,6230500,2041022,0,1,1,0,100),(5408,6230500,2043301,0,1,1,0,100),(5409,6230500,1050049,0,1,1,0,800),(5410,6230500,1072123,0,1,1,0,800),(5411,6230500,1082085,0,1,1,0,800),(5412,6230500,1050056,0,1,1,0,800),(5413,6230500,1002084,0,1,1,0,800),(5414,6230500,1002249,0,1,1,0,800),(5415,6230500,1002270,0,1,1,0,800),(5416,6230500,1002244,0,1,1,0,800),(5417,6230500,1040091,0,1,1,0,800),(5418,6230500,1060080,0,1,1,0,800),(5419,6230500,1072161,0,1,1,0,800),(5420,6230500,1072166,0,1,1,0,800),(5421,6230500,1082103,0,1,1,0,800),(5422,6230500,1332019,0,1,1,0,800),(5423,6230500,1072159,0,1,1,0,800),(5424,6230500,1002637,0,1,1,0,800),(5425,6230500,2040620,0,1,1,0,100),(5426,6230500,4130001,0,1,1,0,6000),(5427,6230500,4130007,0,1,1,0,6000),(5428,6230600,4000185,0,1,1,0,600000),(5429,6230600,2000006,0,1,1,0,20000),(5430,6230600,2000004,0,1,1,0,20000),(5431,6230600,4000030,0,1,1,0,60000),(5435,6230600,1040094,0,1,1,0,800),(5436,6230600,1060083,0,1,1,0,800),(5437,6230600,1041085,0,1,1,0,800),(5438,6230600,1061083,0,1,1,0,800),(5439,6230600,1040091,0,1,1,0,800),(5440,6230600,1060080,0,1,1,0,800),(5441,6230600,1041091,0,1,1,0,800),(5442,6230600,1061090,0,1,1,0,800),(5443,6230600,1051043,0,1,1,0,800),(5444,6230600,1051046,0,1,1,0,800),(5445,6230600,1082095,0,1,1,0,800),(5446,6230600,1082098,0,1,1,0,800),(5447,6230600,1072158,0,1,1,0,800),(5448,6230600,1472024,0,1,1,0,800),(5449,6230600,4006000,0,1,1,0,10000),(5450,6230600,1462008,0,1,1,0,800),(5452,6230600,1002634,0,1,1,0,800),(5453,6230600,2332000,0,1,1,0,500),(5454,6230600,2040317,0,1,1,0,100),(5455,6230600,2040328,0,1,1,0,100),(5456,6230600,2040928,0,1,1,0,100),(5457,6230600,2044112,0,1,1,0,100),(5458,6230600,2044414,0,1,1,0,100),(5459,6230600,4130006,0,1,1,0,6000),(5460,6230600,4130011,0,1,1,0,6000),(5461,6230600,4130015,0,1,1,0,6000),(5462,6230601,4000186,0,1,1,0,600000),(5464,6230601,2041001,0,1,1,0,100),(5465,6230601,2000002,0,1,1,0,20000),(5466,6230601,2000004,0,1,1,0,20000),(5469,6230601,4000030,0,1,1,0,60000),(5470,6230601,2041004,0,1,1,0,100),(5471,6230601,2040401,0,1,1,0,100),(5472,6230601,1002242,0,1,1,0,800),(5473,6230601,1002247,0,1,1,0,800),(5474,6230601,1002208,0,1,1,0,800),(5475,6230601,1092017,0,1,1,0,800),(5476,6230601,1442010,0,1,1,0,800),(5477,6230601,1432007,0,1,1,0,800),(5478,6230601,1412008,0,1,1,0,800),(5479,6230601,1082109,0,1,1,0,800),(5480,6230601,1041097,0,1,1,0,800),(5481,6230601,1061096,0,1,1,0,800),(5482,6230601,2040001,0,1,1,0,100),(5483,6230601,1061100,0,1,1,0,800),(5484,6230601,1041101,0,1,1,0,800),(5485,6230601,1072172,0,1,1,0,800),(5486,6230601,1372015,0,1,1,0,800),(5488,6230601,1052122,0,1,1,0,800),(5489,6230601,2040024,0,1,1,0,100),(5490,6230601,2040625,0,1,1,0,100),(5491,6230601,4130007,0,1,1,0,6000),(5492,6230601,4130015,0,1,1,0,6000),(5493,6230602,4000207,0,1,1,0,600000),(5494,6230602,2000002,0,1,1,0,20000),(5495,6230602,2000004,0,1,1,0,20000),(5496,6230602,2043802,0,1,1,0,100),(5497,6230602,2040804,0,1,1,0,100),(5498,6230602,2002000,0,1,1,0,20000),(5501,6230602,1082010,0,1,1,0,800),(5502,6230602,1082065,0,1,1,0,800),(5503,6230602,1082082,0,1,1,0,800),(5504,6230602,1082085,0,1,1,0,800),(5505,6230602,1092011,0,1,1,0,800),(5506,6230602,1302011,0,1,1,0,800),(5507,6230602,1332017,0,1,1,0,800),(5508,6230602,1472023,0,1,1,0,800),(5509,6230602,1002084,0,1,1,0,800),(5510,6230602,1002246,0,1,1,0,800),(5511,6230602,1002248,0,1,1,0,800),(5512,6230602,1002269,0,1,1,0,800),(5513,6230602,1082103,0,1,1,0,800),(5514,6230602,1082106,0,1,1,0,800),(5515,6230602,1082098,0,1,1,0,800),(5516,6230602,1082096,0,1,1,0,800),(5517,6230602,1482009,0,1,1,0,800),(5518,6230602,2330002,0,1,1,0,100),(5519,6230602,2040328,0,1,1,0,100),(5520,6230602,2040417,0,1,1,0,100),(5521,6230602,2040423,0,1,1,0,100),(5522,6230602,2040928,0,1,1,0,100),(5523,6230602,4130000,0,1,1,0,6000),(5524,6230602,4130010,0,1,1,0,6000),(5525,6230602,4130016,0,1,1,0,6000),(5526,6300000,4000049,0,1,1,0,600000),(5527,6300000,4003005,0,1,1,0,200000),(5528,6300000,4000021,0,1,1,0,50000),(5529,6300000,2000006,0,1,1,0,20000),(5533,6300000,1041078,0,1,1,0,800),(5534,6300000,1041089,0,1,1,0,800),(5535,6300000,1002022,0,1,1,0,800),(5536,6300000,1032019,0,1,1,0,800),(5537,6300000,1051047,0,1,1,0,800),(5538,6300000,1040099,0,1,1,0,800),(5539,6300000,1060088,0,1,1,0,800),(5540,6300000,1432006,0,1,1,0,800),(5541,6300000,1462008,0,1,1,0,800),(5542,6300000,1472024,0,1,1,0,800),(5543,6300000,1102022,0,1,1,0,800),(5544,6300000,1382007,0,1,1,0,800),(5545,6300000,1472026,0,1,1,0,800),(5546,6300000,1082107,0,1,1,0,800),(5547,6300000,1040104,0,1,1,0,800),(5548,6300000,1060092,0,1,1,0,800),(5549,6300000,1072157,0,1,1,0,800),(5550,6300000,1032020,0,1,1,0,800),(5551,6300000,1051062,0,1,1,0,800),(5552,6300005,4000176,0,1,1,0,600000),(5553,6300005,1032014,0,1,1,0,10000),(5554,6300005,1102024,0,1,1,0,10000),(5555,6300005,2070006,0,1,1,0,1000),(5556,6300005,2043101,0,1,1,0,1500),(5557,6300005,2043201,0,1,1,0,1500),(5558,6300005,2043301,0,1,1,0,1500),(5559,6300005,2043701,0,1,1,0,1500),(5560,6300005,2043801,0,1,1,0,1500),(5561,6300005,2044001,0,1,1,0,1500),(5562,6300005,2044101,0,1,1,0,1500),(5563,6300005,2044201,0,1,1,0,1500),(5564,6300005,2044301,0,1,1,0,1500),(5565,6300005,2044401,0,1,1,0,1500),(5566,6300005,2044501,0,1,1,0,1500),(5567,6300005,2044601,0,1,1,0,1500),(5568,6300005,2044701,0,1,1,0,1500),(5569,6300005,2048001,0,1,1,0,1500),(5570,6300005,2048004,0,1,1,0,1500),(5571,6300005,2043001,0,1,1,0,1500),(5572,6300005,1092010,0,1,1,0,7000),(5573,6300005,2332000,0,1,1,0,5000),(5574,6300005,2044801,0,1,1,0,1500),(5575,6300005,2044901,0,1,1,0,1500),(5576,6300005,2040422,0,1,1,0,1500),(5577,6300005,2043019,0,1,1,0,1500),(5578,6300100,4000130,0,1,1,0,600000),(5579,6300100,2041022,0,1,1,0,100),(5581,6300100,2000001,0,1,1,0,20000),(5582,6300100,2000004,0,1,1,0,20000),(5586,6300100,1040098,0,1,1,0,800),(5587,6300100,1060087,0,1,1,0,800),(5588,6300100,1072139,0,1,1,0,800),(5589,6300100,1041093,0,1,1,0,800),(5590,6300100,1061092,0,1,1,0,800),(5591,6300100,1072158,0,1,1,0,800),(5592,6300100,1082097,0,1,1,0,800),(5593,6300100,1051065,0,1,1,0,800),(5594,6300100,1061097,0,1,1,0,800),(5595,6300100,1041098,0,1,1,0,800),(5596,6300100,1082108,0,1,1,0,800),(5597,6300100,1040106,0,1,1,0,800),(5598,6300100,1060094,0,1,1,0,800),(5599,6300100,1472027,0,1,1,0,800),(5600,6300100,1452010,0,1,1,0,800),(5601,6300100,1442008,0,1,1,0,800),(5602,6300100,1072172,0,1,1,0,800),(5603,6300100,1082122,0,1,1,0,800),(5604,6300100,1082109,0,1,1,0,800),(5605,6300100,1050082,0,1,1,0,800),(5606,6300100,1492010,0,1,1,0,800),(5607,6300100,2040421,0,1,1,0,100),(5608,6300100,2040825,0,1,1,0,100),(5609,6300100,4130003,0,1,1,0,6000),(5610,6300100,4130004,0,1,1,0,6000),(5611,6400000,4000056,0,1,1,0,600000),(5612,6400000,4003004,0,1,1,0,200000),(5613,6400000,2041022,0,1,1,0,100),(5615,6400000,4000021,0,1,1,0,50000),(5616,6400000,2000002,0,1,1,0,20000),(5617,6400000,2000004,0,1,1,0,20000),(5620,6400000,4003002,0,1,1,0,200000),(5622,6400000,1082084,0,1,1,0,800),(5623,6400000,1072142,0,1,1,0,800),(5624,6400000,1442005,0,1,1,0,800),(5625,6400000,1472019,0,1,1,0,800),(5626,6400000,1051045,0,1,1,0,800),(5627,6400000,1002245,0,1,1,0,800),(5628,6400000,1050060,0,1,1,0,800),(5629,6400000,1040092,0,1,1,0,800),(5630,6400000,1060081,0,1,1,0,800),(5631,6400000,1041096,0,1,1,0,800),(5632,6400000,1061095,0,1,1,0,800),(5633,6400000,1002030,0,1,1,0,800),(5634,6400000,1032015,0,1,1,0,800),(5635,6400000,1061096,0,1,1,0,800),(5636,6400000,1041097,0,1,1,0,800),(5637,6400000,1072166,0,1,1,0,800),(5638,6400000,1082097,0,1,1,0,800),(5639,6400000,1002271,0,1,1,0,800),(5640,6400000,1002338,0,1,1,0,800),(5641,6400100,4000131,0,1,1,0,600000),(5642,6400100,2000002,0,1,1,0,20000),(5643,6400100,2000004,0,1,1,0,20000),(5647,6400100,2002008,0,1,1,0,20000),(5648,6400100,2044001,0,1,1,0,100),(5649,6400100,2041013,0,1,1,0,100),(5650,6400100,1051046,0,1,1,0,800),(5651,6400100,1002268,0,1,1,0,800),(5652,6400100,1072149,0,1,1,0,800),(5653,6400100,1002282,0,1,1,0,800),(5654,6400100,1041099,0,1,1,0,800),(5655,6400100,1061098,0,1,1,0,800),(5656,6400100,1050061,0,1,1,0,800),(5657,6400100,1082098,0,1,1,0,800),(5658,6400100,1092017,0,1,1,0,800),(5659,6400100,1472029,0,1,1,0,800),(5660,6400100,1002289,0,1,1,0,800),(5661,6400100,1002252,0,1,1,0,800),(5662,6400100,1040106,0,1,1,0,800),(5663,6400100,1060094,0,1,1,0,800),(5664,6400100,1412008,0,1,1,0,800),(5665,6400100,1032022,0,1,1,0,800),(5666,6400100,1051058,0,1,1,0,800),(5667,6400100,1050077,0,1,1,0,800),(5668,6400100,1072173,0,1,1,0,800),(5669,6400100,1082116,0,1,1,0,800),(5670,6400100,1082207,0,1,1,0,800),(5671,6400100,2040321,0,1,1,0,100),(5672,6400100,2040534,0,1,1,0,100),(5673,6400100,2043114,0,1,1,0,100),(5674,6400100,4130000,0,1,1,0,6000),(5675,6400100,4130002,0,1,1,0,6000),(5676,6400100,4130013,0,1,1,0,6000),(5677,7090000,4000411,0,1,1,0,600000),(5678,7110300,2000006,0,1,1,0,20000),(5681,7110300,2043701,0,1,1,0,100),(5682,7110300,2044701,0,1,1,0,100),(5684,7110300,4006000,0,1,1,0,10000),(5685,7110300,2040302,0,1,1,0,100),(5686,7110300,1050055,0,1,1,0,800),(5687,7110300,1041094,0,1,1,0,800),(5688,7110300,1061093,0,1,1,0,800),(5689,7110300,1050069,0,1,1,0,800),(5690,7110300,1040102,0,1,1,0,800),(5691,7110300,1060090,0,1,1,0,800),(5692,7110300,1082100,0,1,1,0,800),(5693,7110300,1041102,0,1,1,0,800),(5694,7110300,1061101,0,1,1,0,800),(5695,7110300,1002254,0,1,1,0,800),(5696,7110300,1002288,0,1,1,0,800),(5697,7110300,1092015,0,1,1,0,800),(5698,7110300,1332018,0,1,1,0,800),(5699,7110300,1402012,0,1,1,0,800),(5700,7110300,1472029,0,1,1,0,800),(5701,7110300,1322020,0,1,1,0,800),(5702,7110300,1002273,0,1,1,0,800),(5703,7110300,1002339,0,1,1,0,800),(5704,7110300,1051066,0,1,1,0,800),(5705,7110300,1041105,0,1,1,0,800),(5706,7110300,1061104,0,1,1,0,800),(5707,7110300,4000362,0,1,1,0,600000),(5708,7110300,1082204,0,1,1,0,800),(5709,7110300,2330003,0,1,1,0,100),(5710,7110300,2040026,0,1,1,0,100),(5711,7110300,2040319,0,1,1,0,100),(5712,7110300,4130009,0,1,1,0,6000),(5713,7110300,4130015,0,1,1,0,6000),(5714,7110301,2000006,0,1,1,0,20000),(5715,7110301,2000004,0,1,1,0,20000),(5719,7110301,2044601,0,1,1,0,100),(5720,7110301,1051044,0,1,1,0,800),(5721,7110301,1002029,0,1,1,0,800),(5722,7110301,1002248,0,1,1,0,800),(5723,7110301,1051041,0,1,1,0,800),(5724,7110301,1072147,0,1,1,0,800),(5725,7110301,1072150,0,1,1,0,800),(5726,7110301,1072145,0,1,1,0,800),(5727,7110301,1051053,0,1,1,0,800),(5728,7110301,1002094,0,1,1,0,800),(5729,7110301,1002253,0,1,1,0,800),(5730,7110301,1051062,0,1,1,0,800),(5731,7110301,1040105,0,1,1,0,800),(5732,7110301,1060093,0,1,1,0,800),(5733,7110301,1050063,0,1,1,0,800),(5734,7110301,1402012,0,1,1,0,800),(5735,7110301,1040108,0,1,1,0,800),(5736,7110301,1060097,0,1,1,0,800),(5737,7110301,1072210,0,1,1,0,800),(5738,7110301,1002275,0,1,1,0,800),(5739,7110301,1072177,0,1,1,0,800),(5740,7110301,4000361,0,1,1,0,600000),(5741,7110301,1482010,0,1,1,0,800),(5742,7110301,2044801,0,1,1,0,100),(5743,7110301,2040025,0,1,1,0,100),(5744,7110301,2040621,0,1,1,0,100),(5745,7110301,2040933,0,1,1,0,100),(5746,7110301,4130004,0,1,1,0,6000),(5747,7110301,4130005,0,1,1,0,6000),(5748,7110301,4130007,0,1,1,0,6000),(5749,7130000,4000074,0,1,1,0,600000),(5750,7130000,2050004,0,1,1,0,50000),(5751,7130000,2000006,0,1,1,0,20000),(5752,7130000,2000004,0,1,1,0,20000),(5755,7130000,4006001,0,1,1,0,10000),(5757,7130000,2044601,0,1,1,0,100),(5758,7130000,1051044,0,1,1,0,800),(5759,7130000,1002029,0,1,1,0,800),(5760,7130000,1002248,0,1,1,0,800),(5761,7130000,1051041,0,1,1,0,800),(5762,7130000,1072147,0,1,1,0,800),(5763,7130000,1072150,0,1,1,0,800),(5764,7130000,1072145,0,1,1,0,800),(5765,7130000,1051053,0,1,1,0,800),(5766,7130000,1002094,0,1,1,0,800),(5767,7130000,1002253,0,1,1,0,800),(5768,7130000,1051062,0,1,1,0,800),(5769,7130000,1040105,0,1,1,0,800),(5770,7130000,1060093,0,1,1,0,800),(5771,7130000,1050063,0,1,1,0,800),(5772,7130000,1402012,0,1,1,0,800),(5773,7130000,1040108,0,1,1,0,800),(5774,7130000,1060097,0,1,1,0,800),(5775,7130000,1072210,0,1,1,0,800),(5776,7130000,1002275,0,1,1,0,800),(5777,7130000,1072177,0,1,1,0,800),(5778,7130000,4161021,0,1,1,0,6000),(5779,7130000,1072312,0,1,1,0,800),(5780,7130000,2044901,0,1,1,0,100),(5781,7130000,2040419,0,1,1,0,100),(5782,7130000,2040412,0,1,1,0,100),(5783,7130000,4130008,0,1,1,0,6000),(5784,7130000,4130010,0,1,1,0,6000),(5785,7130000,4130011,0,1,1,0,6000),(5786,7130001,4000079,0,1,1,0,600000),(5787,7130001,2050000,0,1,1,0,50000),(5788,7130001,2000006,0,1,1,0,20000),(5789,7130001,2000004,0,1,1,0,20000),(5792,7130001,2044301,0,1,1,0,100),(5793,7130001,2041021,0,1,1,0,100),(5794,7130001,1312009,0,1,1,0,800),(5795,7130001,1332015,0,1,1,0,800),(5796,7130001,1402011,0,1,1,0,800),(5797,7130001,1002246,0,1,1,0,800),(5798,7130001,1032014,0,1,1,0,800),(5799,7130001,1041095,0,1,1,0,800),(5800,7130001,1061094,0,1,1,0,800),(5801,7130001,1072146,0,1,1,0,800),(5802,7130001,1051054,0,1,1,0,800),(5803,7130001,1372015,0,1,1,0,800),(5804,7130001,1050070,0,1,1,0,800),(5805,7130001,1050069,0,1,1,0,800),(5806,7130001,1072165,0,1,1,0,800),(5807,7130001,1082105,0,1,1,0,800),(5808,7130001,1082108,0,1,1,0,800),(5809,7130001,1041102,0,1,1,0,800),(5810,7130001,1061101,0,1,1,0,800),(5811,7130001,1002095,0,1,1,0,800),(5812,7130001,1032016,0,1,1,0,800),(5813,7130001,1372016,0,1,1,0,800),(5814,7130001,1492009,0,1,1,0,800),(5815,7130001,2040618,0,1,1,0,100),(5816,7130001,4130002,0,1,1,0,6000),(5817,7130001,4130003,0,1,1,0,6000),(5818,7130002,4000236,0,1,1,0,600000),(5819,7130002,2000006,0,1,1,0,20000),(5820,7130002,2000004,0,1,1,0,20000),(5823,7130002,2040902,0,1,1,0,100),(5824,7130002,2040801,0,1,1,0,100),(5825,7130002,4006000,0,1,1,0,10000),(5827,7130002,1040103,0,1,1,0,800),(5828,7130002,1060091,0,1,1,0,800),(5829,7130002,1082100,0,1,1,0,800),(5830,7130002,1072184,0,1,1,0,800),(5831,7130002,1002285,0,1,1,0,800),(5832,7130002,1302012,0,1,1,0,800),(5833,7130002,1332019,0,1,1,0,800),(5834,7130002,1382007,0,1,1,0,800),(5835,7130002,1092011,0,1,1,0,800),(5836,7130002,1002640,0,1,1,0,800),(5837,7130002,2330003,0,1,1,0,100),(5838,7130002,2040625,0,1,1,0,100),(5839,7130002,2044014,0,1,1,0,100),(5840,7130002,4130000,0,1,1,0,6000),(5841,7130002,4130005,0,1,1,0,6000),(5842,7130003,4000237,0,1,1,0,600000),(5843,7130003,2000006,0,1,1,0,20000),(5844,7130003,2000004,0,1,1,0,20000),(5847,7130003,2044101,0,1,1,0,100),(5848,7130003,2041002,0,1,1,0,100),(5849,7130003,4006000,0,1,1,0,10000),(5851,7130003,2070005,0,1,1,0,200),(5852,7130003,1072156,0,1,1,0,800),(5853,7130003,1002253,0,1,1,0,800),(5854,7130003,1051063,0,1,1,0,800),(5855,7130003,1082096,0,1,1,0,800),(5856,7130003,1092016,0,1,1,0,800),(5857,7130003,1432007,0,1,1,0,800),(5858,7130003,1372015,0,1,1,0,800),(5859,7130003,1412008,0,1,1,0,800),(5860,7130003,1002640,0,1,1,0,800),(5861,7130003,2040423,0,1,1,0,100),(5862,7130003,4130001,0,1,1,0,6000),(5863,7130003,4130010,0,1,1,0,6000),(5864,7130003,4130013,0,1,1,0,6000),(5865,7130004,4000231,0,1,1,0,600000),(5866,7130004,2000006,0,1,1,0,20000),(5867,7130004,2000004,0,1,1,0,20000),(5870,7130004,2041008,0,1,1,0,100),(5871,7130004,2044401,0,1,1,0,100),(5872,7130004,4006001,0,1,1,0,10000),(5874,7130004,1002338,0,1,1,0,800),(5875,7130004,1050074,0,1,1,0,800),(5876,7130004,1082107,0,1,1,0,800),(5877,7130004,1072161,0,1,1,0,800),(5878,7130004,1102029,0,1,1,0,800),(5879,7130004,1452010,0,1,1,0,800),(5880,7130004,1402012,0,1,1,0,800),(5881,7130004,1322028,0,1,1,0,800),(5882,7130004,1032022,0,1,1,0,800),(5883,7130004,1072312,0,1,1,0,800),(5884,7130004,2330003,0,1,1,0,100),(5885,7130010,4000147,0,1,1,0,600000),(5886,7130010,2050004,0,1,1,0,50000),(5887,7130010,2000006,0,1,1,0,20000),(5888,7130010,2000002,0,1,1,0,20000),(5889,7130010,2002005,0,1,1,0,20000),(5890,7130010,2020015,0,1,1,0,20000),(5894,7130010,4006001,0,1,1,0,10000),(5895,7130010,2040601,0,1,1,0,100),(5896,7130010,2041016,0,1,1,0,100),(5897,7130010,1302016,0,1,1,0,800),(5898,7130010,1051065,0,1,1,0,800),(5899,7130010,1072154,0,1,1,0,800),(5900,7130010,1041101,0,1,1,0,800),(5901,7130010,1061100,0,1,1,0,800),(5902,7130010,1452010,0,1,1,0,800),(5903,7130010,1102030,0,1,1,0,800),(5904,7130010,1050073,0,1,1,0,800),(5905,7130010,1412009,0,1,1,0,800),(5906,7130010,1332022,0,1,1,0,800),(5907,7130010,1082123,0,1,1,0,800),(5908,7130010,1082118,0,1,1,0,800),(5909,7130010,1051078,0,1,1,0,800),(5910,7130010,1072184,0,1,1,0,800),(5911,7130010,1002328,0,1,1,0,800),(5912,7130010,1051077,0,1,1,0,800),(5913,7130010,1050088,0,1,1,0,800),(5914,7130010,1072196,0,1,1,0,800),(5915,7130010,1072209,0,1,1,0,800),(5916,7130010,1082142,0,1,1,0,800),(5917,7130010,1372016,0,1,1,0,800),(5918,7130010,1082207,0,1,1,0,800),(5919,7130010,2040025,0,1,1,0,100),(5920,7130010,2040418,0,1,1,0,100),(5921,7130010,2040923,0,1,1,0,100),(5922,7130010,2040928,0,1,1,0,100),(5923,7130010,2044412,0,1,1,0,100),(5924,7130010,4130002,0,1,1,0,6000),(5925,7130010,4130004,0,1,1,0,6000),(5926,7130010,4130006,0,1,1,0,6000),(5927,7130020,4000179,0,1,1,0,600000),(5928,7130020,2050004,0,1,1,0,50000),(5929,7130020,2000006,0,1,1,0,20000),(5930,7130020,2000002,0,1,1,0,20000),(5931,7130020,2002003,0,1,1,0,20000),(5932,7130020,2020015,0,1,1,0,20000),(5933,7130020,2022040,0,1,1,0,20000),(5934,7130020,1072164,0,1,1,0,800),(5938,7130020,4006001,0,1,1,0,10000),(5939,7130020,1002329,0,1,1,0,800),(5940,7130020,2044701,0,1,1,0,100),(5941,7130020,1002287,0,1,1,0,800),(5942,7130020,1041101,0,1,1,0,800),(5943,7130020,1061100,0,1,1,0,800),(5944,7130020,1051095,0,1,1,0,800),(5945,7130020,1051078,0,1,1,0,800),(5946,7130020,1072152,0,1,1,0,800),(5947,7130020,2048001,0,1,1,0,100),(5948,7130020,1422012,0,1,1,0,800),(5949,7130020,1002323,0,1,1,0,800),(5950,7130020,1102032,0,1,1,0,800),(5951,7130020,1072194,0,1,1,0,800),(5952,7130020,1102035,0,1,1,0,800),(5953,7130020,1072312,0,1,1,0,800),(5954,7130020,2044901,0,1,1,0,100),(5955,7130020,2040324,0,1,1,0,100),(5956,7130020,2040421,0,1,1,0,100),(5957,7130020,4130010,0,1,1,0,6000),(5958,7130020,4130013,0,1,1,0,6000),(5959,7130100,2000006,0,1,1,0,20000),(5960,7130100,2000004,0,1,1,0,20000),(5962,7130100,4000028,0,1,1,0,600000),(5963,7130100,2070005,0,1,1,0,200),(5964,7130100,2043101,0,1,1,0,100),(5965,7130100,4006000,0,1,1,0,10000),(5966,7130100,1041093,0,1,1,0,800),(5967,7130100,1061092,0,1,1,0,800),(5968,7130100,1040100,0,1,1,0,800),(5969,7130100,1060089,0,1,1,0,800),(5970,7130100,1050067,0,1,1,0,800),(5971,7130100,1051055,0,1,1,0,800),(5972,7130100,1002095,0,1,1,0,800),(5973,7130100,1002287,0,1,1,0,800),(5974,7130100,1002283,0,1,1,0,800),(5975,7130100,1051064,0,1,1,0,800),(5976,7130100,1072163,0,1,1,0,800),(5977,7130100,1322019,0,1,1,0,800),(5978,7130100,1452009,0,1,1,0,800),(5979,7130100,1472026,0,1,1,0,800),(5980,7130100,1102027,0,1,1,0,800),(5981,7130100,1082115,0,1,1,0,800),(5982,7130100,1072184,0,1,1,0,800),(5983,7130100,1002272,0,1,1,0,800),(5984,7130100,1082118,0,1,1,0,800),(5985,7130100,1002637,0,1,1,0,800),(5986,7130100,2040421,0,1,1,0,100),(5987,7130100,2049000,0,1,1,0,150),(5988,7130100,4130008,0,1,1,0,6000),(5989,7130100,4130014,0,1,1,0,6000),(5990,7130101,2000005,0,1,1,0,20000),(5993,7130101,2044101,0,1,1,0,100),(5994,7130101,4000046,0,1,1,0,600000),(5995,7130101,4006001,0,1,1,0,10000),(5996,7130101,1051047,0,1,1,0,800),(5997,7130101,1041091,0,1,1,0,800),(5998,7130101,1061090,0,1,1,0,800),(5999,7130101,1412008,0,1,1,0,800),(6000,7130101,1452011,0,1,1,0,800),(6001,7130101,1422010,0,1,1,0,800),(6002,7130101,1082100,0,1,1,0,800),(6003,7130101,1072167,0,1,1,0,800),(6004,7130101,1041103,0,1,1,0,800),(6005,7130101,1061102,0,1,1,0,800),(6006,7130101,1092016,0,1,1,0,800),(6007,7130101,1051063,0,1,1,0,800),(6008,7130101,1002284,0,1,1,0,800),(6009,7130101,1082104,0,1,1,0,800),(6010,7130101,1102028,0,1,1,0,800),(6011,7130101,1382010,0,1,1,0,800),(6012,7130101,1051056,0,1,1,0,800),(6013,7130101,1002327,0,1,1,0,800),(6014,7130101,1050077,0,1,1,0,800),(6015,7130101,1072211,0,1,1,0,800),(6016,7130101,1482009,0,1,1,0,800),(6017,7130101,2044114,0,1,1,0,100),(6018,7130101,4130008,0,1,1,0,6000),(6019,7130101,4130012,0,1,1,0,6000),(6020,7130101,4130014,0,1,1,0,6000),(6021,7130102,4000050,0,1,1,0,600000),(6022,7130102,2041020,0,1,1,0,100),(6023,7130102,2000006,0,1,1,0,20000),(6024,7130102,2000004,0,1,1,0,20000),(6027,7130102,2043801,0,1,1,0,100),(6028,7130102,2044702,0,1,1,0,100),(6029,7130102,2070010,0,1,1,0,500),(6031,7130102,2041005,0,1,1,0,100),(6032,7130102,1002185,0,1,1,0,800),(6033,7130102,1041081,0,1,1,0,800),(6034,7130102,1061080,0,1,1,0,800),(6035,7130102,1050047,0,1,1,0,800),(6036,7130102,1002028,0,1,1,0,800),(6037,7130102,1072124,0,1,1,0,800),(6038,7130102,1072128,0,1,1,0,800),(6039,7130102,1082081,0,1,1,0,800),(6040,7130102,1082010,0,1,1,0,800),(6041,7130102,1432006,0,1,1,0,800),(6042,7130102,1472022,0,1,1,0,800),(6043,7130102,1082091,0,1,1,0,800),(6044,7130102,1442010,0,1,1,0,800),(6045,7130102,1102023,0,1,1,0,800),(6046,7130102,1072137,0,1,1,0,800),(6047,7130102,1050068,0,1,1,0,800),(6048,7130102,1002030,0,1,1,0,800),(6049,7130102,1002282,0,1,1,0,800),(6050,7130102,1050063,0,1,1,0,800),(6051,7130102,1492008,0,1,1,0,800),(6052,7130102,2044901,0,1,1,0,100),(6053,7130102,2040625,0,1,1,0,100),(6054,7130102,4130010,0,1,1,0,6000),(6055,7130102,4130017,0,1,1,0,6000),(6056,7130102,4000049,0,1,1,0,600000),(6057,7130102,4130003,0,1,1,0,6000),(6058,7130102,4003005,0,1,1,0,200000),(6059,7130102,2041023,0,1,1,0,100),(6060,7130102,4000021,0,1,1,0,50000),(6063,7130102,1050069,0,1,1,0,800),(6064,7130102,1051054,0,1,1,0,800),(6065,7130102,2044101,0,1,1,0,100),(6066,7130102,1402012,0,1,1,0,800),(6067,7130102,1422009,0,1,1,0,800),(6068,7130102,2070005,0,1,1,0,200),(6069,7130102,1050074,0,1,1,0,800),(6070,7130102,1051058,0,1,1,0,800),(6071,7130102,1032011,0,1,1,0,800),(6072,7130102,1092006,0,1,1,0,800),(6073,7130102,1332015,0,1,1,0,800),(6074,7130102,1002084,0,1,1,0,800),(6076,7130102,1452011,0,1,1,0,800),(6077,7130102,2040025,0,1,1,0,100),(6078,7130102,2043017,0,1,1,0,100),(6079,7130102,2043210,0,1,1,0,100),(6080,7130102,2044214,0,1,1,0,100),(6081,7130103,4000208,0,1,1,0,600000),(6082,7130103,2002003,0,1,1,0,20000),(6083,7130103,2002004,0,1,1,0,20000),(6084,7130103,2000006,0,1,1,0,20000),(6085,7130103,2000004,0,1,1,0,20000),(6089,7130103,4006001,0,1,1,0,10000),(6090,7130103,2040301,0,1,1,0,100),(6091,7130103,2040516,0,1,1,0,100),(6092,7130103,1040092,0,1,1,0,800),(6093,7130103,1060081,0,1,1,0,800),(6094,7130103,1041092,0,1,1,0,800),(6095,7130103,1061091,0,1,1,0,800),(6096,7130103,1041095,0,1,1,0,800),(6097,7130103,1061094,0,1,1,0,800),(6098,7130103,1050061,0,1,1,0,800),(6099,7130103,1051063,0,1,1,0,800),(6100,7130103,1051054,0,1,1,0,800),(6101,7130103,1092023,0,1,1,0,800),(6102,7130103,1072182,0,1,1,0,800),(6103,7130103,1072172,0,1,1,0,800),(6104,7130103,1072210,0,1,1,0,800),(6105,7130103,1072177,0,1,1,0,800),(6106,7130103,1082207,0,1,1,0,800),(6107,7130103,2040418,0,1,1,0,100),(6108,7130103,4130001,0,1,1,0,6000),(6109,7130103,4130004,0,1,1,0,6000),(6110,7130103,4130012,0,1,1,0,6000),(6111,7130104,2000002,0,1,1,0,20000),(6112,7130104,2000006,0,1,1,0,20000),(6113,7130104,2000004,0,1,1,0,20000),(6116,7130104,4006001,0,1,1,0,10000),(6118,7130104,1002095,0,1,1,0,800),(6119,7130104,1051054,0,1,1,0,800),(6120,7130104,1082110,0,1,1,0,800),(6121,7130104,1072163,0,1,1,0,800),(6122,7130104,1472028,0,1,1,0,800),(6123,7130104,1032020,0,1,1,0,800),(6124,7130104,1102023,0,1,1,0,800),(6125,7130104,2040002,0,1,1,0,100),(6126,7130104,2040705,0,1,1,0,100),(6127,7130104,1332018,0,1,1,0,800),(6128,7130104,1422010,0,1,1,0,800),(6129,7130104,4000297,0,1,1,0,600000),(6130,7130104,1082204,0,1,1,0,800),(6131,7130104,2040412,0,1,1,0,100),(6132,7130104,2040824,0,1,1,0,100),(6133,7130104,2049100,0,1,1,0,150),(6134,7130104,4130000,0,1,1,0,6000),(6135,7130104,4130017,0,1,1,0,6000),(6136,7130200,4000053,0,1,1,0,600000),(6137,7130200,2000006,0,1,1,0,20000),(6140,7130200,2043701,0,1,1,0,100),(6141,7130200,2044701,0,1,1,0,100),(6143,7130200,4006000,0,1,1,0,10000),(6144,7130200,2040302,0,1,1,0,100),(6145,7130200,1050055,0,1,1,0,800),(6146,7130200,1041094,0,1,1,0,800),(6147,7130200,1061093,0,1,1,0,800),(6148,7130200,1050069,0,1,1,0,800),(6149,7130200,1040102,0,1,1,0,800),(6150,7130200,1060090,0,1,1,0,800),(6151,7130200,1082100,0,1,1,0,800),(6152,7130200,1041102,0,1,1,0,800),(6153,7130200,1061101,0,1,1,0,800),(6154,7130200,1002254,0,1,1,0,800),(6155,7130200,1002288,0,1,1,0,800),(6156,7130200,1092015,0,1,1,0,800),(6157,7130200,1332018,0,1,1,0,800),(6158,7130200,1402012,0,1,1,0,800),(6159,7130200,1472029,0,1,1,0,800),(6160,7130200,1322020,0,1,1,0,800),(6161,7130200,1002273,0,1,1,0,800),(6162,7130200,1002339,0,1,1,0,800),(6163,7130200,1051066,0,1,1,0,800),(6164,7130200,1041105,0,1,1,0,800),(6165,7130200,1061104,0,1,1,0,800),(6166,7130200,1072309,0,1,1,0,800),(6167,7130200,2040031,0,1,1,0,100),(6168,7130200,4130006,0,1,1,0,6000),(6169,7130200,4130009,0,1,1,0,6000),(6170,7130200,4130014,0,1,1,0,6000),(6171,7130300,4000148,0,1,1,0,600000),(6172,7130300,2000005,0,1,1,0,20000),(6173,7130300,2000004,0,1,1,0,20000),(6174,7130300,2002004,0,1,1,0,20000),(6175,7130300,4006001,0,1,1,0,10000),(6178,7130300,2044301,0,1,1,0,100),(6179,7130300,2041009,0,1,1,0,100),(6180,7130300,1002284,0,1,1,0,800),(6181,7130300,1002253,0,1,1,0,800),(6182,7130300,1072155,0,1,1,0,800),(6183,7130300,1072167,0,1,1,0,800),(6184,7130300,1050074,0,1,1,0,800),(6185,7130300,1302018,0,1,1,0,800),(6186,7130300,1002274,0,1,1,0,800),(6187,7130300,1002276,0,1,1,0,800),(6188,7130300,1041107,0,1,1,0,800),(6189,7130300,1061106,0,1,1,0,800),(6190,7130300,1050080,0,1,1,0,800),(6191,7130300,1051068,0,1,1,0,800),(6192,7130300,1072212,0,1,1,0,800),(6193,7130300,1082110,0,1,1,0,800),(6194,7130300,1041121,0,1,1,0,800),(6195,7130300,1061120,0,1,1,0,800),(6196,7130300,1072203,0,1,1,0,800),(6197,7130300,1072206,0,1,1,0,800),(6198,7130300,1082143,0,1,1,0,800),(6199,7130300,1072312,0,1,1,0,800),(6200,7130300,2040031,0,1,1,0,100),(6201,7130300,2040823,0,1,1,0,100),(6202,7130300,2043210,0,1,1,0,100),(6203,7130300,4130000,0,1,1,0,6000),(6207,7130400,4006001,0,1,1,0,100000),(6208,7130400,2000006,0,1,1,0,999999),(6209,7130400,2000004,0,1,1,0,999999),(6210,7130400,2002003,0,1,1,0,200000),(6211,7130400,2040504,0,1,1,0,1500),(6212,7130400,1050058,0,1,1,0,7000),(6213,7130400,1041094,0,1,1,0,8000),(6214,7130400,1061093,0,1,1,0,8000),(6215,7130400,2040302,0,1,1,0,1500),(6216,7130400,1092016,0,1,1,0,7000),(6217,7130400,1102021,0,1,1,0,10000),(6218,7130400,1462009,0,1,1,0,5000),(6219,7130400,1472024,0,1,1,0,5000),(6220,7130400,1040102,0,1,1,0,8000),(6221,7130400,1060090,0,1,1,0,8000),(6222,7130400,1072309,0,1,1,0,8000),(6223,7130400,4130002,0,1,1,0,60000),(6224,7130400,4130005,0,1,1,0,60000),(6225,7130400,4130015,0,1,1,0,60000),(6229,7130401,4006001,0,1,1,0,100000),(6230,7130401,2000006,0,1,1,0,999999),(6231,7130401,2000004,0,1,1,0,999999),(6232,7130401,2002000,0,1,1,0,200000),(6233,7130401,2040601,0,1,1,0,1500),(6234,7130401,2040701,0,1,1,0,1500),(6235,7130401,1051041,0,1,1,0,7000),(6236,7130401,1442010,0,1,1,0,7000),(6237,7130401,1072158,0,1,1,0,8000),(6238,7130401,1072163,0,1,1,0,8000),(6239,7130401,1412008,0,1,1,0,7000),(6240,7130401,1040106,0,1,1,0,8000),(6241,7130401,1060094,0,1,1,0,8000),(6242,7130401,1422009,0,1,1,0,7000),(6243,7130401,1032022,0,1,1,0,10000),(6244,7130401,1452010,0,1,1,0,5000),(6245,7130401,2070007,0,1,1,0,80),(6246,7130401,1482009,0,1,1,0,5000),(6247,7130401,2040620,0,1,1,0,1500),(6248,7130401,2044012,0,1,1,0,1500),(6249,7130401,4130006,0,1,1,0,60000),(6250,7130401,4130015,0,1,1,0,60000),(6254,7130402,4006000,0,1,1,0,100000),(6255,7130402,2000006,0,1,1,0,999999),(6256,7130402,2000004,0,1,1,0,999999),(6257,7130402,2002006,0,1,1,0,200000),(6258,7130402,2041007,0,1,1,0,1500),(6259,7130402,1032019,0,1,1,0,10000),(6260,7130402,1082090,0,1,1,0,10000),(6261,7130402,1041092,0,1,1,0,8000),(6262,7130402,1061091,0,1,1,0,8000),(6263,7130402,2043001,0,1,1,0,1500),(6264,7130402,1032022,0,1,1,0,10000),(6265,7130402,1402012,0,1,1,0,7000),(6266,7130402,1072155,0,1,1,0,8000),(6267,7130402,1422005,0,1,1,0,7000),(6268,7130402,1041101,0,1,1,0,8000),(6269,7130402,1061100,0,1,1,0,8000),(6270,7130402,2070007,0,1,1,0,80),(6271,7130402,1002637,0,1,1,0,15000),(6272,7130402,2330003,0,1,1,0,1000),(6273,7130402,2040024,0,1,1,0,1500),(6274,7130402,2040534,0,1,1,0,1500),(6275,7130402,2043112,0,1,1,0,1500),(6276,7130402,4130017,0,1,1,0,60000),(6277,7130500,4000226,0,1,1,0,600000),(6278,7130500,2000006,0,1,1,0,20000),(6279,7130500,2000004,0,1,1,0,20000),(6282,7130500,2040002,0,1,1,0,100),(6283,7130500,2040705,0,1,1,0,100),(6284,7130500,4006001,0,1,1,0,10000),(6286,7130500,1002095,0,1,1,0,800),(6287,7130500,1051054,0,1,1,0,800),(6288,7130500,1082110,0,1,1,0,800),(6289,7130500,1072163,0,1,1,0,800),(6290,7130500,1332018,0,1,1,0,800),(6291,7130500,1422010,0,1,1,0,800),(6292,7130500,1472028,0,1,1,0,800),(6293,7130500,1032020,0,1,1,0,800),(6294,7130500,1102023,0,1,1,0,800),(6295,7130500,4000227,0,1,1,0,600000),(6296,7130500,4000228,0,1,1,0,600000),(6297,7130500,1052122,0,1,1,0,800),(6298,7130500,2040326,0,1,1,0,100),(6299,7130500,2040623,0,1,1,0,100),(6300,7130500,2040824,0,1,1,0,100),(6301,7130500,4130007,0,1,1,0,6000),(6302,7130500,4130011,0,1,1,0,6000),(6303,7130500,4130015,0,1,1,0,6000),(6304,7130501,4000229,0,1,1,0,600000),(6305,7130501,2000006,0,1,1,0,20000),(6306,7130501,2000004,0,1,1,0,20000),(6309,7130501,2040505,0,1,1,0,100),(6310,7130501,2043002,0,1,1,0,100),(6311,7130501,4006001,0,1,1,0,10000),(6313,7130501,1082105,0,1,1,0,800),(6314,7130501,1072178,0,1,1,0,800),(6315,7130501,1002276,0,1,1,0,800),(6316,7130501,1041103,0,1,1,0,800),(6317,7130501,1061102,0,1,1,0,800),(6318,7130501,1472027,0,1,1,0,800),(6319,7130501,1302018,0,1,1,0,800),(6320,7130501,2070005,0,1,1,0,200),(6321,7130501,1102027,0,1,1,0,800),(6322,7130501,1092016,0,1,1,0,800),(6323,7130501,4000230,0,1,1,0,600000),(6324,7130501,1052122,0,1,1,0,800),(6325,7130501,2040321,0,1,1,0,100),(6326,7130501,2040515,0,1,1,0,100),(6327,7130501,2040625,0,1,1,0,100),(6328,7130501,4130008,0,1,1,0,6000),(6329,7130501,4130010,0,1,1,0,6000),(6330,7130600,2000006,0,1,1,0,20000),(6331,7130600,2000004,0,1,1,0,20000),(6334,7130600,2044101,0,1,1,0,100),(6335,7130600,2041008,0,1,1,0,100),(6336,7130600,4006001,0,1,1,0,10000),(6338,7130600,1051062,0,1,1,0,800),(6339,7130600,1002287,0,1,1,0,800),(6340,7130600,1082119,0,1,1,0,800),(6341,7130600,1072211,0,1,1,0,800),(6342,7130600,1332019,0,1,1,0,800),(6343,7130600,1452009,0,1,1,0,800),(6344,7130600,4000260,0,1,1,0,600000),(6345,7130600,2040512,0,1,1,0,100),(6346,7130600,2044010,0,1,1,0,100),(6347,7130600,4130001,0,1,1,0,6000),(6348,7130600,4130005,0,1,1,0,6000),(6349,7130600,4130017,0,1,1,0,6000),(6350,7130601,2000006,0,1,1,0,20000),(6351,7130601,2000004,0,1,1,0,20000),(6354,7130601,2044602,0,1,1,0,100),(6355,7130601,2043701,0,1,1,0,100),(6356,7130601,4006000,0,1,1,0,10000),(6358,7130601,1040106,0,1,1,0,800),(6359,7130601,1060094,0,1,1,0,800),(6360,7130601,1002252,0,1,1,0,800),(6361,7130601,1082125,0,1,1,0,800),(6362,7130601,1072212,0,1,1,0,800),(6363,7130601,1462009,0,1,1,0,800),(6364,7130601,1322019,0,1,1,0,800),(6365,7130601,4000261,0,1,1,0,600000),(6366,7130601,1052125,0,1,1,0,800),(6367,7130601,2044802,0,1,1,0,100),(6368,7130601,2040927,0,1,1,0,100),(6369,7130601,4130003,0,1,1,0,6000),(6370,7130601,4130011,0,1,1,0,6000),(6371,7130601,4130016,0,1,1,0,6000),(6372,7140000,4000132,0,1,1,0,600000),(6373,7140000,2000006,0,1,1,0,20000),(6377,7140000,2041001,0,1,1,0,100),(6378,7140000,2040502,0,1,1,0,100),(6379,7140000,1040107,0,1,1,0,800),(6380,7140000,1060095,0,1,1,0,800),(6381,7140000,1002094,0,1,1,0,800),(6382,7140000,1002287,0,1,1,0,800),(6383,7140000,1040108,0,1,1,0,800),(6384,7140000,1060097,0,1,1,0,800),(6385,7140000,1050082,0,1,1,0,800),(6386,7140000,1002273,0,1,1,0,800),(6387,7140000,1002277,0,1,1,0,800),(6388,7140000,1002338,0,1,1,0,800),(6389,7140000,1072182,0,1,1,0,800),(6390,7140000,1082114,0,1,1,0,800),(6391,7140000,1092025,0,1,1,0,800),(6392,7140000,1462011,0,1,1,0,800),(6393,7140000,1432010,0,1,1,0,800),(6394,7140000,1050089,0,1,1,0,800),(6395,7140000,1072192,0,1,1,0,800),(6396,7140000,1072207,0,1,1,0,800),(6397,7140000,1082128,0,1,1,0,800),(6398,7140000,1002640,0,1,1,0,800),(6399,7140000,2040924,0,1,1,0,100),(6400,7140000,2043015,0,1,1,0,100),(6401,7140000,4130001,0,1,1,0,6000),(6402,7140000,4130005,0,1,1,0,6000),(6403,7160000,4000133,0,1,1,0,600000),(6404,7160000,2000006,0,1,1,0,20000),(6405,7160000,2000002,0,1,1,0,20000),(6408,7160000,2044401,0,1,1,0,100),(6409,7160000,4006001,0,1,1,0,10000),(6411,7160000,4131007,0,1,1,0,6000),(6412,7160000,2070005,0,1,1,0,200),(6413,7160000,1050070,0,1,1,0,800),(6414,7160000,1452011,0,1,1,0,800),(6415,7160000,1082103,0,1,1,0,800),(6416,7160000,1040107,0,1,1,0,800),(6417,7160000,1060095,0,1,1,0,800),(6418,7160000,1051057,0,1,1,0,800),(6419,7160000,1002330,0,1,1,0,800),(6420,7160000,1002272,0,1,1,0,800),(6421,7160000,1032016,0,1,1,0,800),(6422,7160000,1041105,0,1,1,0,800),(6423,7160000,1061104,0,1,1,0,800),(6424,7160000,1050075,0,1,1,0,800),(6425,7160000,1051077,0,1,1,0,800),(6426,7160000,1051066,0,1,1,0,800),(6427,7160000,1072173,0,1,1,0,800),(6428,7160000,1082116,0,1,1,0,800),(6429,7160000,1082109,0,1,1,0,800),(6430,7160000,1082121,0,1,1,0,800),(6431,7160000,1041115,0,1,1,0,800),(6432,7160000,1061114,0,1,1,0,800),(6433,7160000,1072197,0,1,1,0,800),(6434,7160000,1082125,0,1,1,0,800),(6435,7160000,1082131,0,1,1,0,800),(6436,7160000,2330003,0,1,1,0,100),(6437,7160000,1492010,0,1,1,0,800),(6438,7160000,2040619,0,1,1,0,100),(6439,7160000,4130003,0,1,1,0,6000),(6440,7160000,4130007,0,1,1,0,6000),(6441,7160000,4130011,0,1,1,0,6000),(6442,7220000,4000284,0,1,1,0,600000),(6443,7220000,4000284,0,1,1,0,600000),(6444,7220000,4000284,0,1,1,0,600000),(6445,7220000,4000285,0,1,1,0,600000),(6446,7220000,4000285,0,1,1,0,600000),(6447,7220000,4000285,0,1,1,0,600000),(6448,7220000,4000021,0,1,1,0,500000),(6449,7220000,4000021,0,1,1,0,500000),(6450,7220000,4000021,0,1,1,0,500000),(6451,7220000,4000283,0,1,1,0,600000),(6452,7220000,4000283,0,1,1,0,600000),(6453,7220000,4000283,0,1,1,0,600000),(6457,7220000,2000002,0,1,1,0,200000),(6458,7220000,2000003,0,1,1,0,200000),(6459,7220000,2002004,0,1,1,0,200000),(6460,7220000,2002011,0,1,1,0,200000),(6461,7220000,2022142,0,1,1,0,200000),(6462,7220000,2040901,0,1,1,0,1500),(6463,7220000,2041001,0,1,1,0,1500),(6464,7220000,2043801,0,1,1,0,1500),(6465,7220000,2043101,0,1,1,0,1500),(6466,7220000,2041010,0,1,1,0,1500),(6467,7220000,2043301,0,1,1,0,1500),(6468,7220000,2044101,0,1,1,0,1500),(6469,7220000,2044501,0,1,1,0,1500),(6470,7220000,2041022,0,1,1,0,1500),(6471,7220000,2044601,0,1,1,0,1500),(6472,7220000,2048005,0,1,1,0,1500),(6473,7220000,2040005,0,1,1,0,1500),(6474,7220000,2040514,0,1,1,0,1500),(6475,7220000,2040705,0,1,1,0,1500),(6476,7220000,2040805,0,1,1,0,1000),(6477,7220000,2060001,0,1,1,0,300000),(6478,7220000,2061001,0,1,1,0,300000),(6479,7220000,2070004,0,1,1,0,3000),(6480,7220000,1302012,0,1,1,0,7000),(6481,7220000,1312010,0,1,1,0,7000),(6482,7220000,1322019,0,1,1,0,7000),(6483,7220000,1332018,0,1,1,0,5000),(6484,7220000,1372015,0,1,1,0,7000),(6485,7220000,1382010,0,1,1,0,7000),(6486,7220000,1402012,0,1,1,0,7000),(6487,7220000,1412008,0,1,1,0,7000),(6488,7220000,1422010,0,1,1,0,7000),(6489,7220000,1432007,0,1,1,0,5000),(6490,7220000,1442008,0,1,1,0,7000),(6491,7220000,1452011,0,1,1,0,5000),(6492,7220000,1462009,0,1,1,0,5000),(6493,7220000,1472029,0,1,1,0,5000),(6494,7220000,1482009,0,1,1,0,5000),(6495,7220000,1492009,0,1,1,0,5000),(6496,7220000,2044801,0,1,1,0,1500),(6497,7220000,2040025,0,1,1,0,1500),(6498,7220000,2040825,0,1,1,0,1500),(6499,7220000,2043019,0,1,1,0,1500),(6500,7220000,2044014,0,1,1,0,1500),(6501,7220000,2044312,0,1,1,0,1500),(6502,7220000,2044412,0,1,1,0,1500),(6503,7220000,2049100,0,1,1,0,1500),(6504,7220001,4000172,0,1,1,0,600000),(6505,7220001,4000172,0,1,1,0,600000),(6506,7220001,4000172,0,1,1,0,600000),(6507,7220001,4000172,0,1,1,0,600000),(6508,7220001,4000172,0,1,1,0,600000),(6509,7220001,4000172,0,1,1,0,600000),(6510,7220001,4000172,0,1,1,0,600000),(6511,7220001,4000172,0,1,1,0,600000),(6512,7220001,4000021,0,1,1,0,500000),(6516,7220001,2000002,0,1,1,0,200000),(6517,7220001,2000003,0,1,1,0,200000),(6518,7220001,2002002,0,1,1,0,200000),(6519,7220001,2002000,0,1,1,0,200000),(6520,7220001,2040301,0,1,1,0,1500),(6521,7220001,2040501,0,1,1,0,1500),(6522,7220001,2040513,0,1,1,0,1500),(6523,7220001,2040701,0,1,1,0,1500),(6524,7220001,2040804,0,1,1,0,1000),(6525,7220001,2041010,0,1,1,0,1500),(6526,7220001,2043301,0,1,1,0,1500),(6527,7220001,2043801,0,1,1,0,1500),(6528,7220001,2044501,0,1,1,0,1500),(6529,7220001,2041016,0,1,1,0,1500),(6530,7220001,2041017,0,1,1,0,1500),(6531,7220001,2043702,0,1,1,0,1500),(6532,7220001,2044702,0,1,1,0,1500),(6533,7220001,2040902,0,1,1,0,1500),(6534,7220001,2040602,0,1,1,0,1500),(6535,7220001,2060001,0,1,1,0,300000),(6536,7220001,2061001,0,1,1,0,300000),(6537,7220001,2070005,0,1,1,0,3000),(6538,7220001,1002095,0,1,1,0,15000),(6539,7220001,1002254,0,1,1,0,15000),(6540,7220001,1002289,0,1,1,0,15000),(6541,7220001,1002285,0,1,1,0,15000),(6542,7220001,1040103,0,1,1,0,8000),(6543,7220001,1041099,0,1,1,0,8000),(6544,7220001,1050070,0,1,1,0,7000),(6545,7220001,1051055,0,1,1,0,7000),(6546,7220001,1050064,0,1,1,0,7000),(6547,7220001,1051065,0,1,1,0,7000),(6548,7220001,1040107,0,1,1,0,8000),(6549,7220001,1041100,0,1,1,0,8000),(6550,7220001,1082105,0,1,1,0,10000),(6551,7220001,1082100,0,1,1,0,10000),(6552,7220001,1082108,0,1,1,0,10000),(6553,7220001,1082097,0,1,1,0,10000),(6554,7220001,1072156,0,1,1,0,8000),(6555,7220001,1072160,0,1,1,0,8000),(6556,7220001,1072167,0,1,1,0,8000),(6557,7220001,1072161,0,1,1,0,8000),(6558,7220001,1002637,0,1,1,0,15000),(6559,7220001,1052122,0,1,1,0,7000),(6560,7220001,1082204,0,1,1,0,10000),(6561,7220001,1072309,0,1,1,0,8000),(6562,7220001,2044802,0,1,1,0,1500),(6563,7220001,2044901,0,1,1,0,1500),(6564,7220001,2040025,0,1,1,0,1500),(6565,7220001,2040412,0,1,1,0,1500),(6566,7220001,2040625,0,1,1,0,1500),(6567,7220001,2040933,0,1,1,0,1500),(6568,7220001,2043017,0,1,1,0,1500),(6569,7220002,4000298,0,1,1,0,600000),(6570,7220002,4000298,0,1,1,0,600000),(6571,7220002,4000298,0,1,1,0,600000),(6572,7220002,4000289,0,1,1,0,600000),(6573,7220002,4000289,0,1,1,0,600000),(6574,7220002,4000289,0,1,1,0,600000),(6575,7220002,4003005,0,1,1,0,200000),(6579,7220002,2000002,0,1,1,0,200000),(6580,7220002,2000003,0,1,1,0,200000),(6581,7220002,2002002,0,1,1,0,200000),(6582,7220002,2002003,0,1,1,0,200000),(6583,7220002,2022149,0,1,1,0,200000),(6584,7220002,2040004,0,1,1,0,1500),(6585,7220002,2040504,0,1,1,0,1500),(6586,7220002,2040601,0,1,1,0,1500),(6587,7220002,2040701,0,1,1,0,1500),(6588,7220002,2040707,0,1,1,0,1500),(6589,7220002,2040801,0,1,1,0,1500),(6590,7220002,2041010,0,1,1,0,1500),(6591,7220002,2043101,0,1,1,0,1500),(6592,7220002,2044001,0,1,1,0,1500),(6593,7220002,2044601,0,1,1,0,1500),(6594,7220002,2040402,0,1,1,0,1500),(6595,7220002,2040514,0,1,1,0,1500),(6596,7220002,2040702,0,1,1,0,1500),(6597,7220002,2041005,0,1,1,0,1500),(6598,7220002,2044302,0,1,1,0,1500),(6599,7220002,2060001,0,1,1,0,300000),(6600,7220002,2061001,0,1,1,0,300000),(6601,7220002,1302018,0,1,1,0,7000),(6602,7220002,1312011,0,1,1,0,7000),(6603,7220002,1322028,0,1,1,0,7000),(6604,7220002,1332023,0,1,1,0,5000),(6605,7220002,1372016,0,1,1,0,7000),(6606,7220002,1382008,0,1,1,0,7000),(6607,7220002,1402004,0,1,1,0,7000),(6608,7220002,1412009,0,1,1,0,7000),(6609,7220002,1422012,0,1,1,0,7000),(6610,7220002,1432010,0,1,1,0,5000),(6611,7220002,1442019,0,1,1,0,7000),(6612,7220002,1452015,0,1,1,0,5000),(6613,7220002,1462013,0,1,1,0,5000),(6614,7220002,1472031,0,1,1,0,5000),(6615,7220002,1482010,0,1,1,0,5000),(6616,7220002,1492010,0,1,1,0,5000),(6617,7220002,2044902,0,1,1,0,1500),(6618,7220002,2040619,0,1,1,0,1500),(6619,7220002,2044414,0,1,1,0,1500),(6620,7220002,2049000,0,1,1,0,1500),(6621,8090000,4000418,0,1,1,0,600000),(6622,8110300,2000006,0,1,1,0,20000),(6623,8110300,2000005,0,1,1,0,20000),(6626,8110300,2044602,0,1,1,0,100),(6627,8110300,2041005,0,1,1,0,100),(6628,8110300,4006000,0,1,1,0,10000),(6630,8110300,2000002,0,1,1,0,20000),(6631,8110300,2070005,0,1,1,0,200),(6632,8110300,1082114,0,1,1,0,800),(6633,8110300,1072158,0,1,1,0,800),(6634,8110300,1002288,0,1,1,0,800),(6635,8110300,1040107,0,1,1,0,800),(6636,8110300,1060095,0,1,1,0,800),(6637,8110300,1452011,0,1,1,0,800),(6638,8110300,1442008,0,1,1,0,800),(6639,8110300,1312010,0,1,1,0,800),(6640,8110300,1102031,0,1,1,0,800),(6641,8110300,4000355,0,1,1,0,600000),(6642,8110300,2044902,0,1,1,0,100),(6643,8110300,2044807,0,1,1,0,100),(6644,8110300,4130012,0,1,1,0,6000),(6645,8110300,4130013,0,1,1,0,6000),(6646,8130100,4021008,0,1,1,0,90000),(6647,8130100,2000005,0,1,1,0,999999),(6648,8130100,1452009,0,1,1,0,5000),(6649,8130100,1382007,0,1,1,0,7000),(6650,8130100,1462009,0,1,1,0,5000),(6651,8130100,1322019,0,1,1,0,7000),(6652,8130100,1312010,0,1,1,0,7000),(6653,8130100,1412008,0,1,1,0,7000),(6654,8130100,1422010,0,1,1,0,7000),(6655,8130100,1472026,0,1,1,0,5000),(6656,8130100,1432007,0,1,1,0,5000),(6657,8130100,1442008,0,1,1,0,7000),(6658,8130100,1302012,0,1,1,0,7000),(6659,8130100,1402012,0,1,1,0,7000),(6660,8130100,1332018,0,1,1,0,5000),(6661,8130100,1332019,0,1,1,0,5000),(6662,8130100,2043001,0,1,1,0,1500),(6663,8130100,2043101,0,1,1,0,1500),(6664,8130100,2043201,0,1,1,0,1500),(6665,8130100,2043301,0,1,1,0,1500),(6666,8130100,2043701,0,1,1,0,1500),(6667,8130100,2043801,0,1,1,0,1500),(6668,8130100,2044001,0,1,1,0,1500),(6669,8130100,2044101,0,1,1,0,1500),(6670,8130100,2044201,0,1,1,0,1500),(6671,8130100,2044301,0,1,1,0,1500),(6672,8130100,2044401,0,1,1,0,1500),(6673,8130100,2044501,0,1,1,0,1500),(6674,8130100,2044601,0,1,1,0,1500),(6675,8130100,2044701,0,1,1,0,1500),(6676,8130100,2000004,0,1,1,0,999999),(6677,8130100,1092016,0,1,1,0,7000),(6678,8130100,2070007,0,1,1,0,300),(6679,8130100,1482009,0,1,1,0,5000),(6680,8130100,1492009,0,1,1,0,5000),(6681,8130100,2044801,0,1,1,0,1500),(6682,8130100,2044901,0,1,1,0,1500),(6683,8130100,2040419,0,1,1,0,1500),(6684,8130100,2040622,0,1,1,0,1500),(6685,8130100,2049000,0,1,1,0,1500),(6686,8140000,4000054,0,1,1,0,600000),(6687,8140000,4003005,0,1,1,0,200000),(6688,8140000,1402004,0,1,1,0,800),(6689,8140000,2040902,0,1,1,0,100),(6690,8140000,2070006,0,1,1,0,100),(6695,8140000,4006001,0,1,1,0,10000),(6697,8140000,1051053,0,1,1,0,800),(6698,8140000,1442008,0,1,1,0,800),(6699,8140000,1002285,0,1,1,0,800),(6700,8140000,1040104,0,1,1,0,800),(6701,8140000,1060092,0,1,1,0,800),(6702,8140000,1050064,0,1,1,0,800),(6703,8140000,1472028,0,1,1,0,800),(6704,8140000,1102029,0,1,1,0,800),(6705,8140000,1002271,0,1,1,0,800),(6706,8140000,1002275,0,1,1,0,800),(6707,8140000,1072172,0,1,1,0,800),(6708,8140000,1072178,0,1,1,0,800),(6709,8140000,1072210,0,1,1,0,800),(6710,8140000,1032023,0,1,1,0,800),(6711,8140000,1050092,0,1,1,0,800),(6712,8140000,1051082,0,1,1,0,800),(6713,8140000,1072193,0,1,1,0,800),(6714,8140000,1082129,0,1,1,0,800),(6715,8140000,1482010,0,1,1,0,800),(6716,8140000,2040825,0,1,1,0,100),(6717,8140000,2040933,0,1,1,0,100),(6718,8140000,2044010,0,1,1,0,100),(6719,8140000,4130007,0,1,1,0,6000),(6720,8140001,4000238,0,1,1,0,600000),(6721,8140001,2000006,0,1,1,0,20000),(6722,8140001,2000005,0,1,1,0,20000),(6725,8140001,2044602,0,1,1,0,100),(6726,8140001,2041005,0,1,1,0,100),(6727,8140001,4006000,0,1,1,0,10000),(6729,8140001,2000002,0,1,1,0,20000),(6730,8140001,2070005,0,1,1,0,200),(6731,8140001,1082114,0,1,1,0,800),(6732,8140001,1072158,0,1,1,0,800),(6733,8140001,1002288,0,1,1,0,800),(6734,8140001,1040107,0,1,1,0,800),(6735,8140001,1060095,0,1,1,0,800),(6736,8140001,1452011,0,1,1,0,800),(6737,8140001,1442008,0,1,1,0,800),(6738,8140001,1312010,0,1,1,0,800),(6739,8140001,1102031,0,1,1,0,800),(6740,8140001,1492010,0,1,1,0,800),(6741,8140001,2040318,0,1,1,0,100),(6742,8140001,2040824,0,1,1,0,100),(6743,8140001,2044310,0,1,1,0,100),(6744,8140001,2044805,0,1,1,0,100),(6745,8140001,4130004,0,1,1,0,6000),(6746,8140001,4130015,0,1,1,0,6000),(6747,8140001,4130016,0,1,1,0,6000),(6748,8140002,4000239,0,1,1,0,600000),(6749,8140002,2000006,0,1,1,0,20000),(6750,8140002,2000005,0,1,1,0,20000),(6753,8140002,2040707,0,1,1,0,100),(6754,8140002,2043301,0,1,1,0,100),(6755,8140002,4006001,0,1,1,0,10000),(6757,8140002,2000002,0,1,1,0,20000),(6758,8140002,1102030,0,1,1,0,800),(6759,8140002,1002339,0,1,1,0,800),(6760,8140002,1051057,0,1,1,0,800),(6761,8140002,1082112,0,1,1,0,800),(6762,8140002,1072173,0,1,1,0,800),(6763,8140002,1472029,0,1,1,0,800),(6764,8140002,1382010,0,1,1,0,800),(6765,8140002,1462012,0,1,1,0,800),(6766,8140002,2070005,0,1,1,0,200),(6767,8140002,1032022,0,1,1,0,800),(6768,8140002,4000240,0,1,1,0,600000),(6769,8140002,1052125,0,1,1,0,800),(6770,8140002,2330003,0,1,1,0,100),(6771,8140002,2040026,0,1,1,0,100),(6772,8140002,2040316,0,1,1,0,100),(6773,8140002,2043015,0,1,1,0,100),(6774,8140002,2049000,0,1,1,0,150),(6775,8140002,4130000,0,1,1,0,6000),(6776,8140002,4130002,0,1,1,0,6000),(6777,8140002,4130010,0,1,1,0,6000),(6778,8140100,4000057,0,1,1,0,600000),(6780,8140100,2000006,0,1,1,0,20000),(6781,8140100,2000004,0,1,1,0,20000),(6784,8140100,2070004,0,1,1,0,300),(6786,8140100,4006000,0,1,1,0,10000),(6787,8140100,1002217,0,1,1,0,800),(6788,8140100,1032013,0,1,1,0,800),(6789,8140100,1072131,0,1,1,0,800),(6790,8140100,1050055,0,1,1,0,800),(6791,8140100,1422009,0,1,1,0,800),(6792,8140100,1072152,0,1,1,0,800),(6793,8140100,1002267,0,1,1,0,800),(6794,8140100,1041092,0,1,1,0,800),(6795,8140100,1061091,0,1,1,0,800),(6796,8140100,1092009,0,1,1,0,800),(6797,8140100,1102021,0,1,1,0,800),(6798,8140100,1032020,0,1,1,0,800),(6799,8140100,1462009,0,1,1,0,800),(6800,8140100,1302012,0,1,1,0,800),(6801,8140100,1082095,0,1,1,0,800),(6802,8140100,1082099,0,1,1,0,800),(6803,8140100,1002283,0,1,1,0,800),(6804,8140100,2040328,0,1,1,0,100),(6805,8140100,2040512,0,1,1,0,100),(6806,8140100,4130002,0,1,1,0,6000),(6807,8140100,4130003,0,1,1,0,6000),(6808,8140100,4130009,0,1,1,0,6000),(6809,8140100,4000056,0,1,1,0,600000),(6810,8140100,4003004,0,1,1,0,200000),(6814,8140100,1072127,0,1,1,0,800),(6815,8140100,1412007,0,1,1,0,800),(6816,8140100,1332019,0,1,1,0,800),(6817,8140100,1472022,0,1,1,0,800),(6818,8140100,1302011,0,1,1,0,800),(6819,8140100,2044001,0,1,1,0,100),(6820,8140100,2043801,0,1,1,0,100),(6821,8140100,1051030,0,1,1,0,800),(6822,8140100,1051031,0,1,1,0,800),(6823,8140100,1051034,0,1,1,0,800),(6824,8140100,1412003,0,1,1,0,800),(6825,8140100,1302018,0,1,1,0,800),(6827,8140100,1040100,0,1,1,0,800),(6828,8140100,1060089,0,1,1,0,800),(6829,8140100,1492009,0,1,1,0,800),(6830,8140100,2044802,0,1,1,0,100),(6831,8140100,2040318,0,1,1,0,100),(6832,8140100,2040619,0,1,1,0,100),(6833,8140100,2040927,0,1,1,0,100),(6834,8140100,2044012,0,1,1,0,100),(6835,8140100,4130004,0,1,1,0,6000),(6836,8140101,4000234,0,1,1,0,600000),(6837,8140101,2000006,0,1,1,0,20000),(6838,8140101,2000005,0,1,1,0,20000),(6841,8140101,2048004,0,1,1,0,100),(6842,8140101,2040901,0,1,1,0,100),(6843,8140101,4006001,0,1,1,0,10000),(6845,8140101,2000002,0,1,1,0,20000),(6846,8140101,1082117,0,1,1,0,800),(6847,8140101,1072179,0,1,1,0,800),(6848,8140101,1002328,0,1,1,0,800),(6849,8140101,1040109,0,1,1,0,800),(6850,8140101,1060098,0,1,1,0,800),(6851,8140101,1452014,0,1,1,0,800),(6852,8140101,1382008,0,1,1,0,800),(6853,8140101,1032023,0,1,1,0,800),(6854,8140101,1092026,0,1,1,0,800),(6855,8140101,1312030,0,1,1,0,800),(6856,8140101,1402035,0,1,1,0,800),(6857,8140101,1472053,0,1,1,0,800),(6858,8140101,1002640,0,1,1,0,800),(6859,8140101,2040825,0,1,1,0,100),(6860,8140101,4130001,0,1,1,0,6000),(6861,8140101,4130007,0,1,1,0,6000),(6862,8140102,4000232,0,1,1,0,600000),(6863,8140102,2000006,0,1,1,0,20000),(6864,8140102,2000005,0,1,1,0,20000),(6867,8140102,2040805,0,1,1,0,100),(6868,8140102,2040703,0,1,1,0,100),(6869,8140102,4006000,0,1,1,0,10000),(6871,8140102,2000002,0,1,1,0,20000),(6872,8140102,1072211,0,1,1,0,800),(6873,8140102,1002274,0,1,1,0,800),(6874,8140102,1051068,0,1,1,0,800),(6875,8140102,1082118,0,1,1,0,800),(6876,8140102,1402004,0,1,1,0,800),(6877,8140102,1332023,0,1,1,0,800),(6878,8140102,1032022,0,1,1,0,800),(6879,8140102,1092023,0,1,1,0,800),(6880,8140102,1422027,0,1,1,0,800),(6881,8140102,1452019,0,1,1,0,800),(6882,8140102,1382035,0,1,1,0,800),(6883,8140102,1432004,0,1,1,0,800),(6884,8140102,4161015,0,1,1,0,6000),(6885,8140102,1002643,0,1,1,0,800),(6886,8140102,2331000,0,1,1,0,500),(6887,8140102,2040321,0,1,1,0,100),(6888,8140102,2040622,0,1,1,0,100),(6889,8140102,2044807,0,1,1,0,100),(6890,8140102,4130000,0,1,1,0,6000),(6891,8140102,4130002,0,1,1,0,6000),(6892,8140102,4130013,0,1,1,0,6000),(6893,8140103,4000233,0,1,1,0,600000),(6894,8140103,2000006,0,1,1,0,20000),(6895,8140103,2000005,0,1,1,0,20000),(6898,8140103,2040004,0,1,1,0,100),(6899,8140103,2043701,0,1,1,0,100),(6900,8140103,4006000,0,1,1,0,10000),(6902,8140103,2000002,0,1,1,0,20000),(6903,8140103,1082116,0,1,1,0,800),(6904,8140103,1072177,0,1,1,0,800),(6905,8140103,1002277,0,1,1,0,800),(6906,8140103,1041106,0,1,1,0,800),(6907,8140103,1061105,0,1,1,0,800),(6908,8140103,1412009,0,1,1,0,800),(6909,8140103,1452013,0,1,1,0,800),(6910,8140103,1442019,0,1,1,0,800),(6911,8140103,1102032,0,1,1,0,800),(6912,8140103,1332051,0,1,1,0,800),(6913,8140103,1322045,0,1,1,0,800),(6914,8140103,1412021,0,1,1,0,800),(6915,8140103,1432011,0,1,1,0,800),(6916,8140103,4161016,0,1,1,0,6000),(6917,8140103,1492010,0,1,1,0,800),(6918,8140103,2332000,0,1,1,0,500),(6919,8140103,2044314,0,1,1,0,100),(6920,8140103,4130005,0,1,1,0,6000),(6921,8140103,4130011,0,1,1,0,6000),(6922,8140103,4130017,0,1,1,0,6000),(6923,8140110,4000241,0,1,1,0,600000),(6924,8140110,2000006,0,1,1,0,20000),(6925,8140110,2000005,0,1,1,0,20000),(6928,8140110,2044702,0,1,1,0,100),(6929,8140110,2043802,0,1,1,0,100),(6930,8140110,4006000,0,1,1,0,10000),(6932,8140110,2000002,0,1,1,0,20000),(6933,8140110,1050083,0,1,1,0,800),(6934,8140110,1082119,0,1,1,0,800),(6935,8140110,1072185,0,1,1,0,800),(6936,8140110,1002330,0,1,1,0,800),(6937,8140110,1092027,0,1,1,0,800),(6938,8140110,1452015,0,1,1,0,800),(6939,8140110,1462013,0,1,1,0,800),(6940,8140110,1432010,0,1,1,0,800),(6941,8140110,1302056,0,1,1,0,800),(6942,8140110,1372010,0,1,1,0,800),(6943,8140110,1332052,0,1,1,0,800),(6944,8140110,1482010,0,1,1,0,800),(6945,8140110,2044801,0,1,1,0,100),(6946,8140111,4000242,0,1,1,0,600000),(6947,8140111,2000006,0,1,1,0,20000),(6948,8140111,2000005,0,1,1,0,20000),(6951,8140111,2041014,0,1,1,0,100),(6952,8140111,2044001,0,1,1,0,100),(6953,8140111,4006001,0,1,1,0,10000),(6955,8140111,2000002,0,1,1,0,20000),(6956,8140111,2070006,0,1,1,0,100),(6957,8140111,1051080,0,1,1,0,800),(6958,8140111,1082122,0,1,1,0,800),(6959,8140111,1072183,0,1,1,0,800),(6960,8140111,1002328,0,1,1,0,800),(6961,8140111,1092025,0,1,1,0,800),(6962,8140111,1372016,0,1,1,0,800),(6963,8140111,1472031,0,1,1,0,800),(6964,8140111,1032023,0,1,1,0,800),(6965,8140111,1432030,0,1,1,0,800),(6966,8140111,1442044,0,1,1,0,800),(6967,8140111,1462015,0,1,1,0,800),(6968,8140111,2330003,0,1,1,0,100),(6969,8140111,1482010,0,1,1,0,800),(6970,8140111,2040323,0,1,1,0,100),(6971,8140111,2043214,0,1,1,0,100),(6972,8140111,4130001,0,1,1,0,6000),(6973,8140111,4130007,0,1,1,0,6000),(6974,8140111,4130012,0,1,1,0,6000),(6975,8140200,4000145,0,1,1,0,600000),(6979,8140200,4006001,0,1,1,0,10000),(6980,8140200,2000006,0,1,1,0,20000),(6981,8140200,2000004,0,1,1,0,20000),(6982,8140200,2002003,0,1,1,0,20000),(6983,8140200,2040302,0,1,1,0,100),(6984,8140200,2040802,0,1,1,0,100),(6985,8140200,2020014,0,1,1,0,20000),(6986,8140200,1050054,0,1,1,0,800),(6987,8140200,1002270,0,1,1,0,800),(6988,8140200,1040093,0,1,1,0,800),(6989,8140200,1060082,0,1,1,0,800),(6990,8140200,1082059,0,1,1,0,800),(6991,8140200,1072144,0,1,1,0,800),(6992,8140200,1050058,0,1,1,0,800),(6993,8140200,1472022,0,1,1,0,800),(6994,8140200,1051052,0,1,1,0,800),(6995,8140200,1072162,0,1,1,0,800),(6996,8140200,1082104,0,1,1,0,800),(6997,8140200,1072159,0,1,1,0,800),(6998,8140200,1051062,0,1,1,0,800),(6999,8140200,1032015,0,1,1,0,800),(7000,8140200,1322019,0,1,1,0,800),(7001,8140200,1032022,0,1,1,0,800),(7002,8140200,1050073,0,1,1,0,800),(7003,8140200,1072182,0,1,1,0,800),(7004,8140200,1082114,0,1,1,0,800),(7005,8140200,1482009,0,1,1,0,800),(7006,8140200,2040318,0,1,1,0,100),(7007,8140200,2040925,0,1,1,0,100),(7008,8140200,4130000,0,1,1,0,6000),(7009,8140200,4130014,0,1,1,0,6000),(7010,8140200,4130016,0,1,1,0,6000),(7011,8140300,4000146,0,1,1,0,600000),(7012,8140300,2000006,0,1,1,0,20000),(7013,8140300,2000004,0,1,1,0,20000),(7016,8140300,4006000,0,1,1,0,10000),(7018,8140300,2040513,0,1,1,0,100),(7019,8140300,2044602,0,1,1,0,100),(7020,8140300,1051043,0,1,1,0,800),(7021,8140300,1041096,0,1,1,0,800),(7022,8140300,1061095,0,1,1,0,800),(7023,8140300,1040090,0,1,1,0,800),(7024,8140300,1060079,0,1,1,0,800),(7025,8140300,1051055,0,1,1,0,800),(7026,8140300,1060095,0,1,1,0,800),(7027,8140300,1040107,0,1,1,0,800),(7028,8140300,1002252,0,1,1,0,800),(7029,8140300,1002289,0,1,1,0,800),(7030,8140300,1072160,0,1,1,0,800),(7031,8140300,1041099,0,1,1,0,800),(7032,8140300,1061098,0,1,1,0,800),(7033,8140300,1002288,0,1,1,0,800),(7034,8140300,1472027,0,1,1,0,800),(7035,8140300,1322020,0,1,1,0,800),(7036,8140300,1382010,0,1,1,0,800),(7037,8140300,1051057,0,1,1,0,800),(7038,8140300,1040109,0,1,1,0,800),(7039,8140300,1060098,0,1,1,0,800),(7040,8140300,1002277,0,1,1,0,800),(7041,8140300,1002340,0,1,1,0,800),(7042,8140300,2070005,0,1,1,0,200),(7043,8140300,1492009,0,1,1,0,800),(7044,8140300,2040622,0,1,1,0,100),(7045,8140300,2040623,0,1,1,0,100),(7046,8140300,2043110,0,1,1,0,100),(7047,8140300,4130016,0,1,1,0,6000),(7048,8140300,4130017,0,1,1,0,6000),(7049,8140500,4000080,0,1,1,0,600000),(7050,8140500,4003005,0,1,1,0,200000),(7051,8140500,2000006,0,1,1,0,20000),(7052,8140500,2000005,0,1,1,0,20000),(7056,8140500,2044001,0,1,1,0,100),(7057,8140500,2041022,0,1,1,0,100),(7058,8140500,1050070,0,1,1,0,800),(7059,8140500,1072156,0,1,1,0,800),(7060,8140500,1072164,0,1,1,0,800),(7061,8140500,1082096,0,1,1,0,800),(7062,8140500,1312011,0,1,1,0,800),(7063,8140500,1082111,0,1,1,0,800),(7064,8140500,1082117,0,1,1,0,800),(7065,8140500,1082121,0,1,1,0,800),(7066,8140500,1092024,0,1,1,0,800),(7067,8140500,1072174,0,1,1,0,800),(7068,8140500,1050078,0,1,1,0,800),(7069,8140500,1060098,0,1,1,0,800),(7070,8140500,1040109,0,1,1,0,800),(7071,8140500,1002340,0,1,1,0,800),(7072,8140500,1452014,0,1,1,0,800),(7073,8140500,1060104,0,1,1,0,800),(7074,8140500,1040115,0,1,1,0,800),(7075,8140500,1072208,0,1,1,0,800),(7076,8140500,1082126,0,1,1,0,800),(7077,8140500,1032017,0,1,1,0,800),(7078,8140500,1072195,0,1,1,0,800),(7079,8140500,1052125,0,1,1,0,800),(7080,8140500,4130006,0,1,1,0,6000),(7081,8140500,4130014,0,1,1,0,6000),(7082,8140600,4000182,0,1,1,0,600000),(7083,8140600,2000006,0,1,1,0,20000),(7084,8140600,2000005,0,1,1,0,20000),(7085,8140600,2020015,0,1,1,0,20000),(7086,8140600,2020013,0,1,1,0,20000),(7090,8140600,2040401,0,1,1,0,100),(7091,8140600,2040501,0,1,1,0,100),(7092,8140600,1472028,0,1,1,0,800),(7093,8140600,2040513,0,1,1,0,100),(7094,8140600,1452013,0,1,1,0,800),(7095,8140600,1472023,0,1,1,0,800),(7096,8140600,1462008,0,1,1,0,800),(7097,8140600,1102030,0,1,1,0,800),(7098,8140600,1040111,0,1,1,0,800),(7099,8140600,1060100,0,1,1,0,800),(7100,8140600,1060098,0,1,1,0,800),(7101,8140600,1040109,0,1,1,0,800),(7102,8140600,1082108,0,1,1,0,800),(7103,8140600,1082117,0,1,1,0,800),(7104,8140600,1032017,0,1,1,0,800),(7105,8140600,1072160,0,1,1,0,800),(7106,8140600,1002324,0,1,1,0,800),(7107,8140600,1072194,0,1,1,0,800),(7108,8140600,1072205,0,1,1,0,800),(7109,8140600,1052128,0,1,1,0,800),(7110,8140600,2040929,0,1,1,0,100),(7111,8140600,2049100,0,1,1,0,150),(7112,8140600,4130010,0,1,1,0,6000),(7113,8140600,4130015,0,1,1,0,6000),(7114,8140600,4130016,0,1,1,0,6000),(7115,8140700,2000006,0,1,1,0,20000),(7116,8140700,2000005,0,1,1,0,20000),(7120,8140700,1002528,0,1,1,0,800),(7121,8140700,1040117,0,1,1,0,800),(7122,8140700,1060106,0,1,1,0,800),(7123,8140700,1041120,0,1,1,0,800),(7124,8140700,1061119,0,1,1,0,800),(7125,8140700,1082134,0,1,1,0,800),(7126,8140700,1072204,0,1,1,0,800),(7127,8140700,1372009,0,1,1,0,800),(7128,8140700,1472033,0,1,1,0,800),(7129,8140700,2043801,0,1,1,0,100),(7130,8140700,2041022,0,1,1,0,100),(7131,8140700,4000262,0,1,1,0,600000),(7132,8140700,4000244,0,1,1,0,4000),(7133,8140700,4000245,0,1,1,0,4000),(7134,8140700,1082207,0,1,1,0,800),(7135,8140700,2044902,0,1,1,0,100),(14212,8140700,2290126,0,1,1,0,380),(7137,8140700,2040515,0,1,1,0,100),(7138,8140700,2044314,0,1,1,0,100),(7139,8140700,2044805,0,1,1,0,100),(7140,8140700,4130007,0,1,1,0,6000),(7141,8140700,4130012,0,1,1,0,6000),(7142,8140701,2000006,0,1,1,0,20000),(7143,8140701,2000005,0,1,1,0,20000),(7147,8140701,1002365,0,1,1,0,800),(7148,8140701,1040111,0,1,1,0,800),(7149,8140701,1060100,0,1,1,0,800),(7150,8140701,1051096,0,1,1,0,800),(7151,8140701,1082144,0,1,1,0,800),(7152,8140701,1072197,0,1,1,0,800),(7153,8140701,1302023,0,1,1,0,800),(7154,8140701,1332027,0,1,1,0,800),(7155,8140701,2044601,0,1,1,0,100),(7156,8140701,2044101,0,1,1,0,100),(7157,8140701,4000263,0,1,1,0,600000),(7158,8140701,4000244,0,1,1,0,4000),(7159,8140701,4000245,0,1,1,0,4000),(7160,8140701,1082210,0,1,1,0,800),(14213,8140701,2290122,0,1,1,0,170),(7162,8140701,2040925,0,1,1,0,100),(7163,8140701,4130003,0,1,1,0,6000),(7164,8140701,4130008,0,1,1,0,6000),(7165,8140702,2000006,0,1,1,0,20000),(7166,8140702,2000005,0,1,1,0,20000),(7170,8140702,1002403,0,1,1,0,800),(7171,8140702,1050092,0,1,1,0,800),(7172,8140702,1041117,0,1,1,0,800),(7173,8140702,1061116,0,1,1,0,800),(7174,8140702,1050106,0,1,1,0,800),(7175,8140702,1082139,0,1,1,0,800),(7176,8140702,1072206,0,1,1,0,800),(7177,8140702,1312015,0,1,1,0,800),(7178,8140702,1452017,0,1,1,0,800),(7179,8140702,2044701,0,1,1,0,100),(7180,8140702,2040602,0,1,1,0,100),(7181,8140702,4000264,0,1,1,0,600000),(7182,8140702,4000244,0,1,1,0,4000),(7183,8140702,4000245,0,1,1,0,4000),(7184,8140702,1492011,0,1,1,0,800),(14214,8140702,2290112,0,1,1,0,400),(7186,8140702,2040621,0,1,1,0,100),(7187,8140702,2043015,0,1,1,0,100),(7188,8140702,4130004,0,1,1,0,6000),(7189,8140702,4130005,0,1,1,0,6000),(7190,8140702,4130015,0,1,1,0,6000),(7191,8140703,2000006,0,1,1,0,20000),(7192,8140703,2000005,0,1,1,0,20000),(7196,8140703,1002325,0,1,1,0,800),(7197,8140703,1050090,0,1,1,0,800),(7198,8140703,1051082,0,1,1,0,800),(7199,8140703,1082151,0,1,1,0,800),(7200,8140703,1040120,0,1,1,0,800),(7201,8140703,1060109,0,1,1,0,800),(7202,8140703,1072212,0,1,1,0,800),(7203,8140703,1322029,0,1,1,0,800),(7204,8140703,1442020,0,1,1,0,800),(7205,8140703,2043801,0,1,1,0,100),(7206,8140703,2040901,0,1,1,0,100),(7207,8140703,4000265,0,1,1,0,600000),(7208,8140703,4000244,0,1,1,0,4000),(7209,8140703,4000245,0,1,1,0,4000),(7210,8140703,1082159,0,1,1,0,800),(14216,8140703,2290099,0,1,1,0,400),(7212,8140703,1002643,0,1,1,0,800),(7213,8140703,2044801,0,1,1,0,100),(14215,8140703,2290088,0,1,1,0,400),(7215,8141000,4000134,0,1,1,0,600000),(7216,8141000,2000002,0,1,1,0,20000),(7217,8141000,2000006,0,1,1,0,20000),(7221,8141000,2044602,0,1,1,0,100),(7222,8141000,2070006,0,1,1,0,100),(7223,8141000,1051063,0,1,1,0,800),(7224,8141000,1002254,0,1,1,0,800),(7225,8141000,1002285,0,1,1,0,800),(7226,8141000,1422010,0,1,1,0,800),(7227,8141000,1050074,0,1,1,0,800),(7228,8141000,1050072,0,1,1,0,800),(7229,8141000,1322028,0,1,1,0,800),(7230,8141000,1002327,0,1,1,0,800),(7231,8141000,1002278,0,1,1,0,800),(7232,8141000,1050083,0,1,1,0,800),(7233,8141000,1041106,0,1,1,0,800),(7234,8141000,1061105,0,1,1,0,800),(7235,8141000,1050076,0,1,1,0,800),(7236,8141000,1082115,0,1,1,0,800),(7237,8141000,1051068,0,1,1,0,800),(7238,8141000,1051079,0,1,1,0,800),(7239,8141000,1040112,0,1,1,0,800),(7240,8141000,1060101,0,1,1,0,800),(7241,8141000,1041117,0,1,1,0,800),(7242,8141000,1061116,0,1,1,0,800),(7243,8141000,1082132,0,1,1,0,800),(14218,8141000,2290097,0,1,1,0,360),(7245,8141000,1072315,0,1,1,0,800),(7246,8141000,2044802,0,1,1,0,100),(14217,8141000,2290082,0,1,1,0,360),(7248,8141000,2040317,0,1,1,0,100),(7249,8141000,2040929,0,1,1,0,100),(7250,8141000,2044809,0,1,1,0,100),(7251,8141000,2049000,0,1,1,0,150),(7252,8141000,4130013,0,1,1,0,6000),(7253,8141100,4000135,0,1,1,0,600000),(7254,8141100,2000006,0,1,1,0,20000),(7255,8141100,2000005,0,1,1,0,20000),(7258,8141100,2043002,0,1,1,0,100),(7259,8141100,2040902,0,1,1,0,100),(7260,8141100,4131003,0,1,1,0,6000),(7261,8141100,4006001,0,1,1,0,10000),(7262,8141100,1082105,0,1,1,0,800),(7263,8141100,1072165,0,1,1,0,800),(7264,8141100,1051058,0,1,1,0,800),(7265,8141100,1402015,0,1,1,0,800),(7266,8141100,1050081,0,1,1,0,800),(7267,8141100,1050077,0,1,1,0,800),(7268,8141100,1002329,0,1,1,0,800),(7269,8141100,1051080,0,1,1,0,800),(7270,8141100,1072185,0,1,1,0,800),(7271,8141100,1082119,0,1,1,0,800),(7272,8141100,1462012,0,1,1,0,800),(7273,8141100,1050093,0,1,1,0,800),(7274,8141100,1051083,0,1,1,0,800),(7275,8141100,1061115,0,1,1,0,800),(7276,8141100,1041116,0,1,1,0,800),(7277,8141100,1082134,0,1,1,0,800),(7278,8141100,2040025,0,1,1,0,100),(7279,8141100,2040031,0,1,1,0,100),(7280,8141100,2040418,0,1,1,0,100),(7281,8141100,2040412,0,1,1,0,100),(7282,8141100,4130000,0,1,1,0,6000),(7283,8141100,4130010,0,1,1,0,6000),(7284,8141100,4130016,0,1,1,0,6000),(7285,8141300,4000183,0,1,1,0,600000),(7286,8141300,2000005,0,1,1,0,20000),(7287,8141300,2020013,0,1,1,0,20000),(7288,8141300,2002001,0,1,1,0,20000),(7289,8141300,2000002,0,1,1,0,20000),(7292,8141300,4006000,0,1,1,0,10000),(7293,8141300,2020015,0,1,1,0,20000),(7295,8141300,2040601,0,1,1,0,100),(7296,8141300,2040701,0,1,1,0,100),(7297,8141300,1072207,0,1,1,0,800),(7298,8141300,1032020,0,1,1,0,800),(7299,8141300,1002271,0,1,1,0,800),(7300,8141300,1072183,0,1,1,0,800),(7301,8141300,1102026,0,1,1,0,800),(7302,8141300,1041119,0,1,1,0,800),(7303,8141300,1061118,0,1,1,0,800),(7304,8141300,1452011,0,1,1,0,800),(7305,8141300,1442008,0,1,1,0,800),(7306,8141300,1432007,0,1,1,0,800),(7307,8141300,1050089,0,1,1,0,800),(7308,8141300,1051083,0,1,1,0,800),(7309,8141300,1092027,0,1,1,0,800),(7310,8141300,1002365,0,1,1,0,800),(7311,8141300,1072224,0,1,1,0,800),(7312,8141300,1482011,0,1,1,0,800),(14219,8141300,2290098,0,1,1,0,90),(7314,8141300,2040618,0,1,1,0,100),(7315,8141300,2040512,0,1,1,0,100),(7316,8141300,2040627,0,1,1,0,100),(7317,8141300,4130006,0,1,1,0,6000),(7318,8141300,4130008,0,1,1,0,6000),(7319,8141300,4130014,0,1,1,0,6000),(7320,8142000,4000149,0,1,1,0,600000),(7321,8142000,2000005,0,1,1,0,20000),(7322,8142000,2002001,0,1,1,0,20000),(7323,8142000,2000002,0,1,1,0,20000),(7326,8142000,4006000,0,1,1,0,10000),(7327,8142000,2020015,0,1,1,0,20000),(7328,8142000,2044001,0,1,1,0,100),(7329,8142000,2041022,0,1,1,0,100),(7330,8142000,1432007,0,1,1,0,800),(7331,8142000,1082107,0,1,1,0,800),(7332,8142000,1051056,0,1,1,0,800),(7333,8142000,1332023,0,1,1,0,800),(7334,8142000,1082112,0,1,1,0,800),(7335,8142000,1082116,0,1,1,0,800),(7336,8142000,1040110,0,1,1,0,800),(7337,8142000,1060099,0,1,1,0,800),(7338,8142000,1050076,0,1,1,0,800),(7339,8142000,1072212,0,1,1,0,800),(7340,8142000,1002339,0,1,1,0,800),(7341,8142000,1051078,0,1,1,0,800),(7342,8142000,1452013,0,1,1,0,800),(7343,8142000,1051067,0,1,1,0,800),(7344,8142000,1051096,0,1,1,0,800),(7345,8142000,1050091,0,1,1,0,800),(7346,8142000,1040111,0,1,1,0,800),(7347,8142000,1060100,0,1,1,0,800),(7348,8142000,1082133,0,1,1,0,800),(7349,8142000,1492011,0,1,1,0,800),(7350,8142000,2040412,0,1,1,0,100),(7351,8142000,4130003,0,1,1,0,6000),(7352,8142000,4130009,0,1,1,0,6000),(7353,8142100,4000184,0,1,1,0,600000),(7354,8142100,2000006,0,1,1,0,20000),(7355,8142100,2000005,0,1,1,0,20000),(7359,8142100,4006000,0,1,1,0,10000),(7360,8142100,1412009,0,1,1,0,800),(7361,8142100,2040801,0,1,1,0,100),(7362,8142100,2040804,0,1,1,0,100),(7363,8142100,1422010,0,1,1,0,800),(7364,8142100,1092025,0,1,1,0,800),(7365,8142100,1072197,0,1,1,0,800),(7366,8142100,1040110,0,1,1,0,800),(7367,8142100,1060099,0,1,1,0,800),(7368,8142100,1032017,0,1,1,0,800),(7369,8142100,1041118,0,1,1,0,800),(7370,8142100,1061117,0,1,1,0,800),(7371,8142100,1050090,0,1,1,0,800),(7372,8142100,1051084,0,1,1,0,800),(7373,8142100,1050095,0,1,1,0,800),(7374,8142100,1051097,0,1,1,0,800),(7375,8142100,4006001,0,1,1,0,10000),(7376,8142100,1092026,0,1,1,0,800),(7377,8142100,1002325,0,1,1,0,800),(7378,8142100,1092028,0,1,1,0,800),(7379,8142100,1072220,0,1,1,0,800),(14221,8142100,2290114,0,1,1,0,220),(14220,8142100,2290032,0,1,1,0,220),(7382,8142100,2040318,0,1,1,0,100),(7383,8142100,2043019,0,1,1,0,100),(7384,8142100,4130000,0,1,1,0,6000),(7385,8142100,4130009,0,1,1,0,6000),(7386,8143000,4000150,0,1,1,0,600000),(7387,8143000,2000002,0,1,1,0,20000),(7388,8143000,2000005,0,1,1,0,20000),(7389,8143000,2022003,0,1,1,0,20000),(7390,8143000,2002002,0,1,1,0,20000),(7392,8143000,4006001,0,1,1,0,10000),(7394,8143000,2044702,0,1,1,0,100),(7395,8143000,2040401,0,1,1,0,100),(7396,8143000,1002283,0,1,1,0,800),(7397,8143000,1050064,0,1,1,0,800),(7398,8143000,1092016,0,1,1,0,800),(7399,8143000,1422012,0,1,1,0,800),(7400,8143000,1462010,0,1,1,0,800),(7401,8143000,1082122,0,1,1,0,800),(7402,8143000,1082120,0,1,1,0,800),(7403,8143000,1072183,0,1,1,0,800),(7404,8143000,1082117,0,1,1,0,800),(7405,8143000,1072179,0,1,1,0,800),(7406,8143000,1002328,0,1,1,0,800),(7407,8143000,1051094,0,1,1,0,800),(7408,8143000,1002402,0,1,1,0,800),(7409,8143000,1061118,0,1,1,0,800),(7410,8143000,1041119,0,1,1,0,800),(7411,8143000,1040116,0,1,1,0,800),(7412,8143000,1060105,0,1,1,0,800),(7413,8143000,1051084,0,1,1,0,800),(7414,8143000,1082130,0,1,1,0,800),(7415,8143000,2043019,0,1,1,0,100),(7416,8143000,4130011,0,1,1,0,6000),(7417,8143000,4130016,0,1,1,0,6000),(7418,8143000,4130017,0,1,1,0,6000),(7419,8150000,2040002,0,1,1,0,1500),(7420,8150000,2040005,0,1,1,0,1500),(7421,8150000,2040302,0,1,1,0,1500),(7422,8150000,2040402,0,1,1,0,1500),(7423,8150000,2040502,0,1,1,0,1500),(7424,8150000,2040505,0,1,1,0,1500),(7425,8150000,2040602,0,1,1,0,1500),(7426,8150000,2040702,0,1,1,0,1500),(7427,8150000,2040705,0,1,1,0,1500),(7428,8150000,2040708,0,1,1,0,1500),(7429,8150000,2040802,0,1,1,0,1500),(7430,8150000,2040805,0,1,1,0,1000),(7431,8150000,2040902,0,1,1,0,1500),(7432,8150000,2043002,0,1,1,0,1500),(7433,8150000,2043102,0,1,1,0,1500),(7434,8150000,2043202,0,1,1,0,1500),(7435,8150000,2043302,0,1,1,0,1500),(7436,8150000,2043702,0,1,1,0,1500),(7437,8150000,2043802,0,1,1,0,1500),(7438,8150000,2044002,0,1,1,0,1500),(7439,8150000,2044102,0,1,1,0,1500),(7440,8150000,2044202,0,1,1,0,1500),(7441,8150000,2044302,0,1,1,0,1500),(7442,8150000,2044402,0,1,1,0,1500),(7443,8150000,2044502,0,1,1,0,1500),(7444,8150000,2044602,0,1,1,0,1500),(7445,8150000,2044702,0,1,1,0,1500),(7446,8150000,2070007,0,1,1,0,300),(7447,8150000,2044802,0,1,1,0,1500),(7448,8150000,2044902,0,1,1,0,1500),(7449,8150000,2040029,0,1,1,0,1500),(7450,8150000,2040413,0,1,1,0,1500),(7451,8150000,2043212,0,1,1,0,1500),(7452,8150000,2044012,0,1,1,0,1500),(7453,8150000,2044212,0,1,1,0,1500),(7454,8150100,4000180,0,1,1,0,600000),(7455,8150100,2000006,0,1,1,0,20000),(7456,8150100,2022003,0,1,1,0,20000),(7457,8150100,4006000,0,1,1,0,10000),(7458,8150100,2000005,0,1,1,0,20000),(7459,8150100,4006001,0,1,1,0,10000),(7460,8150100,2020013,0,1,1,0,20000),(7463,8150100,2040901,0,1,1,0,100),(7464,8150100,2041001,0,1,1,0,100),(7465,8150100,1082142,0,1,1,0,800),(7466,8150100,1072192,0,1,1,0,800),(7467,8150100,1072204,0,1,1,0,800),(7468,8150100,1032017,0,1,1,0,800),(7469,8150100,1040112,0,1,1,0,800),(7470,8150100,1060101,0,1,1,0,800),(7471,8150100,1322028,0,1,1,0,800),(7472,8150100,1332022,0,1,1,0,800),(7473,8150100,1002405,0,1,1,0,800),(7474,8150100,2041013,0,1,1,0,100),(7475,8150100,1002366,0,1,1,0,800),(7476,8150100,1072214,0,1,1,0,800),(7477,8150100,4161018,0,1,1,0,6000),(7478,8150100,1072315,0,1,1,0,800),(7479,8150100,1052131,0,1,1,0,800),(7480,8150100,2044902,0,1,1,0,100),(14222,8150100,2290118,0,1,1,0,110),(7482,8150100,4130006,0,1,1,0,6000),(7483,8150100,4130007,0,1,1,0,6000),(7484,8150101,4000181,0,1,1,0,600000),(7485,8150101,2000006,0,1,1,0,20000),(7486,8150101,2022003,0,1,1,0,20000),(7487,8150101,4006000,0,1,1,0,10000),(7488,8150101,2000005,0,1,1,0,20000),(7489,8150101,4006001,0,1,1,0,10000),(7490,8150101,2020013,0,1,1,0,20000),(7493,8150101,2041022,0,1,1,0,100),(7494,8150101,2043001,0,1,1,0,100),(7495,8150101,1082143,0,1,1,0,800),(7496,8150101,1072193,0,1,1,0,800),(7497,8150101,1072203,0,1,1,0,800),(7498,8150101,1002403,0,1,1,0,800),(7499,8150101,1040117,0,1,1,0,800),(7500,8150101,1060106,0,1,1,0,800),(7501,8150101,1302018,0,1,1,0,800),(7502,8150101,1312011,0,1,1,0,800),(7503,8150101,1032023,0,1,1,0,800),(7504,8150101,2040301,0,1,1,0,100),(7505,8150101,1002326,0,1,1,0,800),(7506,8150101,1072223,0,1,1,0,800),(14225,8150101,2290102,0,1,1,0,350),(14224,8150101,2290052,0,1,1,0,350),(7509,8150101,4161018,0,1,1,0,6000),(7510,8150101,1072318,0,1,1,0,800),(14223,8150101,2290042,0,1,1,0,350),(7512,8150101,2040420,0,1,1,0,100),(7513,8150101,2040931,0,1,1,0,100),(7514,8150101,2049100,0,1,1,0,150),(7515,8150101,4130009,0,1,1,0,6000),(7516,8150101,4130010,0,1,1,0,6000),(7517,8150200,2000006,0,1,1,0,20000),(7518,8150200,2000005,0,1,1,0,20000),(7519,8150200,2022003,0,1,1,0,20000),(7520,8150200,2020015,0,1,1,0,20000),(7524,8150200,1002529,0,1,1,0,800),(7525,8150200,1050102,0,1,1,0,800),(7526,8150200,1051105,0,1,1,0,800),(7527,8150200,1051092,0,1,1,0,800),(7528,8150200,1082135,0,1,1,0,800),(7529,8150200,1072194,0,1,1,0,800),(7530,8150200,1092026,0,1,1,0,800),(7531,8150200,1402005,0,1,1,0,800),(7532,8150200,1462018,0,1,1,0,800),(7533,8150200,2040001,0,1,1,0,100),(7534,8150200,2043301,0,1,1,0,100),(7535,8150200,4000266,0,1,1,0,600000),(7536,8150200,4000244,0,1,1,0,4000),(7537,8150200,4000245,0,1,1,0,4000),(7538,8150200,1082210,0,1,1,0,800),(7539,8150200,1002646,0,1,1,0,800),(14227,8200004,2290135,0,1,1,0,210),(7541,8150200,2040413,0,1,1,0,100),(7542,8150200,4130005,0,1,1,0,6000),(7543,8150201,2000006,0,1,1,0,20000),(7544,8150201,2000005,0,1,1,0,20000),(7545,8150201,2022003,0,1,1,0,20000),(7546,8150201,2020013,0,1,1,0,20000),(7550,8150201,1002530,0,1,1,0,800),(7551,8150201,1050098,0,1,1,0,800),(7552,8150201,1041122,0,1,1,0,800),(7553,8150201,1061121,0,1,1,0,800),(7554,8150201,1051101,0,1,1,0,800),(7555,8150201,1082158,0,1,1,0,800),(7556,8150201,1072208,0,1,1,0,800),(7557,8150201,1092027,0,1,1,0,800),(7558,8150201,1402016,0,1,1,0,800),(7559,8150201,1382035,0,1,1,0,800),(7560,8150201,2040302,0,1,1,0,100),(7561,8150201,2040501,0,1,1,0,100),(7562,8150201,4000267,0,1,1,0,600000),(7563,8150201,4000244,0,1,1,0,4000),(7564,8150201,4000245,0,1,1,0,4000),(7565,8150201,1082136,0,1,1,0,800),(14301,9400580,2290024,0,1,1,0,470),(14234,8150201,2290117,0,1,1,0,370),(14233,8150201,2290078,0,1,1,0,370),(14232,8150201,2290072,0,1,1,0,370),(14231,8150201,2290056,0,1,1,0,370),(14230,8150201,2290036,0,1,1,0,370),(14229,8150201,2290024,0,1,1,0,370),(7573,8150201,1492012,0,1,1,0,800),(7574,8150201,2044802,0,1,1,0,100),(14228,8150201,2290006,0,1,1,0,370),(7576,8150201,2040618,0,1,1,0,100),(7577,8150201,2044012,0,1,1,0,100),(7578,8150201,2044210,0,1,1,0,100),(7579,8150201,2049100,0,1,1,0,150),(7580,8150201,4130002,0,1,1,0,6000),(7581,8150201,4130015,0,1,1,0,6000),(7582,8150201,4130017,0,1,1,0,6000),(7583,8150300,2000006,0,1,1,0,20000),(7584,8150300,2000005,0,1,1,0,20000),(7588,8150300,4006001,0,1,1,0,10000),(7589,8150300,1002365,0,1,1,0,800),(7590,8150300,1050089,0,1,1,0,800),(7591,8150300,1041118,0,1,1,0,800),(7592,8150300,1061116,0,1,1,0,800),(7593,8150300,1082129,0,1,1,0,800),(7594,8150300,1072223,0,1,1,0,800),(7595,8150300,1452017,0,1,1,0,800),(7596,8150300,2040701,0,1,1,0,100),(7597,8150300,2040516,0,1,1,0,100),(7598,8150300,2043002,0,1,1,0,100),(7599,8150300,4000268,0,1,1,0,600000),(7600,8150300,4000244,0,1,1,0,4000),(7601,8150300,4000245,0,1,1,0,4000),(7602,8150300,1052128,0,1,1,0,800),(7603,8150300,2044901,0,1,1,0,100),(14235,8150300,1342007,0,1,1,0,910),(7605,8150300,2043114,0,1,1,0,100),(7606,8150300,4130002,0,1,1,0,6000),(7607,8150300,4130005,0,1,1,0,6000),(7608,8150300,4130013,0,1,1,0,6000),(7609,8150301,4000269,0,1,1,0,600000),(7610,8150301,2000006,0,1,1,0,20000),(7611,8150301,2022003,0,1,1,0,20000),(7612,8150301,4006000,0,1,1,0,10000),(7613,8150301,2000005,0,1,1,0,20000),(7617,8150301,1002532,0,1,1,0,800),(7618,8150301,1050094,0,1,1,0,800),(7619,8150301,1051105,0,1,1,0,800),(7620,8150301,1082143,0,1,1,0,800),(7621,8150301,1072227,0,1,1,0,800),(7622,8150301,1422013,0,1,1,0,800),(7623,8150301,1372010,0,1,1,0,800),(7624,8150301,2040401,0,1,1,0,100),(7625,8150301,2040001,0,1,1,0,100),(7626,8150301,2044001,0,1,1,0,100),(7627,8150301,4000244,0,1,1,0,4000),(7628,8150301,4000245,0,1,1,0,4000),(7629,8150301,1082213,0,1,1,0,800),(14238,8150301,2290101,0,1,1,0,380),(7631,8150301,2040924,0,1,1,0,100),(7632,8150301,4130004,0,1,1,0,6000),(7633,8150301,4130013,0,1,1,0,6000),(7634,8150302,4000270,0,1,1,0,600000),(7635,8150302,2000006,0,1,1,0,20000),(7636,8150302,2000005,0,1,1,0,20000),(7637,8150302,2022003,0,1,1,0,20000),(7638,8150302,2020013,0,1,1,0,20000),(7642,8150302,4006001,0,1,1,0,10000),(7643,8150302,4006000,0,1,1,0,10000),(7644,8150302,1002531,0,1,1,0,800),(7645,8150302,1040115,0,1,1,0,800),(7646,8150302,1060107,0,1,1,0,800),(7647,8150302,1051095,0,1,1,0,800),(7648,8150302,1082127,0,1,1,0,800),(7649,8150302,1072214,0,1,1,0,800),(7650,8150302,1332027,0,1,1,0,800),(7651,8150302,1442020,0,1,1,0,800),(7652,8150302,2040302,0,1,1,0,100),(7653,8150302,2044301,0,1,1,0,100),(7654,8150302,2044402,0,1,1,0,100),(7655,8150302,4131004,0,1,1,0,6000),(7656,8150302,4000244,0,1,1,0,4000),(7657,8150302,4000245,0,1,1,0,4000),(14244,8150302,2290128,0,1,1,0,340),(14243,8150302,2290119,0,1,1,0,340),(14242,8150302,2290076,0,1,1,0,340),(14241,8150302,2290026,0,1,1,0,340),(7662,8150302,1482012,0,1,1,0,800),(14240,8150302,2290019,0,1,1,0,340),(7664,8150302,4130009,0,1,1,0,6000),(7665,8150302,4130014,0,1,1,0,6000),(7666,8150302,4130017,0,1,1,0,6000),(7667,8160000,4000151,0,1,1,0,600000),(7668,8160000,2000006,0,1,1,0,20000),(7669,8160000,2022003,0,1,1,0,20000),(7670,8160000,4006000,0,1,1,0,10000),(7674,8160000,2040705,0,1,1,0,100),(7675,8160000,2040602,0,1,1,0,100),(7676,8160000,1092015,0,1,1,0,800),(7677,8160000,1462009,0,1,1,0,800),(7678,8160000,1472028,0,1,1,0,800),(7679,8160000,1050062,0,1,1,0,800),(7680,8160000,1442019,0,1,1,0,800),(7681,8160000,1472031,0,1,1,0,800),(7682,8160000,1452015,0,1,1,0,800),(7683,8160000,1050081,0,1,1,0,800),(7684,8160000,1002329,0,1,1,0,800),(7685,8160000,1072179,0,1,1,0,800),(7686,8160000,1082123,0,1,1,0,800),(7687,8160000,1051079,0,1,1,0,800),(7688,8160000,1032023,0,1,1,0,800),(7689,8160000,1051095,0,1,1,0,800),(7690,8160000,1092026,0,1,1,0,800),(7691,8160000,1002403,0,1,1,0,800),(7692,8160000,1040118,0,1,1,0,800),(7693,8160000,1060107,0,1,1,0,800),(7694,8160000,1061119,0,1,1,0,800),(7695,8160000,1041120,0,1,1,0,800),(7696,8160000,1072213,0,1,1,0,800),(7697,8160000,1052131,0,1,1,0,800),(7698,8160000,2040924,0,1,1,0,100),(7699,8160000,4130003,0,1,1,0,6000),(7700,8160000,4130004,0,1,1,0,6000),(7701,8160000,4130014,0,1,1,0,6000),(7702,8170000,4000152,0,1,1,0,600000),(7705,8170000,2000006,0,1,1,0,20000),(7706,8170000,2000005,0,1,1,0,20000),(7708,8170000,4006001,0,1,1,0,10000),(7709,8170000,2040702,0,1,1,0,100),(7710,8170000,2040802,0,1,1,0,100),(7712,8170000,2002001,0,1,1,0,20000),(7713,8170000,1002281,0,1,1,0,800),(7714,8170000,1092017,0,1,1,0,800),(7715,8170000,1332018,0,1,1,0,800),(7716,8170000,1332019,0,1,1,0,800),(7717,8170000,1050072,0,1,1,0,800),(7718,8170000,1452012,0,1,1,0,800),(7719,8170000,1072177,0,1,1,0,800),(7720,8170000,1041107,0,1,1,0,800),(7721,8170000,1061106,0,1,1,0,800),(7722,8170000,1050083,0,1,1,0,800),(7723,8170000,1051069,0,1,1,0,800),(7724,8170000,1072211,0,1,1,0,800),(7725,8170000,1072178,0,1,1,0,800),(7726,8170000,1462013,0,1,1,0,800),(7727,8170000,1102031,0,1,1,0,800),(7728,8170000,1050095,0,1,1,0,800),(7729,8170000,1092027,0,1,1,0,800),(7730,8170000,1002404,0,1,1,0,800),(7731,8170000,1032017,0,1,1,0,800),(7732,8170000,1040113,0,1,1,0,800),(7733,8170000,1060102,0,1,1,0,800),(7734,8170000,1072227,0,1,1,0,800),(7735,8170000,2040512,0,1,1,0,100),(7736,8170000,4130001,0,1,1,0,6000),(7737,8170000,4130003,0,1,1,0,6000),(7738,8170000,4130008,0,1,1,0,6000),(7739,8180000,2000005,0,1,1,0,999999),(7740,8180000,2000004,0,1,1,0,999999),(7741,8180000,1302056,0,1,1,0,7000),(7742,8180000,1312030,0,1,1,0,7000),(7743,8180000,1322045,0,1,1,0,7000),(7744,8180000,1332051,0,1,1,0,5000),(7745,8180000,1332052,0,1,1,0,5000),(7746,8180000,1372010,0,1,1,0,7000),(7747,8180000,1382035,0,1,1,0,7000),(7748,8180000,1402035,0,1,1,0,7000),(7749,8180000,1412021,0,1,1,0,7000),(7750,8180000,1422027,0,1,1,0,7000),(7751,8180000,1432030,0,1,1,0,5000),(7752,8180000,1442044,0,1,1,0,7000),(7753,8180000,1452019,0,1,1,0,5000),(7754,8180000,1462015,0,1,1,0,5000),(7755,8180000,1472053,0,1,1,0,5000),(7756,8180000,2043001,0,1,1,0,1500),(7757,8180000,2043101,0,1,1,0,1500),(7758,8180000,2043201,0,1,1,0,1500),(7759,8180000,2043301,0,1,1,0,1500),(7760,8180000,2043701,0,1,1,0,1500),(7761,8180000,2043801,0,1,1,0,1500),(7762,8180000,2044001,0,1,1,0,1500),(7763,8180000,2044101,0,1,1,0,1500),(7764,8180000,2044301,0,1,1,0,1500),(7765,8180000,2044201,0,1,1,0,1500),(7766,8180000,2044401,0,1,1,0,1500),(7767,8180000,2044501,0,1,1,0,1500),(7768,8180000,2044601,0,1,1,0,1500),(7769,8180000,2044701,0,1,1,0,1500),(7770,8180000,2040805,0,1,1,0,1000),(7775,8180000,4000235,0,1,1,0,600000),(7776,8180000,4000244,0,1,1,0,20000),(7777,8180000,4000245,0,1,1,0,20000),(7778,8180000,2290003,0,1,1,0,5000),(7779,8180000,2290015,0,1,1,0,5000),(7780,8180000,2290030,0,1,1,0,5000),(7781,8180000,2290035,0,1,1,0,5000),(7782,8180000,2290036,0,1,1,0,5000),(7783,8180000,2290063,0,1,1,0,5000),(7784,8180000,2290080,0,1,1,0,5000),(7785,8180000,1482012,0,1,1,0,5000),(7786,8180000,1492012,0,1,1,0,5000),(7787,8180000,2044801,0,1,1,0,1500),(7788,8180000,2044901,0,1,1,0,1500),(7789,8180000,2290098,0,1,1,0,5000),(7790,8180000,2290101,0,1,1,0,5000),(7791,8180000,2290117,0,1,1,0,5000),(7792,8180000,2040328,0,1,1,0,1500),(7793,8180000,2040824,0,1,1,0,1500),(7794,8180000,2043112,0,1,1,0,1500),(7795,8180000,2044014,0,1,1,0,1500),(7796,8180000,2049000,0,1,1,0,1500),(7797,8180001,2000005,0,1,1,0,999999),(7798,8180001,2000004,0,1,1,0,999999),(7799,8180001,1302056,0,1,1,0,7000),(7800,8180001,1312030,0,1,1,0,7000),(7801,8180001,1322045,0,1,1,0,7000),(7802,8180001,1332051,0,1,1,0,5000),(7803,8180001,1332052,0,1,1,0,5000),(7804,8180001,1372010,0,1,1,0,7000),(7805,8180001,1382035,0,1,1,0,7000),(7806,8180001,1402035,0,1,1,0,7000),(7807,8180001,1412021,0,1,1,0,7000),(7808,8180001,1422027,0,1,1,0,7000),(7809,8180001,1432030,0,1,1,0,5000),(7810,8180001,1442044,0,1,1,0,7000),(7811,8180001,1452019,0,1,1,0,5000),(7812,8180001,1462015,0,1,1,0,5000),(7813,8180001,1472053,0,1,1,0,5000),(7814,8180001,2040002,0,1,1,0,1500),(7815,8180001,2040005,0,1,1,0,1500),(7816,8180001,2040302,0,1,1,0,1500),(7817,8180001,2040402,0,1,1,0,1500),(7818,8180001,2040502,0,1,1,0,1500),(7819,8180001,2040505,0,1,1,0,1500),(7820,8180001,2040513,0,1,1,0,1500),(7821,8180001,2040516,0,1,1,0,1500),(7822,8180001,2040602,0,1,1,0,1500),(7823,8180001,2040702,0,1,1,0,1500),(7824,8180001,2040705,0,1,1,0,1500),(7825,8180001,2040708,0,1,1,0,1500),(7826,8180001,2040802,0,1,1,0,1500),(7827,8180001,2040902,0,1,1,0,1500),(7832,8180001,4000243,0,1,1,0,600000),(7833,8180001,4000244,0,1,1,0,20000),(7834,8180001,4000245,0,1,1,0,20000),(7835,8180001,2290018,0,1,1,0,5000),(7836,8180001,2290019,0,1,1,0,5000),(7837,8180001,2290032,0,1,1,0,5000),(7838,8180001,2290042,0,1,1,0,5000),(7839,8180001,2290059,0,1,1,0,5000),(7840,8180001,2290069,0,1,1,0,5000),(7841,8180001,2290072,0,1,1,0,5000),(7842,8180001,2290092,0,1,1,0,5000),(7843,8180001,1482012,0,1,1,0,5000),(7844,8180001,1492012,0,1,1,0,5000),(7845,8180001,2290100,0,1,1,0,5000),(7846,8180001,2290102,0,1,1,0,5000),(7847,8180001,2290119,0,1,1,0,5000),(7848,8180001,2040618,0,1,1,0,1500),(7849,8180001,2040532,0,1,1,0,1500),(7850,8180001,2040925,0,1,1,0,1500),(7851,8180001,2043114,0,1,1,0,1500),(7852,8180001,2043214,0,1,1,0,1500),(7853,8180001,2044112,0,1,1,0,1500),(7854,8180001,2049100,0,1,1,0,1500),(7855,8190000,4000272,0,1,1,0,600000),(7856,8190000,2000006,0,1,1,0,20000),(7857,8190000,2000005,0,1,1,0,20000),(7858,8190000,2022003,0,1,1,0,20000),(7859,8190000,2020013,0,1,1,0,20000),(7863,8190000,4006001,0,1,1,0,10000),(7864,8190000,4006000,0,1,1,0,10000),(7865,8190000,1002398,0,1,1,0,800),(7866,8190000,1040111,0,1,1,0,800),(7867,8190000,1060102,0,1,1,0,800),(7868,8190000,1051092,0,1,1,0,800),(7869,8190000,1082158,0,1,1,0,800),(7870,8190000,1072228,0,1,1,0,800),(7871,8190000,1332052,0,1,1,0,800),(7872,8190000,1402016,0,1,1,0,800),(7873,8190000,2044702,0,1,1,0,100),(7874,8190000,2040004,0,1,1,0,100),(7875,8190000,4000244,0,1,1,0,4000),(7876,8190000,4000245,0,1,1,0,4000),(14246,8190000,2290030,0,1,1,0,420),(14247,8140103,2290044,0,1,1,0,420),(14248,8190000,2290054,0,1,1,0,420),(14249,8190000,2290066,0,1,1,0,420),(14250,8190000,2290092,0,1,1,0,420),(14251,8190000,2290103,0,1,1,0,220),(7883,8190000,1002646,0,1,1,0,800),(7884,8190000,2040419,0,1,1,0,100),(7885,8190000,2044110,0,1,1,0,100),(7886,8190000,2049000,0,1,1,0,150),(7887,8190000,4130004,0,1,1,0,6000),(7888,8190000,4130006,0,1,1,0,6000),(7889,8190000,4130008,0,1,1,0,6000),(7890,8190002,4000271,0,1,1,0,600000),(7891,8190002,2022003,0,1,1,0,20000),(7892,8190002,2000006,0,1,1,0,20000),(7893,8190002,2000005,0,1,1,0,20000),(7897,8190002,4006001,0,1,1,0,10000),(7898,8190002,4006000,0,1,1,0,10000),(7899,8190002,1002406,0,1,1,0,800),(7900,8190002,1051101,0,1,1,0,800),(7901,8190002,1050097,0,1,1,0,800),(7902,8190002,1082139,0,1,1,0,800),(7903,8190002,1072225,0,1,1,0,800),(7904,8190002,1032023,0,1,1,0,800),(7905,8190002,1412021,0,1,1,0,800),(7906,8190002,1452019,0,1,1,0,800),(7907,8190002,2043801,0,1,1,0,100),(7908,8190002,2041023,0,1,1,0,100),(7909,8190002,2040707,0,1,1,0,100),(7910,8190002,4130013,0,1,1,0,6000),(7911,8190002,4000244,0,1,1,0,4000),(7912,8190002,4000245,0,1,1,0,4000),(7913,8190002,1082152,0,1,1,0,800),(14252,8190002,2290000,0,1,1,0,440),(14253,8190002,2290008,0,1,1,0,440),(14254,8190002,2290018,0,1,1,0,440),(14255,8190002,2290038,0,1,1,0,440),(14256,8190002,2290060,0,1,1,0,440),(14257,8190002,2290080,0,1,1,0,440),(7920,8190002,1492012,0,1,1,0,800),(14258,8190002,2290124,0,1,1,0,440),(7922,8190002,1082213,0,1,1,0,800),(7923,8190002,2044901,0,1,1,0,100),(7924,8190003,4000274,0,1,1,0,600000),(7925,8190003,2022003,0,1,1,0,20000),(7926,8190003,2000006,0,1,1,0,20000),(7927,8190003,2000005,0,1,1,0,20000),(7931,8190003,4006001,0,1,1,0,10000),(7932,8190003,4006000,0,1,1,0,10000),(7933,8190003,1002377,0,1,1,0,800),(7934,8190003,1050107,0,1,1,0,800),(7935,8190003,1050103,0,1,1,0,800),(7936,8190003,1082135,0,1,1,0,800),(7937,8190003,1072221,0,1,1,0,800),(7938,8190003,1032017,0,1,1,0,800),(7939,8190003,1422027,0,1,1,0,800),(7940,8190003,1332051,0,1,1,0,800),(7941,8190003,2044602,0,1,1,0,100),(7942,8190003,2043301,0,1,1,0,100),(7943,8190003,2040805,0,1,1,0,100),(7944,8190003,4000244,0,1,1,0,4000),(7945,8190003,4000245,0,1,1,0,4000),(7946,8190003,1082140,0,1,1,0,800),(14259,8190003,2290012,0,1,1,0,390),(14260,8190003,2290014,0,1,1,0,390),(14261,8190003,2290050,0,1,1,0,390),(14262,8190003,2290062,0,1,1,0,390),(14263,8190003,2290070,0,1,1,0,390),(14264,8190003,2290086,0,1,1,0,390),(7953,8190003,1482011,0,1,1,0,800),(7954,8190003,1072318,0,1,1,0,800),(7955,8190003,2044902,0,1,1,0,100),(14265,8190003,2290108,0,1,1,0,390),(7957,8190003,2040534,0,1,1,0,100),(7958,8190003,2040627,0,1,1,0,100),(7959,8190003,2049000,0,1,1,0,150),(7960,8190003,4130001,0,1,1,0,6000),(7961,8190003,4130014,0,1,1,0,6000),(7962,8190004,4000273,0,1,1,0,600000),(7963,8190004,2022003,0,1,1,0,20000),(7964,8190004,2000006,0,1,1,0,20000),(7965,8190004,2000005,0,1,1,0,20000),(7969,8190004,4006001,0,1,1,0,10000),(7970,8190004,4006000,0,1,1,0,10000),(7971,8190004,1002380,0,1,1,0,800),(7972,8190004,1051102,0,1,1,0,800),(7973,8190004,1040121,0,1,1,0,800),(7974,8190004,1060109,0,1,1,0,800),(7975,8190004,1082151,0,1,1,0,800),(7976,8190004,1072215,0,1,1,0,800),(7977,8190004,1322045,0,1,1,0,800),(7978,8190004,1302056,0,1,1,0,800),(7979,8190004,2041004,0,1,1,0,100),(7980,8190004,2041013,0,1,1,0,100),(7981,8190004,2044201,0,1,1,0,100),(7982,8190004,4000244,0,1,1,0,4000),(7983,8190004,4000245,0,1,1,0,4000),(14267,8190004,2290002,0,1,1,0,410),(14268,8190004,2290009,0,1,1,0,210),(14269,8190004,2290034,0,1,1,0,410),(14270,8190004,2290058,0,1,1,0,410),(14271,8190004,2290068,0,1,1,0,410),(14272,8190004,2290090,0,1,1,0,410),(14273,8190004,2290053,0,1,1,0,210),(7991,8190004,1482012,0,1,1,0,800),(7992,8190004,2044801,0,1,1,0,100),(14274,8190004,2290121,0,1,1,0,410),(7994,8190004,2040326,0,1,1,0,100),(7995,8190004,2040530,0,1,1,0,100),(7996,8190004,2040924,0,1,1,0,100),(7997,8190004,2044214,0,1,1,0,100),(7998,8190004,4130010,0,1,1,0,6000),(7999,8200000,4000443,0,1,1,0,600000),(8000,8200000,1002640,0,1,1,0,800),(8001,8200000,1041107,0,1,1,0,800),(8002,8200000,1040110,0,1,1,0,800),(8003,8200000,1082112,0,1,1,0,800),(8004,8200000,1072179,0,1,1,0,800),(8005,8200000,1102028,0,1,1,0,800),(8006,8200000,1402015,0,1,1,0,800),(8007,8200000,1452011,0,1,1,0,800),(8011,8200000,4130000,0,1,1,0,6000),(8012,8200000,4130013,0,1,1,0,6000),(8013,8200000,2330004,0,1,1,0,100),(8014,8200000,2040532,0,1,1,0,100),(8015,8200000,2044112,0,1,1,0,100),(8016,8200000,2044807,0,1,1,0,100),(8017,8200001,4000444,0,1,1,0,600000),(8018,8200001,4000446,0,1,1,0,10000),(8019,8200001,2000006,0,1,1,0,20000),(8020,8200001,2022003,0,1,1,0,20000),(8024,8200001,1002532,0,1,1,0,800),(8025,8200001,1072205,0,1,1,0,800),(8026,8200001,1082144,0,1,1,0,800),(8027,8200001,1052128,0,1,1,0,800),(8028,8200001,1051097,0,1,1,0,800),(8029,8200001,1382035,0,1,1,0,800),(8030,8200001,1402005,0,1,1,0,800),(8031,8200001,1312015,0,1,1,0,800),(8032,8200001,4130001,0,1,1,0,6000),(8033,8200001,4130014,0,1,1,0,6000),(8034,8200001,2043301,0,1,1,0,100),(8035,8200001,2040321,0,1,1,0,100),(8036,8200001,2040029,0,1,1,0,100),(14276,8200001,2290050,0,1,1,0,330),(8038,8200002,4000445,0,1,1,0,600000),(8039,8200002,4000446,0,1,1,0,10000),(8040,8200002,2000006,0,1,1,0,20000),(8041,8200002,2022003,0,1,1,0,20000),(8045,8200002,1040113,0,1,1,0,800),(8046,8200002,1060102,0,1,1,0,800),(8047,8200002,1002366,0,1,1,0,800),(8048,8200002,1072195,0,1,1,0,800),(8049,8200002,1082210,0,1,1,0,800),(8050,8200002,1051085,0,1,1,0,800),(8051,8200002,1452017,0,1,1,0,800),(8052,8200002,1402016,0,1,1,0,800),(8053,8200002,1442044,0,1,1,0,800),(8054,8200002,1092027,0,1,1,0,800),(8055,8200002,4130002,0,1,1,0,6000),(8056,8200002,4130015,0,1,1,0,6000),(8057,8200002,2330004,0,1,1,0,100),(8058,8200002,2040707,0,1,1,0,100),(8059,8200002,2044212,0,1,1,0,100),(8060,8200002,2044401,0,1,1,0,100),(8062,8200003,4000447,0,1,1,0,600000),(8063,8200003,4000459,0,1,1,0,20000),(8064,8200003,2000006,0,1,1,0,20000),(8065,8200003,2022003,0,1,1,0,20000),(8069,8200003,1082130,0,1,1,0,800),(8070,8200003,1050095,0,1,1,0,800),(8071,8200003,1002405,0,1,1,0,800),(8072,8200003,1072315,0,1,1,0,800),(8073,8200003,1041118,0,1,1,0,800),(8074,8200003,1061117,0,1,1,0,800),(8075,8200003,1332027,0,1,1,0,800),(8076,8200003,1482012,0,1,1,0,800),(8077,8200003,1412010,0,1,1,0,800),(8078,8200003,4130003,0,1,1,0,6000),(8079,8200003,4130016,0,1,1,0,6000),(8080,8200003,2330004,0,1,1,0,100),(8081,8200003,2044412,0,1,1,0,100),(8082,8200003,2044702,0,1,1,0,100),(8083,8200003,2040927,0,1,1,0,100),(14282,8200003,2290136,0,1,1,0,330),(8085,8200004,4000448,0,1,1,0,600000),(8086,8200004,4000459,0,1,1,0,20000),(8087,8200004,2000006,0,1,1,0,20000),(8088,8200004,2022003,0,1,1,0,20000),(8089,8200004,2020015,0,1,1,0,20000),(8093,8200004,1072198,0,1,1,0,800),(8094,8200004,1082132,0,1,1,0,800),(8095,8200004,1050091,0,1,1,0,800),(8096,8200004,1002326,0,1,1,0,800),(8097,8200004,1041121,0,1,1,0,800),(8098,8200004,1061120,0,1,1,0,800),(8099,8200004,1482011,0,1,1,0,800),(8100,8200004,1302056,0,1,1,0,800),(8101,8200004,1422013,0,1,1,0,800),(8102,8200004,1092036,0,1,1,0,800),(8103,8200004,4130004,0,1,1,0,6000),(8104,8200004,4130017,0,1,1,0,6000),(8105,8200004,2040025,0,1,1,0,100),(8106,8200004,2044312,0,1,1,0,100),(8107,8200004,2044901,0,1,1,0,100),(14280,8200003,1342008,0,1,1,0,830),(8109,8200005,4000449,0,1,1,0,600000),(8110,8200005,4000451,0,1,1,0,10000),(8111,8200005,2000006,0,1,1,0,20000),(8112,8200005,2022003,0,1,1,0,20000),(8113,8200005,2020013,0,1,1,0,20000),(8117,8200005,1072207,0,1,1,0,800),(8118,8200005,1082127,0,1,1,0,800),(8119,8200005,1040118,0,1,1,0,800),(8120,8200005,1060107,0,1,1,0,800),(8121,8200005,1002643,0,1,1,0,800),(8122,8200005,1051103,0,1,1,0,800),(8123,8200005,1302023,0,1,1,0,800),(8124,8200005,1322029,0,1,1,0,800),(8125,8200005,4130005,0,1,1,0,6000),(8126,8200005,2044012,0,1,1,0,100),(8127,8200005,2040931,0,1,1,0,100),(14285,8200005,2290079,0,1,1,0,100),(8129,8200006,4000450,0,1,1,0,600000),(8130,8200006,4000451,0,1,1,0,10000),(8131,8200006,2000006,0,1,1,0,20000),(8132,8200006,2000005,0,1,1,0,20000),(8133,8200006,2022003,0,1,1,0,20000),(8137,8200006,1002378,0,1,1,0,800),(8138,8200006,1072227,0,1,1,0,800),(8139,8200006,1082135,0,1,1,0,800),(8140,8200006,1052131,0,1,1,0,800),(8141,8200006,1051107,0,1,1,0,800),(8142,8200006,1382035,0,1,1,0,800),(8143,8200006,1462017,0,1,1,0,800),(8144,8200006,1412021,0,1,1,0,800),(8145,8200006,1032023,0,1,1,0,800),(8146,8200006,4130006,0,1,1,0,6000),(8147,8200006,2040317,0,1,1,0,100),(8148,8200006,2040824,0,1,1,0,100),(14287,8200006,2290138,0,1,1,0,300),(8150,8200007,4000452,0,1,1,0,600000),(8151,8200007,4000459,0,1,1,0,20000),(8152,8200007,2000006,0,1,1,0,20000),(8153,8200007,2022003,0,1,1,0,20000),(8157,8200007,1040121,0,1,1,0,800),(8158,8200007,1041124,0,1,1,0,800),(8159,8200007,1002400,0,1,1,0,800),(8160,8200007,1072214,0,1,1,0,800),(8161,8200007,1082213,0,1,1,0,800),(8162,8200007,1051091,0,1,1,0,800),(8163,8200007,1462018,0,1,1,0,800),(8164,8200007,1332052,0,1,1,0,800),(8165,8200007,1422027,0,1,1,0,800),(8166,8200007,4130007,0,1,1,0,6000),(8167,8200007,2040701,0,1,1,0,100),(8168,8200007,2044301,0,1,1,0,100),(8169,8200007,2040302,0,1,1,0,100),(14289,8200007,2290136,0,1,1,0,330),(8171,8200008,4000453,0,1,1,0,600000),(8172,8200008,4000459,0,1,1,0,20000),(8173,8200008,2000006,0,1,1,0,20000),(8174,8200008,2022003,0,1,1,0,20000),(8178,8200008,1082140,0,1,1,0,800),(8179,8200008,1050104,0,1,1,0,800),(8180,8200008,1002407,0,1,1,0,800),(8181,8200008,1072318,0,1,1,0,800),(8182,8200008,1060111,0,1,1,0,800),(8183,8200008,1061123,0,1,1,0,800),(8184,8200008,1472033,0,1,1,0,800),(8185,8200008,1442020,0,1,1,0,800),(8186,8200008,1472053,0,1,1,0,800),(8187,8200008,4130008,0,1,1,0,6000),(8188,8200008,2044101,0,1,1,0,100),(8189,8200008,2044501,0,1,1,0,100),(14291,8200008,2290133,0,1,1,0,130),(8191,8200009,4000454,0,1,1,0,600000),(8192,8200009,4000456,0,1,1,0,10000),(8193,8200009,2000006,0,1,1,0,20000),(8194,8200009,2022003,0,1,1,0,20000),(8198,8200009,1072221,0,1,1,0,800),(8199,8200009,1082153,0,1,1,0,800),(8200,8200009,1050108,0,1,1,0,800),(8201,8200009,1002381,0,1,1,0,800),(8202,8200009,1492011,0,1,1,0,800),(8203,8200009,1432011,0,1,1,0,800),(8204,8200009,1402035,0,1,1,0,800),(8205,8200009,4130000,0,1,1,0,6000),(8206,8200009,4130009,0,1,1,0,6000),(8207,8200009,2044601,0,1,1,0,100),(8208,8200009,2044001,0,1,1,0,100),(8209,8200009,2040924,0,1,1,0,100),(14292,8200009,2290039,0,1,1,0,80),(8211,8200010,4000455,0,1,1,0,600000),(8212,8200010,4000456,0,1,1,0,10000),(8213,8200010,2000006,0,1,1,0,20000),(8214,8200010,2000005,0,1,1,0,20000),(8215,8200010,2022003,0,1,1,0,20000),(8219,8200010,1072225,0,1,1,0,800),(8220,8200010,1082158,0,1,1,0,800),(8221,8200010,1050099,0,1,1,0,800),(8222,8200010,1002646,0,1,1,0,800),(8223,8200010,1432030,0,1,1,0,800),(8224,8200010,1312030,0,1,1,0,800),(8225,8200010,4130001,0,1,1,0,6000),(8226,8200010,4130010,0,1,1,0,6000),(8227,8200010,2043801,0,1,1,0,100),(8228,8200010,2041022,0,1,1,0,100),(14293,8200010,2290089,0,1,1,0,80),(8230,8200011,4000457,0,1,1,0,600000),(8231,8200011,4000459,0,1,1,0,20000),(8232,8200011,2000006,0,1,1,0,20000),(8233,8200011,2000005,0,1,1,0,20000),(8234,8200011,2022003,0,1,1,0,20000),(8238,8200011,1002379,0,1,1,0,800),(8239,8200011,1072229,0,1,1,0,800),(8240,8200011,1082138,0,1,1,0,800),(8241,8200011,1052131,0,1,1,0,800),(8242,8200011,1372010,0,1,1,0,800),(8243,8200011,1322045,0,1,1,0,800),(8244,8200011,4130002,0,1,1,0,6000),(8245,8200011,4130011,0,1,1,0,6000),(8246,8200011,2044201,0,1,1,0,100),(8247,8200011,2041008,0,1,1,0,100),(8248,8200011,2044602,0,1,1,0,100),(14296,8200011,2290046,0,1,1,0,350),(8250,8200012,4000458,0,1,1,0,600000),(8251,8200012,4000459,0,1,1,0,20000),(8252,8200012,2000006,0,1,1,0,20000),(8253,8200012,2000005,0,1,1,0,20000),(8254,8200012,2022003,0,1,1,0,20000),(8258,8200012,1040122,0,1,1,0,800),(8259,8200012,1060111,0,1,1,0,800),(8260,8200012,1002401,0,1,1,0,800),(8261,8200012,1072216,0,1,1,0,800),(8262,8200012,1082213,0,1,1,0,800),(8263,8200012,1452021,0,1,1,0,800),(8264,8200012,1322045,0,1,1,0,800),(8265,8200012,4130003,0,1,1,0,6000),(8266,8200012,4130012,0,1,1,0,6000),(8267,8200012,2040501,0,1,1,0,100),(8268,8200012,2043701,0,1,1,0,100),(14299,8200012,2290139,0,1,1,0,150),(8270,8220000,4000073,0,1,1,0,600000),(8271,8220000,4000073,0,1,1,0,600000),(8272,8220000,4000073,0,1,1,0,600000),(8273,8220000,4000074,0,1,1,0,600000),(8274,8220000,4000074,0,1,1,0,600000),(8275,8220000,4000074,0,1,1,0,600000),(8276,8220000,4000021,0,1,1,0,500000),(8277,8220000,4000021,0,1,1,0,500000),(8278,8220000,4000021,0,1,1,0,500000),(8279,8220000,4006000,0,1,1,0,100000),(8283,8220000,2000004,0,1,1,0,999999),(8284,8220000,2000006,0,1,1,0,999999),(8285,8220000,2002003,0,1,1,0,200000),(8286,8220000,2012001,0,1,1,0,200000),(8287,8220000,2040707,0,1,1,0,1500),(8288,8220000,2041007,0,1,1,0,1500),(8289,8220000,2043701,0,1,1,0,1500),(8290,8220000,2044301,0,1,1,0,1500),(8291,8220000,2041019,0,1,1,0,1500),(8292,8220000,2044401,0,1,1,0,1500),(8293,8220000,2040001,0,1,1,0,1500),(8294,8220000,2040301,0,1,1,0,1500),(8295,8220000,2040401,0,1,1,0,1500),(8296,8220000,2043301,0,1,1,0,1500),(8297,8220000,2044302,0,1,1,0,1500),(8298,8220000,2041020,0,1,1,0,1500),(8299,8220000,2044402,0,1,1,0,1500),(8300,8220000,2040002,0,1,1,0,1500),(8301,8220000,2040302,0,1,1,0,1500),(8302,8220000,2060001,0,1,1,0,300000),(8303,8220000,2061001,0,1,1,0,300000),(8304,8220000,1002532,0,1,1,0,15000),(8305,8220000,1002366,0,1,1,0,15000),(8306,8220000,1002405,0,1,1,0,15000),(8307,8220000,1002326,0,1,1,0,15000),(8308,8220000,1040113,0,1,1,0,8000),(8309,8220000,1041121,0,1,1,0,8000),(8310,8220000,1050095,0,1,1,0,7000),(8311,8220000,1051097,0,1,1,0,7000),(8312,8220000,1050091,0,1,1,0,7000),(8313,8220000,1051085,0,1,1,0,7000),(8314,8220000,1040117,0,1,1,0,8000),(8315,8220000,1041117,0,1,1,0,8000),(8316,8220000,1082130,0,1,1,0,10000),(8317,8220000,1082134,0,1,1,0,10000),(8318,8220000,1082127,0,1,1,0,10000),(8319,8220000,1082144,0,1,1,0,10000),(8320,8220000,1072198,0,1,1,0,8000),(8321,8220000,1072209,0,1,1,0,8000),(8322,8220000,1072205,0,1,1,0,8000),(8323,8220000,1072194,0,1,1,0,8000),(8324,8220000,1002643,0,1,1,0,15000),(8325,8220000,1052128,0,1,1,0,7000),(8326,8220000,1082210,0,1,1,0,10000),(8327,8220000,1072315,0,1,1,0,8000),(8328,8220000,2043017,0,1,1,0,1500),(8329,8220000,2044114,0,1,1,0,1500),(8330,8220000,2044214,0,1,1,0,1500),(8331,8220001,4000048,0,1,1,0,600000),(8332,8220001,4000049,0,1,1,0,600000),(8333,8220001,4000051,0,1,1,0,600000),(8334,8220001,4000257,0,1,1,0,600000),(8335,8220001,4000021,0,1,1,0,500000),(8339,8220001,2000004,0,1,1,0,999999),(8340,8220001,2000006,0,1,1,0,999999),(8341,8220001,2022001,0,1,1,0,200000),(8342,8220001,2022186,0,1,1,0,200000),(8343,8220001,2043701,0,1,1,0,1500),(8344,8220001,2041016,0,1,1,0,1500),(8345,8220001,2043801,0,1,1,0,1500),(8346,8220001,2040804,0,1,1,0,1000),(8347,8220001,2040501,0,1,1,0,1500),(8348,8220001,2040601,0,1,1,0,1500),(8349,8220001,2040701,0,1,1,0,1500),(8350,8220001,2040801,0,1,1,0,1500),(8351,8220001,2040901,0,1,1,0,1500),(8352,8220001,2041001,0,1,1,0,1500),(8353,8220001,2041008,0,1,1,0,1500),(8354,8220001,2043302,0,1,1,0,1500),(8355,8220001,2043702,0,1,1,0,1500),(8356,8220001,2041017,0,1,1,0,1500),(8357,8220001,2043802,0,1,1,0,1500),(8358,8220001,2060001,0,1,1,0,300000),(8359,8220001,2061001,0,1,1,0,300000),(8360,8220001,2070008,0,1,1,0,2000),(8361,8220001,1302023,0,1,1,0,7000),(8362,8220001,1312015,0,1,1,0,7000),(8363,8220001,1322029,0,1,1,0,7000),(8364,8220001,1332027,0,1,1,0,5000),(8365,8220001,1382035,0,1,1,0,7000),(8366,8220001,1402016,0,1,1,0,7000),(8367,8220001,1412010,0,1,1,0,7000),(8368,8220001,1422013,0,1,1,0,7000),(8369,8220001,1432011,0,1,1,0,5000),(8370,8220001,1442020,0,1,1,0,7000),(8371,8220001,1452017,0,1,1,0,5000),(8372,8220001,1462018,0,1,1,0,5000),(8373,8220001,1472033,0,1,1,0,5000),(8374,8220001,1032017,0,1,1,0,10000),(8375,8220001,1092028,0,1,1,0,7000),(8376,8220001,1482011,0,1,1,0,5000),(8377,8220001,1492011,0,1,1,0,5000),(8378,8220001,2044802,0,1,1,0,1500),(8379,8220001,2040026,0,1,1,0,1500),(8380,8220001,2040323,0,1,1,0,1500),(8381,8220001,2040927,0,1,1,0,1500),(8382,8220001,2044314,0,1,1,0,1500),(8383,8220001,2049100,0,1,1,0,1500),(8384,8220002,4000364,0,1,1,0,600000),(8385,8220002,4000364,0,1,1,0,600000),(8386,8220002,4000364,0,1,1,0,600000),(8387,8220002,4000365,0,1,1,0,600000),(8388,8220002,4000365,0,1,1,0,600000),(8389,8220002,4000365,0,1,1,0,600000),(8390,8220002,4000356,0,1,1,0,600000),(8391,8220002,4000356,0,1,1,0,600000),(8392,8220002,4000356,0,1,1,0,600000),(8396,8220002,2000004,0,1,1,0,999999),(8397,8220002,2000006,0,1,1,0,999999),(8398,8220002,2040301,0,1,1,0,1500),(8399,8220002,2040501,0,1,1,0,1500),(8400,8220002,2040504,0,1,1,0,1500),(8401,8220002,2040513,0,1,1,0,1500),(8402,8220002,2040516,0,1,1,0,1500),(8403,8220002,2041007,0,1,1,0,1500),(8404,8220002,2041013,0,1,1,0,1500),(8405,8220002,2041016,0,1,1,0,1500),(8406,8220002,2041019,0,1,1,0,1500),(8407,8220002,2041022,0,1,1,0,1500),(8408,8220002,1372009,0,1,1,0,7000),(8409,8220002,1302023,0,1,1,0,7000),(8410,8220002,1312015,0,1,1,0,7000),(8411,8220002,1322029,0,1,1,0,7000),(8412,8220002,1402005,0,1,1,0,7000),(8413,8220002,1402016,0,1,1,0,7000),(8414,8220002,1412010,0,1,1,0,7000),(8415,8220002,1422013,0,1,1,0,7000),(8416,8220002,1432011,0,1,1,0,5000),(8417,8220002,1442020,0,1,1,0,7000),(8418,8220002,1452017,0,1,1,0,5000),(8419,8220002,1462018,0,1,1,0,5000),(8420,8220002,1332027,0,1,1,0,5000),(8421,8220002,1472033,0,1,1,0,5000),(8422,8220002,1332026,0,1,1,0,5000),(8423,8220002,1482011,0,1,1,0,5000),(8424,8220002,1492011,0,1,1,0,5000),(8425,8220002,1382008,0,1,1,0,7000),(8426,8220002,2070007,0,1,1,0,1000),(8427,8220002,2330003,0,1,1,0,1000),(8428,8220002,2040326,0,1,1,0,1500),(8429,8220002,2040422,0,1,1,0,1500),(8430,8220002,2040532,0,1,1,0,1500),(8431,8220002,2040931,0,1,1,0,1500),(8432,8220003,4000268,0,1,1,0,600000),(8433,8220003,4000268,0,1,1,0,600000),(8434,8220003,4000268,0,1,1,0,600000),(8435,8220003,4000269,0,1,1,0,600000),(8436,8220003,4000269,0,1,1,0,600000),(8437,8220003,4000269,0,1,1,0,600000),(8438,8220003,4000270,0,1,1,0,600000),(8439,8220003,4000270,0,1,1,0,600000),(8440,8220003,4000270,0,1,1,0,600000),(8441,8220003,4006001,0,1,1,0,100000),(8442,8220003,4006000,0,1,1,0,100000),(8443,8220003,2000005,0,1,1,0,999999),(8444,8220003,2000006,0,1,1,0,999999),(8445,8220003,2020013,0,1,1,0,999999),(8446,8220003,2290006,0,1,1,0,5000),(8447,8220003,2290031,0,1,1,0,5000),(8448,8220003,2290033,0,1,1,0,5000),(8449,8220003,2290061,0,1,1,0,5000),(8450,8220003,2290077,0,1,1,0,5000),(8451,8220003,2290105,0,1,1,0,5000),(8452,8220003,2290118,0,1,1,0,5000),(8453,8220003,1382035,0,1,1,0,7000),(8454,8220003,1372010,0,1,1,0,7000),(8455,8220003,1302056,0,1,1,0,7000),(8456,8220003,1312030,0,1,1,0,7000),(8457,8220003,1322045,0,1,1,0,7000),(8458,8220003,1402035,0,1,1,0,7000),(8459,8220003,1412021,0,1,1,0,7000),(8460,8220003,1422027,0,1,1,0,7000),(8461,8220003,1432030,0,1,1,0,5000),(8462,8220003,1442044,0,1,1,0,7000),(8463,8220003,1452019,0,1,1,0,5000),(8464,8220003,1462015,0,1,1,0,5000),(8465,8220003,1332052,0,1,1,0,5000),(8466,8220003,1472053,0,1,1,0,5000),(8467,8220003,1332051,0,1,1,0,5000),(8468,8220003,1482012,0,1,1,0,5000),(8469,8220003,1492012,0,1,1,0,5000),(8470,8220003,2040824,0,1,1,0,1500),(8471,8220003,2044212,0,1,1,0,1500),(8472,8220004,4000460,0,1,1,0,600000),(8473,8220004,4006001,0,1,1,0,100000),(8474,8220004,4006000,0,1,1,0,100000),(8475,8220004,2000005,0,1,1,0,999999),(8476,8220004,2000006,0,1,1,0,999999),(8477,8220004,2020013,0,1,1,0,999999),(8478,8220004,2290018,0,1,1,0,5000),(8479,8220004,2290019,0,1,1,0,5000),(8480,8220004,2290025,0,1,1,0,5000),(8481,8220004,2290059,0,1,1,0,5000),(8482,8220004,2290077,0,1,1,0,5000),(8484,8220004,1082141,0,1,1,0,10000),(8485,8220004,1050105,0,1,1,0,7000),(8486,8220004,1002405,0,1,1,0,15000),(8487,8220004,1072318,0,1,1,0,8000),(8488,8220004,1051093,0,1,1,0,7000),(8489,8220004,1332052,0,1,1,0,5000),(8490,8220004,1322045,0,1,1,0,7000),(8491,8220004,1372010,0,1,1,0,7000),(8492,8220004,2049000,0,1,1,0,1500),(8493,8220004,2330004,0,1,1,0,1000),(8494,8220004,2040326,0,1,1,0,1500),(8495,8220004,2040924,0,1,1,0,1500),(8496,8220004,2040025,0,1,1,0,1500),(8497,8220004,2040532,0,1,1,0,1500),(8498,8220004,2040029,0,1,1,0,1500),(8499,8220005,4000461,0,1,1,0,600000),(8500,8220005,4006001,0,1,1,0,100000),(8501,8220005,4006000,0,1,1,0,100000),(8502,8220005,2000005,0,1,1,0,999999),(8503,8220005,2000006,0,1,1,0,999999),(8504,8220005,2020013,0,1,1,0,999999),(8505,8220005,2290003,0,1,1,0,5000),(8506,8220005,2290037,0,1,1,0,5000),(8507,8220005,2290055,0,1,1,0,5000),(8508,8220005,2290080,0,1,1,0,5000),(8509,8220005,2290099,0,1,1,0,5000),(8510,8220005,1072222,0,1,1,0,8000),(8511,8220005,1082154,0,1,1,0,10000),(8512,8220005,1050108,0,1,1,0,7000),(8513,8220005,1002382,0,1,1,0,15000),(8514,8220005,1051104,0,1,1,0,7000),(8515,8220005,1482012,0,1,1,0,5000),(8516,8220005,1402035,0,1,1,0,7000),(8517,8220005,1452021,0,1,1,0,5000),(8518,8220005,2049000,0,1,1,0,1500),(8519,8220005,2040317,0,1,1,0,1500),(8520,8220005,2040321,0,1,1,0,1500),(8521,8220005,2040931,0,1,1,0,1500),(8522,8220005,2040927,0,1,1,0,1500),(8523,8220006,4000462,0,1,1,0,600000),(8524,8220006,4006001,0,1,1,0,100000),(8525,8220006,4006000,0,1,1,0,100000),(8526,8220006,2000005,0,1,1,0,999999),(8527,8220006,2000006,0,1,1,0,999999),(8528,8220006,2020013,0,1,1,0,999999),(8529,8220006,2290013,0,1,1,0,5000),(8530,8220006,2290043,0,1,1,0,5000),(8531,8220006,2290061,0,1,1,0,5000),(8532,8220006,2290120,0,1,1,0,5000),(8533,8220006,2290090,0,1,1,0,5000),(8534,8220006,1072226,0,1,1,0,8000),(8535,8220006,1082160,0,1,1,0,10000),(8536,8220006,1050099,0,1,1,0,7000),(8537,8220006,1002646,0,1,1,0,15000),(8538,8220006,1051107,0,1,1,0,7000),(8539,8220006,1432030,0,1,1,0,5000),(8540,8220006,1462017,0,1,1,0,5000),(8541,8220006,1472053,0,1,1,0,5000),(8542,8220006,1492012,0,1,1,0,5000),(8543,8220006,2049100,0,1,1,0,1500),(8544,8220006,2043701,0,1,1,0,1500),(8545,8220006,2044701,0,1,1,0,1500),(8546,8220006,2044301,0,1,1,0,1500),(8547,8220006,2044501,0,1,1,0,1500),(8548,8220006,2044801,0,1,1,0,1500),(8549,8220006,2044901,0,1,1,0,1500),(8550,8220007,2000005,0,1,1,0,999999),(8551,8220007,2000004,0,1,1,0,999999),(8552,8220007,1032030,0,1,1,0,10000),(8553,8220007,1382007,0,1,1,0,7000),(8554,8220007,1322019,0,1,1,0,7000),(8555,8220007,1312010,0,1,1,0,7000),(8556,8220007,1412008,0,1,1,0,7000),(8557,8220007,1432007,0,1,1,0,5000),(8558,8220007,1302012,0,1,1,0,7000),(8559,8220007,1332018,0,1,1,0,5000),(8560,8220007,1332019,0,1,1,0,5000),(8561,8220007,2043001,0,1,1,0,1500),(8562,8220007,2043101,0,1,1,0,1500),(8563,8220007,2043301,0,1,1,0,1500),(8564,8220007,2043701,0,1,1,0,1500),(8565,8220007,2044001,0,1,1,0,1500),(8566,8220007,2044201,0,1,1,0,1500),(8567,8220007,2044301,0,1,1,0,1500),(8568,8220007,2044501,0,1,1,0,1500),(8569,8220007,2044601,0,1,1,0,1500),(8570,8220007,2044701,0,1,1,0,1500),(8571,8220009,2000005,0,1,1,0,999999),(8572,8220009,1452009,0,1,1,0,5000),(8573,8220009,1382007,0,1,1,0,7000),(8574,8220009,1462009,0,1,1,0,5000),(8575,8220009,1322019,0,1,1,0,7000),(8576,8220009,1312010,0,1,1,0,7000),(8577,8220009,1412008,0,1,1,0,7000),(8578,8220009,1422010,0,1,1,0,7000),(8579,8220009,1472026,0,1,1,0,5000),(8580,8220009,1432007,0,1,1,0,5000),(8581,8220009,1442008,0,1,1,0,7000),(8582,8220009,1302012,0,1,1,0,7000),(8583,8220009,1402012,0,1,1,0,7000),(8584,8220009,1332018,0,1,1,0,5000),(8585,8220009,1332019,0,1,1,0,5000),(8586,8220009,2043001,0,1,1,0,1500),(8587,8220009,2043101,0,1,1,0,1500),(8588,8220009,2043201,0,1,1,0,1500),(8589,8220009,2043301,0,1,1,0,1500),(8590,8220009,2043701,0,1,1,0,1500),(8591,8220009,2043801,0,1,1,0,1500),(8592,8220009,2044001,0,1,1,0,1500),(8593,8220009,2044101,0,1,1,0,1500),(8594,8220009,2044201,0,1,1,0,1500),(8595,8220009,2044301,0,1,1,0,1500),(8596,8220009,2044401,0,1,1,0,1500),(8597,8220009,2044501,0,1,1,0,1500),(8598,8220009,2044601,0,1,1,0,1500),(8599,8220009,2044701,0,1,1,0,1500),(8600,8220009,2000004,0,1,1,0,999999),(8601,8220009,1092017,0,1,1,0,7000),(13975,8500002,2040421,0,1,1,0,20000),(13974,8500002,2040419,0,1,1,0,5000),(13973,8500002,2040321,0,1,1,0,6000),(13972,8500002,2040318,0,1,1,0,1500),(13971,8500002,1072318,0,1,1,0,10000),(13970,8500002,1082213,0,1,1,0,10000),(13969,8500002,1052131,0,1,1,0,7000),(13968,8500002,1002646,0,1,1,0,15000),(13967,8500002,1482011,0,1,1,0,5000),(13966,8500002,1072220,0,1,1,0,10000),(13965,8500002,1072213,0,1,1,0,8000),(13964,8500002,2041013,0,1,1,0,5000),(13963,8500002,1050106,0,1,1,0,8000),(13962,8500002,2020015,0,45,55,0,999999),(13961,8500002,1050102,0,1,1,0,8000),(13960,8500002,2041022,0,1,1,0,4000),(13959,8500002,1061121,0,1,1,0,8000),(13958,8500002,2020013,0,45,55,0,999999),(13957,8500002,1332027,0,1,1,0,9000),(13956,8500002,1041122,0,1,1,0,8000),(13955,8500002,1072224,0,1,1,0,8000),(13954,8500002,2000004,0,35,45,0,999999),(13953,8500002,2041016,0,1,1,0,4000),(13952,8500002,1462018,0,1,1,0,9000),(13951,8500002,1040120,0,1,1,0,8000),(13950,8500002,1050098,0,1,1,0,8000),(13949,8500002,1312015,0,1,1,0,9000),(13948,8500002,1060109,0,1,1,0,8000),(13947,8500002,2041019,0,1,1,0,1500),(13946,8500002,1051101,0,1,1,0,8000),(13945,8500002,1332026,0,1,1,0,9000),(13944,8500002,2000005,0,25,35,0,999999),(13943,8500002,1072221,0,1,1,0,20000),(13942,8500002,4031901,0,1,1,0,250000),(13941,8500002,4001084,0,1,1,0,999999),(13940,8500002,1372009,0,1,1,0,9000),(13939,8500002,1072227,0,1,1,0,40000),(13938,8500002,1051092,0,1,1,0,40000),(13937,8500002,1051105,0,1,1,0,40000),(13936,8500002,4031196,0,1,1,0,1000000),(13935,8500002,4031196,0,1,1,0,700000),(13934,8500002,4031196,0,1,1,0,1000000),(13933,8500002,4031196,0,1,1,0,400000),(13932,8500002,1082158,0,1,1,0,10000),(13931,8500002,1002377,0,1,1,0,20000),(13918,8500002,2290051,0,1,1,0,15000),(13917,8500002,2290089,0,1,1,0,5000),(8661,8510000,2020013,0,1,1,0,999999),(8662,8510000,2020015,0,1,1,0,999999),(8663,8510000,2000005,0,1,1,0,999999),(8664,8510000,2000004,0,1,1,0,999999),(8665,8510000,1302023,0,1,1,0,7000),(8666,8510000,1322029,0,1,1,0,7000),(8667,8510000,1402005,0,1,1,0,7000),(8668,8510000,1412010,0,1,1,0,7000),(8669,8510000,1040121,0,1,1,0,8000),(8670,8510000,1060110,0,1,1,0,8000),(8671,8510000,1050103,0,1,1,0,7000),(8672,8510000,1051102,0,1,1,0,7000),(8673,8510000,1050097,0,1,1,0,7000),(8674,8510000,1051091,0,1,1,0,7000),(8675,8510000,1041123,0,1,1,0,8000),(8676,8510000,1061122,0,1,1,0,8000),(8677,8510000,1050107,0,1,1,0,7000),(8678,8510000,1051106,0,1,1,0,7000),(8679,8510000,2040513,0,1,1,0,1500),(8680,8510000,2040516,0,1,1,0,1500),(8681,8510000,2040501,0,1,1,0,1500),(8682,8510000,2040504,0,1,1,0,1500),(8683,8510000,2040401,0,1,1,0,1500),(8684,8510000,4001085,0,1,1,0,600000),(8685,8510000,4000175,0,1,1,0,600000),(8686,8510000,1492011,0,1,1,0,5000),(8687,8510000,1052131,0,1,1,0,7000),(8688,8510000,2290000,0,1,1,0,5000),(8689,8510000,2290001,0,1,1,0,5000),(8690,8510000,2290004,0,1,1,0,5000),(8691,8510000,2290005,0,1,1,0,5000),(8692,8510000,2290024,0,1,1,0,5000),(8693,8510000,2290025,0,1,1,0,5000),(8694,8510000,2290026,0,1,1,0,5000),(8695,8510000,2290027,0,1,1,0,5000),(8696,8510000,2290052,0,1,1,0,5000),(8697,8510000,2290053,0,1,1,0,5000),(8698,8510000,2290054,0,1,1,0,5000),(8699,8510000,2290055,0,1,1,0,5000),(8700,8510000,2290076,0,1,1,0,5000),(8701,8510000,2290077,0,1,1,0,5000),(8702,8510000,2290082,0,1,1,0,5000),(8703,8510000,2290083,0,1,1,0,5000),(8704,8510000,2290097,0,1,1,0,5000),(8705,8510000,2290099,0,1,1,0,5000),(8706,8180000,2290106,0,1,1,0,5000),(8707,8510000,2290108,0,1,1,0,5000),(8708,8510000,2290112,0,1,1,0,5000),(8709,8510000,2290114,0,1,1,0,5000),(8710,8510000,2290122,0,1,1,0,5000),(8711,8510000,2290124,0,1,1,0,5000),(8768,8810018,2020013,0,1,1,0,999999),(8769,8810018,2020015,0,1,1,0,999999),(8770,8810018,2000005,0,1,1,0,999999),(8771,8810018,2000006,0,1,1,0,999999),(8772,8810018,2000004,0,1,1,0,999999),(8773,8810018,1302056,0,1,1,0,1512000),(8774,8810018,1312030,0,1,1,0,1512000),(8775,8810018,1322045,0,1,1,0,1512000),(8776,8810018,1332051,0,1,1,0,1080000),(8777,8810018,1332052,0,1,1,0,1080000),(8778,8810018,1372010,0,1,1,0,1512000),(8779,8810018,1382035,0,1,1,0,1512000),(8780,8810018,1402035,0,1,1,0,1512000),(8781,8810018,1412021,0,1,1,0,1512000),(8782,8810018,1422027,0,1,1,0,1512000),(8783,8810018,1432030,0,1,1,0,1080000),(8784,8810018,1442044,0,1,1,0,1512000),(8785,8810018,1452019,0,1,1,0,1080000),(8786,8810018,1452020,0,1,1,0,1080000),(8787,8810018,1452021,0,1,1,0,1080000),(8788,8810018,1462015,0,1,1,0,1080000),(8789,8810018,1462016,0,1,1,0,1080000),(8790,8810018,1462017,0,1,1,0,1080000),(8791,8810018,1472053,0,1,1,0,1080000),(8792,8810018,1372032,0,1,1,0,1512000),(8793,8810018,1302059,0,1,1,0,1512000),(8794,8810018,1312031,0,1,1,0,1512000),(8795,8810018,1322052,0,1,1,0,1512000),(8796,8810018,1332049,0,1,1,0,1080000),(8797,8810018,1332050,0,1,1,0,1080000),(8798,8810018,1382036,0,1,1,0,1512000),(8799,8810018,1402036,0,1,1,0,1512000),(8800,8810018,1412026,0,1,1,0,1512000),(8801,8810018,1422028,0,1,1,0,1512000),(8802,8810018,1432038,0,1,1,0,1080000),(8803,8810018,1442045,0,1,1,0,1512000),(8804,8810018,1452044,0,1,1,0,1080000),(8805,8810018,1462039,0,1,1,0,1080000),(8806,8810018,1472051,0,1,1,0,1080000),(8807,8810018,1472052,0,1,1,0,1080000),(8808,8810018,1122000,0,1,1,0,999999),(8809,8810018,1122000,0,1,1,0,999999),(8810,8810018,1122000,0,1,1,0,300000),(8811,8810018,1122000,0,1,1,0,300000),(8812,8810018,2290017,0,1,1,0,1080000),(8813,8810018,2290021,0,1,1,0,1080000),(8814,8810018,2290023,0,1,1,0,1080000),(8815,8810018,2290041,0,1,1,0,1080000),(8816,8810018,2290047,0,1,1,0,1080000),(8817,8810018,2290049,0,1,1,0,1080000),(8818,8810018,2290065,0,1,1,0,1080000),(8819,8810018,2290075,0,1,1,0,1080000),(8820,8810018,2290085,0,1,1,0,1080000),(8821,8810018,2290095,0,1,1,0,1080000),(8822,8810018,2290096,0,1,1,0,800000),(8823,8810018,1482012,0,1,1,0,1080000),(8824,8810018,1492012,0,1,1,0,1080000),(8825,8810018,1482013,0,1,1,0,1080000),(8826,8810018,1492013,0,1,1,0,1080000),(8827,8810018,2290111,0,1,1,0,1080000),(8828,8810018,2290116,0,1,1,0,1080000),(8829,8810018,2040317,0,1,1,0,648000),(8830,8810018,2040418,0,1,1,0,648000),(8831,8810018,2040421,0,1,1,0,648000),(8832,8810018,2040512,0,1,1,0,648000),(8833,8810018,2040515,0,1,1,0,648000),(8834,8810018,2040625,0,1,1,0,648000),(8835,8810018,2049000,0,1,1,0,324000),(8836,8810018,2049100,0,1,1,0,648000),(8837,9300003,1072369,0,1,1,0,300000),(8838,9300012,4001023,0,1,1,0,999999),(8839,9300028,4001024,0,1,1,0,999999),(8840,9300039,4001054,0,1,1,0,600000),(8841,9300119,2000002,0,1,1,0,200000),(8842,9300119,2000004,0,1,1,0,999999),(8843,9300119,2000006,0,1,1,0,999999),(8844,9300119,2020013,0,1,1,0,999999),(8845,9300119,2020014,0,1,1,0,200000),(8846,9300119,2020015,0,1,1,0,999999),(8847,9300119,2041010,0,1,1,0,1500),(8848,9300119,2040502,0,1,1,0,1500),(8849,9300119,2044201,0,1,1,0,1500),(8850,9300119,2040001,0,1,1,0,1500),(8851,9300119,2040601,0,1,1,0,1500),(8852,9300119,2040505,0,1,1,0,1500),(8853,9300119,2040002,0,1,1,0,1500),(8854,9300119,2040401,0,1,1,0,1500),(8855,9300119,2043201,0,1,1,0,1500),(8856,9300119,2044101,0,1,1,0,1500),(8857,9300119,2043101,0,1,1,0,1500),(8858,9300119,2040801,0,1,1,0,1500),(8859,9300139,2000002,0,1,1,0,200000),(8860,9300139,2000004,0,1,1,0,999999),(8861,9300139,2000006,0,1,1,0,999999),(8862,9300139,2020013,0,1,1,0,999999),(8863,9300139,2020014,0,1,1,0,200000),(8864,9300139,2020015,0,1,1,0,999999),(8865,9300139,2044601,0,1,1,0,1500),(8866,9300139,2040707,0,1,1,0,1500),(8867,9300139,2044401,0,1,1,0,1500),(8868,9300139,2040504,0,1,1,0,1500),(8869,9300139,2044501,0,1,1,0,1500),(8870,9300139,2044001,0,1,1,0,1500),(8871,9300139,2043701,0,1,1,0,1500),(8872,9300139,2043001,0,1,1,0,1500),(8873,9300139,2040004,0,1,1,0,1500),(8874,9300139,2044701,0,1,1,0,1500),(8875,9300139,2043801,0,1,1,0,1500),(8876,9300139,2043301,0,1,1,0,1500),(8877,9300182,4001164,0,1,1,0,600000),(8878,9300182,2000002,0,1,1,0,200000),(8879,9300182,2000006,0,1,1,0,999999),(8880,9300182,2020013,0,1,1,0,999999),(8881,9300182,2020014,0,1,1,0,200000),(8882,9300182,2020015,0,1,1,0,999999),(8883,9300182,2043001,0,1,1,0,1500),(8884,9300182,2043101,0,1,1,0,1500),(8885,9300182,2043201,0,1,1,0,1500),(8886,9300182,2043301,0,1,1,0,1500),(8887,9300182,2043701,0,1,1,0,1500),(8888,9300182,2043801,0,1,1,0,1500),(8889,9300182,2044001,0,1,1,0,1500),(8890,9300182,2044101,0,1,1,0,1500),(8891,9300182,2044201,0,1,1,0,1500),(8892,9300182,2044301,0,1,1,0,1500),(8893,9300182,2044401,0,1,1,0,1500),(8894,9300182,2044501,0,1,1,0,1500),(8895,9300182,2044601,0,1,1,0,1500),(8896,9300182,2044701,0,1,1,0,1500),(8897,9300182,2049000,0,1,1,0,1500),(8898,9300215,2022413,0,1,1,0,200000),(8899,9300215,2022414,0,1,1,0,200000),(8900,9300215,2022415,0,1,1,0,200000),(8901,9300215,2022416,0,1,1,0,200000),(8902,9300215,2022417,0,1,1,0,200000),(8903,9300215,2022418,0,1,1,0,200000),(8904,9300215,2022419,0,1,1,0,200000),(8905,9300215,2022420,0,1,1,0,200000),(8906,9300215,2022421,0,1,1,0,200000),(8907,9300274,4000001,0,1,1,0,600000),(8908,9300274,2000000,0,1,1,0,20000),(8909,9300274,2040705,0,1,1,0,100),(8910,9300274,1072004,0,1,1,0,800),(8911,9300274,1002043,0,1,1,0,800),(8912,9300274,1432000,0,1,1,0,800),(8913,9300274,1312000,0,1,1,0,800),(8914,9300274,2060000,0,1,1,0,30000),(8917,9300274,2061000,0,1,1,0,30000),(8918,9300274,1082012,0,1,1,0,800),(8919,9300274,1072015,0,1,1,0,800),(8920,9300274,1072031,0,1,1,0,800),(8921,9300274,4030001,0,1,1,0,300),(8922,9300274,1052095,0,1,1,0,800),(8923,9300274,2330000,0,1,1,0,100),(8924,9500317,4001141,0,1,1,0,600000),(8925,9500317,2022279,0,1,1,0,200000),(8926,8830000,1302112,0,1,1,0,7000),(8927,8830000,1302113,0,1,1,0,7000),(8928,8830000,1312042,0,1,1,0,7000),(8929,8830000,1312043,0,1,1,0,7000),(8930,8830000,1322068,0,1,1,0,7000),(8931,8830000,1322069,0,1,1,0,7000),(8932,8830000,1332084,0,1,1,0,5000),(8933,8830000,1332085,0,1,1,0,5000),(8934,8830000,1332086,0,1,1,0,5000),(8935,8830000,1332087,0,1,1,0,5000),(8936,8830000,1372050,0,1,1,0,7000),(8937,8830000,1382066,0,1,1,0,7000),(8938,8830000,1382067,0,1,1,0,7000),(8939,8830000,1402056,0,1,1,0,7000),(8940,8830000,1402057,0,1,1,0,7000),(8941,8830000,1402058,0,1,1,0,7000),(8942,8830000,1402059,0,1,1,0,7000),(8943,8830000,1412038,0,1,1,0,7000),(8944,8830000,1412039,0,1,1,0,7000),(8945,8830000,1422042,0,1,1,0,7000),(8946,8830000,1422043,0,1,1,0,7000),(8947,8830000,1432054,0,1,1,0,5000),(8948,8830000,1432055,0,1,1,0,5000),(8949,8830000,1442074,0,1,1,0,7000),(8950,8830000,1442075,0,1,1,0,7000),(8951,8830000,1452066,0,1,1,0,5000),(8952,8830000,1452067,0,1,1,0,5000),(8953,8830000,1452068,0,1,1,0,5000),(8954,8830000,1452069,0,1,1,0,5000),(8955,8830000,1452070,0,1,1,0,5000),(8956,8830000,1462059,0,1,1,0,5000),(8957,8830000,1462060,0,1,1,0,5000),(8958,8830000,1462061,0,1,1,0,5000),(8959,8830000,1462062,0,1,1,0,5000),(8960,8830000,1462063,0,1,1,0,5000),(8961,8830000,1472083,0,1,1,0,5000),(8962,8830000,1472084,0,1,1,0,5000),(8963,8830000,1482031,0,1,1,0,5000),(8964,8830000,1482032,0,1,1,0,5000),(8965,8830000,1492035,0,1,1,0,5000),(8966,8830000,1492036,0,1,1,0,5000),(8967,8830000,2000004,0,1,1,0,999999),(8968,8830000,2000005,0,1,1,0,999999),(8969,8830000,2000006,0,1,1,0,999999),(8970,8830000,2030000,0,1,1,0,200000),(8971,8830000,2050004,0,1,1,0,500000),(8972,8830000,2020001,0,1,1,0,200000),(8973,8830000,2020000,0,1,1,0,200000),(8974,8830000,2000016,0,1,1,0,200000),(8975,8830000,2020005,0,1,1,0,200000),(8976,8830000,2020003,0,1,1,0,200000),(8977,8830000,2020009,0,1,1,0,200000),(8978,8830000,2020006,0,1,1,0,200000),(8979,8830000,2020007,0,1,1,0,200000),(8980,8830000,2022000,0,1,1,0,200000),(8981,8830000,2020010,0,1,1,0,200000),(8982,8830000,2001000,0,1,1,0,200000),(8983,8830000,2001002,0,1,1,0,200000),(8984,8830000,2020012,0,1,1,0,200000),(8985,8830000,2020013,0,1,1,0,999999),(8986,8830000,2020014,0,1,1,0,200000),(8987,8830000,2020015,0,1,1,0,999999),(8988,8830000,2049100,0,1,1,0,1500),(8989,8830000,2049000,0,1,1,0,1500),(8990,8830000,2040739,0,1,1,0,1500),(8991,8830000,1072376,0,1,1,0,8000),(8992,8830000,4001261,0,1,1,0,600000),(8993,8830000,2330005,0,1,1,0,1000),(8994,8830000,1382068,0,1,1,0,7000),(8995,8830000,1402062,0,1,1,0,7000),(8996,8830000,1472086,0,1,1,0,5000),(8997,8830000,1442078,0,1,1,0,7000),(8998,8830000,1452071,0,1,1,0,5000),(8999,8830000,1492037,0,1,1,0,5000),(9000,100134,4000497,0,1,1,0,600000),(9001,100134,2000000,0,1,1,0,20000),(9002,100134,2010009,0,1,1,0,20000),(9005,100134,2040500,0,1,1,0,100),(9006,100134,2044400,0,1,1,0,100),(9007,100134,1002042,0,1,1,0,800),(9008,100134,1002051,0,1,1,0,800),(9009,100134,1032003,0,1,1,0,800),(9010,100134,1040009,0,1,1,0,800),(9011,100134,1060009,0,1,1,0,800),(9012,100134,1051000,0,1,1,0,800),(9013,100134,1072050,0,1,1,0,800),(9014,100133,4000496,0,1,1,0,600000),(9015,100133,2000000,0,1,1,0,20000),(9016,100133,2010009,0,1,1,0,20000),(9019,100133,2048000,0,1,1,0,100),(9020,100133,2041004,0,1,1,0,100),(9021,100133,1002041,0,1,1,0,800),(9022,100133,1002007,0,1,1,0,800),(9023,100133,1032001,0,1,1,0,800),(9024,100133,1040038,0,1,1,0,800),(9025,100133,1060028,0,1,1,0,800),(9026,100133,1041064,0,1,1,0,800),(9027,100133,1061023,0,1,1,0,800),(9028,100133,1072009,0,1,1,0,800),(9029,100133,1082000,0,1,1,0,800),(9030,100133,1442006,0,1,1,0,800),(9031,100132,4000495,0,1,1,0,600000),(9032,100132,2000000,0,1,1,0,20000),(9033,100132,2010009,0,1,1,0,20000),(9036,100132,2040823,0,1,1,0,100),(9037,100132,2041018,0,1,1,0,100),(9038,100132,1002001,0,1,1,0,800),(9039,100132,1002003,0,1,1,0,800),(9040,100132,1040014,0,1,1,0,800),(9041,100132,1040015,0,1,1,0,800),(9042,100132,1060008,0,1,1,0,800),(9043,100132,1041014,0,1,1,0,800),(9044,100132,1061014,0,1,1,0,800),(9045,100132,1072004,0,1,1,0,800),(9046,100132,1082003,0,1,1,0,800),(9047,100132,1442000,0,1,1,0,800),(9048,100131,4000494,0,1,1,0,600000),(9049,100131,2000000,0,1,1,0,20000),(9050,100131,2010009,0,1,1,0,20000),(9053,100131,2040400,0,1,1,0,100),(9054,100131,2040618,0,1,1,0,100),(9055,100131,1002019,0,1,1,0,800),(9056,100131,1002002,0,1,1,0,800),(9057,100131,1040013,0,1,1,0,800),(9058,100131,1041012,0,1,1,0,800),(9059,100131,1060004,0,1,1,0,800),(9060,100131,1072005,0,1,1,0,800),(9061,100130,4000493,0,1,1,0,600000),(9062,100130,2010000,0,1,1,0,20000),(9063,100130,2010009,0,1,1,0,20000),(9066,100130,2040003,0,1,1,0,100),(9067,100130,1002008,0,1,1,0,800),(9068,100130,1040010,0,1,1,0,800),(9069,100130,1041004,0,1,1,0,800),(9070,100130,1060007,0,1,1,0,800),(9071,1110130,4000012,0,1,1,0,600000),(9072,1110130,2000000,0,1,1,0,20000),(9073,1110130,2043102,0,1,1,0,100),(9074,1110130,2000003,0,1,1,0,20000),(9076,1110130,1322000,0,1,1,0,800),(9077,1110130,2060000,0,1,1,0,30000),(9078,1110130,1041044,0,1,1,0,800),(9079,1110130,1061037,0,1,1,0,800),(9081,1110130,1092008,0,1,1,0,800),(9082,1110130,1041017,0,1,1,0,800),(9083,1110130,1061012,0,1,1,0,800),(9084,1110130,1462002,0,1,1,0,800),(9085,1110130,2061000,0,1,1,0,30000),(9086,1110130,1041063,0,1,1,0,800),(9087,1110130,1061059,0,1,1,0,800),(9088,1110130,1452003,0,1,1,0,800),(9089,1110130,2048000,0,1,1,0,100),(9090,1110130,1002033,0,1,1,0,800),(9091,1110130,1302007,0,1,1,0,800),(9093,1110130,1032001,0,1,1,0,800),(9094,1110130,1002010,0,1,1,0,800),(9095,1110130,2000001,0,1,1,0,20000),(9096,1110130,1002143,0,1,1,0,800),(9097,1110130,1432005,0,1,1,0,800),(9098,1110130,1412012,0,1,1,0,800),(9099,1110130,1072285,0,1,1,0,800),(9100,1110130,1482001,0,1,1,0,800),(9101,1140130,2000000,0,1,1,0,20000),(9102,1140130,2000003,0,1,1,0,20000),(9103,1140130,4000195,0,1,1,0,600000),(9104,1140130,2060000,0,1,1,0,30000),(9105,1140130,2061000,0,1,1,0,30000),(9109,1140130,2040501,0,1,1,0,100),(9110,1140130,2040801,0,1,1,0,100),(9111,1140130,1041062,0,1,1,0,800),(9112,1140130,1061058,0,1,1,0,800),(9113,1140130,1050010,0,1,1,0,800),(9114,1140130,2048001,0,1,1,0,100),(9115,1140130,1041029,0,1,1,0,800),(9116,1140130,1061027,0,1,1,0,800),(9117,1140130,1072046,0,1,1,0,800),(9118,1140130,1072066,0,1,1,0,800),(9119,1140130,1082018,0,1,1,0,800),(9120,1140130,1002107,0,1,1,0,800),(9121,1140130,1002113,0,1,1,0,800),(9122,1140130,1050003,0,1,1,0,800),(9123,1140130,1412012,0,1,1,0,800),(9124,1140130,1082180,0,1,1,0,800),(9125,1140130,2044802,0,1,1,0,100),(9126,2230131,4000008,0,1,1,0,600000),(9127,2230131,2000001,0,1,1,0,20000),(9128,2230131,2002000,0,1,1,0,20000),(9129,2230131,2044302,0,1,1,0,100),(9130,2230131,1032000,0,1,1,0,800),(9131,2230131,1032004,0,1,1,0,800),(9132,2230131,1452001,0,1,1,0,800),(9133,2230131,1412002,0,1,1,0,800),(9134,2230131,2060000,0,1,1,0,30000),(9137,2230131,1002158,0,1,1,0,800),(9138,2230131,2000003,0,1,1,0,20000),(9139,2230131,1040048,0,1,1,0,800),(9140,2230131,2061000,0,1,1,0,30000),(9141,2230131,1060038,0,1,1,0,800),(9142,2230131,1372003,0,1,1,0,800),(9143,2230131,1060018,0,1,1,0,800),(9144,2230131,1040026,0,1,1,0,800),(9145,2230131,1040009,0,1,1,0,800),(9147,2230131,2000002,0,1,1,0,20000),(9148,2230131,1050030,0,1,1,0,800),(9149,2230131,1050031,0,1,1,0,800),(9150,2230131,1432003,0,1,1,0,800),(9151,2230131,1002035,0,1,1,0,800),(9152,2230131,1312007,0,1,1,0,800),(9153,2230131,1040021,0,1,1,0,800),(9154,2230131,1082183,0,1,1,0,800),(9155,2230131,1492003,0,1,1,0,800),(9156,2230131,2049100,0,1,1,0,100),(9157,3300000,2000003,0,1,1,0,20000),(9158,3300000,2060000,0,1,1,0,30000),(9159,3300000,2061000,0,1,1,0,30000),(9160,3300000,2000002,0,1,1,0,20000),(9163,3300000,2044701,0,1,1,0,100),(9164,3300000,1332020,0,1,1,0,800),(9165,3300000,1040000,0,1,1,0,800),(9166,3300000,1060075,0,1,1,0,800),(9167,3300000,1402010,0,1,1,0,800),(9168,3300000,1032007,0,1,1,0,800),(9169,3300000,1072078,0,1,1,0,800),(9170,3300000,1082046,0,1,1,0,800),(9171,3300000,1002156,0,1,1,0,800),(9172,3300000,1002622,0,1,1,0,800),(9173,3300000,4130005,0,1,1,0,6000),(9174,3300000,4130009,0,1,1,0,6000),(9175,3300000,4130021,0,1,1,0,6000),(9176,3300000,4000499,0,1,1,0,600000),(9177,3300000,2043216,0,1,1,0,100),(9178,3300000,2043311,0,1,1,0,100),(9179,3300000,2382092,0,1,1,0,1000),(9180,3300003,4131008,0,1,1,0,6000),(9181,3300003,2060000,0,1,1,0,30000),(9182,3300003,2061000,0,1,1,0,30000),(9185,3300003,2000002,0,1,1,0,20000),(9186,3300003,2000003,0,1,1,0,20000),(9187,3300003,1041042,0,1,1,0,800),(9188,3300003,1061035,0,1,1,0,800),(9189,3300003,1002023,0,1,1,0,800),(9190,3300003,1002163,0,1,1,0,800),(9191,3300003,1032010,0,1,1,0,800),(9192,3300003,1040062,0,1,1,0,800),(9193,3300003,1060051,0,1,1,0,800),(9194,3300003,1051015,0,1,1,0,800),(9195,3300003,1302004,0,1,1,0,800),(9196,3300003,1332014,0,1,1,0,800),(9197,3300003,1072119,0,1,1,0,800),(9198,3300003,1072110,0,1,1,0,800),(9199,3300003,1082063,0,1,1,0,800),(9200,3300003,1002625,0,1,1,0,800),(9201,3300003,2330001,0,1,1,0,100),(9202,3300003,4130000,0,1,1,0,6000),(9203,3300003,4130014,0,1,1,0,6000),(9204,3300003,4130017,0,1,1,0,6000),(9205,3300003,4000502,0,1,1,0,600000),(9206,3300003,2044416,0,1,1,0,100),(9207,3300003,2043711,0,1,1,0,100),(9208,3300003,2382095,0,1,1,0,1000),(9209,3300002,4131003,0,1,1,0,6000),(9210,3300002,2060000,0,1,1,0,30000),(9211,3300002,2061000,0,1,1,0,30000),(9215,3300002,2000002,0,1,1,0,20000),(9216,3300002,2000003,0,1,1,0,20000),(9217,3300002,2040701,0,1,1,0,100),(9218,3300002,1462000,0,1,1,0,800),(9219,3300002,1322014,0,1,1,0,800),(9220,3300002,1050030,0,1,1,0,800),(9221,3300002,1040058,0,1,1,0,800),(9222,3300002,1060044,0,1,1,0,800),(9223,3300002,1041058,0,1,1,0,800),(9224,3300002,1061054,0,1,1,0,800),(9225,3300002,1072101,0,1,1,0,800),(9226,3300002,1002013,0,1,1,0,800),(9227,3300002,1052107,0,1,1,0,800),(9228,3300002,4000501,0,1,1,0,600000),(9229,3300002,2044216,0,1,1,0,100),(9230,3300002,2044316,0,1,1,0,100),(9231,3300002,2382094,0,1,1,0,1000),(9232,3300001,2000003,0,1,1,0,20000),(9233,3300001,2060000,0,1,1,0,30000),(9234,3300001,2061000,0,1,1,0,30000),(9235,3300001,2000002,0,1,1,0,20000),(9238,3300001,2044701,0,1,1,0,100),(9239,3300001,1332020,0,1,1,0,800),(9240,3300001,1040000,0,1,1,0,800),(9241,3300001,1060075,0,1,1,0,800),(9242,3300001,1402010,0,1,1,0,800),(9243,3300001,1032007,0,1,1,0,800),(9244,3300001,1072078,0,1,1,0,800),(9245,3300001,1082046,0,1,1,0,800),(9246,3300001,1002156,0,1,1,0,800),(9248,3300001,1002622,0,1,1,0,800),(9249,3300001,4130005,0,1,1,0,6000),(9250,3300001,4130009,0,1,1,0,6000),(9251,3300001,4130021,0,1,1,0,6000),(9252,3300001,4000500,0,1,1,0,600000),(9253,3300001,4000507,0,1,1,0,600000),(9254,3300001,2044024,0,1,1,0,100),(9255,3300001,2044116,0,1,1,0,100),(9256,3300001,2382093,0,1,1,0,1000),(9257,3300004,4131008,0,1,1,0,6000),(9258,3300004,2060000,0,1,1,0,30000),(9259,3300004,2061000,0,1,1,0,30000),(9262,3300004,2000002,0,1,1,0,20000),(9263,3300004,2000003,0,1,1,0,20000),(9264,3300004,1041042,0,1,1,0,800),(9265,3300004,1061035,0,1,1,0,800),(9266,3300004,1002023,0,1,1,0,800),(9267,3300004,1002163,0,1,1,0,800),(9268,3300004,1032010,0,1,1,0,800),(9269,3300004,1040062,0,1,1,0,800),(9270,3300004,1060051,0,1,1,0,800),(9271,3300004,1051015,0,1,1,0,800),(9272,3300004,1302004,0,1,1,0,800),(9273,3300004,1332014,0,1,1,0,800),(9274,3300004,1072119,0,1,1,0,800),(9275,3300004,1072110,0,1,1,0,800),(9276,3300004,1082063,0,1,1,0,800),(9277,3300004,1002625,0,1,1,0,800),(9278,3300004,2330001,0,1,1,0,100),(9279,3300004,4130000,0,1,1,0,6000),(9280,3300004,4130014,0,1,1,0,6000),(9281,3300004,4130017,0,1,1,0,6000),(9282,3300004,4000503,0,1,1,0,600000),(9283,3300004,2044611,0,1,1,0,100),(9284,3300004,2044711,0,1,1,0,100),(9285,3300004,2044816,0,1,1,0,100),(9286,3300004,2382096,0,1,1,0,1000),(9287,3300005,2022570,0,1,1,0,999999),(9288,3300005,2022571,0,1,1,0,999999),(9289,3300005,2022572,0,1,1,0,999999),(9290,3300005,2022573,0,1,1,0,999999),(9291,3300005,2022574,0,1,1,0,999999),(9292,3300005,2000001,0,1,1,0,20000),(9293,3300005,2000003,0,1,1,0,20000),(9294,3300005,2040004,0,1,1,0,100),(9295,3300005,2040501,0,1,1,0,100),(9296,3300005,2040504,0,1,1,0,100),(9297,3300005,2040801,0,1,1,0,100),(9298,3300005,2041007,0,1,1,0,100),(9299,3300005,2041004,0,1,1,0,100),(9300,3300005,2043801,0,1,1,0,100),(9301,3300005,2044001,0,1,1,0,100),(9302,3300005,2044201,0,1,1,0,100),(9303,3300005,2044601,0,1,1,0,100),(9304,3300005,2044801,0,1,1,0,100),(9305,3300005,1082073,0,1,1,0,800),(9306,3300005,1082025,0,1,1,0,800),(9307,3300005,1082064,0,1,1,0,800),(9308,3300005,1082074,0,1,1,0,800),(9309,3300005,1082195,0,1,1,0,800),(9310,3300005,1032013,0,1,1,0,800),(9311,3300005,4000504,0,1,1,0,600000),(9312,3300005,2043216,0,1,1,0,100),(9313,3300005,2043311,0,1,1,0,100),(9314,3300005,2044024,0,1,1,0,100),(9315,3300005,2044116,0,1,1,0,100),(9316,3300005,2044216,0,1,1,0,100),(9317,3300005,2044316,0,1,1,0,100),(9318,3300005,2044416,0,1,1,0,100),(9319,3300005,2043711,0,1,1,0,100),(9320,3300005,2043811,0,1,1,0,100),(9321,3300005,2044511,0,1,1,0,100),(9322,3300005,2044611,0,1,1,0,100),(9323,3300005,2044711,0,1,1,0,100),(9324,3300005,2044816,0,1,1,0,100),(9325,3300005,2388067,0,1,1,0,1000),(9326,3300006,2022575,0,1,1,0,999999),(9327,3300006,2022576,0,1,1,0,999999),(9328,3300006,2022577,0,1,1,0,999999),(9329,3300006,2022578,0,1,1,0,999999),(9330,3300006,2022579,0,1,1,0,999999),(9331,3300006,2000001,0,1,1,0,20000),(9332,3300006,2000003,0,1,1,0,20000),(9333,3300006,2040701,0,1,1,0,100),(9334,3300006,2040801,0,1,1,0,100),(9335,3300006,2040901,0,1,1,0,100),(9336,3300006,2041001,0,1,1,0,100),(9337,3300006,2043001,0,1,1,0,100),(9338,3300006,2043101,0,1,1,0,100),(9339,3300006,2041010,0,1,1,0,100),(9340,3300006,2043201,0,1,1,0,100),(9341,3300006,2041004,0,1,1,0,100),(9342,3300006,2060000,0,1,1,0,30000),(9343,3300006,2061000,0,1,1,0,30000),(9344,3300006,2041017,0,1,1,0,100),(9345,3300006,2040402,0,1,1,0,100),(9346,3300006,2044002,0,1,1,0,100),(9347,3300006,2040502,0,1,1,0,100),(9348,3300006,2040602,0,1,1,0,100),(9349,3300006,2041016,0,1,1,0,100),(9350,3300006,2070009,0,1,1,0,500),(9351,3300006,1002098,0,1,1,0,800),(9352,3300006,1002154,0,1,1,0,800),(9353,3300006,1002170,0,1,1,0,800),(9354,3300006,1002185,0,1,1,0,800),(9355,3300006,1040085,0,1,1,0,800),(9356,3300006,1041086,0,1,1,0,800),(9357,3300006,1050039,0,1,1,0,800),(9358,3300006,1051026,0,1,1,0,800),(9359,3300006,1040080,0,1,1,0,800),(9360,3300006,1041083,0,1,1,0,800),(9361,3300006,1040084,0,1,1,0,800),(9362,3300006,1041076,0,1,1,0,800),(9363,3300006,1082025,0,1,1,0,800),(9364,3300006,1082064,0,1,1,0,800),(9365,3300006,1082073,0,1,1,0,800),(9366,3300006,1082074,0,1,1,0,800),(9367,3300006,1072126,0,1,1,0,800),(9368,3300006,1072117,0,1,1,0,800),(9369,3300006,1072118,0,1,1,0,800),(9370,3300006,1072107,0,1,1,0,800),(9371,3300006,1002628,0,1,1,0,800),(9372,3300006,1052113,0,1,1,0,800),(9373,3300006,1082195,0,1,1,0,800),(9374,3300006,1072300,0,1,1,0,800),(9375,3300006,2044112,0,1,1,0,100),(9376,3300006,2044412,0,1,1,0,100),(9377,3300006,4000506,0,1,1,0,600000),(9378,3300006,2043216,0,1,1,0,100),(9379,3300006,2043311,0,1,1,0,100),(9380,3300006,2044024,0,1,1,0,100),(9381,3300006,2044116,0,1,1,0,100),(9382,3300006,2044216,0,1,1,0,100),(9383,3300006,2044316,0,1,1,0,100),(9384,3300006,2044416,0,1,1,0,100),(9385,3300006,2043711,0,1,1,0,100),(9386,3300006,2043811,0,1,1,0,100),(9387,3300006,2044511,0,1,1,0,100),(9388,3300006,2044611,0,1,1,0,100),(9389,3300006,2044711,0,1,1,0,100),(9390,3300006,2044816,0,1,1,0,100),(9391,3300006,2388068,0,1,1,0,1000),(9392,3300007,2022580,0,1,1,0,999999),(9393,3300007,2022581,0,1,1,0,999999),(9394,3300007,2022582,0,1,1,0,999999),(9395,3300007,2022583,0,1,1,0,999999),(9396,3300007,2022584,0,1,1,0,999999),(9399,3300007,2000000,0,1,1,0,20000),(9400,3300007,2010009,0,1,1,0,20000),(9401,3300007,2020014,0,1,1,0,999999),(9402,3300007,2040001,0,1,1,0,100),(9403,3300007,2040301,0,1,1,0,100),(9404,3300007,2040401,0,1,1,0,100),(9405,3300007,2043201,0,1,1,0,100),(9406,3300007,2043701,0,1,1,0,100),(9407,3300007,2041016,0,1,1,0,100),(9408,3300007,2043801,0,1,1,0,100),(9409,3300007,2044001,0,1,1,0,100),(9410,3300007,2040501,0,1,1,0,100),(9411,3300007,2040601,0,1,1,0,100),(9412,3300007,2060000,0,1,1,0,30000),(9413,3300007,2061000,0,1,1,0,30000),(9414,3300007,2070000,0,1,1,0,500),(9415,3300007,1002049,0,1,1,0,800),(9416,3300007,1002073,0,1,1,0,800),(9417,3300007,1002159,0,1,1,0,800),(9418,3300007,1002150,0,1,1,0,800),(9419,3300007,1040041,0,1,1,0,800),(9420,3300007,1041024,0,1,1,0,800),(9421,3300007,1050025,0,1,1,0,800),(9422,3300007,1051005,0,1,1,0,800),(9423,3300007,1040023,0,1,1,0,800),(9424,3300007,1041033,0,1,1,0,800),(9425,3300007,1040050,0,1,1,0,800),(9426,3300007,1041060,0,1,1,0,800),(9427,3300007,1082001,0,1,1,0,800),(9428,3300007,1082028,0,1,1,0,800),(9429,3300007,1082018,0,1,1,0,800),(9430,3300007,1082039,0,1,1,0,800),(9431,3300007,1072052,0,1,1,0,800),(9432,3300007,1072074,0,1,1,0,800),(9433,3300007,1072069,0,1,1,0,800),(9434,3300007,1072087,0,1,1,0,800),(9435,3300007,2040002,0,1,1,0,100),(9436,3300007,2040302,0,1,1,0,100),(9437,3300007,2040402,0,1,1,0,100),(9438,3300007,2043302,0,1,1,0,100),(9439,3300007,2043702,0,1,1,0,100),(9440,3300007,1002619,0,1,1,0,800),(9441,3300007,1052104,0,1,1,0,800),(9442,3300007,1082186,0,1,1,0,800),(9443,3300007,1072291,0,1,1,0,800),(9444,3300007,2330000,0,1,1,0,100),(9445,3300007,2044801,0,1,1,0,100),(9446,3300007,2044902,0,1,1,0,100),(9447,3300007,2040418,0,1,1,0,100),(9448,3300007,2040928,0,1,1,0,100),(9449,3300007,2043114,0,1,1,0,100),(9450,3300007,2044414,0,1,1,0,100),(9451,3300007,4000505,0,1,1,0,600000),(9452,3300007,2043216,0,1,1,0,100),(9453,3300007,2043311,0,1,1,0,100),(9454,3300007,2044024,0,1,1,0,100),(9455,3300007,2044116,0,1,1,0,100),(9456,3300007,2044216,0,1,1,0,100),(9457,3300007,2044316,0,1,1,0,100),(9458,3300007,2044416,0,1,1,0,100),(9459,3300007,2043711,0,1,1,0,100),(9460,3300007,2043811,0,1,1,0,100),(9461,3300007,2044511,0,1,1,0,100),(9462,3300007,2044611,0,1,1,0,100),(9463,3300007,2044711,0,1,1,0,100),(9464,3300007,2044816,0,1,1,0,100),(9465,3300007,2388069,0,1,1,0,1000),(9466,3300008,4001318,0,1,1,0,600000),(9469,3300008,2000002,0,1,1,0,200000),(9470,3300008,2000003,0,1,1,0,200000),(9471,3300008,2002002,0,1,1,0,200000),(9472,3300008,2002003,0,1,1,0,200000),(9473,3300008,2040301,0,1,1,0,1500),(9474,3300008,2040504,0,1,1,0,1500),(9475,3300008,2040707,0,1,1,0,1500),(9476,3300008,2040801,0,1,1,0,1500),(9477,3300008,2040901,0,1,1,0,1500),(9478,3300008,2041016,0,1,1,0,1500),(9479,3300008,2043801,0,1,1,0,1500),(9480,3300008,2044101,0,1,1,0,1500),(9481,3300008,2044601,0,1,1,0,1500),(9482,3300008,2044701,0,1,1,0,1500),(9483,3300008,2040514,0,1,1,0,1500),(9484,3300008,2041002,0,1,1,0,1500),(9485,3300008,2041017,0,1,1,0,1500),(9486,3300008,2043702,0,1,1,0,1500),(9487,3300008,2044302,0,1,1,0,1500),(9488,3300008,2060000,0,1,1,0,300000),(9489,3300008,2061000,0,1,1,0,300000),(9490,3300008,1302010,0,1,1,0,7000),(9491,3300008,1312008,0,1,1,0,7000),(9492,3300008,1322017,0,1,1,0,7000),(9493,3300008,1332003,0,1,1,0,5000),(9494,3300008,1372007,0,1,1,0,7000),(9495,3300008,1382006,0,1,1,0,7000),(9496,3300008,1402003,0,1,1,0,7000),(9497,3300008,1412003,0,1,1,0,7000),(9498,3300008,1422005,0,1,1,0,7000),(9499,3300008,1432004,0,1,1,0,5000),(9500,3300008,1442005,0,1,1,0,7000),(9501,3300008,1452008,0,1,1,0,5000),(9502,3300008,1462007,0,1,1,0,5000),(9503,3300008,1472021,0,1,1,0,5000),(9504,3300008,1482007,0,1,1,0,5000),(9505,3300008,1492007,0,1,1,0,5000),(9506,3300008,2044802,0,1,1,0,1500),(9507,3300008,2044901,0,1,1,0,1500),(9508,3300008,2040931,0,1,1,0,1500),(9509,3300008,2040928,0,1,1,0,1500),(9510,3300008,2043216,0,1,1,0,1500),(9511,3300008,2043311,0,1,1,0,1500),(9512,3300008,2044024,0,1,1,0,1500),(9513,3300008,2044116,0,1,1,0,1500),(9514,3300008,2044216,0,1,1,0,1500),(9515,3300008,2044316,0,1,1,0,1500),(9516,3300008,2044416,0,1,1,0,1500),(9517,3300008,2043711,0,1,1,0,1500),(9518,3300008,2043811,0,1,1,0,1500),(9519,3300008,2044511,0,1,1,0,1500),(9520,3300008,2044611,0,1,1,0,1500),(9521,3300008,2044711,0,1,1,0,1500),(9522,3300008,2044816,0,1,1,0,1500),(9523,100100,2380000,0,1,1,0,1000),(9524,100101,2380001,0,1,1,0,1000),(9525,130100,2380003,0,1,1,0,1000),(9526,130101,2380004,0,1,1,0,1000),(9527,210100,2380005,0,1,1,0,1000),(9528,1210100,2380006,0,1,1,0,1000),(9529,1210102,2380007,0,1,1,0,1000),(9530,1110101,2380008,0,1,1,0,1000),(9531,1210101,2380009,0,1,1,0,1000),(9532,1120100,2380010,0,1,1,0,1000),(9533,1110100,2380011,0,1,1,0,1000),(9534,1210103,2380012,0,1,1,0,1000),(9535,1130100,2381000,0,1,1,0,1000),(9536,1140100,2381001,0,1,1,0,1000),(9537,2220100,2381002,0,1,1,0,1000),(9538,2300100,2381003,0,1,1,0,1000),(9539,2130103,2381006,0,1,1,0,1000),(9540,2110200,2381007,0,1,1,0,1000),(9541,2130100,2381008,0,1,1,0,1000),(9542,2230108,2381009,0,1,1,0,1000),(9543,2100102,2381010,0,1,1,0,1000),(9544,2230103,2381011,0,1,1,0,1000),(9545,5200000,2381012,0,1,1,0,1000),(9546,2230105,2381013,0,1,1,0,1000),(9547,2230110,2381014,0,1,1,0,1000),(9548,2100105,2381015,0,1,1,0,1000),(9549,2230101,2381016,0,1,1,0,1000),(9550,2230107,2381017,0,1,1,0,1000),(9551,2230111,2381018,0,1,1,0,1000),(9552,2100106,2381019,0,1,1,0,1000),(9553,2110300,2381020,0,1,1,0,1000),(9554,2230106,2381021,0,1,1,0,1000),(9555,2230102,2381022,0,1,1,0,1000),(9556,2100103,2381023,0,1,1,0,1000),(9557,2230100,2381024,0,1,1,0,1000),(9558,2100107,2381025,0,1,1,0,1000),(9559,2230109,2381026,0,1,1,0,1000),(9560,2230104,2381027,0,1,1,0,1000),(9561,2100104,2381028,0,1,1,0,1000),(9562,2230200,2381029,0,1,1,0,1000),(9563,2110301,2381031,0,1,1,0,1000),(9564,3000000,2381032,0,1,1,0,1000),(9565,3000005,2381034,0,1,1,0,1000),(9566,3000006,2381035,0,1,1,0,1000),(9567,3100102,2381036,0,1,1,0,1000),(9568,5200001,2381037,0,1,1,0,1000),(9569,5200002,2381038,0,1,1,0,1000),(9570,3230307,2382000,0,1,1,0,1000),(9571,3110100,2382002,0,1,1,0,1000),(9572,3110101,2382004,0,1,1,0,1000),(9573,3110102,2382005,0,1,1,0,1000),(9574,5300000,2382006,0,1,1,0,1000),(9575,3230104,2382007,0,1,1,0,1000),(9576,3110300,2382009,0,1,1,0,1000),(9577,3210200,2382011,0,1,1,0,1000),(9578,3210201,2382012,0,1,1,0,1000),(9579,3210202,2382013,0,1,1,0,1000),(9580,5300001,2382014,0,1,1,0,1000),(9581,3210204,2382015,0,1,1,0,1000),(9582,3210205,2382016,0,1,1,0,1000),(9583,3210207,2382017,0,1,1,0,1000),(9584,3230100,2382018,0,1,1,0,1000),(9585,3230101,2382019,0,1,1,0,1000),(9586,3230200,2382020,0,1,1,0,1000),(9587,3230302,2382022,0,1,1,0,1000),(9588,5400000,2382023,0,1,1,0,1000),(9589,3110302,2382024,0,1,1,0,1000),(9590,3210203,2382025,0,1,1,0,1000),(9591,3210206,2382026,0,1,1,0,1000),(9592,3210450,2382027,0,1,1,0,1000),(9593,3210208,2382028,0,1,1,0,1000),(9594,3210800,2382029,0,1,1,0,1000),(9595,3230102,2382030,0,1,1,0,1000),(9596,3230303,2382031,0,1,1,0,1000),(9597,3230306,2382032,0,1,1,0,1000),(9598,3230103,2382033,0,1,1,0,1000),(9599,3230304,2382034,0,1,1,0,1000),(9600,3230405,2382035,0,1,1,0,1000),(9601,3110303,2382036,0,1,1,0,1000),(9602,3230308,2382037,0,1,1,0,1000),(9603,3230305,2382038,0,1,1,0,1000),(9604,4230100,2382039,0,1,1,0,1000),(9605,4230101,2382040,0,1,1,0,1000),(9606,4230113,2382041,0,1,1,0,1000),(9607,4230200,2382043,0,1,1,0,1000),(9608,4230201,2382044,0,1,1,0,1000),(9609,4230500,2382045,0,1,1,0,1000),(9610,4230107,2382047,0,1,1,0,1000),(9611,4230111,2382048,0,1,1,0,1000),(9612,4230114,2382049,0,1,1,0,1000),(9613,4230119,2382050,0,1,1,0,1000),(9614,4230501,2382051,0,1,1,0,1000),(9615,4230105,2382052,0,1,1,0,1000),(9616,4230103,2382053,0,1,1,0,1000),(9617,4230109,2382054,0,1,1,0,1000),(9618,4230124,2382056,0,1,1,0,1000),(9619,4110300,2382057,0,1,1,0,1000),(9620,4230108,2382058,0,1,1,0,1000),(9621,4230123,2382059,0,1,1,0,1000),(9622,4230502,2382060,0,1,1,0,1000),(9623,4230120,2382061,0,1,1,0,1000),(9624,4230112,2382062,0,1,1,0,1000),(9625,4230125,2382063,0,1,1,0,1000),(9626,4230106,2382064,0,1,1,0,1000),(9627,4130100,2382065,0,1,1,0,1000),(9628,4230110,2382066,0,1,1,0,1000),(9629,4230300,2382068,0,1,1,0,1000),(9630,4230400,2382069,0,1,1,0,1000),(9631,4230503,2382070,0,1,1,0,1000),(9632,4230504,2382071,0,1,1,0,1000),(9633,4110301,2382072,0,1,1,0,1000),(9634,4250000,2382076,0,1,1,0,1000),(9635,4230121,2383000,0,1,1,0,1000),(9636,4130101,2383001,0,1,1,0,1000),(9637,4230115,2383002,0,1,1,0,1000),(9638,4130102,2383003,0,1,1,0,1000),(9639,4130103,2383004,0,1,1,0,25000),(9640,4230505,2383006,0,1,1,0,1000),(9641,9300255,2383007,0,1,1,0,1000),(9642,4230102,2383008,0,1,1,0,1000),(9643,4230104,2383009,0,1,1,0,1000),(9644,4230506,2383010,0,1,1,0,1000),(9645,5130100,2383012,0,1,1,0,1000),(9646,5100000,2383013,0,1,1,0,1000),(9647,5100003,2383014,0,1,1,0,1000),(9648,5120503,2383015,0,1,1,0,1000),(9649,9300144,2383016,0,1,1,0,1000),(9650,5100002,2383017,0,1,1,0,1000),(9651,5120504,2383018,0,1,1,0,1000),(9652,5130103,2383019,0,1,1,0,1000),(9653,5120001,2383021,0,1,1,0,1000),(9654,5120002,2383022,0,1,1,0,1000),(9655,5120003,2383023,0,1,1,0,1000),(9656,5100005,2383024,0,1,1,0,1000),(9657,5120501,2383025,0,1,1,0,1000),(9658,5120100,2383026,0,1,1,0,25000),(9659,5120502,2383027,0,1,1,0,1000),(9660,9300149,2383028,0,1,1,0,1000),(9661,5300100,2383029,0,1,1,0,1000),(9662,5130101,2383030,0,1,1,0,1000),(9663,5130104,2383031,0,1,1,0,1000),(9664,5120506,2383032,0,1,1,0,1000),(9665,5130105,2383033,0,1,1,0,1000),(9666,5120500,2383035,0,1,1,0,1000),(9667,5150001,2383036,0,1,1,0,1000),(9668,5130107,2383037,0,1,1,0,1000),(9669,5130108,2383038,0,1,1,0,1000),(9670,5130102,2383039,0,1,1,0,1000),(9671,5140000,2383040,0,1,1,0,1000),(9672,5120505,2383041,0,1,1,0,1000),(9673,5110302,2383042,0,1,1,0,1000),(9674,5150000,2383043,0,1,1,0,1000),(9675,6130100,2383044,0,1,1,0,1000),(9676,6130103,2383045,0,1,1,0,1000),(9677,6130201,2383046,0,1,1,0,1000),(9678,6130203,2383047,0,1,1,0,1000),(9679,5090000,2383048,0,1,1,0,25000),(9680,5090001,2383049,0,1,1,0,25000),(9681,4250001,2383056,0,1,1,0,1000),(9682,5250000,2383057,0,1,1,0,1000),(9683,5250002,2383058,0,1,1,0,1000),(9684,5250001,2383059,0,1,1,0,1000),(9685,6130200,2384000,0,1,1,0,1000),(9686,9400201,2384001,0,1,1,0,1000),(9687,6130207,2384002,0,1,1,0,1000),(9688,6230602,2384003,0,1,1,0,1000),(9689,6230400,2384004,0,1,1,0,1000),(9690,6230600,2384006,0,1,1,0,1000),(9691,6230200,2384007,0,1,1,0,1000),(9692,6130204,2384008,0,1,1,0,1000),(9693,6300000,2384009,0,1,1,0,1000),(9694,6090000,2384010,0,1,1,0,25000),(9695,6110300,2384011,0,1,1,0,1000),(9696,6230300,2384012,0,1,1,0,1000),(9697,6130209,2384013,0,1,1,0,1000),(9698,6230500,2384014,0,1,1,0,1000),(9699,6230601,2384015,0,1,1,0,1000),(9700,6400000,2384016,0,1,1,0,1000),(9701,6130208,2384017,0,1,1,0,1000),(9702,9300146,2384018,0,1,1,0,1000),(9703,8140200,2384019,0,1,1,0,1000),(9704,7130100,2384020,0,1,1,0,1000),(9705,7130400,2384021,0,1,1,0,25000),(9706,7130401,2384022,0,1,1,0,25000),(9707,7130402,2384023,0,1,1,0,25000),(9708,7130500,2384024,0,1,1,0,1000),(9709,7130104,2384025,0,1,1,0,1000),(9710,7130001,2384026,0,1,1,0,1000),(9711,7130002,2384027,0,1,1,0,1000),(9712,7130600,2384028,0,1,1,0,1000),(9713,7130103,2384029,0,1,1,0,1000),(9714,6300100,2384032,0,1,1,0,1000),(9715,7130501,2384033,0,1,1,0,1000),(9716,7130200,2384035,0,1,1,0,1000),(9717,7130101,2384036,0,1,1,0,1000),(9718,6090001,2384037,0,1,1,0,25000),(9719,7090000,2384038,0,1,1,0,25000),(9720,6090003,2384039,0,1,1,0,25000),(9721,6090004,2384040,0,1,1,0,25000),(9722,8140300,2385000,0,1,1,0,1000),(9723,7130003,2385001,0,1,1,0,1000),(9724,7130601,2385002,0,1,1,0,1000),(9725,6400100,2385003,0,1,1,0,1000),(9726,7130102,2385004,0,1,1,0,1000),(9727,7130004,2385005,0,1,1,0,1000),(9728,8140000,2385006,0,1,1,0,1000),(9729,8140001,2385007,0,1,1,0,1000),(9730,8110300,2385008,0,1,1,0,1000),(9731,8140100,2385009,0,1,1,0,1000),(9732,8140002,2385011,0,1,1,0,1000),(9733,7130010,2385012,0,1,1,0,1000),(9734,7130020,2385013,0,1,1,0,1000),(9735,8140110,2385014,0,1,1,0,1000),(9736,8140101,2385016,0,1,1,0,1000),(9737,8140102,2385017,0,1,1,0,1000),(9738,8140103,2385018,0,1,1,0,1000),(9739,8140111,2385019,0,1,1,0,1000),(9740,7130300,2385020,0,1,1,0,1000),(9741,8140500,2385021,0,1,1,0,1000),(9742,8140700,2385022,0,1,1,0,1000),(9743,8090000,2385023,0,1,1,0,25000),(9744,8200000,2385025,0,1,1,0,1000),(9745,8140600,2386000,0,1,1,0,1000),(9746,8140701,2386001,0,1,1,0,1000),(9747,9300324,2386002,0,1,1,0,25000),(9748,8141300,2386003,0,1,1,0,1000),(9749,8142000,2386004,0,1,1,0,1000),(9750,8140702,2386005,0,1,1,0,1000),(9751,8140703,2386006,0,1,1,0,1000),(9752,8142100,2386007,0,1,1,0,1000),(9753,8150300,2386008,0,1,1,0,1000),(9754,9500136,2386009,0,1,1,0,1000),(9755,9500137,2386010,0,1,1,0,1000),(9756,8150200,2386011,0,1,1,0,1000),(9757,8150100,2386012,0,1,1,0,1000),(9758,8150301,2386013,0,1,1,0,1000),(9759,8150101,2386014,0,1,1,0,1000),(9760,8150302,2386015,0,1,1,0,1000),(9761,8150201,2386016,0,1,1,0,1000),(9762,8190000,2386017,0,1,1,0,1000),(9763,8200001,2386021,0,1,1,0,1000),(9764,8200002,2386022,0,1,1,0,1000),(9765,8200003,2386023,0,1,1,0,1000),(9766,8200004,2386024,0,1,1,0,1000),(9767,8160000,2387000,0,1,1,0,1000),(9768,8170000,2387001,0,1,1,0,1000),(9769,8190003,2387002,0,1,1,0,1000),(9770,8190004,2387003,0,1,1,0,1000),(9771,8190002,2387004,0,1,1,0,1000),(9772,8200005,2387006,0,1,1,0,1000),(9773,8200006,2387007,0,1,1,0,1000),(9774,8200007,2387008,0,1,1,0,1000),(9775,8200008,2387009,0,1,1,0,1000),(9776,8200009,2387010,0,1,1,0,1000),(9777,8200010,2387011,0,1,1,0,1000),(9778,8200011,2387012,0,1,1,0,1000),(9779,8200012,2387013,0,1,1,0,1000),(9780,9300184,2388000,0,1,1,0,25000),(9781,9300003,2388001,0,1,1,0,1000),(9782,5220002,2388002,0,1,1,0,25000),(9783,5220000,2388003,0,1,1,0,25000),(9784,9300012,2388004,0,1,1,0,25000),(9785,5220003,2388005,0,1,1,0,25000),(9786,6130101,2388006,0,1,1,0,25000),(9787,6220000,2388007,0,1,1,0,25000),(9788,6300005,2388008,0,1,1,0,25000),(9789,7220001,2388009,0,1,1,0,25000),(9790,7220000,2388010,0,1,1,0,25000),(9791,9300119,2388011,0,1,1,0,25000),(9792,9300039,2388012,0,1,1,0,25000),(9793,7220002,2388013,0,1,1,0,25000),(9794,9300139,2388014,0,1,1,0,25000),(9795,8220001,2388016,0,1,1,0,25000),(9796,8150000,2388017,0,1,1,0,25000),(9797,8180000,2388018,0,1,1,0,25000),(9798,8180001,2388019,0,1,1,0,25000),(9799,8510000,2388020,0,1,1,0,25000),(9800,9300028,2388021,0,1,1,0,25000),(13916,8500002,2290037,0,1,1,0,3000),(9802,3220000,2388025,0,1,1,0,25000),(9803,8130100,2388026,0,1,1,0,25000),(9804,9500317,2388028,0,1,1,0,25000),(9805,3220001,2388029,0,1,1,0,25000),(9806,4220000,2388030,0,1,1,0,25000),(9807,6220001,2388031,0,1,1,0,25000),(9808,8220003,2388033,0,1,1,0,25000),(9809,8220004,2388040,0,1,1,0,25000),(9810,8220005,2388041,0,1,1,0,25000),(9811,8220006,2388042,0,1,1,0,25000),(9812,8820000,2388043,0,1,1,0,25000),(9813,9300274,2380013,0,1,1,0,1000),(9814,8830000,2388055,0,1,1,0,25000),(9815,1110130,2380014,0,1,1,0,1000),(9816,100130,2380015,0,1,1,0,1000),(9817,100131,2380016,0,1,1,0,1000),(9818,100132,2380017,0,1,1,0,1000),(9819,100133,2380018,0,1,1,0,1000),(9820,100134,2380019,0,1,1,0,1000),(9821,2230131,2381083,0,1,1,0,1000),(9822,3300001,2382093,0,1,1,0,1000),(9823,3300002,2382094,0,1,1,0,1000),(9824,3300003,2382095,0,1,1,0,1000),(9825,3300004,2382096,0,1,1,0,1000),(9826,5220004,2388052,0,1,1,0,25000),(9827,8220007,2388053,0,1,1,0,25000),(9828,8220009,2388054,0,1,1,0,25000),(9829,3300006,2388068,0,1,1,0,1000),(9830,3300007,2388069,0,1,1,0,1000),(14021,1210101,4001342,0,1,1,28175,100000),(14020,3000003,2050004,0,1,1,0,50000),(14019,3000003,2050003,0,1,1,0,50000),(14018,3000003,2050002,0,1,1,0,50000),(14017,3000003,2050001,0,1,1,0,50000),(14016,3000003,2050000,0,1,1,0,50000),(14013,3000003,2000003,0,1,1,0,20000),(14012,3000003,2000001,0,1,1,0,20000),(14011,3000003,4000068,0,1,1,0,600000),(13915,8500002,2290006,0,1,1,0,3000),(13914,8500002,2290061,0,1,1,0,3500),(13913,8500002,2290078,0,1,1,0,8000),(13912,8500002,2290028,0,1,1,0,40000),(13911,8500002,2290043,0,1,1,0,15000),(14010,3000002,2050004,0,1,1,0,50000),(14009,3000002,2050003,0,1,1,0,50000),(14008,3000002,2050002,0,1,1,0,50000),(14007,3000002,2050001,0,1,1,0,50000),(14006,3000002,2050000,0,1,1,0,50000),(10164,6230100,4031213,0,1,1,2097,200000),(10165,7130100,4031214,0,1,1,2097,200000),(10166,7220001,4031793,0,1,1,3647,999999),(10167,7130101,4031215,0,1,1,2097,200000),(10168,210100,4031273,0,1,1,2104,500000),(10169,2220100,2022016,0,1,1,8164,100000),(10170,2130100,4031153,0,1,1,2070,10000),(10171,5100003,4031268,0,1,1,3629,80000),(10172,2230105,4031259,0,1,1,3080,30000),(10173,2230106,4031260,0,1,1,3080,30000),(10174,2230108,4031261,0,1,1,3080,30000),(10175,2230200,4031262,0,1,1,3081,30000),(10176,3230104,4031263,0,1,1,3081,30000),(10177,2230109,4031264,0,1,1,3081,30000),(10178,4230200,4031265,0,1,1,3082,30000),(10179,4230123,4031266,0,1,1,3082,30000),(10180,4230124,4031267,0,1,1,3082,30000),(10181,4230116,4031103,0,1,1,3414,100000),(10182,4230117,4031104,0,1,1,3414,100000),(10183,4230118,4031105,0,1,1,3414,100000),(10184,4240000,4031106,0,1,1,3414,100000),(10185,7130400,4031232,0,1,1,3611,1000000),(10186,7130401,4031233,0,1,1,3611,1000000),(10187,7130402,4031234,0,1,1,3611,1000000),(10188,5100004,4031790,0,1,1,3642,100000),(10189,4230113,4031675,0,1,1,4917,1000000),(10190,9400546,4031681,0,1,1,4915,1000000),(10191,9600005,4000191,0,1,1,0,1000000),(10192,9600006,4000192,0,1,1,0,1000000),(13910,8500002,2290011,0,1,1,0,5000),(13909,8500002,2290056,0,1,1,0,5000),(13908,8500002,2290091,0,1,1,0,2000),(13907,8500002,2290071,0,1,1,0,2000),(10197,3000006,4031209,0,1,1,0,500000),(10198,2230109,4031209,0,1,1,0,500000),(10199,2230200,4031209,0,1,1,0,500000),(10200,3230104,4031209,0,1,1,0,500000),(10201,3230306,4031159,0,1,1,2074,500000),(10202,9500400,4031224,0,1,1,3607,1000000),(10203,9500400,4031223,0,1,1,3607,1000000),(10204,9420003,4031400,0,1,1,8761,1000000),(10205,9420001,4031401,0,1,1,8761,1000000),(10206,9300097,4031472,0,1,1,6301,100000),(10207,9300098,4031472,0,1,1,6301,100000),(10208,9300099,4031472,0,1,1,6301,100000),(10209,5300100,4031925,0,1,1,2223,100000),(10210,1110100,4031146,0,1,1,2065,1000000),(10211,1130100,4031147,0,1,1,2065,1000000),(10212,2230102,4031155,0,1,1,2071,1000000),(10213,3230100,4031239,0,1,1,2099,50000),(10214,4230100,4031212,0,1,1,2096,500000),(10215,5300000,4031311,0,1,1,3093,1000000),(10216,8140600,4031256,0,1,1,3076,100000),(10217,8140600,4031251,0,1,1,3076,300000),(10218,8510000,4031253,0,1,1,3076,1000000),(10219,8520000,4031253,0,1,1,3076,1000000),(10220,5130107,4031218,0,1,1,3071,10000),(10221,5130108,4031218,0,1,1,3071,10000),(10222,3230200,4031309,0,1,1,3088,500000),(10223,4230106,4031309,0,1,1,3088,500000),(10224,5120000,4031309,0,1,1,3088,500000),(10225,8150100,4031252,0,1,1,3078,10000),(10226,8150101,4031252,0,1,1,3078,10000),(10227,8150100,4031254,0,1,1,3078,10000),(10228,8150101,4031254,0,1,1,3078,10000),(10229,8150100,4031255,0,1,1,3078,10000),(10230,8150101,4031255,0,1,1,3078,10000),(10231,4240000,4031926,0,1,1,3454,1000000),(10232,4230118,4031926,0,1,1,3454,10000),(10233,4230117,4031926,0,1,1,3454,10000),(10234,4230116,4031926,0,1,1,3454,10000),(10235,6130202,4031222,0,1,1,3621,100000),(10236,3230302,4031089,0,1,1,3223,100000),(10237,4230119,4031090,0,1,1,3227,100000),(10238,3210205,4031093,0,1,1,3229,1000000),(10239,3110102,4031129,0,1,1,3207,1000000),(10240,4230119,4031206,0,1,1,3441,50000),(10241,3230400,4031140,0,1,1,3440,100000),(10242,3230400,4031135,0,1,1,3438,100000),(10243,3210208,4031279,0,1,1,3632,1000000),(10244,2230106,4031269,0,1,1,3629,1000000),(10245,4230300,4031241,0,1,1,3606,1000000),(10246,4230112,4031115,0,1,1,3416,100000),(10247,4240000,4031102,0,1,1,3413,1000000),(10248,6230300,4031189,0,1,1,3448,100000),(10249,6230300,4031195,0,1,1,3449,500000),(10250,130101,4031846,0,1,1,2173,50000),(10251,1210100,4031846,0,1,1,2173,50000),(10252,8180001,4031464,0,1,1,6303,1000000),(10253,7130104,4031436,0,1,1,3828,1000000),(10254,3110302,4031694,0,1,1,3312,50000),(10255,3110303,4031694,0,1,1,3312,100000),(10256,5120506,4031432,0,1,1,3810,1000000),(10257,6130209,4031433,0,1,1,3804,100000),(10258,9400110,4031139,0,1,1,8005,100000),(10259,9400111,4031139,0,1,1,8005,100000),(10260,9600002,4000188,0,1,1,0,1000000),(10261,9600001,4000187,0,1,1,0,1000000),(10262,9420005,4000252,0,1,1,0,1000000),(10263,9420005,4000253,0,1,1,0,1000000),(10264,3110100,4031405,0,1,1,8732,500000),(10265,9600007,4000193,0,1,1,0,1000000),(10266,9400543,4031680,0,1,1,4914,300000),(10267,9420003,4000251,0,1,1,0,1000000),(10268,4230116,4031674,0,1,1,4916,300000),(10269,9600003,4000189,0,1,1,0,1000000),(10270,9600004,4000190,0,1,1,0,1000000),(10271,9420002,4000248,0,1,1,0,1000000),(10272,3110100,4031164,0,1,1,2084,300000),(14092,7130002,1342004,0,1,1,0,850),(14091,6300100,1342006,0,1,1,0,830),(10276,6130200,4031170,0,1,1,7100,500000),(10277,6230300,4031170,0,1,1,7100,500000),(10278,6230400,4031170,0,1,1,7100,500000),(10279,6230500,4031170,0,1,1,7100,500000),(10280,6300100,4031170,0,1,1,7100,500000),(10281,6400100,4031170,0,1,1,7100,500000),(10282,7130010,4031170,0,1,1,7100,500000),(10283,7130300,4031170,0,1,1,7100,500000),(10284,7140000,4031170,0,1,1,7100,500000),(10285,8140200,4031170,0,1,1,7100,500000),(10286,8140300,4031170,0,1,1,7100,500000),(10287,8141000,4031170,0,1,1,7100,500000),(10288,8141100,4031170,0,1,1,7100,500000),(10289,8142000,4031170,0,1,1,7100,500000),(10290,8143000,4031170,0,1,1,7100,500000),(10291,8160000,4031170,0,1,1,7100,500000),(10292,8170000,4031170,0,1,1,7100,500000),(10293,9500127,4031170,0,1,1,7100,500000),(10294,9500135,4031170,0,1,1,7100,500000),(10295,9500136,4031170,0,1,1,7100,500000),(10296,9500137,4031170,0,1,1,7100,500000),(10297,7130300,4031171,0,1,1,7101,400000),(10298,7160000,4031171,0,1,1,7101,400000),(10299,6130200,4031175,0,1,1,7101,300000),(10300,6230300,4031175,0,1,1,7101,300000),(10301,6230400,4031175,0,1,1,7101,300000),(10302,6230500,4031175,0,1,1,7101,300000),(10303,6300100,4031175,0,1,1,7101,350000),(10304,6400100,4031175,0,1,1,7101,350000),(10305,7130010,4031175,0,1,1,7101,400000),(10306,7130300,4031175,0,1,1,7101,400000),(10307,7140000,4031175,0,1,1,7101,400000),(10308,8140200,4031175,0,1,1,7101,350000),(10309,8140300,4031175,0,1,1,7101,350000),(10310,8141000,4031175,0,1,1,7101,450000),(10311,8141100,4031175,0,1,1,7101,450000),(10312,8142000,4031175,0,1,1,7101,450000),(10313,8143000,4031175,0,1,1,7101,450000),(10314,8160000,4031175,0,1,1,7101,600000),(10315,8170000,4031175,0,1,1,7101,600000),(10316,9500127,4031175,0,1,1,7101,300000),(10317,9500135,4031175,0,1,1,7101,400000),(10318,9500136,4031175,0,1,1,7101,450000),(10319,9500137,4031175,0,1,1,7101,450000),(10320,8141100,4031176,0,1,1,7104,50000),(10321,8143000,4031176,0,1,1,7104,50000),(10322,9500136,4031176,0,1,1,7104,50000),(10323,9500137,4031176,0,1,1,7104,50000),(10324,8141100,4031177,0,1,1,7104,100000),(10325,8143000,4031177,0,1,1,7104,100000),(10326,9500136,4031177,0,1,1,7104,100000),(10327,9500137,4031177,0,1,1,7104,100000),(10328,8141100,4031178,0,1,1,7104,10000),(10329,8143000,4031178,0,1,1,7104,10000),(10330,9500136,4031178,0,1,1,7104,10000),(10331,9500137,4031178,0,1,1,7104,10000),(10332,8160000,4031172,0,1,1,7103,50000),(10333,8170000,4031172,0,1,1,7103,50000),(10334,8141000,4031193,0,1,1,3446,60000),(10335,7130501,4031412,0,1,1,3712,100000),(10336,8140111,4031413,0,1,1,3712,100000),(10337,8150201,4031414,0,1,1,3712,100000),(10338,8150302,4031415,0,1,1,3712,100000),(10339,8180000,4001076,0,1,1,7301,1000000),(10340,8180000,4001076,0,1,1,7301,1000000),(10341,8180000,4001076,0,1,1,7301,1000000),(10342,8150200,4001075,0,1,1,7301,50000),(10343,8150201,4001075,0,1,1,7301,50000),(10344,8150300,4001077,0,1,1,7301,60000),(10345,8150301,4001077,0,1,1,7301,60000),(10346,8150302,4001077,0,1,1,7301,60000),(10347,8150200,4001079,0,1,1,7301,60000),(10348,8180000,4001104,0,1,1,7303,1000000),(10349,8180000,4001104,0,1,1,7303,1000000),(10350,8180000,4001104,0,1,1,7303,1000000),(10351,8150200,4001103,0,1,1,7303,50000),(10352,8150201,4001103,0,1,1,7303,50000),(10353,8150300,4001105,0,1,1,7303,60000),(10354,8150301,4001105,0,1,1,7303,60000),(10355,8150302,4001105,0,1,1,7303,60000),(10356,8150200,4001079,0,1,1,7303,60000),(10357,8180000,4031343,0,1,1,6904,999999),(10358,8180001,4031344,0,1,1,6904,999999),(10359,8180000,4031511,0,1,1,6914,999999),(10360,8180001,4031512,0,1,1,6914,999999),(10361,8180000,4031514,0,1,1,6924,999999),(10362,8180001,4031515,0,1,1,6924,999999),(10363,8180000,4031517,0,1,1,6934,999999),(10364,8180001,4031518,0,1,1,6934,999999),(10365,8180000,4031860,0,1,1,6944,999999),(10366,8180001,4031861,0,1,1,6944,999999),(10367,8140101,4031465,0,1,1,6250,5000),(10368,8140101,4031487,0,1,1,6251,5000),(10369,8140102,4031465,0,1,1,6250,5000),(10370,8140102,4031487,0,1,1,6251,5000),(10371,8140103,4031465,0,1,1,6250,5000),(10372,8140103,4031487,0,1,1,6251,5000),(10373,8140101,4031487,0,1,1,6251,5000),(10374,8150300,4031449,0,1,1,6120,60000),(10375,8150300,4031449,0,1,1,6120,60000),(10376,8150300,4031449,0,1,1,6120,60000),(10377,8150301,4031449,0,1,1,6120,60000),(10378,8150301,4031449,0,1,1,6120,60000),(10379,8150301,4031449,0,1,1,6120,60000),(10380,8150302,4031449,0,1,1,6120,60000),(10381,8150302,4031449,0,1,1,6120,60000),(10382,8150302,4031449,0,1,1,6120,60000),(10383,8150300,4031482,0,1,1,6121,20000),(10384,8150300,4031482,0,1,1,6121,20000),(10385,8150300,4031482,0,1,1,6121,20000),(10386,8150301,4031482,0,1,1,6121,20000),(10387,8150301,4031482,0,1,1,6121,20000),(10388,8150301,4031482,0,1,1,6121,20000),(10389,8150302,4031482,0,1,1,6121,20000),(10390,8150302,4031482,0,1,1,6121,20000),(10391,8150302,4031482,0,1,1,6121,20000),(10392,8150300,4031483,0,1,1,6122,20000),(10393,8150300,4031483,0,1,1,6122,20000),(10394,8150300,4031483,0,1,1,6122,20000),(10395,8150301,4031483,0,1,1,6122,20000),(10396,8150301,4031483,0,1,1,6122,20000),(10397,8150301,4031483,0,1,1,6122,20000),(10398,8150302,4031483,0,1,1,6122,20000),(10399,8150302,4031483,0,1,1,6122,20000),(10400,8150302,4031483,0,1,1,6122,20000),(10401,8150300,4031484,0,1,1,6123,20000),(10402,8150300,4031484,0,1,1,6123,20000),(10403,8150300,4031484,0,1,1,6123,20000),(10404,8150301,4031484,0,1,1,6123,20000),(10405,8150301,4031484,0,1,1,6123,20000),(10406,8150301,4031484,0,1,1,6123,20000),(10407,8150302,4031484,0,1,1,6123,20000),(10408,8150302,4031484,0,1,1,6123,20000),(10409,8150302,4031484,0,1,1,6123,20000),(10410,8150300,4031485,0,1,1,6124,20000),(10411,8150300,4031485,0,1,1,6124,20000),(10412,8150300,4031485,0,1,1,6124,20000),(10413,8150301,4031485,0,1,1,6124,20000),(10414,8150301,4031485,0,1,1,6124,20000),(10415,8150301,4031485,0,1,1,6124,20000),(10416,8150302,4031485,0,1,1,6124,20000),(10417,8150302,4031485,0,1,1,6124,20000),(10418,8150302,4031485,0,1,1,6124,20000),(10419,8130100,4031466,0,1,1,6107,500000),(10420,7130101,4031466,0,1,1,6107,80000),(10421,7130100,4031466,0,1,1,6107,80000),(10422,6230100,4031466,0,1,1,6107,30000),(10423,9300100,4031470,0,1,1,6225,250000),(10424,9300086,4031470,0,1,1,6225,250000),(10425,9300100,4031469,0,1,1,6315,250000),(10426,9300086,4031469,0,1,1,6315,250000),(10427,8160000,4031474,0,1,1,6295,50000),(10428,8160000,4031473,0,1,1,6226,20000),(10429,8160000,4031496,0,1,1,6316,20000),(10430,9300079,4031461,0,1,1,6169,30000),(10431,9300078,4031461,0,1,1,6169,30000),(10432,9300077,4031461,0,1,1,6169,30000),(10433,9300076,4031461,0,1,1,6169,30000),(10434,9300075,4031461,0,1,1,6169,30000),(10435,9300074,4031461,0,1,1,6169,30000),(10436,9300073,4031461,0,1,1,6169,30000),(10437,9300072,4031461,0,1,1,6169,30000),(10438,9300071,4031461,0,1,1,6169,30000),(10439,9300070,4031461,0,1,1,6169,30000),(10440,9300069,4031461,0,1,1,6169,30000),(10441,9300068,4031461,0,1,1,6169,30000),(10442,9300067,4031461,0,1,1,6169,30000),(10443,9300066,4031461,0,1,1,6169,30000),(10444,9300065,4031461,0,1,1,6169,30000),(10445,9300274,4032190,0,1,1,20705,50000),(10446,9300274,4032314,0,1,1,21709,150000),(10447,1210102,4032314,0,1,1,21709,150000),(10448,1210100,4032340,0,1,1,21710,200000),(10449,9300274,4032315,0,1,1,21711,50000),(10450,1110130,4032316,0,1,1,21714,50000),(10451,100121,4000483,0,1,1,0,400000),(10452,9001011,4032096,0,1,1,20201,700000),(10453,9001011,4032097,0,1,1,20202,700000),(10454,9001011,4032098,0,1,1,20203,700000),(10455,9001011,4032099,0,1,1,20204,700000),(10456,9001011,4032100,0,1,1,20205,700000),(10457,9001009,4032101,0,1,1,20301,999999),(10458,9001009,4032102,0,1,1,20302,999999),(10459,9001009,4032103,0,1,1,20303,999999),(10460,9001009,4032104,0,1,1,20304,999999),(10461,9001009,4032105,0,1,1,20305,999999),(10462,9300289,4032120,0,1,1,20601,999999),(10463,9300289,4032121,0,1,1,20602,999999),(10464,9300289,4032122,0,1,1,20603,999999),(10465,9300289,4032123,0,1,1,20604,999999),(10466,9300289,4032124,0,1,1,20605,999999),(10467,9300294,4032125,0,1,1,20611,999999),(10468,9300294,4032126,0,1,1,20612,999999),(10469,9300294,4032127,0,1,1,20613,999999),(10470,9300294,4032128,0,1,1,20614,999999),(10471,9300294,4032129,0,1,1,20615,999999),(14295,8200011,2290152,0,1,1,0,350),(14294,8200011,2290137,0,1,1,0,350),(10474,9420549,2280010,0,1,1,0,50000),(10475,9420549,2280009,0,1,1,0,70000),(10476,9420549,2280008,0,1,1,0,50000),(10477,9420549,2280007,0,1,1,0,50000),(10478,9420544,2280010,0,1,1,0,70000),(10479,9420544,2280009,0,1,1,0,90000),(10480,9420544,2280008,0,1,1,0,70000),(10481,9420544,2280007,0,1,1,0,70000),(10482,8520000,2280010,0,1,1,0,30000),(10483,8520000,2280009,0,1,1,0,50000),(10484,8520000,2280008,0,1,1,0,30000),(10485,8520000,2280007,0,1,1,0,30000),(10486,8510000,2280010,0,1,1,0,30000),(10487,8510000,2280009,0,1,1,0,50000),(10488,8510000,2280008,0,1,1,0,30000),(10489,8510000,2280007,0,1,1,0,30000),(13906,8500002,2290066,0,1,1,0,1500),(13905,8500002,2290123,0,1,1,0,5000),(13904,8500002,2290121,0,1,1,0,5000),(13903,8500002,2290107,0,1,1,0,5000),(10494,8140701,4031872,0,1,1,6340,60000),(10495,8140700,4031871,0,1,1,6350,60000),(13902,8500002,2290104,0,1,1,0,5000),(10497,8141000,4031873,0,1,1,6380,60000),(10498,8141100,4031874,0,1,1,6390,60000),(10499,7130101,4001112,0,1,1,0,1000),(10500,8170000,4001112,0,1,1,0,1500),(10501,5130107,4001107,0,1,1,0,1000),(10502,8143000,4001107,0,1,1,0,1500),(10503,7160000,4001110,0,1,1,0,1000),(10504,8150100,4161018,0,1,1,0,1000),(10505,7130000,4161021,0,1,1,0,1000),(10506,8150000,4001111,0,1,1,0,999999),(10507,8140000,4031477,0,1,1,0,10000),(10508,8170000,4031453,0,1,1,6291,50000),(10509,8160000,4031474,0,1,1,6295,50000),(10510,8180001,4031479,0,1,1,6151,999999),(10511,8130100,4031475,0,1,1,6153,999999),(10512,8140000,4031460,0,1,1,6168,10000),(10513,8180001,4031457,0,1,1,6231,400000),(10514,8170000,4031458,0,1,1,6231,10000),(10515,6130104,4031459,0,1,1,6231,500000),(10516,9300094,2280004,0,1,1,0,7000),(10517,9300095,2280004,0,1,1,0,7000),(10518,9300094,2280005,0,1,1,0,7000),(10519,9300095,2280005,0,1,1,0,7000),(10520,9300094,2280006,0,1,1,0,7000),(10521,9300095,2280006,0,1,1,0,7000),(13901,8500002,2290129,0,1,1,0,1000),(10524,9300367,2022179,0,1,1,0,300000),(10525,9300368,2022179,0,1,1,0,300000),(10526,9300369,2022179,0,1,1,0,300000),(10527,9300370,2022179,0,1,1,0,300000),(10528,9300371,2022179,0,1,1,0,300000),(10529,9300372,2022179,0,1,1,0,300000),(10530,9300373,2022179,0,1,1,0,300000),(10531,9300374,2022179,0,1,1,0,300000),(10532,9300375,2022179,0,1,1,0,300000),(10533,9300376,2022179,0,1,1,0,300000),(10534,9300377,2022179,0,1,1,0,300000),(10535,9300367,1002971,0,1,1,0,40000),(10536,9300368,1002971,0,1,1,0,40000),(10537,9300369,1002971,0,1,1,0,40000),(10538,9300370,1002971,0,1,1,0,40000),(10539,9300371,1002971,0,1,1,0,40000),(10540,9300372,1002971,0,1,1,0,40000),(10541,9300373,1002971,0,1,1,0,40000),(10542,9300374,1002971,0,1,1,0,40000),(10543,9300375,1002971,0,1,1,0,40000),(10544,9300376,1002971,0,1,1,0,40000),(10545,9300377,1002971,0,1,1,0,40000),(10546,9300367,1442046,0,1,1,0,30000),(10547,9300368,1442046,0,1,1,0,30000),(10548,9300369,1442046,0,1,1,0,30000),(10549,9300370,1442046,0,1,1,0,30000),(10550,9300371,1442046,0,1,1,0,30000),(10551,9300372,1442046,0,1,1,0,30000),(10552,9300373,1442046,0,1,1,0,30000),(10553,9300374,1442046,0,1,1,0,30000),(10554,9300375,1442046,0,1,1,0,30000),(10555,9300376,1442046,0,1,1,0,30000),(10556,9300377,1442046,0,1,1,0,30000),(10557,9300367,1442057,0,1,1,0,40000),(10558,9300368,1442057,0,1,1,0,40000),(10559,9300369,1442057,0,1,1,0,40000),(10560,9300370,1442057,0,1,1,0,40000),(10561,9300371,1442057,0,1,1,0,40000),(10562,9300372,1442057,0,1,1,0,40000),(10563,9300373,1442057,0,1,1,0,40000),(10564,9300374,1442057,0,1,1,0,40000),(10565,9300375,1442057,0,1,1,0,40000),(10566,9300376,1442057,0,1,1,0,40000),(10567,9300377,1442057,0,1,1,0,40000),(10568,8200001,4020009,0,1,1,0,1000),(10569,8200002,4020009,0,1,1,0,1000),(10570,8200003,4020009,0,1,1,0,1000),(10571,8200004,4020009,0,1,1,0,1000),(10572,8200005,4020009,0,1,1,0,1000),(10573,8200006,4020009,0,1,1,0,1000),(10574,8200007,4020009,0,1,1,0,1000),(10575,8200008,4020009,0,1,1,0,1000),(10576,8200009,4020009,0,1,1,0,1000),(10577,8200010,4020009,0,1,1,0,1000),(10578,8200011,4020009,0,1,1,0,1000),(10579,8200012,4020009,0,1,1,0,1000),(10580,9300000,4001008,0,1,1,0,999999),(10581,9300001,4001007,0,1,1,0,999999),(10582,9300002,4001008,0,1,1,0,999999),(10583,9300003,4001008,0,1,1,0,999999),(11218,4230109,1452016,0,1,1,0,800),(10585,9300005,4001022,0,1,1,0,999999),(10586,9300006,4001022,0,1,1,0,999999),(10587,9300007,4001022,0,1,1,0,999999),(10588,9300008,4001022,0,1,1,0,999999),(10589,9300014,4001022,0,1,1,0,999999),(10590,9300010,4001022,0,1,1,0,999999),(10591,9300012,4001023,0,1,1,0,999999),(10592,9300170,4001156,0,1,1,0,999999),(10593,9300171,4001156,0,1,1,0,999999),(10594,9300169,4001156,0,1,1,0,999999),(10595,9000100,4031013,0,1,1,0,700000),(10596,9000101,4031013,0,1,1,0,700000),(10598,9000001,4031013,0,1,1,0,700000),(10599,9000200,4031013,0,1,1,0,700000),(10600,9000201,4031013,0,1,1,0,700000),(10601,9000300,4031013,0,1,1,0,700000),(10602,9000301,4031013,0,1,1,0,700000),(10605,9400407,4000343,0,1,1,0,100000),(10606,9300018,4031802,0,1,1,1035,999999),(10607,6110301,4031745,0,1,1,3358,5000),(10608,9302010,2022524,0,1,1,0,100000),(14090,6230400,1342005,0,1,1,0,740),(14089,6230300,1342005,0,1,1,0,880),(14088,6130203,1342004,0,1,1,0,800),(14087,6130103,1342003,0,1,1,0,840),(14086,6110300,1342004,0,1,1,0,890),(14085,5130108,1342004,0,1,1,0,750),(14084,5130103,1342003,0,1,1,0,720),(14083,5120002,1342003,0,1,1,0,700),(14082,4300008,1342003,0,1,1,0,810),(14081,4300007,1342003,0,1,1,0,810),(14080,4300006,1342002,0,1,1,0,760),(14079,4300001,1342002,0,1,1,0,890),(14078,4230400,1342002,0,1,1,0,700),(14077,4230121,1342003,0,1,1,0,790),(14076,3300001,1342002,0,1,1,0,860),(14075,3230305,1342002,0,1,1,0,840),(14074,3000005,1342001,0,1,1,0,680),(14073,2230101,1342001,0,1,1,0,500),(14072,2110200,1342001,0,1,1,0,600),(14071,210100,1342000,0,1,1,0,470),(14070,1210103,1342000,0,1,1,0,360),(14069,1210100,1342000,0,1,1,0,750),(14068,1120100,1342000,0,1,1,0,810),(10634,9420015,2022042,0,1,1,0,700000),(10635,9420015,2022042,0,1,1,0,700000),(10636,9420015,2022042,0,1,1,0,700000),(10637,9420015,2022042,0,1,1,0,700000),(10638,9420015,2022042,0,1,1,0,700000),(10639,9420015,4032176,0,1,1,0,700000),(10640,9420015,4032176,0,1,1,0,700000),(10641,9420015,4032176,0,1,1,0,700000),(10642,9420015,4032176,0,1,1,0,700000),(10643,9420015,4032176,0,1,1,0,700000),(10644,9420015,4032176,0,1,1,0,700000),(10645,9420015,4032176,0,1,1,0,700000),(10646,9420015,4032176,0,1,1,0,700000),(10647,9420015,4032176,0,1,1,0,700000),(10648,9420015,4032176,0,1,1,0,700000),(10649,9420015,4032176,0,1,1,0,700000),(10650,9420015,4032176,0,1,1,0,700000),(10651,9420015,4032176,0,1,1,0,700000),(10652,9420015,4032176,0,1,1,0,700000),(10653,9420015,4032176,0,1,1,0,700000),(10654,9420015,4032176,0,1,1,0,700000),(10655,9420015,4032176,0,1,1,0,700000),(10656,9420015,4032176,0,1,1,0,700000),(10657,9420015,4032176,0,1,1,0,700000),(10658,9420015,4032176,0,1,1,0,700000),(10659,9420015,4000420,0,1,1,0,700000),(10660,9420015,4000420,0,1,1,0,700000),(10661,9420015,4000420,0,1,1,0,700000),(10662,9420015,4000420,0,1,1,0,700000),(10663,9420015,4000420,0,1,1,0,700000),(10664,9420015,4000420,0,1,1,0,700000),(10665,9420015,4000420,0,1,1,0,700000),(10666,9420015,4000420,0,1,1,0,700000),(10667,9420015,4000420,0,1,1,0,700000),(10668,9420015,4000420,0,1,1,0,700000),(10669,9420015,4000420,0,1,1,0,700000),(10670,9420015,4000420,0,1,1,0,700000),(10671,9420015,4000420,0,1,1,0,700000),(10672,9420015,4000420,0,1,1,0,700000),(10673,9420015,4000420,0,1,1,0,700000),(10674,9420015,4000420,0,1,1,0,700000),(10675,9420015,4000420,0,1,1,0,700000),(10676,9420015,4000420,0,1,1,0,700000),(10677,9420015,4000420,0,1,1,0,700000),(10678,9420015,4000420,0,1,1,0,700000),(10679,9420015,4000420,0,1,1,0,700000),(10680,9420015,4000420,0,1,1,0,700000),(10681,9420015,4000420,0,1,1,0,700000),(10682,9420015,4000420,0,1,1,0,700000),(10683,9420015,4000420,0,1,1,0,700000),(10684,9420015,4000420,0,1,1,0,700000),(10685,9420015,4000420,0,1,1,0,700000),(10686,9420015,4000420,0,1,1,0,700000),(10687,9420015,4000420,0,1,1,0,700000),(10688,9420015,4000420,0,1,1,0,700000),(10689,9420015,4000420,0,1,1,0,700000),(10690,9420015,4000420,0,1,1,0,700000),(10691,9420015,4000420,0,1,1,0,700000),(10692,9420015,4000420,0,1,1,0,700000),(10693,9420015,4000420,0,1,1,0,700000),(10694,9420015,4000420,0,1,1,0,700000),(10695,9420015,4000420,0,1,1,0,700000),(10696,9420015,4000420,0,1,1,0,700000),(10697,9420015,4000420,0,1,1,0,700000),(10698,9420015,4000420,0,1,1,0,700000),(10699,9420015,4000421,0,1,1,0,700000),(10700,9420015,4000421,0,1,1,0,700000),(10701,9420015,4000421,0,1,1,0,700000),(10702,9420015,4000421,0,1,1,0,700000),(10703,9420015,4000421,0,1,1,0,700000),(10704,9420015,4000421,0,1,1,0,700000),(10705,9420015,4000421,0,1,1,0,700000),(10706,9420015,4000421,0,1,1,0,700000),(10707,9420015,4000421,0,1,1,0,700000),(10708,9420015,4000421,0,1,1,0,700000),(10709,9420015,4000421,0,1,1,0,700000),(10710,9420015,4000421,0,1,1,0,700000),(10711,9420015,4000421,0,1,1,0,700000),(10712,9420015,4000421,0,1,1,0,700000),(10713,9420015,4000421,0,1,1,0,700000),(10714,9420015,4000421,0,1,1,0,700000),(10715,9420015,4000421,0,1,1,0,700000),(10716,9420015,4000421,0,1,1,0,700000),(10717,9420015,4000421,0,1,1,0,700000),(10718,9420015,4000421,0,1,1,0,700000),(10719,9420015,4000421,0,1,1,0,700000),(10720,9420015,4000421,0,1,1,0,700000),(10721,9420015,4000421,0,1,1,0,700000),(10722,9420015,4000421,0,1,1,0,700000),(10723,9420015,4000421,0,1,1,0,700000),(10724,9420015,4000421,0,1,1,0,700000),(10725,9420015,4000421,0,1,1,0,700000),(10726,9420015,4000421,0,1,1,0,700000),(10727,9420015,4000421,0,1,1,0,700000),(10728,9420015,4000421,0,1,1,0,700000),(10729,9420015,4000421,0,1,1,0,700000),(10730,9420015,4000421,0,1,1,0,700000),(10731,9420015,4000421,0,1,1,0,700000),(10732,9420015,4000421,0,1,1,0,700000),(10733,9420015,4000421,0,1,1,0,700000),(10734,9420015,4000421,0,1,1,0,700000),(10735,9420015,4000421,0,1,1,0,700000),(10736,9420015,4000421,0,1,1,0,700000),(10737,9420015,4000421,0,1,1,0,700000),(10738,9420015,4000421,0,1,1,0,700000),(10739,9400569,2022311,0,1,4,0,700000),(10740,9400569,2020017,0,1,4,0,700000),(10741,9400569,2020018,0,1,4,0,700000),(10742,9400569,2022310,0,1,4,0,700000),(10743,9400569,2022456,0,1,4,0,700000),(10744,9400569,2020014,0,1,4,0,700000),(10745,9400569,2020015,0,1,4,0,700000),(10746,9400569,2002001,0,1,4,0,700000),(10747,9400569,2002005,0,1,4,0,700000),(10748,9400569,2002003,0,1,4,0,700000),(10749,9400569,2002205,0,1,4,0,700000),(10750,9500168,2022311,0,1,4,0,700000),(10751,9500168,2020017,0,1,4,0,700000),(10752,9500168,2020018,0,1,4,0,700000),(10753,9500168,2022310,0,1,4,0,700000),(10754,9500168,2022456,0,1,4,0,700000),(10755,9500168,2020014,0,1,4,0,700000),(10756,9500168,2020015,0,1,4,0,700000),(10757,9500168,2002001,0,1,4,0,700000),(10758,9500168,2002005,0,1,4,0,700000),(10759,9500168,2002003,0,1,4,0,700000),(10760,9500168,2002205,0,1,4,0,700000),(10761,9500169,2022311,0,1,4,0,700000),(10762,9500169,2020017,0,1,4,0,700000),(10763,9500169,2020018,0,1,4,0,700000),(10764,9500169,2022310,0,1,4,0,700000),(10765,9500169,2022456,0,1,4,0,700000),(10766,9500169,2020014,0,1,4,0,700000),(10767,9500169,2020015,0,1,4,0,700000),(10768,9500169,2002001,0,1,4,0,700000),(10769,9500169,2002005,0,1,4,0,700000),(10770,9500169,2002003,0,1,4,0,700000),(10771,9500169,2002205,0,1,4,0,700000),(10772,9500170,2022311,0,1,4,0,700000),(10773,9500170,2020017,0,1,4,0,700000),(10774,9500170,2020018,0,1,4,0,700000),(10775,9500170,2022310,0,1,4,0,700000),(10776,9500170,2022456,0,1,4,0,700000),(10777,9500170,2020014,0,1,4,0,700000),(10778,9500170,2020015,0,1,4,0,700000),(10779,9500170,2002001,0,1,4,0,700000),(10780,9500170,2002005,0,1,4,0,700000),(10781,9500170,2002003,0,1,4,0,700000),(10782,9500170,2002205,0,1,4,0,700000),(10783,9500171,2022311,0,1,4,0,700000),(10784,9500171,2020017,0,1,4,0,700000),(10785,9500171,2020018,0,1,4,0,700000),(10786,9500171,2022310,0,1,4,0,700000),(10787,9500171,2022456,0,1,4,0,700000),(10788,9500171,2020014,0,1,4,0,700000),(10789,9500171,2020015,0,1,4,0,700000),(10790,9500171,2002001,0,1,4,0,700000),(10791,9500171,2002005,0,1,4,0,700000),(10792,9500171,2002003,0,1,4,0,700000),(10793,9500171,2002205,0,1,4,0,700000),(10794,9500172,2022311,0,1,4,0,700000),(10795,9500172,2020017,0,1,4,0,700000),(10796,9500172,2020018,0,1,4,0,700000),(10797,9500172,2022310,0,1,4,0,700000),(10798,9500172,2022456,0,1,4,0,700000),(10799,9500172,2020014,0,1,4,0,700000),(10800,9500172,2020015,0,1,4,0,700000),(10801,9500172,2002001,0,1,4,0,700000),(10802,9500172,2002005,0,1,4,0,700000),(10803,9500172,2002003,0,1,4,0,700000),(10804,9500172,2002205,0,1,4,0,700000),(10805,9500173,2022311,0,1,4,0,700000),(10806,9500173,2020017,0,1,4,0,700000),(10807,9500173,2020018,0,1,4,0,700000),(10808,9500173,2022310,0,1,4,0,700000),(10809,9500173,2022456,0,1,4,0,700000),(10810,9500173,2020014,0,1,4,0,700000),(10811,9500173,2020015,0,1,4,0,700000),(10812,9500173,2002001,0,1,4,0,700000),(10813,9500173,2002005,0,1,4,0,700000),(10814,9500173,2002003,0,1,4,0,700000),(10815,9500173,2002205,0,1,4,0,700000),(10816,9500174,2022311,0,1,4,0,700000),(10817,9500174,2020017,0,1,4,0,700000),(10818,9500174,2020018,0,1,4,0,700000),(10819,9500174,2022310,0,1,4,0,700000),(10820,9500174,2022456,0,1,4,0,700000),(10821,9500174,2020014,0,1,4,0,700000),(10822,9500174,2020015,0,1,4,0,700000),(10823,9500174,2002001,0,1,4,0,700000),(10824,9500174,2002005,0,1,4,0,700000),(10825,9500174,2002003,0,1,4,0,700000),(10826,9500174,2002205,0,1,4,0,700000),(10827,9500175,2022311,0,1,4,0,700000),(10828,9500175,2020017,0,1,4,0,700000),(10829,9500175,2020018,0,1,4,0,700000),(10830,9500175,2022310,0,1,4,0,700000),(10831,9500175,2022456,0,1,4,0,700000),(10832,9500175,2020014,0,1,4,0,700000),(10833,9500175,2020015,0,1,4,0,700000),(10834,9500175,2002001,0,1,4,0,700000),(10835,9500175,2002005,0,1,4,0,700000),(10836,9500175,2002003,0,1,4,0,700000),(10837,9500175,2002205,0,1,4,0,700000),(10838,9500176,2022311,0,1,4,0,700000),(10839,9500176,2020017,0,1,4,0,700000),(10840,9500176,2020018,0,1,4,0,700000),(10841,9500176,2022310,0,1,4,0,700000),(10842,9500176,2022456,0,1,4,0,700000),(10843,9500176,2020014,0,1,4,0,700000),(10844,9500176,2020015,0,1,4,0,700000),(10845,9500176,2002001,0,1,4,0,700000),(10846,9500176,2002005,0,1,4,0,700000),(10847,9500176,2002003,0,1,4,0,700000),(10848,9500176,2002205,0,1,4,0,700000),(10849,9300217,2022430,0,1,1,0,700000),(10850,9300217,2022431,0,1,1,0,700000),(10851,9300217,2022432,0,1,1,0,700000),(10852,9300217,2022433,0,1,1,0,700000),(10853,9300218,2022430,0,1,1,0,700000),(10854,9300218,2022431,0,1,1,0,700000),(10855,9300218,2022432,0,1,1,0,700000),(10856,9300218,2022433,0,1,1,0,700000),(10857,9300219,2022430,0,1,1,0,700000),(10858,9300219,2022431,0,1,1,0,700000),(10859,9300219,2022432,0,1,1,0,700000),(10860,9300219,2022433,0,1,1,0,700000),(10861,9300220,2022430,0,1,1,0,700000),(10862,9300220,2022431,0,1,1,0,700000),(10863,9300220,2022432,0,1,1,0,700000),(10864,9300220,2022433,0,1,1,0,700000),(10865,9300221,2022430,0,1,1,0,700000),(10866,9300221,2022431,0,1,1,0,700000),(10867,9300221,2022432,0,1,1,0,700000),(10868,9300221,2022433,0,1,1,0,700000),(10869,9300222,2022430,0,1,1,0,700000),(10870,9300222,2022431,0,1,1,0,700000),(10871,9300222,2022432,0,1,1,0,700000),(10872,9300222,2022433,0,1,1,0,700000),(10873,9300223,2022430,0,1,1,0,700000),(10874,9300223,2022431,0,1,1,0,700000),(10875,9300223,2022432,0,1,1,0,700000),(10876,9300223,2022433,0,1,1,0,700000),(10877,9300224,2022430,0,1,1,0,700000),(10878,9300224,2022431,0,1,1,0,700000),(10879,9300224,2022432,0,1,1,0,700000),(10880,9300224,2022433,0,1,1,0,700000),(10881,9300225,2022430,0,1,1,0,700000),(10882,9300225,2022431,0,1,1,0,700000),(10883,9300225,2022432,0,1,1,0,700000),(10884,9300225,2022433,0,1,1,0,700000),(10885,9300226,2022430,0,1,1,0,700000),(10886,9300226,2022431,0,1,1,0,700000),(10887,9300226,2022432,0,1,1,0,700000),(10888,9300226,2022433,0,1,1,0,700000),(10889,9300227,2022430,0,1,1,0,700000),(10890,9300227,2022431,0,1,1,0,700000),(10891,9300227,2022432,0,1,1,0,700000),(10892,9300227,2022433,0,1,1,0,700000),(10893,9300228,2022430,0,1,1,0,700000),(10894,9300228,2022431,0,1,1,0,700000),(10895,9300228,2022432,0,1,1,0,700000),(10896,9300228,2022433,0,1,1,0,700000),(10897,9300229,2022430,0,1,1,0,700000),(10898,9300229,2022431,0,1,1,0,700000),(10899,9300229,2022432,0,1,1,0,700000),(10900,9300229,2022433,0,1,1,0,700000),(10901,9300230,2022430,0,1,1,0,700000),(10902,9300230,2022431,0,1,1,0,700000),(10903,9300230,2022432,0,1,1,0,700000),(10904,9300230,2022433,0,1,1,0,700000),(10905,9300231,2022430,0,1,1,0,700000),(10906,9300231,2022431,0,1,1,0,700000),(10907,9300231,2022432,0,1,1,0,700000),(10908,9300231,2022433,0,1,1,0,700000),(10909,9300232,2022430,0,1,1,0,700000),(10910,9300232,2022431,0,1,1,0,700000),(10911,9300232,2022432,0,1,1,0,700000),(10912,9300232,2022433,0,1,1,0,700000),(10913,9300233,2022430,0,1,1,0,700000),(10914,9300233,2022431,0,1,1,0,700000),(10915,9300233,2022432,0,1,1,0,700000),(10916,9300233,2022433,0,1,1,0,700000),(10917,9300234,2022430,0,1,1,0,700000),(10918,9300234,2022431,0,1,1,0,700000),(10919,9300234,2022432,0,1,1,0,700000),(10920,9300234,2022433,0,1,1,0,700000),(10921,9300235,2022430,0,1,1,0,700000),(10922,9300235,2022431,0,1,1,0,700000),(10923,9300235,2022432,0,1,1,0,700000),(10924,9300235,2022433,0,1,1,0,700000),(10925,9300236,2022430,0,1,1,0,700000),(10926,9300236,2022431,0,1,1,0,700000),(10927,9300236,2022432,0,1,1,0,700000),(10928,9300236,2022433,0,1,1,0,700000),(10929,9300237,2022430,0,1,1,0,700000),(10930,9300237,2022431,0,1,1,0,700000),(10931,9300237,2022432,0,1,1,0,700000),(10932,9300237,2022433,0,1,1,0,700000),(10933,9300238,2022430,0,1,1,0,700000),(10934,9300238,2022431,0,1,1,0,700000),(10935,9300238,2022432,0,1,1,0,700000),(10936,9300238,2022433,0,1,1,0,700000),(10937,9300239,2022430,0,1,1,0,700000),(10938,9300239,2022431,0,1,1,0,700000),(10939,9300239,2022432,0,1,1,0,700000),(10940,9300239,2022433,0,1,1,0,700000),(10941,9300240,2022430,0,1,1,0,700000),(10942,9300240,2022431,0,1,1,0,700000),(10943,9300240,2022432,0,1,1,0,700000),(10944,9300240,2022433,0,1,1,0,700000),(10945,9300241,2022430,0,1,1,0,700000),(10946,9300241,2022431,0,1,1,0,700000),(10947,9300241,2022432,0,1,1,0,700000),(10948,9300241,2022433,0,1,1,0,700000),(10949,9300242,2022430,0,1,1,0,700000),(10950,9300242,2022431,0,1,1,0,700000),(10951,9300242,2022432,0,1,1,0,700000),(10952,9300242,2022433,0,1,1,0,700000),(10953,9300243,2022430,0,1,1,0,700000),(10954,9300243,2022431,0,1,1,0,700000),(10955,9300243,2022432,0,1,1,0,700000),(10956,9300243,2022433,0,1,1,0,700000),(10957,9300244,2022430,0,1,1,0,700000),(10958,9300244,2022431,0,1,1,0,700000),(10959,9300244,2022432,0,1,1,0,700000),(10960,9300244,2022433,0,1,1,0,700000),(10961,9300245,2022430,0,1,1,0,700000),(10962,9300245,2022431,0,1,1,0,700000),(10963,9300245,2022432,0,1,1,0,700000),(10964,9300245,2022433,0,1,1,0,700000),(10965,9300246,2022430,0,1,1,0,700000),(10966,9300246,2022431,0,1,1,0,700000),(10967,9300246,2022432,0,1,1,0,700000),(10968,9300246,2022433,0,1,1,0,700000),(10969,9300247,2022430,0,1,1,0,700000),(10970,9300247,2022431,0,1,1,0,700000),(10971,9300247,2022432,0,1,1,0,700000),(10972,9300247,2022433,0,1,1,0,700000),(10973,9300248,2022430,0,1,1,0,700000),(10974,9300248,2022431,0,1,1,0,700000),(10975,9300248,2022432,0,1,1,0,700000),(10976,9300248,2022433,0,1,1,0,700000),(10977,9300249,2022430,0,1,1,0,700000),(10978,9300249,2022431,0,1,1,0,700000),(10979,9300249,2022432,0,1,1,0,700000),(10980,9300249,2022433,0,1,1,0,700000),(10981,9300250,2022430,0,1,1,0,700000),(10982,9300250,2022431,0,1,1,0,700000),(10983,9300250,2022432,0,1,1,0,700000),(10984,9300250,2022433,0,1,1,0,700000),(10985,9300251,2022430,0,1,1,0,700000),(10986,9300251,2022431,0,1,1,0,700000),(10987,9300251,2022432,0,1,1,0,700000),(10988,9300251,2022433,0,1,1,0,700000),(10989,9300252,2022430,0,1,1,0,700000),(10990,9300252,2022431,0,1,1,0,700000),(10991,9300252,2022432,0,1,1,0,700000),(10992,9300252,2022433,0,1,1,0,700000),(10993,9300253,2022430,0,1,1,0,700000),(10994,9300253,2022431,0,1,1,0,700000),(10995,9300253,2022432,0,1,1,0,700000),(10996,9300253,2022433,0,1,1,0,700000),(10997,9300254,2022430,0,1,1,0,700000),(10998,9300254,2022431,0,1,1,0,700000),(10999,9300254,2022432,0,1,1,0,700000),(11000,9300254,2022433,0,1,1,0,700000),(11001,9300255,2022430,0,1,1,0,700000),(11002,9300255,2022431,0,1,1,0,700000),(11003,9300255,2022432,0,1,1,0,700000),(11004,9300255,2022433,0,1,1,0,700000),(11005,9300256,2022430,0,1,1,0,700000),(11006,9300256,2022431,0,1,1,0,700000),(11007,9300256,2022432,0,1,1,0,700000),(11008,9300256,2022433,0,1,1,0,700000),(11009,9300257,2022430,0,1,1,0,700000),(11010,9300257,2022431,0,1,1,0,700000),(11011,9300257,2022432,0,1,1,0,700000),(11012,9300257,2022433,0,1,1,0,700000),(11013,9300258,2022430,0,1,1,0,700000),(11014,9300258,2022431,0,1,1,0,700000),(11015,9300258,2022432,0,1,1,0,700000),(11016,9300258,2022433,0,1,1,0,700000),(11017,9300259,2022430,0,1,1,0,700000),(11018,9300259,2022431,0,1,1,0,700000),(11019,9300259,2022432,0,1,1,0,700000),(11020,9300259,2022433,0,1,1,0,700000),(11021,9300260,2022430,0,1,1,0,700000),(11022,9300260,2022431,0,1,1,0,700000),(11023,9300260,2022432,0,1,1,0,700000),(11024,9300260,2022433,0,1,1,0,700000),(11025,9300261,2022430,0,1,1,0,700000),(11026,9300261,2022431,0,1,1,0,700000),(11027,9300261,2022432,0,1,1,0,700000),(11028,9300261,2022433,0,1,1,0,700000),(11029,9300262,2022430,0,1,1,0,700000),(11030,9300262,2022431,0,1,1,0,700000),(11031,9300262,2022432,0,1,1,0,700000),(11032,9300262,2022433,0,1,1,0,700000),(11033,9300263,2022430,0,1,1,0,700000),(11034,9300263,2022431,0,1,1,0,700000),(11035,9300263,2022432,0,1,1,0,700000),(11036,9300263,2022433,0,1,1,0,700000),(11037,9300264,2022430,0,1,1,0,700000),(11038,9300264,2022431,0,1,1,0,700000),(11039,9300264,2022432,0,1,1,0,700000),(11040,9300264,2022433,0,1,1,0,700000),(11041,9300265,2022430,0,1,1,0,700000),(11042,9300265,2022431,0,1,1,0,700000),(11043,9300265,2022432,0,1,1,0,700000),(11044,9300265,2022433,0,1,1,0,700000),(11045,9300266,2022430,0,1,1,0,700000),(11046,9300266,2022431,0,1,1,0,700000),(11047,9300266,2022432,0,1,1,0,700000),(11048,9300266,2022433,0,1,1,0,700000),(11049,9300267,2022430,0,1,1,0,700000),(11050,9300267,2022431,0,1,1,0,700000),(11051,9300267,2022432,0,1,1,0,700000),(11052,9300267,2022433,0,1,1,0,700000),(11053,9300270,2022430,0,1,1,0,700000),(11054,9300270,2022431,0,1,1,0,700000),(11055,9300270,2022432,0,1,1,0,700000),(11056,9300270,2022433,0,1,1,0,700000),(11057,8140500,4007007,0,1,1,0,10000),(11058,4230502,4007007,0,1,1,0,10000),(11059,3210205,4007007,0,1,1,0,10000),(11060,8200012,4007007,0,1,1,0,10000),(11061,8150200,4007007,0,1,1,0,10000),(11062,5120003,4007007,0,1,1,0,10000),(11063,5130104,4007007,0,1,1,0,10000),(11064,6110300,4007007,0,1,1,0,10000),(11065,7130000,4007007,0,1,1,0,10000),(11066,4230119,4007007,0,1,1,0,10000),(11067,6130204,4007007,0,1,1,0,10000),(11068,3110102,4007007,0,1,1,0,10000),(11069,8142100,4007007,0,1,1,0,10000),(11070,8190003,4007007,0,1,1,0,10000),(11071,5120506,4007007,0,1,1,0,10000),(11072,4230118,4007007,0,1,1,0,10000),(11073,4230101,4007007,0,1,1,0,10000),(11074,7130104,4007002,0,1,1,0,10000),(11075,3230400,4007002,0,1,1,0,10000),(11076,5300001,4007002,0,1,1,0,10000),(11077,4230124,4007002,0,1,1,0,10000),(11078,7140000,4007002,0,1,1,0,10000),(11079,8143000,4007002,0,1,1,0,10000),(11080,4110300,4007002,0,1,1,0,10000),(11081,5100000,4007002,0,1,1,0,10000),(11082,4230106,4007002,0,1,1,0,10000),(11083,4230115,4007002,0,1,1,0,10000),(11084,6230500,4007002,0,1,1,0,10000),(11085,9400011,4007002,0,1,1,0,10000),(11086,3210208,4007002,0,1,1,0,10000),(11087,6110301,4007002,0,1,1,0,10000),(11088,8141000,4007002,0,1,1,0,10000),(11089,8190003,4007002,0,1,1,0,10000),(11090,5120506,4007002,0,1,1,0,10000),(11091,4230101,4007002,0,1,1,0,10000),(11092,3230306,4007000,0,1,1,0,10000),(11093,5130103,4007000,0,1,1,0,10000),(11094,3110300,4007000,0,1,1,0,10000),(11095,4230600,4007000,0,1,1,0,10000),(11096,8150200,4007000,0,1,1,0,10000),(11097,7110301,4007000,0,1,1,0,10000),(11098,3210200,4007000,0,1,1,0,10000),(11099,8190000,4007000,0,1,1,0,10000),(11100,5400000,4007000,0,1,1,0,10000),(11101,3230101,4007000,0,1,1,0,10000),(11102,5100000,4007000,0,1,1,0,10000),(11103,4230115,4007000,0,1,1,0,10000),(11104,5110302,4007000,0,1,1,0,10000),(11105,4230114,4007000,0,1,1,0,10000),(11106,4110301,4007000,0,1,1,0,10000),(11107,8142100,4007000,0,1,1,0,10000),(11108,5110301,4007000,0,1,1,0,10000),(11109,5100004,4007000,0,1,1,0,10000),(11110,6110301,4007000,0,1,1,0,10000),(11111,8190003,4007000,0,1,1,0,10000),(11112,6230400,4007000,0,1,1,0,10000),(11113,3230200,4007000,0,1,1,0,10000),(11114,5130101,4007000,0,1,1,0,10000),(11115,5120503,4007000,0,1,1,0,10000),(11116,5120504,4007000,0,1,1,0,10000),(11117,4230102,4007000,0,1,1,0,10000),(11118,4230101,4007000,0,1,1,0,10000),(11119,3210100,4007003,0,1,1,0,10000),(11120,5120001,4007003,0,1,1,0,10000),(11121,3230101,4007003,0,1,1,0,10000),(11122,3110302,4007003,0,1,1,0,10000),(11123,4230101,4007003,0,1,1,0,10000),(11124,4230119,4007003,0,1,1,0,10000),(11125,4250000,4007003,0,1,1,0,10000),(11126,4230102,4007003,0,1,1,0,10000),(11127,5110302,4007003,0,1,1,0,10000),(11128,9400012,4007003,0,1,1,0,10000),(11129,8140110,4007003,0,1,1,0,10000),(11130,8150201,4007003,0,1,1,0,10000),(11131,8190003,4007003,0,1,1,0,10000),(11132,3110100,4007005,0,1,1,0,10000),(11133,3210205,4007005,0,1,1,0,10000),(11134,5400000,4007005,0,1,1,0,10000),(11135,3230306,4007005,0,1,1,0,10000),(11136,4230101,4007005,0,1,1,0,10000),(11137,4230107,4007005,0,1,1,0,10000),(11138,4250000,4007005,0,1,1,0,10000),(11139,4110301,4007005,0,1,1,0,10000),(11140,5130107,4007005,0,1,1,0,10000),(11141,6110300,4007005,0,1,1,0,10000),(11142,8200003,4007005,0,1,1,0,10000),(11143,8190000,4007005,0,1,1,0,10000),(11144,3110300,4007006,0,1,1,0,10000),(11145,5400000,4007006,0,1,1,0,10000),(11146,3210200,4007006,0,1,1,0,10000),(11147,4230101,4007006,0,1,1,0,10000),(11148,4110302,4007006,0,1,1,0,10000),(11149,4110301,4007006,0,1,1,0,10000),(11150,4230115,4007006,0,1,1,0,10000),(11151,4230102,4007006,0,1,1,0,10000),(11152,4230600,4007006,0,1,1,0,10000),(11153,5120504,4007006,0,1,1,0,10000),(11154,5130103,4007006,0,1,1,0,10000),(11155,5110301,4007006,0,1,1,0,10000),(11156,5130101,4007006,0,1,1,0,10000),(11157,5100004,4007006,0,1,1,0,10000),(11158,5110302,4007006,0,1,1,0,10000),(11159,8142100,4007006,0,1,1,0,10000),(11160,8200001,4007006,0,1,1,0,10000),(11161,3210100,4007001,0,1,1,0,10000),(11162,2230102,4007001,0,1,1,0,10000),(11163,3110102,4007001,0,1,1,0,10000),(11164,3210200,4007001,0,1,1,0,10000),(11165,4230200,4007001,0,1,1,0,10000),(11166,4230101,4007001,0,1,1,0,10000),(11167,4230105,4007001,0,1,1,0,10000),(11168,4230122,4007001,0,1,1,0,10000),(11169,4110302,4007001,0,1,1,0,10000),(11170,5100000,4007001,0,1,1,0,10000),(11171,5130103,4007001,0,1,1,0,10000),(11172,5120001,4007001,0,1,1,0,10000),(11173,5120003,4007001,0,1,1,0,10000),(11174,5130101,4007001,0,1,1,0,10000),(11175,6130209,4007001,0,1,1,0,10000),(11176,7110301,4007001,0,1,1,0,10000),(11177,8200000,4007001,0,1,1,0,10000),(11178,8140110,4007001,0,1,1,0,10000),(11179,7160000,4007001,0,1,1,0,10000),(11180,8140101,4007001,0,1,1,0,10000),(11181,8140500,4007001,0,1,1,0,10000),(11182,8141300,4007001,0,1,1,0,10000),(11183,8200003,4007001,0,1,1,0,10000),(11184,8190002,4007001,0,1,1,0,10000),(11185,8190005,4007001,0,1,1,0,10000),(11186,8200012,4007001,0,1,1,0,10000),(11187,4110300,4007004,0,1,1,0,10000),(11188,3230400,4007004,0,1,1,0,10000),(11189,3110300,4007004,0,1,1,0,10000),(11190,5300001,4007004,0,1,1,0,10000),(11191,3210208,4007004,0,1,1,0,10000),(11192,3210450,4007004,0,1,1,0,10000),(11193,4230113,4007004,0,1,1,0,10000),(11194,4230101,4007004,0,1,1,0,10000),(11195,4230119,4007004,0,1,1,0,10000),(11196,4230600,4007004,0,1,1,0,10000),(11197,5120503,4007004,0,1,1,0,10000),(11198,5130107,4007004,0,1,1,0,10000),(11199,6130103,4007004,0,1,1,0,10000),(11200,6130208,4007004,0,1,1,0,10000),(11201,8190003,4007004,0,1,1,0,10000),(11202,8200009,4007004,0,1,1,0,10000),(11203,8200011,4007004,0,1,1,0,10000),(11204,8200001,4007004,0,1,1,0,10000),(11205,9420003,4007004,0,1,1,0,10000),(11206,4130104,4000062,0,1,1,0,10000),(11207,4230122,4000058,0,1,1,0,10000),(11208,9001000,4031059,0,1,1,0,999999),(11209,9001001,4031059,0,1,1,0,999999),(11210,9001002,4031059,0,1,1,0,999999),(11211,9001003,4031059,0,1,1,0,999999),(11212,9001008,4031059,0,1,1,0,999999),(12802,1110101,4032374,0,1,1,2405,30000),(11214,9001012,4032311,0,1,1,0,300000),(11215,9001012,4032311,0,1,1,0,300000),(11216,9001013,4032312,0,1,1,0,999999),(11217,9001013,4032339,0,1,1,0,999999),(11219,4230113,1452016,0,1,1,0,800),(11220,4230103,1452016,0,1,1,0,800),(11221,2230102,1452016,0,1,1,0,800),(11222,6230100,1452016,0,1,1,0,800),(11223,2110200,1452016,0,1,1,0,800),(11224,2230104,1452016,0,1,1,0,800),(11225,9400570,1452016,0,1,1,0,800),(11226,4230106,1452016,0,1,1,0,800),(11227,5120502,1452016,0,1,1,0,800),(11228,3230400,1452022,0,1,1,0,800),(11229,2230102,1452022,0,1,1,0,800),(11230,6130100,1452022,0,1,1,0,800),(11231,4230103,1452022,0,1,1,0,800),(11232,5130100,1452022,0,1,1,0,800),(11233,9400570,1452022,0,1,1,0,800),(11234,3210208,1452022,0,1,1,0,800),(11235,6130204,1452022,0,1,1,0,800),(11236,7130103,1452022,0,1,1,0,800),(11237,8140000,1452022,0,1,1,0,800),(11238,5200000,1452022,0,1,1,0,800),(11239,2100104,1452022,0,1,1,0,800),(11240,3210800,1452022,0,1,1,0,800),(11241,4230121,1452022,0,1,1,0,800),(11242,4230101,1472030,0,1,1,0,800),(11243,4230102,1472030,0,1,1,0,800),(11244,7130100,1472030,0,1,1,0,800),(11245,2230101,1472030,0,1,1,0,800),(11246,3210200,1472030,0,1,1,0,800),(11247,7130200,1472030,0,1,1,0,800),(11248,9400570,1472030,0,1,1,0,800),(11249,2230110,1472030,0,1,1,0,800),(11250,5200001,1472030,0,1,1,0,800),(11251,3110303,1472030,0,1,1,0,800),(11252,4130101,1472030,0,1,1,0,800),(11253,5120506,1472030,0,1,1,0,800),(11254,1130100,1472032,0,1,1,0,800),(11255,4230111,1472032,0,1,1,0,800),(11256,4230112,1472032,0,1,1,0,800),(11257,7130102,1472032,0,1,1,0,800),(11258,3210100,1472032,0,1,1,0,800),(11259,2230102,1472032,0,1,1,0,800),(11260,4130100,1472032,0,1,1,0,800),(11261,9400570,1472032,0,1,1,0,800),(11262,3230306,1472032,0,1,1,0,800),(11263,6130203,1472032,0,1,1,0,800),(11264,7130000,1472032,0,1,1,0,800),(11265,8140002,1472032,0,1,1,0,800),(11266,3230200,1462014,0,1,1,0,800),(11267,4230109,1462014,0,1,1,0,800),(11268,2230102,1462014,0,1,1,0,800),(11269,9400570,1462014,0,1,1,0,800),(11270,5300100,1462019,0,1,1,0,800),(11271,4230109,1462019,0,1,1,0,800),(11272,4230110,1462019,0,1,1,0,800),(11273,9400570,1462019,0,1,1,0,800),(11274,5400000,1462019,0,1,1,0,800),(11275,4230505,1462019,0,1,1,0,800),(11276,6230602,1462019,0,1,1,0,800),(11277,7110301,1462019,0,1,1,0,800),(11278,7140000,1462019,0,1,1,0,800),(11279,2230102,1332025,0,1,1,0,800),(11280,8140500,1332025,0,1,1,0,800),(11281,2230103,1332025,0,1,1,0,800),(11282,4230101,1332025,0,1,1,0,800),(11283,9400570,1332025,0,1,1,0,800),(11284,3100101,1332025,0,1,1,0,800),(11285,4230117,1332025,0,1,1,0,800),(11286,5110302,1332025,0,1,1,0,800),(11287,7130500,1332025,0,1,1,0,800),(11288,7130200,1332025,0,1,1,0,800),(11289,9400570,1302020,0,1,1,0,800),(11652,6110300,1382039,0,1,1,0,800),(11651,5100002,1382039,0,1,1,0,800),(11650,6230300,1332056,0,1,1,0,800),(11649,5120505,1332056,0,1,1,0,800),(11648,5120502,1332056,0,1,1,0,800),(11647,5110302,1332056,0,1,1,0,800),(11646,5100005,1332056,0,1,1,0,800),(11297,9400512,1302030,0,1,1,0,800),(11298,3000005,1302030,0,1,1,0,800),(11299,4230102,1302030,0,1,1,0,800),(11300,9400570,1302030,0,1,1,0,800),(11301,3110102,1302030,0,1,1,0,800),(11302,4230124,1302030,0,1,1,0,800),(11303,5150001,1302030,0,1,1,0,800),(11304,6400000,1302030,0,1,1,0,800),(11305,4230105,1442024,0,1,1,0,800),(11306,3110100,1442024,0,1,1,0,800),(11307,8110300,1442024,0,1,1,0,800),(11308,9400570,1442024,0,1,1,0,800),(11309,3230100,1442024,0,1,1,0,800),(11310,4230300,1442024,0,1,1,0,800),(11311,6130207,1442024,0,1,1,0,800),(11312,7130002,1442024,0,1,1,0,800),(11313,3230305,1432012,0,1,1,0,800),(11314,6230300,1432012,0,1,1,0,800),(11315,2230102,1432012,0,1,1,0,800),(11316,9400570,1432012,0,1,1,0,800),(11317,3230200,1432012,0,1,1,0,800),(11318,4230118,1432012,0,1,1,0,800),(11319,6130202,1432012,0,1,1,0,800),(11320,6110300,1432012,0,1,1,0,800),(11321,7130004,1432012,0,1,1,0,800),(11322,7130300,1382009,0,1,1,0,800),(11323,3000000,1382009,0,1,1,0,800),(11324,3110100,1382009,0,1,1,0,800),(11325,9400570,1382009,0,1,1,0,800),(11326,2230103,1382009,0,1,1,0,800),(11327,2100107,1382009,0,1,1,0,800),(11328,3210100,1382009,0,1,1,0,800),(11329,4230502,1382009,0,1,1,0,800),(11804,9420530,1482007,0,1,1,0,800),(11803,9420530,1002166,0,1,1,0,800),(11802,9420530,1002212,0,1,1,0,800),(11801,9420530,1032012,0,1,1,0,800),(11800,9420530,1060080,0,1,1,0,800),(11799,9420530,1040091,0,1,1,0,800),(11798,9420530,1051010,0,1,1,0,800),(11797,9420530,1051006,0,1,1,0,800),(11796,9420530,1082028,0,1,1,0,800),(11795,9420530,1092008,0,1,1,0,800),(11774,9420534,1082104,0,1,1,0,800),(11773,9420534,1072041,0,1,1,0,800),(11772,9420534,1061102,0,1,1,0,800),(11771,9420534,1041103,0,1,1,0,800),(11770,9420534,1050068,0,1,1,0,800),(11769,9420534,1050067,0,1,1,0,800),(11768,9420534,1061077,0,1,1,0,800),(11767,9420534,1032011,0,1,1,0,800),(11766,9420534,1472016,0,1,1,0,800),(11765,9420534,1442037,0,1,1,0,800),(11764,9420534,2044701,0,1,1,0,1000),(11763,9420534,4130013,0,1,1,0,5000),(11746,9420536,1051079,0,1,1,0,800),(11745,9420536,1050082,0,1,1,0,800),(11744,9420536,1050064,0,1,1,0,800),(11743,9420536,1051065,0,1,1,0,800),(11742,9420536,1051058,0,1,1,0,800),(11741,9420536,1050074,0,1,1,0,800),(11740,9420536,1092016,0,1,1,0,800),(11739,9420536,1072154,0,1,1,0,800),(11738,9420536,1072167,0,1,1,0,800),(11737,9420536,1082105,0,1,1,0,800),(11736,9420536,1082097,0,1,1,0,800),(11735,9420536,1382007,0,1,1,0,800),(11722,5130102,1322054,0,1,1,0,800),(11721,5110302,1322054,0,1,1,0,800),(11720,5250002,1422029,0,1,1,0,800),(11719,6230500,1422029,0,1,1,0,800),(11718,6130209,1422029,0,1,1,0,800),(11716,5130105,1422029,0,1,1,0,800),(11715,6110301,1312032,0,1,1,0,800),(11714,5300100,1312032,0,1,1,0,800),(11713,5120506,1312032,0,1,1,0,800),(11712,5120002,1312032,0,1,1,0,800),(11711,5110301,1312032,0,1,1,0,800),(11698,5250002,1092046,0,1,1,0,800),(11697,6300000,1092046,0,1,1,0,800),(11696,5130104,1092046,0,1,1,0,800),(11695,6130209,1092045,0,1,1,0,800),(11690,6130209,1432040,0,1,1,0,800),(11689,6110300,1432040,0,1,1,0,800),(11688,5130104,1432040,0,1,1,0,800),(11687,5120100,1432040,0,1,1,0,800),(11686,5120001,1432040,0,1,1,0,800),(11685,6300000,1402039,0,1,1,0,800),(11684,6130200,1402039,0,1,1,0,800),(11683,5150000,1402039,0,1,1,0,800),(11682,5120506,1402039,0,1,1,0,800),(11672,5120502,1442051,0,1,1,0,800),(11671,5110302,1442051,0,1,1,0,800),(11670,6230601,1482022,0,1,1,0,800),(11669,6230401,1482022,0,1,1,0,800),(11668,5130104,1482022,0,1,1,0,800),(11667,5120003,1482022,0,1,1,0,800),(11666,5100002,1482022,0,1,1,0,800),(11665,7130500,1492022,0,1,1,0,800),(11664,7130402,1492022,0,1,1,0,800),(11663,6300002,1492022,0,1,1,0,800),(11645,6230600,1332055,0,1,1,0,800),(11644,6230400,1332055,0,1,1,0,800),(11643,6130204,1332055,0,1,1,0,800),(11642,6110300,1332055,0,1,1,0,800),(11641,5150001,1332055,0,1,1,0,800),(11640,6230601,1462040,0,1,1,0,800),(11639,6130209,1462040,0,1,1,0,800),(11638,5140000,1462040,0,1,1,0,800),(11629,6220001,1472055,0,1,1,0,800),(11628,6220000,1472055,0,1,1,0,800),(11627,5120500,1472055,0,1,1,0,800),(11626,5120000,1472055,0,1,1,0,800),(11625,9001006,4031856,0,1,1,0,700000),(11624,8190003,4031461,0,1,1,6169,1000),(11623,9400218,4001106,0,1,25,0,999999),(11622,9400217,4001106,0,1,2,0,999999),(11613,2110200,4032390,0,1,1,2248,100000),(11612,8140200,1382012,0,1,1,0,800),(11611,7130600,1382012,0,1,1,0,800),(11610,5100004,1382012,0,1,1,0,800),(11609,4230123,1382012,0,1,1,0,800),(11608,5300001,1382012,0,1,1,0,800),(11607,9400570,1382012,0,1,1,0,800),(11606,2110200,1382012,0,1,1,0,800),(11597,6300001,1492021,0,1,1,0,800),(11596,3230102,1492021,0,1,1,0,800),(11595,3000006,1492021,0,1,1,0,800),(11594,5130101,1492020,0,1,1,0,800),(11593,5200002,1492020,0,1,1,0,800),(11592,1140100,1492020,0,1,1,0,800),(11591,7160000,1482021,0,1,1,0,800),(11590,7130501,1482021,0,1,1,0,800),(11589,6130208,1482021,0,1,1,0,800),(11579,4230503,1422014,0,1,1,0,800),(11578,3230302,1422014,0,1,1,0,800),(11577,9400570,1422014,0,1,1,0,800),(11576,7130001,1422014,0,1,1,0,800),(11575,7130000,1422014,0,1,1,0,800),(11574,3000005,1422014,0,1,1,0,800),(11573,5130100,1422014,0,1,1,0,800),(11572,7130100,1422014,0,1,1,0,800),(11794,9420530,1472013,0,1,1,0,800),(11793,9420530,1462007,0,1,1,0,800),(11792,9420530,1452007,0,1,1,0,800),(11791,9420530,1432004,0,1,1,0,800),(11790,9420530,1382019,0,1,1,0,800),(11789,9420530,2041002,0,1,1,0,1000),(11788,9420530,2040901,0,1,1,0,1000),(11787,9420530,2020014,0,1,1,0,10000),(11759,9420534,4006000,0,1,1,0,5000),(11756,9420534,4000472,0,1,1,0,300000),(11755,9420536,2332000,0,1,1,0,500),(11754,9420536,2330004,0,1,1,0,100),(11753,9420536,1482009,0,1,1,0,800),(11752,9420536,1082204,0,1,1,0,800),(11751,9420536,1072309,0,1,1,0,800),(11750,9420536,1002095,0,1,1,0,800),(11749,9420536,1002273,0,1,1,0,800),(11748,9420536,1002278,0,1,1,0,800),(11747,9420536,1032021,0,1,1,0,800),(11734,9420536,1332019,0,1,1,0,800),(11733,9420536,1462011,0,1,1,0,800),(11732,9420536,1452011,0,1,1,0,800),(11731,9420536,1422005,0,1,1,0,800),(11730,9420536,2040805,0,1,1,0,100),(11728,9420536,2022003,0,1,1,0,333333),(11727,9420536,2070008,0,1,1,0,200),(11726,9420536,4000474,0,1,1,0,300000),(11725,6130203,1322054,0,1,1,0,800),(11724,6130100,1322054,0,1,1,0,800),(11723,5130108,1322054,0,1,1,0,800),(11710,6230601,1412027,0,1,1,0,800),(11709,6230401,1412027,0,1,1,0,800),(11708,6130209,1412027,0,1,1,0,800),(11707,6110301,1412027,0,1,1,0,800),(11706,5120506,1412027,0,1,1,0,800),(11705,6230601,1092047,0,1,1,0,800),(11704,6230401,1092047,0,1,1,0,800),(11703,6220001,1092047,0,1,1,0,800),(11702,6230602,1092047,0,1,1,0,800),(11701,5140000,1092047,0,1,1,0,800),(11700,5130101,1092046,0,1,1,0,800),(11699,6110300,1092046,0,1,1,0,800),(11694,5120500,1092045,0,1,1,0,800),(11693,6300001,1092045,0,1,1,0,800),(11692,6230300,1092045,0,1,1,0,800),(11691,6230401,1092045,0,1,1,0,800),(11681,5120002,1402039,0,1,1,0,800),(11680,5250000,1302064,0,1,1,0,800),(11679,5130104,1302064,0,1,1,0,800),(11678,5130101,1302064,0,1,1,0,800),(11677,5120506,1302064,0,1,1,0,800),(11676,5120502,1302064,0,1,1,0,800),(11675,5250002,1442051,0,1,1,0,800),(11674,5250001,1442051,0,1,1,0,800),(11673,5250000,1442051,0,1,1,0,800),(11662,6230500,1492022,0,1,1,0,800),(11661,5220003,1492022,0,1,1,0,800),(11660,6230401,1372034,0,1,1,0,800),(11659,6230400,1372034,0,1,1,0,800),(11658,5250000,1372034,0,1,1,0,800),(11657,5120503,1372034,0,1,1,0,800),(11656,5100004,1372034,0,1,1,0,800),(11655,6230201,1382039,0,1,1,0,800),(14303,8200006,2290151,0,1,1,0,300),(11653,6130204,1382039,0,1,1,0,800),(11637,5130102,1462040,0,1,1,0,800),(11636,5130101,1462040,0,1,1,0,800),(11635,6300001,1452045,0,1,1,0,800),(11634,6230602,1452045,0,1,1,0,800),(11633,6230100,1452045,0,1,1,0,800),(11632,6130209,1452045,0,1,1,0,800),(11631,5130108,1452045,0,1,1,0,800),(11630,6230400,1472055,0,1,1,0,800),(11621,9400216,4001106,0,1,2,0,999999),(11620,9400215,4001106,0,1,2,0,999999),(11619,9400214,4001106,0,1,2,0,999999),(11618,9400213,4001106,0,1,2,0,999999),(11617,9400212,4001106,0,1,1,0,999999),(11616,9400211,4001106,0,1,1,0,999999),(11615,9400209,4001106,0,1,2,0,999999),(11614,9400209,4001106,0,1,2,0,999999),(11605,3110102,1382012,0,1,1,0,800),(11604,2230107,1092030,0,1,1,0,800),(11603,1210103,1092030,0,1,1,0,800),(11602,4230114,1092030,0,1,1,0,800),(11601,5100002,1092030,0,1,1,0,800),(11600,4230600,1092030,0,1,1,0,800),(11599,8140110,1492021,0,1,1,0,800),(11598,6300100,1492021,0,1,1,0,800),(11588,4240000,1482021,0,1,1,0,800),(11587,4230500,1482021,0,1,1,0,800),(11586,5130104,1482020,0,1,1,0,800),(11585,4230116,1482020,0,1,1,0,800),(11584,3230400,1482020,0,1,1,0,800),(11583,2230101,1482020,0,1,1,0,800),(11582,7130003,1422014,0,1,1,0,800),(11581,7130104,1422014,0,1,1,0,800),(11580,5130107,1422014,0,1,1,0,800),(11571,4230100,1422014,0,1,1,0,800),(11570,7130601,1412011,0,1,1,0,800),(11569,6110301,1412011,0,1,1,0,800),(11568,4230120,1412011,0,1,1,0,800),(11567,3210205,1412011,0,1,1,0,800),(11566,9400570,1412011,0,1,1,0,800),(11565,7130001,1412011,0,1,1,0,800),(11564,2230102,1412011,0,1,1,0,800),(11783,9420530,2002009,0,1,1,0,333333),(11780,9420530,4000468,0,1,1,0,300000),(11779,9420534,2044901,0,1,1,0,1000),(11778,9420534,2330003,0,1,1,0,100),(11777,9420534,1002254,0,1,1,0,800),(11776,9420534,1382015,0,1,1,0,800),(11775,9420534,1452010,0,1,1,0,800),(11805,9420530,1492007,0,1,1,0,800),(11806,9420015,4000420,0,1,1,0,300000),(11807,9420015,4000421,0,1,1,0,300000),(11808,9420500,4000369,0,1,1,0,300000),(11809,9420500,4000370,0,1,1,0,300000),(11811,9420500,2002002,0,1,1,0,333333),(11812,9420500,2044002,0,1,1,0,1000),(11813,9420500,1332001,0,1,1,0,800),(11814,9420500,1382002,0,1,1,0,800),(11815,9420500,1002178,0,1,1,0,800),(11816,9420500,2060000,0,1,1,0,10000),(11819,9420500,2020028,0,1,1,0,20000),(11821,9420500,1060052,0,1,1,0,800),(11822,9420500,1051006,0,1,1,0,800),(11823,9420500,1051007,0,1,1,0,800),(11824,9420500,1002142,0,1,1,0,800),(11825,9420500,2061000,0,1,1,0,10000),(11826,9420500,1422008,0,1,1,0,800),(11827,9420500,4030012,0,1,1,0,300),(11828,9420500,1052095,0,1,1,0,800),(11829,9420500,2330001,0,1,1,0,100),(11830,9420501,4000372,0,1,1,0,300000),(11833,9420501,404000,0,1,1,0,800),(11835,9420501,2043301,0,1,1,0,1000),(11836,9420501,1072103,0,1,1,0,800),(11837,9420501,1032008,0,1,1,0,800),(11838,9420501,1050011,0,1,1,0,800),(11839,9420501,1040044,0,1,1,0,800),(11840,9420501,1060033,0,1,1,0,800),(11841,9420501,1302017,0,1,1,0,800),(11842,9420501,2048005,0,1,1,0,1000),(11843,9420501,2020028,0,1,1,0,20000),(11844,9420501,1050051,0,1,1,0,800),(11845,9420501,1040099,0,1,1,0,800),(11846,9420501,1060088,0,1,1,0,800),(11847,9420501,1050058,0,1,1,0,800),(11848,9420501,1332020,0,1,1,0,800),(11849,9420501,4006001,0,1,1,0,5000),(11850,9420501,4030012,0,1,1,0,300),(11851,9420501,1072297,0,1,1,0,800),(11852,9420501,1482001,0,1,1,0,800),(11853,9420501,1482005,0,1,1,0,800),(11854,9420501,1492005,0,1,1,0,800),(11855,9420502,4000366,0,1,1,0,300000),(11856,9420502,4000367,0,1,1,0,300000),(11857,9420502,400000,0,1,1,0,10000),(11858,9420502,2043202,0,1,1,0,1000),(11859,9420502,1372001,0,1,1,0,800),(11861,9420502,1072008,0,1,1,0,800),(11862,9420502,2060000,0,1,1,0,10000),(11865,9420502,1312016,0,1,1,0,800),(11866,9420502,1051008,0,1,1,0,800),(11867,9420502,1051009,0,1,1,0,800),(11868,9420502,2020028,0,1,1,0,20000),(11869,9420502,1092007,0,1,1,0,800),(11870,9420502,1002141,0,1,1,0,800),(11871,9420502,1002177,0,1,1,0,800),(11872,9420502,1040074,0,1,1,0,800),(11873,9420502,1060063,0,1,1,0,800),(11874,9420502,2061000,0,1,1,0,10000),(11875,9420502,1402009,0,1,1,0,800),(11876,9420502,1002610,0,1,1,0,800),(11877,9420502,2330000,0,1,1,0,100),(11878,9420503,4000371,0,1,1,0,300000),(11879,9420503,4000370,0,1,1,0,300000),(11880,9420503,1061047,0,1,1,0,800),(11881,9420503,1061048,0,1,1,0,800),(11882,9420503,1061049,0,1,1,0,800),(11883,9420503,2070001,0,1,1,0,200),(11884,9420503,1060050,0,1,1,0,800),(11885,9420503,1060051,0,1,1,0,800),(11886,9420503,4001000,0,1,1,0,5000),(11887,9420503,1040061,0,1,1,0,800),(11888,9420503,1002137,0,1,1,0,800),(11891,9420503,1002153,0,1,1,0,800),(11892,9420503,1002181,0,1,1,0,800),(11893,9420503,2020028,0,1,1,0,20000),(11894,9420503,404000,0,1,1,0,800),(11896,9420503,1041075,0,1,1,0,800),(11897,9420503,1061070,0,1,1,0,800),(11898,9420503,1002613,0,1,1,0,800),(11899,9420504,4000377,0,1,1,0,300000),(11905,9420504,404000,0,1,1,0,800),(11906,9420504,1041086,0,1,1,0,800),(11907,9420504,1061085,0,1,1,0,800),(11908,9420504,1302013,0,1,1,0,800),(11909,9420504,1002083,0,1,1,0,800),(11910,9420504,1032007,0,1,1,0,800),(11911,9420504,1041080,0,1,1,0,800),(11912,9420504,1061079,0,1,1,0,800),(11913,9420504,1040094,0,1,1,0,800),(11914,9420504,1060083,0,1,1,0,800),(11915,9420504,1002211,0,1,1,0,800),(11916,9420504,1002212,0,1,1,0,800),(11917,9420504,2020028,0,1,1,0,20000),(11918,9420504,1041092,0,1,1,0,800),(11919,9420504,1061091,0,1,1,0,800),(11920,9420504,1102003,0,1,1,0,800),(11921,9420504,4006001,0,1,1,0,5000),(11922,9420504,4030012,0,1,1,0,300),(11923,9420504,1072291,0,1,1,0,800),(11924,9420504,1082186,0,1,1,0,800),(11925,9420504,1482003,0,1,1,0,333333),(11926,9420504,2331000,0,1,1,0,500),(11927,9420505,4000378,0,1,1,0,300000),(11929,9420505,2002004,0,1,1,0,10000),(11930,9420505,1032002,0,1,1,0,800),(11931,9420505,1041014,0,1,1,0,800),(11932,9420505,1002185,0,1,1,0,800),(11933,9420505,1002167,0,1,1,0,800),(11934,9420505,2020028,0,1,1,0,20000),(11937,9420505,1002036,0,1,1,0,800),(11939,9420505,2070003,0,1,1,0,400),(11940,9420505,1041065,0,1,1,0,800),(11941,9420505,1061060,0,1,1,0,800),(11942,9420505,1051038,0,1,1,0,800),(11943,9420505,1051039,0,1,1,0,800),(11944,9420505,4030012,0,1,1,0,300),(11945,9420505,1002616,0,1,1,0,800),(11946,9420505,1052101,0,1,1,0,800),(11947,9420505,1082183,0,1,1,0,800),(11948,9420506,4000368,0,1,1,0,300000),(11950,9420506,2002000,0,1,1,0,10000),(11951,9420506,2044302,0,1,1,0,1000),(11952,9420506,1032000,0,1,1,0,800),(11953,9420506,1002179,0,1,1,0,800),(11954,9420506,1050030,0,1,1,0,800),(11955,9420506,1050031,0,1,1,0,800),(11956,9420506,2060000,0,1,1,0,10000),(11959,9420506,2020028,0,1,1,0,20000),(11960,9420506,1432003,0,1,1,0,800),(11962,9420506,1002035,0,1,1,0,800),(11963,9420506,2061000,0,1,1,0,10000),(11964,9420506,1312007,0,1,1,0,800),(11965,9420506,1040021,0,1,1,0,800),(11966,9420506,1040081,0,1,1,0,800),(11967,9420506,1060070,0,1,1,0,800),(11968,9420507,4000374,0,1,1,0,300000),(11969,9420507,4000375,0,1,1,0,300000),(11970,9420507,4000376,0,1,1,0,300000),(11975,9420507,1302016,0,1,1,0,800),(11976,9420507,1051032,0,1,1,0,800),(11977,9420507,1051033,0,1,1,0,800),(11978,9420507,2043201,0,1,1,0,1000),(11979,9420507,1041027,0,1,1,0,800),(11980,9420507,1061025,0,1,1,0,800),(11981,9420507,1040089,0,1,1,0,800),(11982,9420507,1060078,0,1,1,0,800),(11983,9420507,2020028,0,1,1,0,20000),(11984,9420507,1002213,0,1,1,0,800),(11985,9420507,1002214,0,1,1,0,800),(11986,9420507,1002216,0,1,1,0,800),(11987,9420507,1050053,0,1,1,0,800),(11988,9420507,1050054,0,1,1,0,800),(11989,9420507,1002242,0,1,1,0,800),(11990,9420507,1002243,0,1,1,0,800),(11991,9420507,1002619,0,1,1,0,800),(11992,9420507,1052104,0,1,1,0,800),(11993,9420507,1482002,0,1,1,0,800),(11994,9420507,1492002,0,1,1,0,800),(11995,9420507,2044802,0,1,1,0,1000),(11996,9420508,4000373,0,1,1,0,300000),(12002,9420508,2060000,0,1,1,0,10000),(12003,9420508,2061000,0,1,1,0,10000),(12004,9420508,1060074,0,1,1,0,800),(12005,9420508,1002128,0,1,1,0,800),(12006,9420508,1072054,0,1,1,0,800),(12007,9420508,1051010,0,1,1,0,800),(12008,9420508,2020028,0,1,1,0,20000),(12009,9420508,1041078,0,1,1,0,800),(12010,9420508,1061077,0,1,1,0,800),(12011,9420508,1040086,0,1,1,0,800),(12012,9420508,1040095,0,1,1,0,800),(12013,9420508,1060084,0,1,1,0,800),(12014,9420508,1041087,0,1,1,0,800),(12015,9420508,1061086,0,1,1,0,800),(12016,9420508,1002217,0,1,1,0,800),(12017,9420508,1072288,0,1,1,0,800),(12018,9420508,1072294,0,1,1,0,800),(12019,9420508,1482000,0,1,1,0,800),(12020,9420508,1482004,0,1,1,0,800),(12021,9420508,1482006,0,1,1,0,800),(12022,9420508,1492004,0,1,1,0,800),(12023,9420508,1492006,0,1,1,0,800),(12024,9420509,4000380,0,1,1,0,300000),(12025,9420509,1050039,0,1,1,0,800),(12029,9420509,1051001,0,1,1,0,800),(12030,9420509,1051014,0,1,1,0,800),(12032,9420509,2070004,0,1,1,0,300),(12033,9420509,1060064,0,1,1,0,800),(12034,9420509,1040075,0,1,1,0,800),(12035,9420509,2044201,0,1,1,0,1000),(12036,9420509,2020028,0,1,1,0,10000),(12037,9420509,1402007,0,1,1,0,800),(12038,9420509,1050036,0,1,1,0,800),(12039,9420509,1050037,0,1,1,0,800),(12040,9420509,4001005,0,1,1,0,5000),(12041,9420509,1050059,0,1,1,0,800),(12042,9420509,1050060,0,1,1,0,800),(12043,9420509,1041093,0,1,1,0,800),(12044,9420509,1061092,0,1,1,0,800),(12045,9420509,1002631,0,1,1,0,800),(12046,9420509,1052116,0,1,1,0,800),(12047,9420509,2330002,0,1,1,0,100),(12048,9420510,4000379,0,1,1,0,300000),(12049,9420510,1061071,0,1,1,0,800),(12053,9420510,1040109,0,1,1,0,800),(12054,9420510,1060098,0,1,1,0,800),(12055,9420510,1041068,0,1,1,0,800),(12056,9420510,1061063,0,1,1,0,800),(12057,9420510,1032011,0,1,1,0,800),(12058,9420510,1452008,0,1,1,0,800),(12059,9420510,1102017,0,1,1,0,800),(12060,9420510,1312008,0,1,1,0,800),(12061,9420510,2043701,0,1,1,0,100),(12062,9420510,1041076,0,1,1,0,800),(12063,9420510,1051030,0,1,1,0,800),(12064,9420510,2020028,0,1,1,0,5000),(12065,9420510,1051031,0,1,1,0,800),(12066,9420510,1051034,0,1,1,0,800),(12067,9420510,1002209,0,1,1,0,800),(12068,9420510,1002210,0,1,1,0,800),(12069,9420510,1051046,0,1,1,0,800),(12070,9420510,1051047,0,1,1,0,800),(12071,9420510,4030012,0,1,1,0,300),(12072,9420510,1492001,0,1,1,0,800),(12073,9420511,4000382,0,1,1,0,300000),(12078,9420511,2070005,0,1,1,0,300),(12079,9420511,1041083,0,1,1,0,800),(12080,9420511,1061082,0,1,1,0,800),(12081,9420511,1072090,0,1,1,0,800),(12082,9420511,1041079,0,1,1,0,800),(12083,9420511,1061078,0,1,1,0,800),(12084,9420511,4001006,0,1,1,0,1000),(12085,9420511,2020028,0,1,1,0,20000),(12086,9420511,1002215,0,1,1,0,800),(12087,9420511,1050055,0,1,1,0,800),(12088,9420511,1102015,0,1,1,0,800),(12089,9420511,1050056,0,1,1,0,800),(12090,9420511,1041098,0,1,1,0,800),(12091,9420511,1482008,0,1,1,0,800),(12092,9420511,1492008,0,1,1,0,800),(12093,9420512,4000383,0,1,1,0,300000),(12098,9420512,4006000,0,1,1,0,5000),(12100,9420512,2020028,0,1,1,0,20000),(12101,9420512,1040093,0,1,1,0,800),(12102,9420512,1060082,0,1,1,0,800),(12103,9420512,1082082,0,1,1,0,800),(12104,9420512,1302011,0,1,1,0,800),(12105,9420512,1312009,0,1,1,0,800),(12106,9420512,1040089,0,1,1,0,800),(12107,9420512,1060078,0,1,1,0,800),(12108,9420512,2041022,0,1,1,0,1000),(12109,9420512,2043301,0,1,1,0,1000),(12110,9420512,1032015,0,1,1,0,800),(12111,9420512,1050093,0,1,1,0,800),(12112,9420512,1002637,0,1,1,0,800),(12113,9420512,1052122,0,1,1,0,800),(12114,9420512,2330003,0,1,1,0,100),(12115,9420513,4000384,0,1,1,0,300000),(12116,9420513,4000385,0,1,1,0,300000),(12117,9420513,2020013,0,1,1,0,333333),(12118,9420513,2020015,0,1,1,0,333333),(12120,9420513,1072178,0,1,1,0,4000),(12121,9420513,1040112,0,1,1,0,4000),(12122,9420513,1041120,0,1,1,0,4000),(12123,9420513,1061119,0,1,1,0,4000),(12124,9420513,1051097,0,1,1,0,3000),(12125,9420513,1060106,0,1,1,0,4000),(12126,9420513,1041118,0,1,1,0,4000),(12127,9420513,1072198,0,1,1,0,4000),(12128,9420513,1312015,0,1,1,0,3000),(12129,9420513,1332026,0,1,1,0,25000),(12130,9420513,1462018,0,1,1,0,25000),(12131,9420513,1372009,0,1,1,0,3000),(12132,9420513,2041022,0,1,1,0,1000),(12134,9420513,2290100,0,1,1,0,4000),(12140,9420514,2044702,0,1,1,0,1000),(12141,9420514,2043802,0,1,1,0,1000),(12142,9420514,4006000,0,1,1,0,5000),(12145,9420514,1050083,0,1,1,0,800),(12146,9420514,1082119,0,1,1,0,800),(12147,9420514,1072185,0,1,1,0,800),(12148,9420514,1002330,0,1,1,0,800),(12149,9420514,1092027,0,1,1,0,800),(12150,9420514,1452015,0,1,1,0,800),(12151,9420514,1462013,0,1,1,0,800),(12152,9420514,1432010,0,1,1,0,800),(12153,9420514,1302056,0,1,1,0,800),(12154,9420514,1372010,0,1,1,0,800),(12155,9420514,1332052,0,1,1,0,800),(12156,9420514,1002640,0,1,1,0,800),(12157,9420514,1052125,0,1,1,0,800),(12158,9420514,1082207,0,1,1,0,800),(12159,9420514,2330004,0,1,1,0,100),(12167,9420516,4006001,0,1,1,0,5000),(12168,9420516,1002365,0,1,1,0,800),(12169,9420516,1050089,0,1,1,0,800),(12170,9420516,1041118,0,1,1,0,800),(12171,9420516,1061116,0,1,1,0,800),(12172,9420516,1082129,0,1,1,0,800),(12173,9420516,1072223,0,1,1,0,800),(12174,9420516,1452017,0,1,1,0,800),(12175,9420516,2040701,0,1,1,0,1000),(12176,9420516,2040516,0,1,1,0,1000),(12177,9420516,2043002,0,1,1,0,1000),(12183,9420515,2048004,0,1,1,0,1000),(12184,9420515,2040901,0,1,1,0,1000),(12185,9420515,4006001,0,1,1,0,5000),(12188,9420515,1082117,0,1,1,0,800),(12189,9420515,1072179,0,1,1,0,800),(12190,9420515,1002328,0,1,1,0,800),(12191,9420515,1040109,0,1,1,0,800),(12192,9420515,1060098,0,1,1,0,800),(12193,9420515,1452014,0,1,1,0,800),(12194,9420515,1382008,0,1,1,0,800),(12195,9420515,1032023,0,1,1,0,800),(12196,9420515,1092026,0,1,1,0,800),(12197,9420515,1312030,0,1,1,0,800),(12198,9420515,1402035,0,1,1,0,800),(12199,9420515,1472053,0,1,1,0,800),(13814,9000002,4031013,0,1,1,0,700000),(12201,9420517,2022003,0,1,1,0,333333),(12207,9420517,4006001,0,1,1,0,5000),(12208,9420517,4006000,0,1,1,0,5000),(12209,9420517,1002406,0,1,1,0,800),(12210,9420517,1051101,0,1,1,0,800),(12211,9420517,1050097,0,1,1,0,800),(12212,9420517,1082139,0,1,1,0,800),(12213,9420517,1072225,0,1,1,0,800),(12214,9420517,1032023,0,1,1,0,800),(12215,9420517,1412021,0,1,1,0,800),(12216,9420517,1452019,0,1,1,0,800),(12217,9420517,2043801,0,1,1,0,1000),(12218,9420517,2041023,0,1,1,0,1000),(12219,9420517,2040707,0,1,1,0,1000),(12220,9420517,1082152,0,1,1,0,800),(12230,9420518,2022003,0,1,1,0,333333),(12231,9420518,2020013,0,1,1,0,333333),(12235,9420518,1002530,0,1,1,0,800),(12236,9420518,1050098,0,1,1,0,800),(12237,9420518,1041122,0,1,1,0,800),(12238,9420518,1061121,0,1,1,0,800),(12239,9420518,1051101,0,1,1,0,800),(12240,9420518,1082158,0,1,1,0,800),(12241,9420518,1072208,0,1,1,0,800),(12242,9420518,1092027,0,1,1,0,800),(12243,9420518,1402016,0,1,1,0,800),(12244,9420518,1382035,0,1,1,0,800),(12245,9420518,2040302,0,1,1,0,1000),(12246,9420518,2040501,0,1,1,0,1000),(12248,9420518,1082136,0,1,1,0,800),(12249,9420518,2044902,0,1,1,0,1000),(13815,9001004,4031059,0,1,1,0,999999),(12252,9420519,2022003,0,1,1,0,333333),(12258,9420519,4006001,0,1,1,0,5000),(12259,9420519,4006000,0,1,1,0,5000),(12260,9420519,1002380,0,1,1,0,800),(12261,9420519,1051102,0,1,1,0,800),(12262,9420519,1040121,0,1,1,0,800),(12263,9420519,1060109,0,1,1,0,800),(12264,9420519,1082151,0,1,1,0,800),(12265,9420519,1072215,0,1,1,0,800),(12266,9420519,1322045,0,1,1,0,800),(12267,9420519,1302056,0,1,1,0,800),(12268,9420519,2041004,0,1,1,0,1000),(12269,9420519,2041013,0,1,1,0,1000),(12270,9420519,2044201,0,1,1,0,1000),(12271,9420519,2330005,0,1,1,0,100),(12273,9420522,2020013,0,1,1,0,333333),(12274,9420522,2020015,0,1,1,0,333333),(12276,9420522,1302056,0,1,1,0,3000),(12277,9420522,1312030,0,1,1,0,3000),(12278,9420522,1322045,0,1,1,0,3000),(12279,9420522,1332051,0,1,1,0,25000),(12280,9420522,1332052,0,1,1,0,25000),(12281,9420522,1372010,0,1,1,0,3000),(12282,9420522,1382035,0,1,1,0,3000),(12283,9420522,1402035,0,1,1,0,3000),(12284,9420522,1412021,0,1,1,0,3000),(12285,9420522,1422027,0,1,1,0,3000),(12286,9420522,1432030,0,1,1,0,25000),(12287,9420522,1442044,0,1,1,0,3000),(12288,9420522,1452019,0,1,1,0,25000),(12289,9420522,1452020,0,1,1,0,25000),(12290,9420522,1462015,0,1,1,0,25000),(12291,9420522,1462016,0,1,1,0,25000),(12292,9420522,1472053,0,1,1,0,13000),(12294,9420522,2290028,0,1,1,0,4000),(12295,9420522,2290037,0,1,1,0,4000),(12296,9420522,2290043,0,1,1,0,4000),(12297,9420522,2290066,0,1,1,0,4000),(12298,9420522,2290089,0,1,1,0,4000),(12299,9420522,2290091,0,1,1,0,4000),(12300,9420522,2290011,0,1,1,0,4000),(12301,9420522,2290001,0,1,1,0,4000),(12302,9420522,2290025,0,1,1,0,4000),(12303,9420522,2290083,0,1,1,0,4000),(12304,9420522,2290000,0,1,1,0,4000),(12305,9420522,2290082,0,1,1,0,4000),(12306,9420522,4000435,0,1,1,0,300000),(12307,9420522,2290107,0,1,1,0,4000),(12308,9420527,4000465,0,1,1,0,300000),(12310,9420527,2020028,0,1,1,0,3000),(12311,9420527,401000,0,1,1,0,800),(12313,9420527,2002010,0,1,1,0,3000),(12314,9420527,2040101,0,1,1,0,1000),(12315,9420527,2040311,0,1,1,0,1000),(12316,9420527,4130010,0,1,1,0,3000),(12317,9420527,1332015,0,1,1,0,800),(12318,9420527,1302013,0,1,1,0,800),(12319,9420527,1472017,0,1,1,0,800),(12320,9420527,1082064,0,1,1,0,800),(12321,9420527,1072124,0,1,1,0,800),(12322,9420527,1072055,0,1,1,0,800),(12323,9420527,1050047,0,1,1,0,800),(12324,9420527,1050046,0,1,1,0,800),(12325,9420527,1051039,0,1,1,0,800),(12326,9420527,2060001,0,1,1,0,3000),(12327,9420527,2061001,0,1,1,0,3000),(12328,9420527,1002625,0,1,1,0,800),(12329,9420527,1052110,0,1,1,0,800),(12330,9420527,1082192,0,1,1,0,800),(12331,9420527,1492000,0,1,1,0,800),(12332,9420527,2330000,0,1,1,0,100),(12333,9420528,4000466,0,1,1,0,300000),(12334,9420528,2020006,0,1,1,0,333333),(12335,9420528,400010,0,1,1,0,333333),(12336,9420528,2050004,0,1,1,0,5000),(12339,9420528,2040516,0,1,1,0,1000),(12340,9420528,2044501,0,1,1,0,1000),(12341,9420528,4131008,0,1,1,0,5000),(12342,9420528,4130000,0,1,1,0,5000),(12343,9420528,2040704,0,1,1,0,1000),(12345,9420528,1302016,0,1,1,0,800),(12346,9420528,1322017,0,1,1,0,800),(12347,9420528,1332016,0,1,1,0,800),(12348,9420528,1372012,0,1,1,0,800),(12349,9420528,1102003,0,1,1,0,800),(12350,9420528,1082050,0,1,1,0,800),(12351,9420528,1060078,0,1,1,0,800),(12352,9420528,1072134,0,1,1,0,800),(12353,9420528,1032018,0,1,1,0,800),(12354,9420528,1002024,0,1,1,0,800),(12355,9420528,4006000,0,1,1,0,5000),(12356,9420528,1002628,0,1,1,0,800),(12357,9420528,1052113,0,1,1,0,800),(12358,9420528,1072285,0,1,1,0,800),(12359,9420528,1072300,0,1,1,0,800),(12360,9420528,1082195,0,1,1,0,800),(12361,9420528,2330001,0,1,1,0,100),(12362,9420529,4000467,0,1,1,0,300000),(12364,9420529,4006001,0,1,1,0,5000),(12365,9420529,2040005,0,1,1,0,1000),(12366,9420529,2043801,0,1,1,0,1000),(12368,9420529,4003002,0,1,1,0,20000),(12369,9420529,1402010,0,1,1,0,800),(12370,9420529,1412003,0,1,1,0,800),(12371,9420529,1452008,0,1,1,0,800),(12372,9420529,1462006,0,1,1,0,800),(12373,9420529,1472021,0,1,1,0,800),(12374,9420529,2040302,0,1,1,0,1000),(12375,9420529,1092009,0,1,1,0,800),(12376,9420529,1082083,0,1,1,0,800),(12377,9420529,1082072,0,1,1,0,800),(12378,9420529,1040089,0,1,1,0,800),(12379,9420529,1041080,0,1,1,0,800),(12380,9420529,1051030,0,1,1,0,800),(12381,9420529,1051038,0,1,1,0,800),(12382,9420529,1002184,0,1,1,0,800),(12383,9420529,1002099,0,1,1,0,800),(12384,9420529,1002216,0,1,1,0,800),(12385,9420529,1040096,0,1,1,0,800),(12386,9420529,1060085,0,1,1,0,800),(12387,9420529,1052098,0,1,1,0,800),(12388,9420529,1072303,0,1,1,0,800),(12389,9420529,1082198,0,1,1,0,800),(12390,9420531,4000469,0,1,1,0,300000),(12391,9420531,2060001,0,1,1,0,10000),(12392,9420531,2061001,0,1,1,0,10000),(12393,9420531,4003005,0,1,1,0,40000),(12400,9420531,1332017,0,1,1,0,800),(12401,9420531,1302010,0,1,1,0,800),(12402,9420531,1372007,0,1,1,0,800),(12403,9420531,1402003,0,1,1,0,800),(12404,9420531,1412007,0,1,1,0,800),(12405,9420531,1452004,0,1,1,0,800),(12406,9420531,1092012,0,1,1,0,800),(12407,9420531,1082067,0,1,1,0,800),(12408,9420531,1082091,0,1,1,0,800),(12409,9420531,1041081,0,1,1,0,800),(12410,9420531,1061080,0,1,1,0,800),(12411,9420531,1041093,0,1,1,0,800),(12412,9420531,1061092,0,1,1,0,800),(12413,9420531,2040804,0,1,1,0,100),(12414,9420531,2041005,0,1,1,0,1000),(12415,9420531,2330002,0,1,1,0,100),(12416,9420532,4000470,0,1,1,0,300000),(12419,9420532,2043009,0,1,1,0,1000),(12420,9420532,2044102,0,1,1,0,1000),(12421,9420532,1032008,0,1,1,0,800),(12422,9420532,1002243,0,1,1,0,800),(12423,9420532,1002244,0,1,1,0,800),(12424,9420532,1002270,0,1,1,0,800),(12425,9420532,1002155,0,1,1,0,800),(12426,9420532,1051043,0,1,1,0,800),(12427,9420532,1041087,0,1,1,0,800),(12428,9420532,1061086,0,1,1,0,800),(12429,9420532,1041095,0,1,1,0,800),(12430,9420532,1061094,0,1,1,0,800),(12431,9420532,1072149,0,1,1,0,800),(12432,9420532,1072110,0,1,1,0,800),(12433,9420532,1051046,0,1,1,0,800),(12434,9420532,1051047,0,1,1,0,800),(12435,9420532,1102017,0,1,1,0,800),(12436,9420532,1472020,0,1,1,0,800),(12437,9420532,1332021,0,1,1,0,800),(12438,9420532,1332029,0,1,1,0,800),(12439,9420532,1372017,0,1,1,0,800),(12440,9420532,1002622,0,1,1,0,800),(12441,9420532,1052107,0,1,1,0,800),(12442,9420532,1082189,0,1,1,0,800),(12443,9420532,1492003,0,1,1,0,800),(12444,9420533,4000471,0,1,1,0,300000),(12445,9420533,2002004,0,1,1,0,10000),(12446,9420533,400009,0,1,1,0,333333),(12448,9420533,2002011,0,1,1,0,10000),(12449,9420533,2044302,0,1,1,0,1000),(12450,9420533,2048001,0,1,1,0,1000),(12451,9420533,1312009,0,1,1,0,800),(12452,9420533,1322012,0,1,1,0,800),(12453,9420533,1332020,0,1,1,0,800),(12454,9420533,1372008,0,1,1,0,800),(12455,9420533,1402017,0,1,1,0,800),(12456,9420533,1432007,0,1,1,0,800),(12457,9420533,1051023,0,1,1,0,800),(12458,9420533,1051038,0,1,1,0,800),(12459,9420533,1050052,0,1,1,0,800),(12460,9420533,1050039,0,1,1,0,800),(12461,9420533,1040105,0,1,1,0,800),(12462,9420533,1060093,0,1,1,0,800),(12463,9420533,1041096,0,1,1,0,800),(12464,9420533,1061095,0,1,1,0,800),(12465,9420533,1002248,0,1,1,0,800),(12466,9420533,1002249,0,1,1,0,800),(12467,9420533,1002254,0,1,1,0,800),(12468,9420533,1082180,0,1,1,0,800),(12469,9420535,4000473,0,1,1,0,300000),(12470,9420535,4030009,0,1,1,0,300),(12473,9420535,2020028,0,1,1,0,20000),(12474,9420535,4030012,0,1,1,0,300),(12475,9420535,2022003,0,1,1,0,333333),(12476,9420535,2044402,0,1,1,0,1000),(12477,9420535,2043701,0,1,1,0,1000),(12479,9420535,404000,0,1,1,0,800),(12480,9420535,1050060,0,1,1,0,800),(12481,9420535,1041076,0,1,1,0,800),(12482,9420535,1061071,0,1,1,0,800),(12483,9420535,1322007,0,1,1,0,800),(12484,9420535,1442009,0,1,1,0,800),(12485,9420535,1102012,0,1,1,0,800),(12486,9420535,1092029,0,1,1,0,800),(12487,9420535,1072018,0,1,1,0,800),(12488,9420535,1072159,0,1,1,0,800),(12489,9420535,1072161,0,1,1,0,800),(12490,9420535,1051016,0,1,1,0,800),(12491,9420535,1050070,0,1,1,0,800),(12492,9420535,1051055,0,1,1,0,800),(12493,9420535,1032020,0,1,1,0,800),(12494,9420535,1082106,0,1,1,0,800),(12495,9420535,1082093,0,1,1,0,800),(12496,9420535,1492009,0,1,1,0,800),(12497,9420537,4000475,0,1,1,0,300000),(12498,9420537,2022003,0,1,1,0,333333),(12500,9420537,1322009,0,1,1,0,800),(12503,9420537,4006000,0,1,1,0,5000),(12505,9420537,1372015,0,1,1,0,800),(12506,9420537,1102030,0,1,1,0,800),(12507,9420537,1041102,0,1,1,0,800),(12508,9420537,1061101,0,1,1,0,800),(12509,9420537,1050083,0,1,1,0,800),(12510,9420537,1051080,0,1,1,0,800),(12511,9420537,1072155,0,1,1,0,800),(12512,9420537,1072165,0,1,1,0,800),(12513,9420537,1032022,0,1,1,0,800),(12514,9420537,1002252,0,1,1,0,800),(12515,9420537,1002284,0,1,1,0,800),(12516,9420537,1002289,0,1,1,0,800),(12517,9420537,1452011,0,1,1,0,800),(12518,9420537,1462013,0,1,1,0,800),(12519,9420537,1472027,0,1,1,0,800),(12520,9420537,2043301,0,1,1,0,1000),(12521,9420537,2040513,0,1,1,0,1000),(12522,9420537,1002634,0,1,1,0,800),(12523,9420537,1052119,0,1,1,0,800),(12524,9420537,1072306,0,1,1,0,800),(12525,9420537,1082201,0,1,1,0,800),(12526,9420538,4000476,0,1,1,0,300000),(12532,9420538,2070004,0,1,1,0,300),(12533,9420538,4006000,0,1,1,0,5000),(12534,9420538,2040705,0,1,1,0,1000),(12535,9420538,2041017,0,1,1,0,1000),(12536,9420538,1432010,0,1,1,0,800),(12537,9420538,1422012,0,1,1,0,800),(12538,9420538,1102029,0,1,1,0,800),(12539,9420538,1092015,0,1,1,0,800),(12540,9420538,1082123,0,1,1,0,800),(12541,9420538,1082112,0,1,1,0,800),(12542,9420538,1060091,0,1,1,0,800),(12543,9420538,1060094,0,1,1,0,800),(12544,9420538,1002274,0,1,1,0,800),(12545,9420538,1002278,0,1,1,0,800),(12546,9420538,1072179,0,1,1,0,800),(12547,9420538,1072163,0,1,1,0,800),(12548,9420538,1072155,0,1,1,0,800),(12549,9420538,1040109,0,1,1,0,800),(12550,9420538,1041106,0,1,1,0,800),(12551,9420538,1060098,0,1,1,0,800),(12552,9420538,1072312,0,1,1,0,800),(12553,9420538,1482010,0,1,1,0,800),(12554,9420538,1492010,0,1,1,0,800),(12555,9420539,4000477,0,1,1,0,300000),(12556,9420539,401000,0,1,1,0,800),(12561,9420539,400009,0,1,1,0,333333),(12562,9420539,2002008,0,1,1,0,333333),(12563,9420539,2070005,0,1,1,0,300),(12564,9420539,4006001,0,1,1,0,5000),(12565,9420539,4006000,0,1,1,0,5000),(12566,9420539,2040514,0,1,1,0,1000),(12567,9420539,2040802,0,1,1,0,1000),(12568,9420539,2044601,0,1,1,0,1000),(12569,9420539,1412009,0,1,1,0,800),(12570,9420539,1402012,0,1,1,0,800),(12571,9420539,1382010,0,1,1,0,800),(12572,9420539,1102035,0,1,1,0,800),(12573,9420539,1102031,0,1,1,0,800),(12574,9420539,1082116,0,1,1,0,800),(12575,9420539,1082108,0,1,1,0,800),(12576,9420539,1082099,0,1,1,0,800),(12577,9420539,1002284,0,1,1,0,800),(12578,9420539,1050074,0,1,1,0,800),(12579,9420539,1050083,0,1,1,0,800),(12580,9420539,1050078,0,1,1,0,800),(12581,9420540,4000478,0,1,1,0,300000),(12584,9420540,4004000,0,1,1,0,800),(12588,9420540,2002006,0,1,1,0,10000),(12589,9420540,2070012,0,1,1,0,500),(12590,9420540,4006001,0,1,1,0,5000),(12591,9420540,2022003,0,1,1,0,40000),(12592,9420540,2041014,0,1,1,0,1000),(12593,9420540,2040804,0,1,1,0,100),(12594,9420540,2040613,0,1,1,0,1000),(12595,9420540,1452017,0,1,1,0,800),(12596,9420540,1472031,0,1,1,0,800),(12597,9420540,1002329,0,1,1,0,800),(12598,9420540,1002366,0,1,1,0,800),(12599,9420540,1002405,0,1,1,0,800),(12600,9420540,1050095,0,1,1,0,800),(12601,9420540,1051097,0,1,1,0,800),(12602,9420540,1072198,0,1,1,0,800),(12603,9420540,1072209,0,1,1,0,800),(12604,9420540,1082134,0,1,1,0,800),(12605,9420540,2330005,0,1,1,0,100),(14302,9420540,2290120,0,1,1,0,130),(12607,9420544,1032031,0,1,1,0,3000),(12608,9420544,4001241,0,1,1,0,300000),(12609,9420544,2020013,0,1,1,0,333333),(12610,9420544,2020014,0,1,1,0,100000),(12611,9420544,1302056,0,1,1,0,3000),(12612,9420544,1312030,0,1,1,0,3000),(12613,9420544,1322045,0,1,1,0,3000),(12614,9420544,1332051,0,1,1,0,25000),(12615,9420544,1332052,0,1,1,0,25000),(12616,9420544,1372010,0,1,1,0,3000),(12617,9420544,1382035,0,1,1,0,3000),(12618,9420544,1402035,0,1,1,0,3000),(12619,9420544,1422027,0,1,1,0,3000),(12620,9420544,1412021,0,1,1,0,3000),(12621,9420544,1432030,0,1,1,0,25000),(12622,9420544,1452020,0,1,1,0,25000),(12623,9420544,1462015,0,1,1,0,25000),(12624,9420544,1462016,0,1,1,0,25000),(12625,9420544,1472053,0,1,1,0,13000),(12626,9420544,1452019,0,1,1,0,25000),(12627,9420544,1442044,0,1,1,0,3000),(12628,9420544,1492012,0,1,1,0,333333),(12629,9420544,1482012,0,1,1,0,333333),(12630,9420544,2043001,0,1,1,0,1000),(12631,9420544,2043101,0,1,1,0,1000),(12632,9420544,2043201,0,1,1,0,1000),(12633,9420544,2043301,0,1,1,0,1000),(12634,9420544,2043701,0,1,1,0,1000),(12635,9420544,2043801,0,1,1,0,1000),(12636,9420544,2044001,0,1,1,0,1000),(12637,9420544,2044101,0,1,1,0,1000),(12638,9420544,2044301,0,1,1,0,1000),(12639,9420544,2044201,0,1,1,0,1000),(12640,9420544,2044401,0,1,1,0,1000),(12641,9420544,2044501,0,1,1,0,1000),(12642,9420544,2044601,0,1,1,0,1000),(12643,9420544,2044701,0,1,1,0,1000),(12644,9420544,2040804,0,1,1,0,100),(12645,9420544,2040001,0,1,1,0,1000),(12646,9420544,2040004,0,1,1,0,1000),(12647,9420544,2040301,0,1,1,0,1000),(12648,9420544,2040401,0,1,1,0,1000),(12649,9420544,2040501,0,1,1,0,1000),(12650,9420544,2040504,0,1,1,0,1000),(12651,9420544,2040516,0,1,1,0,1000),(12652,9420544,2040513,0,1,1,0,1000),(12653,9420544,2040601,0,1,1,0,1000),(12654,9420544,2040701,0,1,1,0,1000),(12655,9420544,2040704,0,1,1,0,1000),(12656,9420544,2040707,0,1,1,0,1000),(12657,9420544,2040801,0,1,1,0,1000),(12658,9420544,2040901,0,1,1,0,1000),(12659,9420544,2290098,0,1,1,0,4000),(12660,9420544,2290015,0,1,1,0,4000),(12661,9420544,2290027,0,1,1,0,4000),(12662,9420544,2290089,0,1,1,0,4000),(12663,9420544,2290054,0,1,1,0,4000),(12664,9420544,2290119,0,1,1,0,4000),(12665,9420544,2290002,0,1,1,0,4000),(12666,9420544,2290022,0,1,1,0,4000),(12667,9420544,2290034,0,1,1,0,4000),(12668,9420544,2290105,0,1,1,0,4000),(12669,9420544,2290110,0,1,1,0,4000),(12670,9420544,2290094,0,1,1,0,4000),(12671,9420544,2290052,0,1,1,0,4000),(12672,9420544,1002926,0,1,1,0,300000),(12673,9420544,1002926,0,1,1,0,300000),(12674,9420544,1002926,0,1,1,0,300000),(12675,9420544,1002926,0,1,1,0,300000),(12676,9420544,1002926,0,1,1,0,300000),(12677,9420549,1032031,0,1,1,0,3000),(12678,9420549,2043001,0,1,1,0,1000),(12679,9420549,2020013,0,1,1,0,333333),(12680,9420549,2020014,0,1,1,0,100000),(12681,9420549,1302056,0,1,1,0,3000),(12682,9420549,1312030,0,1,1,0,3000),(12683,9420549,1322045,0,1,1,0,3000),(12684,9420549,1332051,0,1,1,0,25000),(12685,9420549,1332052,0,1,1,0,25000),(12686,9420549,1372010,0,1,1,0,3000),(12687,9420549,1382035,0,1,1,0,3000),(12688,9420549,1402035,0,1,1,0,3000),(12689,9420549,1422027,0,1,1,0,3000),(12690,9420549,1412021,0,1,1,0,3000),(12691,9420549,1432030,0,1,1,0,25000),(12692,9420549,1452020,0,1,1,0,25000),(12693,9420549,1462015,0,1,1,0,25000),(12694,9420549,1462016,0,1,1,0,25000),(12695,9420549,1472053,0,1,1,0,13000),(12696,9420549,1452019,0,1,1,0,25000),(12697,9420549,1442044,0,1,1,0,3000),(12698,9420549,1492012,0,1,1,0,333333),(12699,9420549,1482012,0,1,1,0,333333),(12700,9420549,2043101,0,1,1,0,1000),(12701,9420549,2043201,0,1,1,0,1000),(12702,9420549,2043301,0,1,1,0,1000),(12703,9420549,2043701,0,1,1,0,1000),(12704,9420549,2043801,0,1,1,0,1000),(12705,9420549,2044001,0,1,1,0,1000),(12706,9420549,2044101,0,1,1,0,1000),(12707,9420549,2044301,0,1,1,0,1000),(12708,9420549,2044201,0,1,1,0,1000),(12709,9420549,2044401,0,1,1,0,1000),(12710,9420549,2044501,0,1,1,0,1000),(12711,9420549,2044601,0,1,1,0,1000),(12712,9420549,2044701,0,1,1,0,1000),(12713,9420549,2040804,0,1,1,0,100),(12714,9420549,2040001,0,1,1,0,1000),(12715,9420549,2040004,0,1,1,0,1000),(12716,9420549,2040301,0,1,1,0,1000),(12717,9420549,2040401,0,1,1,0,1000),(12718,9420549,2040501,0,1,1,0,1000),(12719,9420549,2040504,0,1,1,0,1000),(12720,9420549,2040516,0,1,1,0,1000),(12721,9420549,2040513,0,1,1,0,1000),(12722,9420549,2040601,0,1,1,0,1000),(12723,9420549,2040701,0,1,1,0,1000),(12724,9420549,2040704,0,1,1,0,1000),(12725,9420549,2040707,0,1,1,0,1000),(12726,9420549,2040801,0,1,1,0,1000),(12727,9420549,2040901,0,1,1,0,1000),(12728,9420549,2290098,0,1,1,0,4000),(12729,9420549,2290015,0,1,1,0,4000),(12730,9420549,2290027,0,1,1,0,4000),(12731,9420549,2290089,0,1,1,0,4000),(12732,9420549,2290054,0,1,1,0,4000),(12733,9420549,2290119,0,1,1,0,4000),(12734,9420549,2290002,0,1,1,0,4000),(12735,9420549,2290022,0,1,1,0,4000),(12736,9420549,2290034,0,1,1,0,4000),(12737,9420549,2290105,0,1,1,0,4000),(12738,9420549,2290110,0,1,1,0,4000),(12739,9420549,2290094,0,1,1,0,4000),(12740,9420549,2290052,0,1,1,0,4000),(12741,9420549,4001242,0,1,1,0,300000),(12742,9420549,1002927,0,1,1,0,300000),(12743,9420549,1002927,0,1,1,0,300000),(12744,9420549,1002927,0,1,1,0,300000),(12745,9420549,1002927,0,1,1,0,300000),(14211,8140700,2290106,0,1,1,0,380),(13900,8500002,2290126,0,1,1,0,1000),(14236,8150300,2290120,0,1,1,0,210),(12749,8220004,2290127,0,1,1,0,15000),(12750,8180001,2290128,0,1,1,0,15000),(14239,8150302,2290010,0,1,1,0,340),(14277,8200001,2290129,0,1,1,0,130),(13899,8500002,2290013,0,1,1,0,5000),(12754,8180000,2290130,0,1,1,0,15000),(14275,8190004,2290130,0,1,1,0,410),(14279,8200002,2290131,0,1,1,0,110),(12757,8220005,2290131,0,1,1,0,15000),(12759,8220005,2290136,0,1,1,0,15000),(14281,8200003,2290056,0,1,1,0,330),(14288,8200007,2290007,0,1,1,0,130),(12762,8810018,2290137,0,1,1,0,45000),(14298,8200012,2290137,0,1,1,0,150),(12765,8220006,2290138,0,1,1,0,15000),(14286,8200006,2290077,0,1,1,0,100),(14297,8200012,2290093,0,1,1,0,150),(12768,8810018,2290139,0,1,1,0,45000),(14283,8200004,2290073,0,1,1,0,160),(12771,8220004,2290134,0,1,1,0,15000),(12772,8220006,2290135,0,1,1,0,15000),(14226,8150200,2290100,0,1,1,0,210),(14210,8140600,2290132,0,1,1,0,340),(12776,8510000,2290132,0,1,1,0,15000),(12777,8520000,2290132,0,1,1,0,15000),(12778,8810018,2290133,0,1,1,0,45000),(14290,8200008,2290006,0,1,1,0,330),(12780,6130200,4031171,0,1,1,7101,100000),(12781,8141100,4031171,0,1,1,7101,100000),(12782,8142000,4031171,0,1,1,7101,100000),(12783,8143000,4031171,0,1,1,7101,100000),(12784,8160000,4031171,0,1,1,7101,100000),(12785,8170000,4031171,0,1,1,7101,100000),(12786,9500127,4031171,0,1,1,7101,100000),(12787,9500135,4031171,0,1,1,7101,100000),(12788,9500136,4031171,0,1,1,7101,100000),(12789,8141000,4031171,0,1,1,7101,100000),(12790,8140300,4031171,0,1,1,7101,100000),(12791,8140200,4031171,0,1,1,7101,100000),(12792,6230300,4031171,0,1,1,7101,100000),(12793,6230400,4031171,0,1,1,7101,100000),(12794,6230500,4031171,0,1,1,7101,100000),(12795,6300100,4031171,0,1,1,7101,100000),(12796,6400100,4031171,0,1,1,7101,100000),(12797,7130010,4031171,0,1,1,7101,100000),(12798,7130300,4031171,0,1,1,7101,100000),(12799,7140000,4031171,0,1,1,7101,100000),(12800,9500137,4031171,0,1,1,7101,100000),(12801,9001005,4031857,0,1,1,0,300000),(12803,130100,4032374,0,1,1,2405,30000),(12804,1110101,4032376,0,1,1,2406,30000),(12805,210100,4032376,0,1,1,2406,30000),(12806,210100,4032377,0,1,1,2407,30000),(12807,1210101,4032377,0,1,1,2407,30000),(12808,1210101,4032377,0,1,1,2407,30000),(12809,130100,4032378,0,1,1,2408,30000),(12810,1120100,4032378,0,1,1,2408,30000),(12811,1210100,4032379,0,1,1,2409,30000),(12812,1110100,4032379,0,1,1,2409,30000),(14003,3000002,2000003,0,1,1,0,20000),(14002,3000002,2000001,0,1,1,0,20000),(12817,9300127,2022157,0,1,1,0,100000),(12818,9300127,2022158,0,1,1,0,100000),(12819,9300127,2022159,0,1,1,0,100000),(12820,9300131,2022157,0,1,1,0,100000),(12821,9300131,2022158,0,1,1,0,100000),(12822,9300131,2022159,0,1,1,0,100000),(12823,9300133,2022157,0,1,1,0,100000),(12824,9300133,2022158,0,1,1,0,100000),(12825,9300133,2022159,0,1,1,0,100000),(12826,9300134,2022157,0,1,1,0,100000),(12827,9300134,2022158,0,1,1,0,100000),(12828,9300134,2022159,0,1,1,0,100000),(12829,9300136,2022157,0,1,1,0,100000),(12830,9300136,2022158,0,1,1,0,100000),(12831,9300136,2022159,0,1,1,0,100000),(12832,9300127,2022160,0,1,1,0,100000),(12833,9300127,2022161,0,1,1,0,100000),(12834,9300127,2022162,0,1,1,0,100000),(12835,9300127,2022163,0,1,1,0,100000),(12836,9300131,2022160,0,1,1,0,100000),(12837,9300131,2022161,0,1,1,0,100000),(12838,9300131,2022162,0,1,1,0,100000),(12839,9300131,2022163,0,1,1,0,100000),(12840,9300133,2022160,0,1,1,0,100000),(12841,9300133,2022161,0,1,1,0,100000),(12842,9300133,2022162,0,1,1,0,100000),(12843,9300133,2022163,0,1,1,0,100000),(12844,9300134,2022160,0,1,1,0,100000),(12845,9300134,2022161,0,1,1,0,100000),(12846,9300134,2022162,0,1,1,0,100000),(12847,9300134,2022163,0,1,1,0,100000),(12848,9300136,2022160,0,1,1,0,100000),(12849,9300136,2022161,0,1,1,0,100000),(12850,9300136,2022162,0,1,1,0,100000),(12851,9300136,2022163,0,1,1,0,100000),(12852,9400632,2340000,0,1,1,0,400000),(12853,9300114,4001120,0,1,1,0,1000000),(12854,9300115,4001121,0,1,1,0,1000000),(12855,9300116,4001122,0,1,1,0,1000000),(12856,9300120,4001117,0,1,1,0,100000),(12857,9300121,4001117,0,1,1,0,100000),(12858,9300122,4001117,0,1,1,0,100000),(12864,8820010,4021010,0,1,1,0,7000),(12863,8820001,4021010,0,1,1,0,7000),(12862,8820000,4021010,0,1,1,0,7000),(12865,8820011,4021010,0,1,1,0,7000),(12866,8820012,4021010,0,1,1,0,7000),(12867,8820013,4021010,0,1,1,0,7000),(12868,8820014,4021010,0,1,1,0,7000),(12869,8220011,4031530,0,3,3,0,999999),(14001,3000002,4000068,0,1,1,0,600000),(12871,8220012,4031530,0,3,3,0,999999),(12872,8220012,4031530,0,3,3,0,999999),(12873,9700037,5451000,0,2,5,0,999999),(12874,9400597,2040816,0,1,1,0,499999),(12875,9400597,2040817,0,1,1,0,499999),(12876,9400597,2040818,0,1,1,0,499999),(12877,9400596,2040760,0,1,1,0,499999),(12878,9400596,2040759,0,1,1,0,499999),(12879,9400596,2040758,0,1,1,0,499999),(12881,9400587,4000018,0,1,1,0,14000),(12882,9400587,4032003,0,1,1,0,20000),(12883,9400588,4000018,0,1,1,0,14000),(12884,9400588,4032003,0,1,1,0,20000),(12971,9400576,2001000,0,1,1,0,10000),(12981,9400580,4032011,0,1,1,0,300),(12977,9400576,1072162,0,1,1,0,800),(12978,9400576,4032007,0,1,1,0,7000),(12980,9400580,4032010,0,1,1,0,300),(14300,9400580,2290004,0,1,1,0,470),(12976,9400576,1032015,0,1,1,0,800),(12974,9400576,2040820,0,1,1,0,750),(12973,9400576,2043301,0,1,1,0,750),(12901,9400581,4032006,0,1,1,0,7000),(12904,9400581,1000004,0,1,1,0,800),(12905,9400581,1000005,0,1,1,0,800),(12906,9400581,1000006,0,1,1,0,800),(12907,9400581,2040513,0,1,1,0,750),(12908,9400581,1102012,0,1,1,0,800),(12909,9400581,1002252,0,1,1,0,800),(12910,9400581,1402012,0,1,1,0,800),(12911,9400581,1442008,0,1,1,0,800),(12912,9400579,4032009,0,1,1,0,7000),(12913,9400577,4032008,0,1,1,0,7000),(12914,9400577,1000006,0,1,1,0,800),(12915,9400577,2001000,0,1,1,0,10000),(12916,9400577,2022020,0,1,1,0,10000),(12917,9400578,4032008,0,1,1,0,300),(12918,9400578,1000006,0,1,1,0,800),(12919,9400578,2001000,0,1,1,0,400),(12920,9400578,1032032,0,1,1,0,800),(12921,9400578,1032013,0,1,1,0,800),(12922,9400578,1372009,0,1,1,0,8000),(12923,9400574,4032005,0,1,1,0,7000),(12924,9400574,2041028,0,1,1,0,750),(12925,9400574,1082158,0,1,1,0,800),(12926,9400574,1332027,0,1,1,0,800),(12927,9400574,1332052,0,1,1,0,800),(12928,9400574,1442020,0,1,1,0,800),(12929,9400583,2070005,0,1,1,0,200),(12932,9400583,1000003,0,1,1,0,800),(12933,9400583,1000005,0,1,1,0,800),(12934,9400583,2022178,0,1,1,0,3000),(12935,9400583,1000006,0,1,1,0,800),(12936,9400583,1382010,0,1,1,0,800),(12937,9400583,1422012,0,1,1,0,800),(12938,9400583,1032023,0,1,1,0,800),(12939,9400583,1041099,0,1,1,0,800),(12940,9400583,1051058,0,1,1,0,800),(12942,9400583,1092029,0,1,1,0,800),(12943,9400583,1002276,0,1,1,0,800),(12944,9400584,2070005,0,1,1,0,200),(12947,9400584,1000003,0,1,1,0,800),(12948,9400584,1000005,0,1,1,0,800),(12949,9400584,2022178,0,1,1,0,3000),(12950,9400584,1382010,0,1,1,0,800),(12951,9400584,1051058,0,1,1,0,800),(12953,9400584,1092029,0,1,1,0,800),(12954,9400584,1002276,0,1,1,0,800),(12956,9400584,1041099,0,1,1,0,800),(12957,9400584,1422012,0,1,1,0,800),(12959,9400584,1402013,0,1,1,0,800),(12960,9400584,1051010,0,1,1,0,800),(12961,9400584,1002391,0,1,1,0,800),(12962,9400584,1002328,0,1,1,0,800),(12963,9400584,1072114,0,1,1,0,800),(12964,9400584,1082056,0,1,1,0,800),(12965,9400584,1061101,0,1,1,0,800),(12966,9400584,2041057,0,1,1,0,750),(12967,9400584,2041030,0,1,1,0,750),(12968,9400584,4003330,0,1,1,0,200),(12969,9400584,4032031,0,1,1,0,300),(12970,9400584,4030012,0,1,1,0,300),(13979,8500002,4031869,0,1,1,6360,999999),(13978,8500002,2388022,0,1,1,0,25000),(13977,8500002,2049100,0,1,1,0,1500),(13976,8500002,2044809,0,1,1,0,10000),(13898,8800002,4001083,0,1,1,0,999999),(13897,8800002,2049100,0,1,1,0,10000),(13896,8800002,2049000,0,1,1,0,6750),(13895,8800002,2040512,0,1,1,0,10000),(13894,8800002,2040328,0,1,1,0,10000),(13893,8800002,2040321,0,1,1,0,10000),(13892,8800002,2040031,0,1,1,0,10000),(13891,8800002,2040026,0,1,1,0,10000),(13890,8800002,1492012,0,1,1,0,22500),(13889,8800002,1482012,0,1,1,0,22500),(13888,8800002,2000004,0,45,50,0,1000000),(13887,8800002,1472053,0,1,1,0,50000),(13886,8800002,1462016,0,1,1,0,7000),(13885,8800002,1462015,0,1,1,0,10000),(13884,8800002,1452020,0,1,1,0,7000),(13883,8800002,1452019,0,1,1,0,10000),(13882,8800002,1442044,0,1,1,0,70000),(13881,8800002,1432030,0,1,1,0,70000),(13880,8800002,1422027,0,1,1,0,10000),(13879,8800002,1412021,0,1,1,0,10000),(13878,8800002,1402035,0,1,1,0,10000),(13877,8800002,1382035,0,1,1,0,50000),(13876,8800002,1372010,0,1,1,0,100000),(13875,8800002,1332052,0,1,1,0,30000),(13874,8800002,1332051,0,1,1,0,30000),(13873,8800002,1322045,0,1,1,0,10000),(13872,8800002,1312030,0,1,1,0,10000),(13871,8800002,1302056,0,1,1,0,30000),(13870,8800002,2000005,0,35,45,0,999999),(13869,8800002,2020015,0,60,70,0,999999),(13868,8800002,2020013,0,60,70,0,999999),(13867,8800002,2290115,0,1,1,0,4000),(13866,8800002,2290110,0,1,1,0,30000),(13865,8800002,2290094,0,1,1,0,5000),(13864,8800002,2290084,0,1,1,0,75000),(13863,8800002,2290079,0,1,1,0,80000),(13862,8800002,2290074,0,1,1,0,15000),(13861,8800002,2290067,0,1,1,0,15000),(13860,8800002,2290064,0,1,1,0,50000),(13859,8800002,2290057,0,1,1,0,55000),(13858,8800002,2290048,0,1,1,0,75000),(13857,8800002,2290046,0,1,1,0,35000),(13856,8800002,2290040,0,1,1,0,15000),(13855,8800002,2290029,0,1,1,0,35000),(13854,8800002,2290022,0,1,1,0,80000),(13853,8800002,2290020,0,1,1,0,20000),(13852,8800002,2290016,0,1,1,0,50000),(13851,8800002,2290007,0,1,1,0,80000),(13850,8800002,2280016,0,1,1,0,100000),(13849,8800002,2280015,0,1,1,0,100000),(13848,8800002,2280014,0,1,1,0,100000),(13847,8800002,2280013,0,1,1,0,100000),(13846,8800002,2280010,0,1,1,0,200000),(13845,8800002,2280009,0,1,1,0,150000),(13844,8800002,2280008,0,1,1,0,150000),(13843,8800002,2280007,0,1,1,0,200000),(14000,9400011,4000222,0,1,1,4306,150000),(13999,2230101,4032399,0,1,1,2251,80000),(13998,1210101,4001341,0,1,1,28172,70000),(13997,1110100,4001341,0,1,1,28172,70000),(13996,1210102,4001341,0,1,1,28172,70000),(13995,2100108,4031568,0,1,1,3911,80000),(13994,1110100,4001348,0,1,1,28231,100000),(13993,2220100,4001351,0,1,1,28237,70000),(13992,1120100,4001349,0,1,1,28235,80000),(13991,1210101,4001350,0,1,1,28235,40000),(13990,1110101,4001347,0,1,1,28229,40000),(13988,1210102,4001345,0,1,1,28170,40000),(13987,9400560,4001354,0,1,1,28209,40000),(13986,1110101,4001344,0,1,1,0,100000),(13985,1210101,4001343,0,1,1,28170,100000),(13984,1210101,4001343,0,1,1,28209,100000),(13826,8800002,1002357,0,1,1,0,300000),(13825,8800002,1002357,0,1,1,0,300000),(13824,8800002,1002357,0,1,1,0,300000),(13823,8800002,1002357,0,1,1,0,800000),(13822,8800002,1002357,0,1,1,0,999999),(13821,8800002,1372049,0,1,1,0,999999),(13344,3300005,4032388,0,1,1,0,200000),(13345,3300006,4032388,0,1,1,0,200000),(13346,3300007,4032388,0,1,1,0,200000),(13347,3400000,4000539,0,1,1,0,999999),(13350,3400000,2000001,0,1,1,0,7000),(13351,3400000,2000003,0,1,1,0,7000),(13352,3400000,2000006,0,1,1,0,7000),(13353,3400000,2022003,0,1,1,0,7000),(13354,3400000,2000004,0,1,1,0,7000),(13355,3400000,2040004,0,1,1,0,750),(13356,3400000,2040504,0,1,1,0,750),(13357,3400000,2049208,0,1,1,0,750),(13358,3400000,2049210,0,1,1,0,750),(13359,3400000,1002098,0,1,1,0,800),(13360,3400000,1072126,0,1,1,0,800),(13361,3400000,1002154,0,1,1,0,800),(13362,3400000,1072117,0,1,1,0,800),(13363,3400000,1002170,0,1,1,0,800),(13364,3400000,1072118,0,1,1,0,800),(13365,3400000,1002185,0,1,1,0,800),(13366,3400000,1072107,0,1,1,0,800),(13367,3400000,1002628,0,1,1,0,800),(13368,3400000,1072300,0,1,1,0,800),(13369,3400001,4000541,0,1,1,0,999999),(13372,3400001,2000001,0,1,1,0,7000),(13373,3400001,2000003,0,1,1,0,7000),(13374,3400001,2000006,0,1,1,0,7000),(13375,3400001,2022003,0,1,1,0,7000),(13376,3400001,2000004,0,1,1,0,7000),(13377,3400001,2040004,0,1,1,0,750),(13378,3400001,2040504,0,1,1,0,750),(13379,3400001,2049208,0,1,1,0,750),(13380,3400001,2049210,0,1,1,0,750),(13381,3400001,1002098,0,1,1,0,800),(13382,3400001,1072126,0,1,1,0,800),(13383,3400001,1002154,0,1,1,0,800),(13384,3400001,1072117,0,1,1,0,800),(13385,3400001,1002170,0,1,1,0,800),(13386,3400001,1072118,0,1,1,0,800),(13387,3400001,1002185,0,1,1,0,800),(13388,3400001,1072107,0,1,1,0,800),(13389,3400001,1002628,0,1,1,0,800),(13390,3400001,1072300,0,1,1,0,800),(13391,3400002,4000540,0,1,1,0,999999),(13394,3400002,2000001,0,1,1,0,7000),(13395,3400002,2000003,0,1,1,0,7000),(13396,3400002,2000006,0,1,1,0,7000),(13397,3400002,2022003,0,1,1,0,7000),(13398,3400002,2000004,0,1,1,0,7000),(13399,3400002,2040004,0,1,1,0,750),(13400,3400002,2040504,0,1,1,0,750),(13401,3400002,2049208,0,1,1,0,750),(13402,3400002,2049210,0,1,1,0,750),(13403,3400002,1002098,0,1,1,0,800),(13404,3400002,1072126,0,1,1,0,800),(13405,3400002,1002154,0,1,1,0,800),(13406,3400002,1072117,0,1,1,0,800),(13407,3400002,1002170,0,1,1,0,800),(13408,3400002,1072118,0,1,1,0,800),(13409,3400002,1002185,0,1,1,0,800),(13410,3400002,1072107,0,1,1,0,800),(13411,3400002,1002628,0,1,1,0,800),(13412,3400002,1072300,0,1,1,0,800),(13413,3400004,4032508,0,1,1,2273,10000),(13414,3400004,4000542,0,1,1,0,800000),(13415,3400008,4000544,0,1,1,0,800000),(13416,3400006,4000543,0,1,1,0,800000),(13417,4300006,4032506,0,1,1,2277,10000),(13418,4300007,4032506,0,1,1,2277,10000),(13419,4300008,4032506,0,1,1,2277,10000),(13420,4300006,4000525,0,1,1,0,800000),(13423,4300006,2000001,0,1,1,0,7000),(13424,4300006,2000003,0,1,1,0,7000),(13425,4300006,2000006,0,1,1,0,7000),(13426,4300006,2022003,0,1,1,0,7000),(13427,4300006,2000004,0,1,1,0,7000),(13428,4300006,2040004,0,1,1,0,750),(13429,4300006,2040501,0,1,1,0,750),(13430,4300006,2040801,0,1,1,0,750),(13431,4300006,2041007,0,1,1,0,750),(13432,4300006,2041004,0,1,1,0,750),(13433,4300006,2049200,0,1,1,0,750),(13434,4300006,2049202,0,1,1,0,750),(13435,4300006,2049204,0,1,1,0,750),(13436,4300006,2049206,0,1,1,0,750),(13437,4300006,1302009,0,1,1,0,800),(13438,4300006,1312007,0,1,1,0,800),(13439,4300006,1322016,0,1,1,0,800),(13440,4300006,1402007,0,1,1,0,800),(13441,4300006,1412005,0,1,1,0,800),(13442,4300006,1422007,0,1,1,0,800),(13443,4300006,1432005,0,1,1,0,800),(13444,4300006,1442009,0,1,1,0,800),(13445,4300006,1382019,0,1,1,0,800),(13446,4300006,1452007,0,1,1,0,800),(13447,4300006,1332011,0,1,1,0,800),(13448,4300006,1332031,0,1,1,0,800),(13449,4300006,1472014,0,1,1,0,800),(13450,4300006,1472015,0,1,1,0,800),(13451,4300006,1472016,0,1,1,0,800),(13452,4300006,1472017,0,1,1,0,800),(13453,4300006,1482006,0,1,1,0,800),(13454,4300006,1492006,0,1,1,0,800),(13455,4300007,4000526,0,1,1,0,800000),(13458,4300007,2000001,0,1,1,0,7000),(13459,4300007,2000003,0,1,1,0,7000),(13460,4300007,2000006,0,1,1,0,7000),(13461,4300007,2022003,0,1,1,0,7000),(13462,4300007,2000004,0,1,1,0,7000),(13463,4300007,2040004,0,1,1,0,750),(13464,4300007,2040501,0,1,1,0,750),(13465,4300007,2040801,0,1,1,0,750),(13466,4300007,2041007,0,1,1,0,750),(13467,4300007,2041004,0,1,1,0,750),(13468,4300007,2049200,0,1,1,0,750),(13469,4300007,2049202,0,1,1,0,750),(13470,4300007,2049204,0,1,1,0,750),(13471,4300007,2049206,0,1,1,0,750),(13472,4300007,1302009,0,1,1,0,800),(13473,4300007,1312007,0,1,1,0,800),(13474,4300007,1322016,0,1,1,0,800),(13475,4300007,1402007,0,1,1,0,800),(13476,4300007,1412005,0,1,1,0,800),(13477,4300007,1422007,0,1,1,0,800),(13478,4300007,1432005,0,1,1,0,800),(13479,4300007,1442009,0,1,1,0,800),(13480,4300007,1382019,0,1,1,0,800),(13481,4300007,1452007,0,1,1,0,800),(13482,4300007,1332011,0,1,1,0,800),(13483,4300007,1332031,0,1,1,0,800),(13484,4300007,1472014,0,1,1,0,800),(13485,4300007,1472015,0,1,1,0,800),(13486,4300007,1472016,0,1,1,0,800),(13487,4300007,1472017,0,1,1,0,800),(13488,4300007,1482006,0,1,1,0,800),(13489,4300007,1492006,0,1,1,0,800),(13490,4300008,4000527,0,1,1,0,800000),(13493,4300008,2000001,0,1,1,0,7000),(13494,4300008,2000003,0,1,1,0,7000),(13495,4300008,2000006,0,1,1,0,7000),(13496,4300008,2022003,0,1,1,0,7000),(13497,4300008,2000004,0,1,1,0,7000),(13498,4300008,2040004,0,1,1,0,750),(13499,4300008,2040501,0,1,1,0,750),(13500,4300008,2040801,0,1,1,0,750),(13501,4300008,2041007,0,1,1,0,750),(13502,4300008,2041004,0,1,1,0,750),(13503,4300008,2049200,0,1,1,0,750),(13504,4300008,2049202,0,1,1,0,750),(13505,4300008,2049204,0,1,1,0,750),(13506,4300008,2049206,0,1,1,0,750),(13507,4300008,1302009,0,1,1,0,800),(13508,4300008,1312007,0,1,1,0,800),(13509,4300008,1322016,0,1,1,0,800),(13510,4300008,1402007,0,1,1,0,800),(13511,4300008,1412005,0,1,1,0,800),(13512,4300008,1422007,0,1,1,0,800),(13513,4300008,1432005,0,1,1,0,800),(13514,4300008,1442009,0,1,1,0,800),(13515,4300008,1382019,0,1,1,0,800),(13516,4300008,1452007,0,1,1,0,800),(13517,4300008,1332011,0,1,1,0,800),(13518,4300008,1332031,0,1,1,0,800),(13519,4300008,1472014,0,1,1,0,800),(13520,4300008,1472015,0,1,1,0,800),(13521,4300008,1472016,0,1,1,0,800),(13522,4300008,1472017,0,1,1,0,800),(13523,4300008,1482006,0,1,1,0,800),(13524,4300008,1492006,0,1,1,0,800),(13525,4300001,4000530,0,1,1,0,999999),(13528,4300001,2000001,0,1,1,0,7000),(13529,4300001,2000003,0,1,1,0,7000),(13530,4300001,2000006,0,1,1,0,7000),(13531,4300001,2022003,0,1,1,0,7000),(13532,4300001,2000004,0,1,1,0,7000),(13533,4300001,2040004,0,1,1,0,750),(13534,4300001,2040501,0,1,1,0,750),(13535,4300001,2040801,0,1,1,0,750),(13536,4300001,2041007,0,1,1,0,750),(13537,4300001,2041004,0,1,1,0,750),(13538,4300001,2049200,0,1,1,0,750),(13539,4300001,2049202,0,1,1,0,750),(13540,4300001,2049204,0,1,1,0,750),(13541,4300001,2049206,0,1,1,0,750),(13542,4300001,1302009,0,1,1,0,800),(13543,4300001,1312007,0,1,1,0,800),(13544,4300001,1322016,0,1,1,0,800),(13545,4300001,1402007,0,1,1,0,800),(13546,4300001,1412005,0,1,1,0,800),(13547,4300001,1422007,0,1,1,0,800),(13548,4300001,1432005,0,1,1,0,800),(13549,4300001,1442009,0,1,1,0,800),(13550,4300001,1382019,0,1,1,0,800),(13551,4300001,1452007,0,1,1,0,800),(13552,4300001,1332011,0,1,1,0,800),(13553,4300001,1332031,0,1,1,0,800),(13554,4300001,1472014,0,1,1,0,800),(13555,4300001,1472015,0,1,1,0,800),(13556,4300001,1472016,0,1,1,0,800),(13557,4300001,1472017,0,1,1,0,800),(13558,4300001,1482006,0,1,1,0,800),(13559,4300001,1492006,0,1,1,0,800),(13560,4300003,4000532,0,1,1,0,999999),(13563,4300003,2000001,0,1,1,0,7000),(13564,4300003,2000003,0,1,1,0,7000),(13565,4300003,2000006,0,1,1,0,7000),(13566,4300003,2022003,0,1,1,0,7000),(13567,4300003,2000004,0,1,1,0,7000),(13568,4300003,2040004,0,1,1,0,750),(13569,4300003,2040501,0,1,1,0,750),(13570,4300003,2040801,0,1,1,0,750),(13571,4300003,2041007,0,1,1,0,750),(13572,4300003,2041004,0,1,1,0,750),(13573,4300003,2049200,0,1,1,0,750),(13574,4300003,2049202,0,1,1,0,750),(13575,4300003,2049204,0,1,1,0,750),(13576,4300003,2049206,0,1,1,0,750),(13577,4300003,1302009,0,1,1,0,800),(13578,4300003,1312007,0,1,1,0,800),(13579,4300003,1322016,0,1,1,0,800),(13580,4300003,1402007,0,1,1,0,800),(13581,4300003,1412005,0,1,1,0,800),(13582,4300003,1422007,0,1,1,0,800),(13583,4300003,1432005,0,1,1,0,800),(13584,4300003,1442009,0,1,1,0,800),(13585,4300003,1382019,0,1,1,0,800),(13586,4300003,1452007,0,1,1,0,800),(13587,4300003,1332011,0,1,1,0,800),(13588,4300003,1332031,0,1,1,0,800),(13589,4300003,1472014,0,1,1,0,800),(13590,4300003,1472015,0,1,1,0,800),(13591,4300003,1472016,0,1,1,0,800),(13592,4300003,1472017,0,1,1,0,800),(13593,4300003,1482006,0,1,1,0,800),(13594,4300003,1492006,0,1,1,0,800),(13595,4300005,4000534,0,1,1,0,999999),(13598,4300005,2000001,0,1,1,0,7000),(13599,4300005,2000003,0,1,1,0,7000),(13600,4300005,2000006,0,1,1,0,7000),(13601,4300005,2022003,0,1,1,0,7000),(13602,4300005,2000004,0,1,1,0,7000),(13603,4300005,2040004,0,1,1,0,750),(13604,4300005,2040501,0,1,1,0,750),(13605,4300005,2040801,0,1,1,0,750),(13606,4300005,2041007,0,1,1,0,750),(13607,4300005,2041004,0,1,1,0,750),(13608,4300005,2049200,0,1,1,0,750),(13609,4300005,2049202,0,1,1,0,750),(13610,4300005,2049204,0,1,1,0,750),(13611,4300005,2049206,0,1,1,0,750),(13612,4300005,1302009,0,1,1,0,800),(13613,4300005,1312007,0,1,1,0,800),(13614,4300005,1322016,0,1,1,0,800),(13615,4300005,1402007,0,1,1,0,800),(13616,4300005,1412005,0,1,1,0,800),(13617,4300005,1422007,0,1,1,0,800),(13618,4300005,1432005,0,1,1,0,800),(13619,4300005,1442009,0,1,1,0,800),(13620,4300005,1382019,0,1,1,0,800),(13621,4300005,1452007,0,1,1,0,800),(13622,4300005,1332011,0,1,1,0,800),(13623,4300005,1332031,0,1,1,0,800),(13624,4300005,1472014,0,1,1,0,800),(13625,4300005,1472015,0,1,1,0,800),(13626,4300005,1472016,0,1,1,0,800),(13627,4300005,1472017,0,1,1,0,800),(13628,4300005,1482006,0,1,1,0,800),(13629,4300005,1492006,0,1,1,0,800),(13630,4300010,4000529,0,1,1,0,999999),(13633,4300010,2000001,0,1,1,0,7000),(13634,4300010,2000003,0,1,1,0,7000),(13635,4300010,2000006,0,1,1,0,7000),(13636,4300010,2022003,0,1,1,0,7000),(13637,4300010,2000004,0,1,1,0,7000),(13638,4300010,2040004,0,1,1,0,750),(13639,4300010,2040501,0,1,1,0,750),(13640,4300010,2040801,0,1,1,0,750),(13641,4300010,2041007,0,1,1,0,750),(13642,4300010,2041004,0,1,1,0,750),(13643,4300010,2049200,0,1,1,0,750),(13644,4300010,2049202,0,1,1,0,750),(13645,4300010,2049204,0,1,1,0,750),(13646,4300010,2049206,0,1,1,0,750),(13647,4300010,1302009,0,1,1,0,800),(13648,4300010,1312007,0,1,1,0,800),(13649,4300010,1322016,0,1,1,0,800),(13650,4300010,1402007,0,1,1,0,800),(13651,4300010,1412005,0,1,1,0,800),(13652,4300010,1422007,0,1,1,0,800),(13653,4300010,1432005,0,1,1,0,800),(13654,4300010,1442009,0,1,1,0,800),(13655,4300010,1382019,0,1,1,0,800),(13656,4300010,1452007,0,1,1,0,800),(13657,4300010,1332011,0,1,1,0,800),(13658,4300010,1332031,0,1,1,0,800),(13659,4300010,1472014,0,1,1,0,800),(13660,4300010,1472015,0,1,1,0,800),(13661,4300010,1472016,0,1,1,0,800),(13662,4300010,1472017,0,1,1,0,800),(13663,4300010,1482006,0,1,1,0,800),(13664,4300010,1492006,0,1,1,0,800),(13665,4300009,4000528,0,1,1,0,999999),(13668,4300009,2000001,0,1,1,0,7000),(13669,4300009,2000003,0,1,1,0,7000),(13670,4300009,2000006,0,1,1,0,7000),(13671,4300009,2022003,0,1,1,0,7000),(13672,4300009,2000004,0,1,1,0,7000),(13673,4300009,2040004,0,1,1,0,750),(13674,4300009,2040501,0,1,1,0,750),(13675,4300009,2040801,0,1,1,0,750),(13676,4300009,2041007,0,1,1,0,750),(13677,4300009,2041004,0,1,1,0,750),(13678,4300009,2049200,0,1,1,0,750),(13679,4300009,2049202,0,1,1,0,750),(13680,4300009,2049204,0,1,1,0,750),(13681,4300009,2049206,0,1,1,0,750),(13682,4300009,1302009,0,1,1,0,800),(13683,4300009,1312007,0,1,1,0,800),(13684,4300009,1322016,0,1,1,0,800),(13685,4300009,1402007,0,1,1,0,800),(13686,4300009,1412005,0,1,1,0,800),(13687,4300009,1422007,0,1,1,0,800),(13688,4300009,1432005,0,1,1,0,800),(13689,4300009,1442009,0,1,1,0,800),(13690,4300009,1382019,0,1,1,0,800),(13691,4300009,1452007,0,1,1,0,800),(13692,4300009,1332011,0,1,1,0,800),(13693,4300009,1332031,0,1,1,0,800),(13694,4300009,1472014,0,1,1,0,800),(13695,4300009,1472015,0,1,1,0,800),(13696,4300009,1472016,0,1,1,0,800),(13697,4300009,1472017,0,1,1,0,800),(13698,4300009,1482006,0,1,1,0,800),(13699,4300009,1492006,0,1,1,0,800),(13700,4300011,4032509,0,1,1,2286,10000),(13701,4300011,4000536,0,1,1,0,999999),(13704,4300011,2000001,0,1,1,0,7000),(13705,4300011,2000003,0,1,1,0,7000),(13706,4300011,2000006,0,1,1,0,7000),(13707,4300011,2022003,0,1,1,0,7000),(13708,4300011,2000004,0,1,1,0,7000),(13709,4300011,2040004,0,1,1,0,750),(13710,4300011,2040501,0,1,1,0,750),(13711,4300011,2040801,0,1,1,0,750),(13712,4300011,2041007,0,1,1,0,750),(13713,4300011,2041004,0,1,1,0,750),(13714,4300011,2049200,0,1,1,0,750),(13715,4300011,2049202,0,1,1,0,750),(13716,4300011,2049204,0,1,1,0,750),(13717,4300011,2049206,0,1,1,0,750),(13718,4300011,1302009,0,1,1,0,800),(13719,4300011,1312007,0,1,1,0,800),(13720,4300011,1322016,0,1,1,0,800),(13721,4300011,1402007,0,1,1,0,800),(13722,4300011,1412005,0,1,1,0,800),(13723,4300011,1422007,0,1,1,0,800),(13724,4300011,1432005,0,1,1,0,800),(13725,4300011,1442009,0,1,1,0,800),(13726,4300011,1382019,0,1,1,0,800),(13727,4300011,1452007,0,1,1,0,800),(13728,4300011,1332011,0,1,1,0,800),(13729,4300011,1332031,0,1,1,0,800),(13730,4300011,1472014,0,1,1,0,800),(13731,4300011,1472015,0,1,1,0,800),(13732,4300011,1472016,0,1,1,0,800),(13733,4300011,1472017,0,1,1,0,800),(13734,4300011,1482006,0,1,1,0,800),(13735,4300011,1492006,0,1,1,0,800),(13736,4300012,4000537,0,1,1,0,999999),(14024,1110101,4001356,0,1,1,0,100000),(13739,4300012,2000001,0,1,1,0,7000),(13740,4300012,2000003,0,1,1,0,7000),(13741,4300012,2000006,0,1,1,0,7000),(13742,4300012,2022003,0,1,1,0,7000),(13743,4300012,2000004,0,1,1,0,7000),(13744,4300012,2040004,0,1,1,0,750),(13745,4300012,2040501,0,1,1,0,750),(13746,4300012,2040801,0,1,1,0,750),(13747,4300012,2041007,0,1,1,0,750),(13748,4300012,2041004,0,1,1,0,750),(13749,4300012,2049200,0,1,1,0,750),(13750,4300012,2049202,0,1,1,0,750),(13751,4300012,2049204,0,1,1,0,750),(13752,4300012,2049206,0,1,1,0,750),(13753,4300012,1302009,0,1,1,0,800),(13754,4300012,1312007,0,1,1,0,800),(13755,4300012,1322016,0,1,1,0,800),(13756,4300012,1402007,0,1,1,0,800),(13757,4300012,1412005,0,1,1,0,800),(13758,4300012,1422007,0,1,1,0,800),(13759,4300012,1432005,0,1,1,0,800),(13760,4300012,1442009,0,1,1,0,800),(13761,4300012,1382019,0,1,1,0,800),(13762,4300012,1452007,0,1,1,0,800),(13763,4300012,1332011,0,1,1,0,800),(13764,4300012,1332031,0,1,1,0,800),(13765,4300012,1472014,0,1,1,0,800),(13766,4300012,1472015,0,1,1,0,800),(13767,4300012,1472016,0,1,1,0,800),(13768,4300012,1472017,0,1,1,0,800),(13769,4300012,1482006,0,1,1,0,800),(13770,4300012,1492006,0,1,1,0,800),(13771,4300013,4000538,0,1,1,2288,999999),(13772,4300013,2049201,0,1,1,0,750),(13773,4300013,2049203,0,1,1,0,750),(13774,4300013,2049205,0,1,1,0,750),(13775,4300013,2049207,0,1,1,0,750),(14023,1210102,4001354,0,1,1,28209,60000),(14022,9400560,4001354,0,1,1,28210,40000),(13778,4300013,2000001,0,1,1,0,7000),(13779,4300013,2000003,0,1,1,0,7000),(13780,4300013,2000006,0,1,1,0,7000),(13781,4300013,2022003,0,1,1,0,7000),(13782,4300013,2000004,0,1,1,0,7000),(13783,4300013,2040004,0,1,1,0,750),(13784,4300013,2040501,0,1,1,0,750),(13785,4300013,2040801,0,1,1,0,750),(13786,4300013,2041007,0,1,1,0,750),(13787,4300013,2041004,0,1,1,0,750),(13788,4300013,2049200,0,1,1,0,750),(13789,4300013,2049202,0,1,1,0,750),(13790,4300013,2049204,0,1,1,0,750),(13791,4300013,2049206,0,1,1,0,750),(13792,4300013,1302009,0,1,1,0,800),(13793,4300013,1312007,0,1,1,0,800),(13794,4300013,1322016,0,1,1,0,800),(13795,4300013,1402007,0,1,1,0,800),(13796,4300013,1412005,0,1,1,0,800),(13797,4300013,1422007,0,1,1,0,800),(13798,4300013,1432005,0,1,1,0,800),(13799,4300013,1442009,0,1,1,0,800),(13800,4300013,1382019,0,1,1,0,800),(13801,4300013,1452007,0,1,1,0,800),(13802,4300013,1332011,0,1,1,0,800),(13803,4300013,1332031,0,1,1,0,800),(13804,4300013,1472014,0,1,1,0,800),(13805,4300013,1472015,0,1,1,0,800),(13806,4300013,1472016,0,1,1,0,800),(13807,4300013,1472017,0,1,1,0,800),(13808,4300013,1482006,0,1,1,0,800),(13809,4300013,1492006,0,1,1,0,800),(13810,3300003,4001317,0,1,1,2326,80000),(13811,1120100,4001365,0,1,1,0,20000),(13812,1210102,4001364,0,1,1,0,20000),(13813,1210101,4001357,0,1,1,28244,400000),(13816,9400571,4032056,2,1,1,0,999999),(13817,9300119,4001123,0,1,1,0,999999),(13818,9300147,4001132,0,1,1,0,550000),(13819,9300173,4001161,0,1,1,0,999999),(13820,9300175,4001169,0,1,1,0,999999),(13980,1210100,4001352,0,1,1,28205,33000),(13981,1210101,4001352,0,1,1,28205,33000),(13982,2110200,4001352,0,1,1,28205,35000),(13983,1210102,4001352,0,1,1,28205,30000),(14025,9400549,2020014,0,1,1,0,250000),(14026,9400549,1452015,0,1,1,0,3000),(14027,9400549,2002023,0,1,1,0,9000),(14028,9400549,1402016,0,1,1,0,3000),(14029,9400549,2040407,0,1,1,0,800),(14030,9400549,4031903,0,1,1,0,250000),(14031,9400549,2022117,0,1,1,0,300),(14032,9400549,2022182,0,1,1,0,10000),(14033,9400549,2040011,0,1,1,0,300),(14034,9400549,2002025,0,1,1,0,220000),(14035,9400549,1472033,0,1,1,0,3000),(14036,9400549,1372009,0,1,1,0,2000),(14037,9400549,2002024,0,1,1,0,220000),(14038,1210100,4032453,0,1,1,22503,500000),(14039,2220100,4032459,0,1,1,22524,30000),(14040,2220110,4032459,0,1,1,22524,30000),(14042,2220100,4032459,0,1,1,22524,40000),(14043,2220110,4032459,0,1,1,22524,40000),(14044,130100,4032460,0,1,1,22529,90000),(14045,1110101,4032460,0,1,1,22529,90000),(14046,1130100,4032460,0,1,1,22529,90000),(14047,1140100,4032460,0,1,1,22529,90000),(14048,2130100,4032460,0,1,1,22529,90000),(14049,2230101,4032461,0,1,1,22531,60000),(14050,2230102,4032462,0,1,1,22532,60000),(14051,3110100,4032463,0,1,1,22548,60000),(14052,9300387,4032466,0,1,1,22559,500000),(14053,4220000,4032474,0,1,1,0,999999),(14054,8140000,4032475,0,1,1,22407,999999),(14055,130100,4032498,0,1,1,22004,150000),(14056,1210100,4032453,0,1,1,22503,400000),(14057,1210103,4032620,0,1,1,2357,500000),(14058,1110100,4032620,0,1,1,2357,500000),(14059,1110130,4032620,0,1,1,2357,500000),(14060,1120100,4032622,0,1,1,2359,300000),(14061,1210103,4032621,0,1,1,2378,300000),(14062,2300100,4032623,0,1,1,2379,300000),(14063,1110101,4032624,0,1,1,2380,300000),(14064,130100,4031773,0,1,1,2145,90000),(14065,1110101,4031773,0,1,1,2145,90000),(14066,1130100,4031773,0,1,1,2145,90000),(14067,2130100,4031773,0,1,1,2145,90000),(14093,7130010,1342006,0,1,1,0,710),(14094,7130100,1342004,0,1,1,0,960),(14095,7130300,1342007,0,1,1,0,850),(14096,7140000,1342005,0,1,1,0,750),(14097,8120102,1342007,0,1,1,0,940),(14098,8140002,1342005,0,1,1,0,920),(14099,8140101,1342006,0,1,1,0,860),(14100,8140102,1342005,0,1,1,0,880),(14101,8140102,1342006,0,1,1,0,880),(14102,8140103,1342006,0,1,1,0,780),(14103,8140110,1342006,0,1,1,0,870),(14245,8180001,1342008,0,1,1,0,970),(14237,8150300,2290127,0,1,1,0,210),(14266,8190004,1342008,0,1,1,0,910),(14284,8200004,2290134,0,1,1,0,360);
/*!40000 ALTER TABLE `drop_data` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `drop_data_global`
--

DROP TABLE IF EXISTS `drop_data_global`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `drop_data_global` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `continent` int(11) NOT NULL,
  `dropType` tinyint(1) NOT NULL DEFAULT '0',
  `itemid` int(11) NOT NULL DEFAULT '0',
  `minimum_quantity` int(11) NOT NULL DEFAULT '1',
  `maximum_quantity` int(11) NOT NULL DEFAULT '1',
  `questid` int(11) NOT NULL DEFAULT '0',
  `chance` int(11) NOT NULL DEFAULT '0',
  `comments` varchar(45) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=latin1 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `drop_data_global`
--

LOCK TABLES `drop_data_global` WRITE;
/*!40000 ALTER TABLE `drop_data_global` DISABLE KEYS */;
INSERT INTO `drop_data_global` VALUES (1,0,0,5451000,1,1,0,5000,'gachapon ticket'),(2,0,0,4000514,1,1,0,999999,'bone'),(3,0,0,4032473,1,1,0,100000,'good bone'),(4,0,0,4031865,1,1,0,3000,'100 nx'),(5,0,0,4031866,1,1,0,1000,'250 nx'),(6,0,1,4007014,1,1,0,0,'High mob level * 10'),(7,0,1,4007015,1,1,0,0,'High mob level * 20'),(8,0,1,4007016,1,1,0,0,'High mob level * 30'),(9,0,0,4001126,1,1,0,0,'Maple Leaf'),(10,0,0,4031203,1,1,0,0,'Halloween Candies');
/*!40000 ALTER TABLE `drop_data_global` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `dueyitems`
--

DROP TABLE IF EXISTS `dueyitems`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dueyitems` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `PackageId` int(10) unsigned NOT NULL DEFAULT '0',
  `itemid` int(10) unsigned NOT NULL DEFAULT '0',
  `quantity` int(10) unsigned NOT NULL DEFAULT '0',
  `upgradeslots` int(11) DEFAULT '0',
  `level` int(11) DEFAULT '0',
  `str` int(11) DEFAULT '0',
  `dex` int(11) DEFAULT '0',
  `int` int(11) DEFAULT '0',
  `luk` int(11) DEFAULT '0',
  `hp` int(11) DEFAULT '0',
  `mp` int(11) DEFAULT '0',
  `watk` int(11) DEFAULT '0',
  `matk` int(11) DEFAULT '0',
  `wdef` int(11) DEFAULT '0',
  `mdef` int(11) DEFAULT '0',
  `acc` int(11) DEFAULT '0',
  `avoid` int(11) DEFAULT '0',
  `hands` int(11) DEFAULT '0',
  `speed` int(11) DEFAULT '0',
  `jump` int(11) DEFAULT '0',
  `owner` varchar(13) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `dueyitems`
--

LOCK TABLES `dueyitems` WRITE;
/*!40000 ALTER TABLE `dueyitems` DISABLE KEYS */;
/*!40000 ALTER TABLE `dueyitems` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `dueypackages`
--

DROP TABLE IF EXISTS `dueypackages`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dueypackages` (
  `PackageId` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `RecieverId` int(10) unsigned NOT NULL,
  `SenderName` varchar(13) NOT NULL,
  `Mesos` int(10) unsigned DEFAULT '0',
  `TimeStamp` varchar(10) NOT NULL,
  `Checked` tinyint(1) unsigned DEFAULT '1',
  `Type` tinyint(1) unsigned NOT NULL,
  PRIMARY KEY (`PackageId`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `dueypackages`
--

LOCK TABLES `dueypackages` WRITE;
/*!40000 ALTER TABLE `dueypackages` DISABLE KEYS */;
/*!40000 ALTER TABLE `dueypackages` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eventstats`
--

DROP TABLE IF EXISTS `eventstats`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `eventstats` (
  `characterid` int(11) unsigned NOT NULL,
  `name` varchar(11) NOT NULL DEFAULT '0' COMMENT '0',
  `info` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eventstats`
--

LOCK TABLES `eventstats` WRITE;
/*!40000 ALTER TABLE `eventstats` DISABLE KEYS */;
/*!40000 ALTER TABLE `eventstats` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `explog`
--

DROP TABLE IF EXISTS `explog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `explog` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `type` varchar(25) NOT NULL,
  `amount` bigint(45) NOT NULL,
  `chrid` int(11) NOT NULL,
  `level` int(11) NOT NULL,
  `mapid` int(11) NOT NULL,
  `duration` bigint(45) NOT NULL,
  `data` varchar(100) DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `explog`
--

LOCK TABLES `explog` WRITE;
/*!40000 ALTER TABLE `explog` DISABLE KEYS */;
/*!40000 ALTER TABLE `explog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `famelog`
--

DROP TABLE IF EXISTS `famelog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `famelog` (
  `famelogid` int(11) NOT NULL AUTO_INCREMENT,
  `characterid` int(11) NOT NULL DEFAULT '0',
  `characterid_to` int(11) NOT NULL DEFAULT '0',
  `when` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`famelogid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `famelog`
--

LOCK TABLES `famelog` WRITE;
/*!40000 ALTER TABLE `famelog` DISABLE KEYS */;
/*!40000 ALTER TABLE `famelog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `families`
--

DROP TABLE IF EXISTS `families`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `families` (
  `familyid` int(11) NOT NULL AUTO_INCREMENT,
  `bossID` int(11) NOT NULL,
  `familyName` varchar(45) NOT NULL,
  `world` int(11) NOT NULL,
  `statistic` mediumtext NOT NULL,
  `privilege` mediumtext NOT NULL,
  `privilegeUse` mediumtext NOT NULL,
  PRIMARY KEY (`familyid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `families`
--

LOCK TABLES `families` WRITE;
/*!40000 ALTER TABLE `families` DISABLE KEYS */;
/*!40000 ALTER TABLE `families` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `family_members`
--

DROP TABLE IF EXISTS `family_members`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `family_members` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `chrid` int(11) NOT NULL,
  `familyID` int(11) NOT NULL,
  `parentFamilyID` int(11) NOT NULL,
  `famousPoint` int(11) NOT NULL,
  `totalFamousPoint` int(11) NOT NULL,
  `todaySavePoint` int(11) NOT NULL,
  `characterName` varchar(45) NOT NULL,
  `firstUpdateTime` bigint(18) NOT NULL,
  `parentChrID` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `family_members`
--

LOCK TABLES `family_members` WRITE;
/*!40000 ALTER TABLE `family_members` DISABLE KEYS */;
/*!40000 ALTER TABLE `family_members` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `gifts`
--

DROP TABLE IF EXISTS `gifts`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `gifts` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `to` int(11) NOT NULL,
  `from` varchar(13) NOT NULL,
  `message` tinytext NOT NULL,
  `sn` int(10) unsigned NOT NULL,
  `ringid` int(10) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `gifts`
--

LOCK TABLES `gifts` WRITE;
/*!40000 ALTER TABLE `gifts` DISABLE KEYS */;
/*!40000 ALTER TABLE `gifts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `gmlog`
--

DROP TABLE IF EXISTS `gmlog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `gmlog` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL DEFAULT '0',
  `command` tinytext NOT NULL,
  `when` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `gmlog`
--

LOCK TABLES `gmlog` WRITE;
/*!40000 ALTER TABLE `gmlog` DISABLE KEYS */;
/*!40000 ALTER TABLE `gmlog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `guilds`
--

DROP TABLE IF EXISTS `guilds`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `guilds` (
  `guildid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `leader` int(10) unsigned NOT NULL DEFAULT '0',
  `GP` int(10) unsigned NOT NULL DEFAULT '0',
  `logo` int(10) unsigned DEFAULT NULL,
  `logoColor` smallint(5) unsigned NOT NULL DEFAULT '0',
  `name` varchar(45) NOT NULL,
  `rank1title` varchar(45) NOT NULL DEFAULT 'Master',
  `rank2title` varchar(45) NOT NULL DEFAULT 'Jr. Master',
  `rank3title` varchar(45) NOT NULL DEFAULT 'Member',
  `rank4title` varchar(45) NOT NULL DEFAULT 'Member',
  `rank5title` varchar(45) NOT NULL DEFAULT 'Member',
  `capacity` int(10) unsigned NOT NULL DEFAULT '10',
  `logoBG` int(10) unsigned DEFAULT NULL,
  `logoBGColor` smallint(5) unsigned NOT NULL DEFAULT '0',
  `notice` varchar(101) DEFAULT '',
  `allianceId` int(11) unsigned NOT NULL DEFAULT '0',
  `meso` bigint(20) NOT NULL DEFAULT '0',
  `coins` bigint(20) NOT NULL DEFAULT '0',
  `world` int(11) DEFAULT '0',
  PRIMARY KEY (`guildid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `guilds`
--

LOCK TABLES `guilds` WRITE;
/*!40000 ALTER TABLE `guilds` DISABLE KEYS */;
/*!40000 ALTER TABLE `guilds` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hiredmerchant`
--

DROP TABLE IF EXISTS `hiredmerchant`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `hiredmerchant` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ownerid` int(11) DEFAULT '0',
  `itemid` int(10) unsigned NOT NULL DEFAULT '0',
  `quantity` int(10) unsigned NOT NULL DEFAULT '0',
  `upgradeslots` int(11) DEFAULT '0',
  `level` int(11) DEFAULT '0',
  `str` int(11) DEFAULT '0',
  `dex` int(11) DEFAULT '0',
  `int` int(11) DEFAULT '0',
  `luk` int(11) DEFAULT '0',
  `hp` int(11) DEFAULT '0',
  `mp` int(11) DEFAULT '0',
  `watk` int(11) DEFAULT '0',
  `matk` int(11) DEFAULT '0',
  `wdef` int(11) DEFAULT '0',
  `mdef` int(11) DEFAULT '0',
  `acc` int(11) DEFAULT '0',
  `avoid` int(11) DEFAULT '0',
  `hands` int(11) DEFAULT '0',
  `speed` int(11) DEFAULT '0',
  `jump` int(11) DEFAULT '0',
  `owner` varchar(13) DEFAULT '',
  `type` tinyint(1) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `hiredmerchant`
--

LOCK TABLES `hiredmerchant` WRITE;
/*!40000 ALTER TABLE `hiredmerchant` DISABLE KEYS */;
/*!40000 ALTER TABLE `hiredmerchant` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `htsquads`
--

DROP TABLE IF EXISTS `htsquads`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `htsquads` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `channel` int(10) unsigned NOT NULL,
  `leaderid` int(10) unsigned NOT NULL DEFAULT '0',
  `status` int(10) unsigned NOT NULL DEFAULT '0',
  `members` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `htsquads`
--

LOCK TABLES `htsquads` WRITE;
/*!40000 ALTER TABLE `htsquads` DISABLE KEYS */;
/*!40000 ALTER TABLE `htsquads` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hwidbans`
--

DROP TABLE IF EXISTS `hwidbans`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `hwidbans` (
  `hwidbanid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `hwid` varchar(100) NOT NULL,
  PRIMARY KEY (`hwidbanid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `hwidbans`
--

LOCK TABLES `hwidbans` WRITE;
/*!40000 ALTER TABLE `hwidbans` DISABLE KEYS */;
/*!40000 ALTER TABLE `hwidbans` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `inventoryequipment`
--

DROP TABLE IF EXISTS `inventoryequipment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `inventoryequipment` (
  `sn` int(10) unsigned NOT NULL,
  `upgradeslots` int(11) NOT NULL DEFAULT '0',
  `level` int(11) NOT NULL DEFAULT '0',
  `str` int(11) NOT NULL DEFAULT '0',
  `dex` int(11) NOT NULL DEFAULT '0',
  `int` int(11) NOT NULL DEFAULT '0',
  `luk` int(11) NOT NULL DEFAULT '0',
  `hp` int(11) NOT NULL DEFAULT '0',
  `mp` int(11) NOT NULL DEFAULT '0',
  `watk` int(11) NOT NULL DEFAULT '0',
  `matk` int(11) NOT NULL DEFAULT '0',
  `wdef` int(11) NOT NULL DEFAULT '0',
  `mdef` int(11) NOT NULL DEFAULT '0',
  `acc` int(11) NOT NULL DEFAULT '0',
  `avoid` int(11) NOT NULL DEFAULT '0',
  `hands` int(11) NOT NULL DEFAULT '0',
  `speed` int(11) NOT NULL DEFAULT '0',
  `jump` int(11) NOT NULL DEFAULT '0',
  `vicious` int(11) unsigned NOT NULL DEFAULT '0',
  `itemlevel` int(11) NOT NULL DEFAULT '1',
  `itemexp` float unsigned NOT NULL DEFAULT '0',
  `ringid` int(11) NOT NULL DEFAULT '-1',
  `learnedSkills` tinyint(1) NOT NULL DEFAULT '0',
  `durability` int(11) NOT NULL DEFAULT '1',
  `grade` int(3) NOT NULL DEFAULT '0',
  `chuc` int(3) NOT NULL DEFAULT '0',
  `option1` int(11) NOT NULL DEFAULT '0',
  `option2` int(11) NOT NULL DEFAULT '0',
  `option3` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`sn`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `inventoryequipment`
--

LOCK TABLES `inventoryequipment` WRITE;
/*!40000 ALTER TABLE `inventoryequipment` DISABLE KEYS */;
/*!40000 ALTER TABLE `inventoryequipment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `inventoryitems`
--

DROP TABLE IF EXISTS `inventoryitems`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `inventoryitems` (
  `sn` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type` tinyint(3) unsigned NOT NULL,
  `characterid` int(11) DEFAULT NULL,
  `accountid` int(11) DEFAULT NULL,
  `itemid` int(11) NOT NULL DEFAULT '0',
  `inventorytype` int(11) NOT NULL DEFAULT '0',
  `position` int(11) NOT NULL DEFAULT '0',
  `quantity` int(11) NOT NULL DEFAULT '0',
  `owner` tinytext NOT NULL,
  `petid` int(11) NOT NULL DEFAULT '-1',
  `flag` int(11) NOT NULL,
  `expiration` bigint(20) NOT NULL DEFAULT '-1',
  `lockExpiration` bigint(20) NOT NULL DEFAULT '-1',
  `giftFrom` varchar(26) NOT NULL,
  `bundles` int(11) NOT NULL DEFAULT '1',
  PRIMARY KEY (`sn`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `inventoryitems`
--

LOCK TABLES `inventoryitems` WRITE;
/*!40000 ALTER TABLE `inventoryitems` DISABLE KEYS */;
/*!40000 ALTER TABLE `inventoryitems` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ipbans`
--

DROP TABLE IF EXISTS `ipbans`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ipbans` (
  `ipbanid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `ip` varchar(40) NOT NULL DEFAULT '',
  PRIMARY KEY (`ipbanid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ipbans`
--

LOCK TABLES `ipbans` WRITE;
/*!40000 ALTER TABLE `ipbans` DISABLE KEYS */;
/*!40000 ALTER TABLE `ipbans` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `iplog`
--

DROP TABLE IF EXISTS `iplog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `iplog` (
  `iplogid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `accountid` int(11) NOT NULL DEFAULT '0',
  `ip` varchar(30) NOT NULL DEFAULT '',
  `login` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`iplogid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `iplog`
--

LOCK TABLES `iplog` WRITE;
/*!40000 ALTER TABLE `iplog` DISABLE KEYS */;
/*!40000 ALTER TABLE `iplog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `keymap`
--

DROP TABLE IF EXISTS `keymap`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `keymap` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `characterid` int(11) NOT NULL DEFAULT '0',
  `key` int(11) NOT NULL DEFAULT '0',
  `type` int(11) NOT NULL DEFAULT '0',
  `action` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `keymap`
--

LOCK TABLES `keymap` WRITE;
/*!40000 ALTER TABLE `keymap` DISABLE KEYS */;
/*!40000 ALTER TABLE `keymap` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `limitedgoods`
--

DROP TABLE IF EXISTS `limitedgoods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `limitedgoods` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `itemid` int(11) NOT NULL,
  `sn` varchar(150) DEFAULT NULL,
  `originCount` int(11) NOT NULL,
  `remainCount` int(11) NOT NULL,
  `conditionFlag` int(11) NOT NULL,
  `dateStart` int(11) NOT NULL,
  `dateEnd` int(11) NOT NULL,
  `hourStart` int(11) NOT NULL,
  `hourEnd` int(11) NOT NULL,
  `week` varchar(90) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `limitedgoods`
--

LOCK TABLES `limitedgoods` WRITE;
/*!40000 ALTER TABLE `limitedgoods` DISABLE KEYS */;
/*!40000 ALTER TABLE `limitedgoods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `macbans`
--

DROP TABLE IF EXISTS `macbans`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `macbans` (
  `macbanid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `mac` varchar(100) NOT NULL,
  UNIQUE KEY `macbanid` (`macbanid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `macbans`
--

LOCK TABLES `macbans` WRITE;
/*!40000 ALTER TABLE `macbans` DISABLE KEYS */;
/*!40000 ALTER TABLE `macbans` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `macfilters`
--

DROP TABLE IF EXISTS `macfilters`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `macfilters` (
  `macfilterid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `filter` varchar(30) NOT NULL,
  PRIMARY KEY (`macfilterid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `macfilters`
--

LOCK TABLES `macfilters` WRITE;
/*!40000 ALTER TABLE `macfilters` DISABLE KEYS */;
/*!40000 ALTER TABLE `macfilters` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `machineidbans`
--

DROP TABLE IF EXISTS `machineidbans`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `machineidbans` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `machineid` varchar(100) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `machineidbans`
--

LOCK TABLES `machineidbans` WRITE;
/*!40000 ALTER TABLE `machineidbans` DISABLE KEYS */;
/*!40000 ALTER TABLE `machineidbans` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `makercreatedata`
--

DROP TABLE IF EXISTS `makercreatedata`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `makercreatedata` (
  `id` tinyint(3) unsigned NOT NULL,
  `itemid` int(11) NOT NULL,
  `req_level` tinyint(3) unsigned NOT NULL,
  `req_maker_level` tinyint(3) unsigned NOT NULL,
  `req_meso` int(11) NOT NULL,
  `req_item` int(11) NOT NULL,
  `req_equip` int(11) NOT NULL,
  `catalyst` int(11) NOT NULL,
  `quantity` smallint(6) NOT NULL,
  `tuc` tinyint(3) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `makercreatedata`
--

LOCK TABLES `makercreatedata` WRITE;
/*!40000 ALTER TABLE `makercreatedata` DISABLE KEYS */;
INSERT INTO `makercreatedata` VALUES (0,2040727,50,1,50000,0,1122013,0,1,0),(0,2041058,50,1,50000,0,1122013,0,1,0),(0,4001174,45,1,0,4031966,0,0,1,0),(0,4001175,50,1,0,4031967,0,0,1,0),(0,4001176,55,1,0,4031968,0,0,10,0),(0,4001177,60,1,0,4031969,0,0,100,0),(0,4001178,65,1,0,4031970,0,0,5,0),(0,4001179,70,1,0,4031971,0,0,7,0),(0,4001180,75,2,0,4031972,0,0,1,0),(0,4001181,80,2,0,4031973,0,0,1,0),(0,4001182,85,2,0,4031974,0,0,6,0),(0,4001183,90,2,0,4031975,0,0,30,0),(0,4001184,95,2,0,4031976,0,0,2,0),(0,4001185,100,2,0,4031977,0,0,1,0),(0,4001186,105,3,0,4031978,0,0,1,0),(0,4031980,105,2,0,4031979,0,0,1,0),(0,4250000,45,1,100000,0,0,0,1,0),(0,4250001,45,1,300000,0,0,0,1,0),(0,4250002,45,2,500000,0,0,0,1,0),(0,4250100,45,1,100000,0,0,0,1,0),(0,4250101,45,1,300000,0,0,0,1,0),(0,4250102,45,2,500000,0,0,0,1,0),(0,4250200,45,1,100000,0,0,0,1,0),(0,4250201,45,1,300000,0,0,0,1,0),(0,4250202,45,2,500000,0,0,0,1,0),(0,4250300,45,1,100000,0,0,0,1,0),(0,4250301,45,1,300000,0,0,0,1,0),(0,4250302,45,2,500000,0,0,0,1,0),(0,4250400,45,1,100000,0,0,0,1,0),(0,4250401,45,1,300000,0,0,0,1,0),(0,4250402,45,2,500000,0,0,0,1,0),(0,4250500,45,1,100000,0,0,0,1,0),(0,4250501,45,1,300000,0,0,0,1,0),(0,4250502,45,2,500000,0,0,0,1,0),(0,4250600,45,1,100000,0,0,0,1,0),(0,4250601,45,1,300000,0,0,0,1,0),(0,4250602,45,2,500000,0,0,0,1,0),(0,4250700,45,1,100000,0,0,0,1,0),(0,4250701,45,1,300000,0,0,0,1,0),(0,4250702,45,2,500000,0,0,0,1,0),(0,4250800,45,1,100000,0,0,0,1,0),(0,4250801,45,1,300000,0,0,0,1,0),(0,4250802,45,2,500000,0,0,0,1,0),(0,4250900,45,1,100000,0,0,0,1,0),(0,4250901,45,1,300000,0,0,0,1,0),(0,4250902,45,2,500000,0,0,0,1,0),(0,4251000,45,1,100000,0,0,0,1,0),(0,4251001,45,1,300000,0,0,0,1,0),(0,4251002,45,2,500000,0,0,0,1,0),(0,4251100,45,1,100000,0,0,0,1,0),(0,4251101,45,1,300000,0,0,0,1,0),(0,4251102,45,2,500000,0,0,0,1,0),(0,4251300,75,2,150000,0,0,0,1,0),(0,4251301,75,2,450000,0,0,0,1,0),(0,4251302,75,3,750000,0,0,0,1,0),(0,4251400,75,2,150000,0,0,0,1,0),(0,4251401,75,2,450000,0,0,0,1,0),(0,4251402,75,3,750000,0,0,0,1,0),(1,1002022,50,1,55000,0,0,4130018,1,1),(1,1002028,45,1,50000,0,0,4130018,1,1),(1,1002029,55,1,75000,0,0,4130018,1,1),(1,1002030,65,1,85000,0,0,4130018,1,1),(1,1002084,55,1,75000,0,0,4130018,1,1),(1,1002085,45,1,45000,0,0,4130018,1,1),(1,1002086,45,1,37500,0,0,4130018,1,1),(1,1002094,65,1,85000,0,0,4130018,1,1),(1,1002095,65,1,85000,0,0,4130018,1,1),(1,1002100,50,1,55000,0,0,4130018,1,1),(1,1002101,50,1,55000,0,0,4130018,1,1),(1,1002338,75,2,133000,0,0,4130018,1,2),(1,1002339,75,2,133000,0,0,4130018,1,2),(1,1002340,75,2,133000,0,0,4130018,1,2),(1,1002377,95,2,168000,0,0,4130018,1,2),(1,1002378,95,2,168000,0,0,4130018,1,2),(1,1002379,95,2,168000,0,0,4130018,1,2),(1,1002528,85,2,147000,0,0,4130018,1,2),(1,1002529,85,2,147000,0,0,4130018,1,2),(1,1002530,85,2,147000,0,0,4130018,1,2),(1,1002531,85,2,147000,0,0,4130018,1,2),(1,1002532,85,2,147000,0,0,4130018,1,2),(1,1002551,105,3,280000,0,0,4130018,1,3),(1,1002776,115,3,320000,0,0,4130018,1,3),(1,1002790,115,3,320000,0,0,4130018,1,3),(1,1040087,45,1,37500,0,0,4130019,1,1),(1,1040088,45,1,37500,0,0,4130019,1,1),(1,1040089,45,1,37500,0,0,4130019,1,1),(1,1040090,55,1,45000,0,0,4130019,1,1),(1,1040091,55,1,45000,0,0,4130019,1,1),(1,1040092,55,1,45000,0,0,4130019,1,1),(1,1040093,55,1,45000,0,0,4130019,1,1),(1,1040102,65,1,50000,0,0,4130019,1,1),(1,1040103,65,1,50000,0,0,4130019,1,1),(1,1040104,65,1,50000,0,0,4130019,1,1),(1,1040111,85,2,112000,0,0,4130019,1,2),(1,1040112,85,2,112000,0,0,4130019,1,2),(1,1040113,85,2,112000,0,0,4130019,1,2),(1,1040120,95,2,140000,0,0,4130019,1,2),(1,1040121,95,2,140000,0,0,4130019,1,2),(1,1040122,95,2,140000,0,0,4130019,1,2),(1,1041087,45,1,37500,0,0,4130019,1,1),(1,1041088,45,1,37500,0,0,4130019,1,1),(1,1041089,45,1,37500,0,0,4130019,1,1),(1,1041091,55,1,45000,0,0,4130019,1,1),(1,1041092,55,1,45000,0,0,4130019,1,1),(1,1041093,55,1,45000,0,0,4130019,1,1),(1,1041097,65,1,50000,0,0,4130019,1,1),(1,1041098,65,1,50000,0,0,4130019,1,1),(1,1041099,65,1,50000,0,0,4130019,1,1),(1,1041119,85,2,133000,0,0,4130019,1,2),(1,1041120,85,2,133000,0,0,4130019,1,2),(1,1041121,85,2,133000,0,0,4130019,1,2),(1,1041122,95,2,140000,0,0,4130019,1,2),(1,1041123,95,2,140000,0,0,4130019,1,2),(1,1041124,95,2,140000,0,0,4130019,1,2),(1,1050080,75,2,126000,0,0,4130021,1,2),(1,1050081,75,2,126000,0,0,4130021,1,2),(1,1050082,75,2,126000,0,0,4130021,1,2),(1,1050083,75,2,126000,0,0,4130021,1,2),(1,1051077,75,2,126000,0,0,4130021,1,2),(1,1051078,75,2,126000,0,0,4130021,1,2),(1,1051079,75,2,126000,0,0,4130021,1,2),(1,1051080,75,2,126000,0,0,4130021,1,2),(1,1052075,105,3,320000,0,0,4130021,1,3),(1,1052155,115,3,380000,0,0,4130021,1,3),(1,1052160,115,3,380000,0,0,4130021,1,3),(1,1060076,45,1,30000,0,0,4130020,1,1),(1,1060077,45,1,30000,0,0,4130020,1,1),(1,1060078,45,1,30000,0,0,4130020,1,1),(1,1060079,55,1,37500,0,0,4130020,1,1),(1,1060080,55,1,37500,0,0,4130020,1,1),(1,1060081,55,1,37500,0,0,4130020,1,1),(1,1060082,55,1,37500,0,0,4130020,1,1),(1,1060090,65,1,45000,0,0,4130020,1,1),(1,1060091,65,1,45000,0,0,4130020,1,1),(1,1060092,65,1,45000,0,0,4130020,1,1),(1,1060100,85,2,98000,0,0,4130020,1,2),(1,1060101,85,2,98000,0,0,4130020,1,2),(1,1060102,85,2,98000,0,0,4130020,1,2),(1,1060109,95,2,126000,0,0,4130020,1,2),(1,1060110,95,2,126000,0,0,4130020,1,2),(1,1060111,95,2,126000,0,0,4130020,1,2),(1,1061086,45,1,30000,0,0,4130020,1,1),(1,1061087,45,1,30000,0,0,4130020,1,1),(1,1061088,45,1,30000,0,0,4130020,1,1),(1,1061090,55,1,37500,0,0,4130020,1,1),(1,1061091,55,1,37500,0,0,4130020,1,1),(1,1061092,55,1,37500,0,0,4130020,1,1),(1,1061096,65,1,45000,0,0,4130020,1,1),(1,1061097,65,1,45000,0,0,4130020,1,1),(1,1061098,65,1,45000,0,0,4130020,1,1),(1,1061118,85,2,119000,0,0,4130020,1,2),(1,1061119,85,2,119000,0,0,4130020,1,2),(1,1061120,85,2,119000,0,0,4130020,1,2),(1,1061121,95,2,126000,0,0,4130020,1,2),(1,1061122,95,2,126000,0,0,4130020,1,2),(1,1061123,95,2,126000,0,0,4130020,1,2),(1,1072132,45,1,27500,0,0,4130001,1,1),(1,1072133,45,1,27500,0,0,4130001,1,1),(1,1072134,45,1,27500,0,0,4130001,1,1),(1,1072135,45,1,27500,0,0,4130001,1,1),(1,1072147,55,1,35000,0,0,4130001,1,1),(1,1072148,55,1,35000,0,0,4130001,1,1),(1,1072149,55,1,35000,0,0,4130001,1,1),(1,1072154,65,1,42500,0,0,4130001,1,1),(1,1072155,65,1,42500,0,0,4130001,1,1),(1,1072156,65,1,42500,0,0,4130001,1,1),(1,1072196,85,2,105000,0,0,4130001,1,2),(1,1072197,85,2,105000,0,0,4130001,1,2),(1,1072198,85,2,105000,0,0,4130001,1,2),(1,1072210,75,2,77000,0,0,4130001,1,2),(1,1072211,75,2,77000,0,0,4130001,1,2),(1,1072212,75,2,77000,0,0,4130001,1,2),(1,1072220,95,2,126000,0,0,4130001,1,2),(1,1072221,95,2,126000,0,0,4130001,1,2),(1,1072222,95,2,126000,0,0,4130001,1,2),(1,1072273,105,3,210000,0,0,4130001,1,3),(1,1072355,115,3,240000,0,0,4130001,1,3),(1,1072361,115,3,240000,0,0,4130001,1,3),(1,1082009,45,1,45000,0,0,4130000,1,1),(1,1082010,45,1,50000,0,0,4130000,1,1),(1,1082011,45,1,55000,0,0,4130000,1,1),(1,1082059,55,1,60000,0,0,4130000,1,1),(1,1082060,55,1,65000,0,0,4130000,1,1),(1,1082061,55,1,70000,0,0,4130000,1,1),(1,1082103,65,1,75000,0,0,4130000,1,1),(1,1082104,65,1,80000,0,0,4130000,1,1),(1,1082105,65,1,85000,0,0,4130000,1,1),(1,1082114,75,2,147000,0,0,4130000,1,2),(1,1082115,75,2,150500,0,0,4130000,1,2),(1,1082116,75,2,154000,0,0,4130000,1,2),(1,1082117,75,2,154000,0,0,4130000,1,2),(1,1082128,85,2,168000,0,0,4130000,1,2),(1,1082129,85,2,171500,0,0,4130000,1,2),(1,1082130,85,2,175000,0,0,4130000,1,2),(1,1082139,95,2,189000,0,0,4130000,1,2),(1,1082140,95,2,192500,0,0,4130000,1,2),(1,1082141,95,2,196000,0,0,4130000,1,2),(1,1082168,105,3,300000,0,0,4130000,1,3),(1,1082234,115,3,330000,0,0,4130000,1,3),(1,1082239,115,3,330000,0,0,4130000,1,3),(1,1092004,45,1,75000,0,0,4130022,1,1),(1,1092009,55,1,90000,0,0,4130022,1,1),(1,1092010,55,1,95000,0,0,4130022,1,1),(1,1092011,55,1,95000,0,0,4130022,1,1),(1,1092015,65,1,100000,0,0,4130022,1,1),(1,1092016,65,1,105000,0,0,4130022,1,1),(1,1092017,65,1,105000,0,0,4130022,1,1),(1,1092023,75,2,154000,0,0,4130022,1,2),(1,1092024,75,2,161000,0,0,4130022,1,2),(1,1092025,75,2,161000,0,0,4130022,1,2),(1,1092026,85,2,168000,0,0,4130022,1,2),(1,1092027,85,2,175000,0,0,4130022,1,2),(1,1092028,85,2,175000,0,0,4130022,1,2),(1,1092036,95,2,182000,0,0,4130022,1,2),(1,1092037,95,2,189000,0,0,4130022,1,2),(1,1092038,95,2,196000,0,0,4130022,1,2),(1,1092058,115,3,350000,0,0,4130022,1,3),(1,1092060,105,3,210000,0,0,4130022,1,3),(1,1302010,45,1,60000,0,0,4130002,1,1),(1,1302011,55,1,75000,0,0,4130002,1,1),(1,1302012,65,1,125000,0,0,4130002,1,1),(1,1302018,75,2,210000,0,0,4130002,1,2),(1,1302023,85,2,245000,0,0,4130002,1,2),(1,1302056,95,2,336000,0,0,4130002,1,2),(1,1302059,105,3,550000,0,0,4130002,1,3),(1,1302081,115,3,680000,0,0,4130002,1,3),(1,1302086,115,3,680000,0,0,4130002,1,3),(1,1312008,45,1,70000,0,0,4130003,1,1),(1,1312009,55,1,95000,0,0,4130003,1,1),(1,1312010,65,1,150000,0,0,4130003,1,1),(1,1312011,75,2,245000,0,0,4130003,1,2),(1,1312015,85,2,280000,0,0,4130003,1,2),(1,1312030,95,2,329000,0,0,4130003,1,2),(1,1312031,105,3,530000,0,0,4130003,1,3),(1,1312037,115,3,580000,0,0,4130003,1,3),(1,1312038,115,3,580000,0,0,4130003,1,3),(1,1322017,45,1,70000,0,0,4130004,1,1),(1,1322018,55,1,95000,0,0,4130004,1,1),(1,1322019,65,1,125000,0,0,4130004,1,1),(1,1322020,70,1,150000,0,0,4130004,1,1),(1,1322028,75,2,245000,0,0,4130004,1,2),(1,1322029,85,2,280000,0,0,4130004,1,2),(1,1322045,95,2,329000,0,0,4130004,1,2),(1,1322052,105,3,480000,0,0,4130004,1,3),(1,1322060,115,3,490000,0,0,4130004,1,3),(1,1322061,115,3,490000,0,0,4130004,1,3),(1,1402003,45,1,100000,0,0,4130005,1,1),(1,1402004,75,2,210000,0,0,4130005,1,2),(1,1402005,85,2,280000,0,0,4130005,1,2),(1,1402011,55,1,115000,0,0,4130005,1,1),(1,1402012,65,1,130000,0,0,4130005,1,1),(1,1402015,75,2,210000,0,0,4130005,1,2),(1,1402016,85,2,280000,0,0,4130005,1,2),(1,1402035,95,2,329000,0,0,4130005,1,2),(1,1402036,105,3,550000,0,0,4130005,1,3),(1,1402046,115,3,650000,0,0,4130005,1,3),(1,1402047,115,3,650000,0,0,4130005,1,3),(1,1412003,45,1,70000,0,0,4130006,1,1),(1,1412007,55,1,95000,0,0,4130006,1,1),(1,1412008,65,1,125000,0,0,4130006,1,1),(1,1412009,75,2,217000,0,0,4130006,1,2),(1,1412010,85,2,259000,0,0,4130006,1,2),(1,1412021,95,2,343000,0,0,4130006,1,2),(1,1412026,105,3,520000,0,0,4130006,1,3),(1,1412033,115,3,650000,0,0,4130006,1,3),(1,1412034,115,3,650000,0,0,4130006,1,3),(1,1422005,45,1,75000,0,0,4130007,1,1),(1,1422009,55,1,95000,0,0,4130007,1,1),(1,1422010,65,1,125000,0,0,4130007,1,1),(1,1422012,75,2,217000,0,0,4130007,1,2),(1,1422013,85,2,259000,0,0,4130007,1,2),(1,1422027,95,2,315000,0,0,4130007,1,2),(1,1422028,105,3,510000,0,0,4130007,1,3),(1,1422037,115,3,560000,0,0,4130007,1,3),(1,1422038,115,3,560000,0,0,4130007,1,3),(1,1432004,45,1,75000,0,0,4130008,1,1),(1,1432006,55,1,95000,0,0,4130008,1,1),(1,1432007,65,1,125000,0,0,4130008,1,1),(1,1432010,75,2,217000,0,0,4130008,1,2),(1,1432011,85,2,259000,0,0,4130008,1,2),(1,1432030,95,2,343000,0,0,4130008,1,2),(1,1432038,105,3,530000,0,0,4130008,1,3),(1,1432047,115,3,570000,0,0,4130008,1,3),(1,1432049,115,3,570000,0,0,4130008,1,3),(1,1442005,45,1,75000,0,0,4130009,1,1),(1,1442008,65,1,150000,0,0,4130009,1,1),(1,1442010,55,1,125000,0,0,4130009,1,1),(1,1442019,75,2,245000,0,0,4130009,1,2),(1,1442020,85,2,315000,0,0,4130009,1,2),(1,1442044,95,2,329000,0,0,4130009,1,2),(1,1442045,105,3,570000,0,0,4130009,1,3),(1,1442063,115,3,620000,0,0,4130009,1,3),(1,1442067,115,3,620000,0,0,4130009,1,3),(2,1002215,45,1,20000,0,0,4130018,1,1),(2,1002216,45,1,20000,0,0,4130018,1,1),(2,1002217,45,1,20000,0,0,4130018,1,1),(2,1002218,45,1,20000,0,0,4130018,1,1),(2,1002242,55,1,25000,0,0,4130018,1,1),(2,1002243,55,1,25000,0,0,4130018,1,1),(2,1002244,55,1,25000,0,0,4130018,1,1),(2,1002245,55,1,25000,0,0,4130018,1,1),(2,1002246,55,1,25000,0,0,4130018,1,1),(2,1002252,65,1,40000,0,0,4130018,1,1),(2,1002253,65,1,40000,0,0,4130018,1,1),(2,1002254,65,1,40000,0,0,4130018,1,1),(2,1002271,75,2,66500,0,0,4130018,1,2),(2,1002272,75,2,66500,0,0,4130018,1,2),(2,1002273,75,2,66500,0,0,4130018,1,2),(2,1002274,75,2,66500,0,0,4130018,1,2),(2,1002363,85,2,77000,0,0,4130018,1,2),(2,1002364,85,2,77000,0,0,4130018,1,2),(2,1002365,85,2,77000,0,0,4130018,1,2),(2,1002366,85,2,77000,0,0,4130018,1,2),(2,1002398,95,2,87500,0,0,4130018,1,2),(2,1002399,95,2,87500,0,0,4130018,1,2),(2,1002400,95,2,87500,0,0,4130018,1,2),(2,1002401,95,2,87500,0,0,4130018,1,2),(2,1002773,105,3,150000,0,0,4130018,1,3),(2,1002777,115,3,170000,0,0,4130018,1,3),(2,1002791,115,3,170000,0,0,4130018,1,3),(2,1050045,43,1,45000,0,0,4130021,1,1),(2,1050046,43,1,45000,0,0,4130021,1,1),(2,1050047,43,1,45000,0,0,4130021,1,1),(2,1050048,43,1,45000,0,0,4130021,1,1),(2,1050049,43,1,45000,0,0,4130021,1,1),(2,1050053,53,1,50000,0,0,4130021,1,1),(2,1050054,53,1,50000,0,0,4130021,1,1),(2,1050055,53,1,50000,0,0,4130021,1,1),(2,1050056,53,1,50000,0,0,4130021,1,1),(2,1050067,63,1,60000,0,0,4130021,1,1),(2,1050068,63,1,60000,0,0,4130021,1,1),(2,1050069,63,1,60000,0,0,4130021,1,1),(2,1050070,63,1,60000,0,0,4130021,1,1),(2,1050072,73,2,112000,0,0,4130021,1,2),(2,1050073,73,2,112000,0,0,4130021,1,2),(2,1050074,73,2,112000,0,0,4130021,1,2),(2,1050092,83,2,140000,0,0,4130021,1,2),(2,1050093,83,2,140000,0,0,4130021,1,2),(2,1050094,83,2,140000,0,0,4130021,1,2),(2,1050095,83,2,140000,0,0,4130021,1,2),(2,1050102,93,2,168000,0,0,4130021,1,2),(2,1050103,93,2,168000,0,0,4130021,1,2),(2,1050104,93,2,168000,0,0,4130021,1,2),(2,1050105,93,2,168000,0,0,4130021,1,2),(2,1051030,43,1,45000,0,0,4130021,1,1),(2,1051031,43,1,45000,0,0,4130021,1,1),(2,1051032,43,1,45000,0,0,4130021,1,1),(2,1051033,43,1,45000,0,0,4130021,1,1),(2,1051034,43,1,45000,0,0,4130021,1,1),(2,1051044,53,1,50000,0,0,4130021,1,1),(2,1051045,53,1,50000,0,0,4130021,1,1),(2,1051046,53,1,50000,0,0,4130021,1,1),(2,1051047,53,1,50000,0,0,4130021,1,1),(2,1051052,63,1,60000,0,0,4130021,1,1),(2,1051053,63,1,60000,0,0,4130021,1,1),(2,1051054,63,1,60000,0,0,4130021,1,1),(2,1051055,63,1,60000,0,0,4130021,1,1),(2,1051056,73,2,112000,0,0,4130021,1,2),(2,1051057,73,2,112000,0,0,4130021,1,2),(2,1051058,73,2,112000,0,0,4130021,1,2),(2,1051094,83,2,140000,0,0,4130021,1,2),(2,1051095,83,2,140000,0,0,4130021,1,2),(2,1051096,83,2,140000,0,0,4130021,1,2),(2,1051097,83,2,140000,0,0,4130021,1,2),(2,1051101,93,2,168000,0,0,4130021,1,2),(2,1051102,93,2,168000,0,0,4130021,1,2),(2,1051103,93,2,168000,0,0,4130021,1,2),(2,1051104,93,2,168000,0,0,4130021,1,2),(2,1052076,103,3,290000,0,0,4130021,1,3),(2,1052156,115,3,340000,0,0,4130021,1,3),(2,1052161,115,3,340000,0,0,4130021,1,3),(2,1072136,55,1,30000,0,0,4130001,1,1),(2,1072137,55,1,30000,0,0,4130001,1,1),(2,1072138,55,1,30000,0,0,4130001,1,1),(2,1072139,55,1,30000,0,0,4130001,1,1),(2,1072140,45,1,27500,0,0,4130001,1,1),(2,1072141,45,1,27500,0,0,4130001,1,1),(2,1072142,45,1,27500,0,0,4130001,1,1),(2,1072143,45,1,27500,0,0,4130001,1,1),(2,1072157,65,1,40000,0,0,4130001,1,1),(2,1072158,65,1,40000,0,0,4130001,1,1),(2,1072159,65,1,40000,0,0,4130001,1,1),(2,1072160,65,1,40000,0,0,4130001,1,1),(2,1072177,75,2,70000,0,0,4130001,1,2),(2,1072178,75,2,70000,0,0,4130001,1,2),(2,1072179,75,2,70000,0,0,4130001,1,2),(2,1072206,85,2,84000,0,0,4130001,1,2),(2,1072207,85,2,84000,0,0,4130001,1,2),(2,1072208,85,2,84000,0,0,4130001,1,2),(2,1072209,85,2,84000,0,0,4130001,1,2),(2,1072223,95,2,98000,0,0,4130001,1,2),(2,1072224,95,2,98000,0,0,4130001,1,2),(2,1072225,95,2,98000,0,0,4130001,1,2),(2,1072226,95,2,98000,0,0,4130001,1,2),(2,1072268,105,3,180000,0,0,4130001,1,3),(2,1072356,115,3,220000,0,0,4130001,1,3),(2,1072362,115,3,220000,0,0,4130001,1,3),(2,1082080,45,1,50000,0,0,4130000,1,1),(2,1082081,45,1,40000,0,0,4130000,1,1),(2,1082082,45,1,45000,0,0,4130000,1,1),(2,1082086,55,1,52500,0,0,4130000,1,1),(2,1082087,55,1,57500,0,0,4130000,1,1),(2,1082088,55,1,62500,0,0,4130000,1,1),(2,1082098,65,1,70000,0,0,4130000,1,1),(2,1082099,65,1,72500,0,0,4130000,1,1),(2,1082100,65,1,75000,0,0,4130000,1,1),(2,1082121,75,2,140000,0,0,4130000,1,2),(2,1082122,75,2,143500,0,0,4130000,1,2),(2,1082123,75,2,147000,0,0,4130000,1,2),(2,1082131,85,2,161000,0,0,4130000,1,2),(2,1082132,85,2,164500,0,0,4130000,1,2),(2,1082133,85,2,164500,0,0,4130000,1,2),(2,1082134,85,2,168000,0,0,4130000,1,2),(2,1082151,95,2,182000,0,0,4130000,1,2),(2,1082152,95,2,185500,0,0,4130000,1,2),(2,1082153,95,2,185500,0,0,4130000,1,2),(2,1082154,95,2,189000,0,0,4130000,1,2),(2,1082164,105,3,300000,0,0,4130000,1,3),(2,1082235,115,3,330000,0,0,4130000,1,3),(2,1082240,115,3,330000,0,0,4130000,1,3),(2,1092057,115,3,350000,0,0,4130022,1,3),(2,1372007,43,1,100000,0,0,4130010,1,1),(2,1372009,83,2,227500,0,0,4130010,1,2),(2,1372010,93,2,252000,0,0,4130010,1,2),(2,1372014,53,1,115000,0,0,4130010,1,1),(2,1372015,63,1,130000,0,0,4130010,1,1),(2,1372016,73,2,203000,0,0,4130010,1,2),(2,1372032,103,3,460000,0,0,4130010,1,3),(2,1372044,115,3,510000,0,0,4130010,1,3),(2,1372045,115,3,510000,0,0,4130010,1,3),(2,1382006,50,1,75000,0,0,4130011,1,1),(2,1382007,60,1,100000,0,0,4130011,1,1),(2,1382008,80,2,217000,0,0,4130011,1,2),(2,1382010,70,1,125000,0,0,4130011,1,1),(2,1382035,90,2,266000,0,0,4130011,1,2),(2,1382036,105,3,470000,0,0,4130011,1,3),(2,1382057,115,3,520000,0,0,4130011,1,3),(2,1382059,115,3,520000,0,0,4130011,1,3),(4,1002211,45,1,20000,0,0,4130018,1,1),(4,1002212,45,1,20000,0,0,4130018,1,1),(4,1002213,45,1,20000,0,0,4130018,1,1),(4,1002214,45,1,20000,0,0,4130018,1,1),(4,1002267,55,1,27500,0,0,4130018,1,1),(4,1002268,55,1,27500,0,0,4130018,1,1),(4,1002269,55,1,27500,0,0,4130018,1,1),(4,1002270,55,1,27500,0,0,4130018,1,1),(4,1002275,75,2,70000,0,0,4130018,1,2),(4,1002276,75,2,70000,0,0,4130018,1,2),(4,1002277,75,2,70000,0,0,4130018,1,2),(4,1002278,75,2,70000,0,0,4130018,1,2),(4,1002286,65,1,42500,0,0,4130018,1,1),(4,1002287,65,1,42500,0,0,4130018,1,1),(4,1002288,65,1,42500,0,0,4130018,1,1),(4,1002289,65,1,42500,0,0,4130018,1,1),(4,1002402,85,2,80500,0,0,4130018,1,2),(4,1002403,85,2,80500,0,0,4130018,1,2),(4,1002404,85,2,80500,0,0,4130018,1,2),(4,1002405,85,2,80500,0,0,4130018,1,2),(4,1002406,95,2,91000,0,0,4130018,1,2),(4,1002407,95,2,91000,0,0,4130018,1,2),(4,1002408,95,2,91000,0,0,4130018,1,2),(4,1002547,105,3,150000,0,0,4130018,1,3),(4,1002778,115,3,170000,0,0,4130018,1,3),(4,1002792,115,3,170000,0,0,4130018,1,3),(4,1050051,45,1,47500,0,0,4130021,1,1),(4,1050052,45,1,47500,0,0,4130021,1,1),(4,1050058,55,1,52500,0,0,4130021,1,1),(4,1050059,55,1,52500,0,0,4130021,1,1),(4,1050060,55,1,52500,0,0,4130021,1,1),(4,1050061,65,1,57500,0,0,4130021,1,1),(4,1050062,65,1,57500,0,0,4130021,1,1),(4,1050063,65,1,57500,0,0,4130021,1,1),(4,1050064,65,1,57500,0,0,4130021,1,1),(4,1050075,75,2,98000,0,0,4130021,1,2),(4,1050076,75,2,98000,0,0,4130021,1,2),(4,1050077,75,2,98000,0,0,4130021,1,2),(4,1050078,75,2,98000,0,0,4130021,1,2),(4,1050088,85,2,140000,0,0,4130021,1,2),(4,1050089,85,2,140000,0,0,4130021,1,2),(4,1050090,85,2,140000,0,0,4130021,1,2),(4,1050091,85,2,140000,0,0,4130021,1,2),(4,1050106,95,2,168000,0,0,4130021,1,2),(4,1050107,95,2,168000,0,0,4130021,1,2),(4,1050108,95,2,168000,0,0,4130021,1,2),(4,1051037,45,1,47500,0,0,4130021,1,1),(4,1051038,45,1,47500,0,0,4130021,1,1),(4,1051039,45,1,47500,0,0,4130021,1,1),(4,1051041,55,1,52500,0,0,4130021,1,1),(4,1051042,55,1,52500,0,0,4130021,1,1),(4,1051043,55,1,52500,0,0,4130021,1,1),(4,1051062,65,1,57500,0,0,4130021,1,1),(4,1051063,65,1,57500,0,0,4130021,1,1),(4,1051064,65,1,57500,0,0,4130021,1,1),(4,1051065,65,1,57500,0,0,4130021,1,1),(4,1051066,75,2,98000,0,0,4130021,1,2),(4,1051067,75,2,98000,0,0,4130021,1,2),(4,1051068,75,2,98000,0,0,4130021,1,2),(4,1051069,75,2,98000,0,0,4130021,1,2),(4,1051082,85,2,140000,0,0,4130021,1,2),(4,1051083,85,2,140000,0,0,4130021,1,2),(4,1051084,85,2,140000,0,0,4130021,1,2),(4,1051085,85,2,140000,0,0,4130021,1,2),(4,1051105,95,2,168000,0,0,4130021,1,2),(4,1051106,95,2,168000,0,0,4130021,1,2),(4,1051107,95,2,168000,0,0,4130021,1,2),(4,1052071,105,3,300000,0,0,4130021,1,3),(4,1052157,115,3,360000,0,0,4130021,1,3),(4,1052162,115,3,360000,0,0,4130021,1,3),(4,1072122,45,1,25000,0,0,4130001,1,1),(4,1072123,45,1,25000,0,0,4130001,1,1),(4,1072124,45,1,25000,0,0,4130001,1,1),(4,1072125,45,1,25000,0,0,4130001,1,1),(4,1072144,55,1,32500,0,0,4130001,1,1),(4,1072145,55,1,32500,0,0,4130001,1,1),(4,1072146,55,1,32500,0,0,4130001,1,1),(4,1072164,65,1,45000,0,0,4130001,1,1),(4,1072165,65,1,45000,0,0,4130001,1,1),(4,1072166,65,1,45000,0,0,4130001,1,1),(4,1072167,65,1,45000,0,0,4130001,1,1),(4,1072182,75,2,77000,0,0,4130001,1,2),(4,1072183,75,2,77000,0,0,4130001,1,2),(4,1072184,75,2,77000,0,0,4130001,1,2),(4,1072185,75,2,77000,0,0,4130001,1,2),(4,1072203,85,2,98000,0,0,4130001,1,2),(4,1072204,85,2,98000,0,0,4130001,1,2),(4,1072205,85,2,98000,0,0,4130001,1,2),(4,1072227,95,2,119000,0,0,4130001,1,2),(4,1072228,95,2,119000,0,0,4130001,1,2),(4,1072229,95,2,119000,0,0,4130001,1,2),(4,1072269,105,3,180000,0,0,4130001,1,3),(4,1072357,115,3,200000,0,0,4130001,1,3),(4,1072363,115,3,200000,0,0,4130001,1,3),(4,1082083,45,1,52500,0,0,4130000,1,1),(4,1082084,45,1,42500,0,0,4130000,1,1),(4,1082085,45,1,47500,0,0,4130000,1,1),(4,1082089,55,1,55000,0,0,4130000,1,1),(4,1082090,55,1,60000,0,0,4130000,1,1),(4,1082091,55,1,65000,0,0,4130000,1,1),(4,1082106,65,1,70000,0,0,4130000,1,1),(4,1082107,65,1,75000,0,0,4130000,1,1),(4,1082108,65,1,80000,0,0,4130000,1,1),(4,1082109,75,2,140000,0,0,4130000,1,2),(4,1082110,75,2,143500,0,0,4130000,1,2),(4,1082111,75,2,143500,0,0,4130000,1,2),(4,1082112,75,2,147000,0,0,4130000,1,2),(4,1082125,85,2,161000,0,0,4130000,1,2),(4,1082126,85,2,164500,0,0,4130000,1,2),(4,1082127,85,2,168000,0,0,4130000,1,2),(4,1082158,95,2,182000,0,0,4130000,1,2),(4,1082159,95,2,185500,0,0,4130000,1,2),(4,1082160,95,2,189000,0,0,4130000,1,2),(4,1082163,105,3,300000,0,0,4130000,1,3),(4,1082236,115,3,330000,0,0,4130000,1,3),(4,1082241,115,3,330000,0,0,4130000,1,3),(4,1452004,55,1,125000,0,0,4130012,1,1),(4,1452008,45,1,100000,0,0,4130012,1,1),(4,1452009,65,1,150000,0,0,4130012,1,1),(4,1452010,65,1,150000,0,0,4130012,1,1),(4,1452011,65,1,150000,0,0,4130012,1,1),(4,1452012,75,2,245000,0,0,4130012,1,2),(4,1452013,75,2,245000,0,0,4130012,1,2),(4,1452014,75,2,245000,0,0,4130012,1,2),(4,1452015,75,2,245000,0,0,4130012,1,2),(4,1452017,85,2,280000,0,0,4130012,1,2),(4,1452019,95,2,315000,0,0,4130012,1,2),(4,1452020,95,2,315000,0,0,4130012,1,2),(4,1452021,95,2,315000,0,0,4130012,1,2),(4,1452044,105,3,500000,0,0,4130012,1,3),(4,1452057,115,3,550000,0,0,4130012,1,3),(4,1452059,115,3,550000,0,0,4130012,1,3),(4,1462007,45,1,85000,0,0,4130013,1,1),(4,1462008,55,1,120000,0,0,4130013,1,1),(4,1462009,65,1,150000,0,0,4130013,1,1),(4,1462010,75,2,245000,0,0,4130013,1,2),(4,1462011,75,2,245000,0,0,4130013,1,2),(4,1462012,75,2,245000,0,0,4130013,1,2),(4,1462013,75,2,245000,0,0,4130013,1,2),(4,1462015,95,2,315000,0,0,4130013,1,2),(4,1462016,95,2,315000,0,0,4130013,1,2),(4,1462017,95,2,315000,0,0,4130013,1,2),(4,1462018,85,2,280000,0,0,4130013,1,2),(4,1462039,105,3,500000,0,0,4130013,1,3),(4,1462050,115,3,550000,0,0,4130013,1,3),(4,1462051,115,3,550000,0,0,4130013,1,3),(8,1002207,45,1,20000,0,0,4130018,1,1),(8,1002208,45,1,20000,0,0,4130018,1,1),(8,1002209,45,1,20000,0,0,4130018,1,1),(8,1002210,45,1,20000,0,0,4130018,1,1),(8,1002247,55,1,27500,0,0,4130018,1,1),(8,1002248,55,1,27500,0,0,4130018,1,1),(8,1002249,55,1,27500,0,0,4130018,1,1),(8,1002281,65,1,42500,0,0,4130018,1,1),(8,1002282,65,1,42500,0,0,4130018,1,1),(8,1002283,65,1,42500,0,0,4130018,1,1),(8,1002284,65,1,42500,0,0,4130018,1,1),(8,1002285,65,1,42500,0,0,4130018,1,1),(8,1002323,85,2,80500,0,0,4130018,1,2),(8,1002324,85,2,80500,0,0,4130018,1,2),(8,1002325,85,2,80500,0,0,4130018,1,2),(8,1002326,85,2,80500,0,0,4130018,1,2),(8,1002327,75,2,70000,0,0,4130018,1,2),(8,1002328,75,2,70000,0,0,4130018,1,2),(8,1002329,75,2,70000,0,0,4130018,1,2),(8,1002330,75,2,70000,0,0,4130018,1,2),(8,1002380,95,2,91000,0,0,4130018,1,2),(8,1002381,95,2,91000,0,0,4130018,1,2),(8,1002382,95,2,91000,0,0,4130018,1,2),(8,1002383,95,2,91000,0,0,4130018,1,2),(8,1002550,105,3,150000,0,0,4130018,1,3),(8,1002779,115,3,190000,0,0,4130018,1,3),(8,1002793,115,3,190000,0,0,4130018,1,3),(8,1040094,45,1,37500,0,0,4130019,1,1),(8,1040095,45,1,37500,0,0,4130019,1,1),(8,1040096,45,1,37500,0,0,4130019,1,1),(8,1040097,45,1,37500,0,0,4130019,1,1),(8,1040098,55,1,45000,0,0,4130019,1,1),(8,1040099,55,1,45000,0,0,4130019,1,1),(8,1040100,55,1,45000,0,0,4130019,1,1),(8,1040105,65,1,50000,0,0,4130019,1,1),(8,1040106,65,1,50000,0,0,4130019,1,1),(8,1040107,65,1,50000,0,0,4130019,1,1),(8,1040108,75,2,98000,0,0,4130019,1,2),(8,1040109,75,2,98000,0,0,4130019,1,2),(8,1040110,75,2,98000,0,0,4130019,1,2),(8,1040115,85,2,126000,0,0,4130019,1,2),(8,1040116,85,2,126000,0,0,4130019,1,2),(8,1040117,85,2,126000,0,0,4130019,1,2),(8,1040118,85,2,126000,0,0,4130019,1,2),(8,1041077,45,1,37500,0,0,4130019,1,1),(8,1041078,45,1,37500,0,0,4130019,1,1),(8,1041079,45,1,37500,0,0,4130019,1,1),(8,1041080,45,1,37500,0,0,4130019,1,1),(8,1041094,55,1,45000,0,0,4130019,1,1),(8,1041095,55,1,45000,0,0,4130019,1,1),(8,1041096,55,1,45000,0,0,4130019,1,1),(8,1041100,65,1,50000,0,0,4130019,1,1),(8,1041101,65,1,50000,0,0,4130019,1,1),(8,1041102,65,1,50000,0,0,4130019,1,1),(8,1041103,65,1,50000,0,0,4130019,1,1),(8,1041105,75,2,98000,0,0,4130019,1,2),(8,1041106,75,2,98000,0,0,4130019,1,2),(8,1041107,75,2,98000,0,0,4130019,1,2),(8,1041115,85,2,126000,0,0,4130019,1,2),(8,1041116,85,2,126000,0,0,4130019,1,2),(8,1041117,85,2,126000,0,0,4130019,1,2),(8,1041118,85,2,126000,0,0,4130019,1,2),(8,1050096,95,2,168000,0,0,4130021,1,2),(8,1050097,95,2,168000,0,0,4130021,1,2),(8,1050098,95,2,168000,0,0,4130021,1,2),(8,1050099,95,2,168000,0,0,4130021,1,2),(8,1051090,95,2,168000,0,0,4130021,1,2),(8,1051091,95,2,168000,0,0,4130021,1,2),(8,1051092,95,2,168000,0,0,4130021,1,2),(8,1051093,95,2,168000,0,0,4130021,1,2),(8,1052072,105,3,300000,0,0,4130021,1,3),(8,1052158,115,3,360000,0,0,4130021,1,3),(8,1052163,115,3,360000,0,0,4130021,1,3),(8,1060083,45,1,30000,0,0,4130020,1,1),(8,1060084,45,1,30000,0,0,4130020,1,1),(8,1060085,45,1,30000,0,0,4130020,1,1),(8,1060086,45,1,30000,0,0,4130020,1,1),(8,1060087,55,1,37500,0,0,4130020,1,1),(8,1060088,55,1,37500,0,0,4130020,1,1),(8,1060089,55,1,37500,0,0,4130020,1,1),(8,1060093,65,1,45000,0,0,4130020,1,1),(8,1060094,65,1,45000,0,0,4130020,1,1),(8,1060095,65,1,45000,0,0,4130020,1,1),(8,1060097,75,2,84000,0,0,4130020,1,2),(8,1060098,75,2,84000,0,0,4130020,1,2),(8,1060099,75,2,84000,0,0,4130020,1,2),(8,1060104,85,2,112000,0,0,4130020,1,2),(8,1060105,85,2,112000,0,0,4130020,1,2),(8,1060106,85,2,112000,0,0,4130020,1,2),(8,1060107,85,2,112000,0,0,4130020,1,2),(8,1061076,45,1,30000,0,0,4130020,1,1),(8,1061077,45,1,30000,0,0,4130020,1,1),(8,1061078,45,1,30000,0,0,4130020,1,1),(8,1061079,45,1,30000,0,0,4130020,1,1),(8,1061093,55,1,37500,0,0,4130020,1,1),(8,1061094,55,1,37500,0,0,4130020,1,1),(8,1061095,55,1,37500,0,0,4130020,1,1),(8,1061099,65,1,45000,0,0,4130020,1,1),(8,1061100,65,1,45000,0,0,4130020,1,1),(8,1061101,65,1,45000,0,0,4130020,1,1),(8,1061102,65,1,45000,0,0,4130020,1,1),(8,1061104,75,2,84000,0,0,4130020,1,2),(8,1061105,75,2,84000,0,0,4130020,1,2),(8,1061106,75,2,84000,0,0,4130020,1,2),(8,1061114,85,2,112000,0,0,4130020,1,2),(8,1061115,85,2,112000,0,0,4130020,1,2),(8,1061116,85,2,112000,0,0,4130020,1,2),(8,1061117,85,2,112000,0,0,4130020,1,2),(8,1072128,45,1,25000,0,0,4130001,1,1),(8,1072129,45,1,25000,0,0,4130001,1,1),(8,1072130,45,1,25000,0,0,4130001,1,1),(8,1072131,45,1,25000,0,0,4130001,1,1),(8,1072150,55,1,32500,0,0,4130001,1,1),(8,1072151,55,1,32500,0,0,4130001,1,1),(8,1072152,55,1,35000,0,0,4130001,1,1),(8,1072161,65,1,45000,0,0,4130001,1,1),(8,1072162,65,1,45000,0,0,4130001,1,1),(8,1072163,65,1,45000,0,0,4130001,1,1),(8,1072172,75,2,77000,0,0,4130001,1,2),(8,1072173,75,2,77000,0,0,4130001,1,2),(8,1072174,75,2,77000,0,0,4130001,1,2),(8,1072192,85,2,98000,0,0,4130001,1,2),(8,1072193,85,2,98000,0,0,4130001,1,2),(8,1072194,85,2,98000,0,0,4130001,1,2),(8,1072195,85,2,98000,0,0,4130001,1,2),(8,1072213,95,2,119000,0,0,4130001,1,2),(8,1072214,95,2,119000,0,0,4130001,1,2),(8,1072215,95,2,119000,0,0,4130001,1,2),(8,1072216,95,2,119000,0,0,4130001,1,2),(8,1072272,105,3,195000,0,0,4130001,1,3),(8,1072358,115,3,225000,0,0,4130001,1,3),(8,1072364,115,3,225000,0,0,4130001,1,3),(8,1082065,45,1,42500,0,0,4130000,1,1),(8,1082066,45,1,47500,0,0,4130000,1,1),(8,1082067,45,1,45000,0,0,4130000,1,1),(8,1082092,55,1,55000,0,0,4130000,1,1),(8,1082093,55,1,60000,0,0,4130000,1,1),(8,1082094,55,1,65000,0,0,4130000,1,1),(8,1082095,65,1,75000,0,0,4130000,1,1),(8,1082096,65,1,80000,0,0,4130000,1,1),(8,1082097,65,1,85000,0,0,4130000,1,1),(8,1082118,75,2,140000,0,0,4130000,1,2),(8,1082119,75,2,143500,0,0,4130000,1,2),(8,1082120,75,2,147000,0,0,4130000,1,2),(8,1082135,95,2,182000,0,0,4130000,1,2),(8,1082136,95,2,185500,0,0,4130000,1,2),(8,1082137,95,2,185500,0,0,4130000,1,2),(8,1082138,95,2,189000,0,0,4130000,1,2),(8,1082142,85,2,150500,0,0,4130000,1,2),(8,1082143,85,2,150500,0,0,4130000,1,2),(8,1082144,85,2,150500,0,0,4130000,1,2),(8,1082167,105,3,300000,0,0,4130000,1,3),(8,1082237,115,3,330000,0,0,4130000,1,3),(8,1082242,115,3,330000,0,0,4130000,1,3),(8,1092059,115,3,350000,0,0,4130022,1,3),(8,1332003,45,1,110000,0,0,4130014,1,1),(8,1332015,55,1,125000,0,0,4130014,1,1),(8,1332016,45,1,110000,0,0,4130014,1,1),(8,1332017,55,1,125000,0,0,4130014,1,1),(8,1332018,65,1,140000,0,0,4130014,1,1),(8,1332019,65,1,140000,0,0,4130014,1,1),(8,1332022,75,2,217000,0,0,4130014,1,2),(8,1332023,75,2,217000,0,0,4130014,1,2),(8,1332026,85,2,238000,0,0,4130014,1,2),(8,1332027,85,2,238000,0,0,4130014,1,2),(8,1332049,105,3,450000,0,0,4130014,1,3),(8,1332050,105,3,450000,0,0,4130014,1,3),(8,1332051,95,2,280000,0,0,4130014,1,2),(8,1332052,95,2,280000,0,0,4130014,1,2),(8,1332073,115,3,500000,0,0,4130014,1,3),(8,1332074,115,3,510000,0,0,4130014,1,3),(8,1332075,115,3,500000,0,0,4130014,1,3),(8,1332076,115,3,500000,0,0,4130014,1,3),(8,1472018,45,1,50000,0,0,4130015,1,1),(8,1472019,45,1,52500,0,0,4130015,1,1),(8,1472020,45,1,52500,0,0,4130015,1,1),(8,1472021,45,1,55000,0,0,4130015,1,1),(8,1472022,55,1,125000,0,0,4130015,1,1),(8,1472023,55,1,127500,0,0,4130015,1,1),(8,1472024,55,1,127500,0,0,4130015,1,1),(8,1472025,55,1,130000,0,0,4130015,1,1),(8,1472026,65,1,150000,0,0,4130015,1,1),(8,1472027,65,1,152500,0,0,4130015,1,1),(8,1472028,65,1,152500,0,0,4130015,1,1),(8,1472029,65,1,155000,0,0,4130015,1,1),(8,1472031,75,2,280000,0,0,4130015,1,2),(8,1472033,85,2,315000,0,0,4130015,1,2),(8,1472051,105,3,570000,0,0,4130015,1,3),(8,1472052,105,3,570000,0,0,4130015,1,3),(8,1472053,95,2,357000,0,0,4130015,1,2),(8,1472068,115,3,630000,0,0,4130015,1,3),(8,1472071,115,3,630000,0,0,4130015,1,3),(16,1002631,45,1,20000,0,0,4130018,1,1),(16,1002634,55,1,27500,0,0,4130018,1,1),(16,1002637,65,1,42500,0,0,4130018,1,1),(16,1002640,75,2,70000,0,0,4130018,1,2),(16,1002643,85,2,80500,0,0,4130018,1,2),(16,1002646,95,2,91000,0,0,4130018,1,2),(16,1002649,105,3,150000,0,0,4130018,1,3),(16,1002780,115,3,170000,0,0,4130018,1,3),(16,1002794,115,3,170000,0,0,4130018,1,3),(16,1052116,45,1,47500,0,0,4130021,1,1),(16,1052119,55,1,50000,0,0,4130021,1,1),(16,1052122,65,1,57500,0,0,4130021,1,1),(16,1052125,75,2,126000,0,0,4130021,1,2),(16,1052128,85,2,140000,0,0,4130021,1,2),(16,1052131,95,2,168000,0,0,4130021,1,2),(16,1052134,105,3,300000,0,0,4130021,1,3),(16,1052159,115,3,360000,0,0,4130021,1,3),(16,1052164,115,3,360000,0,0,4130021,1,3),(16,1072303,45,1,25000,0,0,4130001,1,1),(16,1072306,55,1,32500,0,0,4130001,1,1),(16,1072309,65,1,45000,0,0,4130001,1,1),(16,1072312,75,2,77000,0,0,4130001,1,2),(16,1072315,85,2,98000,0,0,4130001,1,2),(16,1072318,95,2,119000,0,0,4130001,1,2),(16,1072321,105,3,180000,0,0,4130001,1,3),(16,1072359,115,3,200000,0,0,4130001,1,3),(16,1072365,115,3,200000,0,0,4130001,1,3),(16,1082198,45,1,42500,0,0,4130000,1,1),(16,1082201,55,1,55000,0,0,4130000,1,1),(16,1082204,65,1,75000,0,0,4130000,1,1),(16,1082207,75,2,140000,0,0,4130000,1,2),(16,1082210,85,2,161000,0,0,4130000,1,2),(16,1082213,95,2,185500,0,0,4130000,1,2),(16,1082216,105,3,300000,0,0,4130000,1,3),(16,1082238,115,3,335000,0,0,4130000,1,3),(16,1082243,115,3,335000,0,0,4130000,1,3),(16,1482007,45,1,65000,0,0,4130016,1,1),(16,1482008,55,1,120000,0,0,4130016,1,1),(16,1482009,65,1,150000,0,0,4130016,1,1),(16,1482010,75,2,245000,0,0,4130016,1,2),(16,1482011,85,2,273000,0,0,4130016,1,2),(16,1482012,95,2,308000,0,0,4130016,1,2),(16,1482013,105,3,510000,0,0,4130016,1,3),(16,1482023,115,3,560000,0,0,4130016,1,3),(16,1482024,115,3,560000,0,0,4130016,1,3),(16,1492007,45,1,70000,0,0,4130017,1,1),(16,1492008,55,1,125000,0,0,4130017,1,1),(16,1492009,65,1,155000,0,0,4130017,1,1),(16,1492010,75,2,245000,0,0,4130017,1,2),(16,1492011,85,2,280000,0,0,4130017,1,2),(16,1492012,95,2,315000,0,0,4130017,1,2),(16,1492013,105,3,520000,0,0,4130017,1,3),(16,1492023,115,3,570000,0,0,4130017,1,3),(16,1492025,115,3,570000,0,0,4130017,1,3);
/*!40000 ALTER TABLE `makercreatedata` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `makerrecipedata`
--

DROP TABLE IF EXISTS `makerrecipedata`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `makerrecipedata` (
  `itemid` int(11) NOT NULL,
  `req_item` int(11) NOT NULL,
  `count` smallint(6) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `makerrecipedata`
--

LOCK TABLES `makerrecipedata` WRITE;
/*!40000 ALTER TABLE `makerrecipedata` DISABLE KEYS */;
INSERT INTO `makerrecipedata` VALUES (1002022,4007001,5),(1002022,4260000,5),(1002028,4007001,5),(1002028,4260000,5),(1002029,4007006,6),(1002029,4260001,6),(1002030,4007001,7),(1002030,4260002,7),(1002084,4007002,6),(1002084,4260001,6),(1002085,4007002,5),(1002085,4260000,5),(1002086,4007000,5),(1002086,4260000,5),(1002094,4007000,7),(1002094,4260002,7),(1002095,4007002,7),(1002095,4260002,7),(1002100,4007000,5),(1002100,4260000,5),(1002101,4007003,5),(1002101,4260000,5),(1002207,4007006,5),(1002207,4260000,5),(1002208,4007002,5),(1002208,4260000,5),(1002209,4007003,5),(1002209,4260000,5),(1002210,4007004,5),(1002210,4260000,5),(1002211,4007002,5),(1002211,4260000,5),(1002212,4007006,5),(1002212,4260000,5),(1002213,4007003,5),(1002213,4260000,5),(1002214,4007007,5),(1002214,4260000,5),(1002215,4007006,5),(1002215,4260000,5),(1002216,4007002,5),(1002216,4260000,5),(1002217,4007004,5),(1002217,4260000,5),(1002218,4007007,5),(1002218,4260000,5),(1002242,4007006,6),(1002242,4260001,6),(1002243,4007002,6),(1002243,4260001,6),(1002244,4007003,6),(1002244,4260001,6),(1002245,4007001,6),(1002245,4260001,6),(1002246,4007007,6),(1002246,4260001,6),(1002247,4007000,6),(1002247,4260001,6),(1002248,4007001,6),(1002248,4260001,6),(1002249,4007007,6),(1002249,4260001,6),(1002252,4007006,7),(1002252,4260002,7),(1002253,4007002,7),(1002253,4260002,7),(1002254,4007007,7),(1002254,4260002,7),(1002267,4007006,6),(1002267,4260001,6),(1002268,4007000,6),(1002268,4260001,6),(1002269,4007001,6),(1002269,4260001,6),(1002270,4007007,6),(1002270,4260001,6),(1002271,4007003,8),(1002271,4260003,8),(1002272,4007002,8),(1002272,4260003,8),(1002273,4007005,8),(1002273,4260003,8),(1002274,4007007,8),(1002274,4260003,8),(1002275,4007002,8),(1002275,4260003,8),(1002276,4007006,8),(1002276,4260003,8),(1002277,4007003,8),(1002277,4260003,8),(1002278,4007007,8),(1002278,4260003,8),(1002281,4007000,7),(1002281,4260002,7),(1002282,4007002,7),(1002282,4260002,7),(1002283,4007005,7),(1002283,4260002,7),(1002284,4007001,7),(1002284,4260002,7),(1002285,4007006,7),(1002285,4260002,7),(1002286,4007002,7),(1002286,4260002,7),(1002287,4007001,4),(1002287,4007004,3),(1002287,4260002,7),(1002288,4007003,7),(1002288,4260002,7),(1002289,4007007,7),(1002289,4260002,7),(1002323,4007003,9),(1002323,4260004,9),(1002324,4007000,9),(1002324,4260004,9),(1002325,4007005,9),(1002325,4260004,9),(1002326,4007006,9),(1002326,4260004,9),(1002327,4007000,8),(1002327,4260003,8),(1002328,4007003,8),(1002328,4260003,8),(1002329,4007006,8),(1002329,4260003,8),(1002330,4007007,8),(1002330,4260003,8),(1002338,4007006,8),(1002338,4260003,8),(1002339,4007002,8),(1002339,4260003,8),(1002340,4007007,8),(1002340,4260003,8),(1002363,4007003,9),(1002363,4260004,9),(1002364,4007002,9),(1002364,4260004,9),(1002365,4007006,9),(1002365,4260004,9),(1002366,4007007,9),(1002366,4260004,9),(1002377,4007003,10),(1002377,4260005,10),(1002378,4007002,10),(1002378,4260005,10),(1002379,4007007,10),(1002379,4260005,10),(1002380,4007003,10),(1002380,4260005,10),(1002381,4007002,10),(1002381,4260005,10),(1002382,4007006,10),(1002382,4260005,10),(1002383,4007007,10),(1002383,4260005,10),(1002398,4007003,10),(1002398,4260005,10),(1002399,4007002,10),(1002399,4260005,10),(1002400,4007006,10),(1002400,4260005,10),(1002401,4007007,10),(1002401,4260005,10),(1002402,4007006,9),(1002402,4260004,9),(1002403,4007002,9),(1002403,4260004,9),(1002404,4007003,9),(1002404,4260004,9),(1002405,4007007,9),(1002405,4260004,9),(1002406,4007006,10),(1002406,4260005,10),(1002407,4007002,10),(1002407,4260005,10),(1002408,4007003,10),(1002408,4260005,10),(1002528,4007003,9),(1002528,4260004,9),(1002529,4007002,9),(1002529,4260004,9),(1002530,4007006,9),(1002530,4260004,9),(1002531,4007001,9),(1002531,4260004,9),(1002532,4007007,9),(1002532,4260004,9),(1002547,4000244,5),(1002547,4000245,5),(1002547,4007006,11),(1002547,4260006,11),(1002550,4000244,5),(1002550,4000245,5),(1002550,4007007,11),(1002550,4260006,11),(1002551,4000244,5),(1002551,4000245,5),(1002551,4007002,11),(1002551,4260006,11),(1002631,4007000,5),(1002631,4260000,5),(1002634,4007005,6),(1002634,4260001,6),(1002637,4007007,7),(1002637,4260002,7),(1002640,4007002,8),(1002640,4260003,8),(1002643,4007006,9),(1002643,4260004,9),(1002646,4007007,10),(1002646,4260005,10),(1002649,4000244,5),(1002649,4000245,5),(1002649,4007007,11),(1002649,4260006,11),(1002773,4000244,5),(1002773,4000245,5),(1002773,4007004,11),(1002773,4260006,11),(1002776,4007001,12),(1002776,4021010,1),(1002776,4260007,2),(1002776,4260008,10),(1002777,4007002,12),(1002777,4021010,1),(1002777,4260007,2),(1002777,4260008,10),(1002778,4007005,12),(1002778,4021010,1),(1002778,4260007,2),(1002778,4260008,10),(1002779,4007005,12),(1002779,4021010,1),(1002779,4260007,2),(1002779,4260008,10),(1002780,4007006,12),(1002780,4021010,1),(1002780,4260007,2),(1002780,4260008,10),(1002790,4007001,12),(1002790,4020009,15),(1002790,4260007,8),(1002790,4260008,4),(1002791,4007002,12),(1002791,4020009,15),(1002791,4260007,8),(1002791,4260008,4),(1002792,4007005,12),(1002792,4020009,15),(1002792,4260007,8),(1002792,4260008,4),(1002793,4007005,12),(1002793,4020009,15),(1002793,4260007,8),(1002793,4260008,4),(1002794,4007006,12),(1002794,4020009,15),(1002794,4260007,8),(1002794,4260008,4),(1040087,4007002,5),(1040087,4260000,5),(1040088,4007004,5),(1040088,4260000,5),(1040089,4007007,5),(1040089,4260000,5),(1040090,4007003,6),(1040090,4260001,6),(1040091,4007006,6),(1040091,4260001,6),(1040092,4007002,6),(1040092,4260001,6),(1040093,4007007,6),(1040093,4260001,6),(1040094,4007006,5),(1040094,4260000,5),(1040095,4007002,5),(1040095,4260000,5),(1040096,4007004,5),(1040096,4260000,5),(1040097,4007003,5),(1040097,4260000,5),(1040098,4007001,6),(1040098,4260001,6),(1040099,4007004,6),(1040099,4260001,6),(1040100,4007007,6),(1040100,4260001,6),(1040102,4007000,7),(1040102,4260002,7),(1040103,4007002,7),(1040103,4260002,7),(1040104,4007005,7),(1040104,4260002,7),(1040105,4007000,7),(1040105,4260002,7),(1040106,4007002,7),(1040106,4260002,7),(1040107,4007007,7),(1040107,4260002,7),(1040108,4007003,8),(1040108,4260003,8),(1040109,4007006,8),(1040109,4260003,8),(1040110,4007007,8),(1040110,4260003,8),(1040111,4007003,9),(1040111,4260004,9),(1040112,4007002,9),(1040112,4260004,9),(1040113,4007007,9),(1040113,4260004,9),(1040115,4007003,9),(1040115,4260004,9),(1040116,4007000,9),(1040116,4260004,9),(1040117,4007005,9),(1040117,4260004,9),(1040118,4007006,9),(1040118,4260004,9),(1040120,4007003,10),(1040120,4260005,10),(1040121,4007002,10),(1040121,4260005,10),(1040122,4007007,10),(1040122,4260005,10),(1041077,4007005,5),(1041077,4260000,5),(1041078,4007002,5),(1041078,4260000,5),(1041079,4007004,5),(1041079,4260000,5),(1041080,4007006,5),(1041080,4260000,5),(1041087,4007006,5),(1041087,4260000,5),(1041088,4007001,5),(1041088,4260000,5),(1041089,4007007,5),(1041089,4260000,5),(1041091,4007003,6),(1041091,4260001,6),(1041092,4007006,6),(1041092,4260001,6),(1041093,4007002,6),(1041093,4260001,6),(1041094,4007001,6),(1041094,4260001,6),(1041095,4007006,6),(1041095,4260001,6),(1041096,4007007,6),(1041096,4260001,6),(1041097,4007002,7),(1041097,4260002,7),(1041098,4007005,7),(1041098,4260002,7),(1041099,4007006,7),(1041099,4260002,7),(1041100,4007005,7),(1041100,4260002,7),(1041101,4007002,7),(1041101,4260002,7),(1041102,4007006,7),(1041102,4260002,7),(1041103,4007006,7),(1041103,4260002,7),(1041105,4007003,8),(1041105,4260003,8),(1041106,4007006,8),(1041106,4260003,8),(1041107,4007007,8),(1041107,4260003,8),(1041115,4007003,9),(1041115,4260004,9),(1041116,4007000,9),(1041116,4260004,9),(1041117,4007005,9),(1041117,4260004,9),(1041118,4007006,9),(1041118,4260004,9),(1041119,4007003,9),(1041119,4260004,9),(1041120,4007005,9),(1041120,4260004,9),(1041121,4007007,9),(1041121,4260004,9),(1041122,4007003,10),(1041122,4260005,10),(1041123,4007005,10),(1041123,4260005,10),(1041124,4007007,10),(1041124,4260005,10),(1050045,4007002,5),(1050045,4260000,10),(1050046,4007006,5),(1050046,4260000,10),(1050047,4007004,5),(1050047,4260000,10),(1050048,4007001,5),(1050048,4260000,10),(1050049,4007007,5),(1050049,4260000,10),(1050051,4007006,5),(1050051,4260000,10),(1050052,4007002,5),(1050052,4260000,10),(1050053,4007002,6),(1050053,4260001,12),(1050054,4007006,6),(1050054,4260001,12),(1050055,4007001,6),(1050055,4260001,12),(1050056,4007007,6),(1050056,4260001,12),(1050058,4007005,6),(1050058,4260001,12),(1050059,4007002,6),(1050059,4260001,12),(1050060,4007006,6),(1050060,4260001,12),(1050061,4007002,7),(1050061,4260002,14),(1050062,4007001,4),(1050062,4007004,3),(1050062,4260002,14),(1050063,4007003,7),(1050063,4260002,14),(1050064,4007007,7),(1050064,4260002,14),(1050067,4007002,7),(1050067,4260002,14),(1050068,4007006,7),(1050068,4260002,14),(1050069,4007000,7),(1050069,4260002,14),(1050070,4007007,7),(1050070,4260002,14),(1050072,4007003,8),(1050072,4260003,16),(1050073,4007002,8),(1050073,4260003,16),(1050074,4007007,8),(1050074,4260003,16),(1050075,4007006,8),(1050075,4260003,16),(1050076,4007002,8),(1050076,4260003,16),(1050077,4007003,8),(1050077,4260003,16),(1050078,4007007,8),(1050078,4260003,16),(1050080,4007003,8),(1050080,4260003,16),(1050081,4007006,8),(1050081,4260003,16),(1050082,4007002,8),(1050082,4260003,16),(1050083,4007007,8),(1050083,4260003,16),(1050088,4007006,9),(1050088,4260004,18),(1050089,4007002,9),(1050089,4260004,18),(1050090,4007003,9),(1050090,4260004,18),(1050091,4007007,9),(1050091,4260004,18),(1050092,4007003,9),(1050092,4260004,18),(1050093,4007002,9),(1050093,4260004,18),(1050094,4007006,9),(1050094,4260004,18),(1050095,4007007,9),(1050095,4260004,18),(1050096,4007003,10),(1050096,4260005,20),(1050097,4007002,10),(1050097,4260005,20),(1050098,4007006,10),(1050098,4260005,20),(1050099,4007007,10),(1050099,4260005,20),(1050102,4007003,10),(1050102,4260005,20),(1050103,4007002,10),(1050103,4260005,20),(1050104,4007006,10),(1050104,4260005,20),(1050105,4007007,10),(1050105,4260005,20),(1050106,4007003,10),(1050106,4260005,20),(1050107,4007002,10),(1050107,4260005,20),(1050108,4007006,10),(1050108,4260005,20),(1051030,4007007,5),(1051030,4260000,10),(1051031,4007001,5),(1051031,4260000,10),(1051032,4007002,5),(1051032,4260000,10),(1051033,4007006,5),(1051033,4260000,10),(1051034,4007004,5),(1051034,4260000,10),(1051037,4007002,5),(1051037,4260000,10),(1051038,4007003,5),(1051038,4260000,10),(1051039,4007006,5),(1051039,4260000,10),(1051041,4007006,6),(1051041,4260001,12),(1051042,4007002,6),(1051042,4260001,12),(1051043,4007004,6),(1051043,4260001,12),(1051044,4007002,6),(1051044,4260001,12),(1051045,4007006,6),(1051045,4260001,12),(1051046,4007001,6),(1051046,4260001,12),(1051047,4007007,6),(1051047,4260001,12),(1051052,4007002,7),(1051052,4260002,14),(1051053,4007006,7),(1051053,4260002,14),(1051054,4007000,7),(1051054,4260002,14),(1051055,4007007,7),(1051055,4260002,14),(1051056,4007003,8),(1051056,4260003,16),(1051057,4007005,8),(1051057,4260003,16),(1051058,4007007,8),(1051058,4260003,16),(1051062,4007002,7),(1051062,4260002,14),(1051063,4007001,4),(1051063,4007004,3),(1051063,4260002,14),(1051064,4007003,7),(1051064,4260002,14),(1051065,4007007,7),(1051065,4260002,14),(1051066,4007006,8),(1051066,4260003,16),(1051067,4007002,8),(1051067,4260003,16),(1051068,4007003,8),(1051068,4260003,16),(1051069,4007007,8),(1051069,4260003,16),(1051077,4007004,8),(1051077,4260003,16),(1051078,4007006,8),(1051078,4260003,16),(1051079,4007002,8),(1051079,4260003,16),(1051080,4007007,8),(1051080,4260003,16),(1051082,4007006,9),(1051082,4260004,18),(1051083,4007002,9),(1051083,4260004,18),(1051084,4007003,9),(1051084,4260004,18),(1051085,4007007,9),(1051085,4260004,18),(1051090,4007003,10),(1051090,4260005,20),(1051091,4007002,10),(1051091,4260005,20),(1051092,4007006,10),(1051092,4260005,20),(1051093,4007007,10),(1051093,4260005,20),(1051094,4007003,9),(1051094,4260004,18),(1051095,4007002,9),(1051095,4260004,18),(1051096,4007006,9),(1051096,4260004,18),(1051097,4007007,9),(1051097,4260004,18),(1051101,4007003,10),(1051101,4260005,20),(1051102,4007002,10),(1051102,4260005,20),(1051103,4007006,10),(1051103,4260005,20),(1051104,4007007,10),(1051104,4260005,20),(1051105,4007003,10),(1051105,4260005,20),(1051106,4007002,10),(1051106,4260005,20),(1051107,4007006,10),(1051107,4260005,20),(1052071,4000244,5),(1052071,4000245,5),(1052071,4007006,11),(1052071,4260006,22),(1052072,4000244,5),(1052072,4000245,5),(1052072,4007007,11),(1052072,4260006,22),(1052075,4000244,5),(1052075,4000245,5),(1052075,4007002,11),(1052075,4260006,22),(1052076,4000244,5),(1052076,4000245,5),(1052076,4007007,11),(1052076,4260006,22),(1052116,4007003,5),(1052116,4260000,10),(1052119,4007007,6),(1052119,4260001,12),(1052122,4007006,7),(1052122,4260002,14),(1052125,4007001,8),(1052125,4260003,16),(1052128,4007001,9),(1052128,4260004,18),(1052131,4007006,10),(1052131,4260005,20),(1052134,4000244,5),(1052134,4000245,5),(1052134,4007007,11),(1052134,4260006,22),(1052155,4007005,12),(1052155,4021010,1),(1052155,4260007,4),(1052155,4260008,20),(1052156,4007002,12),(1052156,4021010,1),(1052156,4260007,4),(1052156,4260008,20),(1052157,4007005,12),(1052157,4021010,1),(1052157,4260007,4),(1052157,4260008,20),(1052158,4007005,12),(1052158,4021010,1),(1052158,4260007,4),(1052158,4260008,20),(1052159,4007006,12),(1052159,4021010,1),(1052159,4260007,4),(1052159,4260008,20),(1052160,4007005,12),(1052160,4020009,15),(1052160,4260007,16),(1052160,4260008,8),(1052161,4007002,12),(1052161,4020009,15),(1052161,4260007,16),(1052161,4260008,8),(1052162,4007005,12),(1052162,4020009,15),(1052162,4260007,16),(1052162,4260008,8),(1052163,4007005,12),(1052163,4020009,15),(1052163,4260007,16),(1052163,4260008,8),(1052164,4007006,12),(1052164,4020009,15),(1052164,4260007,16),(1052164,4260008,8),(1060076,4007002,5),(1060076,4260000,5),(1060077,4007004,5),(1060077,4260000,5),(1060078,4007007,5),(1060078,4260000,5),(1060079,4007003,6),(1060079,4260001,6),(1060080,4007006,6),(1060080,4260001,6),(1060081,4007002,6),(1060081,4260001,6),(1060082,4007007,6),(1060082,4260001,6),(1060083,4007006,5),(1060083,4260000,5),(1060084,4007002,5),(1060084,4260000,5),(1060085,4007004,5),(1060085,4260000,5),(1060086,4007003,5),(1060086,4260000,5),(1060087,4007001,6),(1060087,4260001,6),(1060088,4007004,6),(1060088,4260001,6),(1060089,4007007,6),(1060089,4260001,6),(1060090,4007000,7),(1060090,4260002,7),(1060091,4007002,7),(1060091,4260002,7),(1060092,4007005,7),(1060092,4260002,7),(1060093,4007000,7),(1060093,4260002,7),(1060094,4007002,7),(1060094,4260002,7),(1060095,4007007,7),(1060095,4260002,7),(1060097,4007003,8),(1060097,4260003,8),(1060098,4007006,8),(1060098,4260003,8),(1060099,4007007,8),(1060099,4260003,8),(1060100,4007003,9),(1060100,4260004,9),(1060101,4007002,9),(1060101,4260004,9),(1060102,4007007,9),(1060102,4260004,9),(1060104,4007003,9),(1060104,4260004,9),(1060105,4007000,9),(1060105,4260004,9),(1060106,4007005,9),(1060106,4260004,9),(1060107,4007006,9),(1060107,4260004,9),(1060109,4007003,10),(1060109,4260005,10),(1060110,4007002,10),(1060110,4260005,10),(1060111,4007007,10),(1060111,4260005,10),(1061076,4007005,5),(1061076,4260000,5),(1061077,4007002,5),(1061077,4260000,5),(1061078,4007004,5),(1061078,4260000,5),(1061079,4007006,5),(1061079,4260000,5),(1061086,4007006,5),(1061086,4260000,5),(1061087,4007001,5),(1061087,4260000,5),(1061088,4007007,5),(1061088,4260000,5),(1061090,4007003,6),(1061090,4260001,6),(1061091,4007006,6),(1061091,4260001,6),(1061092,4007002,6),(1061092,4260001,6),(1061093,4007001,6),(1061093,4260001,6),(1061094,4007006,6),(1061094,4260001,6),(1061095,4007007,6),(1061095,4260001,6),(1061096,4007002,7),(1061096,4260002,7),(1061097,4007005,7),(1061097,4260002,7),(1061098,4007006,7),(1061098,4260002,7),(1061099,4007005,7),(1061099,4260002,7),(1061100,4007002,7),(1061100,4260002,7),(1061101,4007006,7),(1061101,4260002,7),(1061102,4007006,7),(1061102,4260002,7),(1061104,4007003,8),(1061104,4260003,8),(1061105,4007006,8),(1061105,4260003,8),(1061106,4007007,8),(1061106,4260003,8),(1061114,4007003,9),(1061114,4260004,9),(1061115,4007000,9),(1061115,4260004,9),(1061116,4007005,9),(1061116,4260004,9),(1061117,4007006,9),(1061117,4260004,9),(1061118,4007003,9),(1061118,4260004,9),(1061119,4007005,9),(1061119,4260004,9),(1061120,4007006,9),(1061120,4260004,9),(1061121,4007003,10),(1061121,4260005,10),(1061122,4007005,10),(1061122,4260005,10),(1061123,4007007,10),(1061123,4260005,10),(1072122,4007000,5),(1072122,4260000,5),(1072123,4007003,5),(1072123,4260000,5),(1072124,4007002,5),(1072124,4260000,5),(1072125,4007005,5),(1072125,4260000,5),(1072128,4007002,5),(1072128,4260000,5),(1072129,4007003,5),(1072129,4260000,5),(1072130,4007006,5),(1072130,4260000,5),(1072131,4007005,5),(1072131,4260000,5),(1072132,4007003,5),(1072132,4260000,5),(1072133,4007002,5),(1072133,4260000,5),(1072134,4007005,5),(1072134,4260000,5),(1072135,4007004,5),(1072135,4260000,5),(1072136,4007001,3),(1072136,4007006,3),(1072136,4260001,6),(1072137,4007003,6),(1072137,4260001,6),(1072138,4007004,6),(1072138,4260001,6),(1072139,4007002,6),(1072139,4260001,6),(1072140,4007001,2),(1072140,4007006,3),(1072140,4260000,5),(1072141,4007002,5),(1072141,4260000,5),(1072142,4007005,5),(1072142,4260000,5),(1072143,4007003,5),(1072143,4260000,5),(1072144,4007006,6),(1072144,4260001,6),(1072145,4007002,6),(1072145,4260001,6),(1072146,4007003,6),(1072146,4260001,6),(1072147,4007002,6),(1072147,4260001,6),(1072148,4007005,6),(1072148,4260001,6),(1072149,4007006,6),(1072149,4260001,6),(1072150,4007006,6),(1072150,4260001,6),(1072151,4007004,6),(1072151,4260001,6),(1072152,4007007,6),(1072152,4260001,6),(1072154,4007002,7),(1072154,4260002,7),(1072155,4007005,7),(1072155,4260002,7),(1072156,4007007,7),(1072156,4260002,7),(1072157,4007002,7),(1072157,4260002,7),(1072158,4007006,7),(1072158,4260002,7),(1072159,4007000,7),(1072159,4260002,7),(1072160,4007004,7),(1072160,4260002,7),(1072161,4007005,7),(1072161,4260002,7),(1072162,4007002,7),(1072162,4260002,7),(1072163,4007006,7),(1072163,4260002,7),(1072164,4007002,7),(1072164,4260002,7),(1072165,4007001,4),(1072165,4007004,3),(1072165,4260002,7),(1072166,4007003,7),(1072166,4260002,7),(1072167,4007007,7),(1072167,4260002,7),(1072172,4007003,8),(1072172,4260003,8),(1072173,4007006,8),(1072173,4260003,8),(1072174,4007007,8),(1072174,4260003,8),(1072177,4007003,8),(1072177,4260003,8),(1072178,4007005,8),(1072178,4260003,8),(1072179,4007007,8),(1072179,4260003,8),(1072182,4007002,8),(1072182,4260003,8),(1072183,4007006,8),(1072183,4260003,8),(1072184,4007003,8),(1072184,4260003,8),(1072185,4007007,8),(1072185,4260003,8),(1072192,4007003,9),(1072192,4260004,9),(1072193,4007000,9),(1072193,4260004,9),(1072194,4007005,9),(1072194,4260004,9),(1072195,4007006,9),(1072195,4260004,9),(1072196,4007003,9),(1072196,4260004,9),(1072197,4007005,9),(1072197,4260004,9),(1072198,4007007,9),(1072198,4260004,9),(1072203,4007006,9),(1072203,4260004,9),(1072204,4007003,9),(1072204,4260004,9),(1072205,4007007,9),(1072205,4260004,9),(1072206,4007002,9),(1072206,4260004,9),(1072207,4007003,9),(1072207,4260004,9),(1072208,4007006,9),(1072208,4260004,9),(1072209,4007007,9),(1072209,4260004,9),(1072210,4007006,8),(1072210,4260003,8),(1072211,4007002,8),(1072211,4260003,8),(1072212,4007007,8),(1072212,4260003,8),(1072213,4007001,10),(1072213,4260005,10),(1072214,4007002,10),(1072214,4260005,10),(1072215,4007006,10),(1072215,4260005,10),(1072216,4007007,10),(1072216,4260005,10),(1072220,4007003,10),(1072220,4260005,10),(1072221,4007002,10),(1072221,4260005,10),(1072222,4007007,10),(1072222,4260005,10),(1072223,4007003,10),(1072223,4260005,10),(1072224,4007002,10),(1072224,4260005,10),(1072225,4007006,10),(1072225,4260005,10),(1072226,4007007,10),(1072226,4260005,10),(1072227,4007006,10),(1072227,4260005,10),(1072228,4007002,10),(1072228,4260005,10),(1072229,4007003,10),(1072229,4260005,10),(1072268,4000244,5),(1072268,4000245,5),(1072268,4007002,11),(1072268,4260006,11),(1072269,4000244,5),(1072269,4000245,5),(1072269,4007006,11),(1072269,4260006,11),(1072272,4000244,5),(1072272,4000245,5),(1072272,4007007,11),(1072272,4260006,11),(1072273,4000244,5),(1072273,4000245,5),(1072273,4007002,11),(1072273,4260006,11),(1072303,4007000,5),(1072303,4260000,5),(1072306,4007007,6),(1072306,4260001,6),(1072309,4007007,7),(1072309,4260002,7),(1072312,4007002,8),(1072312,4260003,8),(1072315,4007007,9),(1072315,4260004,9),(1072318,4007007,10),(1072318,4260005,10),(1072321,4000244,5),(1072321,4000245,5),(1072321,4007007,11),(1072321,4260006,11),(1072355,4007007,12),(1072355,4021010,1),(1072355,4260007,2),(1072355,4260008,10),(1072356,4007004,12),(1072356,4021010,1),(1072356,4260007,2),(1072356,4260008,10),(1072357,4007005,12),(1072357,4021010,1),(1072357,4260007,2),(1072357,4260008,10),(1072358,4007005,12),(1072358,4021010,1),(1072358,4260007,2),(1072358,4260008,10),(1072359,4007006,12),(1072359,4021010,1),(1072359,4260007,2),(1072359,4260008,10),(1072361,4007007,12),(1072361,4020009,15),(1072361,4260007,8),(1072361,4260008,4),(1072362,4020009,15),(1072362,4260007,8),(1072362,4260008,4),(1072363,4007004,12),(1072363,4020009,15),(1072363,4260007,8),(1072363,4260008,4),(1072364,4007005,12),(1072364,4020009,15),(1072364,4260007,8),(1072364,4260008,4),(1072365,4007006,12),(1072365,4020009,15),(1072365,4260007,8),(1072365,4260008,4),(1082009,4007001,5),(1082009,4260000,5),(1082010,4007007,5),(1082010,4260000,5),(1082011,4007004,5),(1082011,4260000,5),(1082059,4007000,6),(1082059,4260001,6),(1082060,4007002,6),(1082060,4260001,6),(1082061,4007007,6),(1082061,4260001,6),(1082065,4007002,5),(1082065,4260000,5),(1082066,4007004,5),(1082066,4260000,5),(1082067,4007006,5),(1082067,4260000,5),(1082080,4007007,5),(1082080,4260000,5),(1082081,4007006,5),(1082081,4260000,5),(1082082,4007002,5),(1082082,4260000,5),(1082083,4007007,5),(1082083,4260000,5),(1082084,4007002,5),(1082084,4260000,5),(1082085,4007006,5),(1082085,4260000,5),(1082086,4007001,6),(1082086,4260001,6),(1082087,4007004,6),(1082087,4260001,6),(1082088,4007007,6),(1082088,4260001,6),(1082089,4007004,6),(1082089,4260001,6),(1082090,4007006,6),(1082090,4260001,6),(1082091,4007007,6),(1082091,4260001,6),(1082092,4007000,6),(1082092,4260001,6),(1082093,4007001,6),(1082093,4260001,6),(1082094,4007004,6),(1082094,4260001,6),(1082095,4007000,7),(1082095,4260002,7),(1082096,4007001,7),(1082096,4260002,7),(1082097,4007004,7),(1082097,4260002,7),(1082098,4007000,7),(1082098,4260002,7),(1082099,4007002,7),(1082099,4260002,7),(1082100,4007007,7),(1082100,4260002,7),(1082103,4007000,7),(1082103,4260002,7),(1082104,4007002,7),(1082104,4260002,7),(1082105,4007007,7),(1082105,4260002,7),(1082106,4007002,7),(1082106,4260002,7),(1082107,4007004,7),(1082107,4260002,7),(1082108,4007007,7),(1082108,4260002,7),(1082109,4007006,8),(1082109,4260003,8),(1082110,4007002,8),(1082110,4260003,8),(1082111,4007003,8),(1082111,4260003,8),(1082112,4007007,8),(1082112,4260003,8),(1082114,4007002,8),(1082114,4260003,8),(1082115,4007003,8),(1082115,4260003,8),(1082116,4007006,8),(1082116,4260003,8),(1082117,4007007,8),(1082117,4260003,8),(1082118,4007003,8),(1082118,4260003,8),(1082119,4007005,8),(1082119,4260003,8),(1082120,4007006,8),(1082120,4260003,8),(1082121,4007003,8),(1082121,4260003,8),(1082122,4007002,8),(1082122,4260003,8),(1082123,4007007,8),(1082123,4260003,8),(1082125,4007006,9),(1082125,4260004,9),(1082126,4007003,9),(1082126,4260004,9),(1082127,4007007,9),(1082127,4260004,9),(1082128,4007003,9),(1082128,4260004,9),(1082129,4007005,9),(1082129,4260004,9),(1082130,4007007,9),(1082130,4260004,9),(1082131,4007002,9),(1082131,4260004,9),(1082132,4007003,9),(1082132,4260004,9),(1082133,4007006,9),(1082133,4260004,9),(1082134,4007007,9),(1082134,4260004,9),(1082135,4007002,10),(1082135,4260005,10),(1082136,4007003,10),(1082136,4260005,10),(1082137,4007006,10),(1082137,4260005,10),(1082138,4007007,10),(1082138,4260005,10),(1082139,4007003,10),(1082139,4260005,10),(1082140,4007002,10),(1082140,4260005,10),(1082141,4007007,10),(1082141,4260005,10),(1082142,4007003,9),(1082142,4260004,9),(1082143,4007005,9),(1082143,4260004,9),(1082144,4007007,9),(1082144,4260004,9),(1082151,4007003,10),(1082151,4260005,10),(1082152,4007002,10),(1082152,4260005,10),(1082153,4007006,10),(1082153,4260005,10),(1082154,4007005,10),(1082154,4260005,10),(1082158,4007006,10),(1082158,4260005,10),(1082159,4007002,10),(1082159,4260005,10),(1082160,4007003,10),(1082160,4260005,10),(1082163,4000244,5),(1082163,4000245,5),(1082163,4007006,11),(1082163,4260006,11),(1082164,4000244,5),(1082164,4000245,5),(1082164,4007002,11),(1082164,4260006,11),(1082167,4000244,5),(1082167,4000245,5),(1082167,4007007,11),(1082167,4260006,11),(1082168,4000244,5),(1082168,4000245,5),(1082168,4007002,11),(1082168,4260006,11),(1082198,4007000,5),(1082198,4260000,5),(1082201,4007007,6),(1082201,4260001,6),(1082204,4007007,7),(1082204,4260002,7),(1082207,4007002,8),(1082207,4260003,8),(1082210,4007006,9),(1082210,4260004,9),(1082213,4007007,10),(1082213,4260005,10),(1082216,4000244,5),(1082216,4000245,5),(1082216,4007007,11),(1082216,4260006,11),(1082234,4007007,12),(1082234,4021010,1),(1082234,4260007,2),(1082234,4260008,10),(1082235,4007002,12),(1082235,4021010,1),(1082235,4260007,2),(1082235,4260008,10),(1082236,4007001,12),(1082236,4021010,1),(1082236,4260007,2),(1082236,4260008,10),(1082237,4007005,12),(1082237,4021010,1),(1082237,4260007,2),(1082237,4260008,10),(1082238,4007006,12),(1082238,4021010,1),(1082238,4260007,2),(1082238,4260008,10),(1082239,4007007,12),(1082239,4020009,15),(1082239,4260007,8),(1082239,4260008,4),(1082240,4007002,12),(1082240,4020009,15),(1082240,4260007,8),(1082240,4260008,4),(1082241,4007001,12),(1082241,4020009,15),(1082241,4260007,8),(1082241,4260008,4),(1082242,4007005,12),(1082242,4020009,15),(1082242,4260007,8),(1082242,4260008,4),(1082243,4007006,12),(1082243,4020009,15),(1082243,4260007,8),(1082243,4260008,4),(1092004,4007001,5),(1092004,4260000,5),(1092009,4007000,6),(1092009,4260001,6),(1092010,4007001,6),(1092010,4260001,6),(1092011,4007004,6),(1092011,4260001,6),(1092015,4007001,7),(1092015,4260002,7),(1092016,4007001,7),(1092016,4260002,7),(1092017,4007004,7),(1092017,4260002,7),(1092023,4007001,8),(1092023,4260003,8),(1092024,4007001,8),(1092024,4260003,8),(1092025,4007004,8),(1092025,4260003,8),(1092026,4007000,9),(1092026,4260004,9),(1092027,4007001,9),(1092027,4260004,9),(1092028,4007004,9),(1092028,4260004,9),(1092036,4007003,10),(1092036,4260005,10),(1092037,4007005,10),(1092037,4260005,10),(1092038,4007002,10),(1092038,4260005,10),(1092057,4007004,12),(1092057,4021010,1),(1092057,4260007,2),(1092057,4260008,10),(1092058,4007002,12),(1092058,4021010,1),(1092058,4260007,2),(1092058,4260008,10),(1092059,4007000,12),(1092059,4021010,1),(1092059,4260007,2),(1092059,4260008,10),(1092060,4000244,5),(1092060,4000245,5),(1092060,4007001,11),(1092060,4260006,11),(1302010,4011000,1),(1302010,4260000,20),(1302011,4011001,2),(1302011,4260001,22),(1302012,4011001,3),(1302012,4260002,24),(1302018,4011002,3),(1302018,4260003,26),(1302023,4011002,4),(1302023,4260004,28),(1302056,4011003,4),(1302056,4260005,30),(1302059,4000244,20),(1302059,4000245,20),(1302059,4011003,5),(1302059,4260006,32),(1302081,4011005,5),(1302081,4021010,3),(1302081,4260007,14),(1302081,4260008,20),(1302086,4011005,5),(1302086,4020009,45),(1302086,4260007,20),(1302086,4260008,14),(1312008,4011000,1),(1312008,4260000,20),(1312009,4011001,2),(1312009,4260001,22),(1312010,4011001,3),(1312010,4260002,24),(1312011,4011002,3),(1312011,4260003,26),(1312015,4011002,4),(1312015,4260004,28),(1312030,4011003,4),(1312030,4260005,30),(1312031,4000244,20),(1312031,4000245,20),(1312031,4011003,5),(1312031,4260006,32),(1312037,4011005,5),(1312037,4021010,3),(1312037,4260007,14),(1312037,4260008,20),(1312038,4011005,5),(1312038,4020009,45),(1312038,4260007,20),(1312038,4260008,14),(1322017,4011000,1),(1322017,4260000,20),(1322018,4011001,2),(1322018,4260001,22),(1322019,4011001,3),(1322019,4260002,24),(1322020,4011001,3),(1322020,4260002,24),(1322028,4011002,3),(1322028,4260003,26),(1322029,4011002,4),(1322029,4260004,28),(1322045,4011003,4),(1322045,4260005,30),(1322052,4000244,20),(1322052,4000245,20),(1322052,4011003,5),(1322052,4260006,32),(1322060,4011005,5),(1322060,4021010,3),(1322060,4260007,14),(1322060,4260008,20),(1322061,4011005,5),(1322061,4020009,45),(1322061,4260007,20),(1322061,4260008,14),(1332003,4011000,1),(1332003,4260000,20),(1332015,4011001,2),(1332015,4260001,22),(1332016,4011000,1),(1332016,4260000,20),(1332017,4011001,2),(1332017,4260001,22),(1332018,4011001,3),(1332018,4260002,24),(1332019,4011001,3),(1332019,4260002,24),(1332022,4011002,3),(1332022,4260003,26),(1332023,4011002,3),(1332023,4260003,26),(1332026,4011002,4),(1332026,4260004,28),(1332027,4011002,4),(1332027,4260004,28),(1332049,4000244,20),(1332049,4000245,20),(1332049,4011003,5),(1332049,4260006,32),(1332050,4000244,20),(1332050,4000245,20),(1332050,4011003,5),(1332050,4260006,32),(1332051,4011003,4),(1332051,4260005,30),(1332052,4011003,4),(1332052,4260005,30),(1332073,4011005,5),(1332073,4021010,3),(1332073,4260007,14),(1332073,4260008,20),(1332074,4011005,5),(1332074,4021010,3),(1332074,4260007,14),(1332074,4260008,20),(1332075,4011005,5),(1332075,4020009,45),(1332075,4260007,20),(1332075,4260008,14),(1332076,4011005,5),(1332076,4020009,45),(1332076,4260007,20),(1332076,4260008,14),(1372007,4011000,1),(1372007,4260000,20),(1372009,4011002,4),(1372009,4260004,28),(1372010,4011003,4),(1372010,4260005,30),(1372014,4011001,2),(1372014,4260001,22),(1372015,4011001,3),(1372015,4260002,24),(1372016,4011002,3),(1372016,4260003,26),(1372032,4000244,20),(1372032,4000245,20),(1372032,4011003,5),(1372032,4260006,32),(1372044,4011005,5),(1372044,4021010,3),(1372044,4260007,14),(1372044,4260008,20),(1372045,4011005,5),(1372045,4020009,45),(1372045,4260007,20),(1372045,4260008,14),(1382006,4011000,1),(1382006,4260000,20),(1382007,4011001,2),(1382007,4260001,22),(1382008,4011002,3),(1382008,4260003,26),(1382010,4011001,3),(1382010,4260002,24),(1382035,4011002,4),(1382035,4260004,28),(1382036,4000244,20),(1382036,4000245,20),(1382036,4011003,5),(1382036,4260006,32),(1382057,4011005,5),(1382057,4021010,3),(1382057,4260007,14),(1382057,4260008,20),(1382059,4011005,5),(1382059,4020009,45),(1382059,4260007,20),(1382059,4260008,14),(1402003,4011000,1),(1402003,4260000,20),(1402004,4011002,3),(1402004,4260003,26),(1402005,4011002,4),(1402005,4260004,28),(1402011,4011001,2),(1402011,4260001,22),(1402012,4011001,3),(1402012,4260002,24),(1402015,4011002,3),(1402015,4260003,26),(1402016,4011002,4),(1402016,4260004,28),(1402035,4011003,4),(1402035,4260005,30),(1402036,4000244,20),(1402036,4000245,20),(1402036,4011003,5),(1402036,4260006,32),(1402046,4011005,5),(1402046,4021010,3),(1402046,4260007,14),(1402046,4260008,20),(1402047,4011005,5),(1402047,4020009,45),(1402047,4260007,20),(1402047,4260008,14),(1412003,4011000,1),(1412003,4260000,20),(1412007,4011001,2),(1412007,4260001,22),(1412008,4011001,3),(1412008,4260002,24),(1412009,4011002,3),(1412009,4260003,26),(1412010,4011002,4),(1412010,4260004,28),(1412021,4011003,4),(1412021,4260005,30),(1412026,4000244,20),(1412026,4000245,20),(1412026,4011003,5),(1412026,4260006,32),(1412033,4011005,5),(1412033,4021010,3),(1412033,4260007,14),(1412033,4260008,20),(1412034,4011005,5),(1412034,4020009,45),(1412034,4260007,20),(1412034,4260008,14),(1422005,4011000,1),(1422005,4260000,20),(1422009,4011001,2),(1422009,4260001,22),(1422010,4011001,3),(1422010,4260002,24),(1422012,4011002,3),(1422012,4260003,26),(1422013,4011002,4),(1422013,4260004,28),(1422027,4011003,4),(1422027,4260005,30),(1422028,4000244,20),(1422028,4000245,20),(1422028,4011003,5),(1422028,4260006,32),(1422037,4011005,5),(1422037,4021010,3),(1422037,4260007,14),(1422037,4260008,20),(1422038,4011005,5),(1422038,4020009,45),(1422038,4260007,20),(1422038,4260008,14),(1432004,4011000,1),(1432004,4260000,20),(1432006,4011001,2),(1432006,4260001,22),(1432007,4011001,3),(1432007,4260002,24),(1432010,4011002,3),(1432010,4260003,26),(1432011,4011002,4),(1432011,4260004,28),(1432030,4011003,4),(1432030,4260005,30),(1432038,4000244,20),(1432038,4000245,20),(1432038,4011003,5),(1432038,4260006,32),(1432047,4011005,5),(1432047,4021010,3),(1432047,4260007,14),(1432047,4260008,20),(1432049,4011005,5),(1432049,4020009,45),(1432049,4260007,20),(1432049,4260008,14),(1442005,4011000,1),(1442005,4260000,20),(1442008,4011001,3),(1442008,4260002,24),(1442010,4011001,2),(1442010,4260001,22),(1442019,4011002,3),(1442019,4260003,26),(1442020,4011002,4),(1442020,4260004,28),(1442044,4011003,4),(1442044,4260005,30),(1442045,4000244,20),(1442045,4000245,20),(1442045,4011003,5),(1442045,4260006,32),(1442063,4011005,5),(1442063,4021010,3),(1442063,4260007,14),(1442063,4260008,20),(1442067,4011005,5),(1442067,4020009,45),(1442067,4260007,20),(1442067,4260008,14),(1452004,4011001,2),(1452004,4260001,22),(1452008,4011000,1),(1452008,4260000,20),(1452009,4007006,7),(1452009,4011001,3),(1452009,4260002,24),(1452010,4007002,7),(1452010,4011001,3),(1452010,4260002,24),(1452011,4007004,7),(1452011,4011001,3),(1452011,4260002,24),(1452012,4007002,8),(1452012,4011002,3),(1452012,4260003,26),(1452013,4007006,8),(1452013,4011002,3),(1452013,4260003,26),(1452014,4007004,8),(1452014,4011002,3),(1452014,4260003,26),(1452015,4007007,8),(1452015,4011002,3),(1452015,4260003,26),(1452017,4011002,4),(1452017,4260004,28),(1452019,4007001,10),(1452019,4011003,4),(1452019,4260005,30),(1452020,4007004,10),(1452020,4011003,4),(1452020,4260005,30),(1452021,4007007,10),(1452021,4011003,4),(1452021,4260005,30),(1452044,4000244,20),(1452044,4000245,20),(1452044,4011003,5),(1452044,4260006,32),(1452057,4011005,5),(1452057,4021010,3),(1452057,4260007,14),(1452057,4260008,20),(1452059,4011005,5),(1452059,4020009,45),(1452059,4260007,20),(1452059,4260008,14),(1462007,4011000,1),(1462007,4260000,20),(1462008,4011001,2),(1462008,4260001,22),(1462009,4011001,3),(1462009,4260002,24),(1462010,4007002,8),(1462010,4011002,3),(1462010,4260003,26),(1462011,4007006,8),(1462011,4011002,3),(1462011,4260003,26),(1462012,4007004,8),(1462012,4011002,3),(1462012,4260003,26),(1462013,4007007,8),(1462013,4011002,3),(1462013,4260003,26),(1462015,4007001,10),(1462015,4011003,4),(1462015,4260005,30),(1462016,4007004,10),(1462016,4011003,4),(1462016,4260005,30),(1462017,4007007,10),(1462017,4011003,4),(1462017,4260005,30),(1462018,4011002,4),(1462018,4260004,28),(1462039,4000244,20),(1462039,4000245,20),(1462039,4011003,5),(1462039,4260006,32),(1462050,4011005,5),(1462050,4021010,3),(1462050,4260007,14),(1462050,4260008,20),(1462051,4011005,5),(1462051,4020009,45),(1462051,4260007,20),(1462051,4260008,14),(1472018,4007001,5),(1472018,4011000,1),(1472018,4260000,20),(1472019,4007006,5),(1472019,4011000,1),(1472019,4260000,20),(1472020,4007002,5),(1472020,4011000,1),(1472020,4260000,20),(1472021,4007007,5),(1472021,4011000,1),(1472021,4260000,20),(1472022,4007000,6),(1472022,4011001,2),(1472022,4260001,22),(1472023,4007006,6),(1472023,4011001,2),(1472023,4260001,22),(1472024,4007002,6),(1472024,4011001,2),(1472024,4260001,22),(1472025,4007007,6),(1472025,4011001,2),(1472025,4260001,22),(1472026,4007004,7),(1472026,4011001,3),(1472026,4260002,24),(1472027,4007003,7),(1472027,4011001,3),(1472027,4260002,24),(1472028,4007002,7),(1472028,4011001,3),(1472028,4260002,24),(1472029,4007007,7),(1472029,4011001,3),(1472029,4260002,24),(1472031,4011002,3),(1472031,4260003,26),(1472033,4011002,4),(1472033,4260004,28),(1472051,4000244,20),(1472051,4000245,20),(1472051,4007003,11),(1472051,4011003,5),(1472051,4260006,32),(1472052,4000244,20),(1472052,4000245,20),(1472052,4007005,11),(1472052,4011003,5),(1472052,4260006,32),(1472053,4011003,4),(1472053,4260005,30),(1472068,4011005,5),(1472068,4021010,3),(1472068,4260007,14),(1472068,4260008,20),(1472071,4011005,5),(1472071,4020009,45),(1472071,4260007,20),(1472071,4260008,14),(1482007,4011000,1),(1482007,4260000,20),(1482008,4011001,2),(1482008,4260001,22),(1482009,4011001,3),(1482009,4260002,24),(1482010,4011002,3),(1482010,4260003,26),(1482011,4011002,4),(1482011,4260004,28),(1482012,4011003,4),(1482012,4260005,30),(1482013,4000244,20),(1482013,4000245,20),(1482013,4011003,5),(1482013,4260006,32),(1482023,4011005,5),(1482023,4021010,3),(1482023,4260007,14),(1482023,4260008,20),(1482024,4011005,5),(1482024,4020009,45),(1482024,4260007,20),(1482024,4260008,14),(1492007,4011000,1),(1492007,4260000,20),(1492008,4011001,2),(1492008,4260001,22),(1492009,4011001,3),(1492009,4260002,24),(1492010,4011002,3),(1492010,4260003,26),(1492011,4011002,4),(1492011,4260004,28),(1492012,4011003,4),(1492012,4260005,30),(1492013,4000244,20),(1492013,4000245,20),(1492013,4011003,5),(1492013,4260006,32),(1492023,4011005,5),(1492023,4021010,3),(1492023,4260007,14),(1492023,4260008,20),(1492025,4011005,5),(1492025,4020009,45),(1492025,4260007,20),(1492025,4260008,14),(2040727,4000159,50),(2040727,4000299,10),(2041058,4000048,100),(2041058,4000299,10),(4001174,4000155,10),(4001174,4000277,5),(4001174,4000278,5),(4001174,4031966,1),(4001175,4000030,3),(4001175,4000048,20),(4001175,4031967,1),(4001176,4000360,30),(4001176,4003001,20),(4001176,4011001,5),(4001176,4031968,1),(4001177,4000052,100),(4001177,4007001,10),(4001177,4031969,1),(4001178,4000286,25),(4001178,4000295,25),(4001178,4007002,1),(4001178,4031970,1),(4001179,4000122,7),(4001179,4000364,70),(4001179,4003000,7),(4001179,4031971,1),(4001180,4000074,10),(4001180,4000229,30),(4001180,4007000,1),(4001180,4031972,1),(4001181,4000238,30),(4001181,4003005,20),(4001181,4007006,1),(4001181,4031973,1),(4001182,4000239,12),(4001182,4000240,1),(4001182,4003004,36),(4001182,4007001,6),(4001182,4031974,1),(4001183,4000232,30),(4001183,4000285,30),(4001183,4007001,3),(4001183,4031975,1),(4001184,4000182,30),(4001184,4003001,10),(4001184,4011001,10),(4001184,4031976,1),(4001185,4000081,5),(4001185,4000134,30),(4001185,4003005,20),(4001185,4031977,1),(4001186,4003005,30),(4001186,4005001,1),(4001186,4021007,10),(4001186,4021009,1),(4001186,4031978,1),(4031980,4011001,2),(4031980,4011006,6),(4031980,4011008,1),(4031980,4031979,1),(4250000,4021007,1),(4250001,4250000,10),(4250002,4250001,10),(4250100,4021005,1),(4250101,4250100,10),(4250102,4250101,10),(4250200,4021000,1),(4250201,4250200,10),(4250202,4250201,10),(4250300,4021004,1),(4250301,4250300,10),(4250302,4250301,10),(4250400,4021001,1),(4250401,4250400,10),(4250402,4250401,10),(4250500,4021002,1),(4250501,4250500,10),(4250502,4250501,10),(4250600,4021006,1),(4250601,4250600,10),(4250602,4250601,10),(4250700,4021003,1),(4250701,4250700,10),(4250702,4250701,10),(4250800,4005000,1),(4250801,4250800,10),(4250802,4250801,10),(4250900,4005001,1),(4250901,4250900,10),(4250902,4250901,10),(4251000,4005003,1),(4251001,4251000,10),(4251002,4251001,10),(4251100,4005002,1),(4251101,4251100,10),(4251102,4251101,10),(4251300,4021008,1),(4251301,4251300,10),(4251302,4251301,10),(4251400,4005004,1),(4251401,4251400,10),(4251402,4251401,10);
/*!40000 ALTER TABLE `makerrecipedata` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `makerrewarddata`
--

DROP TABLE IF EXISTS `makerrewarddata`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `makerrewarddata` (
  `itemid` int(11) NOT NULL,
  `rewardid` int(11) NOT NULL,
  `quantity` smallint(6) NOT NULL,
  `prob` tinyint(3) unsigned NOT NULL DEFAULT '100'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `makerrewarddata`
--

LOCK TABLES `makerrewarddata` WRITE;
/*!40000 ALTER TABLE `makerrewarddata` DISABLE KEYS */;
INSERT INTO `makerrewarddata` VALUES (4250000,4250000,1,14),(4250000,4250001,1,5),(4250000,4250002,1,1),(4250001,4250000,9,2),(4250001,4250001,1,3),(4250002,4250001,9,7),(4250002,4250002,1,3),(4250100,4250100,1,14),(4250100,4250101,1,5),(4250100,4250102,1,1),(4250101,4250100,9,2),(4250101,4250101,1,3),(4250102,4250101,9,7),(4250102,4250102,1,3),(4250200,4250200,1,14),(4250200,4250201,1,5),(4250200,4250202,1,1),(4250201,4250200,9,2),(4250201,4250201,1,3),(4250202,4250201,9,7),(4250202,4250202,1,3),(4250300,4250300,1,14),(4250300,4250301,1,5),(4250300,4250302,1,1),(4250301,4250300,9,2),(4250301,4250301,1,3),(4250302,4250301,9,7),(4250302,4250302,1,3),(4250400,4250400,1,14),(4250400,4250401,1,5),(4250400,4250402,1,1),(4250401,4250400,9,2),(4250401,4250401,1,3),(4250402,4250401,9,7),(4250402,4250402,1,3),(4250500,4250500,1,14),(4250500,4250501,1,5),(4250500,4250502,1,1),(4250501,4250500,9,2),(4250501,4250501,1,3),(4250502,4250501,9,7),(4250502,4250502,1,3),(4250600,4250600,1,14),(4250600,4250601,1,5),(4250600,4250602,1,1),(4250601,4250600,9,2),(4250601,4250601,1,3),(4250602,4250601,9,7),(4250602,4250602,1,3),(4250700,4250700,1,14),(4250700,4250701,1,5),(4250700,4250702,1,1),(4250701,4250700,9,2),(4250701,4250701,1,3),(4250702,4250701,9,7),(4250702,4250702,1,3),(4250800,4250800,1,75),(4250800,4250801,1,24),(4250800,4250802,1,1),(4250801,4250800,9,2),(4250801,4250801,1,3),(4250802,4250801,9,7),(4250802,4250802,1,3),(4250900,4250900,1,75),(4250900,4250901,1,24),(4250900,4250902,1,1),(4250901,4250900,9,2),(4250901,4250901,1,3),(4250902,4250901,9,7),(4250902,4250902,1,3),(4251000,4251000,1,75),(4251000,4251001,1,24),(4251000,4251002,1,1),(4251001,4251000,9,2),(4251001,4251001,1,3),(4251002,4251001,9,7),(4251002,4251002,1,3),(4251100,4251100,1,75),(4251100,4251101,1,24),(4251100,4251102,1,1),(4251101,4251100,9,2),(4251101,4251101,1,3),(4251102,4251101,9,7),(4251102,4251102,1,3),(4251300,4251300,1,27),(4251300,4251301,1,12),(4251300,4251302,1,1),(4251301,4251300,9,1),(4251301,4251301,1,1),(4251302,4251301,9,4),(4251302,4251302,1,1),(4251400,4251400,1,27),(4251400,4251401,1,12),(4251400,4251402,1,1),(4251401,4251400,9,1),(4251401,4251401,1,1),(4251402,4251401,9,4),(4251402,4251402,1,1);
/*!40000 ALTER TABLE `makerrewarddata` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `marriages`
--

DROP TABLE IF EXISTS `marriages`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `marriages` (
  `marriageid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `husbandid` int(10) unsigned NOT NULL DEFAULT '0',
  `wifeid` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`marriageid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `marriages`
--

LOCK TABLES `marriages` WRITE;
/*!40000 ALTER TABLE `marriages` DISABLE KEYS */;
/*!40000 ALTER TABLE `marriages` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `medalmaps`
--

DROP TABLE IF EXISTS `medalmaps`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `medalmaps` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `queststatusid` int(11) unsigned NOT NULL,
  `mapid` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `medalmaps`
--

LOCK TABLES `medalmaps` WRITE;
/*!40000 ALTER TABLE `medalmaps` DISABLE KEYS */;
/*!40000 ALTER TABLE `medalmaps` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `migrations`
--

DROP TABLE IF EXISTS `migrations`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `migrations` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `migration` varchar(255) NOT NULL,
  `batch` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `migrations`
--

LOCK TABLES `migrations` WRITE;
/*!40000 ALTER TABLE `migrations` DISABLE KEYS */;
/*!40000 ALTER TABLE `migrations` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `modifiedcashitems`
--

DROP TABLE IF EXISTS `modifiedcashitems`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `modifiedcashitems` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `sn` int(11) NOT NULL DEFAULT '0',
  `priority` int(11) NOT NULL DEFAULT '0',
  `gender` int(11) NOT NULL DEFAULT '0',
  `class` int(11) NOT NULL DEFAULT '0',
  `limit` int(11) NOT NULL DEFAULT '0',
  `bonus` tinyint(1) NOT NULL DEFAULT '0',
  `forPremiumUser` tinyint(1) NOT NULL DEFAULT '0',
  `onSale` tinyint(1) NOT NULL DEFAULT '0',
  `count` int(11) NOT NULL DEFAULT '0',
  `period` int(11) NOT NULL DEFAULT '90',
  `reqPOP` int(11) NOT NULL DEFAULT '0',
  `reqLEV` int(11) NOT NULL DEFAULT '0',
  `pbCash` int(11) NOT NULL DEFAULT '0',
  `pbPoint` int(11) NOT NULL DEFAULT '0',
  `pbGift` int(11) NOT NULL DEFAULT '0',
  `itemid` int(11) NOT NULL DEFAULT '0',
  `price` int(11) NOT NULL DEFAULT '0',
  `maplePoint` int(11) NOT NULL DEFAULT '0',
  `meso` int(11) NOT NULL DEFAULT '0',
  `packageSN` longtext NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=27 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `modifiedcashitems`
--

LOCK TABLES `modifiedcashitems` WRITE;
/*!40000 ALTER TABLE `modifiedcashitems` DISABLE KEYS */;
INSERT INTO `modifiedcashitems` VALUES (1,30200001,14,2,2,0,0,0,0,1,90,0,0,0,0,0,5120008,300,0,0,''),(3,30100056,15,2,0,0,0,0,1,1,90,0,0,0,0,0,5074000,1300,0,0,''),(4,30100057,15,2,0,0,0,0,1,11,90,0,0,0,0,0,5074000,13000,0,0,''),(5,30100056,15,2,0,0,0,0,1,1,90,0,0,0,0,0,5074000,1300,0,0,''),(6,30100057,15,2,0,0,0,0,1,11,90,0,0,0,0,0,5074000,13000,0,0,''),(9,9102289,0,0,0,0,0,0,0,0,90,0,0,0,0,0,0,0,0,0,''),(10,9102290,0,0,0,0,0,0,0,0,90,0,0,0,0,0,0,0,0,0,''),(11,50200174,0,0,0,0,0,0,0,0,90,0,0,0,0,0,5620006,0,0,0,''),(12,50200181,0,0,0,0,0,0,0,0,90,0,0,0,0,0,5620006,0,0,0,''),(13,50200182,0,0,0,0,0,0,0,0,90,0,0,0,0,0,5620006,0,0,0,''),(14,50200184,0,0,0,0,0,0,0,0,90,0,0,0,0,0,5620006,0,0,0,''),(15,40000000,0,0,0,0,0,0,0,0,90,0,0,0,0,0,0,0,0,0,''),(16,40000001,0,0,0,0,0,0,0,0,90,0,0,0,0,0,0,0,0,0,''),(17,40000002,0,0,0,0,0,0,0,0,90,0,0,0,0,0,0,0,0,0,''),(18,40000003,0,0,0,0,0,0,0,0,90,0,0,0,0,0,0,0,0,0,''),(19,40000004,0,0,0,0,0,0,0,0,90,0,0,0,0,0,0,0,0,0,''),(20,40000005,0,0,0,0,0,0,0,0,90,0,0,0,0,0,0,0,0,0,''),(21,40000013,0,0,0,0,0,0,0,0,90,0,0,0,0,0,0,0,0,0,''),(22,40000014,0,0,0,0,0,0,0,0,90,0,0,0,0,0,0,0,0,0,''),(23,40000015,0,0,0,0,0,0,0,0,90,0,0,0,0,0,0,0,0,0,''),(24,40000016,0,0,0,0,0,0,0,0,90,0,0,0,0,0,0,0,0,0,''),(25,40000017,0,0,0,0,0,0,0,0,90,0,0,0,0,0,0,0,0,0,''),(26,40000018,0,0,0,0,0,0,0,0,90,0,0,0,0,0,0,0,0,0,'');
/*!40000 ALTER TABLE `modifiedcashitems` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `monsterbook`
--

DROP TABLE IF EXISTS `monsterbook`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `monsterbook` (
  `charid` int(11) unsigned NOT NULL,
  `cardid` int(11) NOT NULL,
  `level` int(1) DEFAULT '1'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `monsterbook`
--

LOCK TABLES `monsterbook` WRITE;
/*!40000 ALTER TABLE `monsterbook` DISABLE KEYS */;
/*!40000 ALTER TABLE `monsterbook` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `monstercarddata`
--

DROP TABLE IF EXISTS `monstercarddata`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `monstercarddata` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cardid` int(11) NOT NULL DEFAULT '0',
  `mobid` int(11) NOT NULL DEFAULT '0',
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=309 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `monstercarddata`
--

LOCK TABLES `monstercarddata` WRITE;
/*!40000 ALTER TABLE `monstercarddata` DISABLE KEYS */;
INSERT INTO `monstercarddata` VALUES (1,2380000,100100),(2,2380001,100101),(3,2380003,130100),(4,2380004,130101),(5,2380005,210100),(6,2380006,1210100),(7,2380007,1210102),(8,2380008,1110101),(9,2380009,1210101),(10,2380010,1120100),(11,2380011,1110100),(12,2380012,1210103),(13,2381000,1130100),(14,2381001,1140100),(15,2381002,2220100),(16,2381003,2300100),(17,2381006,2130103),(18,2381007,2110200),(19,2381008,2130100),(20,2381009,2230108),(21,2381010,2100102),(22,2381011,2230103),(23,2381012,5200000),(24,2381013,2230105),(25,2381014,2230110),(26,2381015,2100105),(27,2381016,2230101),(28,2381017,2230107),(29,2381018,2230111),(30,2381019,2100106),(31,2381020,2110300),(32,2381021,2230106),(33,2381022,2230102),(34,2381023,2100103),(35,2381024,2230100),(36,2381025,2100107),(37,2381026,2230109),(38,2381027,2230104),(39,2381028,2100104),(40,2381029,2230200),(41,2381031,2110301),(42,2381032,3000000),(43,2381034,3000005),(44,2381035,3000006),(45,2381036,3100102),(46,2381037,5200001),(47,2381038,5200002),(48,2382000,3230307),(49,2382002,3110100),(50,2382004,3110101),(51,2382005,3110102),(52,2382006,5300000),(53,2382007,3230104),(54,2382009,3110300),(55,2382011,3210200),(56,2382012,3210201),(57,2382013,3210202),(58,2382014,5300001),(59,2382015,3210204),(60,2382016,3210205),(61,2382017,3210207),(62,2382018,3230100),(63,2382019,3230101),(64,2382020,3230200),(65,2382022,3230302),(66,2382023,5400000),(67,2382024,3110302),(68,2382025,3210203),(69,2382026,3210206),(70,2382027,3210450),(71,2382028,3210208),(72,2382029,3210800),(73,2382030,3230102),(74,2382031,3230303),(75,2382032,3230306),(76,2382033,3230103),(77,2382034,3230304),(78,2382035,3230405),(79,2382036,3110303),(80,2382037,3230308),(81,2382038,3230305),(82,2382039,4230100),(83,2382040,4230101),(84,2382041,4230113),(85,2382043,4230200),(86,2382044,4230201),(87,2382045,4230500),(88,2382047,4230107),(89,2382048,4230111),(90,2382049,4230114),(91,2382050,4230119),(92,2382051,4230501),(93,2382052,4230105),(94,2382053,4230103),(95,2382054,4230109),(96,2382056,4230124),(97,2382057,4110300),(98,2382058,4230108),(99,2382059,4230123),(100,2382060,4230502),(101,2382061,4230120),(102,2382062,4230112),(103,2382063,4230125),(104,2382064,4230106),(105,2382065,4130100),(106,2382066,4230110),(107,2382068,4230300),(108,2382069,4230400),(109,2382070,4230503),(110,2382071,4230504),(111,2382072,4110301),(112,2382076,4250000),(113,2383000,4230121),(114,2383001,4130101),(115,2383002,4230115),(116,2383003,4130102),(117,2383004,4130103),(118,2383006,4230505),(119,2383007,9300255),(120,2383008,4230102),(121,2383009,4230104),(122,2383010,4230506),(123,2383012,5130100),(124,2383013,5100000),(125,2383014,5100003),(126,2383015,5120503),(127,2383016,9300144),(128,2383017,5100002),(129,2383018,5120504),(130,2383019,5130103),(131,2383021,5120001),(132,2383022,5120002),(133,2383023,5120003),(134,2383024,5100005),(135,2383025,5120501),(136,2383026,5120100),(137,2383027,5120502),(138,2383028,9300149),(139,2383029,5300100),(140,2383030,5130101),(141,2383031,5130104),(142,2383032,5120506),(143,2383033,5130105),(144,2383035,5120500),(145,2383036,5150001),(146,2383037,5130107),(147,2383038,5130108),(148,2383039,5130102),(149,2383040,5140000),(150,2383041,5120505),(151,2383042,5110302),(152,2383043,5150000),(153,2383044,6130100),(154,2383045,6130103),(155,2383046,6130201),(156,2383047,6130203),(157,2383048,5090000),(158,2383049,5090001),(159,2383056,4250001),(160,2383057,5250000),(161,2383058,5250002),(162,2383059,5250001),(163,2384000,6130200),(164,2384001,9400201),(165,2384002,6130207),(166,2384003,6230602),(167,2384004,6230400),(168,2384006,6230600),(169,2384007,6230200),(170,2384008,6130204),(171,2384009,6300000),(172,2384010,6090000),(173,2384011,6110300),(174,2384012,6230300),(175,2384013,6130209),(176,2384014,6230500),(177,2384015,6230601),(178,2384016,6400000),(179,2384017,6130208),(180,2384018,9300146),(181,2384019,8140200),(182,2384020,7130100),(183,2384021,7130400),(184,2384022,7130401),(185,2384023,7130402),(186,2384024,7130500),(187,2384025,7130104),(188,2384026,7130001),(189,2384027,7130002),(190,2384028,7130600),(191,2384029,7130103),(192,2384032,6300100),(193,2384033,7130501),(194,2384035,7130200),(195,2384036,7130101),(196,2384037,6090001),(197,2384038,7090000),(198,2384039,6090003),(199,2384040,6090004),(200,2385000,8140300),(201,2385001,7130003),(202,2385002,7130601),(203,2385003,6400100),(204,2385004,7130102),(205,2385005,7130004),(206,2385006,8140000),(207,2385007,8140001),(208,2385008,8110300),(209,2385009,8140100),(210,2385011,8140002),(211,2385012,7130010),(212,2385013,7130020),(213,2385014,8140110),(214,2385016,8140101),(215,2385017,8140102),(216,2385018,8140103),(217,2385019,8140111),(218,2385020,7130300),(219,2385021,8140500),(220,2385022,8140700),(221,2385023,8090000),(222,2385025,8200000),(223,2386000,8140600),(224,2386001,8140701),(225,2386002,9300324),(226,2386003,8141300),(227,2386004,8142000),(228,2386005,8140702),(229,2386006,8140703),(230,2386007,8142100),(231,2386008,8150300),(232,2386009,9500136),(233,2386010,9500137),(234,2386011,8150200),(235,2386012,8150100),(236,2386013,8150301),(237,2386014,8150101),(238,2386015,8150302),(239,2386016,8150201),(240,2386017,8190000),(241,2386021,8200001),(242,2386022,8200002),(243,2386023,8200003),(244,2386024,8200004),(245,2387000,8160000),(246,2387001,8170000),(247,2387002,8190003),(248,2387003,8190004),(249,2387004,8190002),(250,2387006,8200005),(251,2387007,8200006),(252,2387008,8200007),(253,2387009,8200008),(254,2387010,8200009),(255,2387011,8200010),(256,2387012,8200011),(257,2387013,8200012),(258,2388000,9300184),(259,2388001,9300003),(260,2388002,5220002),(261,2388003,5220000),(262,2388004,9300012),(263,2388005,5220003),(264,2388006,6130101),(265,2388007,6220000),(266,2388008,6300005),(267,2388009,7220001),(268,2388010,7220000),(269,2388011,9300119),(270,2388012,9300039),(271,2388013,7220002),(272,2388014,9300139),(273,2388016,8220001),(274,2388017,8150000),(275,2388018,8180000),(276,2388019,8180001),(277,2388020,8510000),(278,2388021,9300028),(279,2388022,8500002),(280,2388025,3220000),(281,2388026,8130100),(282,2388028,9500317),(283,2388029,3220001),(284,2388030,4220000),(285,2388031,6220001),(286,2388033,8220003),(287,2388040,8220004),(288,2388041,8220005),(289,2388042,8220006),(290,2388043,8820000),(291,2380013,9300274),(292,2388055,8830000),(293,2380014,1110130),(294,2380015,100130),(295,2380016,100131),(296,2380017,100132),(297,2380018,100133),(298,2380019,100134),(299,2381083,2230131),(300,2382093,3300001),(301,2382094,3300002),(302,2382095,3300003),(303,2382096,3300004),(304,2388052,5220004),(305,2388053,8220007),(306,2388054,8220009),(307,2388068,3300006),(308,2388069,3300007);
/*!40000 ALTER TABLE `monstercarddata` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `monsterkills`
--

DROP TABLE IF EXISTS `monsterkills`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `monsterkills` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `date` varchar(45) NOT NULL,
  `total` bigint(20) NOT NULL DEFAULT '0',
  `higher` bigint(20) NOT NULL DEFAULT '0',
  UNIQUE KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `monsterkills`
--

LOCK TABLES `monsterkills` WRITE;
/*!40000 ALTER TABLE `monsterkills` DISABLE KEYS */;
/*!40000 ALTER TABLE `monsterkills` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mts_bids`
--

DROP TABLE IF EXISTS `mts_bids`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mts_bids` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mtsItemID` int(11) NOT NULL DEFAULT '0',
  `bidderid` int(11) NOT NULL DEFAULT '0',
  `bid` int(11) NOT NULL DEFAULT '0',
  `bidRange` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mts_bids`
--

LOCK TABLES `mts_bids` WRITE;
/*!40000 ALTER TABLE `mts_bids` DISABLE KEYS */;
/*!40000 ALTER TABLE `mts_bids` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mts_cart`
--

DROP TABLE IF EXISTS `mts_cart`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mts_cart` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL,
  `itemid` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mts_cart`
--

LOCK TABLES `mts_cart` WRITE;
/*!40000 ALTER TABLE `mts_cart` DISABLE KEYS */;
/*!40000 ALTER TABLE `mts_cart` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mts_history`
--

DROP TABLE IF EXISTS `mts_history`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mts_history` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `tab` int(11) NOT NULL DEFAULT '0',
  `type` int(11) NOT NULL DEFAULT '0',
  `chrid` int(11) NOT NULL DEFAULT '0',
  `itemid` int(10) unsigned NOT NULL DEFAULT '0',
  `quantity` int(11) NOT NULL DEFAULT '1',
  `upgradeslots` int(11) DEFAULT '0',
  `level` int(11) DEFAULT '0',
  `str` int(11) DEFAULT '0',
  `dex` int(11) DEFAULT '0',
  `int` int(11) DEFAULT '0',
  `luk` int(11) DEFAULT '0',
  `hp` int(11) DEFAULT '0',
  `mp` int(11) DEFAULT '0',
  `watk` int(11) DEFAULT '0',
  `matk` int(11) DEFAULT '0',
  `wdef` int(11) DEFAULT '0',
  `mdef` int(11) DEFAULT '0',
  `acc` int(11) DEFAULT '0',
  `avoid` int(11) DEFAULT '0',
  `hands` int(11) DEFAULT '0',
  `speed` int(11) DEFAULT '0',
  `jump` int(11) DEFAULT '0',
  `vicious` int(2) unsigned NOT NULL DEFAULT '0',
  `flag` int(2) unsigned NOT NULL DEFAULT '0',
  `owner` varchar(16) DEFAULT '',
  `position` int(4) NOT NULL DEFAULT '0',
  `petid` int(4) NOT NULL DEFAULT '-1',
  `expiration` int(1) NOT NULL DEFAULT '-1',
  `giftFrom` varchar(1) NOT NULL DEFAULT '',
  `bundles` int(1) NOT NULL DEFAULT '1',
  `itemexp` int(11) NOT NULL DEFAULT '0',
  `itemlevel` int(11) NOT NULL DEFAULT '1',
  `lockExpiration` int(20) NOT NULL DEFAULT '-1',
  `ringid` int(11) NOT NULL DEFAULT '0',
  `learnedSkills` tinyint(1) NOT NULL DEFAULT '0',
  `date` bigint(50) NOT NULL DEFAULT '0',
  `seller` int(11) NOT NULL DEFAULT '0',
  `sellername` varchar(16) NOT NULL,
  `price` int(11) NOT NULL DEFAULT '0',
  `status` int(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mts_history`
--

LOCK TABLES `mts_history` WRITE;
/*!40000 ALTER TABLE `mts_history` DISABLE KEYS */;
/*!40000 ALTER TABLE `mts_history` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mts_items`
--

DROP TABLE IF EXISTS `mts_items`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mts_items` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `tab` int(11) NOT NULL DEFAULT '0',
  `type` int(11) NOT NULL DEFAULT '0',
  `itemid` int(10) unsigned NOT NULL DEFAULT '0',
  `quantity` int(11) NOT NULL DEFAULT '1',
  `seller` int(11) NOT NULL DEFAULT '0',
  `price` int(11) NOT NULL DEFAULT '0',
  `bid_incre` int(11) DEFAULT '0',
  `buy_now` int(11) DEFAULT '0',
  `upgradeslots` int(11) DEFAULT '0',
  `level` int(11) DEFAULT '0',
  `str` int(11) DEFAULT '0',
  `dex` int(11) DEFAULT '0',
  `int` int(11) DEFAULT '0',
  `luk` int(11) DEFAULT '0',
  `hp` int(11) DEFAULT '0',
  `mp` int(11) DEFAULT '0',
  `watk` int(11) DEFAULT '0',
  `matk` int(11) DEFAULT '0',
  `wdef` int(11) DEFAULT '0',
  `mdef` int(11) DEFAULT '0',
  `acc` int(11) DEFAULT '0',
  `avoid` int(11) DEFAULT '0',
  `hands` int(11) DEFAULT '0',
  `speed` int(11) DEFAULT '0',
  `jump` int(11) DEFAULT '0',
  `vicious` int(2) unsigned NOT NULL DEFAULT '0',
  `flag` int(2) unsigned NOT NULL DEFAULT '0',
  `owner` varchar(16) DEFAULT '',
  `sellername` varchar(16) NOT NULL,
  `sell_ends` bigint(50) NOT NULL DEFAULT '0',
  `transfer` int(2) DEFAULT '0',
  `position` int(5) NOT NULL DEFAULT '0',
  `petid` int(11) NOT NULL DEFAULT '-1',
  `expiration` int(20) NOT NULL DEFAULT '-1',
  `giftFrom` varchar(16) NOT NULL DEFAULT '',
  `bundles` int(11) NOT NULL DEFAULT '1',
  `itemexp` int(11) NOT NULL DEFAULT '0',
  `itemlevel` int(11) NOT NULL DEFAULT '1',
  `lockExpiration` int(20) NOT NULL DEFAULT '-1',
  `ringid` int(11) NOT NULL DEFAULT '0',
  `learnedSkills` tinyint(1) NOT NULL DEFAULT '0',
  `note` varchar(100) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mts_items`
--

LOCK TABLES `mts_items` WRITE;
/*!40000 ALTER TABLE `mts_items` DISABLE KEYS */;
/*!40000 ALTER TABLE `mts_items` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mts_wanted`
--

DROP TABLE IF EXISTS `mts_wanted`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mts_wanted` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ownerid` int(11) NOT NULL DEFAULT '0',
  `ownername` varchar(45) NOT NULL DEFAULT '',
  `itemid` int(11) NOT NULL DEFAULT '0',
  `price` int(11) NOT NULL DEFAULT '0',
  `quantity` int(11) NOT NULL DEFAULT '0',
  `note` varchar(100) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mts_wanted`
--

LOCK TABLES `mts_wanted` WRITE;
/*!40000 ALTER TABLE `mts_wanted` DISABLE KEYS */;
/*!40000 ALTER TABLE `mts_wanted` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `news`
--

DROP TABLE IF EXISTS `news`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `news` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `author` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `title` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `type` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `content` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `views` int(11) NOT NULL DEFAULT '0',
  `created_at` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `updated_at` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `news`
--

LOCK TABLES `news` WRITE;
/*!40000 ALTER TABLE `news` DISABLE KEYS */;
/*!40000 ALTER TABLE `news` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `notes`
--

DROP TABLE IF EXISTS `notes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `notes` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `to` varchar(13) NOT NULL DEFAULT '',
  `from` varchar(13) NOT NULL DEFAULT '',
  `message` text NOT NULL,
  `timestamp` bigint(20) unsigned NOT NULL,
  `fame` int(11) NOT NULL DEFAULT '0',
  `deleted` int(2) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `notes`
--

LOCK TABLES `notes` WRITE;
/*!40000 ALTER TABLE `notes` DISABLE KEYS */;
/*!40000 ALTER TABLE `notes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `nxcode`
--

DROP TABLE IF EXISTS `nxcode`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `nxcode` (
  `code` varchar(32) NOT NULL,
  `valid` int(11) NOT NULL DEFAULT '1',
  `user` varchar(13) DEFAULT NULL,
  `type` int(11) NOT NULL DEFAULT '0',
  `item` int(11) NOT NULL DEFAULT '10000',
  PRIMARY KEY (`code`),
  UNIQUE KEY `code` (`code`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `nxcode`
--

LOCK TABLES `nxcode` WRITE;
/*!40000 ALTER TABLE `nxcode` DISABLE KEYS */;
/*!40000 ALTER TABLE `nxcode` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `password_resets`
--

DROP TABLE IF EXISTS `password_resets`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `password_resets` (
  `email` varchar(64) COLLATE utf8mb4_unicode_ci NOT NULL,
  `token` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL,
  `created_at` timestamp NULL DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `password_resets`
--

LOCK TABLES `password_resets` WRITE;
/*!40000 ALTER TABLE `password_resets` DISABLE KEYS */;
/*!40000 ALTER TABLE `password_resets` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pets`
--

DROP TABLE IF EXISTS `pets`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `pets` (
  `petid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(13) DEFAULT NULL,
  `level` int(10) unsigned NOT NULL,
  `closeness` int(10) unsigned NOT NULL,
  `fullness` int(10) unsigned NOT NULL,
  `summoned` tinyint(1) NOT NULL DEFAULT '0',
  `remainLife` int(11) NOT NULL DEFAULT '0',
  `excluded` varchar(200) NOT NULL DEFAULT '',
  PRIMARY KEY (`petid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `pets`
--

LOCK TABLES `pets` WRITE;
/*!40000 ALTER TABLE `pets` DISABLE KEYS */;
/*!40000 ALTER TABLE `pets` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `playernpcs`
--

DROP TABLE IF EXISTS `playernpcs`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `playernpcs` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(40) NOT NULL,
  `hair` int(11) NOT NULL,
  `face` int(11) NOT NULL,
  `skin` int(11) NOT NULL,
  `x` int(11) NOT NULL,
  `cy` int(11) NOT NULL DEFAULT '0',
  `map` int(11) NOT NULL,
  `gender` int(11) NOT NULL DEFAULT '0',
  `dir` int(11) NOT NULL DEFAULT '0',
  `ScriptId` int(10) unsigned NOT NULL DEFAULT '0',
  `Foothold` int(11) NOT NULL DEFAULT '0',
  `rx0` int(11) NOT NULL DEFAULT '0',
  `rx1` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `playernpcs`
--

LOCK TABLES `playernpcs` WRITE;
/*!40000 ALTER TABLE `playernpcs` DISABLE KEYS */;
INSERT INTO `playernpcs` VALUES (1,'FangBlade',30000,20002,0,-278,197,102000003,0,0,9901000,2,-328,-228);
/*!40000 ALTER TABLE `playernpcs` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `playernpcs_equip`
--

DROP TABLE IF EXISTS `playernpcs_equip`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `playernpcs_equip` (
  `id` int(11) NOT NULL,
  `NpcId` int(11) NOT NULL DEFAULT '0',
  `equipid` int(11) NOT NULL,
  `type` int(11) NOT NULL DEFAULT '0',
  `equippos` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `playernpcs_equip`
--

LOCK TABLES `playernpcs_equip` WRITE;
/*!40000 ALTER TABLE `playernpcs_equip` DISABLE KEYS */;
INSERT INTO `playernpcs_equip` VALUES (7058,0,1002023,0,-1),(7059,0,1032043,0,-4),(7060,0,1050022,0,-5),(7061,0,1072168,0,-7),(7062,0,1082002,0,-8),(7063,0,1302033,0,-11);
/*!40000 ALTER TABLE `playernpcs_equip` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pqhistory`
--

DROP TABLE IF EXISTS `pqhistory`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `pqhistory` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `pq` varchar(30) NOT NULL DEFAULT 'null',
  `characterid` int(11) NOT NULL,
  `success` tinyint(1) NOT NULL DEFAULT '0',
  `startat` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `endat` timestamp NULL DEFAULT NULL,
  `duration` smallint(5) unsigned NOT NULL DEFAULT '65535' COMMENT 'in minutes',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `pqhistory`
--

LOCK TABLES `pqhistory` WRITE;
/*!40000 ALTER TABLE `pqhistory` DISABLE KEYS */;
/*!40000 ALTER TABLE `pqhistory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pqranks`
--

DROP TABLE IF EXISTS `pqranks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `pqranks` (
  `pq` varchar(30) NOT NULL,
  `characterid` int(11) NOT NULL,
  `rank` varchar(3) NOT NULL DEFAULT 'z',
  `tries` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `completed` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `completerate` tinyint(3) NOT NULL DEFAULT '0',
  `fastesttime` smallint(5) unsigned NOT NULL DEFAULT '65535',
  `fastestdate` date DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `pqranks`
--

LOCK TABLES `pqranks` WRITE;
/*!40000 ALTER TABLE `pqranks` DISABLE KEYS */;
/*!40000 ALTER TABLE `pqranks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `questactions`
--

DROP TABLE IF EXISTS `questactions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `questactions` (
  `questactionid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `questid` int(11) NOT NULL DEFAULT '0',
  `status` int(11) NOT NULL DEFAULT '0',
  `data` blob NOT NULL,
  PRIMARY KEY (`questactionid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `questactions`
--

LOCK TABLES `questactions` WRITE;
/*!40000 ALTER TABLE `questactions` DISABLE KEYS */;
/*!40000 ALTER TABLE `questactions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `questprogress`
--

DROP TABLE IF EXISTS `questprogress`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `questprogress` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `queststatusid` int(10) unsigned NOT NULL DEFAULT '0',
  `progressid` int(11) NOT NULL DEFAULT '0',
  `progress` varchar(15) CHARACTER SET latin1 COLLATE latin1_german1_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `questprogress`
--

LOCK TABLES `questprogress` WRITE;
/*!40000 ALTER TABLE `questprogress` DISABLE KEYS */;
/*!40000 ALTER TABLE `questprogress` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `questrequirements`
--

DROP TABLE IF EXISTS `questrequirements`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `questrequirements` (
  `questrequirementid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `questid` int(11) NOT NULL DEFAULT '0',
  `status` int(11) NOT NULL DEFAULT '0',
  `data` blob NOT NULL,
  PRIMARY KEY (`questrequirementid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `questrequirements`
--

LOCK TABLES `questrequirements` WRITE;
/*!40000 ALTER TABLE `questrequirements` DISABLE KEYS */;
/*!40000 ALTER TABLE `questrequirements` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `queststatus`
--

DROP TABLE IF EXISTS `queststatus`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `queststatus` (
  `queststatusid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `characterid` int(11) NOT NULL DEFAULT '0',
  `quest` int(11) NOT NULL DEFAULT '0',
  `status` int(11) NOT NULL DEFAULT '0',
  `time` int(11) NOT NULL DEFAULT '0',
  `forfeited` int(11) NOT NULL DEFAULT '0',
  `info` tinyint(3) NOT NULL DEFAULT '0',
  PRIMARY KEY (`queststatusid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `queststatus`
--

LOCK TABLES `queststatus` WRITE;
/*!40000 ALTER TABLE `queststatus` DISABLE KEYS */;
/*!40000 ALTER TABLE `queststatus` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `queue_vp`
--

DROP TABLE IF EXISTS `queue_vp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `queue_vp` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `account_name` varchar(45) DEFAULT NULL,
  `vp_held` int(11) DEFAULT NULL,
  `date` varchar(255) DEFAULT NULL,
  `used` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `queue_vp`
--

LOCK TABLES `queue_vp` WRITE;
/*!40000 ALTER TABLE `queue_vp` DISABLE KEYS */;
/*!40000 ALTER TABLE `queue_vp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `queue_xp`
--

DROP TABLE IF EXISTS `queue_xp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `queue_xp` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `account_id` varchar(45) DEFAULT NULL,
  `xp_held` int(11) DEFAULT NULL,
  `date` varchar(255) DEFAULT NULL,
  `used` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `queue_xp`
--

LOCK TABLES `queue_xp` WRITE;
/*!40000 ALTER TABLE `queue_xp` DISABLE KEYS */;
/*!40000 ALTER TABLE `queue_xp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `reactordrops`
--

DROP TABLE IF EXISTS `reactordrops`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `reactordrops` (
  `reactordropid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `reactorid` int(11) DEFAULT NULL,
  `reactorAction` varchar(45) DEFAULT NULL,
  `itemid` int(11) NOT NULL,
  `chance` int(11) NOT NULL,
  `questid` int(5) NOT NULL DEFAULT '-1',
  PRIMARY KEY (`reactordropid`)
) ENGINE=MyISAM AUTO_INCREMENT=915 DEFAULT CHARSET=latin1 PACK_KEYS=1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `reactordrops`
--

LOCK TABLES `reactordrops` WRITE;
/*!40000 ALTER TABLE `reactordrops` DISABLE KEYS */;
INSERT INTO `reactordrops` VALUES (842,NULL,'EpisodeQuest0',4001366,2,28194),(127,1202000,NULL,4001366,1,28194),(128,1202003,NULL,4001346,1,28225),(129,1202004,NULL,4001346,1,28225),(130,1032000,NULL,4032362,1,28252),(131,1032000,NULL,4032363,1,28252),(132,1202004,NULL,4032494,1,28255),(1,2001,NULL,4031161,1,1008),(2,2001,NULL,4031162,1,1008),(3,2001,NULL,2010009,2,-1),(4,2001,NULL,2010000,4,-1),(5,2001,NULL,2000000,4,-1),(6,2001,NULL,2000001,7,-1),(7,2001,NULL,2000002,10,-1),(8,2001,NULL,2000003,15,-1),(9,1012000,NULL,2000000,6,-1),(10,1012000,NULL,4000003,6,-1),(11,1012000,NULL,4031150,3,-1),(12,1072000,NULL,4031165,4,-1),(13,1102000,NULL,4000136,1,-1),(14,1102001,NULL,4000136,1,-1),(15,1102002,NULL,4000136,1,-1),(16,2002000,NULL,2000002,4,-1),(17,2002000,NULL,2000001,2,-1),(18,2002000,NULL,4031198,2,-1),(19,2112000,NULL,2000004,1,-1),(20,2112001,NULL,2020001,1,-1),(21,2112004,NULL,4001016,1,-1),(22,2112005,NULL,4001015,1,-1),(23,2112003,NULL,2000005,1,-1),(24,2112007,NULL,2022001,1,-1),(25,2112008,NULL,2000004,1,-1),(26,2112009,NULL,2020001,1,-1),(27,2112010,NULL,2000005,1,-1),(28,2112011,NULL,4001016,1,-1),(29,2112012,NULL,4001015,1,-1),(30,2112014,NULL,4001018,1,-1),(31,2112016,NULL,4001113,1,-1),(32,2112017,NULL,4001114,1,-1),(33,2202000,NULL,4031094,1,-1),(34,2212000,NULL,4031142,2,-1),(35,2212000,NULL,2000002,3,-1),(36,2212001,NULL,2000002,3,-1),(37,2212002,NULL,2000002,3,-1),(38,2212001,NULL,4031141,2,-1),(39,2212002,NULL,4031143,2,-1),(40,2212003,NULL,4031107,2,-1),(41,2212004,NULL,4031116,2,-1),(42,2212004,NULL,2000001,2,-1),(43,2212005,NULL,4031136,8,-1),(44,2222000,NULL,4031231,2,-1),(45,2222000,NULL,4031258,2,-1),(46,2222000,NULL,2000002,3,-1),(47,2302000,NULL,2000001,3,-1),(48,2302000,NULL,2022040,6,-1),(49,2302000,NULL,4031274,50,-1),(50,2302000,NULL,4031275,50,-1),(51,2302000,NULL,4031276,50,-1),(52,2302000,NULL,4031277,50,-1),(53,2302000,NULL,4031278,50,-1),(54,2302001,NULL,2000002,3,-1),(55,2302001,NULL,2022040,4,-1),(56,2302002,NULL,2000001,3,-1),(57,2302002,NULL,2022040,8,-1),(58,2302003,NULL,4161017,1,-1),(59,2302000,NULL,4031508,1,6002),(60,2502000,NULL,2022116,1,-1),(61,2052001,NULL,2022116,1,-1),(62,9202000,NULL,1032033,1,-1),(63,9202009,NULL,1032033,1,-1),(64,2202001,NULL,4031092,1,-1),(65,9202001,NULL,4001025,1,-1),(66,9202002,NULL,4001037,1,-1),(67,9202003,NULL,4001029,1,-1),(68,9202004,NULL,4001030,1,-1),(69,9202005,NULL,4001031,1,-1),(70,9202006,NULL,4001032,1,-1),(71,9202007,NULL,4001033,1,-1),(72,9202008,NULL,4001034,1,-1),(73,9202012,NULL,2020014,3,-1),(74,9202012,NULL,2020015,3,-1),(75,9202012,NULL,2001001,3,-1),(76,9202012,NULL,2000004,3,-1),(77,9202012,NULL,2000005,3,-1),(78,9202012,NULL,2000001,3,-1),(79,9202012,NULL,2000002,3,-1),(80,9202012,NULL,2000006,3,-1),(81,9202012,NULL,2001002,3,-1),(82,9202012,NULL,2040504,40,-1),(83,9202012,NULL,2040501,40,-1),(84,9202012,NULL,2040513,40,-1),(85,9202012,NULL,2040516,40,-1),(86,9202012,NULL,2041007,40,-1),(87,9202012,NULL,2041010,40,-1),(88,9202012,NULL,2041004,40,-1),(89,9202012,NULL,2041001,40,-1),(90,9202012,NULL,2041019,40,-1),(91,9202012,NULL,2041022,40,-1),(92,9202012,NULL,2041013,40,-1),(93,9202012,NULL,2041016,40,-1),(94,9202012,NULL,2040301,40,-1),(95,9202012,NULL,2040704,40,-1),(96,9202012,NULL,2040707,40,-1),(97,9202012,NULL,2040701,40,-1),(98,9202012,NULL,2040804,40,-1),(99,9202012,NULL,2040801,40,-1),(100,9202012,NULL,2040004,40,-1),(101,9202012,NULL,2040001,40,-1),(102,9202012,NULL,2290009,60,-1),(103,9202012,NULL,2290031,60,-1),(104,9202012,NULL,2290039,60,-1),(105,9202012,NULL,2290033,60,-1),(106,9202012,NULL,2290045,60,-1),(107,9202012,NULL,2290081,60,-1),(108,9202012,NULL,2290083,60,-1),(109,9202012,NULL,2290087,60,-1),(110,9202012,NULL,2290060,60,-1),(111,9202012,NULL,2290073,60,-1),(112,9202012,NULL,2100000,250,-1),(113,2612004,NULL,4031703,1,-1),(114,1302000,NULL,2010000,30,-1),(115,1302000,NULL,2010009,30,-1),(116,1302000,NULL,4032268,1,20013),(117,1302000,NULL,4032267,1,20013),(118,1052000,NULL,4031471,1,6153),(119,2112015,NULL,2280000,1,-1),(120,1022000,NULL,4031452,1,-1),(121,0,'ludiquest3',4001022,1,-1),(122,2201001,NULL,4001022,1,-1),(123,1402000,NULL,4032309,1,-1),(124,1402000,NULL,4032310,1,-1),(125,1022001,NULL,4032319,7,-1),(133,1052001,NULL,3010126,100,-1),(134,1052002,NULL,3010126,100,-1),(135,1052001,NULL,1072375,3,-1),(136,1052001,NULL,1072376,3,-1),(137,1052001,NULL,2049100,3,-1),(138,1052001,NULL,2049001,3,-1),(139,1052001,NULL,1382068,3,-1),(140,1052001,NULL,1402062,3,-1),(141,1052001,NULL,1442078,3,-1),(142,1052001,NULL,1452071,3,-1),(143,1052001,NULL,1472086,3,-1),(144,1052001,NULL,1492037,3,-1),(145,1052001,NULL,2040728,3,-1),(146,1052001,NULL,2040729,3,-1),(147,1052001,NULL,2040730,3,-1),(148,1052001,NULL,2040731,3,-1),(149,1052001,NULL,2040732,3,-1),(150,1052001,NULL,2040733,3,-1),(151,1052001,NULL,2040734,3,-1),(152,1052001,NULL,2040735,3,-1),(153,1052001,NULL,2040736,3,-1),(154,1052001,NULL,2040737,3,-1),(155,1052001,NULL,2040738,3,-1),(156,1052001,NULL,2040739,3,-1),(157,1052001,NULL,1302112,3,-1),(158,1052001,NULL,1302113,3,-1),(159,1052001,NULL,1312042,3,-1),(160,1052001,NULL,1312043,3,-1),(161,1052001,NULL,1322068,3,-1),(162,1052001,NULL,1322069,3,-1),(163,1052001,NULL,1332084,3,-1),(164,1052001,NULL,1332085,3,-1),(165,1052001,NULL,1332086,3,-1),(166,1052001,NULL,1332087,3,-1),(167,1052001,NULL,1342019,3,-1),(168,1052001,NULL,1342020,3,-1),(169,1052001,NULL,1372050,3,-1),(170,1052001,NULL,1372051,3,-1),(171,1052001,NULL,1382066,3,-1),(172,1052001,NULL,1382067,3,-1),(173,1052001,NULL,1402056,3,-1),(174,1052001,NULL,1402057,3,-1),(175,1052001,NULL,1402058,3,-1),(176,1052001,NULL,1402059,3,-1),(177,1052001,NULL,1412038,3,-1),(178,1052001,NULL,1412039,3,-1),(179,1052001,NULL,1422042,3,-1),(180,1052001,NULL,1422043,3,-1),(181,1052002,NULL,1072375,3,-1),(182,1052002,NULL,1072376,3,-1),(183,1052002,NULL,2040728,3,-1),(184,1052002,NULL,2040729,3,-1),(185,1052002,NULL,2040730,3,-1),(186,1052002,NULL,2040731,3,-1),(187,1052002,NULL,2040732,3,-1),(188,1052002,NULL,2040733,3,-1),(189,1052002,NULL,2040734,3,-1),(190,1052002,NULL,2040735,3,-1),(191,1052002,NULL,2040736,3,-1),(192,1052002,NULL,2040737,3,-1),(193,1052002,NULL,2040738,3,-1),(194,1052002,NULL,2040739,3,-1),(195,1052002,NULL,1302112,3,-1),(196,1052002,NULL,1302113,3,-1),(197,1052002,NULL,1312042,3,-1),(198,1052002,NULL,1312043,3,-1),(199,1052002,NULL,1322068,3,-1),(200,1052002,NULL,1322069,3,-1),(201,1052002,NULL,1332084,3,-1),(202,1052002,NULL,1332085,3,-1),(203,1052002,NULL,1332086,3,-1),(204,1052002,NULL,1332087,3,-1),(205,1052002,NULL,1342019,3,-1),(206,1052002,NULL,1342020,3,-1),(207,1052002,NULL,1372050,3,-1),(208,1052002,NULL,1372051,3,-1),(209,1052002,NULL,1382066,3,-1),(210,1052002,NULL,1382067,3,-1),(211,1052002,NULL,1402056,3,-1),(212,1052002,NULL,1402057,3,-1),(213,1052002,NULL,1402058,3,-1),(214,1052002,NULL,1402059,3,-1),(215,1052002,NULL,1412038,3,-1),(216,1052002,NULL,1412039,3,-1),(217,1052002,NULL,1422042,3,-1),(218,1052002,NULL,1422043,3,-1),(219,1002008,NULL,4032452,1,22502),(220,6102001,NULL,4001260,1,-1),(221,6102002,NULL,1472051,25,-1),(222,6102002,NULL,1442056,25,-1),(223,6102002,NULL,1072228,25,-1),(224,6102002,NULL,1322062,25,-1),(225,6102002,NULL,1092061,25,-1),(226,6102002,NULL,1452019,25,-1),(227,6102002,NULL,1492012,25,-1),(228,6102002,NULL,1092050,25,-1),(229,6102002,NULL,1402005,25,-1),(230,6102002,NULL,1052131,25,-1),(231,6102002,NULL,1462016,25,-1),(232,6102002,NULL,1332051,25,-1),(233,6102002,NULL,1102043,50,-1),(234,6102002,NULL,1102206,50,-1),(235,6102002,NULL,1102260,50,-1),(236,6102002,NULL,3010010,25,-1),(237,6102002,NULL,4032015,25,-1),(238,6102002,NULL,4032016,25,-1),(239,6102002,NULL,4032017,25,-1),(240,6102002,NULL,4161018,25,-1),(241,6102002,NULL,4161021,25,-1),(242,6102002,NULL,4001107,25,-1),(243,6102002,NULL,4161015,25,-1),(244,6102002,NULL,4161016,25,-1),(245,6102002,NULL,2022121,25,-1),(246,6102002,NULL,2044803,25,-1),(247,6102002,NULL,2044903,25,-1),(248,6102002,NULL,2290071,50,-1),(249,6102002,NULL,2290027,50,-1),(250,6102002,NULL,2290111,50,-1),(251,6102002,NULL,2290118,50,-1),(252,6102002,NULL,2290103,50,-1),(253,6102002,NULL,2290047,50,-1),(254,6102002,NULL,2290091,50,-1),(255,6102002,NULL,2290053,50,-1),(256,6102002,NULL,2290061,50,-1),(257,6102002,NULL,2290011,50,-1),(258,6102002,NULL,2290089,50,-1),(259,6102003,NULL,1472051,25,-1),(260,6102003,NULL,1442056,25,-1),(261,6102003,NULL,1072228,25,-1),(262,6102003,NULL,1322062,25,-1),(263,6102003,NULL,1092061,25,-1),(264,6102003,NULL,1452019,25,-1),(265,6102003,NULL,1492012,25,-1),(266,6102003,NULL,1092050,25,-1),(267,6102003,NULL,1402005,25,-1),(268,6102003,NULL,1052131,25,-1),(269,6102003,NULL,1462016,25,-1),(270,6102003,NULL,1332051,25,-1),(271,6102003,NULL,1102043,50,-1),(272,6102003,NULL,1102206,50,-1),(273,6102003,NULL,1102260,50,-1),(274,6102003,NULL,3010010,25,-1),(275,6102003,NULL,4032015,25,-1),(276,6102003,NULL,4032016,25,-1),(277,6102003,NULL,4032017,25,-1),(278,6102003,NULL,4161018,25,-1),(279,6102003,NULL,4161021,25,-1),(280,6102003,NULL,4001107,25,-1),(281,6102003,NULL,4161015,25,-1),(282,6102003,NULL,4161016,25,-1),(283,6102003,NULL,2022121,25,-1),(284,6102003,NULL,2044803,25,-1),(285,6102003,NULL,2044903,25,-1),(286,6102003,NULL,2290071,50,-1),(287,6102003,NULL,2290027,50,-1),(288,6102003,NULL,2290111,50,-1),(289,6102003,NULL,2290118,50,-1),(290,6102003,NULL,2290103,50,-1),(291,6102003,NULL,2290047,50,-1),(292,6102003,NULL,2290091,50,-1),(293,6102003,NULL,2290053,50,-1),(294,6102003,NULL,2290061,50,-1),(295,6102003,NULL,2290011,50,-1),(296,6102003,NULL,2290089,50,-1),(297,6102004,NULL,1472051,25,-1),(298,6102004,NULL,1442056,25,-1),(299,6102004,NULL,1072228,25,-1),(300,6102004,NULL,1322062,25,-1),(301,6102004,NULL,1092061,25,-1),(302,6102004,NULL,1452019,25,-1),(303,6102004,NULL,1492012,25,-1),(304,6102004,NULL,1092050,25,-1),(305,6102004,NULL,1402005,25,-1),(306,6102004,NULL,1052131,25,-1),(307,6102004,NULL,1462016,25,-1),(308,6102004,NULL,1332051,25,-1),(309,6102004,NULL,1102043,50,-1),(310,6102004,NULL,1102206,50,-1),(311,6102004,NULL,1102260,50,-1),(312,6102004,NULL,3010010,25,-1),(313,6102004,NULL,4032015,25,-1),(314,6102004,NULL,4032016,25,-1),(315,6102004,NULL,4032017,25,-1),(316,6102004,NULL,4161018,25,-1),(317,6102004,NULL,4161021,25,-1),(318,6102004,NULL,4001107,25,-1),(319,6102004,NULL,4161015,25,-1),(320,6102004,NULL,4161016,25,-1),(321,6102004,NULL,2022121,25,-1),(322,6102004,NULL,2044803,25,-1),(323,6102004,NULL,2044903,25,-1),(324,6102004,NULL,2290071,50,-1),(325,6102004,NULL,2290027,50,-1),(326,6102004,NULL,2290111,50,-1),(327,6102004,NULL,2290118,50,-1),(328,6102004,NULL,2290103,50,-1),(329,6102004,NULL,2290047,50,-1),(330,6102004,NULL,2290091,50,-1),(331,6102004,NULL,2290053,50,-1),(332,6102004,NULL,2290061,50,-1),(333,6102004,NULL,2290011,50,-1),(334,6102004,NULL,2290089,50,-1),(335,6102005,NULL,1472051,25,-1),(336,6102005,NULL,1442056,25,-1),(337,6102005,NULL,1072228,25,-1),(338,6102005,NULL,1322062,25,-1),(339,6102005,NULL,1092061,25,-1),(340,6102005,NULL,1452019,25,-1),(341,6102005,NULL,1492012,25,-1),(342,6102005,NULL,1092050,25,-1),(343,6102005,NULL,1402005,25,-1),(344,6102005,NULL,1052131,25,-1),(345,6102005,NULL,1462016,25,-1),(346,6102005,NULL,1332051,25,-1),(347,6102005,NULL,1102043,50,-1),(348,6102005,NULL,1102206,50,-1),(349,6102005,NULL,1102260,50,-1),(350,6102005,NULL,3010010,25,-1),(351,6102005,NULL,4032015,25,-1),(352,6102005,NULL,4032016,25,-1),(353,6102005,NULL,4032017,25,-1),(354,6102005,NULL,4161018,25,-1),(355,6102005,NULL,4161021,25,-1),(356,6102005,NULL,4001107,25,-1),(357,6102005,NULL,4161015,25,-1),(358,6102005,NULL,4161016,25,-1),(359,6102005,NULL,2022121,25,-1),(360,6102005,NULL,2044803,25,-1),(361,6102005,NULL,2044903,25,-1),(362,6102005,NULL,2290071,50,-1),(363,6102005,NULL,2290027,50,-1),(364,6102005,NULL,2290111,50,-1),(365,6102005,NULL,2290118,50,-1),(366,6102005,NULL,2290103,50,-1),(367,6102005,NULL,2290047,50,-1),(368,6102005,NULL,2290091,50,-1),(369,6102005,NULL,2290053,50,-1),(370,6102005,NULL,2290061,50,-1),(371,6102005,NULL,2290011,50,-1),(372,6102005,NULL,2290089,50,-1),(373,3002000,NULL,4001162,1,-1),(374,3002001,NULL,4001163,1,-1),(375,6702000,NULL,4031595,1,-1),(376,6702003,NULL,1032043,5,-1),(377,6702003,NULL,1032044,5,-1),(378,6702003,NULL,1032045,5,-1),(379,6702003,NULL,1102099,20,-1),(380,6702003,NULL,1102100,20,-1),(381,6702003,NULL,1102101,50,-1),(382,6702003,NULL,1102102,50,-1),(383,6702003,NULL,1102103,50,-1),(384,6702003,NULL,1102104,50,-1),(385,6702003,NULL,1102105,50,-1),(386,6702003,NULL,1102106,50,-1),(387,6702003,NULL,4021007,5,-1),(388,6702003,NULL,4021008,5,-1),(389,6702003,NULL,4020007,5,-1),(390,6702003,NULL,4020007,5,-1),(391,6702003,NULL,4011006,5,-1),(392,6702003,NULL,2040759,50,-1),(393,6702003,NULL,2041035,20,-1),(394,6702003,NULL,2041037,20,-1),(395,6702003,NULL,2041039,20,-1),(396,6702003,NULL,2041041,20,-1),(397,6702003,NULL,2000005,5,-1),(398,6702003,NULL,2022179,4,-1),(399,6702003,NULL,2022180,5,-1),(400,6702003,NULL,2022181,5,-1),(401,6702003,NULL,2022182,5,-1),(402,6702003,NULL,2000005,5,-1),(403,6702003,NULL,2020010,5,-1),(404,6702003,NULL,2020013,5,-1),(405,6702003,NULL,3010011,50,-1),(406,6702003,NULL,3012000,100,-1),(407,6702003,NULL,3012005,100,-1),(408,6702004,NULL,1032043,5,-1),(409,6702004,NULL,1032044,5,-1),(410,6702004,NULL,1032045,5,-1),(411,6702004,NULL,1102099,20,-1),(412,6702004,NULL,1102100,20,-1),(413,6702004,NULL,1102101,50,-1),(414,6702004,NULL,1102102,50,-1),(415,6702004,NULL,1102103,50,-1),(416,6702004,NULL,1102104,50,-1),(417,6702004,NULL,1102105,50,-1),(418,6702004,NULL,1102106,50,-1),(419,6702004,NULL,4021007,5,-1),(420,6702004,NULL,4021008,5,-1),(421,6702004,NULL,4020007,5,-1),(422,6702004,NULL,4020007,5,-1),(423,6702004,NULL,4011006,5,-1),(424,6702004,NULL,2040759,50,-1),(425,6702004,NULL,2041035,20,-1),(426,6702004,NULL,2041037,20,-1),(427,6702004,NULL,2041039,20,-1),(428,6702004,NULL,2041041,20,-1),(429,6702004,NULL,2000005,5,-1),(430,6702004,NULL,2022179,4,-1),(431,6702004,NULL,2022180,5,-1),(432,6702004,NULL,2022181,5,-1),(433,6702004,NULL,2022182,5,-1),(434,6702004,NULL,2000005,5,-1),(435,6702004,NULL,2020010,5,-1),(436,6702004,NULL,2020013,5,-1),(437,6702004,NULL,3010011,50,-1),(438,6702004,NULL,3012000,100,-1),(439,6702004,NULL,3012005,100,-1),(440,6702005,NULL,1032043,5,-1),(441,6702005,NULL,1032044,5,-1),(442,6702005,NULL,1032045,5,-1),(443,6702005,NULL,1102099,20,-1),(444,6702005,NULL,1102100,20,-1),(445,6702005,NULL,1102101,50,-1),(446,6702005,NULL,1102102,50,-1),(447,6702005,NULL,1102103,50,-1),(448,6702005,NULL,1102104,50,-1),(449,6702005,NULL,1102105,50,-1),(450,6702005,NULL,1102106,50,-1),(451,6702005,NULL,4021007,5,-1),(452,6702005,NULL,4021008,5,-1),(453,6702005,NULL,4020007,5,-1),(454,6702005,NULL,4020007,5,-1),(455,6702005,NULL,4011006,5,-1),(456,6702005,NULL,2040759,50,-1),(457,6702005,NULL,2041035,20,-1),(458,6702005,NULL,2041037,20,-1),(459,6702005,NULL,2041039,20,-1),(460,6702005,NULL,2041041,20,-1),(461,6702005,NULL,2000005,5,-1),(462,6702005,NULL,2022179,4,-1),(463,6702005,NULL,2022180,5,-1),(464,6702005,NULL,2022181,5,-1),(465,6702005,NULL,2022182,5,-1),(466,6702005,NULL,2000005,5,-1),(467,6702005,NULL,2020010,5,-1),(468,6702005,NULL,2020013,5,-1),(469,6702005,NULL,3010011,50,-1),(470,6702005,NULL,3012000,100,-1),(471,6702005,NULL,3012005,100,-1),(472,6702006,NULL,1032043,5,-1),(473,6702006,NULL,1032044,5,-1),(474,6702006,NULL,1032045,5,-1),(475,6702006,NULL,1102099,20,-1),(476,6702006,NULL,1102100,20,-1),(477,6702006,NULL,1102101,50,-1),(478,6702006,NULL,1102102,50,-1),(479,6702006,NULL,1102103,50,-1),(480,6702006,NULL,1102104,50,-1),(481,6702006,NULL,1102105,50,-1),(482,6702006,NULL,1102106,50,-1),(483,6702006,NULL,4021007,5,-1),(484,6702006,NULL,4021008,5,-1),(485,6702006,NULL,4020007,5,-1),(486,6702006,NULL,4020007,5,-1),(487,6702006,NULL,4011006,5,-1),(488,6702006,NULL,2040759,50,-1),(489,6702006,NULL,2041035,20,-1),(490,6702006,NULL,2041037,20,-1),(491,6702006,NULL,2041039,20,-1),(492,6702006,NULL,2041041,20,-1),(493,6702006,NULL,2000005,5,-1),(494,6702006,NULL,2022179,4,-1),(495,6702006,NULL,2022180,5,-1),(496,6702006,NULL,2022181,5,-1),(497,6702006,NULL,2022182,5,-1),(498,6702006,NULL,2000005,5,-1),(499,6702006,NULL,2020010,5,-1),(500,6702006,NULL,2020013,5,-1),(501,6702006,NULL,3010011,50,-1),(502,6702006,NULL,3012000,100,-1),(503,6702006,NULL,3012005,100,-1),(504,6702007,NULL,1032043,5,-1),(505,6702007,NULL,1032044,5,-1),(506,6702007,NULL,1032045,5,-1),(507,6702007,NULL,1102099,20,-1),(508,6702007,NULL,1102100,20,-1),(509,6702007,NULL,1102101,50,-1),(510,6702007,NULL,1102102,50,-1),(511,6702007,NULL,1102103,50,-1),(512,6702007,NULL,1102104,50,-1),(513,6702007,NULL,1102105,50,-1),(514,6702007,NULL,1102106,50,-1),(515,6702007,NULL,4021007,5,-1),(516,6702007,NULL,4021008,5,-1),(517,6702007,NULL,4020007,5,-1),(518,6702007,NULL,4020007,5,-1),(519,6702007,NULL,4011006,5,-1),(520,6702007,NULL,2040759,50,-1),(521,6702007,NULL,2041035,20,-1),(522,6702007,NULL,2041037,20,-1),(523,6702007,NULL,2041039,20,-1),(524,6702007,NULL,2041041,20,-1),(525,6702007,NULL,2000005,5,-1),(526,6702007,NULL,2022179,4,-1),(527,6702007,NULL,2022180,5,-1),(528,6702007,NULL,2022181,5,-1),(529,6702007,NULL,2022182,5,-1),(530,6702007,NULL,2000005,5,-1),(531,6702007,NULL,2020010,5,-1),(532,6702007,NULL,2020013,5,-1),(533,6702007,NULL,3010011,50,-1),(534,6702007,NULL,3012000,100,-1),(535,6702007,NULL,3012005,100,-1),(536,6702008,NULL,1032043,5,-1),(537,6702008,NULL,1032044,5,-1),(538,6702008,NULL,1032045,5,-1),(539,6702008,NULL,1102099,20,-1),(540,6702008,NULL,1102100,20,-1),(541,6702008,NULL,1102101,50,-1),(542,6702008,NULL,1102102,50,-1),(543,6702008,NULL,1102103,50,-1),(544,6702008,NULL,1102104,50,-1),(545,6702008,NULL,1102105,50,-1),(546,6702008,NULL,1102106,50,-1),(547,6702008,NULL,4021007,5,-1),(548,6702008,NULL,4021008,5,-1),(549,6702008,NULL,4020007,5,-1),(550,6702008,NULL,4020007,5,-1),(551,6702008,NULL,4011006,5,-1),(552,6702008,NULL,2040759,50,-1),(553,6702008,NULL,2041035,20,-1),(554,6702008,NULL,2041037,20,-1),(555,6702008,NULL,2041039,20,-1),(556,6702008,NULL,2041041,20,-1),(557,6702008,NULL,2000005,5,-1),(558,6702008,NULL,2022179,4,-1),(559,6702008,NULL,2022180,5,-1),(560,6702008,NULL,2022181,5,-1),(561,6702008,NULL,2022182,5,-1),(562,6702008,NULL,2000005,5,-1),(563,6702008,NULL,2020010,5,-1),(564,6702008,NULL,2020013,5,-1),(565,6702008,NULL,3010011,50,-1),(566,6702008,NULL,3012000,100,-1),(567,6702008,NULL,3012005,100,-1),(568,6702009,NULL,1032043,5,-1),(569,6702009,NULL,1032044,5,-1),(570,6702009,NULL,1032045,5,-1),(571,6702009,NULL,1102099,20,-1),(572,6702009,NULL,1102100,20,-1),(573,6702009,NULL,1102101,50,-1),(574,6702009,NULL,1102102,50,-1),(575,6702009,NULL,1102103,50,-1),(576,6702009,NULL,1102104,50,-1),(577,6702009,NULL,1102105,50,-1),(578,6702009,NULL,1102106,50,-1),(579,6702009,NULL,4021007,5,-1),(580,6702009,NULL,4021008,5,-1),(581,6702009,NULL,4020007,5,-1),(582,6702009,NULL,4020007,5,-1),(583,6702009,NULL,4011006,5,-1),(584,6702009,NULL,2040759,50,-1),(585,6702009,NULL,2041035,20,-1),(586,6702009,NULL,2041037,20,-1),(587,6702009,NULL,2041039,20,-1),(588,6702009,NULL,2041041,20,-1),(589,6702009,NULL,2000005,5,-1),(590,6702009,NULL,2022179,4,-1),(591,6702009,NULL,2022180,5,-1),(592,6702009,NULL,2022181,5,-1),(593,6702009,NULL,2022182,5,-1),(594,6702009,NULL,2000005,5,-1),(595,6702009,NULL,2020010,5,-1),(596,6702009,NULL,2020013,5,-1),(597,6702009,NULL,3010011,50,-1),(598,6702009,NULL,3012000,100,-1),(599,6702009,NULL,3012005,100,-1),(600,6702010,NULL,1032043,5,-1),(601,6702010,NULL,1032044,5,-1),(602,6702010,NULL,1032045,5,-1),(603,6702010,NULL,1102099,20,-1),(604,6702010,NULL,1102100,20,-1),(605,6702010,NULL,1102101,50,-1),(606,6702010,NULL,1102102,50,-1),(607,6702010,NULL,1102103,50,-1),(608,6702010,NULL,1102104,50,-1),(609,6702010,NULL,1102105,50,-1),(610,6702010,NULL,1102106,50,-1),(611,6702010,NULL,4021007,5,-1),(612,6702010,NULL,4021008,5,-1),(613,6702010,NULL,4020007,5,-1),(614,6702010,NULL,4020007,5,-1),(615,6702010,NULL,4011006,5,-1),(616,6702010,NULL,2040759,50,-1),(617,6702010,NULL,2041035,20,-1),(618,6702010,NULL,2041037,20,-1),(619,6702010,NULL,2041039,20,-1),(620,6702010,NULL,2041041,20,-1),(621,6702010,NULL,2000005,5,-1),(622,6702010,NULL,2022179,4,-1),(623,6702010,NULL,2022180,5,-1),(624,6702010,NULL,2022181,5,-1),(625,6702010,NULL,2022182,5,-1),(626,6702010,NULL,2000005,5,-1),(627,6702010,NULL,2020010,5,-1),(628,6702010,NULL,2020013,5,-1),(629,6702010,NULL,3010011,50,-1),(630,6702010,NULL,3012000,100,-1),(631,6702010,NULL,3012005,100,-1),(632,6702011,NULL,1032043,5,-1),(633,6702011,NULL,1032044,5,-1),(634,6702011,NULL,1032045,5,-1),(635,6702011,NULL,1102099,20,-1),(636,6702011,NULL,1102100,20,-1),(637,6702011,NULL,1102101,50,-1),(638,6702011,NULL,1102102,50,-1),(639,6702011,NULL,1102103,50,-1),(640,6702011,NULL,1102104,50,-1),(641,6702011,NULL,1102105,50,-1),(642,6702011,NULL,1102106,50,-1),(643,6702011,NULL,4021007,5,-1),(644,6702011,NULL,4021008,5,-1),(645,6702011,NULL,4020007,5,-1),(646,6702011,NULL,4020007,5,-1),(647,6702011,NULL,4011006,5,-1),(648,6702011,NULL,2040759,50,-1),(649,6702011,NULL,2041035,20,-1),(650,6702011,NULL,2041037,20,-1),(651,6702011,NULL,2041039,20,-1),(652,6702011,NULL,2041041,20,-1),(653,6702011,NULL,2000005,5,-1),(654,6702011,NULL,2022179,4,-1),(655,6702011,NULL,2022180,5,-1),(656,6702011,NULL,2022181,5,-1),(657,6702011,NULL,2022182,5,-1),(658,6702011,NULL,2000005,5,-1),(659,6702011,NULL,2020010,5,-1),(660,6702011,NULL,2020013,5,-1),(661,6702011,NULL,3010011,50,-1),(662,6702011,NULL,3012000,100,-1),(663,6702011,NULL,3012005,100,-1),(664,6702012,NULL,1032043,5,-1),(665,6702012,NULL,1032044,5,-1),(666,6702012,NULL,1032045,5,-1),(667,6702012,NULL,1102099,20,-1),(668,6702012,NULL,1102100,20,-1),(669,6702012,NULL,1102101,50,-1),(670,6702012,NULL,1102102,50,-1),(671,6702012,NULL,1102103,50,-1),(672,6702012,NULL,1102104,50,-1),(673,6702012,NULL,1102105,50,-1),(674,6702012,NULL,1102106,50,-1),(675,6702012,NULL,4021007,5,-1),(676,6702012,NULL,4021008,5,-1),(677,6702012,NULL,4020007,5,-1),(678,6702012,NULL,4020007,5,-1),(679,6702012,NULL,4011006,5,-1),(680,6702012,NULL,2040759,50,-1),(681,6702012,NULL,2041035,20,-1),(682,6702012,NULL,2041037,20,-1),(683,6702012,NULL,2041039,20,-1),(684,6702012,NULL,2041041,20,-1),(685,6702012,NULL,2000005,5,-1),(686,6702012,NULL,2022179,5,-1),(687,6702012,NULL,2022180,5,-1),(688,6702012,NULL,2022181,5,-1),(689,6702012,NULL,2022182,5,-1),(690,6702012,NULL,2000005,5,-1),(691,6702012,NULL,2020010,5,-1),(692,6702012,NULL,2020013,5,-1),(693,6702012,NULL,3010011,50,-1),(694,6702012,NULL,3012000,100,-1),(695,6702012,NULL,3012005,100,-1),(696,1032000,NULL,4001363,1,-1),(697,1032000,NULL,4001362,1,-1),(698,2512000,NULL,2022131,1,-1),(699,2512000,NULL,2022132,1,-1),(700,2612002,NULL,4001134,1,-1),(701,2612001,NULL,4001135,1,-1),(704,9102003,NULL,4001095,3,-1),(705,9102003,NULL,4001096,3,-1),(706,9102004,NULL,4001096,3,-1),(707,9102004,NULL,4001097,3,-1),(708,9102005,NULL,4001097,3,-1),(709,9102005,NULL,4001098,3,-1),(710,9102006,NULL,4001098,3,-1),(711,9102006,NULL,4001099,3,-1),(712,9102007,NULL,4001099,3,-1),(713,9102007,NULL,4001100,3,-1),(714,2002001,NULL,4001063,1,-1),(715,2002002,NULL,4001052,1,-1),(716,2002003,NULL,4001055,1,-1),(717,2002004,NULL,4001056,1,-1),(718,2002005,NULL,4001057,1,-1),(719,2002006,NULL,4001058,1,-1),(720,2002007,NULL,4001059,1,-1),(721,2002008,NULL,4001060,1,-1),(722,2002009,NULL,4001061,1,-1),(723,2002010,NULL,4001062,1,-1),(724,2002011,NULL,4001046,1,-1),(725,2002012,NULL,4001047,1,-1),(726,2002013,NULL,4001049,1,-1),(727,2002017,NULL,4001158,1,-1),(728,2002018,NULL,4001158,1,-1),(729,3102000,NULL,4000276,1,-1),(730,6102002,NULL,1382060,50,-1),(731,6102003,NULL,1382060,50,-1),(732,6102004,NULL,1382060,50,-1),(733,6102005,NULL,1382060,50,-1),(734,6102002,NULL,1442068,50,-1),(735,6102003,NULL,1442068,50,-1),(736,6102004,NULL,1442068,50,-1),(737,6102005,NULL,1442068,50,-1),(738,6102002,NULL,1452060,50,-1),(739,6102003,NULL,1452060,50,-1),(740,6102004,NULL,1452060,50,-1),(741,6102005,NULL,1452060,50,-1),(742,3102000,NULL,2022712,1,-1),(743,2502002,NULL,2022252,1,-1),(744,1202002,NULL,4031843,1,2169),(749,9102002,NULL,4001453,1,-1),(911,200012,NULL,4031865,4,-1),(910,200011,NULL,4004004,4,-1),(905,200009,NULL,4004003,4,-1),(904,200009,NULL,4004001,4,-1),(903,200009,NULL,4010007,4,-1),(898,200007,NULL,4020000,4,-1),(909,200011,NULL,4004003,4,-1),(902,200008,NULL,4004003,4,-1),(897,200006,NULL,4020007,4,-1),(896,200006,NULL,4020002,4,-1),(895,200005,NULL,4010006,4,-1),(894,200005,NULL,4020006,4,-1),(893,200004,NULL,4004002,4,-1),(892,200004,NULL,4010006,4,-1),(891,200004,NULL,4020003,4,-1),(890,200004,NULL,4020006,4,-1),(889,200004,NULL,4010002,4,-1),(888,200003,NULL,4010003,4,-1),(793,100000,NULL,4022023,1,-1),(794,100001,NULL,4022023,1,-1),(795,100002,NULL,4022023,1,-1),(796,100003,NULL,4022023,1,-1),(797,100004,NULL,4022023,1,-1),(798,100005,NULL,4022023,1,-1),(799,100006,NULL,4022023,1,-1),(800,100007,NULL,4022023,1,-1),(801,100008,NULL,4022023,1,-1),(802,100009,NULL,4022023,1,-1),(803,100011,NULL,4022023,1,-1),(804,100011,NULL,4022023,1,-1),(805,100011,NULL,4022023,1,-1),(806,100011,NULL,4022023,1,-1),(807,100011,NULL,4022023,1,-1),(808,100011,NULL,4022023,1,-1),(809,100011,NULL,4022023,1,-1),(810,100011,NULL,4022023,1,-1),(811,100011,NULL,4022023,1,-1),(812,100011,NULL,4022023,1,-1),(813,100000,NULL,4022000,1,-1),(814,100000,NULL,4022001,1,-1),(815,100001,NULL,4022002,1,-1),(816,100001,NULL,4022003,1,-1),(817,100002,NULL,4022004,1,-1),(818,100002,NULL,4022005,1,-1),(819,100003,NULL,4022006,1,-1),(820,100003,NULL,4022007,1,-1),(821,100004,NULL,4022008,1,-1),(822,100004,NULL,4022009,1,-1),(823,100005,NULL,4022010,1,-1),(824,100005,NULL,4022011,1,-1),(825,100006,NULL,4022012,1,-1),(826,100006,NULL,4022013,1,-1),(827,100007,NULL,4022014,1,-1),(828,100007,NULL,4022015,1,-1),(829,100008,NULL,4022016,1,-1),(830,100008,NULL,4022017,1,-1),(831,100009,NULL,4022018,1,-1),(832,100009,NULL,4022019,1,-1),(833,100009,NULL,4022020,1,-1),(834,100009,NULL,4022021,1,-1),(835,100010,NULL,4022022,1,-1),(836,1002009,NULL,4031161,1,1008),(837,1002009,NULL,4031162,1,1008),(838,1209001,NULL,4032980,1,2565),(839,1052001,NULL,1532022,3,-1),(840,1052001,NULL,1532023,3,-1),(841,NULL,'EpisodeQuest0',4001340,1,28167),(843,0,'pFItem0',4001162,1,0),(844,0,'EpisodeQuest1',4001346,1,28225),(845,NULL,'sBoxItem0',4031157,1,2074),(846,NULL,'magatiaItem1',4031703,1,0),(847,NULL,'sBoxItem1',4031158,1,2074),(848,NULL,'ntItem03',4031843,1,2169),(912,200013,NULL,4031866,4,-1),(908,200011,NULL,4004002,4,-1),(907,200011,NULL,4004001,4,-1),(906,200011,NULL,4004000,4,-1),(901,200008,NULL,4004004,4,-1),(900,200008,NULL,4020008,4,-1),(899,200007,NULL,4004000,4,-1),(887,200003,NULL,4010000,4,-1),(886,200002,NULL,4020005,4,-1),(885,200002,NULL,4010001,4,-1),(884,200001,NULL,4020001,4,-1),(883,200001,NULL,4010005,4,-1),(882,200000,NULL,4020004,4,-1),(881,200000,NULL,4010004,4,-1),(913,NULL,'aquaItem3',4032476,1,22407),(914,0,'dual_ball00',2430071,1,-1);
/*!40000 ALTER TABLE `reactordrops` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `reports`
--

DROP TABLE IF EXISTS `reports`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `reports` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `reporttime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `reporterid` int(11) NOT NULL,
  `victimid` int(11) NOT NULL,
  `reason` tinyint(4) NOT NULL,
  `chatlog` text NOT NULL,
  `status` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `reports`
--

LOCK TABLES `reports` WRITE;
/*!40000 ALTER TABLE `reports` DISABLE KEYS */;
/*!40000 ALTER TABLE `reports` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `responses`
--

DROP TABLE IF EXISTS `responses`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `responses` (
  `chat` text,
  `response` text,
  `id` int(10) unsigned NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `responses`
--

LOCK TABLES `responses` WRITE;
/*!40000 ALTER TABLE `responses` DISABLE KEYS */;
/*!40000 ALTER TABLE `responses` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rings`
--

DROP TABLE IF EXISTS `rings`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rings` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `partnerRingId` int(11) NOT NULL DEFAULT '0',
  `partnerChrId` int(11) NOT NULL DEFAULT '0',
  `itemid` int(11) NOT NULL DEFAULT '0',
  `partnername` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rings`
--

LOCK TABLES `rings` WRITE;
/*!40000 ALTER TABLE `rings` DISABLE KEYS */;
/*!40000 ALTER TABLE `rings` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `savedlocations`
--

DROP TABLE IF EXISTS `savedlocations`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `savedlocations` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `characterid` int(11) NOT NULL,
  `locationtype` enum('FREE_MARKET','WORLDTOUR','FLORINA','INTRO','MIRROR','EVENT','BOSSPQ') NOT NULL,
  `map` int(11) NOT NULL,
  `portal` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `savedlocations`
--

LOCK TABLES `savedlocations` WRITE;
/*!40000 ALTER TABLE `savedlocations` DISABLE KEYS */;
/*!40000 ALTER TABLE `savedlocations` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `serverStatus`
--

DROP TABLE IF EXISTS `serverStatus`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `serverStatus` (
  `idinc` int(11) NOT NULL AUTO_INCREMENT,
  `server` varchar(45) NOT NULL,
  `status` tinyint(1) NOT NULL,
  PRIMARY KEY (`idinc`),
  UNIQUE KEY `serverType_UNIQUE` (`server`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `serverStatus`
--

LOCK TABLES `serverStatus` WRITE;
/*!40000 ALTER TABLE `serverStatus` DISABLE KEYS */;
/*!40000 ALTER TABLE `serverStatus` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sessions`
--

DROP TABLE IF EXISTS `sessions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sessions` (
  `id` varchar(700) COLLATE utf8mb4_unicode_ci NOT NULL,
  `user_id` int(10) unsigned DEFAULT NULL,
  `ip_address` varchar(45) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `user_agent` text COLLATE utf8mb4_unicode_ci,
  `payload` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `last_activity` int(11) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sessions`
--

LOCK TABLES `sessions` WRITE;
/*!40000 ALTER TABLE `sessions` DISABLE KEYS */;
/*!40000 ALTER TABLE `sessions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `settings`
--

DROP TABLE IF EXISTS `settings`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `settings` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `alert` longtext NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `settings`
--

LOCK TABLES `settings` WRITE;
/*!40000 ALTER TABLE `settings` DISABLE KEYS */;
INSERT INTO `settings` VALUES (1,'Site is under Construction');
/*!40000 ALTER TABLE `settings` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `shopitems`
--

DROP TABLE IF EXISTS `shopitems`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `shopitems` (
  `shopitemid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `shopid` int(10) unsigned NOT NULL,
  `itemid` int(11) NOT NULL,
  `price` int(11) NOT NULL,
  `discountRate` int(5) NOT NULL DEFAULT '0',
  `tokenItemID` int(11) NOT NULL DEFAULT '0',
  `tokenPrice` int(11) NOT NULL DEFAULT '0',
  `itemPeriod` int(11) NOT NULL DEFAULT '0',
  `levelLimited` int(11) NOT NULL DEFAULT '0',
  `position` int(11) NOT NULL,
  PRIMARY KEY (`shopitemid`)
) ENGINE=MyISAM AUTO_INCREMENT=20146 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `shopitems`
--

LOCK TABLES `shopitems` WRITE;
/*!40000 ALTER TABLE `shopitems` DISABLE KEYS */;
INSERT INTO `shopitems` VALUES (1,11000,1332005,500,0,0,0,0,0,3),(2,11000,1322005,50,0,0,0,0,0,2),(3,11000,1312004,50,0,0,0,0,0,1),(4,11000,1302000,50,0,0,0,0,0,0),(5,11100,2010002,50,0,0,0,0,0,4),(6,11100,2010000,30,0,0,0,0,0,3),(7,11100,2000002,320,0,0,0,0,0,2),(8,11100,2000001,160,0,0,0,0,0,1),(9,11100,2000000,50,0,0,0,0,0,0),(10,21000,1072005,50,0,0,0,0,0,12),(11,21000,1072001,50,0,0,0,0,0,11),(12,21000,1061008,50,0,0,0,0,0,10),(13,21000,1061002,50,0,0,0,0,0,9),(14,21000,1060006,50,0,0,0,0,0,8),(15,21000,1060002,50,0,0,0,0,0,7),(16,21000,1041011,50,0,0,0,0,0,6),(17,21000,1041010,50,0,0,0,0,0,5),(18,21000,1041006,50,0,0,0,0,0,4),(19,21000,1041002,50,0,0,0,0,0,3),(20,21000,1040010,50,0,0,0,0,0,2),(21,21000,1040006,50,0,0,0,0,0,1),(22,21000,1040002,50,0,0,0,0,0,0),(23,1001000,1332007,1000,0,0,0,0,0,5),(24,1001000,1312000,3000,0,0,0,0,0,2),(25,1001000,1302007,3000,0,0,0,0,0,1),(26,1001000,1322005,50,0,0,0,0,0,4),(27,1001000,1312004,50,0,0,0,0,0,3),(28,1001000,1302000,50,0,0,0,0,0,0),(29,1001001,3010001,1000,0,0,0,0,0,30),(30,1001001,1092003,2000,0,0,0,0,0,29),(31,1001001,1072063,10000,0,0,0,0,0,28),(32,1001001,1072062,10000,0,0,0,0,0,27),(33,1001001,1072017,10000,0,0,0,0,0,22),(34,1001001,1072049,5000,0,0,0,0,0,26),(35,1001001,1072048,5000,0,0,0,0,0,25),(36,1001001,1072008,5000,0,0,0,0,0,21),(37,1001001,1072005,50,0,0,0,0,0,20),(38,1001001,1072038,50,0,0,0,0,0,24),(39,1001001,1072037,50,0,0,0,0,0,23),(40,1001001,1072001,50,0,0,0,0,0,19),(41,1001001,1062001,4800,0,0,0,0,0,18),(42,1001001,1062000,4800,0,0,0,0,0,17),(43,1001001,1060004,2800,0,0,0,0,0,15),(44,1001001,1060007,1000,0,0,0,0,0,16),(45,1001001,1041012,3000,0,0,0,0,0,14),(46,1001001,1041004,3000,0,0,0,0,0,13),(47,1001001,1040014,3000,0,0,0,0,0,12),(48,1001001,1040013,3000,0,0,0,0,0,11),(49,1001001,1002001,3000,0,0,0,0,0,0),(50,1001001,1002019,2000,0,0,0,0,0,3),(51,1001001,1002134,800,0,0,0,0,0,10),(52,1001001,1002133,800,0,0,0,0,0,9),(53,1001001,1002132,800,0,0,0,0,0,8),(54,1001001,1002069,450,0,0,0,0,0,7),(55,1001001,1002068,450,0,0,0,0,0,6),(56,1001001,1002067,450,0,0,0,0,0,5),(57,1001001,1002066,450,0,0,0,0,0,4),(58,1001001,1002014,1000,0,0,0,0,0,2),(59,1001001,1002008,500,0,0,0,0,0,1),(60,1001100,2330000,600,0,0,0,0,0,21),(61,1001100,2070000,500,0,0,0,0,0,20),(64,1001100,2061000,1,0,0,0,0,0,19),(65,1001100,2060000,1,0,0,0,0,0,18),(66,1001100,2030001,500,0,0,0,0,0,17),(67,1001100,2030000,400,0,0,0,0,0,16),(68,1001100,2020028,3000,0,0,0,0,0,15),(69,1001100,2010004,310,0,0,0,0,0,14),(70,1001100,2010003,100,0,0,0,0,0,13),(71,1001100,2010001,106,0,0,0,0,0,11),(72,1001100,2010002,50,0,0,0,0,0,12),(73,1001100,2010000,30,0,0,0,0,0,10),(74,1001100,2002005,500,0,0,0,0,0,9),(75,1001100,2002004,500,0,0,0,0,0,8),(76,1001100,2002002,500,0,0,0,0,0,7),(77,1001100,2002001,400,0,0,0,0,0,6),(78,1001100,2002000,500,0,0,0,0,0,5),(79,1001100,2000006,620,0,0,0,0,0,4),(80,1001100,2000003,200,0,0,0,0,0,3),(81,1001100,2000002,320,0,0,0,0,0,2),(82,1001100,2000001,160,0,0,0,0,0,1),(83,1001100,2000000,50,0,0,0,0,0,0),(84,1011000,1442004,24000,0,0,0,0,0,4),(85,1011000,1422004,20000,0,0,0,0,0,3),(86,1011000,1322008,12000,0,0,0,0,0,2),(87,1011000,1322007,6000,0,0,0,0,0,1),(88,1011000,1302007,3000,0,0,0,0,0,0),(89,1011000,1462000,30000,0,0,0,0,0,9),(90,1011000,1462003,12000,0,0,0,0,0,12),(91,1011000,1462002,8000,0,0,0,0,0,11),(92,1011000,1462001,4000,0,0,0,0,0,10),(93,1011000,1452000,20000,0,0,0,0,0,5),(94,1011000,1452001,10000,0,0,0,0,0,6),(95,1011000,1452003,6000,0,0,0,0,0,8),(96,1011000,1452002,3000,0,0,0,0,0,7),(97,1011001,1072064,30000,0,0,0,0,0,90),(98,1011001,1072018,30000,0,0,0,0,0,81),(99,1011001,1072056,15000,0,0,0,0,0,86),(100,1011001,1072055,15000,0,0,0,0,0,85),(101,1011001,1072054,15000,0,0,0,0,0,84),(102,1011001,1072012,15000,0,0,0,0,0,78),(103,1011001,1072068,9000,0,0,0,0,0,92),(104,1011001,1072067,9000,0,0,0,0,0,91),(105,1011001,1072026,9000,0,0,0,0,0,83),(106,1011001,1072025,9000,0,0,0,0,0,82),(107,1011001,1072061,4500,0,0,0,0,0,89),(108,1011001,1072060,4500,0,0,0,0,0,88),(109,1011001,1072016,4500,0,0,0,0,0,80),(110,1011001,1072059,1800,0,0,0,0,0,87),(111,1011001,1072015,1800,0,0,0,0,0,79),(112,1011001,1062006,13000,0,0,0,0,0,77),(113,1011001,1062002,9000,0,0,0,0,0,75),(114,1011001,1062004,3000,0,0,0,0,0,76),(115,1011001,1061052,44000,0,0,0,0,0,71),(116,1011001,1061051,44000,0,0,0,0,0,70),(117,1011001,1061050,44000,0,0,0,0,0,69),(118,1011001,1061026,9000,0,0,0,0,0,68),(119,1011001,1061025,9000,0,0,0,0,0,67),(120,1011001,1061024,9000,0,0,0,0,0,66),(121,1011001,1061059,5000,0,0,0,0,0,74),(122,1011001,1061058,5000,0,0,0,0,0,73),(123,1011001,1061006,5000,0,0,0,0,0,64),(124,1011001,1061057,3000,0,0,0,0,0,72),(125,1011001,1061009,3000,0,0,0,0,0,65),(126,1011001,1060059,44000,0,0,0,0,0,63),(127,1011001,1060058,44000,0,0,0,0,0,62),(128,1011001,1060057,44000,0,0,0,0,0,61),(129,1011001,1060056,44000,0,0,0,0,0,60),(130,1011001,1060005,14000,0,0,0,0,0,59),(131,1011001,1041056,50000,0,0,0,0,0,55),(132,1011001,1041055,50000,0,0,0,0,0,54),(133,1011001,1041054,50000,0,0,0,0,0,53),(134,1011001,1041035,15000,0,0,0,0,0,52),(135,1011001,1041034,15000,0,0,0,0,0,51),(136,1011001,1041033,15000,0,0,0,0,0,50),(137,1011001,1041032,15000,0,0,0,0,0,49),(138,1011001,1041028,9000,0,0,0,0,0,48),(139,1011001,1041027,9000,0,0,0,0,0,47),(140,1011001,1041013,9000,0,0,0,0,0,46),(141,1011001,1041063,5500,0,0,0,0,0,58),(142,1011001,1041062,5500,0,0,0,0,0,57),(143,1011001,1041008,5500,0,0,0,0,0,45),(144,1011001,1041061,3200,0,0,0,0,0,56),(145,1011001,1041007,3200,0,0,0,0,0,44),(146,1011001,1040070,50000,0,0,0,0,0,42),(147,1011001,1040069,50000,0,0,0,0,0,41),(148,1011001,1040068,50000,0,0,0,0,0,40),(149,1011001,1040067,50000,0,0,0,0,0,39),(150,1011001,1040025,15000,0,0,0,0,0,38),(151,1011001,1040024,15000,0,0,0,0,0,37),(152,1011001,1040023,15000,0,0,0,0,0,36),(153,1011001,1040022,15000,0,0,0,0,0,35),(154,1011001,1040003,9000,0,0,0,0,0,31),(155,1011001,1040011,5500,0,0,0,0,0,34),(156,1011001,1040007,5500,0,0,0,0,0,32),(157,1011001,1040071,3200,0,0,0,0,0,43),(158,1011001,1040008,3200,0,0,0,0,0,33),(159,1011001,1032003,7000,0,0,0,0,0,30),(160,1011001,1032001,7000,0,0,0,0,0,29),(161,1011001,1002165,30000,0,0,0,0,0,28),(162,1011001,1002164,30000,0,0,0,0,0,27),(163,1011001,1002163,30000,0,0,0,0,0,26),(164,1011001,1002162,30000,0,0,0,0,0,25),(165,1011001,1002161,30000,0,0,0,0,0,24),(166,1011001,1002160,20000,0,0,0,0,0,23),(167,1011001,1002159,20000,0,0,0,0,0,22),(168,1011001,1002158,20000,0,0,0,0,0,21),(169,1011001,1002157,20000,0,0,0,0,0,20),(170,1011001,1002156,20000,0,0,0,0,0,19),(171,1011001,1002057,800,0,0,0,0,0,4),(172,1011001,1002010,800,0,0,0,0,0,1),(173,1011001,1002121,12000,0,0,0,0,0,18),(174,1011001,1002120,12000,0,0,0,0,0,17),(175,1011001,1002119,12000,0,0,0,0,0,16),(176,1011001,1002118,12000,0,0,0,0,0,15),(177,1011001,1002117,12000,0,0,0,0,0,14),(178,1011001,1002116,4000,0,0,0,0,0,13),(179,1011001,1002115,4000,0,0,0,0,0,12),(180,1011001,1002114,4000,0,0,0,0,0,11),(181,1011001,1002113,4000,0,0,0,0,0,10),(182,1011001,1002112,4000,0,0,0,0,0,9),(183,1011001,1002063,3000,0,0,0,0,0,8),(184,1011001,1002062,3000,0,0,0,0,0,7),(185,1011001,1002061,3000,0,0,0,0,0,6),(186,1011001,1002060,3000,0,0,0,0,0,5),(187,1011001,1002012,3000,0,0,0,0,0,2),(188,1011001,1002033,3000,0,0,0,0,0,3),(189,1011001,1002008,500,0,0,0,0,0,0),(190,1011100,2330000,600,0,0,0,0,0,24),(191,1011100,2070000,500,0,0,0,0,0,23),(192,1011100,2050002,300,0,0,0,0,0,20),(193,1011100,2050001,200,0,0,0,0,0,19),(194,1011100,2050000,200,0,0,0,0,0,18),(197,1011100,2061000,1,0,0,0,0,0,22),(198,1011100,2060000,1,0,0,0,0,0,21),(199,1011100,2030004,500,0,0,0,0,0,17),(200,1011100,2030000,400,0,0,0,0,0,16),(201,1011100,2020028,3000,0,0,0,0,0,15),(202,1011100,2010004,310,0,0,0,0,0,14),(203,1011100,2010003,100,0,0,0,0,0,13),(204,1011100,2010001,106,0,0,0,0,0,11),(205,1011100,2010002,50,0,0,0,0,0,12),(206,1011100,2010000,30,0,0,0,0,0,10),(207,1011100,2002005,500,0,0,0,0,0,9),(208,1011100,2002004,500,0,0,0,0,0,8),(209,1011100,2002002,500,0,0,0,0,0,7),(210,1011100,2002001,400,0,0,0,0,0,6),(211,1011100,2002000,500,0,0,0,0,0,5),(212,1011100,2000006,620,0,0,0,0,0,4),(213,1011100,2000003,200,0,0,0,0,0,3),(214,1011100,2000002,320,0,0,0,0,0,2),(215,1011100,2000001,160,0,0,0,0,0,1),(216,1011100,2000000,50,0,0,0,0,0,0),(217,1012004,4160019,1000,0,0,0,0,0,19),(218,1012004,4160039,1000,0,0,0,0,0,30),(219,1012004,4160037,1000,0,0,0,0,0,29),(220,1012004,4031993,100000,0,0,0,0,0,2),(221,1012004,4160036,1000,0,0,0,0,0,28),(222,1012004,4160035,1000,0,0,0,0,0,27),(223,1012004,4160034,1000,0,0,0,0,0,26),(224,1012004,4160032,1000,0,0,0,0,0,25),(225,1012004,4160024,1000,0,0,0,0,0,23),(226,1012004,4160023,1000,0,0,0,0,0,22),(227,1012004,4160022,1000,0,0,0,0,0,21),(228,1012004,4160015,1000,0,0,0,0,0,17),(229,1012004,4160012,1000,0,0,0,0,0,14),(230,1012004,4160013,1000,0,0,0,0,0,15),(231,1012004,4160017,1000,0,0,0,0,0,18),(232,1012004,4160014,1000,0,0,0,0,0,16),(233,1012004,4160020,1000,0,0,0,0,0,20),(234,1012004,4160010,1000,0,0,0,0,0,13),(235,1012004,4160009,1000,0,0,0,0,0,12),(236,1012004,4160008,1000,0,0,0,0,0,11),(237,1012004,4160007,1000,0,0,0,0,0,10),(238,1012004,4160006,1000,0,0,0,0,0,9),(239,1012004,4160005,1000,0,0,0,0,0,8),(240,1012004,4160004,1000,0,0,0,0,0,7),(241,1012004,4160003,1000,0,0,0,0,0,6),(242,1012004,4160002,1000,0,0,0,0,0,5),(243,1012004,4160001,1000,0,0,0,0,0,4),(244,1012004,4160000,1000,0,0,0,0,0,3),(245,1012004,4160026,1000,0,0,0,0,0,24),(246,1012004,2260000,1000,0,0,0,0,0,1),(247,1012004,2120000,30,0,0,0,0,0,0),(248,1021000,1442004,24000,0,0,0,0,0,31),(249,1021000,1442007,12000,0,0,0,0,0,33),(250,1021000,1442006,8000,0,0,0,0,0,32),(251,1021000,1442000,3000,0,0,0,0,0,30),(252,1021000,1432001,7000,0,0,0,0,0,29),(253,1021000,1432000,3000,0,0,0,0,0,28),(254,1021000,1422004,20000,0,0,0,0,0,26),(255,1021000,1422006,10000,0,0,0,0,0,27),(256,1021000,1422003,10000,0,0,0,0,0,25),(257,1021000,1422002,6000,0,0,0,0,0,24),(258,1021000,1422000,3000,0,0,0,0,0,23),(259,1021000,1412006,45000,0,0,0,0,0,22),(260,1021000,1412000,22000,0,0,0,0,0,19),(261,1021000,1412002,10000,0,0,0,0,0,21),(262,1021000,1412001,3000,0,0,0,0,0,20),(263,1021000,1402008,22000,0,0,0,0,0,18),(264,1021000,1402000,12000,0,0,0,0,0,16),(265,1021000,1402001,3000,0,0,0,0,0,17),(266,1021000,1322014,40000,0,0,0,0,0,12),(267,1021000,1322004,22000,0,0,0,0,0,11),(268,1021000,1322002,10000,0,0,0,0,0,10),(269,1021000,1322000,6000,0,0,0,0,0,9),(270,1021000,1312005,40000,0,0,0,0,0,8),(271,1021000,1312003,20000,0,0,0,0,0,7),(272,1021000,1312001,6000,0,0,0,0,0,6),(273,1021000,1332010,22000,0,0,0,0,0,15),(274,1021000,1332008,10000,0,0,0,0,0,14),(275,1021000,1332006,7000,0,0,0,0,0,13),(276,1021000,1302008,40000,0,0,0,0,0,5),(277,1021000,1302003,20000,0,0,0,0,0,1),(278,1021000,1302006,10000,0,0,0,0,0,3),(279,1021000,1302002,10000,0,0,0,0,0,0),(280,1021000,1302005,6000,0,0,0,0,0,2),(281,1021000,1302007,3000,0,0,0,0,0,4),(282,1021001,1092000,6000,0,0,0,0,0,62),(283,1021001,1092005,4000,0,0,0,0,0,63),(284,1021001,1072011,15000,0,0,0,0,0,58),(285,1021001,1072047,10000,0,0,0,0,0,60),(286,1021001,1072046,10000,0,0,0,0,0,59),(287,1021001,1072007,10000,0,0,0,0,0,56),(288,1021001,1072050,5000,0,0,0,0,0,61),(289,1021001,1072009,5000,0,0,0,0,0,57),(290,1021001,1061020,14000,0,0,0,0,0,54),(291,1021001,1061019,14000,0,0,0,0,0,53),(292,1021001,1061015,14000,0,0,0,0,0,49),(293,1021001,1061018,9000,0,0,0,0,0,52),(294,1021001,1061017,9000,0,0,0,0,0,51),(295,1021001,1061016,9000,0,0,0,0,0,50),(296,1021001,1061023,3000,0,0,0,0,0,55),(297,1021001,1061014,3000,0,0,0,0,0,48),(298,1021001,1060019,38000,0,0,0,0,0,42),(299,1021001,1060018,38000,0,0,0,0,0,41),(300,1021001,1060017,38000,0,0,0,0,0,40),(301,1021001,1060016,38000,0,0,0,0,0,39),(302,1021001,1060060,14000,0,0,0,0,0,47),(303,1021001,1060030,14000,0,0,0,0,0,46),(304,1021001,1060011,14000,0,0,0,0,0,38),(305,1021001,1060029,9000,0,0,0,0,0,45),(306,1021001,1060010,9000,0,0,0,0,0,37),(307,1021001,1060027,5000,0,0,0,0,0,43),(308,1021001,1060009,5000,0,0,0,0,0,36),(309,1021001,1060028,3000,0,0,0,0,0,44),(310,1021001,1060008,3000,0,0,0,0,0,35),(311,1021001,1051013,60000,0,0,0,0,0,34),(312,1021001,1051012,60000,0,0,0,0,0,33),(313,1021001,1051011,60000,0,0,0,0,0,32),(314,1021001,1051010,60000,0,0,0,0,0,31),(315,1021001,1051000,8000,0,0,0,0,0,30),(316,1021001,1050011,70000,0,0,0,0,0,29),(317,1021001,1050007,15000,0,0,0,0,0,28),(318,1021001,1050006,15000,0,0,0,0,0,27),(319,1021001,1050005,15000,0,0,0,0,0,26),(320,1021001,1041024,16000,0,0,0,0,0,24),(321,1021001,1041023,16000,0,0,0,0,0,23),(322,1021001,1041022,16000,0,0,0,0,0,22),(323,1021001,1041021,9000,0,0,0,0,0,21),(324,1021001,1041020,9000,0,0,0,0,0,20),(325,1021001,1041019,9000,0,0,0,0,0,19),(326,1021001,1041064,3200,0,0,0,0,0,25),(327,1021001,1041014,3200,0,0,0,0,0,18),(328,1021001,1040026,40000,0,0,0,0,0,12),(329,1021001,1040021,40000,0,0,0,0,0,11),(330,1021001,1040041,16000,0,0,0,0,0,17),(331,1021001,1040016,16000,0,0,0,0,0,10),(332,1021001,1040040,16000,0,0,0,0,0,16),(333,1021001,1040039,9000,0,0,0,0,0,15),(334,1021001,1040012,9000,0,0,0,0,0,8),(335,1021001,1040037,5500,0,0,0,0,0,13),(336,1021001,1040009,5500,0,0,0,0,0,7),(337,1021001,1040038,3200,0,0,0,0,0,14),(338,1021001,1040015,3200,0,0,0,0,0,9),(339,1021001,1002005,19000,0,0,0,0,0,0),(340,1021001,1002027,11500,0,0,0,0,0,1),(341,1021001,1002059,8500,0,0,0,0,0,6),(342,1021001,1002055,8700,0,0,0,0,0,5),(343,1021001,1002051,3500,0,0,0,0,0,4),(344,1021001,1002039,2700,0,0,0,0,0,2),(345,1021001,1002043,2400,0,0,0,0,0,3),(346,1021100,2330000,600,0,0,0,0,0,23),(347,1021100,2070000,500,0,0,0,0,0,22),(348,1021100,2050002,300,0,0,0,0,0,19),(349,1021100,2050001,200,0,0,0,0,0,18),(350,1021100,2050000,200,0,0,0,0,0,17),(353,1021100,2061000,1,0,0,0,0,0,21),(354,1021100,2060000,1,0,0,0,0,0,20),(355,1021100,2030003,500,0,0,0,0,0,16),(356,1021100,2030000,400,0,0,0,0,0,15),(357,1021100,2010004,310,0,0,0,0,0,14),(358,1021100,2010003,100,0,0,0,0,0,13),(359,1021100,2010001,106,0,0,0,0,0,11),(360,1021100,2010002,50,0,0,0,0,0,12),(361,1021100,2010000,30,0,0,0,0,0,10),(362,1021100,2002005,500,0,0,0,0,0,9),(363,1021100,2002004,500,0,0,0,0,0,8),(364,1021100,2002002,500,0,0,0,0,0,7),(365,1021100,2002001,400,0,0,0,0,0,6),(366,1021100,2002000,500,0,0,0,0,0,5),(367,1021100,2000006,620,0,0,0,0,0,4),(368,1021100,2000003,200,0,0,0,0,0,3),(369,1021100,2000002,320,0,0,0,0,0,2),(370,1021100,2000001,160,0,0,0,0,0,1),(371,1021100,2000000,50,0,0,0,0,0,0),(372,1031000,1322002,10000,0,0,0,0,0,0),(373,1031000,1382002,20000,0,0,0,0,0,7),(374,1031000,1382004,10000,0,0,0,0,0,9),(375,1031000,1382005,6000,0,0,0,0,0,10),(376,1031000,1382003,6000,0,0,0,0,0,8),(377,1031000,1382000,3000,0,0,0,0,0,6),(378,1031000,1372003,38000,0,0,0,0,0,2),(379,1031000,1372004,18000,0,0,0,0,0,3),(380,1031000,1372002,9000,0,0,0,0,0,1),(381,1031000,1372006,5000,0,0,0,0,0,5),(382,1031000,1372005,2000,0,0,0,0,0,4),(383,1031001,1072024,4000,0,0,0,0,0,55),(384,1031001,1072023,4000,0,0,0,0,0,54),(385,1031001,1072045,1500,0,0,0,0,0,57),(386,1031001,1072044,1500,0,0,0,0,0,56),(387,1031001,1072006,1500,0,0,0,0,0,53),(388,1031001,1061036,40000,0,0,0,0,0,52),(389,1031001,1061035,40000,0,0,0,0,0,51),(390,1031001,1061034,40000,0,0,0,0,0,50),(391,1031001,1061028,8000,0,0,0,0,0,49),(392,1031001,1061027,8000,0,0,0,0,0,48),(393,1031001,1061022,4000,0,0,0,0,0,47),(394,1031001,1061021,4000,0,0,0,0,0,46),(395,1031001,1061013,4000,0,0,0,0,0,45),(396,1031001,1061012,4000,0,0,0,0,0,44),(397,1031001,1061011,2000,0,0,0,0,0,43),(398,1031001,1061010,2000,0,0,0,0,0,42),(399,1031001,1060015,8000,0,0,0,0,0,41),(400,1031001,1060014,8000,0,0,0,0,0,40),(401,1031001,1060013,2000,0,0,0,0,0,39),(402,1031001,1060012,2000,0,0,0,0,0,38),(403,1031001,1051003,16000,0,0,0,0,0,35),(404,1031001,1051005,16000,0,0,0,0,0,37),(405,1031001,1051004,16000,0,0,0,0,0,36),(406,1031001,1050028,40000,0,0,0,0,0,34),(407,1031001,1050027,40000,0,0,0,0,0,33),(408,1031001,1050026,40000,0,0,0,0,0,32),(409,1031001,1050003,40000,0,0,0,0,0,25),(410,1031001,1050025,16000,0,0,0,0,0,31),(411,1031001,1050024,16000,0,0,0,0,0,30),(412,1031001,1050023,16000,0,0,0,0,0,29),(413,1031001,1050001,16000,0,0,0,0,0,24),(414,1031001,1050010,7000,0,0,0,0,0,28),(415,1031001,1050009,7000,0,0,0,0,0,27),(416,1031001,1050008,7000,0,0,0,0,0,26),(417,1031001,1041043,42000,0,0,0,0,0,23),(418,1031001,1041042,42000,0,0,0,0,0,22),(419,1031001,1041041,42000,0,0,0,0,0,21),(420,1031001,1041031,8500,0,0,0,0,0,20),(421,1031001,1041030,8500,0,0,0,0,0,19),(422,1031001,1041029,8500,0,0,0,0,0,18),(423,1031001,1041026,4000,0,0,0,0,0,17),(424,1031001,1041025,4000,0,0,0,0,0,16),(425,1031001,1041018,4000,0,0,0,0,0,15),(426,1031001,1041017,4000,0,0,0,0,0,14),(427,1031001,1041016,2000,0,0,0,0,0,13),(428,1031001,1041015,2000,0,0,0,0,0,12),(429,1031001,1040020,8500,0,0,0,0,0,11),(430,1031001,1040019,8500,0,0,0,0,0,10),(431,1031001,1040018,8500,0,0,0,0,0,9),(432,1031001,1040017,2000,0,0,0,0,0,8),(433,1031001,1040004,2000,0,0,0,0,0,7),(434,1031001,1002016,8000,0,0,0,0,0,0),(435,1031001,1002106,3800,0,0,0,0,0,6),(436,1031001,1002105,3800,0,0,0,0,0,5),(437,1031001,1002104,3800,0,0,0,0,0,4),(438,1031001,1002103,3800,0,0,0,0,0,3),(439,1031001,1002102,3800,0,0,0,0,0,2),(440,1031001,1002017,1200,0,0,0,0,0,1),(441,1031100,2330000,600,0,0,0,0,0,24),(442,1031100,2070000,500,0,0,0,0,0,23),(443,1031100,2050003,500,0,0,0,0,0,20),(444,1031100,2050002,300,0,0,0,0,0,19),(445,1031100,2050001,200,0,0,0,0,0,18),(446,1031100,2050000,200,0,0,0,0,0,17),(449,1031100,2061000,1,0,0,0,0,0,22),(450,1031100,2060000,1,0,0,0,0,0,21),(451,1031100,2030002,500,0,0,0,0,0,16),(452,1031100,2030000,400,0,0,0,0,0,15),(453,1031100,2010004,305,0,0,0,0,0,14),(454,1031100,2010003,97,0,0,0,0,0,13),(455,1031100,2010001,106,0,0,0,0,0,11),(456,1031100,2010002,50,0,0,0,0,0,12),(457,1031100,2010000,30,0,0,0,0,0,10),(458,1031100,2002005,500,0,0,0,0,0,9),(459,1031100,2002004,500,0,0,0,0,0,8),(460,1031100,2002002,500,0,0,0,0,0,7),(461,1031100,2002001,400,0,0,0,0,0,6),(462,1031100,2002000,500,0,0,0,0,0,5),(463,1031100,2000006,604,0,0,0,0,0,4),(464,1031100,2000003,192,0,0,0,0,0,3),(465,1031100,2000002,320,0,0,0,0,0,2),(466,1031100,2000001,160,0,0,0,0,0,1),(467,1031100,2000000,50,0,0,0,0,0,0),(468,1032103,2044900,70000,0,0,0,0,0,10),(469,1032103,2044800,70000,0,0,0,0,0,9),(470,1032103,2043800,70000,0,0,0,0,0,6),(471,1032103,2043700,70000,0,0,0,0,0,5),(472,1032103,2044600,70000,0,0,0,0,0,8),(473,1032103,2044500,70000,0,0,0,0,0,7),(474,1032103,2040300,35000,0,0,0,0,0,1),(475,1032103,2040700,35000,0,0,0,0,0,4),(476,1032103,2040600,35000,0,0,0,0,0,3),(477,1032103,2040400,35000,0,0,0,0,0,2),(478,1032103,2040000,35000,0,0,0,0,0,0),(479,1051000,1472000,3000,0,0,0,0,0,17),(480,1051000,1442000,3000,0,0,0,0,0,16),(481,1051000,1432001,7000,0,0,0,0,0,15),(482,1051000,1432000,3000,0,0,0,0,0,14),(483,1051000,1422000,3000,0,0,0,0,0,13),(484,1051000,1412001,3000,0,0,0,0,0,12),(485,1051000,1402001,3000,0,0,0,0,0,11),(486,1051000,1322009,20000,0,0,0,0,0,1),(487,1051000,1332009,42000,0,0,0,0,0,7),(488,1051000,1332012,40000,0,0,0,0,0,9),(489,1051000,1332004,38000,0,0,0,0,0,4),(490,1051000,1332010,22000,0,0,0,0,0,8),(491,1051000,1332013,15000,0,0,0,0,0,10),(492,1051000,1332008,10000,0,0,0,0,0,6),(493,1051000,1332002,8000,0,0,0,0,0,3),(494,1051000,1332006,7000,0,0,0,0,0,5),(495,1051000,1332000,4000,0,0,0,0,0,2),(496,1051000,1302007,3000,0,0,0,0,0,0),(497,1051001,1072066,9000,0,0,0,0,0,103),(498,1051001,1072065,9000,0,0,0,0,0,102),(499,1051001,1072022,9000,0,0,0,0,0,95),(500,1051001,1072031,4500,0,0,0,0,0,99),(501,1051001,1072030,4500,0,0,0,0,0,98),(502,1051001,1072029,4500,0,0,0,0,0,97),(503,1051001,1072028,4500,0,0,0,0,0,96),(504,1051001,1072043,2000,0,0,0,0,0,101),(505,1051001,1072042,2000,0,0,0,0,0,100),(506,1051001,1072004,2000,0,0,0,0,0,94),(507,1051001,1072071,1800,0,0,0,0,0,105),(508,1051001,1072070,1800,0,0,0,0,0,104),(509,1051001,1061046,40000,0,0,0,0,0,89),(510,1051001,1061045,40000,0,0,0,0,0,88),(511,1051001,1061044,40000,0,0,0,0,0,87),(512,1051001,1061043,40000,0,0,0,0,0,86),(513,1051001,1061056,18000,0,0,0,0,0,93),(514,1051001,1061055,18000,0,0,0,0,0,92),(515,1051001,1061054,18000,0,0,0,0,0,91),(516,1051001,1061053,18000,0,0,0,0,0,90),(517,1051001,1061042,12000,0,0,0,0,0,85),(518,1051001,1061041,12000,0,0,0,0,0,84),(519,1051001,1061040,12000,0,0,0,0,0,83),(520,1051001,1061033,8000,0,0,0,0,0,80),(521,1051001,1061032,8000,0,0,0,0,0,79),(522,1051001,1061003,8000,0,0,0,0,0,75),(523,1051001,1061038,4800,0,0,0,0,0,82),(524,1051001,1061037,4800,0,0,0,0,0,81),(525,1051001,1061031,2800,0,0,0,0,0,78),(526,1051001,1061030,2800,0,0,0,0,0,77),(527,1051001,1061029,2800,0,0,0,0,0,76),(528,1051001,1060046,40000,0,0,0,0,0,74),(529,1051001,1060045,40000,0,0,0,0,0,73),(530,1051001,1060044,40000,0,0,0,0,0,72),(531,1051001,1060043,40000,0,0,0,0,0,71),(532,1051001,1060039,19000,0,0,0,0,0,70),(533,1051001,1060038,19000,0,0,0,0,0,69),(534,1051001,1060037,19000,0,0,0,0,0,68),(535,1051001,1060033,8000,0,0,0,0,0,67),(536,1051001,1060032,8000,0,0,0,0,0,66),(537,1051001,1060031,8000,0,0,0,0,0,65),(538,1051001,1060025,4800,0,0,0,0,0,64),(539,1051001,1060024,4800,0,0,0,0,0,63),(540,1051001,1060023,2800,0,0,0,0,0,62),(541,1051001,1060022,2800,0,0,0,0,0,61),(542,1051001,1060021,2800,0,0,0,0,0,60),(543,1051001,1041050,45000,0,0,0,0,0,55),(544,1051001,1041049,45000,0,0,0,0,0,54),(545,1051001,1041048,45000,0,0,0,0,0,53),(546,1051001,1041047,45000,0,0,0,0,0,52),(547,1051001,1041060,18000,0,0,0,0,0,59),(548,1051001,1041059,18000,0,0,0,0,0,58),(549,1051001,1041058,18000,0,0,0,0,0,57),(550,1051001,1041057,18000,0,0,0,0,0,56),(551,1051001,1041040,9000,0,0,0,0,0,49),(552,1051001,1041039,9000,0,0,0,0,0,48),(553,1051001,1041003,9000,0,0,0,0,0,44),(554,1051001,1041045,5000,0,0,0,0,0,51),(555,1051001,1041044,5000,0,0,0,0,0,50),(556,1051001,1041038,3000,0,0,0,0,0,47),(557,1051001,1041037,3000,0,0,0,0,0,46),(558,1051001,1041036,3000,0,0,0,0,0,45),(559,1051001,1040060,45000,0,0,0,0,0,43),(560,1051001,1040059,45000,0,0,0,0,0,42),(561,1051001,1040058,45000,0,0,0,0,0,41),(562,1051001,1040057,45000,0,0,0,0,0,40),(563,1051001,1040050,16000,0,0,0,0,0,39),(564,1051001,1040049,16000,0,0,0,0,0,38),(565,1051001,1040048,16000,0,0,0,0,0,37),(566,1051001,1040044,9000,0,0,0,0,0,36),(567,1051001,1040043,9000,0,0,0,0,0,35),(568,1051001,1040042,9000,0,0,0,0,0,34),(569,1051001,1040035,5000,0,0,0,0,0,33),(570,1051001,1040034,5000,0,0,0,0,0,32),(571,1051001,1040033,3000,0,0,0,0,0,31),(572,1051001,1040032,3000,0,0,0,0,0,30),(573,1051001,1040031,3000,0,0,0,0,0,29),(574,1051001,1002175,30000,0,0,0,0,0,28),(575,1051001,1002174,30000,0,0,0,0,0,27),(576,1051001,1002173,30000,0,0,0,0,0,26),(577,1051001,1002172,30000,0,0,0,0,0,25),(578,1051001,1002171,30000,0,0,0,0,0,24),(579,1051001,1002150,20000,0,0,0,0,0,23),(580,1051001,1002149,20000,0,0,0,0,0,22),(581,1051001,1002148,20000,0,0,0,0,0,21),(582,1051001,1002147,20000,0,0,0,0,0,20),(583,1051001,1002146,20000,0,0,0,0,0,19),(584,1051001,1002097,7400,0,0,0,0,0,3),(585,1051001,1002096,7400,0,0,0,0,0,2),(586,1051001,1002020,7400,0,0,0,0,0,1),(587,1051001,1002131,12000,0,0,0,0,0,18),(588,1051001,1002130,12000,0,0,0,0,0,17),(589,1051001,1002129,12000,0,0,0,0,0,16),(590,1051001,1002128,12000,0,0,0,0,0,15),(591,1051001,1002127,12000,0,0,0,0,0,14),(592,1051001,1002111,4000,0,0,0,0,0,8),(593,1051001,1002110,4000,0,0,0,0,0,7),(594,1051001,1002109,4000,0,0,0,0,0,6),(595,1051001,1002108,4000,0,0,0,0,0,5),(596,1051001,1002107,4000,0,0,0,0,0,4),(597,1051001,1002001,3000,0,0,0,0,0,0),(598,1051001,1002126,900,0,0,0,0,0,13),(599,1051001,1002125,900,0,0,0,0,0,12),(600,1051001,1002124,900,0,0,0,0,0,11),(601,1051001,1002123,900,0,0,0,0,0,10),(602,1051001,1002122,900,0,0,0,0,0,9),(603,1051002,2330000,600,0,0,0,0,0,23),(604,1051002,2070000,500,0,0,0,0,0,22),(605,1051002,2050002,300,0,0,0,0,0,19),(606,1051002,2050001,200,0,0,0,0,0,18),(607,1051002,2050000,200,0,0,0,0,0,17),(610,1051002,2061000,1,0,0,0,0,0,21),(611,1051002,2060000,1,0,0,0,0,0,20),(612,1051002,2030005,500,0,0,0,0,0,16),(613,1051002,2030000,400,0,0,0,0,0,15),(614,1051002,2010004,310,0,0,0,0,0,14),(615,1051002,2010003,100,0,0,0,0,0,13),(616,1051002,2010001,106,0,0,0,0,0,11),(617,1051002,2010002,50,0,0,0,0,0,12),(618,1051002,2010000,30,0,0,0,0,0,10),(619,1051002,2002005,500,0,0,0,0,0,9),(620,1051002,2002004,500,0,0,0,0,0,8),(621,1051002,2002002,500,0,0,0,0,0,7),(622,1051002,2002001,400,0,0,0,0,0,6),(623,1051002,2002000,500,0,0,0,0,0,5),(624,1051002,2000006,620,0,0,0,0,0,4),(625,1051002,2000003,200,0,0,0,0,0,3),(626,1051002,2000002,320,0,0,0,0,0,2),(627,1051002,2000001,160,0,0,0,0,0,1),(628,1051002,2000000,50,0,0,0,0,0,0),(629,1052104,2044700,70000,0,0,0,0,0,15),(630,1052104,2043300,70000,0,0,0,0,0,9),(631,1052104,2044400,70000,0,0,0,0,0,14),(632,1052104,2044300,70000,0,0,0,0,0,13),(633,1052104,2044200,70000,0,0,0,0,0,12),(634,1052104,2044100,70000,0,0,0,0,0,11),(635,1052104,2044000,70000,0,0,0,0,0,10),(636,1052104,2043200,70000,0,0,0,0,0,8),(637,1052104,2043100,70000,0,0,0,0,0,7),(638,1052104,2043000,70000,0,0,0,0,0,6),(639,1052104,2040703,35000,0,0,0,0,0,5),(640,1052104,2040700,35000,0,0,0,0,0,4),(641,1052104,2040600,35000,0,0,0,0,0,3),(642,1052104,2040500,35000,0,0,0,0,0,2),(643,1052104,2040003,35000,0,0,0,0,0,1),(644,1052104,2040000,35000,0,0,0,0,0,0),(645,1061001,2330000,600,0,0,0,0,0,15),(646,1061001,2070000,500,0,0,0,0,0,14),(647,1061001,2061000,2800,0,0,0,0,0,12),(648,1061001,2060000,2800,0,0,0,0,0,10),(649,1061001,2061000,2,0,0,0,0,0,13),(650,1061001,2060000,2,0,0,0,0,0,11),(651,1061001,2030000,400,0,0,0,0,0,9),(652,1061001,2020002,320,0,0,0,0,0,2),(653,1061001,2022000,1650,0,0,0,0,0,7),(654,1061001,2020000,420,0,0,0,0,0,0),(655,1061001,2022003,1100,0,0,0,0,0,8),(656,1061001,2020006,530,0,0,0,0,0,6),(657,1061001,2020004,450,0,0,0,0,0,4),(658,1061001,2020003,450,0,0,0,0,0,3),(659,1061001,2020005,320,0,0,0,0,0,5),(660,1061001,2020001,220,0,0,0,0,0,1),(661,1061002,2330000,600,0,0,0,0,0,17),(662,1061002,2070000,500,0,0,0,0,0,16),(665,1061002,2061000,1,0,0,0,0,0,15),(666,1061002,2060000,1,0,0,0,0,0,14),(667,1061002,2030006,600,0,0,0,0,0,13),(668,1061002,2030000,400,0,0,0,0,0,12),(669,1061002,2022003,1100,0,0,0,0,0,11),(670,1061002,2022000,1650,0,0,0,0,0,10),(671,1061002,2010004,310,0,0,0,0,0,9),(672,1061002,2010003,100,0,0,0,0,0,8),(673,1061002,2010001,106,0,0,0,0,0,6),(674,1061002,2010002,50,0,0,0,0,0,7),(675,1061002,2010000,30,0,0,0,0,0,5),(676,1061002,2000006,620,0,0,0,0,0,4),(677,1061002,2000003,200,0,0,0,0,0,3),(678,1061002,2000002,320,0,0,0,0,0,2),(679,1061002,2000001,160,0,0,0,0,0,1),(680,1061002,2000000,50,0,0,0,0,0,0),(681,1081000,2330000,600,0,0,0,0,0,22),(682,1081000,2070000,500,0,0,0,0,0,21),(683,1081000,2001002,4000,0,0,0,0,0,6),(684,1081000,2001001,2300,0,0,0,0,0,5),(685,1081000,2001000,3200,0,0,0,0,0,4),(686,1081000,2020002,320,0,0,0,0,0,14),(687,1081000,2022000,1650,0,0,0,0,0,19),(688,1081000,2020000,420,0,0,0,0,0,12),(689,1081000,2022003,1100,0,0,0,0,0,20),(690,1081000,2020006,530,0,0,0,0,0,18),(691,1081000,2020004,450,0,0,0,0,0,16),(692,1081000,2020003,450,0,0,0,0,0,15),(693,1081000,2020005,320,0,0,0,0,0,17),(694,1081000,2020001,220,0,0,0,0,0,13),(695,1081000,2010004,310,0,0,0,0,0,11),(696,1081000,2010003,100,0,0,0,0,0,10),(697,1081000,2010001,106,0,0,0,0,0,8),(698,1081000,2010002,50,0,0,0,0,0,9),(699,1081000,2010000,30,0,0,0,0,0,7),(700,1081000,2000003,200,0,0,0,0,0,3),(701,1081000,2000002,320,0,0,0,0,0,2),(702,1081000,2000001,160,0,0,0,0,0,1),(703,1081000,2000000,50,0,0,0,0,0,0),(704,1091000,1322007,6000,0,0,0,0,0,1),(705,1091000,1302007,3000,0,0,0,0,0,0),(706,1091000,1442004,24000,0,0,0,0,0,2),(707,1091000,1482004,52000,0,0,0,0,0,7),(708,1091000,1482003,20000,0,0,0,0,0,6),(709,1091000,1482002,10000,0,0,0,0,0,5),(710,1091000,1482001,6000,0,0,0,0,0,4),(711,1091000,1482000,3000,0,0,0,0,0,3),(712,1091000,1492004,50000,0,0,0,0,0,12),(713,1091000,1492003,22000,0,0,0,0,0,11),(714,1091000,1492002,10000,0,0,0,0,0,10),(715,1091000,1492001,6000,0,0,0,0,0,9),(716,1091000,1492000,3000,0,0,0,0,0,8),(717,1091001,1072288,8000,0,0,0,0,0,10),(718,1091001,1072285,5000,0,0,0,0,0,9),(719,1091001,1052107,60000,0,0,0,0,0,8),(720,1091001,1052104,30000,0,0,0,0,0,7),(721,1091001,1052101,16000,0,0,0,0,0,6),(722,1091001,1052098,8000,0,0,0,0,0,5),(723,1091001,1052095,4000,0,0,0,0,0,4),(724,1091001,1002619,20000,0,0,0,0,0,3),(725,1091001,1002616,12000,0,0,0,0,0,2),(726,1091001,1002613,4000,0,0,0,0,0,1),(727,1091001,1002610,900,0,0,0,0,0,0),(728,1091002,2330000,600,0,0,0,0,0,21),(729,1091002,2070000,500,0,0,0,0,0,20),(732,1091002,2061000,1,0,0,0,0,0,19),(733,1091002,2060000,1,0,0,0,0,0,18),(734,1091002,2030019,500,0,0,0,0,0,17),(735,1091002,2030000,400,0,0,0,0,0,16),(736,1091002,2020028,3000,0,0,0,0,0,15),(737,1091002,2010004,310,0,0,0,0,0,14),(738,1091002,2010003,100,0,0,0,0,0,13),(739,1091002,2010001,106,0,0,0,0,0,11),(740,1091002,2010002,50,0,0,0,0,0,12),(741,1091002,2010000,30,0,0,0,0,0,10),(742,1091002,2002005,500,0,0,0,0,0,9),(743,1091002,2002004,500,0,0,0,0,0,8),(744,1091002,2002002,500,0,0,0,0,0,7),(745,1091002,2002001,400,0,0,0,0,0,6),(746,1091002,2002000,500,0,0,0,0,0,5),(747,1091002,2000006,620,0,0,0,0,0,4),(748,1091002,2000003,200,0,0,0,0,0,3),(749,1091002,2000002,320,0,0,0,0,0,2),(750,1091002,2000001,160,0,0,0,0,0,1),(751,1091002,2000000,50,0,0,0,0,0,0),(752,1093000,2022258,105,0,0,0,0,0,0),(753,1100001,1072005,50,0,0,0,0,0,12),(754,1100001,1072001,50,0,0,0,0,0,11),(755,1100001,1061008,50,0,0,0,0,0,10),(756,1100001,1061002,50,0,0,0,0,0,9),(757,1100001,1060006,50,0,0,0,0,0,8),(758,1100001,1060002,50,0,0,0,0,0,7),(759,1100001,1041011,50,0,0,0,0,0,6),(760,1100001,1041010,50,0,0,0,0,0,5),(761,1100001,1041006,50,0,0,0,0,0,4),(762,1100001,1041002,50,0,0,0,0,0,3),(763,1100001,1040010,50,0,0,0,0,0,2),(764,1100001,1040006,50,0,0,0,0,0,1),(765,1100001,1040002,50,0,0,0,0,0,0),(766,1100001,1332005,500,0,0,0,0,0,16),(767,1100001,1322005,50,0,0,0,0,0,15),(768,1100001,1312004,50,0,0,0,0,0,14),(769,1100001,1302000,50,0,0,0,0,0,13),(770,1100002,2330000,600,0,0,0,0,0,23),(771,1100002,2070000,500,0,0,0,0,0,21),(772,1100002,2050002,300,0,0,0,0,0,18),(773,1100002,2050001,200,0,0,0,0,0,17),(774,1100002,2050000,200,0,0,0,0,0,16),(777,1100002,2061000,1,0,0,0,0,0,20),(778,1100002,2060000,1,0,0,0,0,0,19),(779,1100002,2030000,400,0,0,0,0,0,15),(780,1100002,2120008,200,0,0,0,0,0,22),(781,1100002,2010004,310,0,0,0,0,0,14),(782,1100002,2010003,100,0,0,0,0,0,13),(783,1100002,2010001,106,0,0,0,0,0,11),(784,1100002,2010002,50,0,0,0,0,0,12),(785,1100002,2010000,30,0,0,0,0,0,10),(786,1100002,2002005,500,0,0,0,0,0,9),(787,1100002,2002004,500,0,0,0,0,0,8),(788,1100002,2002002,500,0,0,0,0,0,7),(789,1100002,2002001,400,0,0,0,0,0,6),(790,1100002,2002000,500,0,0,0,0,0,5),(791,1100002,2000006,620,0,0,0,0,0,4),(792,1100002,2000003,200,0,0,0,0,0,3),(793,1100002,2000002,320,0,0,0,0,0,2),(794,1100002,2000001,160,0,0,0,0,0,1),(795,1100002,2000000,50,0,0,0,0,0,0),(796,2010004,4160019,1000,0,0,0,0,0,19),(797,2010004,4160039,1000,0,0,0,0,0,30),(798,2010004,4160037,1000,0,0,0,0,0,29),(799,2010004,4031993,100000,0,0,0,0,0,2),(800,2010004,4160036,1000,0,0,0,0,0,28),(801,2010004,4160035,1000,0,0,0,0,0,27),(802,2010004,4160034,1000,0,0,0,0,0,26),(803,2010004,4160032,1000,0,0,0,0,0,25),(804,2010004,4160024,1000,0,0,0,0,0,23),(805,2010004,4160023,1000,0,0,0,0,0,22),(806,2010004,4160022,1000,0,0,0,0,0,21),(807,2010004,4160015,1000,0,0,0,0,0,17),(808,2010004,4160012,1000,0,0,0,0,0,14),(809,2010004,4160013,1000,0,0,0,0,0,15),(810,2010004,4160017,1000,0,0,0,0,0,18),(811,2010004,4160014,1000,0,0,0,0,0,16),(812,2010004,4160020,1000,0,0,0,0,0,20),(813,2010004,4160010,1000,0,0,0,0,0,13),(814,2010004,4160009,1000,0,0,0,0,0,12),(815,2010004,4160008,1000,0,0,0,0,0,11),(816,2010004,4160007,1000,0,0,0,0,0,10),(817,2010004,4160006,1000,0,0,0,0,0,9),(818,2010004,4160005,1000,0,0,0,0,0,8),(819,2010004,4160004,1000,0,0,0,0,0,7),(820,2010004,4160003,1000,0,0,0,0,0,6),(821,2010004,4160002,1000,0,0,0,0,0,5),(822,2010004,4160001,1000,0,0,0,0,0,4),(823,2010004,4160000,1000,0,0,0,0,0,3),(824,2010004,4160026,1000,0,0,0,0,0,24),(825,2010004,2260000,1000,0,0,0,0,0,1),(826,2010004,2120000,30,0,0,0,0,0,0),(827,2012003,1492004,75000,0,0,0,0,0,16),(828,2012003,1482004,75000,0,0,0,0,0,15),(829,2012003,1472001,20000,0,0,0,0,0,14),(830,2012003,1462000,30000,0,0,0,0,0,13),(831,2012003,1452005,150000,0,0,0,0,0,12),(832,2012003,1442001,60000,0,0,0,0,0,11),(833,2012003,1432002,60000,0,0,0,0,0,10),(834,2012003,1422001,45000,0,0,0,0,0,9),(835,2012003,1412006,45000,0,0,0,0,0,8),(836,2012003,1402002,150000,0,0,0,0,0,7),(837,2012003,1382002,20000,0,0,0,0,0,6),(838,2012003,1372003,38000,0,0,0,0,0,5),(839,2012003,1332012,40000,0,0,0,0,0,4),(840,2012003,1332009,42000,0,0,0,0,0,3),(841,2012003,1322014,40000,0,0,0,0,0,2),(842,2012003,1312005,40000,0,0,0,0,0,1),(843,2012003,1302008,40000,0,0,0,0,0,0),(844,2012004,1052107,90000,0,0,0,0,0,41),(845,2012004,1002622,40000,0,0,0,0,0,12),(846,2012004,1061046,40000,0,0,0,0,0,60),(847,2012004,1061045,40000,0,0,0,0,0,59),(848,2012004,1061044,40000,0,0,0,0,0,58),(849,2012004,1061043,40000,0,0,0,0,0,57),(850,2012004,1060046,40000,0,0,0,0,0,49),(851,2012004,1060045,40000,0,0,0,0,0,48),(852,2012004,1060044,40000,0,0,0,0,0,47),(853,2012004,1060043,40000,0,0,0,0,0,46),(854,2012004,1041050,45000,0,0,0,0,0,29),(855,2012004,1041049,45000,0,0,0,0,0,28),(856,2012004,1041048,45000,0,0,0,0,0,27),(857,2012004,1041047,45000,0,0,0,0,0,26),(858,2012004,1040060,45000,0,0,0,0,0,18),(859,2012004,1040059,45000,0,0,0,0,0,17),(860,2012004,1040058,45000,0,0,0,0,0,16),(861,2012004,1040057,45000,0,0,0,0,0,15),(862,2012004,1002175,30000,0,0,0,0,0,11),(863,2012004,1002174,30000,0,0,0,0,0,10),(864,2012004,1002173,30000,0,0,0,0,0,9),(865,2012004,1002172,30000,0,0,0,0,0,8),(866,2012004,1002171,30000,0,0,0,0,0,7),(867,2012004,1061051,44000,0,0,0,0,0,62),(868,2012004,1061050,44000,0,0,0,0,0,61),(869,2012004,1061052,44000,0,0,0,0,0,63),(870,2012004,1060057,44000,0,0,0,0,0,51),(871,2012004,1060056,44000,0,0,0,0,0,50),(872,2012004,1060058,44000,0,0,0,0,0,52),(873,2012004,1060059,44000,0,0,0,0,0,53),(874,2012004,1041055,50000,0,0,0,0,0,31),(875,2012004,1041054,50000,0,0,0,0,0,30),(876,2012004,1041056,50000,0,0,0,0,0,32),(877,2012004,1040068,50000,0,0,0,0,0,20),(878,2012004,1040067,50000,0,0,0,0,0,19),(879,2012004,1040070,50000,0,0,0,0,0,22),(880,2012004,1040069,50000,0,0,0,0,0,21),(881,2012004,1002165,30000,0,0,0,0,0,6),(882,2012004,1002164,30000,0,0,0,0,0,5),(883,2012004,1002163,30000,0,0,0,0,0,4),(884,2012004,1002162,30000,0,0,0,0,0,3),(885,2012004,1002161,30000,0,0,0,0,0,2),(886,2012004,1061036,40000,0,0,0,0,0,56),(887,2012004,1061035,40000,0,0,0,0,0,55),(888,2012004,1061034,40000,0,0,0,0,0,54),(889,2012004,1050028,40000,0,0,0,0,0,36),(890,2012004,1050027,40000,0,0,0,0,0,35),(891,2012004,1050026,40000,0,0,0,0,0,34),(892,2012004,1050003,40000,0,0,0,0,0,33),(893,2012004,1041043,42000,0,0,0,0,0,25),(894,2012004,1041042,42000,0,0,0,0,0,24),(895,2012004,1041041,42000,0,0,0,0,0,23),(896,2012004,1002064,40000,0,0,0,0,0,1),(897,2012004,1092006,60000,0,0,0,0,0,64),(898,2012004,1060019,38000,0,0,0,0,0,45),(899,2012004,1060018,38000,0,0,0,0,0,44),(900,2012004,1060017,38000,0,0,0,0,0,43),(901,2012004,1060016,38000,0,0,0,0,0,42),(902,2012004,1051013,60000,0,0,0,0,0,40),(903,2012004,1051012,60000,0,0,0,0,0,39),(904,2012004,1051011,60000,0,0,0,0,0,38),(905,2012004,1051010,60000,0,0,0,0,0,37),(906,2012004,1040026,40000,0,0,0,0,0,14),(907,2012004,1040021,40000,0,0,0,0,0,13),(908,2012004,1002023,120000,0,0,0,0,0,0),(909,2012005,2330000,600,0,0,0,0,0,29),(910,2012005,2070000,500,0,0,0,0,0,28),(913,2012005,2061000,1,0,0,0,0,0,27),(914,2012005,2060000,1,0,0,0,0,0,26),(915,2012005,2030000,400,0,0,0,0,0,21),(916,2012005,2050003,500,0,0,0,0,0,25),(917,2012005,2050002,300,0,0,0,0,0,24),(918,2012005,2050001,200,0,0,0,0,0,23),(919,2012005,2050000,200,0,0,0,0,0,22),(920,2012005,2020028,3000,0,0,0,0,0,18),(921,2012005,2010004,310,0,0,0,0,0,17),(922,2012005,2010003,100,0,0,0,0,0,16),(923,2012005,2010001,106,0,0,0,0,0,14),(924,2012005,2010002,50,0,0,0,0,0,15),(925,2012005,2010000,30,0,0,0,0,0,13),(926,2012005,2001002,4000,0,0,0,0,0,7),(927,2012005,2001001,2300,0,0,0,0,0,6),(928,2012005,2001000,3200,0,0,0,0,0,5),(929,2012005,2022000,1650,0,0,0,0,0,19),(930,2012005,2022003,1100,0,0,0,0,0,20),(931,2012005,2002005,500,0,0,0,0,0,12),(932,2012005,2002004,500,0,0,0,0,0,11),(933,2012005,2002002,500,0,0,0,0,0,10),(934,2012005,2002001,400,0,0,0,0,0,9),(935,2012005,2002000,500,0,0,0,0,0,8),(936,2012005,2000006,620,0,0,0,0,0,4),(937,2012005,2000003,200,0,0,0,0,0,3),(938,2012005,2000002,320,0,0,0,0,0,2),(939,2012005,2000001,160,0,0,0,0,0,1),(940,2012005,2000000,50,0,0,0,0,0,0),(941,2020001,1492006,160000,0,0,0,0,0,30),(942,2020001,1492005,100000,0,0,0,0,0,29),(943,2020001,1482006,150000,0,0,0,0,0,28),(944,2020001,1482005,100000,0,0,0,0,0,27),(945,2020001,1472007,60000,0,0,0,0,0,26),(946,2020001,1472004,30000,0,0,0,0,0,25),(947,2020001,1462005,250000,0,0,0,0,0,24),(948,2020001,1462004,200000,0,0,0,0,0,23),(949,2020001,1452007,375000,0,0,0,0,0,22),(950,2020001,1452006,250000,0,0,0,0,0,21),(951,2020001,1442009,300000,0,0,0,0,0,20),(952,2020001,1442003,175000,0,0,0,0,0,19),(953,2020001,1432005,225000,0,0,0,0,0,18),(954,2020001,1432003,175000,0,0,0,0,0,17),(955,2020001,1422007,250000,0,0,0,0,0,15),(956,2020001,1422008,200000,0,0,0,0,0,16),(957,2020001,1412005,250000,0,0,0,0,0,14),(958,2020001,1412004,200000,0,0,0,0,0,13),(959,2020001,1402007,450000,0,0,0,0,0,12),(960,2020001,1402006,350000,0,0,0,0,0,11),(961,2020001,1372000,400000,0,0,0,0,0,9),(962,2020001,1372001,175000,0,0,0,0,0,10),(963,2020001,1332011,425000,0,0,0,0,0,7),(964,2020001,1332014,375000,0,0,0,0,0,8),(965,2020001,1332001,200000,0,0,0,0,0,6),(966,2020001,1322016,175000,0,0,0,0,0,5),(967,2020001,1322015,100000,0,0,0,0,0,4),(968,2020001,1312007,175000,0,0,0,0,0,3),(969,2020001,1312006,100000,0,0,0,0,0,2),(970,2020001,1302009,225000,0,0,0,0,0,1),(971,2020001,1302004,100000,0,0,0,0,0,0),(972,2022000,1002625,75000,0,0,0,0,0,14),(973,2022000,1052113,120000,0,0,0,0,0,58),(974,2022000,1052110,100000,0,0,0,0,0,57),(975,2022000,1061069,160000,0,0,0,0,0,78),(976,2022000,1061070,160000,0,0,0,0,0,79),(977,2022000,1060072,160000,0,0,0,0,0,69),(978,2022000,1060071,160000,0,0,0,0,0,68),(979,2022000,1060052,108000,0,0,0,0,0,61),(980,2022000,1060050,108000,0,0,0,0,0,59),(981,2022000,1060051,108000,0,0,0,0,0,60),(982,2022000,1051009,111000,0,0,0,0,0,51),(983,2022000,1051008,111000,0,0,0,0,0,50),(984,2022000,1051007,111000,0,0,0,0,0,49),(985,2022000,1041074,180000,0,0,0,0,0,34),(986,2022000,1041075,180000,0,0,0,0,0,35),(987,2022000,1040083,180000,0,0,0,0,0,26),(988,2022000,1040082,180000,0,0,0,0,0,25),(989,2022000,1040061,114000,0,0,0,0,0,16),(990,2022000,1040062,114000,0,0,0,0,0,17),(991,2022000,1040063,114000,0,0,0,0,0,18),(992,2022000,1002180,100000,0,0,0,0,0,13),(993,2022000,1002179,100000,0,0,0,0,0,12),(994,2022000,1002178,100000,0,0,0,0,0,11),(995,2022000,1002177,100000,0,0,0,0,0,10),(996,2022000,1002176,100000,0,0,0,0,0,9),(997,2022000,1061080,160000,0,0,0,0,0,80),(998,2022000,1061081,160000,0,0,0,0,0,81),(999,2022000,1061062,108000,0,0,0,0,0,76),(1000,2022000,1061060,108000,0,0,0,0,0,74),(1001,2022000,1061064,108000,0,0,0,0,0,77),(1002,2022000,1061061,108000,0,0,0,0,0,75),(1003,2022000,1060069,160000,0,0,0,0,0,66),(1004,2022000,1060070,160000,0,0,0,0,0,67),(1005,2022000,1060063,108000,0,0,0,0,0,64),(1006,2022000,1060061,108000,0,0,0,0,0,62),(1007,2022000,1060065,108000,0,0,0,0,0,65),(1008,2022000,1060062,108000,0,0,0,0,0,63),(1009,2022000,1041081,180000,0,0,0,0,0,36),(1010,2022000,1041082,180000,0,0,0,0,0,37),(1011,2022000,1041067,114000,0,0,0,0,0,32),(1012,2022000,1041065,114000,0,0,0,0,0,30),(1013,2022000,1041069,114000,0,0,0,0,0,33),(1014,2022000,1041066,114000,0,0,0,0,0,31),(1015,2022000,1040079,180000,0,0,0,0,0,23),(1016,2022000,1040081,180000,0,0,0,0,0,24),(1017,2022000,1040076,114000,0,0,0,0,0,22),(1018,2022000,1040074,114000,0,0,0,0,0,21),(1019,2022000,1040073,114000,0,0,0,0,0,20),(1020,2022000,1040072,114000,0,0,0,0,0,19),(1021,2022000,1002137,100000,0,0,0,0,0,2),(1022,2022000,1002135,100000,0,0,0,0,0,1),(1023,2022000,1002139,100000,0,0,0,0,0,4),(1024,2022000,1002138,100000,0,0,0,0,0,3),(1025,2022000,1061047,120000,0,0,0,0,0,72),(1026,2022000,1061048,120000,0,0,0,0,0,73),(1027,2022000,1051027,450000,0,0,0,0,0,56),(1028,2022000,1051024,450000,0,0,0,0,0,54),(1029,2022000,1051025,450000,0,0,0,0,0,55),(1030,2022000,1051023,450000,0,0,0,0,0,53),(1031,2022000,1050037,450000,0,0,0,0,0,46),(1032,2022000,1050036,450000,0,0,0,0,0,45),(1033,2022000,1050038,450000,0,0,0,0,0,47),(1034,2022000,1050035,450000,0,0,0,0,0,44),(1035,2022000,1050002,300000,0,0,0,0,0,41),(1036,2022000,1050031,300000,0,0,0,0,0,43),(1037,2022000,1041051,120000,0,0,0,0,0,28),(1038,2022000,1041052,120000,0,0,0,0,0,29),(1039,2022000,1002144,96000,0,0,0,0,0,8),(1040,2022000,1002143,96000,0,0,0,0,0,7),(1041,2022000,1002142,96000,0,0,0,0,0,6),(1042,2022000,1002141,96000,0,0,0,0,0,5),(1043,2022000,1092002,200000,0,0,0,0,0,90),(1044,2022000,1092001,100000,0,0,0,0,0,89),(1045,2022000,1061084,180000,0,0,0,0,0,83),(1046,2022000,1061083,180000,0,0,0,0,0,82),(1047,2022000,1060074,180000,0,0,0,0,0,70),(1048,2022000,1060075,180000,0,0,0,0,0,71),(1049,2022000,1051014,112500,0,0,0,0,0,52),(1050,2022000,1051001,112500,0,0,0,0,0,48),(1051,2022000,1050021,112500,0,0,0,0,0,42),(1052,2022000,1050000,112500,0,0,0,0,0,40),(1053,2022000,1041085,200000,0,0,0,0,0,39),(1054,2022000,1041084,200000,0,0,0,0,0,38),(1055,2022000,1040085,200000,0,0,0,0,0,27),(1056,2022000,1040000,200000,0,0,0,0,0,15),(1057,2022000,1002004,160000,0,0,0,0,0,0),(1058,2022000,1072338,29000,0,0,0,0,0,88),(1059,2022000,1072171,29000,0,0,0,0,0,87),(1060,2022000,1072170,29000,0,0,0,0,0,86),(1061,2022000,1072169,28000,0,0,0,0,0,85),(1062,2022000,1072168,30000,0,0,0,0,0,84),(1063,2022001,2330000,600,0,0,0,0,0,33),(1064,2022001,2070000,500,0,0,0,0,0,32),(1067,2022001,2061000,1,0,0,0,0,0,31),(1068,2022001,2060000,1,0,0,0,0,0,30),(1069,2022001,2030000,400,0,0,0,0,0,26),(1070,2022001,2050002,300,0,0,0,0,0,29),(1071,2022001,2050001,200,0,0,0,0,0,28),(1072,2022001,2050000,200,0,0,0,0,0,27),(1073,2022001,2020015,10200,0,0,0,0,0,21),(1074,2022001,2020014,8100,0,0,0,0,0,20),(1075,2022001,2020013,5600,0,0,0,0,0,19),(1076,2022001,2020012,4500,0,0,0,0,0,18),(1077,2022001,2001002,4000,0,0,0,0,0,7),(1078,2022001,2001001,2300,0,0,0,0,0,6),(1079,2022001,2001000,3200,0,0,0,0,0,5),(1080,2022001,2022000,1650,0,0,0,0,0,22),(1081,2022001,2022003,1100,0,0,0,0,0,24),(1082,2022001,2010004,310,0,0,0,0,0,17),(1083,2022001,2010003,100,0,0,0,0,0,16),(1084,2022001,2010001,106,0,0,0,0,0,14),(1085,2022001,2010002,50,0,0,0,0,0,15),(1086,2022001,2010000,30,0,0,0,0,0,13),(1087,2022001,2002005,500,0,0,0,0,0,12),(1088,2022001,2002004,500,0,0,0,0,0,11),(1089,2022001,2002002,500,0,0,0,0,0,10),(1090,2022001,2002001,400,0,0,0,0,0,9),(1091,2022001,2002000,500,0,0,0,0,0,8),(1092,2022001,2000006,620,0,0,0,0,0,4),(1093,2022001,2000003,200,0,0,0,0,0,3),(1094,2022001,2000002,320,0,0,0,0,0,2),(1095,2022001,2000001,160,0,0,0,0,0,1),(1096,2022001,2000000,50,0,0,0,0,0,0),(1097,2022001,2022186,2400,0,0,0,0,0,25),(1098,2022001,2022001,400,0,0,0,0,0,23),(1099,2022002,2044900,70000,0,0,0,0,0,25),(1100,2022002,2044800,70000,0,0,0,0,0,24),(1101,2022002,2044700,70000,0,0,0,0,0,23),(1102,2022002,2044600,70000,0,0,0,0,0,22),(1103,2022002,2044500,70000,0,0,0,0,0,21),(1104,2022002,2044400,70000,0,0,0,0,0,20),(1105,2022002,2044300,70000,0,0,0,0,0,19),(1106,2022002,2044200,70000,0,0,0,0,0,18),(1107,2022002,2044100,70000,0,0,0,0,0,17),(1108,2022002,2044000,70000,0,0,0,0,0,16),(1109,2022002,2043800,70000,0,0,0,0,0,15),(1110,2022002,2043700,70000,0,0,0,0,0,14),(1111,2022002,2043300,70000,0,0,0,0,0,13),(1112,2022002,2043200,70000,0,0,0,0,0,12),(1113,2022002,2043100,70000,0,0,0,0,0,11),(1114,2022002,2043000,70000,0,0,0,0,0,10),(1115,2022002,2041003,35000,0,0,0,0,0,9),(1116,2022002,2041000,35000,0,0,0,0,0,8),(1117,2022002,2040900,35000,0,0,0,0,0,7),(1118,2022002,2040800,35000,0,0,0,0,0,6),(1119,2022002,2040700,35000,0,0,0,0,0,5),(1120,2022002,2040600,35000,0,0,0,0,0,4),(1121,2022002,2040503,35000,0,0,0,0,0,3),(1122,2022002,2040400,35000,0,0,0,0,0,2),(1123,2022002,2040300,35000,0,0,0,0,0,1),(1124,2022002,2040003,35000,0,0,0,0,0,0),(1125,2030009,2330000,600,0,0,0,0,0,28),(1126,2030009,2070000,500,0,0,0,0,0,27),(1129,2030009,2061000,1,0,0,0,0,0,26),(1130,2030009,2060000,1,0,0,0,0,0,25),(1131,2030009,2030000,400,0,0,0,0,0,24),(1132,2030009,2020015,10608,0,0,0,0,0,21),(1133,2030009,2020014,8424,0,0,0,0,0,20),(1134,2030009,2020013,5824,0,0,0,0,0,19),(1135,2030009,2020012,4680,0,0,0,0,0,18),(1136,2030009,2022000,1716,0,0,0,0,0,22),(1137,2030009,2022003,1144,0,0,0,0,0,23),(1138,2030009,2020006,551,0,0,0,0,0,17),(1139,2030009,2020004,468,0,0,0,0,0,15),(1140,2030009,2020003,468,0,0,0,0,0,14),(1141,2030009,2020001,228,0,0,0,0,0,13),(1142,2030009,2010004,322,0,0,0,0,0,12),(1143,2030009,2020005,332,0,0,0,0,0,16),(1144,2030009,2001002,4160,0,0,0,0,0,6),(1145,2030009,2001001,2392,0,0,0,0,0,5),(1146,2030009,2001000,3328,0,0,0,0,0,4),(1147,2030009,2002005,520,0,0,0,0,0,11),(1148,2030009,2002004,520,0,0,0,0,0,10),(1149,2030009,2002002,520,0,0,0,0,0,9),(1150,2030009,2002001,416,0,0,0,0,0,8),(1151,2030009,2002000,520,0,0,0,0,0,7),(1152,2030009,2000006,644,0,0,0,0,0,3),(1153,2030009,2000003,208,0,0,0,0,0,2),(1154,2030009,2000002,332,0,0,0,0,0,1),(1155,2030009,2000001,166,0,0,0,0,0,0),(1156,2040049,2061001,10,0,0,0,0,0,34),(1157,2040049,2060001,10,0,0,0,0,0,32),(1160,2040049,2061000,1,0,0,0,0,0,33),(1161,2040049,2060000,1,0,0,0,0,0,31),(1162,2040049,2120000,25,0,0,0,0,0,35),(1163,2040049,2020015,10608,0,0,0,0,0,28),(1164,2040049,2020014,8424,0,0,0,0,0,27),(1165,2040049,2020013,5824,0,0,0,0,0,26),(1166,2040049,2020012,4680,0,0,0,0,0,25),(1167,2040049,2022000,1716,0,0,0,0,0,29),(1168,2040049,2022003,1144,0,0,0,0,0,30),(1169,2040049,2020006,503,0,0,0,0,0,24),(1170,2040049,2020005,304,0,0,0,0,0,23),(1171,2040049,2020004,427,0,0,0,0,0,22),(1172,2040049,2020003,427,0,0,0,0,0,21),(1173,2040049,2020002,304,0,0,0,0,0,20),(1174,2040049,2020001,209,0,0,0,0,0,19),(1175,2040049,2010002,47,0,0,0,0,0,18),(1176,2040049,2010001,106,0,0,0,0,0,17),(1177,2040049,2002010,475,0,0,0,0,0,16),(1178,2040049,2002009,570,0,0,0,0,0,15),(1179,2040049,2002008,570,0,0,0,0,0,14),(1180,2040049,2002007,570,0,0,0,0,0,13),(1181,2040049,2002006,570,0,0,0,0,0,12),(1182,2040049,2001002,3800,0,0,0,0,0,11),(1183,2040049,2001001,2185,0,0,0,0,0,10),(1184,2040049,2000006,589,0,0,0,0,0,4),(1185,2040049,2000011,620,0,0,0,0,0,9),(1186,2040049,2000003,190,0,0,0,0,0,3),(1187,2040049,2000010,200,0,0,0,0,0,8),(1188,2040049,2000002,304,0,0,0,0,0,2),(1189,2040049,2000009,320,0,0,0,0,0,7),(1190,2040049,2000001,152,0,0,0,0,0,1),(1191,2040049,2000008,160,0,0,0,0,0,6),(1192,2040049,2000000,47,0,0,0,0,0,0),(1193,2040049,2000007,50,0,0,0,0,0,5),(1194,2040051,2030000,400,0,0,0,0,0,23),(1195,2040051,2061001,10,0,0,0,0,0,31),(1196,2040051,2060001,10,0,0,0,0,0,29),(1199,2040051,2061000,1,0,0,0,0,0,30),(1200,2040051,2060000,1,0,0,0,0,0,28),(1201,2040051,2050003,500,0,0,0,0,0,27),(1202,2040051,2050002,300,0,0,0,0,0,26),(1203,2040051,2050001,200,0,0,0,0,0,25),(1204,2040051,2050000,200,0,0,0,0,0,24),(1205,2040051,2000006,620,0,0,0,0,0,4),(1206,2040051,2000011,620,0,0,0,0,0,9),(1207,2040051,2000003,200,0,0,0,0,0,3),(1208,2040051,2000010,200,0,0,0,0,0,8),(1209,2040051,2000002,320,0,0,0,0,0,2),(1210,2040051,2000009,320,0,0,0,0,0,7),(1211,2040051,2000001,160,0,0,0,0,0,1),(1212,2040051,2000008,160,0,0,0,0,0,6),(1213,2040051,2000000,50,0,0,0,0,0,0),(1214,2040051,2000007,50,0,0,0,0,0,5),(1215,2040051,2020015,10200,0,0,0,0,0,20),(1216,2040051,2020014,8100,0,0,0,0,0,19),(1217,2040051,2020013,5824,0,0,0,0,0,18),(1218,2040051,2020012,4680,0,0,0,0,0,17),(1219,2040051,2001002,4000,0,0,0,0,0,11),(1220,2040051,2001001,2300,0,0,0,0,0,10),(1221,2040051,2022000,1650,0,0,0,0,0,21),(1222,2040051,2022003,1100,0,0,0,0,0,22),(1223,2040051,2002009,600,0,0,0,0,0,15),(1224,2040051,2002008,600,0,0,0,0,0,14),(1225,2040051,2002007,600,0,0,0,0,0,13),(1226,2040051,2002006,600,0,0,0,0,0,12),(1227,2040051,2002010,500,0,0,0,0,0,16),(1228,2041002,1492006,160000,0,0,0,0,0,47),(1229,2041002,1492005,100000,0,0,0,0,0,46),(1230,2041002,1492004,75000,0,0,0,0,0,45),(1231,2041002,1482006,150000,0,0,0,0,0,44),(1232,2041002,1482005,100000,0,0,0,0,0,43),(1233,2041002,1482004,75000,0,0,0,0,0,42),(1234,2041002,1472007,60000,0,0,0,0,0,41),(1235,2041002,1472004,30000,0,0,0,0,0,40),(1236,2041002,1472001,20000,0,0,0,0,0,39),(1237,2041002,1462005,250000,0,0,0,0,0,38),(1238,2041002,1462004,200000,0,0,0,0,0,37),(1239,2041002,1462000,30000,0,0,0,0,0,36),(1240,2041002,1452007,375000,0,0,0,0,0,35),(1241,2041002,1452006,250000,0,0,0,0,0,34),(1242,2041002,1452005,150000,0,0,0,0,0,33),(1243,2041002,1442009,300000,0,0,0,0,0,32),(1244,2041002,1442003,175000,0,0,0,0,0,31),(1245,2041002,1442001,60000,0,0,0,0,0,30),(1246,2041002,1432005,225000,0,0,0,0,0,29),(1247,2041002,1432003,175000,0,0,0,0,0,28),(1248,2041002,1432002,60000,0,0,0,0,0,27),(1249,2041002,1422007,250000,0,0,0,0,0,25),(1250,2041002,1422008,200000,0,0,0,0,0,26),(1251,2041002,1422001,45000,0,0,0,0,0,24),(1252,2041002,1412005,250000,0,0,0,0,0,22),(1253,2041002,1412004,200000,0,0,0,0,0,21),(1254,2041002,1412006,45000,0,0,0,0,0,23),(1255,2041002,1402007,450000,0,0,0,0,0,20),(1256,2041002,1402006,350000,0,0,0,0,0,19),(1257,2041002,1402002,150000,0,0,0,0,0,18),(1258,2041002,1382002,20000,0,0,0,0,0,17),(1259,2041002,1372000,400000,0,0,0,0,0,14),(1260,2041002,1372001,175000,0,0,0,0,0,15),(1261,2041002,1372003,38000,0,0,0,0,0,16),(1262,2041002,1332011,425000,0,0,0,0,0,11),(1263,2041002,1332014,375000,0,0,0,0,0,13),(1264,2041002,1332001,200000,0,0,0,0,0,9),(1265,2041002,1332012,40000,0,0,0,0,0,12),(1266,2041002,1332009,42000,0,0,0,0,0,10),(1267,2041002,1322016,175000,0,0,0,0,0,8),(1268,2041002,1322015,100000,0,0,0,0,0,7),(1269,2041002,1322014,40000,0,0,0,0,0,6),(1270,2041002,1312007,175000,0,0,0,0,0,5),(1271,2041002,1312006,100000,0,0,0,0,0,4),(1272,2041002,1312005,40000,0,0,0,0,0,3),(1273,2041002,1302009,225000,0,0,0,0,0,2),(1274,2041002,1302004,100000,0,0,0,0,0,0),(1275,2041002,1302008,40000,0,0,0,0,0,1),(1276,2041003,1002625,75000,0,0,0,0,0,14),(1277,2041003,1052113,120000,0,0,0,0,0,58),(1278,2041003,1052110,100000,0,0,0,0,0,57),(1279,2041003,1061069,160000,0,0,0,0,0,78),(1280,2041003,1061070,160000,0,0,0,0,0,79),(1281,2041003,1060072,160000,0,0,0,0,0,69),(1282,2041003,1060071,160000,0,0,0,0,0,68),(1283,2041003,1060052,108000,0,0,0,0,0,61),(1284,2041003,1060050,108000,0,0,0,0,0,59),(1285,2041003,1060051,108000,0,0,0,0,0,60),(1286,2041003,1051009,111000,0,0,0,0,0,51),(1287,2041003,1051008,111000,0,0,0,0,0,50),(1288,2041003,1051007,111000,0,0,0,0,0,49),(1289,2041003,1041074,180000,0,0,0,0,0,34),(1290,2041003,1041075,180000,0,0,0,0,0,35),(1291,2041003,1040083,180000,0,0,0,0,0,26),(1292,2041003,1040082,180000,0,0,0,0,0,25),(1293,2041003,1040061,114000,0,0,0,0,0,16),(1294,2041003,1040062,114000,0,0,0,0,0,17),(1295,2041003,1040063,114000,0,0,0,0,0,18),(1296,2041003,1002180,100000,0,0,0,0,0,13),(1297,2041003,1002179,100000,0,0,0,0,0,12),(1298,2041003,1002178,100000,0,0,0,0,0,11),(1299,2041003,1002177,100000,0,0,0,0,0,10),(1300,2041003,1002176,100000,0,0,0,0,0,9),(1301,2041003,1061080,160000,0,0,0,0,0,80),(1302,2041003,1061081,160000,0,0,0,0,0,81),(1303,2041003,1061062,108000,0,0,0,0,0,76),(1304,2041003,1061060,108000,0,0,0,0,0,74),(1305,2041003,1061064,108000,0,0,0,0,0,77),(1306,2041003,1061061,108000,0,0,0,0,0,75),(1307,2041003,1060069,160000,0,0,0,0,0,66),(1308,2041003,1060070,160000,0,0,0,0,0,67),(1309,2041003,1060063,108000,0,0,0,0,0,64),(1310,2041003,1060061,108000,0,0,0,0,0,62),(1311,2041003,1060065,108000,0,0,0,0,0,65),(1312,2041003,1060062,108000,0,0,0,0,0,63),(1313,2041003,1041081,180000,0,0,0,0,0,36),(1314,2041003,1041082,180000,0,0,0,0,0,37),(1315,2041003,1041067,114000,0,0,0,0,0,32),(1316,2041003,1041065,114000,0,0,0,0,0,30),(1317,2041003,1041069,114000,0,0,0,0,0,33),(1318,2041003,1041066,114000,0,0,0,0,0,31),(1319,2041003,1040079,180000,0,0,0,0,0,23),(1320,2041003,1040081,180000,0,0,0,0,0,24),(1321,2041003,1040076,114000,0,0,0,0,0,22),(1322,2041003,1040074,114000,0,0,0,0,0,21),(1323,2041003,1040073,114000,0,0,0,0,0,20),(1324,2041003,1040072,114000,0,0,0,0,0,19),(1325,2041003,1002137,100000,0,0,0,0,0,2),(1326,2041003,1002135,100000,0,0,0,0,0,1),(1327,2041003,1002139,100000,0,0,0,0,0,4),(1328,2041003,1002138,100000,0,0,0,0,0,3),(1329,2041003,1061047,120000,0,0,0,0,0,72),(1330,2041003,1061048,120000,0,0,0,0,0,73),(1331,2041003,1051027,450000,0,0,0,0,0,56),(1332,2041003,1051024,450000,0,0,0,0,0,54),(1333,2041003,1051025,450000,0,0,0,0,0,55),(1334,2041003,1051023,450000,0,0,0,0,0,53),(1335,2041003,1050037,450000,0,0,0,0,0,46),(1336,2041003,1050036,450000,0,0,0,0,0,45),(1337,2041003,1050038,450000,0,0,0,0,0,47),(1338,2041003,1050035,450000,0,0,0,0,0,44),(1339,2041003,1050002,300000,0,0,0,0,0,41),(1340,2041003,1050031,300000,0,0,0,0,0,43),(1341,2041003,1041051,120000,0,0,0,0,0,28),(1342,2041003,1041052,120000,0,0,0,0,0,29),(1343,2041003,1002144,96000,0,0,0,0,0,8),(1344,2041003,1002143,96000,0,0,0,0,0,7),(1345,2041003,1002142,96000,0,0,0,0,0,6),(1346,2041003,1002141,96000,0,0,0,0,0,5),(1347,2041003,1092002,200000,0,0,0,0,0,85),(1348,2041003,1092001,100000,0,0,0,0,0,84),(1349,2041003,1061084,180000,0,0,0,0,0,83),(1350,2041003,1061083,180000,0,0,0,0,0,82),(1351,2041003,1060074,180000,0,0,0,0,0,70),(1352,2041003,1060075,180000,0,0,0,0,0,71),(1353,2041003,1051014,112500,0,0,0,0,0,52),(1354,2041003,1051001,112500,0,0,0,0,0,48),(1355,2041003,1050021,112500,0,0,0,0,0,42),(1356,2041003,1050000,112500,0,0,0,0,0,40),(1357,2041003,1041085,200000,0,0,0,0,0,39),(1358,2041003,1041084,200000,0,0,0,0,0,38),(1359,2041003,1040085,200000,0,0,0,0,0,27),(1360,2041003,1040000,200000,0,0,0,0,0,15),(1361,2041003,1002004,160000,0,0,0,0,0,0),(1362,2041006,2330000,600,0,0,0,0,0,32),(1363,2041006,2070000,500,0,0,0,0,0,31),(1364,2041006,2061001,10,0,0,0,0,0,30),(1365,2041006,2060001,10,0,0,0,0,0,28),(1368,2041006,2061000,1,0,0,0,0,0,29),(1369,2041006,2060000,1,0,0,0,0,0,27),(1370,2041006,2030000,400,0,0,0,0,0,26),(1371,2041006,2020028,2850,0,0,0,0,0,25),(1372,2041006,2020006,503,0,0,0,0,0,24),(1373,2041006,2020005,304,0,0,0,0,0,23),(1374,2041006,2020004,427,0,0,0,0,0,22),(1375,2041006,2020003,427,0,0,0,0,0,21),(1376,2041006,2020002,304,0,0,0,0,0,20),(1377,2041006,2020001,209,0,0,0,0,0,19),(1378,2041006,2010002,47,0,0,0,0,0,18),(1379,2041006,2010001,106,0,0,0,0,0,17),(1380,2041006,2002010,500,0,0,0,0,0,16),(1381,2041006,2002009,500,0,0,0,0,0,15),(1382,2041006,2002008,500,0,0,0,0,0,14),(1383,2041006,2002007,500,0,0,0,0,0,13),(1384,2041006,2002006,500,0,0,0,0,0,12),(1385,2041006,2001002,3800,0,0,0,0,0,11),(1386,2041006,2001001,2185,0,0,0,0,0,10),(1387,2041006,2000006,589,0,0,0,0,0,4),(1388,2041006,2000011,620,0,0,0,0,0,9),(1389,2041006,2000003,190,0,0,0,0,0,3),(1390,2041006,2000010,200,0,0,0,0,0,8),(1391,2041006,2000002,304,0,0,0,0,0,2),(1392,2041006,2000009,320,0,0,0,0,0,7),(1393,2041006,2000001,152,0,0,0,0,0,1),(1394,2041006,2000008,160,0,0,0,0,0,6),(1395,2041006,2000000,47,0,0,0,0,0,0),(1396,2041006,2000007,50,0,0,0,0,0,5),(1397,2041014,4160019,1000,0,0,0,0,0,19),(1398,2041014,4160039,1000,0,0,0,0,0,30),(1399,2041014,4160037,1000,0,0,0,0,0,29),(1400,2041014,4031993,100000,0,0,0,0,0,2),(1401,2041014,4160036,1000,0,0,0,0,0,28),(1402,2041014,4160035,1000,0,0,0,0,0,27),(1403,2041014,4160034,1000,0,0,0,0,0,26),(1404,2041014,4160032,1000,0,0,0,0,0,25),(1405,2041014,4160024,1000,0,0,0,0,0,23),(1406,2041014,4160023,1000,0,0,0,0,0,22),(1407,2041014,4160022,1000,0,0,0,0,0,21),(1408,2041014,4160015,1000,0,0,0,0,0,17),(1409,2041014,4160012,1000,0,0,0,0,0,14),(1410,2041014,4160013,1000,0,0,0,0,0,15),(1411,2041014,4160017,1000,0,0,0,0,0,18),(1412,2041014,4160014,1000,0,0,0,0,0,16),(1413,2041014,4160020,1000,0,0,0,0,0,20),(1414,2041014,4160010,1000,0,0,0,0,0,13),(1415,2041014,4160009,1000,0,0,0,0,0,12),(1416,2041014,4160008,1000,0,0,0,0,0,11),(1417,2041014,4160007,1000,0,0,0,0,0,10),(1418,2041014,4160006,1000,0,0,0,0,0,9),(1419,2041014,4160005,1000,0,0,0,0,0,8),(1420,2041014,4160004,1000,0,0,0,0,0,7),(1421,2041014,4160003,1000,0,0,0,0,0,6),(1422,2041014,4160002,1000,0,0,0,0,0,5),(1423,2041014,4160001,1000,0,0,0,0,0,4),(1424,2041014,4160000,1000,0,0,0,0,0,3),(1425,2041014,4160026,1000,0,0,0,0,0,24),(1426,2041014,2260000,1000,0,0,0,0,0,1),(1427,2041014,2120000,30,0,0,0,0,0,0),(1428,2041016,4031348,10000000,0,0,0,0,0,28),(1429,2041016,2044900,69000,0,0,0,0,0,27),(1430,2041016,2044800,69000,0,0,0,0,0,26),(1431,2041016,2044700,69000,0,0,0,0,0,25),(1432,2041016,2044600,69000,0,0,0,0,0,24),(1433,2041016,2044500,69000,0,0,0,0,0,23),(1434,2041016,2043800,69000,0,0,0,0,0,17),(1435,2041016,2043700,69000,0,0,0,0,0,16),(1436,2041016,2044400,69000,0,0,0,0,0,22),(1437,2041016,2044300,69000,0,0,0,0,0,21),(1438,2041016,2044200,69000,0,0,0,0,0,20),(1439,2041016,2044100,69000,0,0,0,0,0,19),(1440,2041016,2044000,69000,0,0,0,0,0,18),(1441,2041016,2043300,69000,0,0,0,0,0,15),(1442,2041016,2043200,69000,0,0,0,0,0,14),(1443,2041016,2043100,69000,0,0,0,0,0,13),(1444,2041016,2043000,69000,0,0,0,0,0,12),(1445,2041016,2041003,34000,0,0,0,0,0,11),(1446,2041016,2041000,34000,0,0,0,0,0,10),(1447,2041016,2040900,34000,0,0,0,0,0,9),(1448,2041016,2040800,34000,0,0,0,0,0,8),(1449,2041016,2040706,34000,0,0,0,0,0,7),(1450,2041016,2040703,34000,0,0,0,0,0,6),(1451,2041016,2040700,34000,0,0,0,0,0,5),(1452,2041016,2040600,34000,0,0,0,0,0,4),(1453,2041016,2040503,34000,0,0,0,0,0,3),(1454,2041016,2040400,34000,0,0,0,0,0,2),(1455,2041016,2040000,34000,0,0,0,0,0,0),(1456,2041016,2040300,34000,0,0,0,0,0,1),(1457,2050000,1492006,160000,0,0,0,0,0,30),(1458,2050000,1492005,100000,0,0,0,0,0,29),(1459,2050000,1482006,150000,0,0,0,0,0,28),(1460,2050000,1482005,100000,0,0,0,0,0,27),(1461,2050000,1472007,60000,0,0,0,0,0,26),(1462,2050000,1472004,30000,0,0,0,0,0,25),(1463,2050000,1462005,250000,0,0,0,0,0,24),(1464,2050000,1462004,200000,0,0,0,0,0,23),(1465,2050000,1452007,375000,0,0,0,0,0,22),(1466,2050000,1452006,250000,0,0,0,0,0,21),(1467,2050000,1442009,300000,0,0,0,0,0,20),(1468,2050000,1442003,175000,0,0,0,0,0,19),(1469,2050000,1432005,225000,0,0,0,0,0,18),(1470,2050000,1432003,175000,0,0,0,0,0,17),(1471,2050000,1422007,250000,0,0,0,0,0,15),(1472,2050000,1422008,200000,0,0,0,0,0,16),(1473,2050000,1412005,250000,0,0,0,0,0,14),(1474,2050000,1412004,200000,0,0,0,0,0,13),(1475,2050000,1402007,450000,0,0,0,0,0,12),(1476,2050000,1402006,350000,0,0,0,0,0,11),(1477,2050000,1372000,400000,0,0,0,0,0,9),(1478,2050000,1372001,175000,0,0,0,0,0,10),(1479,2050000,1332011,425000,0,0,0,0,0,7),(1480,2050000,1332014,375000,0,0,0,0,0,8),(1481,2050000,1332001,200000,0,0,0,0,0,6),(1482,2050000,1322016,175000,0,0,0,0,0,5),(1483,2050000,1322015,100000,0,0,0,0,0,4),(1484,2050000,1312007,175000,0,0,0,0,0,3),(1485,2050000,1312006,100000,0,0,0,0,0,2),(1486,2050000,1302009,225000,0,0,0,0,0,1),(1487,2050000,1302004,100000,0,0,0,0,0,0),(1488,2050003,1002625,75000,0,0,0,0,0,14),(1489,2050003,1052113,120000,0,0,0,0,0,58),(1490,2050003,1052110,100000,0,0,0,0,0,57),(1491,2050003,1061069,160000,0,0,0,0,0,78),(1492,2050003,1061070,160000,0,0,0,0,0,79),(1493,2050003,1060072,160000,0,0,0,0,0,69),(1494,2050003,1060071,160000,0,0,0,0,0,68),(1495,2050003,1060052,108000,0,0,0,0,0,61),(1496,2050003,1060050,108000,0,0,0,0,0,59),(1497,2050003,1060051,108000,0,0,0,0,0,60),(1498,2050003,1051009,111000,0,0,0,0,0,51),(1499,2050003,1051008,111000,0,0,0,0,0,50),(1500,2050003,1051007,111000,0,0,0,0,0,49),(1501,2050003,1041074,180000,0,0,0,0,0,34),(1502,2050003,1041075,180000,0,0,0,0,0,35),(1503,2050003,1040083,180000,0,0,0,0,0,26),(1504,2050003,1040082,180000,0,0,0,0,0,25),(1505,2050003,1040061,114000,0,0,0,0,0,16),(1506,2050003,1040062,114000,0,0,0,0,0,17),(1507,2050003,1040063,114000,0,0,0,0,0,18),(1508,2050003,1002180,100000,0,0,0,0,0,13),(1509,2050003,1002179,100000,0,0,0,0,0,12),(1510,2050003,1002178,100000,0,0,0,0,0,11),(1511,2050003,1002177,100000,0,0,0,0,0,10),(1512,2050003,1002176,100000,0,0,0,0,0,9),(1513,2050003,1061080,160000,0,0,0,0,0,80),(1514,2050003,1061081,160000,0,0,0,0,0,81),(1515,2050003,1061062,108000,0,0,0,0,0,76),(1516,2050003,1061060,108000,0,0,0,0,0,74),(1517,2050003,1061064,108000,0,0,0,0,0,77),(1518,2050003,1061061,108000,0,0,0,0,0,75),(1519,2050003,1060069,160000,0,0,0,0,0,66),(1520,2050003,1060070,160000,0,0,0,0,0,67),(1521,2050003,1060063,108000,0,0,0,0,0,64),(1522,2050003,1060061,108000,0,0,0,0,0,62),(1523,2050003,1060065,108000,0,0,0,0,0,65),(1524,2050003,1060062,108000,0,0,0,0,0,63),(1525,2050003,1041081,180000,0,0,0,0,0,36),(1526,2050003,1041082,180000,0,0,0,0,0,37),(1527,2050003,1041067,114000,0,0,0,0,0,32),(1528,2050003,1041065,114000,0,0,0,0,0,30),(1529,2050003,1041069,114000,0,0,0,0,0,33),(1530,2050003,1041066,114000,0,0,0,0,0,31),(1531,2050003,1040079,180000,0,0,0,0,0,23),(1532,2050003,1040081,180000,0,0,0,0,0,24),(1533,2050003,1040076,114000,0,0,0,0,0,22),(1534,2050003,1040074,114000,0,0,0,0,0,21),(1535,2050003,1040073,114000,0,0,0,0,0,20),(1536,2050003,1040072,114000,0,0,0,0,0,19),(1537,2050003,1002137,100000,0,0,0,0,0,2),(1538,2050003,1002135,100000,0,0,0,0,0,1),(1539,2050003,1002139,100000,0,0,0,0,0,4),(1540,2050003,1002138,100000,0,0,0,0,0,3),(1541,2050003,1061047,120000,0,0,0,0,0,72),(1542,2050003,1061048,120000,0,0,0,0,0,73),(1543,2050003,1051027,450000,0,0,0,0,0,56),(1544,2050003,1051024,450000,0,0,0,0,0,54),(1545,2050003,1051025,450000,0,0,0,0,0,55),(1546,2050003,1051023,450000,0,0,0,0,0,53),(1547,2050003,1050037,450000,0,0,0,0,0,46),(1548,2050003,1050036,450000,0,0,0,0,0,45),(1549,2050003,1050038,450000,0,0,0,0,0,47),(1550,2050003,1050035,450000,0,0,0,0,0,44),(1551,2050003,1050002,300000,0,0,0,0,0,41),(1552,2050003,1050031,300000,0,0,0,0,0,43),(1553,2050003,1041051,120000,0,0,0,0,0,28),(1554,2050003,1041052,120000,0,0,0,0,0,29),(1555,2050003,1002144,96000,0,0,0,0,0,8),(1556,2050003,1002143,96000,0,0,0,0,0,7),(1557,2050003,1002142,96000,0,0,0,0,0,6),(1558,2050003,1002141,96000,0,0,0,0,0,5),(1559,2050003,1092002,200000,0,0,0,0,0,85),(1560,2050003,1092001,100000,0,0,0,0,0,84),(1561,2050003,1061084,180000,0,0,0,0,0,83),(1562,2050003,1061083,180000,0,0,0,0,0,82),(1563,2050003,1060074,180000,0,0,0,0,0,70),(1564,2050003,1060075,180000,0,0,0,0,0,71),(1565,2050003,1051014,112500,0,0,0,0,0,52),(1566,2050003,1051001,112500,0,0,0,0,0,48),(1567,2050003,1050021,112500,0,0,0,0,0,42),(1568,2050003,1050000,112500,0,0,0,0,0,40),(1569,2050003,1041085,200000,0,0,0,0,0,39),(1570,2050003,1041084,200000,0,0,0,0,0,38),(1571,2050003,1040085,200000,0,0,0,0,0,27),(1572,2050003,1040000,200000,0,0,0,0,0,15),(1573,2050003,1002004,160000,0,0,0,0,0,0),(1574,2051000,2330000,600,0,0,0,0,0,31),(1575,2051000,2070000,500,0,0,0,0,0,30),(1576,2051000,2061001,10,0,0,0,0,0,29),(1577,2051000,2060001,10,0,0,0,0,0,27),(1580,2051000,2061000,1,0,0,0,0,0,28),(1581,2051000,2060000,1,0,0,0,0,0,26),(1582,2051000,2030000,400,0,0,0,0,0,25),(1583,2051000,2022000,1567,0,0,0,0,0,23),(1584,2051000,2022003,1045,0,0,0,0,0,24),(1585,2051000,2020015,9690,0,0,0,0,0,22),(1586,2051000,2020014,7695,0,0,0,0,0,21),(1587,2051000,2020013,5600,0,0,0,0,0,20),(1588,2051000,2020012,4680,0,0,0,0,0,19),(1589,2051000,2010004,294,0,0,0,0,0,18),(1590,2051000,2010003,95,0,0,0,0,0,17),(1591,2051000,2010002,47,0,0,0,0,0,16),(1592,2051000,2010001,106,0,0,0,0,0,15),(1593,2051000,2010000,28,0,0,0,0,0,14),(1594,2051000,2001002,3800,0,0,0,0,0,7),(1595,2051000,2001001,2185,0,0,0,0,0,6),(1596,2051000,2001000,3040,0,0,0,0,0,5),(1597,2051000,2002011,1200,0,0,0,0,0,13),(1598,2051000,2002005,475,0,0,0,0,0,12),(1599,2051000,2002004,475,0,0,0,0,0,11),(1600,2051000,2002002,475,0,0,0,0,0,10),(1601,2051000,2002001,380,0,0,0,0,0,9),(1602,2051000,2002000,475,0,0,0,0,0,8),(1603,2051000,2000006,589,0,0,0,0,0,4),(1604,2051000,2000003,190,0,0,0,0,0,3),(1605,2051000,2000002,304,0,0,0,0,0,2),(1606,2051000,2000001,152,0,0,0,0,0,1),(1607,2051000,2000000,47,0,0,0,0,0,0),(1608,2060003,1002625,75000,0,0,0,0,0,9),(1609,2060003,1052113,120000,0,0,0,0,0,72),(1610,2060003,1052110,100000,0,0,0,0,0,71),(1611,2060003,1052107,90000,0,0,0,0,0,70),(1612,2060003,1002622,40000,0,0,0,0,0,8),(1613,2060003,1061070,160000,0,0,0,0,0,104),(1614,2060003,1061069,160000,0,0,0,0,0,103),(1615,2060003,1041075,180000,0,0,0,0,0,41),(1616,2060003,1041074,180000,0,0,0,0,0,40),(1617,2060003,1060072,160000,0,0,0,0,0,87),(1618,2060003,1060071,160000,0,0,0,0,0,86),(1619,2060003,1040083,180000,0,0,0,0,0,24),(1620,2060003,1040082,180000,0,0,0,0,0,23),(1621,2060003,1051009,111000,0,0,0,0,0,61),(1622,2060003,1051008,111000,0,0,0,0,0,60),(1623,2060003,1051007,111000,0,0,0,0,0,59),(1624,2060003,1060051,108000,0,0,0,0,0,78),(1625,2060003,1060050,108000,0,0,0,0,0,77),(1626,2060003,1040062,114000,0,0,0,0,0,15),(1627,2060003,1040061,114000,0,0,0,0,0,14),(1628,2060003,1060045,40000,0,0,0,0,0,76),(1629,2060003,1060043,40000,0,0,0,0,0,75),(1630,2060003,1040059,45000,0,0,0,0,0,13),(1631,2060003,1040057,45000,0,0,0,0,0,12),(1632,2060003,1061046,40000,0,0,0,0,0,95),(1633,2060003,1061045,40000,0,0,0,0,0,94),(1634,2060003,1061043,40000,0,0,0,0,0,93),(1635,2060003,1041050,45000,0,0,0,0,0,32),(1636,2060003,1041049,45000,0,0,0,0,0,31),(1637,2060003,1041047,45000,0,0,0,0,0,30),(1638,2060003,1061081,160000,0,0,0,0,0,106),(1639,2060003,1061080,160000,0,0,0,0,0,105),(1640,2060003,1041082,180000,0,0,0,0,0,43),(1641,2060003,1041081,180000,0,0,0,0,0,42),(1642,2060003,1060070,160000,0,0,0,0,0,85),(1643,2060003,1060069,160000,0,0,0,0,0,84),(1644,2060003,1040081,180000,0,0,0,0,0,22),(1645,2060003,1040079,180000,0,0,0,0,0,21),(1646,2060003,1060063,108000,0,0,0,0,0,83),(1647,2060003,1060062,108000,0,0,0,0,0,82),(1648,2060003,1060061,108000,0,0,0,0,0,81),(1649,2060003,1040074,114000,0,0,0,0,0,20),(1650,2060003,1040073,114000,0,0,0,0,0,19),(1651,2060003,1040072,114000,0,0,0,0,0,18),(1652,2060003,1061062,108000,0,0,0,0,0,102),(1653,2060003,1061061,108000,0,0,0,0,0,101),(1654,2060003,1061060,108000,0,0,0,0,0,100),(1655,2060003,1041067,114000,0,0,0,0,0,39),(1656,2060003,1041066,114000,0,0,0,0,0,38),(1657,2060003,1041065,114000,0,0,0,0,0,37),(1658,2060003,1060058,44000,0,0,0,0,0,80),(1659,2060003,1060056,44000,0,0,0,0,0,79),(1660,2060003,1040069,50000,0,0,0,0,0,17),(1661,2060003,1040067,50000,0,0,0,0,0,16),(1662,2060003,1061052,44000,0,0,0,0,0,99),(1663,2060003,1061050,44000,0,0,0,0,0,98),(1664,2060003,1041056,50000,0,0,0,0,0,36),(1665,2060003,1041054,50000,0,0,0,0,0,35),(1666,2060003,1050038,450000,0,0,0,0,0,57),(1667,2060003,1050037,450000,0,0,0,0,0,56),(1668,2060003,1050036,450000,0,0,0,0,0,55),(1669,2060003,1051025,450000,0,0,0,0,0,69),(1670,2060003,1051024,450000,0,0,0,0,0,68),(1671,2060003,1051023,450000,0,0,0,0,0,67),(1672,2060003,1050031,300000,0,0,0,0,0,54),(1673,2060003,1050030,300000,0,0,0,0,0,53),(1674,2060003,1050002,300000,0,0,0,0,0,47),(1675,2060003,1061048,120000,0,0,0,0,0,97),(1676,2060003,1061047,120000,0,0,0,0,0,96),(1677,2060003,1041052,120000,0,0,0,0,0,34),(1678,2060003,1041051,120000,0,0,0,0,0,33),(1679,2060003,1050028,40000,0,0,0,0,0,52),(1680,2060003,1050026,40000,0,0,0,0,0,51),(1681,2060003,1050003,40000,0,0,0,0,0,48),(1682,2060003,1061036,40000,0,0,0,0,0,92),(1683,2060003,1061035,40000,0,0,0,0,0,91),(1684,2060003,1061034,40000,0,0,0,0,0,90),(1685,2060003,1041043,42000,0,0,0,0,0,29),(1686,2060003,1041042,42000,0,0,0,0,0,28),(1687,2060003,1041041,42000,0,0,0,0,0,27),(1688,2060003,1061084,180000,0,0,0,0,0,108),(1689,2060003,1061083,180000,0,0,0,0,0,107),(1690,2060003,1060075,180000,0,0,0,0,0,89),(1691,2060003,1060074,180000,0,0,0,0,0,88),(1692,2060003,1041085,200000,0,0,0,0,0,45),(1693,2060003,1041084,200000,0,0,0,0,0,44),(1694,2060003,1040086,200000,0,0,0,0,0,26),(1695,2060003,1040085,200000,0,0,0,0,0,25),(1696,2060003,1051015,112500,0,0,0,0,0,66),(1697,2060003,1051014,112500,0,0,0,0,0,65),(1698,2060003,1051001,112500,0,0,0,0,0,58),(1699,2060003,1050021,112500,0,0,0,0,0,50),(1700,2060003,1050000,112500,0,0,0,0,0,46),(1701,2060003,1060017,38000,0,0,0,0,0,74),(1702,2060003,1060016,38000,0,0,0,0,0,73),(1703,2060003,1040026,40000,0,0,0,0,0,11),(1704,2060003,1040021,40000,0,0,0,0,0,10),(1705,2060003,1050011,70000,0,0,0,0,0,49),(1706,2060003,1051013,60000,0,0,0,0,0,64),(1707,2060003,1051012,60000,0,0,0,0,0,63),(1708,2060003,1051011,60000,0,0,0,0,0,62),(1709,2060003,1002177,100000,0,0,0,0,0,7),(1710,2060003,1002172,60000,0,0,0,0,0,6),(1711,2060003,1002138,100000,0,0,0,0,0,3),(1712,2060003,1002162,60000,0,0,0,0,0,5),(1713,2060003,1002142,96000,0,0,0,0,0,4),(1714,2060003,1002034,60000,0,0,0,0,0,1),(1715,2060003,1002048,160000,0,0,0,0,0,2),(1716,2060003,1002023,120000,0,0,0,0,0,0),(1717,2060004,2330000,600,0,0,0,0,0,32),(1718,2060004,2070000,500,0,0,0,0,0,31),(1719,2060004,2061001,10,0,0,0,0,0,30),(1720,2060004,2060001,10,0,0,0,0,0,28),(1723,2060004,2061000,1,0,0,0,0,0,29),(1724,2060004,2060000,1,0,0,0,0,0,27),(1725,2060004,2030000,400,0,0,0,0,0,26),(1726,2060004,2022000,1650,0,0,0,0,0,22),(1727,2060004,2022003,1100,0,0,0,0,0,23),(1728,2060004,2020015,10200,0,0,0,0,0,21),(1729,2060004,2020014,8100,0,0,0,0,0,20),(1730,2060004,2020013,5600,0,0,0,0,0,19),(1731,2060004,2020012,4500,0,0,0,0,0,18),(1732,2060004,2010004,310,0,0,0,0,0,17),(1733,2060004,2010003,100,0,0,0,0,0,16),(1734,2060004,2010001,106,0,0,0,0,0,14),(1735,2060004,2010002,50,0,0,0,0,0,15),(1736,2060004,2010000,30,0,0,0,0,0,13),(1737,2060004,2001002,4000,0,0,0,0,0,7),(1738,2060004,2001001,2300,0,0,0,0,0,6),(1739,2060004,2001000,3200,0,0,0,0,0,5),(1740,2060004,2022041,1600,0,0,0,0,0,25),(1741,2060004,2022040,300,0,0,0,0,0,24),(1742,2060004,2002005,500,0,0,0,0,0,12),(1743,2060004,2002004,500,0,0,0,0,0,11),(1744,2060004,2002002,500,0,0,0,0,0,10),(1745,2060004,2002001,400,0,0,0,0,0,9),(1746,2060004,2002000,500,0,0,0,0,0,8),(1747,2060004,2000006,620,0,0,0,0,0,4),(1748,2060004,2000003,200,0,0,0,0,0,3),(1749,2060004,2000002,320,0,0,0,0,0,2),(1750,2060004,2000001,160,0,0,0,0,0,1),(1751,2060004,2000000,50,0,0,0,0,0,0),(1752,2060007,1492006,160000,0,0,0,0,0,54),(1753,2060007,1492005,100000,0,0,0,0,0,53),(1754,2060007,1492004,75000,0,0,0,0,0,52),(1755,2060007,1482006,150000,0,0,0,0,0,51),(1756,2060007,1482005,100000,0,0,0,0,0,50),(1757,2060007,1482004,75000,0,0,0,0,0,49),(1758,2060007,1472007,60000,0,0,0,0,0,48),(1759,2060007,1462005,250000,0,0,0,0,0,47),(1760,2060007,1462004,200000,0,0,0,0,0,46),(1761,2060007,1462000,30000,0,0,0,0,0,44),(1762,2060007,1462003,12000,0,0,0,0,0,45),(1763,2060007,1452007,375000,0,0,0,0,0,43),(1764,2060007,1452006,250000,0,0,0,0,0,42),(1765,2060007,1452005,150000,0,0,0,0,0,41),(1766,2060007,1452000,20000,0,0,0,0,0,40),(1767,2060007,1442009,300000,0,0,0,0,0,39),(1768,2060007,1442003,175000,0,0,0,0,0,37),(1769,2060007,1442001,60000,0,0,0,0,0,36),(1770,2060007,1442004,24000,0,0,0,0,0,38),(1771,2060007,1432005,225000,0,0,0,0,0,35),(1772,2060007,1432003,175000,0,0,0,0,0,34),(1773,2060007,1432002,60000,0,0,0,0,0,33),(1774,2060007,1422007,250000,0,0,0,0,0,31),(1775,2060007,1422008,200000,0,0,0,0,0,32),(1776,2060007,1422001,45000,0,0,0,0,0,29),(1777,2060007,1422004,20000,0,0,0,0,0,30),(1778,2060007,1412005,250000,0,0,0,0,0,27),(1779,2060007,1412006,45000,0,0,0,0,0,28),(1780,2060007,1412004,200000,0,0,0,0,0,26),(1781,2060007,1412000,22000,0,0,0,0,0,25),(1782,2060007,1402007,450000,0,0,0,0,0,23),(1783,2060007,1402006,350000,0,0,0,0,0,22),(1784,2060007,1402002,150000,0,0,0,0,0,21),(1785,2060007,1402008,22000,0,0,0,0,0,24),(1786,2060007,1372000,400000,0,0,0,0,0,16),(1787,2060007,1372001,175000,0,0,0,0,0,17),(1788,2060007,1372003,38000,0,0,0,0,0,18),(1789,2060007,1382002,20000,0,0,0,0,0,20),(1790,2060007,1372004,18000,0,0,0,0,0,19),(1791,2060007,1332011,425000,0,0,0,0,0,13),(1792,2060007,1332014,375000,0,0,0,0,0,15),(1793,2060007,1332012,40000,0,0,0,0,0,14),(1794,2060007,1332004,38000,0,0,0,0,0,12),(1795,2060007,1322016,175000,0,0,0,0,0,11),(1796,2060007,1322015,100000,0,0,0,0,0,10),(1797,2060007,1322014,40000,0,0,0,0,0,9),(1798,2060007,1322004,22000,0,0,0,0,0,8),(1799,2060007,1312007,175000,0,0,0,0,0,7),(1800,2060007,1312006,100000,0,0,0,0,0,6),(1801,2060007,1312005,40000,0,0,0,0,0,5),(1802,2060007,1312003,20000,0,0,0,0,0,4),(1803,2060007,1302009,225000,0,0,0,0,0,3),(1804,2060007,1302004,100000,0,0,0,0,0,1),(1805,2060007,1302008,40000,0,0,0,0,0,2),(1806,2060007,1302003,20000,0,0,0,0,0,0),(1807,2070001,2330000,600,0,0,0,0,0,30),(1808,2070001,2070000,500,0,0,0,0,0,29),(1809,2070001,2061001,10,0,0,0,0,0,28),(1810,2070001,2060001,10,0,0,0,0,0,26),(1813,2070001,2061000,1,0,0,0,0,0,27),(1814,2070001,2060000,1,0,0,0,0,0,25),(1815,2070001,2030000,400,0,0,0,0,0,24),(1816,2070001,2022000,1650,0,0,0,0,0,22),(1817,2070001,2022003,1100,0,0,0,0,0,23),(1818,2070001,2020015,10200,0,0,0,0,0,21),(1819,2070001,2020014,8100,0,0,0,0,0,20),(1820,2070001,2020013,5600,0,0,0,0,0,19),(1821,2070001,2020012,4500,0,0,0,0,0,18),(1822,2070001,2010004,310,0,0,0,0,0,17),(1823,2070001,2010003,100,0,0,0,0,0,16),(1824,2070001,2010001,106,0,0,0,0,0,14),(1825,2070001,2010002,50,0,0,0,0,0,15),(1826,2070001,2010000,30,0,0,0,0,0,13),(1827,2070001,2001002,4000,0,0,0,0,0,7),(1828,2070001,2001001,2300,0,0,0,0,0,6),(1829,2070001,2001000,3200,0,0,0,0,0,5),(1830,2070001,2002005,500,0,0,0,0,0,12),(1831,2070001,2002004,500,0,0,0,0,0,11),(1832,2070001,2002002,500,0,0,0,0,0,10),(1833,2070001,2002001,400,0,0,0,0,0,9),(1834,2070001,2002000,500,0,0,0,0,0,8),(1835,2070001,2000006,620,0,0,0,0,0,4),(1836,2070001,2000003,200,0,0,0,0,0,3),(1837,2070001,2000002,320,0,0,0,0,0,2),(1838,2070001,2000001,160,0,0,0,0,0,1),(1839,2070001,2000000,50,0,0,0,0,0,0),(1840,2070002,1492006,160000,0,0,0,0,0,30),(1841,2070002,1492005,100000,0,0,0,0,0,29),(1842,2070002,1482006,150000,0,0,0,0,0,28),(1843,2070002,1482005,100000,0,0,0,0,0,27),(1844,2070002,1472007,60000,0,0,0,0,0,26),(1845,2070002,1472004,30000,0,0,0,0,0,25),(1846,2070002,1462005,250000,0,0,0,0,0,24),(1847,2070002,1462004,200000,0,0,0,0,0,23),(1848,2070002,1452007,375000,0,0,0,0,0,22),(1849,2070002,1452006,250000,0,0,0,0,0,21),(1850,2070002,1442009,300000,0,0,0,0,0,20),(1851,2070002,1442003,175000,0,0,0,0,0,19),(1852,2070002,1432005,225000,0,0,0,0,0,18),(1853,2070002,1432003,175000,0,0,0,0,0,17),(1854,2070002,1422007,250000,0,0,0,0,0,15),(1855,2070002,1422008,200000,0,0,0,0,0,16),(1856,2070002,1412005,250000,0,0,0,0,0,14),(1857,2070002,1412004,200000,0,0,0,0,0,13),(1858,2070002,1402007,450000,0,0,0,0,0,12),(1859,2070002,1402006,350000,0,0,0,0,0,11),(1860,2070002,1372000,400000,0,0,0,0,0,9),(1861,2070002,1372001,175000,0,0,0,0,0,10),(1862,2070002,1332011,425000,0,0,0,0,0,7),(1863,2070002,1332014,375000,0,0,0,0,0,8),(1864,2070002,1332001,200000,0,0,0,0,0,6),(1865,2070002,1322016,175000,0,0,0,0,0,5),(1866,2070002,1322015,100000,0,0,0,0,0,4),(1867,2070002,1312007,175000,0,0,0,0,0,3),(1868,2070002,1312006,100000,0,0,0,0,0,2),(1869,2070002,1302009,225000,0,0,0,0,0,1),(1870,2070002,1302004,100000,0,0,0,0,0,0),(1871,2070003,1002625,75000,0,0,0,0,0,14),(1872,2070003,1052113,120000,0,0,0,0,0,59),(1873,2070003,1052110,100000,0,0,0,0,0,58),(1874,2070003,1052107,90000,0,0,0,0,0,57),(1875,2070003,1061069,160000,0,0,0,0,0,79),(1876,2070003,1061070,160000,0,0,0,0,0,80),(1877,2070003,1060072,160000,0,0,0,0,0,70),(1878,2070003,1060071,160000,0,0,0,0,0,69),(1879,2070003,1060052,108000,0,0,0,0,0,62),(1880,2070003,1060050,108000,0,0,0,0,0,60),(1881,2070003,1060051,108000,0,0,0,0,0,61),(1882,2070003,1051009,111000,0,0,0,0,0,51),(1883,2070003,1051008,111000,0,0,0,0,0,50),(1884,2070003,1051007,111000,0,0,0,0,0,49),(1885,2070003,1041074,180000,0,0,0,0,0,34),(1886,2070003,1041075,180000,0,0,0,0,0,35),(1887,2070003,1040083,180000,0,0,0,0,0,26),(1888,2070003,1040082,180000,0,0,0,0,0,25),(1889,2070003,1040061,114000,0,0,0,0,0,16),(1890,2070003,1040062,114000,0,0,0,0,0,17),(1891,2070003,1040063,114000,0,0,0,0,0,18),(1892,2070003,1002180,100000,0,0,0,0,0,13),(1893,2070003,1002179,100000,0,0,0,0,0,12),(1894,2070003,1002178,100000,0,0,0,0,0,11),(1895,2070003,1002177,100000,0,0,0,0,0,10),(1896,2070003,1002176,100000,0,0,0,0,0,9),(1897,2070003,1061080,160000,0,0,0,0,0,81),(1898,2070003,1061081,160000,0,0,0,0,0,82),(1899,2070003,1061062,108000,0,0,0,0,0,77),(1900,2070003,1061060,108000,0,0,0,0,0,75),(1901,2070003,1061064,108000,0,0,0,0,0,78),(1902,2070003,1061061,108000,0,0,0,0,0,76),(1903,2070003,1060069,160000,0,0,0,0,0,67),(1904,2070003,1060070,160000,0,0,0,0,0,68),(1905,2070003,1060063,108000,0,0,0,0,0,65),(1906,2070003,1060061,108000,0,0,0,0,0,63),(1907,2070003,1060065,108000,0,0,0,0,0,66),(1908,2070003,1060062,108000,0,0,0,0,0,64),(1909,2070003,1041081,180000,0,0,0,0,0,36),(1910,2070003,1041082,180000,0,0,0,0,0,37),(1911,2070003,1041067,114000,0,0,0,0,0,32),(1912,2070003,1041065,114000,0,0,0,0,0,30),(1913,2070003,1041069,114000,0,0,0,0,0,33),(1914,2070003,1041066,114000,0,0,0,0,0,31),(1915,2070003,1040079,180000,0,0,0,0,0,23),(1916,2070003,1040081,180000,0,0,0,0,0,24),(1917,2070003,1040076,114000,0,0,0,0,0,22),(1918,2070003,1040074,114000,0,0,0,0,0,21),(1919,2070003,1040073,114000,0,0,0,0,0,20),(1920,2070003,1040072,114000,0,0,0,0,0,19),(1921,2070003,1002137,100000,0,0,0,0,0,2),(1922,2070003,1002135,100000,0,0,0,0,0,1),(1923,2070003,1002139,100000,0,0,0,0,0,4),(1924,2070003,1002138,100000,0,0,0,0,0,3),(1925,2070003,1061047,120000,0,0,0,0,0,73),(1926,2070003,1061048,120000,0,0,0,0,0,74),(1927,2070003,1051027,450000,0,0,0,0,0,56),(1928,2070003,1051024,450000,0,0,0,0,0,54),(1929,2070003,1051025,450000,0,0,0,0,0,55),(1930,2070003,1051023,450000,0,0,0,0,0,53),(1931,2070003,1050037,450000,0,0,0,0,0,46),(1932,2070003,1050036,450000,0,0,0,0,0,45),(1933,2070003,1050038,450000,0,0,0,0,0,47),(1934,2070003,1050035,450000,0,0,0,0,0,44),(1935,2070003,1050002,300000,0,0,0,0,0,41),(1936,2070003,1050031,300000,0,0,0,0,0,43),(1937,2070003,1041051,120000,0,0,0,0,0,28),(1938,2070003,1041052,120000,0,0,0,0,0,29),(1939,2070003,1002144,96000,0,0,0,0,0,8),(1940,2070003,1002143,96000,0,0,0,0,0,7),(1941,2070003,1002142,96000,0,0,0,0,0,6),(1942,2070003,1002141,96000,0,0,0,0,0,5),(1943,2070003,1092002,200000,0,0,0,0,0,86),(1944,2070003,1092001,100000,0,0,0,0,0,85),(1945,2070003,1061084,180000,0,0,0,0,0,84),(1946,2070003,1061083,180000,0,0,0,0,0,83),(1947,2070003,1060074,180000,0,0,0,0,0,71),(1948,2070003,1060075,180000,0,0,0,0,0,72),(1949,2070003,1051014,112500,0,0,0,0,0,52),(1950,2070003,1051001,112500,0,0,0,0,0,48),(1951,2070003,1050021,112500,0,0,0,0,0,42),(1952,2070003,1050000,112500,0,0,0,0,0,40),(1953,2070003,1041085,200000,0,0,0,0,0,39),(1954,2070003,1041084,200000,0,0,0,0,0,38),(1955,2070003,1040085,200000,0,0,0,0,0,27),(1956,2070003,1040000,200000,0,0,0,0,0,15),(1957,2070003,1002004,160000,0,0,0,0,0,0),(1958,2080001,2330000,600,0,0,0,0,0,29),(1959,2080001,2070000,500,0,0,0,0,0,28),(1960,2080001,2061001,10,0,0,0,0,0,27),(1961,2080001,2060001,10,0,0,0,0,0,25),(1964,2080001,2061000,1,0,0,0,0,0,26),(1965,2080001,2060000,1,0,0,0,0,0,24),(1966,2080001,2030000,400,0,0,0,0,0,23),(1967,2080001,2020015,10200,0,0,0,0,0,21),(1968,2080001,2020014,8100,0,0,0,0,0,20),(1969,2080001,2020013,5600,0,0,0,0,0,19),(1970,2080001,2020012,4500,0,0,0,0,0,18),(1971,2080001,2010004,310,0,0,0,0,0,17),(1972,2080001,2010003,100,0,0,0,0,0,16),(1973,2080001,2010001,106,0,0,0,0,0,14),(1974,2080001,2010002,50,0,0,0,0,0,15),(1975,2080001,2010000,30,0,0,0,0,0,13),(1976,2080001,2001002,4000,0,0,0,0,0,7),(1977,2080001,2001001,2300,0,0,0,0,0,6),(1978,2080001,2001000,3200,0,0,0,0,0,5),(1979,2080001,2022089,3400,0,0,0,0,0,22),(1980,2080001,2002005,500,0,0,0,0,0,12),(1981,2080001,2002004,500,0,0,0,0,0,11),(1982,2080001,2002002,500,0,0,0,0,0,10),(1983,2080001,2002001,400,0,0,0,0,0,9),(1984,2080001,2002000,500,0,0,0,0,0,8),(1985,2080001,2000006,620,0,0,0,0,0,4),(1986,2080001,2000003,200,0,0,0,0,0,3),(1987,2080001,2000002,320,0,0,0,0,0,2),(1988,2080001,2000001,160,0,0,0,0,0,1),(1989,2080001,2000000,50,0,0,0,0,0,0),(1990,2080002,1002625,75000,0,0,0,0,0,14),(1991,2080002,1052113,120000,0,0,0,0,0,58),(1992,2080002,1052110,100000,0,0,0,0,0,57),(1993,2080002,1061069,160000,0,0,0,0,0,78),(1994,2080002,1061070,160000,0,0,0,0,0,79),(1995,2080002,1060072,160000,0,0,0,0,0,69),(1996,2080002,1060071,160000,0,0,0,0,0,68),(1997,2080002,1060052,108000,0,0,0,0,0,61),(1998,2080002,1060050,108000,0,0,0,0,0,59),(1999,2080002,1060051,108000,0,0,0,0,0,60),(2000,2080002,1051009,111000,0,0,0,0,0,51),(2001,2080002,1051008,111000,0,0,0,0,0,50),(2002,2080002,1051007,111000,0,0,0,0,0,49),(2003,2080002,1041074,180000,0,0,0,0,0,34),(2004,2080002,1041075,180000,0,0,0,0,0,35),(2005,2080002,1040083,180000,0,0,0,0,0,26),(2006,2080002,1040082,180000,0,0,0,0,0,25),(2007,2080002,1040061,114000,0,0,0,0,0,16),(2008,2080002,1040062,114000,0,0,0,0,0,17),(2009,2080002,1040063,114000,0,0,0,0,0,18),(2010,2080002,1002180,100000,0,0,0,0,0,13),(2011,2080002,1002179,100000,0,0,0,0,0,12),(2012,2080002,1002178,100000,0,0,0,0,0,11),(2013,2080002,1002177,100000,0,0,0,0,0,10),(2014,2080002,1002176,100000,0,0,0,0,0,9),(2015,2080002,1061080,160000,0,0,0,0,0,80),(2016,2080002,1061081,160000,0,0,0,0,0,81),(2017,2080002,1061062,108000,0,0,0,0,0,76),(2018,2080002,1061060,108000,0,0,0,0,0,74),(2019,2080002,1061064,108000,0,0,0,0,0,77),(2020,2080002,1061061,108000,0,0,0,0,0,75),(2021,2080002,1060069,160000,0,0,0,0,0,66),(2022,2080002,1060070,160000,0,0,0,0,0,67),(2023,2080002,1060063,108000,0,0,0,0,0,64),(2024,2080002,1060061,108000,0,0,0,0,0,62),(2025,2080002,1060065,108000,0,0,0,0,0,65),(2026,2080002,1060062,108000,0,0,0,0,0,63),(2027,2080002,1041081,180000,0,0,0,0,0,36),(2028,2080002,1041082,180000,0,0,0,0,0,37),(2029,2080002,1041067,114000,0,0,0,0,0,32),(2030,2080002,1041065,114000,0,0,0,0,0,30),(2031,2080002,1041069,114000,0,0,0,0,0,33),(2032,2080002,1041066,114000,0,0,0,0,0,31),(2033,2080002,1040079,180000,0,0,0,0,0,23),(2034,2080002,1040081,180000,0,0,0,0,0,24),(2035,2080002,1040076,114000,0,0,0,0,0,22),(2036,2080002,1040074,114000,0,0,0,0,0,21),(2037,2080002,1040073,114000,0,0,0,0,0,20),(2038,2080002,1040072,114000,0,0,0,0,0,19),(2039,2080002,1002137,100000,0,0,0,0,0,2),(2040,2080002,1002135,100000,0,0,0,0,0,1),(2041,2080002,1002139,100000,0,0,0,0,0,4),(2042,2080002,1002138,100000,0,0,0,0,0,3),(2043,2080002,1061047,120000,0,0,0,0,0,72),(2044,2080002,1061048,120000,0,0,0,0,0,73),(2045,2080002,1051027,450000,0,0,0,0,0,56),(2046,2080002,1051024,450000,0,0,0,0,0,54),(2047,2080002,1051025,450000,0,0,0,0,0,55),(2048,2080002,1051023,450000,0,0,0,0,0,53),(2049,2080002,1050037,450000,0,0,0,0,0,46),(2050,2080002,1050036,450000,0,0,0,0,0,45),(2051,2080002,1050038,450000,0,0,0,0,0,47),(2052,2080002,1050035,450000,0,0,0,0,0,44),(2053,2080002,1050002,300000,0,0,0,0,0,41),(2054,2080002,1050031,300000,0,0,0,0,0,43),(2055,2080002,1041051,120000,0,0,0,0,0,28),(2056,2080002,1041052,120000,0,0,0,0,0,29),(2057,2080002,1002144,96000,0,0,0,0,0,8),(2058,2080002,1002143,96000,0,0,0,0,0,7),(2059,2080002,1002142,96000,0,0,0,0,0,6),(2060,2080002,1002141,96000,0,0,0,0,0,5),(2061,2080002,1092002,200000,0,0,0,0,0,85),(2062,2080002,1092001,100000,0,0,0,0,0,84),(2063,2080002,1061084,180000,0,0,0,0,0,83),(2064,2080002,1061083,180000,0,0,0,0,0,82),(2065,2080002,1060074,180000,0,0,0,0,0,70),(2066,2080002,1060075,180000,0,0,0,0,0,71),(2067,2080002,1051014,112500,0,0,0,0,0,52),(2068,2080002,1051001,112500,0,0,0,0,0,48),(2069,2080002,1050021,112500,0,0,0,0,0,42),(2070,2080002,1050000,112500,0,0,0,0,0,40),(2071,2080002,1041085,200000,0,0,0,0,0,39),(2072,2080002,1041084,200000,0,0,0,0,0,38),(2073,2080002,1040085,200000,0,0,0,0,0,27),(2074,2080002,1040000,200000,0,0,0,0,0,15),(2075,2080002,1002004,160000,0,0,0,0,0,0),(2076,2080003,2044900,70000,0,0,0,0,0,24),(2077,2080003,2044800,70000,0,0,0,0,0,23),(2078,2080003,2044700,70000,0,0,0,0,0,22),(2079,2080003,2044600,70000,0,0,0,0,0,21),(2080,2080003,2044500,70000,0,0,0,0,0,20),(2081,2080003,2044400,70000,0,0,0,0,0,19),(2082,2080003,2044300,70000,0,0,0,0,0,18),(2083,2080003,2044200,70000,0,0,0,0,0,17),(2084,2080003,2044100,70000,0,0,0,0,0,16),(2085,2080003,2044000,70000,0,0,0,0,0,15),(2086,2080003,2043800,70000,0,0,0,0,0,14),(2087,2080003,2043700,70000,0,0,0,0,0,13),(2088,2080003,2043300,70000,0,0,0,0,0,12),(2089,2080003,2043200,70000,0,0,0,0,0,11),(2090,2080003,2043100,70000,0,0,0,0,0,10),(2091,2080003,2043000,70000,0,0,0,0,0,9),(2092,2080003,2040706,35000,0,0,0,0,0,5),(2093,2080003,2040703,35000,0,0,0,0,0,4),(2094,2080003,2041003,35000,0,0,0,0,0,8),(2095,2080003,2041000,35000,0,0,0,0,0,7),(2096,2080003,2040900,35000,0,0,0,0,0,6),(2097,2080003,2040600,35000,0,0,0,0,0,3),(2098,2080003,2040400,35000,0,0,0,0,0,2),(2099,2080003,2040300,35000,0,0,0,0,0,1),(2100,2080003,2040000,35000,0,0,0,0,0,0),(2101,2080004,4160019,1000,0,0,0,0,0,19),(2102,2080004,4160039,1000,0,0,0,0,0,30),(2103,2080004,4160037,1000,0,0,0,0,0,29),(2104,2080004,4031993,100000,0,0,0,0,0,2),(2105,2080004,4160036,1000,0,0,0,0,0,28),(2106,2080004,4160035,1000,0,0,0,0,0,27),(2107,2080004,4160034,1000,0,0,0,0,0,26),(2108,2080004,4160032,1000,0,0,0,0,0,25),(2109,2080004,4160024,1000,0,0,0,0,0,23),(2110,2080004,4160023,1000,0,0,0,0,0,22),(2111,2080004,4160022,1000,0,0,0,0,0,21),(2112,2080004,4160015,1000,0,0,0,0,0,17),(2113,2080004,4160012,1000,0,0,0,0,0,14),(2114,2080004,4160013,1000,0,0,0,0,0,15),(2115,2080004,4160017,1000,0,0,0,0,0,18),(2116,2080004,4160014,1000,0,0,0,0,0,16),(2117,2080004,4160020,1000,0,0,0,0,0,20),(2118,2080004,4160010,1000,0,0,0,0,0,13),(2119,2080004,4160009,1000,0,0,0,0,0,12),(2120,2080004,4160008,1000,0,0,0,0,0,11),(2121,2080004,4160007,1000,0,0,0,0,0,10),(2122,2080004,4160006,1000,0,0,0,0,0,9),(2123,2080004,4160005,1000,0,0,0,0,0,8),(2124,2080004,4160004,1000,0,0,0,0,0,7),(2125,2080004,4160003,1000,0,0,0,0,0,6),(2126,2080004,4160002,1000,0,0,0,0,0,5),(2127,2080004,4160001,1000,0,0,0,0,0,4),(2128,2080004,4160000,1000,0,0,0,0,0,3),(2129,2080004,4160026,1000,0,0,0,0,0,24),(2130,2080004,2260000,1000,0,0,0,0,0,1),(2131,2080004,2120000,30,0,0,0,0,0,0),(2132,2090001,1492006,160000,0,0,0,0,0,45),(2133,2090001,1492005,100000,0,0,0,0,0,44),(2134,2090001,1482006,150000,0,0,0,0,0,43),(2135,2090001,1482005,100000,0,0,0,0,0,42),(2136,2090001,1472007,60000,0,0,0,0,0,41),(2137,2090001,1472004,30000,0,0,0,0,0,40),(2138,2090001,1472001,20000,0,0,0,0,0,39),(2139,2090001,1462005,250000,0,0,0,0,0,38),(2140,2090001,1462004,200000,0,0,0,0,0,37),(2141,2090001,1462000,30000,0,0,0,0,0,36),(2142,2090001,1452007,375000,0,0,0,0,0,35),(2143,2090001,1452006,250000,0,0,0,0,0,34),(2144,2090001,1452005,150000,0,0,0,0,0,33),(2145,2090001,1442009,300000,0,0,0,0,0,32),(2146,2090001,1442003,175000,0,0,0,0,0,31),(2147,2090001,1442001,60000,0,0,0,0,0,30),(2148,2090001,1432005,225000,0,0,0,0,0,29),(2149,2090001,1432003,175000,0,0,0,0,0,28),(2150,2090001,1432002,60000,0,0,0,0,0,27),(2151,2090001,1422007,250000,0,0,0,0,0,25),(2152,2090001,1422008,200000,0,0,0,0,0,26),(2153,2090001,1422001,45000,0,0,0,0,0,24),(2154,2090001,1412005,250000,0,0,0,0,0,22),(2155,2090001,1412004,200000,0,0,0,0,0,21),(2156,2090001,1412006,45000,0,0,0,0,0,23),(2157,2090001,1402007,450000,0,0,0,0,0,20),(2158,2090001,1402006,350000,0,0,0,0,0,19),(2159,2090001,1402002,150000,0,0,0,0,0,18),(2160,2090001,1382002,20000,0,0,0,0,0,17),(2161,2090001,1372000,400000,0,0,0,0,0,14),(2162,2090001,1372001,175000,0,0,0,0,0,15),(2163,2090001,1372003,38000,0,0,0,0,0,16),(2164,2090001,1332011,425000,0,0,0,0,0,11),(2165,2090001,1332014,375000,0,0,0,0,0,13),(2166,2090001,1332001,200000,0,0,0,0,0,9),(2167,2090001,1332012,40000,0,0,0,0,0,12),(2168,2090001,1332009,42000,0,0,0,0,0,10),(2169,2090001,1322016,175000,0,0,0,0,0,8),(2170,2090001,1322015,100000,0,0,0,0,0,7),(2171,2090001,1322014,40000,0,0,0,0,0,6),(2172,2090001,1312007,175000,0,0,0,0,0,5),(2173,2090001,1312006,100000,0,0,0,0,0,4),(2174,2090001,1312005,40000,0,0,0,0,0,3),(2175,2090001,1302009,225000,0,0,0,0,0,2),(2176,2090001,1302004,100000,0,0,0,0,0,0),(2177,2090001,1302008,40000,0,0,0,0,0,1),(2178,2090002,1002625,75000,0,0,0,0,0,14),(2179,2090002,1052113,120000,0,0,0,0,0,58),(2180,2090002,1052110,100000,0,0,0,0,0,57),(2181,2090002,1061069,160000,0,0,0,0,0,78),(2182,2090002,1061070,160000,0,0,0,0,0,79),(2183,2090002,1060072,160000,0,0,0,0,0,69),(2184,2090002,1060071,160000,0,0,0,0,0,68),(2185,2090002,1060052,108000,0,0,0,0,0,61),(2186,2090002,1060050,108000,0,0,0,0,0,59),(2187,2090002,1060051,108000,0,0,0,0,0,60),(2188,2090002,1051009,111000,0,0,0,0,0,51),(2189,2090002,1051008,111000,0,0,0,0,0,50),(2190,2090002,1051007,111000,0,0,0,0,0,49),(2191,2090002,1041074,180000,0,0,0,0,0,34),(2192,2090002,1041075,180000,0,0,0,0,0,35),(2193,2090002,1040083,180000,0,0,0,0,0,26),(2194,2090002,1040082,180000,0,0,0,0,0,25),(2195,2090002,1040061,114000,0,0,0,0,0,16),(2196,2090002,1040062,114000,0,0,0,0,0,17),(2197,2090002,1040063,114000,0,0,0,0,0,18),(2198,2090002,1002180,100000,0,0,0,0,0,13),(2199,2090002,1002179,100000,0,0,0,0,0,12),(2200,2090002,1002178,100000,0,0,0,0,0,11),(2201,2090002,1002177,100000,0,0,0,0,0,10),(2202,2090002,1002176,100000,0,0,0,0,0,9),(2203,2090002,1061080,160000,0,0,0,0,0,80),(2204,2090002,1061081,160000,0,0,0,0,0,81),(2205,2090002,1061062,108000,0,0,0,0,0,76),(2206,2090002,1061060,108000,0,0,0,0,0,74),(2207,2090002,1061064,108000,0,0,0,0,0,77),(2208,2090002,1061061,108000,0,0,0,0,0,75),(2209,2090002,1060069,160000,0,0,0,0,0,66),(2210,2090002,1060070,160000,0,0,0,0,0,67),(2211,2090002,1060063,108000,0,0,0,0,0,64),(2212,2090002,1060061,108000,0,0,0,0,0,62),(2213,2090002,1060065,108000,0,0,0,0,0,65),(2214,2090002,1060062,108000,0,0,0,0,0,63),(2215,2090002,1041081,180000,0,0,0,0,0,36),(2216,2090002,1041082,180000,0,0,0,0,0,37),(2217,2090002,1041067,114000,0,0,0,0,0,32),(2218,2090002,1041065,114000,0,0,0,0,0,30),(2219,2090002,1041069,114000,0,0,0,0,0,33),(2220,2090002,1041066,114000,0,0,0,0,0,31),(2221,2090002,1040079,180000,0,0,0,0,0,23),(2222,2090002,1040081,180000,0,0,0,0,0,24),(2223,2090002,1040076,114000,0,0,0,0,0,22),(2224,2090002,1040074,114000,0,0,0,0,0,21),(2225,2090002,1040073,114000,0,0,0,0,0,20),(2226,2090002,1040072,114000,0,0,0,0,0,19),(2227,2090002,1002137,100000,0,0,0,0,0,2),(2228,2090002,1002135,100000,0,0,0,0,0,1),(2229,2090002,1002139,100000,0,0,0,0,0,4),(2230,2090002,1002138,100000,0,0,0,0,0,3),(2231,2090002,1061047,120000,0,0,0,0,0,72),(2232,2090002,1061048,120000,0,0,0,0,0,73),(2233,2090002,1051027,450000,0,0,0,0,0,56),(2234,2090002,1051024,450000,0,0,0,0,0,54),(2235,2090002,1051025,450000,0,0,0,0,0,55),(2236,2090002,1051023,450000,0,0,0,0,0,53),(2237,2090002,1050037,450000,0,0,0,0,0,46),(2238,2090002,1050036,450000,0,0,0,0,0,45),(2239,2090002,1050038,450000,0,0,0,0,0,47),(2240,2090002,1050035,450000,0,0,0,0,0,44),(2241,2090002,1050002,300000,0,0,0,0,0,41),(2242,2090002,1050031,300000,0,0,0,0,0,43),(2243,2090002,1041051,120000,0,0,0,0,0,28),(2244,2090002,1041052,120000,0,0,0,0,0,29),(2245,2090002,1002144,96000,0,0,0,0,0,8),(2246,2090002,1002143,96000,0,0,0,0,0,7),(2247,2090002,1002142,96000,0,0,0,0,0,6),(2248,2090002,1002141,96000,0,0,0,0,0,5),(2249,2090002,1092002,200000,0,0,0,0,0,85),(2250,2090002,1092001,100000,0,0,0,0,0,84),(2251,2090002,1061084,180000,0,0,0,0,0,83),(2252,2090002,1061083,180000,0,0,0,0,0,82),(2253,2090002,1060074,180000,0,0,0,0,0,70),(2254,2090002,1060075,180000,0,0,0,0,0,71),(2255,2090002,1051014,112500,0,0,0,0,0,52),(2256,2090002,1051001,112500,0,0,0,0,0,48),(2257,2090002,1050021,112500,0,0,0,0,0,42),(2258,2090002,1050000,112500,0,0,0,0,0,40),(2259,2090002,1041085,200000,0,0,0,0,0,39),(2260,2090002,1041084,200000,0,0,0,0,0,38),(2261,2090002,1040085,200000,0,0,0,0,0,27),(2262,2090002,1040000,200000,0,0,0,0,0,15),(2263,2090002,1002004,160000,0,0,0,0,0,0),(2264,2090003,2330000,600,0,0,0,0,0,31),(2265,2090003,2070000,500,0,0,0,0,0,30),(2268,2090003,2061000,1,0,0,0,0,0,29),(2269,2090003,2060000,1,0,0,0,0,0,28),(2270,2090003,2030000,400,0,0,0,0,0,24),(2271,2090003,2050002,300,0,0,0,0,0,27),(2272,2090003,2050001,200,0,0,0,0,0,26),(2273,2090003,2050000,200,0,0,0,0,0,25),(2274,2090003,2020015,10200,0,0,0,0,0,21),(2275,2090003,2020014,8100,0,0,0,0,0,20),(2276,2090003,2020013,5600,0,0,0,0,0,19),(2277,2090003,2020012,4500,0,0,0,0,0,18),(2278,2090003,2001002,4000,0,0,0,0,0,7),(2279,2090003,2001001,2300,0,0,0,0,0,6),(2280,2090003,2001000,3200,0,0,0,0,0,5),(2281,2090003,2022000,1650,0,0,0,0,0,22),(2282,2090003,2022003,1100,0,0,0,0,0,23),(2283,2090003,2010004,310,0,0,0,0,0,17),(2284,2090003,2010003,100,0,0,0,0,0,16),(2285,2090003,2010001,106,0,0,0,0,0,14),(2286,2090003,2010002,50,0,0,0,0,0,15),(2287,2090003,2010000,30,0,0,0,0,0,13),(2288,2090003,2002005,500,0,0,0,0,0,12),(2289,2090003,2002004,500,0,0,0,0,0,11),(2290,2090003,2002002,500,0,0,0,0,0,10),(2291,2090003,2002001,400,0,0,0,0,0,9),(2292,2090003,2002000,500,0,0,0,0,0,8),(2293,2090003,2000006,620,0,0,0,0,0,4),(2294,2090003,2000003,200,0,0,0,0,0,3),(2295,2090003,2000002,320,0,0,0,0,0,2),(2296,2090003,2000001,160,0,0,0,0,0,1),(2297,2090003,2000000,50,0,0,0,0,0,0),(2298,2090006,4160019,1000,0,0,0,0,0,19),(2299,2090006,4160039,1000,0,0,0,0,0,30),(2300,2090006,4160037,1000,0,0,0,0,0,29),(2301,2090006,4031993,100000,0,0,0,0,0,2),(2302,2090006,4160036,1000,0,0,0,0,0,28),(2303,2090006,4160035,1000,0,0,0,0,0,27),(2304,2090006,4160034,1000,0,0,0,0,0,26),(2305,2090006,4160032,1000,0,0,0,0,0,25),(2306,2090006,4160024,1000,0,0,0,0,0,23),(2307,2090006,4160023,1000,0,0,0,0,0,22),(2308,2090006,4160022,1000,0,0,0,0,0,21),(2309,2090006,4160015,1000,0,0,0,0,0,17),(2310,2090006,4160012,1000,0,0,0,0,0,14),(2311,2090006,4160013,1000,0,0,0,0,0,15),(2312,2090006,4160017,1000,0,0,0,0,0,18),(2313,2090006,4160014,1000,0,0,0,0,0,16),(2314,2090006,4160020,1000,0,0,0,0,0,20),(2315,2090006,4160010,1000,0,0,0,0,0,13),(2316,2090006,4160009,1000,0,0,0,0,0,12),(2317,2090006,4160008,1000,0,0,0,0,0,11),(2318,2090006,4160007,1000,0,0,0,0,0,10),(2319,2090006,4160006,1000,0,0,0,0,0,9),(2320,2090006,4160005,1000,0,0,0,0,0,8),(2321,2090006,4160004,1000,0,0,0,0,0,7),(2322,2090006,4160003,1000,0,0,0,0,0,6),(2323,2090006,4160002,1000,0,0,0,0,0,5),(2324,2090006,4160001,1000,0,0,0,0,0,4),(2325,2090006,4160000,1000,0,0,0,0,0,3),(2326,2090006,4160026,1000,0,0,0,0,0,24),(2327,2090006,2260000,1000,0,0,0,0,0,1),(2328,2090006,2120000,30,0,0,0,0,0,0),(2329,2093000,1492004,75000,0,0,0,0,0,16),(2330,2093000,1482004,75000,0,0,0,0,0,15),(2331,2093000,1472001,20000,0,0,0,0,0,14),(2332,2093000,1462000,30000,0,0,0,0,0,13),(2333,2093000,1452005,150000,0,0,0,0,0,12),(2334,2093000,1442001,60000,0,0,0,0,0,11),(2335,2093000,1432002,60000,0,0,0,0,0,10),(2336,2093000,1422001,45000,0,0,0,0,0,9),(2337,2093000,1412006,45000,0,0,0,0,0,8),(2338,2093000,1402002,150000,0,0,0,0,0,7),(2339,2093000,1382002,20000,0,0,0,0,0,6),(2340,2093000,1372003,38000,0,0,0,0,0,5),(2341,2093000,1332012,40000,0,0,0,0,0,4),(2342,2093000,1332009,42000,0,0,0,0,0,3),(2343,2093000,1322014,40000,0,0,0,0,0,2),(2344,2093000,1312005,40000,0,0,0,0,0,1),(2345,2093000,1302008,40000,0,0,0,0,0,0),(2346,2093001,1052107,90000,0,0,0,0,0,41),(2347,2093001,1002622,40000,0,0,0,0,0,12),(2348,2093001,1061046,40000,0,0,0,0,0,60),(2349,2093001,1061045,40000,0,0,0,0,0,59),(2350,2093001,1061044,40000,0,0,0,0,0,58),(2351,2093001,1061043,40000,0,0,0,0,0,57),(2352,2093001,1060046,40000,0,0,0,0,0,49),(2353,2093001,1060045,40000,0,0,0,0,0,48),(2354,2093001,1060044,40000,0,0,0,0,0,47),(2355,2093001,1060043,40000,0,0,0,0,0,46),(2356,2093001,1041050,45000,0,0,0,0,0,29),(2357,2093001,1041049,45000,0,0,0,0,0,28),(2358,2093001,1041048,45000,0,0,0,0,0,27),(2359,2093001,1041047,45000,0,0,0,0,0,26),(2360,2093001,1040060,45000,0,0,0,0,0,18),(2361,2093001,1040059,45000,0,0,0,0,0,17),(2362,2093001,1040058,45000,0,0,0,0,0,16),(2363,2093001,1040057,45000,0,0,0,0,0,15),(2364,2093001,1002175,30000,0,0,0,0,0,11),(2365,2093001,1002174,30000,0,0,0,0,0,10),(2366,2093001,1002173,30000,0,0,0,0,0,9),(2367,2093001,1002172,30000,0,0,0,0,0,8),(2368,2093001,1002171,30000,0,0,0,0,0,7),(2369,2093001,1061051,44000,0,0,0,0,0,62),(2370,2093001,1061050,44000,0,0,0,0,0,61),(2371,2093001,1061052,44000,0,0,0,0,0,63),(2372,2093001,1060057,44000,0,0,0,0,0,51),(2373,2093001,1060056,44000,0,0,0,0,0,50),(2374,2093001,1060058,44000,0,0,0,0,0,52),(2375,2093001,1060059,44000,0,0,0,0,0,53),(2376,2093001,1041055,50000,0,0,0,0,0,31),(2377,2093001,1041054,50000,0,0,0,0,0,30),(2378,2093001,1041056,50000,0,0,0,0,0,32),(2379,2093001,1040068,50000,0,0,0,0,0,20),(2380,2093001,1040067,50000,0,0,0,0,0,19),(2381,2093001,1040070,50000,0,0,0,0,0,22),(2382,2093001,1040069,50000,0,0,0,0,0,21),(2383,2093001,1002165,30000,0,0,0,0,0,6),(2384,2093001,1002164,30000,0,0,0,0,0,5),(2385,2093001,1002163,30000,0,0,0,0,0,4),(2386,2093001,1002162,30000,0,0,0,0,0,3),(2387,2093001,1002161,30000,0,0,0,0,0,2),(2388,2093001,1061036,40000,0,0,0,0,0,56),(2389,2093001,1061035,40000,0,0,0,0,0,55),(2390,2093001,1061034,40000,0,0,0,0,0,54),(2391,2093001,1050028,40000,0,0,0,0,0,36),(2392,2093001,1050027,40000,0,0,0,0,0,35),(2393,2093001,1050026,40000,0,0,0,0,0,34),(2394,2093001,1050003,40000,0,0,0,0,0,33),(2395,2093001,1041043,42000,0,0,0,0,0,25),(2396,2093001,1041042,42000,0,0,0,0,0,24),(2397,2093001,1041041,42000,0,0,0,0,0,23),(2398,2093001,1002064,40000,0,0,0,0,0,1),(2399,2093001,1092006,60000,0,0,0,0,0,64),(2400,2093001,1060019,38000,0,0,0,0,0,45),(2401,2093001,1060018,38000,0,0,0,0,0,44),(2402,2093001,1060017,38000,0,0,0,0,0,43),(2403,2093001,1060016,38000,0,0,0,0,0,42),(2404,2093001,1051013,60000,0,0,0,0,0,40),(2405,2093001,1051012,60000,0,0,0,0,0,39),(2406,2093001,1051011,60000,0,0,0,0,0,38),(2407,2093001,1051010,60000,0,0,0,0,0,37),(2408,2093001,1040026,40000,0,0,0,0,0,14),(2409,2093001,1040021,40000,0,0,0,0,0,13),(2410,2093001,1002023,120000,0,0,0,0,0,0),(2411,2093002,2330000,600,0,0,0,0,0,29),(2412,2093002,2070000,500,0,0,0,0,0,28),(2415,2093002,2061000,1,0,0,0,0,0,27),(2416,2093002,2060000,1,0,0,0,0,0,26),(2417,2093002,2030000,400,0,0,0,0,0,21),(2418,2093002,2050003,500,0,0,0,0,0,25),(2419,2093002,2050002,300,0,0,0,0,0,24),(2420,2093002,2050001,200,0,0,0,0,0,23),(2421,2093002,2050000,200,0,0,0,0,0,22),(2422,2093002,2020028,3000,0,0,0,0,0,18),(2423,2093002,2010004,310,0,0,0,0,0,17),(2424,2093002,2010003,100,0,0,0,0,0,16),(2425,2093002,2010001,106,0,0,0,0,0,14),(2426,2093002,2010002,50,0,0,0,0,0,15),(2427,2093002,2010000,30,0,0,0,0,0,13),(2428,2093002,2001002,4000,0,0,0,0,0,7),(2429,2093002,2001001,2300,0,0,0,0,0,6),(2430,2093002,2001000,3200,0,0,0,0,0,5),(2431,2093002,2022000,1650,0,0,0,0,0,19),(2432,2093002,2022003,1100,0,0,0,0,0,20),(2433,2093002,2002005,500,0,0,0,0,0,12),(2434,2093002,2002004,500,0,0,0,0,0,11),(2435,2093002,2002002,500,0,0,0,0,0,10),(2436,2093002,2002001,400,0,0,0,0,0,9),(2437,2093002,2002000,500,0,0,0,0,0,8),(2438,2093002,2000006,620,0,0,0,0,0,4),(2439,2093002,2000003,200,0,0,0,0,0,3),(2440,2093002,2000002,320,0,0,0,0,0,2),(2441,2093002,2000001,160,0,0,0,0,0,1),(2442,2093002,2000000,50,0,0,0,0,0,0),(2443,2100002,1492004,75000,0,0,0,0,0,16),(2444,2100002,1482004,75000,0,0,0,0,0,15),(2445,2100002,1472001,20000,0,0,0,0,0,14),(2446,2100002,1462000,30000,0,0,0,0,0,13),(2447,2100002,1452005,150000,0,0,0,0,0,12),(2448,2100002,1442001,60000,0,0,0,0,0,11),(2449,2100002,1432002,60000,0,0,0,0,0,10),(2450,2100002,1422001,45000,0,0,0,0,0,9),(2451,2100002,1412006,45000,0,0,0,0,0,8),(2452,2100002,1402002,150000,0,0,0,0,0,7),(2453,2100002,1382002,20000,0,0,0,0,0,6),(2454,2100002,1372003,38000,0,0,0,0,0,5),(2455,2100002,1332012,40000,0,0,0,0,0,4),(2456,2100002,1332009,42000,0,0,0,0,0,3),(2457,2100002,1322014,40000,0,0,0,0,0,2),(2458,2100002,1312005,40000,0,0,0,0,0,1),(2459,2100002,1302008,40000,0,0,0,0,0,0),(2460,2100003,1052107,90000,0,0,0,0,0,42),(2461,2100003,1002622,40000,0,0,0,0,0,13),(2462,2100003,1061046,40000,0,0,0,0,0,61),(2463,2100003,1061045,40000,0,0,0,0,0,60),(2464,2100003,1061044,40000,0,0,0,0,0,59),(2465,2100003,1061043,40000,0,0,0,0,0,58),(2466,2100003,1060046,40000,0,0,0,0,0,50),(2467,2100003,1060045,40000,0,0,0,0,0,49),(2468,2100003,1060044,40000,0,0,0,0,0,48),(2469,2100003,1060043,40000,0,0,0,0,0,47),(2470,2100003,1041050,45000,0,0,0,0,0,30),(2471,2100003,1041049,45000,0,0,0,0,0,29),(2472,2100003,1041048,45000,0,0,0,0,0,28),(2473,2100003,1041047,45000,0,0,0,0,0,27),(2474,2100003,1040060,45000,0,0,0,0,0,19),(2475,2100003,1040059,45000,0,0,0,0,0,18),(2476,2100003,1040058,45000,0,0,0,0,0,17),(2477,2100003,1040057,45000,0,0,0,0,0,16),(2478,2100003,1002175,30000,0,0,0,0,0,12),(2479,2100003,1002174,30000,0,0,0,0,0,11),(2480,2100003,1002173,30000,0,0,0,0,0,10),(2481,2100003,1002172,30000,0,0,0,0,0,9),(2482,2100003,1002171,30000,0,0,0,0,0,8),(2483,2100003,1061051,44000,0,0,0,0,0,63),(2484,2100003,1061050,44000,0,0,0,0,0,62),(2485,2100003,1061052,44000,0,0,0,0,0,64),(2486,2100003,1060057,44000,0,0,0,0,0,52),(2487,2100003,1060056,44000,0,0,0,0,0,51),(2488,2100003,1060058,44000,0,0,0,0,0,53),(2489,2100003,1060059,44000,0,0,0,0,0,54),(2490,2100003,1041055,50000,0,0,0,0,0,32),(2491,2100003,1041054,50000,0,0,0,0,0,31),(2492,2100003,1041056,50000,0,0,0,0,0,33),(2493,2100003,1040068,50000,0,0,0,0,0,21),(2494,2100003,1040067,50000,0,0,0,0,0,20),(2495,2100003,1040070,50000,0,0,0,0,0,23),(2496,2100003,1040069,50000,0,0,0,0,0,22),(2497,2100003,1002165,30000,0,0,0,0,0,7),(2498,2100003,1002164,30000,0,0,0,0,0,6),(2499,2100003,1002163,30000,0,0,0,0,0,5),(2500,2100003,1002162,30000,0,0,0,0,0,4),(2501,2100003,1002161,30000,0,0,0,0,0,3),(2502,2100003,1061036,40000,0,0,0,0,0,57),(2503,2100003,1061035,40000,0,0,0,0,0,56),(2504,2100003,1061034,40000,0,0,0,0,0,55),(2505,2100003,1050028,40000,0,0,0,0,0,37),(2506,2100003,1050027,40000,0,0,0,0,0,36),(2507,2100003,1050026,40000,0,0,0,0,0,35),(2508,2100003,1050003,40000,0,0,0,0,0,34),(2509,2100003,1041043,42000,0,0,0,0,0,26),(2510,2100003,1041042,42000,0,0,0,0,0,25),(2511,2100003,1041041,42000,0,0,0,0,0,24),(2512,2100003,1002064,40000,0,0,0,0,0,2),(2513,2100003,1092006,60000,0,0,0,0,0,65),(2514,2100003,1060019,38000,0,0,0,0,0,46),(2515,2100003,1060018,38000,0,0,0,0,0,45),(2516,2100003,1060017,38000,0,0,0,0,0,44),(2517,2100003,1060016,38000,0,0,0,0,0,43),(2518,2100003,1051013,60000,0,0,0,0,0,41),(2519,2100003,1051012,60000,0,0,0,0,0,40),(2520,2100003,1051011,60000,0,0,0,0,0,39),(2521,2100003,1051010,60000,0,0,0,0,0,38),(2522,2100003,1040026,40000,0,0,0,0,0,15),(2523,2100003,1040021,40000,0,0,0,0,0,14),(2524,2100003,1002023,120000,0,0,0,0,0,1),(2525,2100003,1002004,160000,0,0,0,0,0,0),(2526,2100004,2330000,600,0,0,0,0,0,30),(2527,2100004,2070000,500,0,0,0,0,0,28),(2528,2100004,2120000,30,0,0,0,0,0,29),(2531,2100004,2061000,1,0,0,0,0,0,27),(2532,2100004,2060000,1,0,0,0,0,0,26),(2533,2100004,2030000,400,0,0,0,0,0,21),(2534,2100004,2050003,500,0,0,0,0,0,25),(2535,2100004,2050002,300,0,0,0,0,0,24),(2536,2100004,2050001,200,0,0,0,0,0,23),(2537,2100004,2050000,200,0,0,0,0,0,22),(2538,2100004,2020028,3000,0,0,0,0,0,18),(2539,2100004,2010004,310,0,0,0,0,0,17),(2540,2100004,2010003,100,0,0,0,0,0,16),(2541,2100004,2010001,106,0,0,0,0,0,14),(2542,2100004,2010002,50,0,0,0,0,0,15),(2543,2100004,2010000,30,0,0,0,0,0,13),(2544,2100004,2001002,4000,0,0,0,0,0,7),(2545,2100004,2001001,2300,0,0,0,0,0,6),(2546,2100004,2001000,3200,0,0,0,0,0,5),(2547,2100004,2022000,1650,0,0,0,0,0,19),(2548,2100004,2022003,1100,0,0,0,0,0,20),(2549,2100004,2002005,500,0,0,0,0,0,12),(2550,2100004,2002004,500,0,0,0,0,0,11),(2551,2100004,2002002,500,0,0,0,0,0,10),(2552,2100004,2002001,400,0,0,0,0,0,9),(2553,2100004,2002000,500,0,0,0,0,0,8),(2554,2100004,2000006,620,0,0,0,0,0,4),(2555,2100004,2000003,200,0,0,0,0,0,3),(2556,2100004,2000002,320,0,0,0,0,0,2),(2557,2100004,2000001,160,0,0,0,0,0,1),(2558,2100004,2000000,50,0,0,0,0,0,0),(2559,2110001,2330000,600,0,0,0,0,0,30),(2560,2110001,2070000,500,0,0,0,0,0,28),(2561,2110001,2120000,30,0,0,0,0,0,29),(2564,2110001,2061000,1,0,0,0,0,0,27),(2565,2110001,2060000,1,0,0,0,0,0,26),(2566,2110001,2030000,400,0,0,0,0,0,21),(2567,2110001,2050003,500,0,0,0,0,0,25),(2568,2110001,2050002,300,0,0,0,0,0,24),(2569,2110001,2050001,200,0,0,0,0,0,23),(2570,2110001,2050000,200,0,0,0,0,0,22),(2571,2110001,2020028,3000,0,0,0,0,0,18),(2572,2110001,2010004,310,0,0,0,0,0,17),(2573,2110001,2010003,100,0,0,0,0,0,16),(2574,2110001,2010001,106,0,0,0,0,0,14),(2575,2110001,2010002,50,0,0,0,0,0,15),(2576,2110001,2010000,30,0,0,0,0,0,13),(2577,2110001,2001002,4000,0,0,0,0,0,7),(2578,2110001,2001001,2300,0,0,0,0,0,6),(2579,2110001,2001000,3200,0,0,0,0,0,5),(2580,2110001,2022000,1650,0,0,0,0,0,19),(2581,2110001,2022003,1100,0,0,0,0,0,20),(2582,2110001,2002005,500,0,0,0,0,0,12),(2583,2110001,2002004,500,0,0,0,0,0,11),(2584,2110001,2002002,500,0,0,0,0,0,10),(2585,2110001,2002001,400,0,0,0,0,0,9),(2586,2110001,2002000,500,0,0,0,0,0,8),(2587,2110001,2000006,620,0,0,0,0,0,4),(2588,2110001,2000003,200,0,0,0,0,0,3),(2589,2110001,2000002,320,0,0,0,0,0,2),(2590,2110001,2000001,160,0,0,0,0,0,1),(2591,2110001,2000000,50,0,0,0,0,0,0),(2592,2130000,2330000,600,0,0,0,0,0,31),(2593,2130000,2070000,500,0,0,0,0,0,30),(2596,2130000,2061000,1,0,0,0,0,0,29),(2597,2130000,2060000,1,0,0,0,0,0,28),(2598,2130000,2030000,400,0,0,0,0,0,24),(2599,2130000,2050002,300,0,0,0,0,0,27),(2600,2130000,2050001,200,0,0,0,0,0,26),(2601,2130000,2050000,200,0,0,0,0,0,25),(2602,2130000,2020015,10200,0,0,0,0,0,21),(2603,2130000,2020014,8100,0,0,0,0,0,20),(2604,2130000,2020013,5600,0,0,0,0,0,19),(2605,2130000,2020012,4500,0,0,0,0,0,18),(2606,2130000,2001002,4000,0,0,0,0,0,7),(2607,2130000,2001001,2300,0,0,0,0,0,6),(2608,2130000,2001000,3200,0,0,0,0,0,5),(2609,2130000,2022000,1650,0,0,0,0,0,22),(2610,2130000,2022003,1100,0,0,0,0,0,23),(2611,2130000,2010004,310,0,0,0,0,0,17),(2612,2130000,2010003,100,0,0,0,0,0,16),(2613,2130000,2010001,106,0,0,0,0,0,14),(2614,2130000,2010002,50,0,0,0,0,0,15),(2615,2130000,2010000,30,0,0,0,0,0,13),(2616,2130000,2002005,500,0,0,0,0,0,12),(2617,2130000,2002004,500,0,0,0,0,0,11),(2618,2130000,2002002,500,0,0,0,0,0,10),(2619,2130000,2002001,400,0,0,0,0,0,9),(2620,2130000,2002000,500,0,0,0,0,0,8),(2621,2130000,2000006,620,0,0,0,0,0,4),(2622,2130000,2000003,200,0,0,0,0,0,3),(2623,2130000,2000002,320,0,0,0,0,0,2),(2624,2130000,2000001,160,0,0,0,0,0,1),(2625,2130000,2000000,50,0,0,0,0,0,0),(2626,9110003,2022022,1300,0,0,0,0,0,1),(2627,9110003,2022021,550,0,0,0,0,0,0),(2628,9110004,2022023,1350,0,0,0,0,0,1),(2629,9110004,2022014,650,0,0,0,0,0,0),(2630,9110005,2022025,4200,0,0,0,0,0,1),(2631,9110005,2022024,2000,0,0,0,0,0,0),(2632,9110006,2022027,3800,0,0,0,0,0,1),(2633,9110006,2022026,1800,0,0,0,0,0,0),(2634,9110007,2022020,550,0,0,0,0,0,3),(2635,9110007,2022019,850,0,0,0,0,0,2),(2636,9110007,2022018,1600,0,0,0,0,0,1),(2637,9110007,2022017,1100,0,0,0,0,0,0),(2638,9120000,2070000,500,0,0,0,0,0,12),(2639,9120000,1472008,250000,0,0,0,0,0,11),(2640,9120000,1312013,100000,0,0,0,0,0,2),(2641,9120000,1322012,15000,0,0,0,0,0,3),(2642,9120000,1402009,30000,0,0,0,0,0,6),(2643,9120000,1432008,150000,0,0,0,0,0,8),(2644,9120000,1402010,150000,0,0,0,0,0,7),(2645,9120000,1462006,500000,0,0,0,0,0,10),(2646,9120000,1302021,1250000,0,0,0,0,0,0),(2647,9120000,1302022,80000,0,0,0,0,0,1),(2648,9120000,1332024,2000000,0,0,0,0,0,4),(2649,9120000,1382011,2000000,0,0,0,0,0,5),(2650,9120002,2070000,500,0,0,0,0,0,11),(2651,9120002,2020014,8100,0,0,0,0,0,7),(2652,9120002,2022002,1000,0,0,0,0,0,8),(2653,9120002,2001002,4000,0,0,0,0,0,5),(2654,9120002,2000006,620,0,0,0,0,0,3),(2655,9120002,2000003,200,0,0,0,0,0,2),(2656,9120002,2020012,4500,0,0,0,0,0,6),(2657,9120002,2001001,2300,0,0,0,0,0,4),(2658,9120002,2000002,320,0,0,0,0,0,1),(2659,9120002,2000001,160,0,0,0,0,0,0),(2660,9120002,2060003,40,0,0,0,0,0,9),(2661,9120004,2070000,500,0,0,0,0,0,4),(2662,9120004,2030010,500,0,0,0,0,0,3),(2663,9120004,2030009,500,0,0,0,0,0,2),(2664,9120004,2030008,400,0,0,0,0,0,1),(2665,9120004,1050100,30000,0,0,0,0,0,0),(2666,9120019,2070000,500,0,0,0,0,0,4),(2667,9120019,2030010,500,0,0,0,0,0,3),(2668,9120019,2030009,500,0,0,0,0,0,2),(2669,9120019,2030008,400,0,0,0,0,0,1),(2670,9120019,1051098,30000,0,0,0,0,0,0),(2671,9201020,1051153,100000,0,0,0,0,0,7),(2672,9201020,1051152,100000,0,0,0,0,0,6),(2673,9201020,1051151,100000,0,0,0,0,0,5),(2674,9201020,1051150,100000,0,0,0,0,0,4),(2675,9201020,1050134,100000,0,0,0,0,0,3),(2676,9201020,1050133,100000,0,0,0,0,0,2),(2677,9201020,1050132,100000,0,0,0,0,0,1),(2678,9201020,1050131,100000,0,0,0,0,0,0),(2679,9201058,1061046,42500,0,0,0,0,0,58),(2680,9201058,1061045,42500,0,0,0,0,0,57),(2681,9201058,1061044,42500,0,0,0,0,0,56),(2682,9201058,1061043,42500,0,0,0,0,0,55),(2683,9201058,1060046,42500,0,0,0,0,0,47),(2684,9201058,1060045,42500,0,0,0,0,0,46),(2685,9201058,1060044,42500,0,0,0,0,0,45),(2686,9201058,1060043,42500,0,0,0,0,0,44),(2687,9201058,1041050,47500,0,0,0,0,0,28),(2688,9201058,1041049,47500,0,0,0,0,0,27),(2689,9201058,1041048,47500,0,0,0,0,0,26),(2690,9201058,1041047,47500,0,0,0,0,0,25),(2691,9201058,1040060,47500,0,0,0,0,0,17),(2692,9201058,1040059,47500,0,0,0,0,0,16),(2693,9201058,1040058,47500,0,0,0,0,0,15),(2694,9201058,1040057,47500,0,0,0,0,0,14),(2695,9201058,1002175,32500,0,0,0,0,0,11),(2696,9201058,1002174,32500,0,0,0,0,0,10),(2697,9201058,1002173,32500,0,0,0,0,0,9),(2698,9201058,1002172,32500,0,0,0,0,0,8),(2699,9201058,1002171,32500,0,0,0,0,0,7),(2700,9201058,1061051,46500,0,0,0,0,0,60),(2701,9201058,1061050,46500,0,0,0,0,0,59),(2702,9201058,1061052,46500,0,0,0,0,0,61),(2703,9201058,1060057,46500,0,0,0,0,0,49),(2704,9201058,1060056,46500,0,0,0,0,0,48),(2705,9201058,1060058,46500,0,0,0,0,0,50),(2706,9201058,1060059,46500,0,0,0,0,0,51),(2707,9201058,1041055,52500,0,0,0,0,0,30),(2708,9201058,1041054,52500,0,0,0,0,0,29),(2709,9201058,1041056,52500,0,0,0,0,0,31),(2710,9201058,1040068,52500,0,0,0,0,0,19),(2711,9201058,1040067,52500,0,0,0,0,0,18),(2712,9201058,1040070,52500,0,0,0,0,0,21),(2713,9201058,1040069,52500,0,0,0,0,0,20),(2714,9201058,1002165,32500,0,0,0,0,0,6),(2715,9201058,1002164,32500,0,0,0,0,0,5),(2716,9201058,1002163,32500,0,0,0,0,0,4),(2717,9201058,1002162,32500,0,0,0,0,0,3),(2718,9201058,1002161,32500,0,0,0,0,0,2),(2719,9201058,1061036,42500,0,0,0,0,0,54),(2720,9201058,1061035,42500,0,0,0,0,0,53),(2721,9201058,1061034,42500,0,0,0,0,0,52),(2722,9201058,1050028,42500,0,0,0,0,0,35),(2723,9201058,1050027,42500,0,0,0,0,0,34),(2724,9201058,1050026,42500,0,0,0,0,0,33),(2725,9201058,1050003,42500,0,0,0,0,0,32),(2726,9201058,1041043,44500,0,0,0,0,0,24),(2727,9201058,1041042,44500,0,0,0,0,0,23),(2728,9201058,1041041,44500,0,0,0,0,0,22),(2729,9201058,1002064,42500,0,0,0,0,0,1),(2730,9201058,1092006,62500,0,0,0,0,0,62),(2731,9201058,1060019,40500,0,0,0,0,0,43),(2732,9201058,1060018,40500,0,0,0,0,0,42),(2733,9201058,1060017,40500,0,0,0,0,0,41),(2734,9201058,1060016,40500,0,0,0,0,0,40),(2735,9201058,1051013,62500,0,0,0,0,0,39),(2736,9201058,1051012,62500,0,0,0,0,0,38),(2737,9201058,1051011,62500,0,0,0,0,0,37),(2738,9201058,1051010,62500,0,0,0,0,0,36),(2739,9201058,1040026,42500,0,0,0,0,0,13),(2740,9201058,1040021,42500,0,0,0,0,0,12),(2741,9201058,1002023,122500,0,0,0,0,0,0),(2742,9201059,1472001,22500,0,0,0,0,0,15),(2743,9201059,1462000,32500,0,0,0,0,0,14),(2744,9201059,1452005,152500,0,0,0,0,0,13),(2745,9201059,1442001,62500,0,0,0,0,0,12),(2746,9201059,1432002,62500,0,0,0,0,0,11),(2747,9201059,1422001,47500,0,0,0,0,0,10),(2748,9201059,1412006,47500,0,0,0,0,0,9),(2749,9201059,1402002,152500,0,0,0,0,0,8),(2750,9201059,1382002,22500,0,0,0,0,0,7),(2751,9201059,1372003,40500,0,0,0,0,0,6),(2752,9201059,1332012,42500,0,0,0,0,0,5),(2753,9201059,1332009,44500,0,0,0,0,0,4),(2754,9201059,1322014,42500,0,0,0,0,0,3),(2755,9201059,1312005,42500,0,0,0,0,0,2),(2756,9201059,1302068,352500,0,0,0,0,0,1),(2757,9201059,1302008,42500,0,0,0,0,0,0),(2758,9201060,2010003,100,0,0,0,0,0,21),(2759,9201060,2061000,1,0,0,0,0,0,36),(2760,9201060,2060000,1,0,0,0,0,0,35),(2761,9201060,2030000,400,0,0,0,0,0,34),(2762,9201060,2022195,15000,0,0,0,0,0,33),(2763,9201060,2020015,10200,0,0,0,0,0,26),(2764,9201060,2020014,8100,0,0,0,0,0,25),(2765,9201060,2020013,5600,0,0,0,0,0,24),(2766,9201060,2020012,4500,0,0,0,0,0,23),(2767,9201060,2022190,3000,0,0,0,0,0,30),(2768,9201060,2001002,4000,0,0,0,0,0,7),(2769,9201060,2001001,2300,0,0,0,0,0,6),(2770,9201060,2001000,3200,0,0,0,0,0,5),(2771,9201060,2022000,1650,0,0,0,0,0,27),(2772,9201060,2022003,1100,0,0,0,0,0,28),(2773,9201060,2022192,600,0,0,0,0,0,32),(2774,9201060,2022191,1000,0,0,0,0,0,31),(2775,9201060,2022189,1000,0,0,0,0,0,29),(2776,9201060,2010004,310,0,0,0,0,0,22),(2777,9201060,2010001,106,0,0,0,0,0,19),(2778,9201060,2010002,50,0,0,0,0,0,20),(2779,9201060,2010000,30,0,0,0,0,0,18),(2780,9201060,2002025,1500,0,0,0,0,0,17),(2781,9201060,2002024,1500,0,0,0,0,0,16),(2782,9201060,2002023,3800,0,0,0,0,0,15),(2783,9201060,2002022,2100,0,0,0,0,0,14),(2784,9201060,2002021,2800,0,0,0,0,0,13),(2785,9201060,2002020,2800,0,0,0,0,0,12),(2786,9201060,2002019,5000,0,0,0,0,0,11),(2787,9201060,2002018,5000,0,0,0,0,0,10),(2788,9201060,2002017,5000,0,0,0,0,0,9),(2789,9201060,2002016,5000,0,0,0,0,0,8),(2790,9201060,2000006,620,0,0,0,0,0,4),(2791,9201060,2000003,200,0,0,0,0,0,3),(2792,9201060,2000002,320,0,0,0,0,0,2),(2793,9201060,2000001,160,0,0,0,0,0,1),(2794,9201060,2000000,50,0,0,0,0,0,0),(2795,9270019,1472007,60000,0,0,0,0,0,41),(2796,9270019,1472004,30000,0,0,0,0,0,40),(2797,9270019,1472001,20000,0,0,0,0,0,39),(2798,9270019,1462005,250000,0,0,0,0,0,38),(2799,9270019,1462004,200000,0,0,0,0,0,37),(2800,9270019,1462000,30000,0,0,0,0,0,36),(2801,9270019,1452007,375000,0,0,0,0,0,35),(2802,9270019,1452006,250000,0,0,0,0,0,34),(2803,9270019,1452005,150000,0,0,0,0,0,33),(2804,9270019,1442009,300000,0,0,0,0,0,32),(2805,9270019,1442003,175000,0,0,0,0,0,31),(2806,9270019,1442001,60000,0,0,0,0,0,30),(2807,9270019,1432005,225000,0,0,0,0,0,29),(2808,9270019,1432003,175000,0,0,0,0,0,28),(2809,9270019,1432002,60000,0,0,0,0,0,27),(2810,9270019,1422007,250000,0,0,0,0,0,25),(2811,9270019,1422008,200000,0,0,0,0,0,26),(2812,9270019,1422001,45000,0,0,0,0,0,24),(2813,9270019,1412005,250000,0,0,0,0,0,22),(2814,9270019,1412004,200000,0,0,0,0,0,21),(2815,9270019,1412006,45000,0,0,0,0,0,23),(2816,9270019,1402007,450000,0,0,0,0,0,20),(2817,9270019,1402006,350000,0,0,0,0,0,19),(2818,9270019,1402002,150000,0,0,0,0,0,18),(2819,9270019,1382002,20000,0,0,0,0,0,17),(2820,9270019,1372000,400000,0,0,0,0,0,14),(2821,9270019,1372001,175000,0,0,0,0,0,15),(2822,9270019,1372003,38000,0,0,0,0,0,16),(2823,9270019,1332011,425000,0,0,0,0,0,11),(2824,9270019,1332014,375000,0,0,0,0,0,13),(2825,9270019,1332001,200000,0,0,0,0,0,9),(2826,9270019,1332012,40000,0,0,0,0,0,12),(2827,9270019,1332009,42000,0,0,0,0,0,10),(2828,9270019,1322016,175000,0,0,0,0,0,8),(2829,9270019,1322015,100000,0,0,0,0,0,7),(2830,9270019,1322014,40000,0,0,0,0,0,6),(2831,9270019,1312007,175000,0,0,0,0,0,5),(2832,9270019,1312006,100000,0,0,0,0,0,4),(2833,9270019,1312005,40000,0,0,0,0,0,3),(2834,9270019,1302009,225000,0,0,0,0,0,2),(2835,9270019,1302004,100000,0,0,0,0,0,0),(2836,9270019,1302008,40000,0,0,0,0,0,1),(2837,9270020,1061069,160000,0,0,0,0,0,75),(2838,9270020,1061070,160000,0,0,0,0,0,76),(2839,9270020,1060072,160000,0,0,0,0,0,66),(2840,9270020,1060071,160000,0,0,0,0,0,65),(2841,9270020,1060052,108000,0,0,0,0,0,58),(2842,9270020,1060050,108000,0,0,0,0,0,56),(2843,9270020,1060051,108000,0,0,0,0,0,57),(2844,9270020,1051009,111000,0,0,0,0,0,50),(2845,9270020,1051008,111000,0,0,0,0,0,49),(2846,9270020,1051007,111000,0,0,0,0,0,48),(2847,9270020,1041074,180000,0,0,0,0,0,33),(2848,9270020,1041075,180000,0,0,0,0,0,34),(2849,9270020,1040083,180000,0,0,0,0,0,25),(2850,9270020,1040082,180000,0,0,0,0,0,24),(2851,9270020,1040061,114000,0,0,0,0,0,15),(2852,9270020,1040062,114000,0,0,0,0,0,16),(2853,9270020,1040063,114000,0,0,0,0,0,17),(2854,9270020,1002180,100000,0,0,0,0,0,13),(2855,9270020,1002179,100000,0,0,0,0,0,12),(2856,9270020,1002178,100000,0,0,0,0,0,11),(2857,9270020,1002177,100000,0,0,0,0,0,10),(2858,9270020,1002176,100000,0,0,0,0,0,9),(2859,9270020,1061080,160000,0,0,0,0,0,77),(2860,9270020,1061081,160000,0,0,0,0,0,78),(2861,9270020,1061062,108000,0,0,0,0,0,73),(2862,9270020,1061060,108000,0,0,0,0,0,71),(2863,9270020,1061064,108000,0,0,0,0,0,74),(2864,9270020,1061061,108000,0,0,0,0,0,72),(2865,9270020,1060069,160000,0,0,0,0,0,63),(2866,9270020,1060070,160000,0,0,0,0,0,64),(2867,9270020,1060063,108000,0,0,0,0,0,61),(2868,9270020,1060061,108000,0,0,0,0,0,59),(2869,9270020,1060065,108000,0,0,0,0,0,62),(2870,9270020,1060062,108000,0,0,0,0,0,60),(2871,9270020,1041081,180000,0,0,0,0,0,35),(2872,9270020,1041082,180000,0,0,0,0,0,36),(2873,9270020,1041067,114000,0,0,0,0,0,31),(2874,9270020,1041065,114000,0,0,0,0,0,29),(2875,9270020,1041069,114000,0,0,0,0,0,32),(2876,9270020,1041066,114000,0,0,0,0,0,30),(2877,9270020,1040079,180000,0,0,0,0,0,22),(2878,9270020,1040081,180000,0,0,0,0,0,23),(2879,9270020,1040076,114000,0,0,0,0,0,21),(2880,9270020,1040074,114000,0,0,0,0,0,20),(2881,9270020,1040073,114000,0,0,0,0,0,19),(2882,9270020,1040072,114000,0,0,0,0,0,18),(2883,9270020,1002137,100000,0,0,0,0,0,2),(2884,9270020,1002135,100000,0,0,0,0,0,1),(2885,9270020,1002139,100000,0,0,0,0,0,4),(2886,9270020,1002138,100000,0,0,0,0,0,3),(2887,9270020,1061047,120000,0,0,0,0,0,69),(2888,9270020,1061048,120000,0,0,0,0,0,70),(2889,9270020,1051027,450000,0,0,0,0,0,55),(2890,9270020,1051024,450000,0,0,0,0,0,53),(2891,9270020,1051025,450000,0,0,0,0,0,54),(2892,9270020,1051023,450000,0,0,0,0,0,52),(2893,9270020,1050037,450000,0,0,0,0,0,45),(2894,9270020,1050036,450000,0,0,0,0,0,44),(2895,9270020,1050038,450000,0,0,0,0,0,46),(2896,9270020,1050035,450000,0,0,0,0,0,43),(2897,9270020,1050002,300000,0,0,0,0,0,40),(2898,9270020,1050031,300000,0,0,0,0,0,42),(2899,9270020,1041051,120000,0,0,0,0,0,27),(2900,9270020,1041052,120000,0,0,0,0,0,28),(2901,9270020,1002144,96000,0,0,0,0,0,8),(2902,9270020,1002143,96000,0,0,0,0,0,7),(2903,9270020,1002142,96000,0,0,0,0,0,6),(2904,9270020,1002141,96000,0,0,0,0,0,5),(2905,9270020,1092002,200000,0,0,0,0,0,82),(2906,9270020,1092001,100000,0,0,0,0,0,81),(2907,9270020,1061084,180000,0,0,0,0,0,80),(2908,9270020,1061083,180000,0,0,0,0,0,79),(2909,9270020,1060074,180000,0,0,0,0,0,67),(2910,9270020,1060075,180000,0,0,0,0,0,68),(2911,9270020,1051014,112500,0,0,0,0,0,51),(2912,9270020,1051001,112500,0,0,0,0,0,47),(2913,9270020,1050021,112500,0,0,0,0,0,41),(2914,9270020,1050000,112500,0,0,0,0,0,39),(2915,9270020,1041085,200000,0,0,0,0,0,38),(2916,9270020,1041084,200000,0,0,0,0,0,37),(2917,9270020,1040085,200000,0,0,0,0,0,26),(2918,9270020,1040000,200000,0,0,0,0,0,14),(2919,9270020,1002004,160000,0,0,0,0,0,0),(2920,9270021,2070000,500,0,0,0,0,0,29),(2921,9270021,2022015,12000,0,0,0,0,0,21),(2922,9270021,2061000,1,0,0,0,0,0,28),(2923,9270021,2060000,1,0,0,0,0,0,27),(2924,9270021,2030000,400,0,0,0,0,0,22),(2925,9270021,2050003,500,0,0,0,0,0,26),(2926,9270021,2050002,300,0,0,0,0,0,25),(2927,9270021,2050001,200,0,0,0,0,0,24),(2928,9270021,2050000,200,0,0,0,0,0,23),(2929,9270021,2020028,3000,0,0,0,0,0,18),(2930,9270021,2010004,310,0,0,0,0,0,17),(2931,9270021,2010003,100,0,0,0,0,0,16),(2932,9270021,2010001,106,0,0,0,0,0,14),(2933,9270021,2010002,50,0,0,0,0,0,15),(2934,9270021,2010000,30,0,0,0,0,0,13),(2935,9270021,2001002,4000,0,0,0,0,0,7),(2936,9270021,2001001,2300,0,0,0,0,0,6),(2937,9270021,2001000,3200,0,0,0,0,0,5),(2938,9270021,2022000,1650,0,0,0,0,0,19),(2939,9270021,2022003,1100,0,0,0,0,0,20),(2940,9270021,2002005,500,0,0,0,0,0,12),(2941,9270021,2002004,500,0,0,0,0,0,11),(2942,9270021,2002002,500,0,0,0,0,0,10),(2943,9270021,2002001,400,0,0,0,0,0,9),(2944,9270021,2002000,500,0,0,0,0,0,8),(2945,9270021,2000006,620,0,0,0,0,0,4),(2946,9270021,2000003,200,0,0,0,0,0,3),(2947,9270021,2000002,320,0,0,0,0,0,2),(2948,9270021,2000001,160,0,0,0,0,0,1),(2949,9270021,2000000,50,0,0,0,0,0,0),(2950,9270022,2070000,500,0,0,0,0,0,28),(2951,9270022,2061000,1,0,0,0,0,0,27),(2952,9270022,2060000,1,0,0,0,0,0,26),(2953,9270022,2030000,400,0,0,0,0,0,21),(2954,9270022,2050003,500,0,0,0,0,0,25),(2955,9270022,2050002,300,0,0,0,0,0,24),(2956,9270022,2050001,200,0,0,0,0,0,23),(2957,9270022,2050000,200,0,0,0,0,0,22),(2958,9270022,2020028,3000,0,0,0,0,0,18),(2959,9270022,2010004,310,0,0,0,0,0,17),(2960,9270022,2010003,100,0,0,0,0,0,16),(2961,9270022,2010001,106,0,0,0,0,0,14),(2962,9270022,2010002,50,0,0,0,0,0,15),(2963,9270022,2010000,30,0,0,0,0,0,13),(2964,9270022,2001002,4000,0,0,0,0,0,7),(2965,9270022,2001001,2300,0,0,0,0,0,6),(2966,9270022,2001000,3200,0,0,0,0,0,5),(2967,9270022,2022000,1650,0,0,0,0,0,19),(2968,9270022,2022003,1100,0,0,0,0,0,20),(2969,9270022,2002005,500,0,0,0,0,0,12),(2970,9270022,2002004,500,0,0,0,0,0,11),(2971,9270022,2002002,500,0,0,0,0,0,10),(2972,9270022,2002001,400,0,0,0,0,0,9),(2973,9270022,2002000,500,0,0,0,0,0,8),(2974,9270022,2000006,620,0,0,0,0,0,4),(2975,9270022,2000003,200,0,0,0,0,0,3),(2976,9270022,2000002,320,0,0,0,0,0,2),(2977,9270022,2000001,160,0,0,0,0,0,1),(2978,9270022,2000000,50,0,0,0,0,0,0),(2979,9270027,2022215,6800,0,0,0,0,0,10),(2980,9270027,2022214,3200,0,0,0,0,0,9),(2981,9270027,2022211,6400,0,0,0,0,0,8),(2982,9270027,2022210,3200,0,0,0,0,0,7),(2983,9270027,2022209,1600,0,0,0,0,0,6),(2984,9270027,2022208,1000,0,0,0,0,0,5),(2985,9270027,2022207,2600,0,0,0,0,0,4),(2986,9270027,2022206,2200,0,0,0,0,0,3),(2987,9270027,2022205,1800,0,0,0,0,0,2),(2988,9270027,2022204,1200,0,0,0,0,0,1),(2989,9270027,2022203,800,0,0,0,0,0,0),(2990,9999992,1812006,1,0,0,0,0,0,57),(2991,9999992,1832000,1,0,0,0,0,0,59),(2992,9999992,1812005,1,0,0,0,0,0,56),(2993,9999992,1822000,1,0,0,0,0,0,58),(2994,9999992,1812004,1,0,0,0,0,0,55),(2995,9999992,1812003,1,0,0,0,0,0,54),(2996,9999992,1812002,1,0,0,0,0,0,53),(2997,9999992,1812001,1,0,0,0,0,0,52),(2998,9999992,1812000,1,0,0,0,0,0,51),(2999,9999992,1802100,1,0,0,0,0,0,50),(3000,9999992,1802055,1,0,0,0,0,0,49),(3001,9999992,1802053,1,0,0,0,0,0,48),(3002,9999992,1802052,1,0,0,0,0,0,47),(3003,9999992,1802051,1,0,0,0,0,0,46),(3004,9999992,1802050,1,0,0,0,0,0,45),(3005,9999992,1802049,1,0,0,0,0,0,44),(3006,9999992,1802048,1,0,0,0,0,0,43),(3007,9999992,1802047,1,0,0,0,0,0,42),(3008,9999992,1802045,1,0,0,0,0,0,41),(3009,9999992,1802044,1,0,0,0,0,0,40),(3010,9999992,1802042,1,0,0,0,0,0,39),(3011,9999992,1802038,1,0,0,0,0,0,38),(3012,9999992,1802037,1,0,0,0,0,0,37),(3013,9999992,1802036,1,0,0,0,0,0,36),(3014,9999992,1802035,1,0,0,0,0,0,35),(3015,9999992,1802034,1,0,0,0,0,0,34),(3016,9999992,1802033,1,0,0,0,0,0,33),(3017,9999992,1802032,1,0,0,0,0,0,32),(3018,9999992,1802031,1,0,0,0,0,0,31),(3019,9999992,1802030,1,0,0,0,0,0,30),(3020,9999992,1802029,1,0,0,0,0,0,29),(3021,9999992,1802028,1,0,0,0,0,0,28),(3022,9999992,1802027,1,0,0,0,0,0,27),(3023,9999992,1802026,1,0,0,0,0,0,26),(3024,9999992,1802025,1,0,0,0,0,0,25),(3025,9999992,1802024,1,0,0,0,0,0,24),(3026,9999992,1802023,1,0,0,0,0,0,23),(3027,9999992,1802022,1,0,0,0,0,0,22),(3028,9999992,1802021,1,0,0,0,0,0,21),(3029,9999992,1802020,1,0,0,0,0,0,20),(3030,9999992,1802019,1,0,0,0,0,0,19),(3031,9999992,1802018,1,0,0,0,0,0,18),(3032,9999992,1802017,1,0,0,0,0,0,17),(3033,9999992,1802016,1,0,0,0,0,0,16),(3034,9999992,1802015,1,0,0,0,0,0,15),(3035,9999992,1802014,1,0,0,0,0,0,14),(3036,9999992,1802013,1,0,0,0,0,0,13),(3037,9999992,1802012,1,0,0,0,0,0,12),(3038,9999992,1802011,1,0,0,0,0,0,11),(3039,9999992,1802010,1,0,0,0,0,0,10),(3040,9999992,1802009,1,0,0,0,0,0,9),(3041,9999992,1802008,1,0,0,0,0,0,8),(3042,9999992,1802007,1,0,0,0,0,0,7),(3043,9999992,1802006,1,0,0,0,0,0,6),(3044,9999992,1802005,1,0,0,0,0,0,5),(3045,9999992,1802004,1,0,0,0,0,0,4),(3046,9999992,1802003,1,0,0,0,0,0,3),(3047,9999992,1802002,1,0,0,0,0,0,2),(3048,9999992,1802001,1,0,0,0,0,0,1),(3049,9999992,1802000,1,0,0,0,0,0,0),(3050,9999992,5000045,1,0,0,0,0,0,88),(3051,9999992,5000044,1,0,0,0,0,0,87),(3052,9999992,5000041,1,0,0,0,0,0,86),(3053,9999992,5000039,1,0,0,0,0,0,85),(3054,9999992,5000037,1,0,0,0,0,0,84),(3055,9999992,5000036,1,0,0,0,0,0,83),(3056,9999992,5000034,1,0,0,0,0,0,82),(3057,9999992,5000025,1,0,0,0,0,0,81),(3058,9999992,5000024,1,0,0,0,0,0,80),(3059,9999992,5000023,1,0,0,0,0,0,79),(3060,9999992,5000022,1,0,0,0,0,0,78),(3061,9999992,5000020,1,0,0,0,0,0,77),(3062,9999992,5000017,1,0,0,0,0,0,76),(3063,9999992,5000015,1,0,0,0,0,0,75),(3064,9999992,5000014,1,0,0,0,0,0,74),(3065,9999992,5000013,1,0,0,0,0,0,73),(3066,9999992,5000012,1,0,0,0,0,0,72),(3067,9999992,5000011,1,0,0,0,0,0,71),(3068,9999992,5000010,1,0,0,0,0,0,70),(3069,9999992,5000009,1,0,0,0,0,0,69),(3070,9999992,5000008,1,0,0,0,0,0,68),(3071,9999992,5000007,1,0,0,0,0,0,67),(3072,9999992,5000006,1,0,0,0,0,0,66),(3073,9999992,5000005,1,0,0,0,0,0,65),(3074,9999992,5000004,1,0,0,0,0,0,64),(3075,9999992,5000003,1,0,0,0,0,0,63),(3076,9999992,5000002,1,0,0,0,0,0,62),(3077,9999992,5000001,1,0,0,0,0,0,61),(3078,9999992,5000000,1,0,0,0,0,0,60),(3079,9999993,5077000,1,0,0,0,0,0,6),(3080,9999993,5076000,1,0,0,0,0,0,5),(3081,9999993,5075000,1,0,0,0,0,0,2),(3082,9999993,5075001,1,0,0,0,0,0,3),(3083,9999993,5075002,1,0,0,0,0,0,4),(3084,9999993,5072000,1,0,0,0,0,0,1),(3085,9999993,5390000,1,0,0,0,0,0,7),(3086,9999993,5390001,1,0,0,0,0,0,8),(3087,9999993,5390002,1,0,0,0,0,0,9),(3088,9999993,5071000,1,0,0,0,0,0,0),(3089,9999994,3010041,1,0,0,0,0,0,27),(3090,9999994,3010040,1,0,0,0,0,0,26),(3091,9999994,3010028,1,0,0,0,0,0,25),(3092,9999994,3010026,1,0,0,0,0,0,24),(3093,9999994,3010025,1,0,0,0,0,0,23),(3094,9999994,3010024,1,0,0,0,0,0,22),(3095,9999994,3010023,1,0,0,0,0,0,21),(3096,9999994,3010022,1,0,0,0,0,0,20),(3097,9999994,3010019,1,0,0,0,0,0,19),(3098,9999994,3010018,1,0,0,0,0,0,18),(3099,9999994,3010017,1,0,0,0,0,0,17),(3100,9999994,3010016,1,0,0,0,0,0,16),(3101,9999994,3010015,1,0,0,0,0,0,15),(3102,9999994,3010014,1,0,0,0,0,0,14),(3103,9999994,3010013,1,0,0,0,0,0,13),(3104,9999994,3010012,1,0,0,0,0,0,12),(3105,9999994,3010011,1,0,0,0,0,0,11),(3106,9999994,3010010,1,0,0,0,0,0,10),(3107,9999994,3010009,1,0,0,0,0,0,9),(3108,9999994,3010008,1,0,0,0,0,0,8),(3109,9999994,3010007,1,0,0,0,0,0,7),(3110,9999994,3010006,1,0,0,0,0,0,6),(3111,9999994,3010005,1,0,0,0,0,0,5),(3112,9999994,3010004,1,0,0,0,0,0,4),(3113,9999994,3010003,1,0,0,0,0,0,3),(3114,9999994,3010002,1,0,0,0,0,0,2),(3115,9999994,3010001,1,0,0,0,0,0,1),(3116,9999994,3010000,1,0,0,0,0,0,0),(3117,9999995,1112230,1,0,0,0,0,0,51),(3118,9999995,1112229,1,0,0,0,0,0,50),(3119,9999995,1112228,1,0,0,0,0,0,49),(3120,9999995,1112227,1,0,0,0,0,0,48),(3121,9999995,1112226,1,0,0,0,0,0,47),(3122,9999995,1112225,1,0,0,0,0,0,46),(3123,9999995,1112224,1,0,0,0,0,0,45),(3124,9999995,1112223,1,0,0,0,0,0,44),(3125,9999995,1112222,1,0,0,0,0,0,43),(3126,9999995,1112221,1,0,0,0,0,0,42),(3127,9999995,1112220,1,0,0,0,0,0,41),(3128,9999995,1112219,1,0,0,0,0,0,40),(3129,9999995,1112218,1,0,0,0,0,0,39),(3130,9999995,1112217,1,0,0,0,0,0,38),(3131,9999995,1112216,1,0,0,0,0,0,37),(3132,9999995,1112215,1,0,0,0,0,0,36),(3133,9999995,1112214,1,0,0,0,0,0,35),(3134,9999995,1112213,1,0,0,0,0,0,34),(3135,9999995,1112212,1,0,0,0,0,0,33),(3136,9999995,1112211,1,0,0,0,0,0,32),(3137,9999995,1112210,1,0,0,0,0,0,31),(3138,9999995,1112209,1,0,0,0,0,0,30),(3139,9999995,1112208,1,0,0,0,0,0,29),(3140,9999995,1112207,1,0,0,0,0,0,28),(3141,9999995,1112206,1,0,0,0,0,0,27),(3142,9999995,1112205,1,0,0,0,0,0,26),(3143,9999995,1112204,1,0,0,0,0,0,25),(3144,9999995,1112203,1,0,0,0,0,0,24),(3145,9999995,1112202,1,0,0,0,0,0,23),(3146,9999995,1112201,1,0,0,0,0,0,22),(3147,9999995,1112200,1,0,0,0,0,0,21),(3148,9999995,1112120,1,0,0,0,0,0,20),(3149,9999995,1112119,1,0,0,0,0,0,19),(3150,9999995,1112118,1,0,0,0,0,0,18),(3151,9999995,1112117,1,0,0,0,0,0,17),(3152,9999995,1112116,1,0,0,0,0,0,16),(3153,9999995,1112115,1,0,0,0,0,0,15),(3154,9999995,1112114,1,0,0,0,0,0,14),(3155,9999995,1112113,1,0,0,0,0,0,13),(3156,9999995,1112112,1,0,0,0,0,0,12),(3157,9999995,1112111,1,0,0,0,0,0,11),(3158,9999995,1112110,1,0,0,0,0,0,10),(3159,9999995,1112109,1,0,0,0,0,0,9),(3160,9999995,1112108,1,0,0,0,0,0,8),(3161,9999995,1112107,1,0,0,0,0,0,7),(3162,9999995,1112106,1,0,0,0,0,0,6),(3163,9999995,1112105,1,0,0,0,0,0,5),(3164,9999995,1112104,1,0,0,0,0,0,4),(3165,9999995,1112103,1,0,0,0,0,0,3),(3166,9999995,1112102,1,0,0,0,0,0,2),(3167,9999995,1112101,1,0,0,0,0,0,1),(3168,9999995,1112100,1,0,0,0,0,0,0),(3169,9999996,1012010,1,0,0,0,0,0,4),(3170,9999996,1011002,1,0,0,0,0,0,0),(3171,9999996,1012000,1,0,0,0,0,0,2),(3172,9999996,1012024,1,0,0,0,0,0,5),(3173,9999996,1012074,1,0,0,0,0,0,11),(3174,9999996,1012083,1,0,0,0,0,0,12),(3175,9999996,1012055,1,0,0,0,0,0,10),(3176,9999996,1011003,1,0,0,0,0,0,1),(3177,9999996,1012028,1,0,0,0,0,0,7),(3178,9999996,1012006,1,0,0,0,0,0,3),(3179,9999996,1012027,1,0,0,0,0,0,6),(3180,9999996,1012032,1,0,0,0,0,0,9),(3181,9999996,1012031,1,0,0,0,0,0,8),(3182,9999996,1022007,1,0,0,0,0,0,20),(3183,9999996,1022006,1,0,0,0,0,0,19),(3184,9999996,1022044,1,0,0,0,0,0,24),(3185,9999996,1022033,1,0,0,0,0,0,23),(3186,9999996,1022019,1,0,0,0,0,0,21),(3187,9999996,1022020,1,0,0,0,0,0,22),(3188,9999996,1022005,1,0,0,0,0,0,18),(3189,9999996,1022004,1,0,0,0,0,0,17),(3190,9999996,1022003,1,0,0,0,0,0,16),(3191,9999996,1022002,1,0,0,0,0,0,15),(3192,9999996,1022001,1,0,0,0,0,0,14),(3193,9999996,1022000,1,0,0,0,0,0,13),(3194,9999996,5160014,1,0,0,0,0,0,38),(3195,9999996,5160013,1,0,0,0,0,0,37),(3196,9999996,5160012,1,0,0,0,0,0,36),(3197,9999996,5160011,1,0,0,0,0,0,35),(3198,9999996,5160009,1,0,0,0,0,0,34),(3199,9999996,5160008,1,0,0,0,0,0,33),(3200,9999996,5160007,1,0,0,0,0,0,32),(3201,9999996,5160006,1,0,0,0,0,0,31),(3202,9999996,5160005,1,0,0,0,0,0,30),(3203,9999996,5160004,1,0,0,0,0,0,29),(3204,9999996,5160003,1,0,0,0,0,0,28),(3205,9999996,5160002,1,0,0,0,0,0,27),(3206,9999996,5160001,1,0,0,0,0,0,26),(3207,9999996,5160000,1,0,0,0,0,0,25),(3208,9999997,1070002,1,0,0,0,0,0,23),(3209,9999997,1071008,1,0,0,0,0,0,24),(3210,9999997,1052049,1,0,0,0,0,0,18),(3211,9999997,1072234,1,0,0,0,0,0,28),(3212,9999997,1072325,1,0,0,0,0,0,35),(3213,9999997,1072326,1,0,0,0,0,0,36),(3214,9999997,1072235,1,0,0,0,0,0,29),(3215,9999997,1072189,1,0,0,0,0,0,27),(3216,9999997,1072257,1,0,0,0,0,0,30),(3217,9999997,1072186,1,0,0,0,0,0,26),(3218,9999997,1072258,1,0,0,0,0,0,31),(3219,9999997,1072260,1,0,0,0,0,0,32),(3220,9999997,1072279,1,0,0,0,0,0,34),(3221,9999997,1072276,1,0,0,0,0,0,33),(3222,9999997,1072153,1,0,0,0,0,0,25),(3223,9999997,1062003,1,0,0,0,0,0,19),(3224,9999997,1062018,1,0,0,0,0,0,20),(3225,9999997,1062040,1,0,0,0,0,0,22),(3226,9999997,1062032,1,0,0,0,0,0,21),(3227,9999997,1082102,1,0,0,0,0,0,37),(3228,9999997,1102156,1,0,0,0,0,0,39),(3229,9999997,1102039,1,0,0,0,0,0,38),(3230,9999997,1042013,1,0,0,0,0,0,12),(3231,9999997,1042018,1,0,0,0,0,0,13),(3232,9999997,1042012,1,0,0,0,0,0,11),(3233,9999997,1042036,1,0,0,0,0,0,14),(3234,9999997,1042037,1,0,0,0,0,0,15),(3235,9999997,1042099,1,0,0,0,0,0,17),(3236,9999997,1042043,1,0,0,0,0,0,16),(3237,9999997,1032054,1,0,0,0,0,0,10),(3238,9999997,1032053,1,0,0,0,0,0,9),(3239,9999997,1032052,1,0,0,0,0,0,8),(3240,9999997,1032024,1,0,0,0,0,0,7),(3241,9999997,1002294,1,0,0,0,0,0,2),(3242,9999997,1002342,1,0,0,0,0,0,3),(3243,9999997,1002485,1,0,0,0,0,0,5),(3244,9999997,1002343,1,0,0,0,0,0,4),(3245,9999997,1002667,1,0,0,0,0,0,6),(3246,9999997,1002234,1,0,0,0,0,0,1),(3247,9999997,1002186,1,0,0,0,0,0,0),(3248,9999997,1702136,1,0,0,0,0,0,44),(3249,9999997,1702121,1,0,0,0,0,0,43),(3250,9999997,1702179,1,0,0,0,0,0,45),(3251,9999997,1702187,1,0,0,0,0,0,50),(3252,9999997,1702185,1,0,0,0,0,0,49),(3253,9999997,1702184,1,0,0,0,0,0,48),(3254,9999997,1702183,1,0,0,0,0,0,47),(3255,9999997,1702180,1,0,0,0,0,0,46),(3256,9999997,1702120,1,0,0,0,0,0,42),(3257,9999997,1702119,1,0,0,0,0,0,41),(3258,9999997,1702118,1,0,0,0,0,0,40),(3259,9999998,2040026,1,0,0,0,0,0,1),(3260,9999998,2040016,1,0,0,0,0,0,0),(3261,9999998,2040031,1,0,0,0,0,0,2),(3262,9999998,2040920,1,0,0,0,0,0,15),(3263,9999998,2040915,1,0,0,0,0,0,14),(3264,9999998,2041057,1,0,0,0,0,0,19),(3265,9999998,2041053,1,0,0,0,0,0,17),(3266,9999998,2041055,1,0,0,0,0,0,18),(3267,9999998,2041051,1,0,0,0,0,0,16),(3268,9999998,2040529,1,0,0,0,0,0,8),(3269,9999998,2040527,1,0,0,0,0,0,7),(3270,9999998,2040506,1,0,0,0,0,0,6),(3271,9999998,2040534,1,0,0,0,0,0,9),(3272,9999998,2040710,1,0,0,0,0,0,11),(3273,9999998,2040709,1,0,0,0,0,0,10),(3274,9999998,2040806,1,0,0,0,0,0,12),(3275,9999998,2040323,1,0,0,0,0,0,5),(3276,9999998,2040303,1,0,0,0,0,0,3),(3277,9999998,2040318,1,0,0,0,0,0,4),(3278,9999998,2044902,1,0,0,0,0,0,36),(3279,9999998,2044802,1,0,0,0,0,0,35),(3280,9999998,2043703,1,0,0,0,0,0,25),(3281,9999998,2044203,1,0,0,0,0,0,29),(3282,9999998,2044103,1,0,0,0,0,0,28),(3283,9999998,2044003,1,0,0,0,0,0,27),(3284,9999998,2043803,1,0,0,0,0,0,26),(3285,9999998,2044303,1,0,0,0,0,0,30),(3286,9999998,2044403,1,0,0,0,0,0,31),(3287,9999998,2043203,1,0,0,0,0,0,23),(3288,9999998,2043103,1,0,0,0,0,0,22),(3289,9999998,2043003,1,0,0,0,0,0,21),(3290,9999998,2040807,1,0,0,0,0,0,13),(3291,9999998,2043303,1,0,0,0,0,0,24),(3292,9999998,2044603,1,0,0,0,0,0,33),(3293,9999998,2044703,1,0,0,0,0,0,34),(3294,9999998,2044503,1,0,0,0,0,0,32),(3295,9999998,2041200,1,0,0,0,0,0,20),(3296,9999998,2049100,1,0,0,0,0,0,38),(3297,9999998,2049002,1,0,0,0,0,0,37),(3298,9999998,2340000,1,0,0,0,0,0,39),(3299,9999999,1082150,1,0,0,0,0,0,26),(3300,9999999,1082148,1,0,0,0,0,0,24),(3301,9999999,1082147,1,0,0,0,0,0,23),(3302,9999999,1082146,1,0,0,0,0,0,22),(3303,9999999,1082145,1,0,0,0,0,0,21),(3304,9999999,1102103,1,0,0,0,0,0,34),(3305,9999999,1102102,1,0,0,0,0,0,33),(3306,9999999,1102101,1,0,0,0,0,0,32),(3307,9999999,1102106,1,0,0,0,0,0,37),(3308,9999999,1102105,1,0,0,0,0,0,36),(3309,9999999,1102104,1,0,0,0,0,0,35),(3310,9999999,1092022,1,0,0,0,0,0,28),(3311,9999999,1032032,1,0,0,0,0,0,8),(3312,9999999,1032031,1,0,0,0,0,0,7),(3313,9999999,1032030,1,0,0,0,0,0,6),(3314,9999999,1032028,1,0,0,0,0,0,5),(3315,9999999,1032027,1,0,0,0,0,0,4),(3316,9999999,1032026,1,0,0,0,0,0,3),(3317,9999999,1032048,1,0,0,0,0,0,9),(3318,9999999,1102042,1,0,0,0,0,0,31),(3319,9999999,1102041,1,0,0,0,0,0,30),(3320,9999999,1122001,1,0,0,0,0,0,39),(3321,9999999,1122000,1,0,0,0,0,0,38),(3322,9999999,1072344,1,0,0,0,0,0,20),(3323,9999999,1072239,1,0,0,0,0,0,19),(3324,9999999,1051140,1,0,0,0,0,0,16),(3325,9999999,1050127,1,0,0,0,0,0,13),(3326,9999999,1050100,1,0,0,0,0,0,12),(3327,9999999,1051098,1,0,0,0,0,0,15),(3328,9999999,1050018,1,0,0,0,0,0,11),(3329,9999999,1051017,1,0,0,0,0,0,14),(3330,9999999,1082149,1,0,0,0,0,0,25),(3331,9999999,1082223,1,0,0,0,0,0,27),(3332,9999999,1002518,1,0,0,0,0,0,2),(3333,9999999,1002357,1,0,0,0,0,0,1),(3334,9999999,1492013,1,0,0,0,0,0,55),(3335,9999999,1482023,1,0,0,0,0,0,54),(3336,9999999,1412033,1,0,0,0,0,0,47),(3337,9999999,1422037,1,0,0,0,0,0,48),(3338,9999999,1302081,1,0,0,0,0,0,40),(3339,9999999,1402046,1,0,0,0,0,0,46),(3340,9999999,1372040,1,0,0,0,0,0,44),(3341,9999999,1382050,1,0,0,0,0,0,45),(3342,9999999,1432038,1,0,0,0,0,0,49),(3343,9999999,1442045,1,0,0,0,0,0,50),(3344,9999999,1462039,1,0,0,0,0,0,52),(3345,9999999,1092049,1,0,0,0,0,0,29),(3346,9999999,1332050,1,0,0,0,0,0,43),(3347,9999999,1332049,1,0,0,0,0,0,42),(3348,9999999,1452044,1,0,0,0,0,0,51),(3349,9999999,1472052,1,0,0,0,0,0,53),(3350,9999999,2330005,1,0,0,0,0,0,65),(3351,9999999,2070018,1,0,0,0,0,0,64),(3352,9999999,4006001,1,0,0,0,0,0,67),(3353,9999999,4006000,1,0,0,0,0,0,66),(3354,9999999,1902002,1,0,0,0,0,0,58),(3355,9999999,1902001,1,0,0,0,0,0,57),(3356,9999999,1902000,1,0,0,0,0,0,56),(3357,9999999,1912000,1,0,0,0,0,0,59),(3358,9999999,2022283,1,0,0,0,0,0,63),(3359,9999999,2022282,1,0,0,0,0,0,62),(3360,9999999,2022273,1,0,0,0,0,0,61),(3361,9999999,2022179,1,0,0,0,0,0,60),(3362,9999999,1322013,1,0,0,0,0,0,41),(3363,9999999,1072200,1,0,0,0,0,0,18),(3364,9999999,1062007,1,0,0,0,0,0,17),(3365,9999999,1042003,1,0,0,0,0,0,10),(3366,9999999,1002140,1,0,0,0,0,0,0),(6479,1337,1002140,1,0,0,0,0,0,0),(6480,1337,1042003,1,0,0,0,0,0,1),(6481,1337,1062007,1,0,0,0,0,0,2),(6482,1337,1322013,1,0,0,0,0,0,8),(6483,1337,1072010,1,0,0,0,0,0,3),(6484,1337,2022179,1,0,0,0,0,0,27),(6485,1337,2022273,1,0,0,0,0,0,28),(6486,1337,5072000,1,0,0,0,0,0,54),(6487,1337,5390000,1,0,0,0,0,0,55),(6488,1337,5390001,1,0,0,0,0,0,56),(6489,1337,5390001,1,0,0,0,0,0,57),(6490,1337,1452044,1,0,0,0,0,0,18),(6491,1337,1472052,1,0,0,0,0,0,20),(6492,1337,1462039,1,0,0,0,0,0,19),(6493,1337,1332050,1,0,0,0,0,0,10),(6494,1337,1312031,1,0,0,0,0,0,7),(6495,1337,1322052,1,0,0,0,0,0,9),(6496,1337,1302059,1,0,0,0,0,0,6),(6497,1337,1442045,1,0,0,0,0,0,17),(6498,1337,1432038,1,0,0,0,0,0,16),(6499,1337,1382036,1,0,0,0,0,0,11),(6500,1337,1412026,1,0,0,0,0,0,14),(6501,1337,1422028,1,0,0,0,0,0,15),(6502,1337,1402036,1,0,0,0,0,0,12),(6503,1337,1122000,1,0,0,0,0,0,5),(6504,1337,2041200,1,0,0,0,0,0,35),(6505,1337,4006001,1,0,0,0,0,0,52),(6506,1337,4001017,1,0,0,0,0,0,51),(6507,1337,4031179,1,0,0,0,0,0,53),(6508,1337,1912000,1,0,0,0,0,0,25),(6509,1337,1902000,1,0,0,0,0,0,21),(6510,1337,1902001,1,0,0,0,0,0,22),(6511,1337,1902002,1,0,0,0,0,0,23),(6512,1337,2044503,1,0,0,0,0,0,47),(6513,1337,2044703,1,0,0,0,0,0,49),(6514,1337,2044603,1,0,0,0,0,0,48),(6515,1337,2043303,1,0,0,0,0,0,39),(6516,1337,2043103,1,0,0,0,0,0,37),(6517,1337,2043203,1,0,0,0,0,0,38),(6518,1337,2043003,1,0,0,0,0,0,36),(6519,1337,2044403,1,0,0,0,0,0,46),(6520,1337,2044303,1,0,0,0,0,0,45),(6521,1337,2043803,1,0,0,0,0,0,41),(6522,1337,2044103,1,0,0,0,0,0,43),(6523,1337,2044203,1,0,0,0,0,0,44),(6524,1337,2044003,1,0,0,0,0,0,42),(6525,1337,2043703,1,0,0,0,0,0,40),(6526,1337,2040807,1,0,0,0,0,0,34),(6527,1337,2040806,1,0,0,0,0,0,33),(6528,1337,2040007,1,0,0,0,0,0,29),(6529,1337,2040506,1,0,0,0,0,0,30),(6530,1337,2040710,1,0,0,0,0,0,31),(6531,1337,2040711,1,0,0,0,0,0,32),(6532,1337,2340000,1,0,0,0,0,0,50),(20020,1337,1082149,1,0,0,0,0,0,4),(20097,1339,2002023,3700,0,0,0,0,0,4),(20130,1301000,2000003,200,0,0,0,0,0,4),(20095,9120002,2061003,40,0,0,0,0,0,10),(20129,1301000,2000002,320,0,0,0,0,0,3),(20128,1301000,2000001,160,0,0,0,0,0,2),(20127,1301000,2000000,50,0,0,0,0,0,1),(20098,1339,2002025,1500,0,0,0,0,0,6),(20022,1338,2061000,1,0,0,0,0,0,23),(20023,1338,2060000,1,0,0,0,0,0,22),(20024,1338,2030000,400,0,0,0,0,0,21),(20025,1338,2022195,15000,0,0,0,0,0,20),(20026,1338,2020015,10200,0,0,0,0,0,13),(20027,1338,2020014,8100,0,0,0,0,0,12),(20028,1338,2020013,5600,0,0,0,0,0,11),(20029,1338,2020012,4500,0,0,0,0,0,10),(20030,1338,2022190,3000,0,0,0,0,0,17),(20031,1338,2001002,4000,0,0,0,0,0,2),(20032,1338,2001001,2300,0,0,0,0,0,1),(20033,1338,2001000,3200,0,0,0,0,0,0),(20034,1338,2022000,1650,0,0,0,0,0,14),(20035,1338,2022003,1100,0,0,0,0,0,15),(20036,1338,2022192,600,0,0,0,0,0,19),(20037,1338,2022191,1000,0,0,0,0,0,18),(20038,1338,2022189,1000,0,0,0,0,0,16),(20039,1338,2010004,310,0,0,0,0,0,9),(20040,1338,2010001,106,0,0,0,0,0,7),(20041,1338,2010002,50,0,0,0,0,0,8),(20042,1338,2010000,30,0,0,0,0,0,6),(20043,1338,2002025,1500,0,0,0,0,0,5),(20044,1338,2002024,1500,0,0,0,0,0,4),(20045,1338,2002023,3800,0,0,0,0,0,3),(20046,1339,5041000,1500000,0,0,0,0,0,13),(20047,1200002,2330000,600,0,0,0,0,0,22),(20048,1200002,2070000,500,0,0,0,0,0,21),(20049,1200002,2050002,300,0,0,0,0,0,18),(20050,1200002,2050001,200,0,0,0,0,0,17),(20051,1200002,2050000,200,0,0,0,0,0,16),(20052,1200002,2061000,1,0,0,0,0,0,20),(20053,1200002,2060000,1,0,0,0,0,0,19),(20055,1200002,2030000,400,0,0,0,0,0,15),(20056,1200002,2010004,310,0,0,0,0,0,14),(20057,1200002,2010003,100,0,0,0,0,0,13),(20058,1200002,2010001,106,0,0,0,0,0,11),(20059,1200002,2010002,50,0,0,0,0,0,12),(20060,1200002,2010000,30,0,0,0,0,0,10),(20061,1200002,2002005,500,0,0,0,0,0,9),(20062,1200002,2002004,500,0,0,0,0,0,8),(20063,1200002,2002002,500,0,0,0,0,0,7),(20064,1200002,2002001,400,0,0,0,0,0,6),(20065,1200002,2002000,500,0,0,0,0,0,5),(20066,1200002,2000006,620,0,0,0,0,0,4),(20067,1200002,2000003,200,0,0,0,0,0,3),(20068,1200002,2000002,320,0,0,0,0,0,2),(20069,1200002,2000001,160,0,0,0,0,0,1),(20070,1200002,2000000,50,0,0,0,0,0,0),(20071,1200001,1442000,3000,0,0,0,0,0,13),(20072,1200001,1442006,8000,0,0,0,0,0,15),(20073,1200001,1442007,12000,0,0,0,0,0,16),(20074,1200001,1442004,24000,0,0,0,0,0,14),(20075,1200001,1040002,50,0,0,0,0,0,0),(20076,1200001,1040006,50,0,0,0,0,0,1),(20077,1200001,1040010,50,0,0,0,0,0,2),(20078,1200001,1041002,50,0,0,0,0,0,3),(20079,1200001,1041006,50,0,0,0,0,0,4),(20080,1200001,1041010,50,0,0,0,0,0,5),(20081,1200001,1041011,50,0,0,0,0,0,6),(20082,1200001,1060002,50,0,0,0,0,0,7),(20083,1200001,1060006,50,0,0,0,0,0,8),(20084,1200001,1061002,50,0,0,0,0,0,9),(20085,1200001,1061008,50,0,0,0,0,0,10),(20086,1200001,1072001,50,0,0,0,0,0,11),(20087,1200001,1072005,50,0,0,0,0,0,12),(20088,9120000,1452018,3000000,0,0,0,0,0,9),(20099,1339,2002024,1500,0,0,0,0,0,5),(20100,1339,2000002,300,0,0,0,0,0,0),(20101,0,2000003,200,0,0,0,0,0,199),(20112,1339,2020015,10000,0,0,0,0,0,10),(20103,1339,2000003,200,0,0,0,0,0,1),(20113,1339,2020014,4000,0,0,0,0,0,9),(20114,1339,2020013,5000,0,0,0,0,0,8),(20115,1339,2020012,4000,0,0,0,0,0,7),(20117,1339,2001001,2000,0,0,0,0,0,2),(20116,1339,2001002,2000,0,0,0,0,0,3),(20118,1339,2022000,1600,0,0,0,0,0,11),(20119,1339,2022003,1000,0,0,0,0,0,12),(20120,1337,1402257,1,0,0,0,0,0,13),(20121,1337,1902042,1,0,0,0,0,0,24),(20122,1337,1912009,1,0,0,0,0,0,26),(20123,1011100,2460000,1000,0,0,0,0,0,25),(20124,1011100,2460001,10000,0,0,0,0,0,26),(20125,1011100,2460002,30000,0,0,0,0,0,27),(20126,1011100,2460003,50000,0,0,0,0,0,28),(20131,1301000,2000006,620,0,0,0,0,0,5),(20132,1301000,2002000,500,0,0,0,0,0,6),(20133,1301000,2002001,400,0,0,0,0,0,7),(20134,1301000,2002002,500,0,0,0,0,0,8),(20135,1301000,2002004,500,0,0,0,0,0,9),(20136,1301000,2022003,1100,0,0,0,0,0,10),(20137,1301000,2022000,1650,0,0,0,0,0,11),(20138,1301000,2030000,400,0,0,0,0,0,12),(20139,1301000,2060000,1,0,0,0,0,0,13),(20140,1301000,2061000,1,0,0,0,0,0,14),(20141,1301000,2070000,500,0,0,0,0,0,15),(20142,1301000,2330000,600,0,0,0,0,0,16),(20143,2041002,1342002,350000,0,0,0,0,0,86),(20144,1051000,1342000,10000,0,0,0,0,0,88),(20145,1051000,1342001,30000,0,0,0,0,0,89);
/*!40000 ALTER TABLE `shopitems` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `shops`
--

DROP TABLE IF EXISTS `shops`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `shops` (
  `shopid` int(10) unsigned NOT NULL,
  `npcid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`shopid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `shops`
--

LOCK TABLES `shops` WRITE;
/*!40000 ALTER TABLE `shops` DISABLE KEYS */;
INSERT INTO `shops` VALUES (11000,11000),(11100,11100),(21000,21000),(1001000,1001000),(1001001,1001001),(1001100,1001100),(1011000,1011000),(1011001,1011001),(1011100,1011100),(1012004,1012004),(1021000,1021000),(1021001,1021001),(1021100,1021100),(1031000,1031000),(1031001,1031001),(1031100,1031100),(1032103,1032103),(1051000,1051000),(1051001,1051001),(1051002,1051002),(1052104,1052104),(1061001,1061001),(1061002,1061002),(1081000,1081000),(1091000,1091000),(1091001,1091001),(1091002,1091002),(1093000,1093000),(1100001,1100001),(1100002,1100002),(2010004,2010004),(2012003,2012003),(2012004,2012004),(2012005,2012005),(2020001,2020001),(2022000,2022000),(2022001,2022001),(2022002,2022002),(2030009,2030009),(2040049,2040049),(2040051,2040051),(2041002,2041002),(2041003,2041003),(2041006,2041006),(2041014,2041014),(2041016,2041016),(2050000,2050000),(2050003,2050003),(2051000,2051000),(2060003,2060003),(2060004,2060004),(2060007,2060007),(2070001,2070001),(2070002,2070002),(2070003,2070003),(2080001,2080001),(2080002,2080002),(2080003,2080003),(2080004,2080004),(2090001,2090001),(2090002,2090002),(2090003,2090003),(2090006,2090006),(2093000,2093000),(2093001,2093001),(2093002,2093002),(2100002,2100002),(2100003,2100003),(2100004,2100004),(2110001,2110001),(2130000,2130000),(9110003,9110003),(9110004,9110004),(9110005,9110005),(9110006,9110006),(9110007,9110007),(9120000,9120000),(9120002,9120002),(9120004,9120004),(9120019,9120019),(9201020,9201020),(9201058,9201058),(9201059,9201059),(9201060,9201060),(9270019,9270019),(9270020,9270020),(9270021,9270021),(9270022,9270022),(9270027,9270027),(9999992,9001002),(9999993,9001002),(9999994,9001002),(9999995,9001002),(9999996,9001002),(9999997,9001002),(9999998,9001002),(9999999,9001002),(1337,11000),(9000069,9000069),(1338,9090000),(1200002,1200002),(1200001,1200001),(1339,9090000),(1301000,1301000);
/*!40000 ALTER TABLE `shops` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `skill_ranking`
--

DROP TABLE IF EXISTS `skill_ranking`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `skill_ranking` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `chrid` int(11) NOT NULL,
  `chrname` varchar(45) NOT NULL,
  `world` int(11) NOT NULL,
  `skill` varchar(45) NOT NULL,
  `level` int(11) NOT NULL,
  `exp` int(11) NOT NULL,
  `ironman` tinyint(1) NOT NULL DEFAULT '0',
  `hardmode` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `skill_ranking`
--

LOCK TABLES `skill_ranking` WRITE;
/*!40000 ALTER TABLE `skill_ranking` DISABLE KEYS */;
/*!40000 ALTER TABLE `skill_ranking` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `skill_ranking_total`
--

DROP TABLE IF EXISTS `skill_ranking_total`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `skill_ranking_total` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `chrid` int(11) NOT NULL,
  `chrname` varchar(45) NOT NULL,
  `world` int(11) NOT NULL,
  `level` int(11) NOT NULL,
  `exp` int(11) NOT NULL,
  `ironman` tinyint(1) NOT NULL DEFAULT '0',
  `hardmode` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `skill_ranking_total`
--

LOCK TABLES `skill_ranking_total` WRITE;
/*!40000 ALTER TABLE `skill_ranking_total` DISABLE KEYS */;
/*!40000 ALTER TABLE `skill_ranking_total` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `skillmacros`
--

DROP TABLE IF EXISTS `skillmacros`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `skillmacros` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `characterid` int(11) NOT NULL DEFAULT '0',
  `position` tinyint(1) NOT NULL DEFAULT '0',
  `skill1` int(11) NOT NULL DEFAULT '0',
  `skill2` int(11) NOT NULL DEFAULT '0',
  `skill3` int(11) NOT NULL DEFAULT '0',
  `name` varchar(13) DEFAULT NULL,
  `shout` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `skillmacros`
--

LOCK TABLES `skillmacros` WRITE;
/*!40000 ALTER TABLE `skillmacros` DISABLE KEYS */;
/*!40000 ALTER TABLE `skillmacros` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `skills`
--

DROP TABLE IF EXISTS `skills`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `skills` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `skillid` int(11) NOT NULL DEFAULT '0',
  `characterid` int(11) NOT NULL DEFAULT '0',
  `skilllevel` int(11) NOT NULL DEFAULT '0',
  `masterlevel` int(11) NOT NULL DEFAULT '0',
  `expiration` bigint(20) NOT NULL DEFAULT '-1',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `skills`
--

LOCK TABLES `skills` WRITE;
/*!40000 ALTER TABLE `skills` DISABLE KEYS */;
/*!40000 ALTER TABLE `skills` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `storages`
--

DROP TABLE IF EXISTS `storages`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `storages` (
  `storageid` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `accountid` int(11) NOT NULL DEFAULT '0',
  `world` int(2) NOT NULL,
  `slots` int(11) NOT NULL DEFAULT '0',
  `meso` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`storageid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `storages`
--

LOCK TABLES `storages` WRITE;
/*!40000 ALTER TABLE `storages` DISABLE KEYS */;
/*!40000 ALTER TABLE `storages` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `trocklocations`
--

DROP TABLE IF EXISTS `trocklocations`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `trocklocations` (
  `trockid` int(11) NOT NULL AUTO_INCREMENT,
  `characterid` int(11) NOT NULL,
  `mapid` int(11) NOT NULL,
  `vip` int(2) NOT NULL,
  PRIMARY KEY (`trockid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `trocklocations`
--

LOCK TABLES `trocklocations` WRITE;
/*!40000 ALTER TABLE `trocklocations` DISABLE KEYS */;
/*!40000 ALTER TABLE `trocklocations` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vote_log`
--

DROP TABLE IF EXISTS `vote_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `vote_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `voter` varchar(45) DEFAULT NULL,
  `ip` varchar(45) DEFAULT NULL,
  `successful` varchar(45) DEFAULT NULL,
  `reason` longtext,
  `site` varchar(45) DEFAULT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `vote_log`
--

LOCK TABLES `vote_log` WRITE;
/*!40000 ALTER TABLE `vote_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `vote_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `weddings`
--

DROP TABLE IF EXISTS `weddings`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `weddings` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `player1` int(11) NOT NULL,
  `player2` int(11) NOT NULL,
  `cathedral` int(11) NOT NULL DEFAULT '0',
  `premium` int(11) NOT NULL DEFAULT '0',
  `status` int(11) DEFAULT '0',
  `invited` longtext NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `weddings`
--

LOCK TABLES `weddings` WRITE;
/*!40000 ALTER TABLE `weddings` DISABLE KEYS */;
/*!40000 ALTER TABLE `weddings` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wishlists`
--

DROP TABLE IF EXISTS `wishlists`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `wishlists` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `charid` int(11) NOT NULL,
  `sn` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `wishlists`
--

LOCK TABLES `wishlists` WRITE;
/*!40000 ALTER TABLE `wishlists` DISABLE KEYS */;
/*!40000 ALTER TABLE `wishlists` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zaksquads`
--

DROP TABLE IF EXISTS `zaksquads`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `zaksquads` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `channel` int(10) unsigned NOT NULL,
  `leaderid` int(10) unsigned NOT NULL DEFAULT '0',
  `status` int(10) unsigned NOT NULL DEFAULT '0',
  `members` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zaksquads`
--

LOCK TABLES `zaksquads` WRITE;
/*!40000 ALTER TABLE `zaksquads` DISABLE KEYS */;
/*!40000 ALTER TABLE `zaksquads` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2017-12-23 18:41:51
